 ===== readme for slatec =====

SLATEC Common Mathematical Library, Version 4.1, July 1993
a comprehensive software library containing over
1400 general purpose mathematical and statistical routines
written in Fortran 77.

*DECK SCHK13
      SUBROUTINE SCHK13 (SNAME, EPS, THRESH, NOUT, KPRINT, FATAL, NIDIM,
     $   IDIM, NALF, ALF, NBET, BET, NMAX, A, AA, AS, B, BB, BS, C, CC,
     $   CS, CT, G)
C***BEGIN PROLOGUE  SCHK13
C***SUBSIDIARY
C***PURPOSE  Quick check for SGEMM.
C***LIBRARY   SLATEC (BLAS)
C***KEYWORDS  BLAS, QUICK CHECK SERVICE ROUTINE
C***AUTHOR  Dongarra, J. J., (ANL)
C           Duff, I., (AERE)
C           Du Croz, J., (NAG)
C           Hammarling, S., (NAG)
C***DESCRIPTION
C
C  Quick check for SGEMM.
C
C  Auxiliary routine for test program for Level 3 Blas.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  LSE, LSERES, NUMXER, SGEMM, SMAKE3, SMMCH
C***REVISION HISTORY  (YYMMDD)
C   890208  DATE WRITTEN
C   910619  Modified to meet SLATEC code and prologue standards.  (BKS)
C***END PROLOGUE  SCHK13
C     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0 )
C     .. Scalar Arguments ..
      LOGICAL            FATAL
      REAL               EPS, THRESH
      INTEGER            KPRINT, NALF, NBET, NIDIM, NMAX, NOUT
      CHARACTER*6        SNAME
C     .. Array Arguments ..
      REAL               A( NMAX, NMAX ), AA( NMAX*NMAX ), ALF( NALF ),
     $                   AS( NMAX*NMAX ), BET( NBET ), G( NMAX ),
     $                   B( NMAX, NMAX ), BB( NMAX*NMAX ),
     $                   BS( NMAX*NMAX ), C( NMAX, NMAX ),
     $                   CC( NMAX*NMAX ), CS( NMAX*NMAX ),
     $                   CT( NMAX )
      INTEGER            IDIM( NIDIM )
C     .. Local Scalars ..
      REAL               ALPHA, ALS, BETA, BLS, ERR, ERRMAX
      INTEGER            I, IA, IB, ICA, ICB, IK, IM, IN, K, KS, LAA,
     $                   LBB, LCC, LDA, LDAS, LDB, LDBS, LDC, LDCS, M,
     $                   MA, MB, MS, N, NA, NARGS, NB, NC, NERR, NS
      LOGICAL            FTL, NULL, RESET, TRANA, TRANB
      CHARACTER*1        TRANAS, TRANBS, TRANSA, TRANSB
      CHARACTER*3        ICH
C     .. Local Arrays ..
      LOGICAL            ISAME( 13 )
C     .. External Functions ..
      INTEGER            NUMXER
      LOGICAL            LSE, LSERES
      EXTERNAL           LSE, LSERES, NUMXER
C     .. External Subroutines ..
      EXTERNAL           SGEMM, SMAKE3, SMMCH
C     .. Intrinsic Functions ..
      INTRINSIC          MAX
C     .. Data statements ..
      DATA               ICH/'NTC'/
C***FIRST EXECUTABLE STATEMENT  SCHK13
      NARGS = 13
C
      NC = 0
      RESET = .TRUE.
      ERRMAX = ZERO
C
C
      DO 110 IM = 1, NIDIM
         M = IDIM( IM )
C
         DO 100 IN = 1, NIDIM
            N = IDIM( IN )
C           Set LDC to 1 more than minimum value if room.
            LDC = M
            IF( LDC.LT.NMAX )
     $         LDC = LDC + 1
C           Skip tests if not enough room.
            IF( LDC.GT.NMAX )
     $         GO TO 100
            LCC = LDC*N
            NULL = N.LE.0.OR.M.LE.0
C
            DO 90 IK = 1, NIDIM
               K = IDIM( IK )
C
               DO 80 ICA = 1, 3
                  TRANSA = ICH( ICA: ICA )
                  TRANA = TRANSA.EQ.'T'.OR.TRANSA.EQ.'C'
C
                  IF( TRANA )THEN
                     MA = K
                     NA = M
                  ELSE
                     MA = M
                     NA = K
                  END IF
C                 Set LDA to 1 more than minimum value if room.
                  LDA = MA
                  IF( LDA.LT.NMAX )
     $               LDA = LDA + 1
C                 Skip tests if not enough room.
                  IF( LDA.GT.NMAX )
     $               GO TO 80
                  LAA = LDA*NA
C
C                 Generate the matrix A.
C
                  CALL SMAKE3( 'GE', ' ', ' ', MA, NA, A, NMAX, AA, LDA,
     $                        RESET, ZERO )
C
                  DO 70 ICB = 1, 3
                     TRANSB = ICH( ICB: ICB )
                     TRANB = TRANSB.EQ.'T'.OR.TRANSB.EQ.'C'
C
                     IF( TRANB )THEN
                        MB = N
                        NB = K
                     ELSE
                        MB = K
                        NB = N
                     END IF
C                    Set LDB to 1 more than minimum value if room.
                     LDB = MB
                     IF( LDB.LT.NMAX )
     $                  LDB = LDB + 1
C                    Skip tests if not enough room.
                     IF( LDB.GT.NMAX )
     $                  GO TO 70
                     LBB = LDB*NB
C
C                    Generate the matrix B.
C
                     CALL SMAKE3( 'GE', ' ', ' ', MB, NB, B, NMAX, BB,
     $                           LDB, RESET, ZERO )
C
                     DO 60 IA = 1, NALF
                        ALPHA = ALF( IA )
C
                        DO 50 IB = 1, NBET
                           BETA = BET( IB )
C
C                          Generate the matrix C.
C
                           CALL SMAKE3( 'GE', ' ', ' ', M, N, C, NMAX,
     $                                 CC, LDC, RESET, ZERO )
C
                           NC = NC + 1
C
C                          Save every datum before calling the
C                          subroutine.
C
                           TRANAS = TRANSA
                           TRANBS = TRANSB
                           MS = M
                           NS = N
                           KS = K
                           ALS = ALPHA
                           DO 10 I = 1, LAA
                              AS( I ) = AA( I )
   10                      CONTINUE
                           LDAS = LDA
                           DO 20 I = 1, LBB
                              BS( I ) = BB( I )
   20                      CONTINUE
                           LDBS = LDB
                           BLS = BETA
                           DO 30 I = 1, LCC
                              CS( I ) = CC( I )
   30                      CONTINUE
                           LDCS = LDC
C
C                          Call the subroutine.
C
                           CALL SGEMM( TRANSA, TRANSB, M, N, K, ALPHA,
     $                                 AA, LDA, BB, LDB, BETA, CC, LDC )
C
C                          Check if error-exit was taken incorrectly.
C
                           IF( NUMXER(NERR) .NE. 0) THEN
                            IF (KPRINT .GE. 2) THEN
                              WRITE( NOUT, FMT = 9994 )
                            ENDIF
                            FATAL = .TRUE.
                           END IF
C
C                          See what data changed inside subroutines.
C
                           ISAME( 1 ) = TRANSA.EQ.TRANAS
                           ISAME( 2 ) = TRANSB.EQ.TRANBS
                           ISAME( 3 ) = MS.EQ.M
                           ISAME( 4 ) = NS.EQ.N
                           ISAME( 5 ) = KS.EQ.K
                           ISAME( 6 ) = ALS.EQ.ALPHA
                           ISAME( 7 ) = LSE( AS, AA, LAA )
                           ISAME( 8 ) = LDAS.EQ.LDA
                           ISAME( 9 ) = LSE( BS, BB, LBB )
                           ISAME( 10 ) = LDBS.EQ.LDB
                           ISAME( 11 ) = BLS.EQ.BETA
                           IF( NULL )THEN
                              ISAME( 12 ) = LSE( CS, CC, LCC )
                           ELSE
                              ISAME( 12 ) = LSERES( 'GE', ' ', M, N, CS,
     $                                      CC, LDC )
                           END IF
                           ISAME( 13 ) = LDCS.EQ.LDC
C
C                          If data was incorrectly changed, report
C                          and return.
C
                              DO 40 I = 1, NARGS
                                IF (.NOT. ISAME( I )) THEN
                                  FATAL = .TRUE.
                                  IF (KPRINT .GE. 2) THEN
                                    WRITE( NOUT, FMT = 9998 )I
                                  ENDIF
                                ENDIF
  40                          CONTINUE
C
                           FTL = .FALSE.
                           IF( .NOT.NULL )THEN
C
C                             Check the result.
C
                              CALL SMMCH( TRANSA, TRANSB, M, N, K,
     $                                    ALPHA, A, NMAX, B, NMAX, BETA,
     $                                    C, NMAX, CT, G, CC, LDC, EPS,
     $                                    ERR, FTL, NOUT, .TRUE.,
     $                                    KPRINT )
                              ERRMAX = MAX( ERRMAX, ERR )
                           END IF
                           IF (FTL) THEN
                             FATAL = .TRUE.
                             IF (KPRINT .GE. 3) THEN
                               WRITE (NOUT, FMT = 9996) SNAME
                               WRITE( NOUT, FMT = 9995 )NC, SNAME,
     $                           TRANSA, TRANSB, M, N, K,
     $                           ALPHA, LDA, LDB, BETA, LDC
                             ENDIF
                           ENDIF
C
   50                   CONTINUE
C
   60                CONTINUE
C
   70             CONTINUE
C
   80          CONTINUE
C
   90       CONTINUE
C
  100    CONTINUE
C
  110 CONTINUE
C
C     Report result.
C
      IF (.NOT. (FATAL)) THEN
        IF (KPRINT .GE. 3) THEN
          IF( ERRMAX.LT.THRESH )THEN
             WRITE( NOUT, FMT = 9999 )SNAME, NC
          ELSE
             WRITE( NOUT, FMT = 9997 )SNAME, NC, ERRMAX
          END IF
        ENDIF
      ENDIF
      RETURN
C
 9999 FORMAT( ' ', A6, ' PASSED THE COMPUTATIONAL TESTS (', I6, ' CALL',
     $      'S)' )
 9998 FORMAT( ' ******* FATAL ERROR - PARAMETER NUMBER ', I2, ' WAS CH',
     $      'ANGED INCORRECTLY *******' )
 9997 FORMAT( ' ', A6, ' COMPLETED THE COMPUTATIONAL TESTS (', I6, ' C',
     $      'ALLS)', /' ******* BUT WITH MAXIMUM TEST RATIO', F8.2,
     $      ' - SUSPECT *******' )
 9996 FORMAT( ' ******* ', A6, ' FAILED ON CALL NUMBER:' )
 9995 FORMAT( 1X, I6, ': ', A6, '(''', A1, ''',''', A1, ''',',
     $      3( I3, ',' ), F4.1, ', A,', I3, ', B,', I3, ',', F4.1, ', ',
     $      'C,', I3, ').' )
 9994 FORMAT( ' ******* FATAL ERROR - ERROR-EXIT TAKEN ON VALID CALL *',
     $      '******' )
C
C     End of SCHK13.
C
      END

*DECK SBLAT2
      SUBROUTINE SBLAT2 (NOUT, KPRINT, IPASS)
C***BEGIN PROLOGUE  SBLAT2
C***PURPOSE  Driver for testing Level 2 BLAS single precision
C            subroutines.
C***LIBRARY   SLATEC (BLAS)
C***CATEGORY  A3A
C***TYPE      SINGLE PRECISION (SBLAT2-S, DBLAT2-D, CBLAT2-C)
C***KEYWORDS  BLAS, QUICK CHECK DRIVER
C***AUTHOR  Du Croz, J. J., (NAG)
C           Hanson, R. J., (SNLA)
C***DESCRIPTION
C
C  Test program for the REAL             Level 2 Blas.
C
C***REFERENCES  Dongarra, J. J., Du Croz, J. J., Hammarling, S. and
C                 Hanson, R. J.  An  extended  set of Fortran Basic
C                 Linear Algebra Subprograms. ACM TOMS, Vol. 14, No. 1,
C                 pp. 1-17, March 1988.
C***ROUTINES CALLED  LSE, R1MACH, SCHK12, SCHK22, SCHK32, SCHK42,
C                    SCHK52, SCHK62, SCHKE2, SMVCH, XERCLR
C***REVISION HISTORY  (YYMMDD)
C   870810  DATE WRITTEN
C   910619  Modified to meet SLATEC code and prologue standards.  (BKS)
C   930315  Removed unused variables.  (WRB)
C   930618  Code modified to improve PASS/FAIL reporting.  (BKS, WRB)
C***END PROLOGUE  SBLAT2
C     .. Parameters ..
      INTEGER            NSUBS
      PARAMETER          ( NSUBS = 16)
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0, ONE = 1.0 )
      INTEGER            NMAX, INCMAX
      PARAMETER          ( NMAX = 65, INCMAX = 2 )
C     .. Scalar Arguments ..
      INTEGER            IPASS, KPRINT
C     .. Local Scalars ..
      LOGICAL            FTL, FTL1, FTL2
      REAL               EPS, ERR, THRESH
      INTEGER            I, ISNUM, J, N, NALF, NBET, NIDIM, NINC, NKB,
     $                   NOUT
      PARAMETER          (NIDIM=6, NKB=4,NINC=4, NALF=3, NBET=3)
      LOGICAL            SAME, TSTERR
      CHARACTER*1        TRANS
C     .. Local Arrays ..
      REAL               A( NMAX, NMAX ), AA( NMAX*NMAX ),
     $                   ALF( NALF ), AS( NMAX*NMAX ), BET( NBET ),
     $                   G( NMAX ), X( NMAX ), XS( NMAX*INCMAX ),
     $                   XX( NMAX*INCMAX ), Y( NMAX ),
     $                   YS( NMAX*INCMAX ), YT( NMAX ),
     $                   YY( NMAX*INCMAX ), Z( 2*NMAX )
      INTEGER            IDIM( NIDIM ), INC( NINC ), KB( NKB )
      LOGICAL            LTEST( NSUBS )
      CHARACTER*6        SNAMES( NSUBS )
C     .. External Functions ..
      REAL               R1MACH
      LOGICAL            LSE
      EXTERNAL           LSE, R1MACH
C     .. External Subroutines ..
      EXTERNAL           SCHK12, SCHK22, SCHK32, SCHK42, SCHK52, SCHK62,
     $                   SCHKE2, SMVCH
C     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN
C     .. Data statements ..
      DATA               SNAMES/'SGEMV ', 'SGBMV ', 'SSYMV ', 'SSBMV ',
     $                   'SSPMV ', 'STRMV ', 'STBMV ', 'STPMV ',
     $                   'STRSV ', 'STBSV ', 'STPSV ', 'SGER  ',
     $                   'SSYR  ', 'SSPR  ', 'SSYR2 ', 'SSPR2 '/
      DATA               IDIM/0,1,2,3,5,9/
      DATA               KB/0,1,2,4/
      DATA               INC/1,2,-1,-2/
      DATA               ALF/0.0,1.0,0.7/
      DATA               BET/0.0,1.0,0.9/
C***FIRST EXECUTABLE STATEMENT  SBLAT2
C
C     Set the flag that indicates whether error exits are to be tested.
C
      TSTERR=.TRUE.
C
C     Set the threshold value of the test ratio
C
      THRESH=16.0
C
C     Initialize IPASS to 1 assuming everything will pass.
C
      IPASS = 1
C
C     Report values of parameters.
C
      IF (KPRINT .GE. 3) THEN
        WRITE( NOUT, FMT = 9993 )
        WRITE( NOUT, FMT = 9992 )( IDIM( I ), I = 1, NIDIM )
        WRITE( NOUT, FMT = 9991 )( KB( I ), I = 1, NKB )
        WRITE( NOUT, FMT = 9990 )( INC( I ), I = 1, NINC )
        WRITE( NOUT, FMT = 9989 )( ALF( I ), I = 1, NALF )
        WRITE( NOUT, FMT = 9988 )( BET( I ), I = 1, NBET )
        IF( .NOT.TSTERR )THEN
           WRITE( NOUT, FMT = 9980 )
        END IF
        WRITE( NOUT, FMT = 9999 )THRESH
      ENDIF
C
C     Set names of subroutines and flags which indicate
C     whether they are to be tested.
C
      DO 40 I = 1, NSUBS
         LTEST( I ) = .TRUE.
   40 CONTINUE
C
C     Set EPS (the machine precision).
C
      EPS = R1MACH (4)
C
C     Check the reliability of SMVCH using exact data.
C
      N = MIN( 32, NMAX )
      DO 120 J = 1, N
         DO 110 I = 1, N
            A( I, J ) = MAX( I - J + 1, 0 )
  110    CONTINUE
         X( J ) = J
         Y( J ) = ZERO
  120 CONTINUE
      DO 130 J = 1, N
         YY( J ) = J*( ( J + 1 )*J )/2 - ( ( J + 1 )*J*( J - 1 ) )/3
  130 CONTINUE
C     YY holds the exact result. On exit from SMVCH YT holds
C     the result computed by SMVCH.
      TRANS = 'N'
      FTL = .FALSE.
      CALL SMVCH( TRANS, N, N, ONE, A, NMAX, X, 1, ZERO, Y, 1, YT, G,
     $            YY, EPS, ERR, FTL, NOUT, .TRUE., KPRINT )
      SAME = LSE( YY, YT, N )
      IF( .NOT.SAME.OR.ERR.NE.ZERO )THEN
        IPASS = 0
        IF (KPRINT .GE. 2) THEN
           WRITE( NOUT, FMT = 9985 )TRANS, SAME, ERR
        END IF
      ENDIF
      TRANS = 'T'
      FTL = .FALSE.
      CALL SMVCH( TRANS, N, N, ONE, A, NMAX, X, -1, ZERO, Y, -1, YT, G,
     $            YY, EPS, ERR, FTL, NOUT, .TRUE., KPRINT )
      SAME = LSE( YY, YT, N )
      IF( .NOT.SAME.OR.ERR.NE.ZERO )THEN
        IPASS = 0
        IF (KPRINT .GE. 2) THEN
           WRITE( NOUT, FMT = 9985 )TRANS, SAME, ERR
        END IF
      ENDIF
C
C     Test each subroutine in turn.
C
      DO 210 ISNUM = 1, NSUBS
         IF( .NOT.LTEST( ISNUM ) )THEN
C           Subprogram is not to be tested.
            WRITE( NOUT, FMT = 9983 )SNAMES( ISNUM )
         ELSE
C           Test error exits.
            FTL1 = .FALSE.
            IF( TSTERR )THEN
              CALL SCHKE2( ISNUM, SNAMES( ISNUM ), NOUT, KPRINT, FTL1)
            END IF
C           Test computations.
            FTL2 = .FALSE.
            CALL XERCLR
            GO TO ( 140, 140, 150, 150, 150, 160, 160,
     $              160, 160, 160, 160, 170, 180, 180,
     $              190, 190 )ISNUM
C           Test SGEMV, 01, and SGBMV, 02.
  140       CALL SCHK12( SNAMES( ISNUM ), EPS, THRESH, NOUT, KPRINT,
     $                  FTL2, NIDIM, IDIM, NKB, KB, NALF, ALF,
     $                  NBET, BET, NINC, INC, NMAX, INCMAX, A, AA, AS,
     $                  X, XX, XS, Y, YY, YS, YT, G )
            GO TO 200
C           Test SSYMV, 03, SSBMV, 04, and SSPMV, 05.
  150       CALL SCHK22( SNAMES( ISNUM ), EPS, THRESH, NOUT, KPRINT,
     $                  FTL2, NIDIM, IDIM, NKB, KB, NALF, ALF,
     $                  NBET, BET, NINC, INC, NMAX, INCMAX, A, AA, AS,
     $                  X, XX, XS, Y, YY, YS, YT, G )
            GO TO 200
C           Test STRMV, 06, STBMV, 07, STPMV, 08,
C           STRSV, 09, STBSV, 10, and STPSV, 11.
  160       CALL SCHK32( SNAMES( ISNUM ), EPS, THRESH, NOUT, KPRINT,
     $                  FTL2, NIDIM, IDIM, NKB, KB, NINC, INC,
     $                  NMAX, INCMAX, A, AA, AS, Y, YY, YS, YT, G, Z )
            GO TO 200
C           Test SGER, 12.
  170       CALL SCHK42( SNAMES( ISNUM ), EPS, THRESH, NOUT, KPRINT,
     $                  FTL2, NIDIM, IDIM, NALF, ALF, NINC, INC,
     $                  NMAX, INCMAX, A, AA, AS, X, XX, XS, Y, YY, YS,
     $                  YT, G, Z )
            GO TO 200
C           Test SSYR, 13, and SSPR, 14.
  180       CALL SCHK52( SNAMES( ISNUM ), EPS, THRESH, NOUT, KPRINT,
     $                  FTL2, NIDIM, IDIM, NALF, ALF, NINC, INC,
     $                  NMAX, INCMAX, A, AA, AS, X, XX, XS, Y, YY, YS,
     $                  YT, G, Z )
            GO TO 200
C           Test SSYR2, 15, and SSPR2, 16.
  190       CALL SCHK62( SNAMES( ISNUM ), EPS, THRESH, NOUT, KPRINT,
     $                  FTL2, NIDIM, IDIM, NALF, ALF, NINC, INC,
     $                  NMAX, INCMAX, A, AA, AS, X, XX, XS, Y, YY, YS,
     $                  YT, G, Z )
C
  200       IF (FTL1 .OR. FTL2 ) THEN
              IPASS = 0
            ENDIF
         END IF
  210 CONTINUE
      RETURN
C
 9999 FORMAT( ' ROUTINES PASS COMPUTATIONAL TESTS IF TEST RATIO IS LES',
     $      'S THAN', F8.2 )
 9993 FORMAT( ' TESTS OF THE REAL             LEVEL 2 BLAS', //' THE F',
     $      'OLLOWING PARAMETER VALUES WILL BE USED:' )
 9992 FORMAT( '   FOR N              ', 9I6 )
 9991 FORMAT( '   FOR K              ', 7I6 )
 9990 FORMAT( '   FOR INCX AND INCY  ', 7I6 )
 9989 FORMAT( '   FOR ALPHA          ', 7F6.1 )
 9988 FORMAT( '   FOR BETA           ', 7F6.1 )
 9985 FORMAT( ' ERROR IN SMVCH -  IN-LINE DOT PRODUCTS ARE BEING EVALU',
     $      'ATED WRONGLY.', /' SMVCH WAS CALLED WITH TRANS = ', A1,
     $      ' AND RETURNED SAME = ', L1, ' AND ERR = ', F12.3, '.', /
     $      ' THIS MAY BE DUE TO FAULTS IN THE ARITHMETIC OR THE',
     $      ' COMPILER.')
 9983 FORMAT( 1X, A6, ' WAS NOT TESTED' )
 9980 FORMAT( ' ERROR-EXITS WILL NOT BE TESTED' )
C
C     End of SBLAT2.
C
      END

*DECK EISQX1
      SUBROUTINE EISQX1 (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  EISQX1
C***PURPOSE  Quick check for SGEEV and CGEEV.
C***LIBRARY   SLATEC
C***KEYWORDS  QUICK CHECK
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     THIS QUICK CHECK ROUTINE IS WRITTEN FOR EISPACK DRIVERS
C     SGEEV AND CGEEV.  THE EIGENVALUES OF INPUT MATRIX A(.,.)
C     ARE STORED IN EK(.).  RELERR IS THE RELATIVE ACCURACY
C     REQUIRED FOR THEM TO PASS.
C
C***ROUTINES CALLED  CGEEV, R1MACH, SGEEV
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   890618  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900405  CALL to XERROR replaced by message to LUN.  (WRB)
C***END PROLOGUE  EISQX1
      INTEGER KPRINT,IPASS,LUN
      INTEGER LDA,N,LDV,JOB,I,J,ID
      REAL A(3,3),EK(3),W(9)
      REAL ERR,ERRI,RELERR,RECJ
      COMPLEX AC(3,3),EC(3),VC(3,3)
      DATA LDA,N,LDV / 3*3 /
      DATA A / 1., -2., 6., -1., 0., -3., 2., 5., 6. /
      DATA EK / -1., 3., 5. /
C***FIRST EXECUTABLE STATEMENT  EISQX1
      IPASS = 1
      RELERR = SQRT(R1MACH(4))
      DO 20 J=1,N
         DO 10 I=1,N
            AC(I,J) = CMPLX(A(I,J),0.)
   10       CONTINUE
   20    CONTINUE
      JOB = 1
      CALL CGEEV(AC,LDA,N,EC,VC,LDV,W,JOB,INFO)
      IF (INFO .NE. 0) THEN
         IF (KPRINT .GE. 2) WRITE (LUN, 688) 'CGEEV', INFO
         IPASS = 0
      ENDIF
      DO 40 J=1,N
         ERR = ABS(AIMAG(EC(J)))
         IF (ERR .GE. RELERR) IPASS = 0
         RECJ = REAL(EC(J))
         ERR = ABS(RECJ - EK(1))
         ID = 1
         DO 30 I=2,N
            ERRI = ABS(RECJ - EK(I))
            IF (ERRI .LT. ERR) ID = I
            ERR = MIN(ERRI,ERR)
   30       CONTINUE
         IF (ABS(RECJ-EK(ID))/ABS(EK(ID)) .GE. RELERR) IPASS = 0
   40    CONTINUE
      JOB = 0
      CALL SGEEV(A,LDA,N,EC,VC,LDV,W,JOB,INFO)
      IF (INFO .NE. 0) THEN
         IF (KPRINT .GE. 2) WRITE (LUN, 688) 'SGEEV', INFO
         IPASS = 0
      ENDIF
      DO 60 J=1,N
         ERR = ABS(AIMAG(EC(J)))
         IF (ERR .GE. RELERR) IPASS = 0
         RECJ = REAL(EC(J))
         ERR = ABS(RECJ - EK(1))
         ID = 1
         DO 50 I=2,N
            ERRI = ABS(RECJ - EK(I))
            IF (ERRI .LT. ERR) ID = I
            ERR = MIN(ERRI,ERR)
   50       CONTINUE
         IF (ABS(RECJ-EK(ID))/ABS(EK(ID)) .GE. RELERR) IPASS = 0
   60    CONTINUE
      IF (KPRINT.GE.2 .AND. IPASS.NE.0) WRITE (LUN,670)
  670 FORMAT(25H EISQX1 PASSES ALL TESTS.)
      IF (KPRINT.GE.1 .AND. IPASS.EQ.0) WRITE (LUN,680)
  680 FORMAT(25H EISQX1 FAILS SOME TESTS.)
  688 FORMAT (1X, 'Eigenvalue iteration failed to converge in ', A5,
     +        ', INFO = ', I4)
      RETURN
      END

*DECK F3G
      REAL FUNCTION F3G (X)
C***BEGIN PROLOGUE  F3G
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F3G
      REAL X
C***FIRST EXECUTABLE STATEMENT  F3G
      F3G = ABS(X-0.33E+00)**(-0.9E+00)
      RETURN
      END

*DECK VFILL
      SUBROUTINE VFILL (N, V, VAL)
C***BEGIN PROLOGUE  VFILL
C***SUBSIDIARY
C***PURPOSE  Fill a vector with a value.
C***LIBRARY   SLATEC (SLAP)
C***TYPE      SINGLE PRECISION (VFILL-S, DFILL-D)
C***AUTHOR  Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-300
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C
C *Usage:
C     INTEGER  N
C     REAL     V(N), VAL
C
C     CALL VFILL( N, V, VAL )
C
C *Arguments:
C N      :IN       Integer.
C         Length of the vector
C V      :OUT      Real V(N).
C         Vector to be set.
C VAL    :IN       Real.
C         Value to seed the vector with.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   871119  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890920  Converted prologue to SLATEC 4.0 format.  (FNF)
C   920511  Added complete declaration section.  (WRB)
C***END PROLOGUE  VFILL
C     .. Scalar Arguments ..
      REAL VAL
      INTEGER N
C     .. Array Arguments ..
      REAL V(*)
C     .. Local Scalars ..
      INTEGER I, IS, NR
C     .. Intrinsic Functions ..
      INTRINSIC MOD
C***FIRST EXECUTABLE STATEMENT  VFILL
      IF (N .LE. 0) RETURN
      NR=MOD(N,4)
C
C         The following construct assumes a zero pass do loop.
C
      IS=1
      GOTO(1,2,3,4), NR+1
    4   IS=4
        V(1)=VAL
        V(2)=VAL
        V(3)=VAL
        GOTO 1
    3   IS=3
        V(1)=VAL
        V(2)=VAL
        GOTO 1
    2   IS=2
        V(1)=VAL
    1 DO 10 I=IS,N,4
        V(I)  =VAL
        V(I+1)=VAL
        V(I+2)=VAL
        V(I+3)=VAL
 10   CONTINUE
      RETURN
C------------- LAST LINE OF VFILL FOLLOWS -----------------------------
      END

*DECK SDQCK
      SUBROUTINE SDQCK (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  SDQCK
C***PURPOSE  Quick check for SLATEC routines SDRIV1, SDRIV2 and SDRIV3.
C***LIBRARY   SLATEC (SDRIVE)
C***CATEGORY  I1A2, I1A1B
C***TYPE      SINGLE PRECISION (SDQCK-S, DDQCK-D, CDQCK-C)
C***KEYWORDS  QUICK CHECK, SDRIV1, SDRIV2, SDRIV3
C***AUTHOR  Kahaner, D. K., (NIST)
C             National Institute of Standards and Technology
C             Gaithersburg, MD  20899
C           Sutherland, C. D., (LANL)
C             Mail Stop D466
C             Los Alamos National Laboratory
C             Los Alamos, NM  87545
C***DESCRIPTION
C
C  For assistance in determining the cause of a failure of these
C  routines contact C. D. Sutherland at commercial telephone number
C  (505)667-6949, FTS telephone number 8-843-6949, or electronic mail
C  address CDS@LANL.GOV .
C
C***ROUTINES CALLED  R1MACH, SDF, SDRIV1, SDRIV2, SDRIV3, XERCLR
C***REVISION HISTORY  (YYMMDD)
C   890405  DATE WRITTEN
C   890405  Revised to meet SLATEC standards.
C***END PROLOGUE  SDQCK
      EXTERNAL SDF
      REAL ALFA, EPS, EWT(1), HMAX, R1MACH, T, TOUT
      INTEGER IERFLG, IERROR, IMPL, IPASS, KPRINT, LENIW, LENIWX, LENW,
     8        LENWMX, LENWX, LIWMX, LUN, MINT, MITER, ML, MSTATE, MU,
     8        MXORD, MXSTEP, N, NDE, NFE, NJE, NROOT, NSTATE, NSTEP,
     8        NTASK, NX
      PARAMETER(ALFA = 1.E0, HMAX = 15.E0, IERROR = 3, IMPL = 0,
     8          LENWMX = 342, LIWMX = 53, MITER = 5, ML = 2, MU = 2,
     8          MXORD = 5, MXSTEP = 1000, N = 3, NROOT = 0, NTASK = 1)
      REAL WORK(LENWMX), Y(N+1)
      INTEGER IWORK(LIWMX)
      DATA EWT(1) /.00001E0/
C***FIRST EXECUTABLE STATEMENT  SDQCK
      EPS = R1MACH(4)**(1.E0/3.E0)
      IPASS = 1
C                                            Exercise SDRIV1 for problem
C                                            with known solution.
      Y(4) = ALFA
      T = 0.E0
      Y(1) = 10.E0
      Y(2) = 0.E0
      Y(3) = 10.E0
      TOUT = 10.E0
      MSTATE = 1
      LENW = 342
      CALL SDRIV1 (N, T, Y, SDF, TOUT, MSTATE, EPS, WORK, LENW, IERFLG)
      NSTEP = WORK(LENW - (N + 50) + 3)
      NFE = WORK(LENW - (N + 50) + 4)
      NJE = WORK(LENW - (N + 50) + 5)
      IF (MSTATE .EQ. 2) THEN
        IF (ABS(1.E0 - Y(1)*1.5E0) .LE. EPS**(2.E0/3.E0) .AND.
     8  ABS(1.E0 - Y(2)*3.E0) .LE. EPS**(2.E0/3.E0) .AND.
     8  ABS(1.E0 - Y(3)) .LE. EPS**(2.E0/3.E0)) THEN
          IF (KPRINT .EQ. 2) THEN
            WRITE(LUN, '('' SDRIV1:The solution determined met '',
     8      ''the expected values.'' //)')
          ELSE IF (KPRINT .EQ. 3) THEN
            WRITE(LUN, '('' SDRIV1:The solution determined met '',
     8      ''the expected values.'')')
            WRITE(LUN, '('' The values of results are '')')
            WRITE(LUN, *) ' T ', T
            WRITE(LUN, *) ' Y(1) ', Y(1)
            WRITE(LUN, *) ' Y(2) ', Y(2)
            WRITE(LUN, *) ' Y(3) ', Y(3)
            WRITE(LUN, '(/)')
          END IF
        ELSE
          IF (KPRINT .EQ. 1) THEN
            WRITE(LUN, '('' SDRIV1:The solution determined is not '',
     8      ''accurate enough.'' //)')
          ELSE IF (KPRINT .EQ. 2) THEN
            WRITE(LUN, '('' SDRIV1:The solution determined is not '',
     8      ''accurate enough.'')')
            WRITE(LUN, '('' The values of parameters, results, and '',
     8      ''statistical quantities are:'')')
            WRITE(LUN, *) ' EPS = ', EPS
            WRITE(LUN, *) ' T ', T
            WRITE(LUN, *) ' Y(1) ', Y(1)
            WRITE(LUN, *) ' Y(2) ', Y(2)
            WRITE(LUN, *) ' Y(3) ', Y(3)
            WRITE(LUN, *)
     8      ' Number of steps taken is  ', NSTEP
            WRITE(LUN, *)
     8      ' Number of evaluations of the right hand side is  ', NFE
            WRITE(LUN, *)
     8      ' Number of evaluations of the Jacobian matrix is  ', NJE
            WRITE(LUN, '(//)')
          END IF
          IPASS = 0
        END IF
      ELSE
        IF (KPRINT .EQ. 1) THEN
          WRITE(LUN, '('' While using SDRIV1, a solution was not '',
     8    ''obtained.'' //)')
        ELSE IF (KPRINT .GE. 2) THEN
          WRITE(LUN, '('' While using SDRIV1, a solution was not '',
     8    ''obtained.'')')
          WRITE(LUN, '('' The values of parameters, results, and '',
     8    ''statistical quantities are:'')')
          WRITE(LUN, *)
     8    ' MSTATE = ', MSTATE, ', Error number = ', IERFLG
          WRITE(LUN, *) ' N ', N, ', EPS ', EPS, ', LENW ', LENW
          WRITE(LUN, *) ' T ', T
          WRITE(LUN, *) ' Y(1) ', Y(1)
          WRITE(LUN, *) ' Y(2) ', Y(2)
          WRITE(LUN, *) ' Y(3) ', Y(3)
          WRITE(LUN, *)
     8    ' Number of steps taken is  ', NSTEP
          WRITE(LUN, *)
     8    ' Number of evaluations of the right hand side is  ', NFE
          WRITE(LUN, *)
     8    ' Number of evaluations of the Jacobian matrix is  ', NJE
          WRITE(LUN, '(//)')
        END IF
        IPASS = 0
      END IF
      CALL XERCLR
C                                         Run SDRIV1 with invalid input.
      NX = 201
      T = 0.E0
      Y(1) = 10.E0
      Y(2) = 0.E0
      Y(3) = 10.E0
      Y(4) = ALFA
      TOUT = 10.E0
      MSTATE = 1
      LENW = 342
      CALL SDRIV1 (NX, T, Y, SDF, TOUT, MSTATE, EPS, WORK, LENW, IERFLG)
      IF (IERFLG .EQ. 21) THEN
        IF (KPRINT .EQ. 2) THEN
          WRITE(LUN, '('' SDRIV1:An invalid parameter has been '',
     8    ''correctly detected.'' //)')
        ELSE IF (KPRINT .EQ. 3) THEN
          WRITE(LUN, '('' SDRIV1:An invalid parameter has been '',
     8    ''correctly detected.'')')
          WRITE(LUN, *) ' The value of N was set to ', NX
          WRITE(LUN, *)
     8    ' MSTATE = ', MSTATE, ', Error number = ', IERFLG
          WRITE(LUN, '(/)')
        END IF
      ELSE
        IF (KPRINT .EQ. 1) THEN
          WRITE(LUN, '('' SDRIV1:An invalid parameter has not '',
     8    ''been correctly detected.'' //)')
        ELSE IF (KPRINT .GE. 2) THEN
          WRITE(LUN, '('' SDRIV1:An invalid parameter has not '',
     8    ''been correctly detected.'')')
          WRITE(LUN, *) ' The value of N was set to ', NX
          WRITE(LUN, *)
     8    ' MSTATE = ', MSTATE, ', Error number = ', IERFLG
          WRITE(LUN, '('' The values of parameters, results, and '',
     8    ''statistical quantities are:'')')
          WRITE(LUN, *) ' EPS ', EPS, ', LENW ', LENW
          WRITE(LUN, *) ' T ', T
          WRITE(LUN, *) ' Y(1) ', Y(1)
          WRITE(LUN, *) ' Y(2) ', Y(2)
          WRITE(LUN, *) ' Y(3) ', Y(3)
          WRITE(LUN, *)
     8    ' Number of steps taken is  ', NSTEP
          WRITE(LUN, *)
     8    ' Number of evaluations of the right hand side is  ', NFE
          WRITE(LUN, *)
     8    ' Number of evaluations of the Jacobian matrix is  ', NJE
          WRITE(LUN, '(//)')
        END IF
        IPASS = 0
      END IF
      CALL XERCLR
C                                            Exercise SDRIV2 for problem
C                                            with known solution.
      T = 0.E0
      Y(1) = 10.E0
      Y(2) = 0.E0
      Y(3) = 10.E0
      Y(4) = ALFA
      MSTATE = 1
      TOUT = 10.E0
      MINT = 1
      LENW = 298
      LENIW = 50
      CALL SDRIV2 (N, T, Y, SDF, TOUT, MSTATE, NROOT, EPS, EWT,
     8             MINT, WORK, LENW, IWORK, LENIW, SDF, IERFLG)
      NSTEP = IWORK(3)
      NFE = IWORK(4)
      NJE = IWORK(5)
      IF (MSTATE .EQ. 2) THEN
        IF (ABS(1.E0 - Y(1)*1.5E0) .LE. EPS**(2.E0/3.E0) .AND.
     8  ABS(1.E0 - Y(2)*3.E0) .LE. EPS**(2.E0/3.E0) .AND.
     8  ABS(1.E0 - Y(3)) .LE. EPS**(2.E0/3.E0)) THEN
          IF (KPRINT .EQ. 2) THEN
            WRITE(LUN, '('' SDRIV2:The solution determined met '',
     8      ''the expected values.'' //)')
          ELSE IF (KPRINT .EQ. 3) THEN
            WRITE(LUN, '('' SDRIV2:The solution determined met '',
     8      ''the expected values.'')')
            WRITE(LUN, '('' The values of results are '')')
            WRITE(LUN, *) ' T ', T
            WRITE(LUN, *) ' Y(1) ', Y(1)
            WRITE(LUN, *) ' Y(2) ', Y(2)
            WRITE(LUN, *) ' Y(3) ', Y(3)
            WRITE(LUN, '(/)')
          END IF
        ELSE
          IF (KPRINT .EQ. 1) THEN
            WRITE(LUN, '('' SDRIV2:The solution determined is not '',
     8      ''accurate enough.'' //)')
          ELSE IF (KPRINT .EQ. 2) THEN
            WRITE(LUN, '('' SDRIV2:The solution determined is not '',
     8      ''accurate enough.'')')
            WRITE(LUN, '('' The values of parameters, results, and '',
     8      ''statistical quantities are:'')')
            WRITE(LUN, *) ' EPS = ', EPS, ', EWT = ', EWT
            WRITE(LUN, *) ' T ', T
            WRITE(LUN, *) ' Y(1) ', Y(1)
            WRITE(LUN, *) ' Y(2) ', Y(2)
            WRITE(LUN, *) ' Y(3) ', Y(3)
            WRITE(LUN, *)
     8      ' Number of steps taken is  ', NSTEP
            WRITE(LUN, *)
     8      ' Number of evaluations of the right hand side is  ', NFE
            WRITE(LUN, *)
     8      ' Number of evaluations of the Jacobian matrix is  ', NJE
            WRITE(LUN, '(//)')
          END IF
          IPASS = 0
        END IF
      ELSE
        IF (KPRINT .EQ. 1) THEN
          WRITE(LUN, '('' While using SDRIV2, a solution was not '',
     8    ''obtained.'' //)')
        ELSE IF (KPRINT .GE. 2) THEN
          WRITE(LUN, '('' While using SDRIV2, a solution was not '',
     8    ''obtained.'')')
          WRITE(LUN, *)
     8    ' MSTATE = ', MSTATE, ', Error number = ', IERFLG
          WRITE(LUN, '('' The values of parameters, results, and '',
     8    ''statistical quantities are:'')')
          WRITE(LUN, *) ' EPS = ', EPS, ', EWT ', EWT
          WRITE(LUN, *)
     8    ' MINT = ', MINT, ', LENW ', LENW, ', LENIW ', LENIW
          WRITE(LUN, *) ' T ', T
          WRITE(LUN, *) ' Y(1) ', Y(1)
          WRITE(LUN, *) ' Y(2) ', Y(2)
          WRITE(LUN, *) ' Y(3) ', Y(3)
          WRITE(LUN, *)
     8    ' Number of steps taken is  ', NSTEP
          WRITE(LUN, *)
     8    ' Number of evaluations of the right hand side is  ', NFE
          WRITE(LUN, *)
     8    ' Number of evaluations of the Jacobian matrix is  ', NJE
          WRITE(LUN, '(//)')
        END IF
        IPASS = 0
      END IF
      CALL XERCLR
C                                         Run SDRIV2 with invalid input.
      T = 0.E0
      Y(1) = 10.E0
      Y(2) = 0.E0
      Y(3) = 10.E0
      Y(4) = ALFA
      TOUT = 10.E0
      MSTATE = 1
      MINT = 1
      LENWX = 1
      LENIW = 50
      CALL SDRIV2 (N, T, Y, SDF, TOUT, MSTATE, NROOT, EPS, EWT,
     8             MINT, WORK, LENWX, IWORK, LENIW, SDF, IERFLG)
      IF (IERFLG .EQ. 32) THEN
        IF (KPRINT .EQ. 2) THEN
          WRITE(LUN, '('' SDRIV2:An invalid parameter has been '',
     8    ''correctly detected.'' //)')
        ELSE IF (KPRINT .EQ. 3) THEN
          WRITE(LUN, '('' SDRIV2:An invalid parameter has been '',
     8    ''correctly detected.'')')
          WRITE(LUN, *)
     8    ' The value of LENW was set to ', LENWX
          WRITE(LUN, *)
     8    ' MSTATE = ', MSTATE, ', Error number = ', IERFLG
          WRITE(LUN, '(/)')
        END IF
      ELSE
        IF (KPRINT .EQ. 1) THEN
          WRITE(LUN, '('' SDRIV2:An invalid parameter has not '',
     8    ''been correctly detected.'' //)')
        ELSE IF (KPRINT .GE. 2) THEN
          WRITE(LUN, '('' SDRIV2:An invalid parameter has not '',
     8    ''been correctly detected.'')')
          WRITE(LUN, *) ' The value of LENW was set to ', LENWX
          WRITE(LUN, *)
     8    ' MSTATE = ', MSTATE, ', Error number = ', IERFLG
          WRITE(LUN, '('' The values of parameters, results, and '',
     8    ''statistical quantities are:'')')
          WRITE(LUN, *)
     8    ' EPS ', EPS, ', MINT ', MINT, ', LENW ', LENW,
     8    ', LENIW ', LENIW
          WRITE(LUN, *) ' T ', T
          WRITE(LUN, *) ' Y(1) ', Y(1)
          WRITE(LUN, *) ' Y(2) ', Y(2)
          WRITE(LUN, *) ' Y(3) ', Y(3)
          WRITE(LUN, *)
     8    ' Number of steps taken is  ', NSTEP
          WRITE(LUN, *)
     8    ' Number of evaluations of the right hand side is  ', NFE
          WRITE(LUN, *)
     8    ' Number of evaluations of the Jacobian matrix is  ', NJE
          WRITE(LUN, '(//)')
        END IF
        IPASS = 0
      END IF
      CALL XERCLR
C                                            Exercise SDRIV3 for problem
C                                            with known solution.
      T = 0.E0
      Y(1) = 10.E0
      Y(2) = 0.E0
      Y(3) = 10.E0
      Y(4) = ALFA
      NSTATE = 1
      TOUT = 10.E0
      MINT = 2
      LENW = 301
      LENIW = 53
      CALL SDRIV3 (N, T, Y, SDF, NSTATE, TOUT, NTASK, NROOT, EPS, EWT,
     8             IERROR, MINT, MITER, IMPL, ML, MU, MXORD, HMAX,
     8             WORK, LENW, IWORK, LENIW, SDF, SDF, NDE,
     8             MXSTEP, SDF, SDF, IERFLG)
      NSTEP = IWORK(3)
      NFE = IWORK(4)
      NJE = IWORK(5)
      IF (NSTATE .EQ. 2) THEN
        IF (ABS(1.E0 - Y(1)*1.5E0) .LE. EPS**(2.E0/3.E0) .AND.
     8  ABS(1.E0 - Y(2)*3.E0) .LE. EPS**(2.E0/3.E0) .AND.
     8  ABS(1.E0 - Y(3)) .LE. EPS**(2.E0/3.E0)) THEN
          IF (KPRINT .EQ. 2) THEN
            WRITE(LUN, '('' SDRIV3:The solution determined met '',
     8      ''the expected values.'' //)')
          ELSE IF (KPRINT .EQ. 3) THEN
            WRITE(LUN, '('' SDRIV3:The solution determined met '',
     8      ''the expected values.'')')
            WRITE(LUN, '('' The values of results are '')')
            WRITE(LUN, *) ' T ', T
            WRITE(LUN, *) ' Y(1) ', Y(1)
            WRITE(LUN, *) ' Y(2) ', Y(2)
            WRITE(LUN, *) ' Y(3) ', Y(3)
            WRITE(LUN, '(/)')
          END IF
        ELSE
          IF (KPRINT .EQ. 1) THEN
            WRITE(LUN, '('' SDRIV3:The solution determined is not '',
     8      ''accurate enough.'' //)')
          ELSE IF (KPRINT .GE. 2) THEN
            WRITE(LUN, '('' SDRIV3:The solution determined is not '',
     8      ''accurate enough.'')')
            WRITE(LUN, '('' The values of parameters, results, and '',
     8      ''statistical quantities are:'')')
            WRITE(LUN, *)
     8      ' EPS = ', EPS, ', EWT = ', EWT, ', IERROR = ', IERROR
            WRITE(LUN, *)
     8      ' MINT = ', MINT, ', MITER = ', MITER, ', IMPL = ', IMPL
            WRITE(LUN, *) ' T ', T
            WRITE(LUN, *) ' Y(1) ', Y(1)
            WRITE(LUN, *) ' Y(2) ', Y(2)
            WRITE(LUN, *) ' Y(3) ', Y(3)
            WRITE(LUN, *)
     8      ' Number of steps taken is  ', NSTEP
            WRITE(LUN, *)
     8      ' Number of evaluations of the right hand side is  ', NFE
            WRITE(LUN, *)
     8      ' Number of evaluations of the Jacobian matrix is  ', NJE
            WRITE(LUN, '(//)')
          END IF
          IPASS = 0
        END IF
      ELSE
        IF (KPRINT .EQ. 1) THEN
          WRITE(LUN, '('' While using SDRIV3, a solution was not '',
     8    ''obtained.'' //)')
        ELSE IF (KPRINT .GE. 2) THEN
          WRITE(LUN, '('' While using SDRIV3, a solution was not '',
     8    ''obtained.'')')
          WRITE(LUN, *)
     8    ' MSTATE = ', MSTATE, ', Error number = ', IERFLG
          WRITE(LUN, '('' The values of parameters, results, and '',
     8    ''statistical quantities are:'')')
          WRITE(LUN, *)
     8    ' EPS = ', EPS, ', EWT = ', EWT, ', IERROR = ', IERROR
          WRITE(LUN, *)
     8    ' MINT = ', MINT, ', MITER = ', MITER, ', IMPL = ', IMPL
          WRITE(LUN, *) ' T ', T
          WRITE(LUN, *) ' Y(1) ', Y(1)
          WRITE(LUN, *) ' Y(2) ', Y(2)
          WRITE(LUN, *) ' Y(3) ', Y(3)
          WRITE(LUN, *)
     8    ' Number of steps taken is  ', NSTEP
          WRITE(LUN, *)
     8    ' Number of evaluations of the right hand side is  ', NFE
          WRITE(LUN, *)
     8    ' Number of evaluations of the Jacobian matrix is  ', NJE
          WRITE(LUN, '(//)')
        END IF
        IPASS = 0
      END IF
      CALL XERCLR
C                                         Run SDRIV3 with invalid input.
      T = 0.E0
      Y(1) = 10.E0
      Y(2) = 0.E0
      Y(3) = 10.E0
      Y(4) = ALFA
      NSTATE = 1
      TOUT = 10.E0
      MINT = 2
      LENW = 301
      LENIWX = 1
      CALL SDRIV3 (N, T, Y, SDF, NSTATE, TOUT, NTASK, NROOT, EPS,
     8             EWT, IERROR, MINT, MITER, IMPL, ML, MU,
     8             MXORD, HMAX, WORK, LENW, IWORK, LENIWX, SDF,
     8             SDF, NDE, MXSTEP, SDF, SDF, IERFLG)
      IF (IERFLG .EQ. 33) THEN
        IF (KPRINT .EQ. 2) THEN
          WRITE(LUN, '('' SDRIV3:An invalid parameter has been '',
     8    ''correctly detected.'' //)')
        ELSE IF (KPRINT .EQ. 3) THEN
          WRITE(LUN, '('' SDRIV3:An invalid parameter has been '',
     8    ''correctly detected.'')')
          WRITE(LUN, *)
     8    ' The value of LENIW was set to ', LENIWX
          WRITE(LUN, *)
     8    ' NSTATE = ', NSTATE, ', Error number = ', IERFLG
          WRITE(LUN, '(/)')
        END IF
      ELSE
        IF (KPRINT .EQ. 1) THEN
          WRITE(LUN, '('' SDRIV3:An invalid parameter has not '',
     8    ''been correctly detected.'' //)')
        ELSE IF (KPRINT .GE. 2) THEN
          WRITE(LUN, '('' SDRIV3:An invalid parameter has not '',
     8    ''been correctly detected.'')')
          WRITE(LUN, *)
     8    ' The value of LENIW was set to ', LENIWX
          WRITE(LUN, *)
     8    ' NSTATE = ', NSTATE, ', Error number = ', IERFLG
          WRITE(LUN, '('' The values of parameters, results, and '',
     8    ''statistical quantities are:'')')
          WRITE(LUN, *)
     8    ' EPS = ', EPS, ', EWT = ', EWT, ', IERROR = ', IERROR
          WRITE(LUN, *)
     8    ' MINT = ', MINT, ', MITER = ', MITER, ', IMPL = ', IMPL
          WRITE(LUN, *) ' T ', T
          WRITE(LUN, *) ' Y(1) ', Y(1)
          WRITE(LUN, *) ' Y(2) ', Y(2)
          WRITE(LUN, *) ' Y(3) ', Y(3)
          WRITE(LUN, *)
     8    ' Number of steps taken is  ', NSTEP
          WRITE(LUN, *)
     8    ' Number of evaluations of the right hand side is  ', NFE
          WRITE(LUN, *)
     8    ' Number of evaluations of the Jacobian matrix is  ', NJE
          WRITE(LUN, '(//)')
        END IF
        IPASS = 0
      END IF
      CALL XERCLR
      RETURN
      END

*DECK QCKIN
      SUBROUTINE QCKIN (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  QCKIN
C***PURPOSE  Quick check for BSKIN.
C***LIBRARY   SLATEC
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Amos, D. E., (SNLA)
C***DESCRIPTION
C
C     ABSTRACT
C     QCKIN IS A QUICK CHECK ROUTINE WHICH EXERCISES THE MAJOR
C     LOOPS IN SUBROUTINE BSKIN (X,N,KODE,M,Y,NZ,IERR) FOR BICKLEY
C     FUNCTIONS KI(J,X).  MORE PRECISELY, QCKIN DOES CONSISTENCY CHECKS
C     ON THE OUTPUT FROM BSKIN BY COMPARING SINGLE EVALUATIONS (M=1)
C     AGAINST SELECTED MEMBERS OF SEQUENCES WHICH ARE GENERATED BY
C     RECURSION.  IF THE RELATIVE ERROR IS LESS THAN 1000 TIMES UNIT
C     ROUND OFF, THEN THE TEST IS PASSED - IF NOT, THEN X, THE VALUES
C     TO BE COMPARED, THE RELATIVE ERROR AND PARAMETERS KODE, N, M AND K
C     ARE WRITTEN ON LOGICAL UNIT 6 WHERE K IS THE MEMBER OF THE
C     SEQUENCE OF LENGTH M WHICH FAILED THE TEST.  THAT IS, THE INDEX
C     OF THE FUNCTION WHICH FAILED THE TEST IS J=N+K-1.  UNDERFLOW
C     TESTS ARE MADE AND ERROR CONDITIONS ARE TRIGGERED.
C
C     FUNCTIONS I1MACH AND R1MACH MUST BE INITIALIZED ACCORDING TO THE
C     PROLOGUE IN EACH FUNCTION FOR THE MACHINE ENVIRONMENT BEFORE
C     QCKIN OR BSKIN CAN BE EXECUTED.  FIFTEEN MACHINE ENVIRONMENTS
C     CAN BE DEFINED IN I1MACH AND R1MACH.
C
C***ROUTINES CALLED  BSKIN, I1MACH, R1MACH
C***REVISION HISTORY  (YYMMDD)
C   820601  DATE WRITTEN
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890911  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  QCKIN
      INTEGER I, IERR, IFLG, IX, I1M12, J, K, KODE, LUN, M, MDEL, MM,
     * N, NDEL, NN, NZ
      INTEGER I1MACH
      REAL AIX, ER, TOL, V, X, XINC, Y
      REAL R1MACH
      DIMENSION V(1), Y(10)
C***FIRST EXECUTABLE STATEMENT  QCKIN
      TOL = 1000.0E0*MAX(R1MACH(4),1.0E-18)
      IFLG = 0
      IF(KPRINT.GE.3)WRITE (LUN,99999)
99999 FORMAT (1H1//34H QUICK CHECK DIAGNOSTICS FOR BSKIN//)
      DO 70 KODE=1,2
        N = 0
        DO 60 NN=1,7
          M = 1
          DO 50 MM=1,4
            X = 0.0E0
            DO 40 IX=1,6
              IF (N.EQ.0 .AND. IX.EQ.1) GO TO 30
              CALL BSKIN(X, N, KODE, M, Y, NZ, IERR)
              DO 20 K=1,M,2
                J = N + K - 1
                CALL BSKIN(X, J, KODE, 1, V, NZ, IERR)
                ER = ABS((V(1)-Y(K))/V(1))
                IF (ER.LE.TOL) GO TO 20
                IF (IFLG.NE.0) GO TO 10
                IF(KPRINT.GE.2)WRITE (LUN,99998)
99998           FORMAT (8X, 1HX, 13X, 4HV(1), 11X, 4HY(K), 9X, 6HREL ER,
     *           1HR, 5X, 4HKODE, 3X, 1HN, 4X, 1HM, 4X, 1HK)
   10           CONTINUE
                IFLG = IFLG + 1
                IF(KPRINT.GE.2)
     *          WRITE (LUN,99997) X, V(1), Y(K), ER, KODE, N, M, K
99997           FORMAT (4E15.6, 4I5)
                IF (IFLG.GT.200) GO TO 130
   20         CONTINUE
   30         CONTINUE
              AIX = 2*IX-3
              XINC = MAX(1.0E0,AIX)
              X = X + XINC
   40       CONTINUE
            MDEL = MAX(1,MM-1)
            M = M + MDEL
   50     CONTINUE
          NDEL = MAX(1,2*N-2)
          N = N + NDEL
   60   CONTINUE
   70 CONTINUE
C-----------------------------------------------------------------------
C     TEST UNDERFLOW
C-----------------------------------------------------------------------
      KODE = 1
      M = 10
      N = 10
      I1M12 = I1MACH(12)
      X = -2.302E0*R1MACH(5)*I1M12
      CALL BSKIN(X, N, KODE, M, Y, NZ, IERR)
      IF (NZ.EQ.M) GO TO 80
      IF(KPRINT.GE.2)WRITE (LUN,99996)
99996 FORMAT (//30H NZ IN UNDERFLOW TEST IS NOT 1//)
      IFLG = IFLG + 1
      GO TO 110
   80 CONTINUE
      DO 90 I=1,M
        IF (Y(I).NE.0.0E0) GO TO 100
   90 CONTINUE
      GO TO 110
  100 CONTINUE
      IFLG = IFLG + 1
      IF(KPRINT.GE.2)WRITE (LUN,99995)
99995 FORMAT (//43H SOME Y VALUE IN UNDERFLOW TEST IS NOT ZERO//)
  110 CONTINUE
      IF (IFLG.NE.0.OR.KPRINT.LT.3) GO TO 120
      WRITE (LUN,99994)
99994 FORMAT (//16H QUICK CHECKS OK//)
  120 CONTINUE
      IPASS=0
      IF(IFLG.EQ.0) IPASS=1
      RETURN
  130 CONTINUE
      IF(KPRINT.GE.2)WRITE (LUN,99992)
99992 FORMAT (//52H PROCESSING OF MAIN LOOPS TERMINATED BECAUSE THE NUM,
     * 36HBER OF DIAGNOSTIC PRINTS EXCEEDS 200//)
      IPASS=0
      IF(IFLG.EQ.0) IPASS=1
      RETURN
      END

*DECK F2P
      REAL FUNCTION F2P (X)
C***BEGIN PROLOGUE  F2P
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F2P
      REAL X
C***FIRST EXECUTABLE STATEMENT  F2P
      F2P = SIN(0.314159E+03*X)/(0.314159E+01*X)
      RETURN
      END

*DECK GVEC
      SUBROUTINE GVEC (X, G)
C***BEGIN PROLOGUE  GVEC
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  GVEC
      DIMENSION G(*)
C***FIRST EXECUTABLE STATEMENT  GVEC
      G(1) = 0.0
      G(2) = 1.0+COS(X)
      RETURN
      END

*DECK SDRES1
      SUBROUTINE SDRES1 (T, Y, YPRIME, DELTA, IRES, RPAR, IPAR)
C***BEGIN PROLOGUE  SDRES1
C***SUBSIDIARY
C***PURPOSE  First residual evaluator for SDASQC.
C***LIBRARY   SLATEC (DASSL)
C***TYPE      SINGLE PRECISION (SDRES1-S, DDRES1-D)
C***AUTHOR  PETZOLD, LINDA R., (LLNL)
C***SEE ALSO  SDASQC
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   891013  DATE WRITTEN
C   901001  Converted prologue to 4.0 format and made all argument
C           declarations explicit.  (FNF)
C***END PROLOGUE  SDRES1
      INTEGER  IRES, IPAR(*)
      REAL  T, Y(*), YPRIME(*), DELTA(*), RPAR(*)
C***FIRST EXECUTABLE STATEMENT  SDRES1
      DELTA(1) = YPRIME(1) + 10.0E0*Y(1)
      DELTA(2) = Y(2) + Y(1) - 1.0E0
      RETURN
      END

*DECK DMAKE2
      SUBROUTINE DMAKE2 (TYPE, UPLO, DIAG, M, N, A, NMAX, AA, LDA, KL,
     $   KU, RESET, TRANSL)
C***BEGIN PROLOGUE  DMAKE2
C***SUBSIDIARY
C***PURPOSE  Generate values for an M by N matrix A.
C***LIBRARY   SLATEC (BLAS)
C***AUTHOR  Du Croz, J. J., (NAG)
C           Hanson, R. J., (SNLA)
C***DESCRIPTION
C
C  Generates values for an M by N matrix A within the bandwidth
C  defined by KL and KU.
C  Stores the values in the array AA in the data structure required
C  by the routine, with unwanted elements set to rogue value.
C
C  TYPE is 'GE', 'GB', 'SY', 'SB', 'SP', 'TR', 'TB' OR 'TP'.
C
C  Auxiliary routine for test program for Level 2 Blas.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  DBEG
C***REVISION HISTORY  (YYMMDD)
C   870810  DATE WRITTEN
C   910620  Modified to meet SLATEC code and prologue standards.  (BKS)
C***END PROLOGUE  DMAKE2
C     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
      DOUBLE PRECISION   ROGUE
      PARAMETER          ( ROGUE = -1.0D10 )
C     .. Scalar Arguments ..
      DOUBLE PRECISION   TRANSL
      INTEGER            KL, KU, LDA, M, N, NMAX
      LOGICAL            RESET
      CHARACTER*1        DIAG, UPLO
      CHARACTER*2        TYPE
C     .. Array Arguments ..
      DOUBLE PRECISION   A( NMAX, * ), AA( * )
C     .. Local Scalars ..
      INTEGER            I, I1, I2, I3, IBEG, IEND, IOFF, J, KK
      LOGICAL            GEN, LOWER, SYM, TRI, UNIT, UPPER
C     .. External Functions ..
      DOUBLE PRECISION   DBEG
      EXTERNAL           DBEG
C     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
C***FIRST EXECUTABLE STATEMENT  DMAKE2
      GEN = TYPE( 1: 1 ).EQ.'G'
      SYM = TYPE( 1: 1 ).EQ.'S'
      TRI = TYPE( 1: 1 ).EQ.'T'
      UPPER = ( SYM.OR.TRI ).AND.UPLO.EQ.'U'
      LOWER = ( SYM.OR.TRI ).AND.UPLO.EQ.'L'
      UNIT = TRI.AND.DIAG.EQ.'U'
C
C     Generate data in array A.
C
      DO 20 J = 1, N
         DO 10 I = 1, M
            IF( GEN.OR.( UPPER.AND.I.LE.J ).OR.( LOWER.AND.I.GE.J ) )
     $          THEN
               IF( ( I.LE.J.AND.J - I.LE.KU ).OR.
     $             ( I.GE.J.AND.I - J.LE.KL ) )THEN
                  A( I, J ) = DBEG( RESET ) + TRANSL
               ELSE
                  A( I, J ) = ZERO
               END IF
               IF( I.NE.J )THEN
                  IF( SYM )THEN
                     A( J, I ) = A( I, J )
                  ELSE IF( TRI )THEN
                     A( J, I ) = ZERO
                  END IF
               END IF
            END IF
   10    CONTINUE
         IF( TRI )
     $      A( J, J ) = A( J, J ) + ONE
         IF( UNIT )
     $      A( J, J ) = ONE
   20 CONTINUE
C
C     Store elements in array AS in data structure required by routine.
C
      IF( TYPE.EQ.'GE' )THEN
         DO 50 J = 1, N
            DO 30 I = 1, M
               AA( I + ( J - 1 )*LDA ) = A( I, J )
   30       CONTINUE
            DO 40 I = M + 1, LDA
               AA( I + ( J - 1 )*LDA ) = ROGUE
   40       CONTINUE
   50    CONTINUE
      ELSE IF( TYPE.EQ.'GB' )THEN
         DO 90 J = 1, N
            DO 60 I1 = 1, KU + 1 - J
               AA( I1 + ( J - 1 )*LDA ) = ROGUE
   60       CONTINUE
            DO 70 I2 = I1, MIN( KL + KU + 1, KU + 1 + M - J )
               AA( I2 + ( J - 1 )*LDA ) = A( I2 + J - KU - 1, J )
   70       CONTINUE
            DO 80 I3 = I2, LDA
               AA( I3 + ( J - 1 )*LDA ) = ROGUE
   80       CONTINUE
   90    CONTINUE
      ELSE IF( TYPE.EQ.'SY'.OR.TYPE.EQ.'TR' )THEN
         DO 130 J = 1, N
            IF( UPPER )THEN
               IBEG = 1
               IF( UNIT )THEN
                  IEND = J - 1
               ELSE
                  IEND = J
               END IF
            ELSE
               IF( UNIT )THEN
                  IBEG = J + 1
               ELSE
                  IBEG = J
               END IF
               IEND = N
            END IF
            DO 100 I = 1, IBEG - 1
               AA( I + ( J - 1 )*LDA ) = ROGUE
  100       CONTINUE
            DO 110 I = IBEG, IEND
               AA( I + ( J - 1 )*LDA ) = A( I, J )
  110       CONTINUE
            DO 120 I = IEND + 1, LDA
               AA( I + ( J - 1 )*LDA ) = ROGUE
  120       CONTINUE
  130    CONTINUE
      ELSE IF( TYPE.EQ.'SB'.OR.TYPE.EQ.'TB' )THEN
         DO 170 J = 1, N
            IF( UPPER )THEN
               KK = KL + 1
               IBEG = MAX( 1, KL + 2 - J )
               IF( UNIT )THEN
                  IEND = KL
               ELSE
                  IEND = KL + 1
               END IF
            ELSE
               KK = 1
               IF( UNIT )THEN
                  IBEG = 2
               ELSE
                  IBEG = 1
               END IF
               IEND = MIN( KL + 1, 1 + M - J )
            END IF
            DO 140 I = 1, IBEG - 1
               AA( I + ( J - 1 )*LDA ) = ROGUE
  140       CONTINUE
            DO 150 I = IBEG, IEND
               AA( I + ( J - 1 )*LDA ) = A( I + J - KK, J )
  150       CONTINUE
            DO 160 I = IEND + 1, LDA
               AA( I + ( J - 1 )*LDA ) = ROGUE
  160       CONTINUE
  170    CONTINUE
      ELSE IF( TYPE.EQ.'SP'.OR.TYPE.EQ.'TP' )THEN
         IOFF = 0
         DO 190 J = 1, N
            IF( UPPER )THEN
               IBEG = 1
               IEND = J
            ELSE
               IBEG = J
               IEND = N
            END IF
            DO 180 I = IBEG, IEND
               IOFF = IOFF + 1
               AA( IOFF ) = A( I, J )
               IF( I.EQ.J )THEN
                  IF( UNIT )
     $               AA( IOFF ) = ROGUE
               END IF
  180       CONTINUE
  190    CONTINUE
      END IF
      RETURN
C
C     End of DMAKE2.
C
      END

*DECK HSRTQC
      SUBROUTINE HSRTQC (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  HSRTQC
C***SUBSIDIARY
C***PURPOSE  Quick check for SLATEC routine HPSORT, HPPERM
C***LIBRARY   SLATEC
C***CATEGORY  N6A
C***TYPE      CHARACTER (SSRTQC-S, DSRTQC-D, ISRTQC-I, HSRTQC-H)
C***KEYWORDS  HPPERM, HPSORT, QUICK CHECK
C***AUTHOR  Boisvert, Ronald, (NIST)
C***REFERENCES  (NONE)
C***ROUTINES CALLED  HPPERM, HPSORT
C***REVISION HISTORY  (YYMMDD)
C   890620  DATE WRITTEN
C   901005  Included test of HPPERM.  (MAM)
C   920511  Added error message tests.  (MAM)
C***END PROLOGUE  HSRTQC
C
      INTEGER N, NTEST
      PARAMETER (N=9,NTEST=4)
C
      LOGICAL FAIL
      CHARACTER*1 SHORT
      CHARACTER*2 X(N,NTEST), XS(N,NTEST), Y(N), WORK(N)
      INTEGER IX(N,NTEST), IY(N), KFLAG(NTEST), KPRINT, LUN, IPASS, J,
     +        I, KABS, IER, NERR, NUMXER, NN, KKFLAG, STRBEG, STREND
C
C     ---------
C     TEST DATA
C     ---------
C
C         X   = TEST VECTOR
C         XS  = TEST VECTOR IN SORTED ORDER
C         IX  = PERMUTATION VECTOR, I.E.  X(IX(J)) = XS(J)
C
      DATA KFLAG(1)       /  2 /
      DATA (X(I,1),I=1,N) /'AC','AZ','AD','AA','AB','ZZ','ZA','ZX','ZY'/
      DATA (IX(I,1),I=1,N)/  4,   5,   1,   3,   2,   7,   8,   9,   6/
      DATA (XS(I,1),I=1,N)/'AA','AB','AC','AD','AZ','ZA','ZX','ZY','ZZ'/
C
      DATA KFLAG(2)       / -1 /
      DATA (X(I,2),I=1,N) /'AA','BB','CC','DD','EE','FF','GG','HH','II'/
      DATA (IX(I,2),I=1,N)/  9,   8,   7,   6,   5,   4,   3,   2,   1 /
      DATA (XS(I,2),I=1,N)/'II','HH','GG','FF','EE','DD','CC','BB','AA'/
C
      DATA KFLAG(3)       / -2 /
      DATA (X(I,3),I=1,N) /'AA','BB','CC','DD','EE','FF','GG','HH','II'/
      DATA (IX(I,3),I=1,N)/  9,   8,   7,   6,   5,   4,   3,   2,   1/
      DATA (XS(I,3),I=1,N)/'II','HH','GG','FF','EE','DD','CC','BB','AA'/
C
      DATA KFLAG(4)       /  1 /
      DATA (X(I,4),I=1,N) /'AC','AZ','AD','AA','AB','ZZ','ZA','ZX','ZY'/
      DATA (IX(I,4),I=1,N)/  4,   5,   1,   3,   2,   7,   8,   9,   6/
      DATA (XS(I,4),I=1,N)/'AA','AB','AC','AD','AZ','ZA','ZX','ZY','ZZ'/
C
C***FIRST EXECUTABLE STATEMENT  HSRTQC
      IF ( KPRINT .GE. 2 ) THEN
         WRITE (LUN,2001) '================='
         WRITE (LUN,2002) 'OUTPUT FROM HSRTQC'
         WRITE (LUN,2002) '================='
      ENDIF
      IPASS = 1
C
C     -------------------------------------------------------------
C                            CHECK HPSORT
C     -------------------------------------------------------------
C
      DO 300 J=1,NTEST
C
C        ... SETUP PROBLEM
C
         DO 210 I=1,N
            Y(I) = X(I,J)
  210    CONTINUE
C
C        ... CALL ROUTINE TO BE TESTED
C
         CALL HPSORT(Y,N,1,2,IY,KFLAG(J),WORK,IER)
C
C        ... EVALUATE RESULTS
C
         KABS = ABS(KFLAG(J))
         FAIL = .FALSE. .OR. (IER.GT.0)
         DO 220 I=1,N
            FAIL = FAIL .OR. (IY(I).NE.IX(I,J))
     +                  .OR. ((KABS.EQ.1).AND.(Y(I).NE.X(I,J)))
     +                  .OR. ((KABS.EQ.2).AND.(Y(I).NE.XS(I,J)))
  220    CONTINUE
C
C        ... PRODUCE REQUIRED OUTPUT
C
         IF (FAIL) THEN
            IPASS = 0
            IF (KPRINT .GT. 0) WRITE(LUN,2001) 'HPSORT FAILED TEST ',J
         ELSE
            IF (KPRINT .GE. 2) WRITE(LUN,2001) 'HPSORT PASSED TEST ',J
         ENDIF
         IF ((FAIL .AND. (KPRINT .GE. 2)) .OR. (KPRINT .GE. 3)) THEN
            WRITE(LUN,2001) '-------------------------'
            WRITE(LUN,2002) 'DETAILS OF HPSORT TEST ',J
            WRITE(LUN,2002) '-------------------------'
            WRITE(LUN,2002) '1ST ARGUMENT (VECTOR TO BE SORTED)'
            WRITE(LUN,2003) '             INPUT = ',(X(I,J),I=1,N)
            WRITE(LUN,2003) '   COMPUTED OUTPUT = ',(Y(I),I=1,N)
            IF (KABS .EQ. 1) THEN
               WRITE(LUN,2003) '    CORRECT OUTPUT = ',(X(I,J),I=1,N)
            ELSE
               WRITE(LUN,2003) '    CORRECT OUTPUT = ',(XS(I,J),I=1,N)
            ENDIF
            WRITE(LUN,2002) '2ND ARGUMENT (VECTOR LENGTH)'
            WRITE(LUN,2004) '             INPUT = ',N
            WRITE(LUN,2002) '3RD ARGUMENT (PERMUTATION VECTOR)'
            WRITE(LUN,2004) '   COMPUTED OUTPUT = ',(IY(I),I=1,N)
            WRITE(LUN,2004) '    CORRECT OUTPUT = ',(IX(I,J),I=1,N)
            WRITE(LUN,2002) '4TH ARGUMENT (TYPE OF SORT)'
            WRITE(LUN,2004) '             INPUT = ',KFLAG(J)
         ENDIF
C
  300 CONTINUE
C
C     ... TEST ERROR MESSAGES
C
      IF(KPRINT.LE.2)THEN
         CALL XSETF(0)
      ELSE
         CALL XSETF(-1)
      ENDIF
C
      NN=-1
      STRBEG=1
      STREND=2
      KKFLAG=1
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL HPSORT(Y,NN,STRBEG,STREND,IY,KKFLAG,WORK,IER)
      IF(NUMXER(NERR).NE.IER)IPASS=0
C
      NN=1
      STRBEG=1
      STREND=2
      KKFLAG=0
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL HPSORT(Y,NN,STRBEG,STREND,IY,KKFLAG,WORK,IER)
      IF(NUMXER(NERR).NE.IER)IPASS=0
C
      NN=1
      STRBEG=1
      STREND=2
      KKFLAG=1
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL HPSORT(Y,NN,STRBEG,STREND,IY,KKFLAG,SHORT,IER)
      IF(NUMXER(NERR).NE.IER)IPASS=0
C
      NN=1
      STRBEG=2
      STREND=1
      KKFLAG=1
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL HPSORT(Y,NN,STRBEG,STREND,IY,KKFLAG,WORK,IER)
      IF(NUMXER(NERR).NE.IER)IPASS=0
C
      NN=1
      STRBEG=-1
      STREND=2
      KKFLAG=1
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL HPSORT(Y,NN,STRBEG,STREND,IY,KKFLAG,WORK,IER)
      IF(NUMXER(NERR).NE.IER)IPASS=0
C
      NN=1
      STRBEG=1
      STREND=3
      KKFLAG=1
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL HPSORT(Y,NN,STRBEG,STREND,IY,KKFLAG,WORK,IER)
      IF(NUMXER(NERR).NE.IER)IPASS=0
C
      IF((KPRINT.GE.2).AND.(IPASS.EQ.1))THEN
         WRITE(LUN,*)
         WRITE(LUN,*)' HPSORT PASSED ERROR MESSAGE TESTS'
      ELSE IF((KPRINT.GE.1).AND.(IPASS.EQ.0))THEN
         WRITE(LUN,*)
         WRITE(LUN,*)' HPSORT FAILED ERROR MESSAGE TESTS'
      ENDIF
C
C     -------------------------------------------------------------
C                            CHECK HPPERM
C     -------------------------------------------------------------
C
      DO 400 J=1,NTEST
C
C        ... SETUP PROBLEM
C
         KABS = ABS(KFLAG(J))
         DO 310 I=1,N
            Y(I) = X(I,J)
            IF(KABS.EQ.1)THEN
               IY(I) = I
            ELSE
               IY(I) = IX(I,J)
            ENDIF
  310    CONTINUE
C
C        ... CALL ROUTINE TO BE TESTED
C
         CALL HPPERM(Y,N,IY,WORK,IER)
C
C        ... EVALUATE RESULTS
C
         FAIL = .FALSE. .OR. (IER.GT.0)
         DO 320 I=1,N
            FAIL = FAIL .OR. ((KABS.EQ.1).AND.(IY(I).NE.I))
     +                  .OR. ((KABS.EQ.2).AND.(IY(I).NE.IX(I,J)))
     +                  .OR. ((KABS.EQ.1).AND.(Y(I).NE.X(I,J)))
     +                  .OR. ((KABS.EQ.2).AND.(Y(I).NE.XS(I,J)))
  320    CONTINUE
C
C        ... PRODUCE REQUIRED OUTPUT
C
         IF (FAIL) THEN
            IPASS = 0
            IF (KPRINT.GT.0) WRITE(LUN,2001)'HPPERM FAILED TEST ',J
         ELSE
            IF (KPRINT.GE.2) WRITE(LUN,2001)'HPPERM PASSED TEST ',J
         ENDIF
         IF ((FAIL .AND. (KPRINT.GE.2)) .OR. (KPRINT.GE.3)) THEN
            WRITE(LUN,2001)'------------------------'
            WRITE(LUN,2002)'DETAILS OF HPPERM TEST',J
            WRITE(LUN,2002)'------------------------'
            WRITE(LUN,2002)'1ST ARGUMENT (VECTOR TO BE PERMUTED)'
            WRITE(LUN,2003)'             INPUT =',(X(I,J),I=1,N)
            WRITE(LUN,2003)'   COMPUTED OUTPUT =',(Y(I),I=1,N)
            IF(KABS.EQ.1)THEN
               WRITE(LUN,2003)'    CORRECT OUTPUT =',(X(I,J),I=1,N)
            ELSE
               WRITE(LUN,2003)'    CORRECT OUTPUT =',(XS(I,J),I=1,N)
            ENDIF
            WRITE(LUN,2002)'2ND ARGUMENT (VECTOR LENGTH)'
            WRITE(LUN,2004)'             INPUT =',N
            WRITE(LUN,2002)'3RD ARGUMENT (PERMUTATION VECTOR)'
            WRITE(LUN,2004)'             INPUT =',(IY(I),I=1,N)
            WRITE(LUN,2002)'4TH ARGUMENT (ERROR FLAG)'
            WRITE(LUN,2004)'             OUTPUT =',IER
         ENDIF
C
  400 CONTINUE
C
C     ... TEST ERROR MESSAGES
C
      IF(KPRINT.LE.2)THEN
         CALL XSETF(0)
      ELSE
         CALL XSETF(-1)
      ENDIF
C
      NN=-1
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL HPPERM(Y,NN,IY,WORK,IER)
      IF(NUMXER(NERR).NE.IER)IPASS=0
C
      NN=1
      IY(1)=5
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL HPPERM(Y,NN,IY,WORK,IER)
      IF(NUMXER(NERR).NE.IER)IPASS=0
C
      IF((KPRINT.GE.2).AND.(IPASS.EQ.1))THEN
         WRITE(LUN,*)
         WRITE(LUN,*)' HPPERM PASSED ERROR MESSAGE TESTS'
      ELSE IF((KPRINT.GE.1).AND.(IPASS.EQ.0))THEN
         WRITE(LUN,*)
         WRITE(LUN,*)' HPPERM FAILED ERROR MESSAGE TESTS'
      ENDIF
C
      RETURN
C
 2001 FORMAT(/ 1X,A,I2)
 2002 FORMAT(1X,A,I2)
 2003 FORMAT(1X,A,9(2X,A2))
 2004 FORMAT(1X,A,9I4)
      END

*DECK SBLAT3
      SUBROUTINE SBLAT3 (NOUT, KPRINT, IPASS)
C***BEGIN PROLOGUE  SBLAT3
C***PURPOSE  Driver for testing Level 3 BLAS single precision
C            subroutines.
C***LIBRARY   SLATEC (BLAS)
C***CATEGORY  A3A
C***TYPE      SINGLE PRECISION (SBLAT3-S, DBLAT3-D, CBLAT3-C)
C***KEYWORDS  BLAS, QUICK CHECK DRIVER
C***AUTHOR  Dongarra, J. J., (ANL)
C           Duff, I., (AERE)
C           Du Croz, J., (NAG)
C           Hammarling, S., (NAG)
C***DESCRIPTION
C
C  Test program for the REAL             Level 3 Blas.
C
C***REFERENCES  Dongarra, J., Du Croz, J., Duff, I., and Hammarling, S.
C                 A set of level 3 basic linear algebra subprograms.
C                 ACM TOMS, Vol. 16, No. 1, pp. 1-17, March 1990.
C***ROUTINES CALLED  LSE, R1MACH, SCHK13, SCHK23, SCHK33, SCHK43,
C                    SCHK53, SCHKE3, SMMCH, XERCLR
C***REVISION HISTORY  (YYMMDD)
C   890208  DATE WRITTEN
C   910619  Modified to meet SLATEC code and prologue standards.  (BKS)
C   930315  Removed unused variables.  (WRB)
C   930618  Code modified to improve PASS/FAIL reporting.  (BKS, WRB)
C   930701  Call to SCHKE5 changed to call to SCHKE3.  (BKS)
C***END PROLOGUE  SBLAT3
C     .. Parameters ..
      INTEGER            NSUBS
      PARAMETER          ( NSUBS = 6)
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0, ONE = 1.0 )
      INTEGER            NMAX, INCMAX
      PARAMETER          ( NMAX = 65, INCMAX = 2 )
C     .. Scalar Arguments ..
      INTEGER            IPASS, KPRINT
C     .. Local Scalars ..
      REAL               EPS, ERR, THRESH
      INTEGER            I, ISNUM, J, N, NALF, NBET, NIDIM, NOUT
      PARAMETER          (NIDIM=6, NALF=3, NBET=3)
      LOGICAL            SAME, TSTERR, FTL, FTL1, FTL2
      CHARACTER*1        TRANSA, TRANSB
C     .. Local Arrays ..
      REAL               AB( NMAX, 2*NMAX ), AA( NMAX*NMAX ),
     $                   ALF( NALF ), AS( NMAX*NMAX ), BET( NBET ),
     $                   G( NMAX ),  BB( NMAX*NMAX ),
     $                   BS( NMAX*NMAX ), C( NMAX,NMAX),
     $                   CC( NMAX*NMAX ), CS( NMAX*NMAX),
     $                   CT( NMAX), W( 2*NMAX )
      INTEGER            IDIM( NIDIM )
      LOGICAL            LTEST( NSUBS )
      CHARACTER*6        SNAMES( NSUBS )
C     .. External Functions ..
      REAL               R1MACH
      LOGICAL            LSE
      EXTERNAL           LSE, R1MACH
C     .. External Subroutines ..
      EXTERNAL           SCHK13, SCHK23, SCHK33, SCHK43, SCHK53,
     $                   SCHKE3, SMMCH
C     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
C     .. Data statements ..
      DATA               SNAMES/'SGEMM ', 'SSYMM ', 'STRMM ', 'STRSM ',
     $                   'SSYRK ', 'SSYR2K'/
      DATA               IDIM/0,1,2,3,5,9/
      DATA               ALF/0.0,1.0,0.7/
      DATA               BET/0.0,1.0,1.3/
C***FIRST EXECUTABLE STATEMENT  SBLAT3
C
C     Set the flag that indicates whether error exits are to be tested.
C
      TSTERR=.TRUE.
C
C     Set the threshold value of the test ratio
C
      THRESH=16.0
C
C     Initialize IPASS to 1 assuming everything will pass.
C
      IPASS = 1
C
C     Report values of parameters.
C
      IF (KPRINT .GE. 3) THEN
        WRITE( NOUT, FMT = 9995 )
        WRITE( NOUT, FMT = 9994 )( IDIM( I ), I = 1, NIDIM )
        WRITE( NOUT, FMT = 9993 )( ALF( I ), I = 1, NALF )
        WRITE( NOUT, FMT = 9992 )( BET( I ), I = 1, NBET )
        IF( .NOT.TSTERR )THEN
           WRITE( NOUT, FMT = 9984 )
        END IF
        WRITE( NOUT, FMT = 9999 )THRESH
      ENDIF
C
C     Set names of subroutines and flags which indicate
C     whether they are to be tested.
C
      DO 40 I = 1, NSUBS
         LTEST( I ) = .TRUE.
   40 CONTINUE
C
C     Set EPS (the machine precision).
C
      EPS = R1MACH (4)
C
C     Check the reliability of SMMCH using exact data.
C
      N = MIN( 32, NMAX )
      DO 120 J = 1, N
         DO 110 I = 1, N
            AB( I, J ) = MAX( I - J + 1, 0 )
  110    CONTINUE
         AB( J, NMAX + 1 ) = J
         AB( 1, NMAX + J ) = J
         C( J, 1 ) = ZERO
  120 CONTINUE
      DO 130 J = 1, N
         CC( J ) = J*( ( J + 1 )*J )/2 - ( ( J + 1 )*J*( J - 1 ) )/3
  130 CONTINUE
C     CC holds the exact result. On exit from SMMCH CT holds
C     the result computed by SMMCH.
      TRANSA = 'N'
      TRANSB = 'N'
      FTL = .FALSE.
      CALL SMMCH( TRANSA, TRANSB, N, 1, N, ONE, AB, NMAX,
     $            AB( 1, NMAX + 1 ), NMAX, ZERO, C, NMAX, CT, G, CC,
     $            NMAX, EPS, ERR, FTL, NOUT, .TRUE., KPRINT )
      SAME = LSE( CC, CT, N )
      IF( .NOT.SAME.OR.ERR.NE.ZERO )THEN
        IPASS = 0
        IF (KPRINT .GE. 2) THEN
           WRITE( NOUT, FMT = 9989 )TRANSA, TRANSB, SAME, ERR
        END IF
      ENDIF
      TRANSB = 'T'
      FTL = .FALSE.
      CALL SMMCH( TRANSA, TRANSB, N, 1, N, ONE, AB, NMAX,
     $            AB( 1, NMAX + 1 ), NMAX, ZERO, C, NMAX, CT, G, CC,
     $            NMAX, EPS, ERR, FTL, NOUT, .TRUE., KPRINT )
      SAME = LSE( CC, CT, N )
      IF( .NOT.SAME.OR.ERR.NE.ZERO )THEN
        IPASS = 0
        IF ( KPRINT .GE. 2) THEN
           WRITE( NOUT, FMT = 9989 )TRANSA, TRANSB, SAME, ERR
        END IF
      ENDIF
      DO 125 J = 1, N
         AB( J, NMAX + 1 ) = N - J + 1
         AB( 1, NMAX + J ) = N - J + 1
  125 CONTINUE
      DO 135 J = 1, N
         CC( N - J + 1 ) = J*( ( J + 1 )*J )/2 -
     $                     ( ( J + 1 )*J*( J - 1 ) )/3
  135 CONTINUE
      TRANSA = 'T'
      TRANSB = 'N'
      FTL = .FALSE.
      CALL SMMCH( TRANSA, TRANSB, N, 1, N, ONE, AB, NMAX,
     $            AB( 1, NMAX + 1 ), NMAX, ZERO, C, NMAX, CT, G, CC,
     $            NMAX, EPS, ERR, FTL, NOUT, .TRUE., KPRINT )
      SAME = LSE( CC, CT, N )
      IF( .NOT.SAME.OR.ERR.NE.ZERO )THEN
        IPASS = 0
        IF ( KPRINT .GE. 2) THEN
           WRITE( NOUT, FMT = 9989 )TRANSA, TRANSB, SAME, ERR
        END IF
      END IF
      TRANSB = 'T'
      FTL = .FALSE.
      CALL SMMCH( TRANSA, TRANSB, N, 1, N, ONE, AB, NMAX,
     $            AB( 1, NMAX + 1 ), NMAX, ZERO, C, NMAX, CT, G, CC,
     $            NMAX, EPS, ERR, FTL, NOUT, .TRUE., KPRINT )
      SAME = LSE( CC, CT, N )
      IF( .NOT.SAME.OR.ERR.NE.ZERO )THEN
        IPASS = 0
        IF ( KPRINT .GE. 2) THEN
           WRITE( NOUT, FMT = 9989 )TRANSA, TRANSB, SAME, ERR
        END IF
      END IF
C
C     Test each subroutine in turn.
C
      DO 210 ISNUM = 1, NSUBS
         IF( .NOT.LTEST( ISNUM ) )THEN
C           Subprogram is not to be tested.
            WRITE( NOUT, FMT = 9987 )SNAMES( ISNUM )
         ELSE
C           Test error exits.
            FTL1 = .FALSE.
            IF( TSTERR )THEN
              CALL SCHKE3(ISNUM, SNAMES( ISNUM ), NOUT, KPRINT, FTL1)
            END IF
C           Test computations.
            FTL2 = .FALSE.
            CALL XERCLR
            GO TO ( 140, 150, 160, 160, 170, 180) ISNUM
C           Test SGEMM, 01.
  140       CALL SCHK13( SNAMES( ISNUM ), EPS, THRESH, NOUT, KPRINT,
     $                  FTL2, NIDIM, IDIM, NALF, ALF, NBET, BET,
     $                  NMAX, AB, AA, AS, AB(1, NMAX + 1),
     $                  BB, BS, C, CC, CS, CT, G )
            GO TO 200
C           Test SSYMM, 02.
  150       CALL SCHK23( SNAMES( ISNUM ), EPS, THRESH, NOUT, KPRINT,
     $                  FTL2, NIDIM, IDIM, NALF, ALF, NBET, BET,
     $                  NMAX, AB, AA, AS, AB(1, NMAX + 1),
     $                  BB, BS, C, CC, CS, CT, G )
            GO TO 200
C           Test STRMM, 03, STRSM, 04.
  160       CALL SCHK33( SNAMES( ISNUM ), EPS, THRESH, NOUT, KPRINT,
     $                  FTL2, NIDIM, IDIM, NALF, ALF, NMAX, AB,
     $                  AA, AS ,AB(1, NMAX + 1), BB, BS, CT, G, C)
            GO TO 200
C           Test SSYRK, 05.
  170       CALL SCHK43( SNAMES( ISNUM ), EPS, THRESH, NOUT, KPRINT,
     $                  FTL2, NIDIM, IDIM, NALF, ALF, NBET, BET,
     $                  NMAX, AB, AA, AS, AB(1, NMAX + 1), BB, BS, C,
     $                  CC, CS, CT, G )
            GO TO 200
C           Test SSYR2K, 06.
  180       CALL SCHK53( SNAMES( ISNUM ), EPS, THRESH, NOUT, KPRINT,
     $                  FTL2, NIDIM, IDIM, NALF, ALF, NBET, BET,
     $                  NMAX, AB, AA, AS, BB, BS, C, CC, CS, CT, G, W)
            GO TO 200
  200       IF (FTL1 .OR. FTL2) THEN
              IPASS = 0
            ENDIF
         END IF
  210 CONTINUE
      RETURN
C
 9999 FORMAT( ' ROUTINES PASS COMPUTATIONAL TESTS IF TEST RATIO IS LES',
     $      'S THAN', F8.2 )
 9995 FORMAT( ' TESTS OF THE REAL             LEVEL 3 BLAS', //' THE F',
     $      'OLLOWING PARAMETER VALUES WILL BE USED:' )
 9994 FORMAT( '   FOR N              ', 9I6 )
 9993 FORMAT( '   FOR ALPHA          ', 7F6.1 )
 9992 FORMAT( '   FOR BETA           ', 7F6.1 )
 9989 FORMAT( ' ERROR IN SMMCH -  IN-LINE DOT PRODUCTS ARE BEING EVALU',
     $      'ATED WRONGLY.', /' SMMCH WAS CALLED WITH TRANSA = ', A1,
     $      ' AND TRANSB = ', A1,
     $      ' AND RETURNED SAME = ', L1, ' AND ERR = ', F12.3, '.', /
     $      ' THIS MAY BE DUE TO FAULTS IN THE ARITHMETIC OR THE',
     $      ' COMPILER.')
 9987 FORMAT( 1X, A6, ' WAS NOT TESTED' )
 9984 FORMAT( ' ERROR-EXITS WILL NOT BE TESTED' )
C
C     End of SBLAT3.
C
      END

*DECK SDJAC1
      SUBROUTINE SDJAC1 (T, Y, YPRIME, PD, CJ, RPAR, IPAR)
C***BEGIN PROLOGUE  SDJAC1
C***SUBSIDIARY
C***PURPOSE  First Jacobian evaluator for SDASQC.
C***LIBRARY   SLATEC (DASSL)
C***TYPE      SINGLE PRECISION (SDJAC1-S, DDJAC1-D)
C***AUTHOR  PETZOLD, LINDA R., (LLNL)
C***SEE ALSO  SDASQC
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   891013  DATE WRITTEN
C   901001  Converted prologue to 4.0 format and made all argument
C           declarations explicit.  (FNF)
C***END PROLOGUE  SDJAC1
      INTEGER  IPAR(*)
      REAL  T, Y(*), YPRIME(*), PD(2,2), CJ, RPAR(*)
C***FIRST EXECUTABLE STATEMENT  SDJAC1
      PD(1,1) = CJ + 10.0E0
      PD(1,2) = 0.0E0
      PD(2,1) = 1.0E0
      PD(2,2) = 1.0E0
      RETURN
      END

*DECK SCHK43
      SUBROUTINE SCHK43 (SNAME, EPS, THRESH, NOUT, KPRINT, FATAL, NIDIM,
     $   IDIM, NALF, ALF, NBET, BET, NMAX, A, AA, AS, B, BB, BS, C, CC,
     $   CS, CT, G)
C***BEGIN PROLOGUE  SCHK43
C***SUBSIDIARY
C***PURPOSE  Quick check for SSYRK.
C***LIBRARY   SLATEC (BLAS)
C***KEYWORDS  BLAS, QUICK CHECK SERVICE ROUTINE
C***AUTHOR  Dongarra, J. J., (ANL)
C           Duff, I., (AERE)
C           Du Croz, J., (NAG)
C           Hammarling, S., (NAG)
C***DESCRIPTION
C
C  Quick check for SSYRK.
C
C  Auxiliary routine for test program for Level 3 Blas.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  LSE, LSERES, NUMXER, SMAKE3, SMMCH, SSYRK
C***REVISION HISTORY  (YYMMDD)
C   890208  DATE WRITTEN
C   910619  Modified to meet SLATEC code and prologue standards.  (BKS)
C***END PROLOGUE  SCHK43
C     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0, ONE = 1.0)
C     .. Scalar Arguments ..
      LOGICAL            FATAL
      REAL               EPS, THRESH
      INTEGER            KPRINT, NALF, NBET, NIDIM, NMAX, NOUT
      CHARACTER*6        SNAME
C     .. Array Arguments ..
      REAL               A( NMAX, NMAX), AA( NMAX*NMAX), ALF( NALF),
     $                   AS( NMAX*NMAX ), BET( NBET ), G( NMAX ),
     $                   B( NMAX, NMAX ), BB( NMAX*NMAX ),
     $                   BS( NMAX*NMAX ), C( NMAX, NMAX ),
     $                   CC( NMAX*NMAX ), CS( NMAX*NMAX ),
     $                   CT( NMAX )
      INTEGER            IDIM( NIDIM )
C     .. Local Scalars ..
      REAL               ALPHA, ALS, BETA, BETS, ERR, ERRMAX
      INTEGER            I, IA, IB, ICT, ICU, IK, IN, J, JC, JJ, K, LAA,
     $                   LCC, LDA, LDAS, LDC, LDCS,
     $                   N, NA, NARGS, NC, NERR, NS, KS, LJ, MA
      LOGICAL            FTL, NULL, RESET, TRAN, UPPER
      CHARACTER*1        UPLO, UPLOS, TRANS, TRANSS
      CHARACTER*2        ICHU
      CHARACTER*3        ICHT
C     .. Local Arrays ..
      LOGICAL            ISAME( 13 )
C     .. External Functions ..
      INTEGER            NUMXER
      LOGICAL            LSE, LSERES
      EXTERNAL           LSE, LSERES, NUMXER
C     .. External Subroutines ..
      EXTERNAL           SSYRK, SMAKE3, SMMCH
C     .. Intrinsic Functions ..
      INTRINSIC          MAX
C     .. Data statements ..
      DATA               ICHT/'NTC'/, ICHU/'UL'/
C***FIRST EXECUTABLE STATEMENT  SCHK43
      NARGS = 10
C
      NC = 0
      RESET = .TRUE.
      ERRMAX = ZERO
C
C
      DO 100 IN = 1, NIDIM
         N = IDIM( IN )
C        Set LDC to 1 more than minimum value if room.
         LDC = N
         IF( LDC.LT.NMAX )
     $      LDC = LDC + 1
C        Skip tests if not enough room.
         IF( LDC.GT.NMAX )
     $      GO TO 100
         LCC = LDC*N
         NULL = N.LE.0
C
         DO 90 IK = 1, NIDIM
            K = IDIM( IK )
C
            DO 80 ICT = 1, 3
               TRANS = ICHT( ICT: ICT )
               TRAN = TRANS.EQ.'T'.OR.TRANS.EQ.'C'
               IF( TRAN )THEN
                  MA = K
                  NA = N
               ELSE
                  MA = N
                  NA = K
               END IF
C              Set LDA to 1 more than minimum value if room.
               LDA = MA
               IF( LDA.LT.NMAX )
     $            LDA = LDA + 1
C              Skip tests if not enough room.
               IF( LDA.GT.NMAX )
     $            GO TO 80
               LAA = LDA*NA
C
C              Generate the matrix A.
C
               CALL SMAKE3( 'GE', ' ', ' ', MA, NA, A, NMAX, AA, LDA,
     $                     RESET, ZERO )
C
               DO 70 ICU = 1, 2
                  UPLO = ICHU( ICU: ICU )
                  UPPER = UPLO.EQ.'U'
C
                  DO 60 IA = 1, NALF
                     ALPHA = ALF( IA )
C
                     DO 50 IB = 1, NBET
                        BETA = BET( IB )
C
C                       Generate the matrix C.
C
                        CALL SMAKE3( 'SY', UPLO, ' ', N, N, C, NMAX, CC,
     $                              LDC, RESET, ZERO )
C
                        NC = NC + 1
C
C                       Save every datum before calling the subroutine.
C
                        UPLOS = UPLO
                        TRANSS = TRANS
                        NS = N
                        KS = K
                        ALS = ALPHA
                        DO 10 I = 1, LAA
                           AS( I ) = AA( I )
   10                   CONTINUE
                        LDAS = LDA
                        BETS = BETA
                        DO 20 I = 1, LCC
                           CS( I ) = CC( I )
   20                   CONTINUE
                        LDCS = LDC
C
C                       Call the subroutine.
C
                        CALL SSYRK( UPLO, TRANS, N, K, ALPHA, AA, LDA,
     $                              BETA, CC, LDC )
C
C                       Check if error-exit was taken incorrectly.
C
                        IF(NUMXER(NERR) .NE. 0) THEN
                           IF (KPRINT .GE. 2) THEN
                           WRITE( NOUT, FMT = 9993 )
                           ENDIF
                           FATAL = .TRUE.
                        END IF
C
C                       See what data changed inside subroutines.
C
                        ISAME( 1 ) = UPLOS.EQ.UPLO
                        ISAME( 2 ) = TRANSS.EQ.TRANS
                        ISAME( 3 ) = NS.EQ.N
                        ISAME( 4 ) = KS.EQ.K
                        ISAME( 5 ) = ALS.EQ.ALPHA
                        ISAME( 6 ) = LSE( AS, AA, LAA )
                        ISAME( 7 ) = LDAS.EQ.LDA
                        ISAME( 8 ) = BETS.EQ.BETA
                        IF( NULL )THEN
                           ISAME( 9 ) = LSE( CS, CC, LCC )
                        ELSE
                           ISAME( 9 ) = LSERES( 'SY', UPLO, N, N, CS,
     $                                  CC, LDC )
                        END IF
                        ISAME( 10 ) = LDCS.EQ.LDC
C
C                       If data was incorrectly changed, report and
C                       return.
C
                        DO 30 I = 1, NARGS
                          IF (.NOT. ISAME( I )) THEN
                            FATAL = .TRUE.
                            IF (KPRINT .GE. 2) THEN
                              WRITE( NOUT, FMT = 9998 )I
                            ENDIF
                          ENDIF
  30                    CONTINUE
C
                        FTL = .FALSE.
                        IF( .NOT.NULL )THEN
C
C                          Check the result column by column.
C
                           JC = 1
                           DO 40 J = 1, N
                              IF( UPPER )THEN
                                 JJ = 1
                                 LJ = J
                              ELSE
                                 JJ = J
                                 LJ = N - J + 1
                              END IF
                              IF( TRAN )THEN
                                 CALL SMMCH( 'T', 'N', LJ, 1, K, ALPHA,
     $                                       A( 1, JJ ), NMAX,
     $                                       A( 1, J ), NMAX, BETA,
     $                                       C( JJ, J ), NMAX, CT, G,
     $                                       CC( JC ), LDC, EPS, ERR,
     $                                       FTL, NOUT, .TRUE.,KPRINT)
                              ELSE
                                 CALL SMMCH( 'N', 'T', LJ, 1, K, ALPHA,
     $                                       A( JJ, 1 ), NMAX,
     $                                       A( J, 1 ), NMAX, BETA,
     $                                       C( JJ, J ), NMAX, CT, G,
     $                                       CC( JC ), LDC, EPS, ERR,
     $                                       FTL, NOUT, .TRUE.,KPRINT)
                              END IF
                              IF( UPPER )THEN
                                 JC = JC + LDC
                              ELSE
                                 JC = JC + LDC + 1
                              END IF
                              ERRMAX = MAX( ERRMAX, ERR )
   40                      CONTINUE
                        END IF
                        IF (FTL) THEN
                          FATAL = .TRUE.
                          IF (KPRINT .GE. 3) THEN
                            WRITE (NOUT, FMT = 9996) SNAME
                            WRITE( NOUT, FMT = 9994 )NC, SNAME,
     $                        UPLO, TRANS, N, K,
     $                        ALPHA, LDA, BETA, LDC
                          ENDIF
                        ENDIF
C
   50                CONTINUE
C
   60             CONTINUE
C
   70          CONTINUE
C
   80       CONTINUE
C
   90    CONTINUE
C
  100 CONTINUE
C
C     Report result.
C
      IF (.NOT. (FATAL)) THEN
        IF (KPRINT .GE. 3) THEN
          IF( ERRMAX.LT.THRESH )THEN
             WRITE( NOUT, FMT = 9999 )SNAME, NC
          ELSE
             WRITE( NOUT, FMT = 9997 )SNAME, NC, ERRMAX
          END IF
        ENDIF
      ENDIF
      RETURN
C
 9999 FORMAT( ' ', A6, ' PASSED THE COMPUTATIONAL TESTS (', I6, ' CALL',
     $      'S)' )
 9998 FORMAT( ' ******* FATAL ERROR - PARAMETER NUMBER ', I2, ' WAS CH',
     $      'ANGED INCORRECTLY *******' )
 9997 FORMAT( ' ', A6, ' COMPLETED THE COMPUTATIONAL TESTS (', I6, ' C',
     $      'ALLS)', /' ******* BUT WITH MAXIMUM TEST RATIO', F8.2,
     $      ' - SUSPECT *******' )
 9996 FORMAT( ' ******* ', A6, ' FAILED ON CALL NUMBER:' )
 9994 FORMAT( 1X, I6, ': ', A6, '(', 2( '''', A1, ''',' ), 2( I3, ',' ),
     $      F4.1, ', A,', I3, ',', F4.1, ', C,', I3, ')           .' )
 9993 FORMAT( ' ******* FATAL ERROR - ERROR-EXIT TAKEN ON VALID CALL *',
     $      '******' )
C
C     End of SCHK43.
C
      END

*DECK SCHK33
      SUBROUTINE SCHK33 (SNAME, EPS, THRESH, NOUT, KPRINT, FATAL, NIDIM,
     $   IDIM, NALF, ALF, NMAX, A, AA, AS, B, BB, BS, CT, G, C)
C***BEGIN PROLOGUE  SCHK33
C***SUBSIDIARY
C***PURPOSE  Quick check for STRMM and STRSM.
C***LIBRARY   SLATEC (BLAS)
C***KEYWORDS  BLAS, QUICK CHECK SERVICE ROUTINE
C***AUTHOR  Dongarra, J. J., (ANL)
C           Duff, I., (AERE)
C           Du Croz, J., (NAG)
C           Hammarling, S., (NAG)
C***DESCRIPTION
C
C  Quick check for STRMM and STRSM.
C
C  Auxiliary routine for test program for Level 3 Blas.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  LSE, LSERES, NUMXER, SMAKE3, SMMCH, STRMM, STRSM
C***REVISION HISTORY  (YYMMDD)
C   890208  DATE WRITTEN
C   910619  Modified to meet SLATEC code and prologue standards.  (BKS)
C***END PROLOGUE  SCHK33
C     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0, ONE = 1.0)
C     .. Scalar Arguments ..
      LOGICAL            FATAL
      REAL               EPS, THRESH
      INTEGER            KPRINT, NALF, NIDIM, NMAX, NOUT
      CHARACTER*6        SNAME
C     .. Array Arguments ..
      REAL               A( NMAX, NMAX ), AA( NMAX*NMAX ), ALF( NALF ),
     $                   AS( NMAX*NMAX ), G( NMAX ),
     $                   B( NMAX, NMAX ), BB( NMAX*NMAX ),
     $                   BS( NMAX*NMAX ), C( NMAX, NMAX ),
     $                   CT( NMAX )
      INTEGER            IDIM( NIDIM )
C     .. Local Scalars ..
      REAL               ALPHA, ALS, ERR, ERRMAX
      INTEGER            I, IA, ICD, ICS, ICT, ICU, IM, IN, J, LAA,
     $                   LBB, LDA, LDAS, LDB, LDBS, M,
     $                   MS, N, NA, NARGS, NC, NERR, NS
      LOGICAL            FTL, NULL, RESET, LEFT
      CHARACTER*1        SIDE, SIDES, UPLO, UPLOS, TRANAS, TRANSA, DIAG,
     $                   DIAGS
      CHARACTER*2        ICHS, ICHU, ICHD
      CHARACTER*3        ICHT
C     .. Local Arrays ..
      LOGICAL            ISAME( 13 )
C     .. External Functions ..
      INTEGER            NUMXER
      LOGICAL            LSE, LSERES
      EXTERNAL           LSE, LSERES, NUMXER
C     .. External Subroutines ..
      EXTERNAL           STRMM, STRSM, SMAKE3, SMMCH
C     .. Intrinsic Functions ..
      INTRINSIC          MAX
C     .. Data statements ..
      DATA               ICHT/'NTC'/, ICHU/'UL'/, ICHD/'UN'/, ICHS/'LR'/
C***FIRST EXECUTABLE STATEMENT  SCHK33
      NARGS = 11
C
      NC = 0
      RESET = .TRUE.
      ERRMAX = ZERO
C
C     Set up zero matrix for SMMCH.
      DO 20 J = 1, NMAX
         DO 10 I = 1, NMAX
            C( I, J ) = ZERO
   10    CONTINUE
   20 CONTINUE
C
      DO 140 IM = 1, NIDIM
         M = IDIM( IM )
C
         DO 130 IN = 1, NIDIM
            N = IDIM( IN )
C           Set LDB to 1 more than minimum value if room.
            LDB = M
            IF( LDB.LT.NMAX )
     $         LDB = LDB + 1
C           Skip tests if not enough room.
            IF( LDB.GT.NMAX )
     $         GO TO 130
            LBB = LDB*N
            NULL = M.LE.0.OR.N.LE.0
C
            DO 120 ICS = 1, 2
               SIDE = ICHS( ICS: ICS )
               LEFT = SIDE.EQ.'L'
               IF( LEFT )THEN
                  NA = M
               ELSE
                  NA = N
               END IF
C              Set LDA to 1 more than minimum value if room.
               LDA = NA
               IF( LDA.LT.NMAX )
     $            LDA = LDA + 1
C              Skip tests if not enough room.
               IF( LDA.GT.NMAX )
     $            GO TO 130
               LAA = LDA*NA
C
               DO 110 ICU = 1, 2
                  UPLO = ICHU( ICU: ICU )
C
                  DO 100 ICT = 1, 3
                     TRANSA = ICHT( ICT: ICT )
C
                     DO 90 ICD = 1, 2
                        DIAG = ICHD( ICD: ICD )
C
                        DO 80 IA = 1, NALF
                           ALPHA = ALF( IA )
C
C                          Generate the matrix A.
C
                           CALL SMAKE3( 'TR', UPLO, DIAG, NA, NA, A,
     $                                 NMAX, AA, LDA, RESET, ZERO )
C
C                          Generate the matrix B.
C
                           CALL SMAKE3( 'GE', ' ', ' ', M, N, B, NMAX,
     $                                 BB, LDB, RESET, ZERO )
C
                           NC = NC + 1
C
C                          Save every datum before calling the
C                          subroutine.
C
                           SIDES = SIDE
                           UPLOS = UPLO
                           TRANAS = TRANSA
                           DIAGS = DIAG
                           MS = M
                           NS = N
                           ALS = ALPHA
                           DO 30 I = 1, LAA
                              AS( I ) = AA( I )
   30                      CONTINUE
                           LDAS = LDA
                           DO 40 I = 1, LBB
                              BS( I ) = BB( I )
   40                      CONTINUE
                           LDBS = LDB
C
C                          Call the subroutine.
C
                           IF( SNAME( 4: 5 ).EQ.'MM' )THEN
                              CALL STRMM( SIDE, UPLO, TRANSA, DIAG, M,
     $                                    N, ALPHA, AA, LDA, BB, LDB )
                           ELSE IF( SNAME( 4: 5 ).EQ.'SM' )THEN
                              CALL STRSM( SIDE, UPLO, TRANSA, DIAG, M,
     $                                    N, ALPHA, AA, LDA, BB, LDB )
                           END IF
C
C                          Check if error-exit was taken incorrectly.
C
                           IF(NUMXER(NERR) .NE. 0) THEN
                             IF (KPRINT .GE. 2) THEN
                              WRITE( NOUT, FMT = 9994 )
                           ENDIF
                           FATAL = .TRUE.
                           END IF
C
C                          See what data changed inside subroutines.
C
                           ISAME( 1 ) = SIDES.EQ.SIDE
                           ISAME( 2 ) = UPLOS.EQ.UPLO
                           ISAME( 3 ) = TRANAS.EQ.TRANSA
                           ISAME( 4 ) = DIAGS.EQ.DIAG
                           ISAME( 5 ) = MS.EQ.M
                           ISAME( 6 ) = NS.EQ.N
                           ISAME( 7 ) = ALS.EQ.ALPHA
                           ISAME( 8 ) = LSE( AS, AA, LAA )
                           ISAME( 9 ) = LDAS.EQ.LDA
                           IF( NULL )THEN
                              ISAME( 10 ) = LSE( BS, BB, LBB )
                           ELSE
                              ISAME( 10 ) = LSERES( 'GE', ' ', M, N, BS,
     $                                      BB, LDB )
                           END IF
                           ISAME( 11 ) = LDBS.EQ.LDB
C
C                          If data was incorrectly changed, report and
C                          return.
C
                           DO 50 I = 1, NARGS
                             IF (.NOT. ISAME( I )) THEN
                               FATAL = .TRUE.
                               IF (KPRINT .GE. 2) THEN
                                 WRITE( NOUT, FMT = 9998 )I
                               ENDIF
                             ENDIF
  50                       CONTINUE
C
                           FTL = .FALSE.
                           IF( .NOT.NULL )THEN
                              IF( SNAME( 4: 5 ).EQ.'MM' )THEN
C
C                                Check the result.
C
                                 IF( LEFT )THEN
                                    CALL SMMCH( TRANSA, 'N', M, N, M,
     $                                          ALPHA, A, NMAX, B, NMAX,
     $                                          ZERO, C, NMAX, CT, G,
     $                                          BB, LDB, EPS, ERR,
     $                                          FTL, NOUT, .TRUE.,
     $                                          KPRINT )
                                 ELSE
                                    CALL SMMCH( 'N', TRANSA, M, N, N,
     $                                          ALPHA, B, NMAX, A, NMAX,
     $                                          ZERO, C, NMAX, CT, G,
     $                                          BB, LDB, EPS, ERR,
     $                                          FTL, NOUT, .TRUE.,
     $                                          KPRINT )
                                 END IF
                              ELSE IF( SNAME( 4: 5 ).EQ.'SM' )THEN
C
C                                Compute approximation to original
C                                matrix.
C
                                 DO 70 J = 1, N
                                    DO 60 I = 1, M
                                       C( I, J ) = BB( I + ( J - 1 )*
     $                                             LDB )
                                       BB( I + ( J - 1 )*LDB ) = ALPHA*
     $                                    B( I, J )
   60                               CONTINUE
   70                            CONTINUE
C
                                 IF( LEFT )THEN
                                    CALL SMMCH( TRANSA, 'N', M, N, M,
     $                                          ONE, A, NMAX, C, NMAX,
     $                                          ZERO, B, NMAX, CT, G,
     $                                          BB, LDB, EPS, ERR,
     $                                          FTL, NOUT, .FALSE.,
     $                                          KPRINT )
                                 ELSE
                                    CALL SMMCH( 'N', TRANSA, M, N, N,
     $                                          ONE, C, NMAX, A, NMAX,
     $                                          ZERO, B, NMAX, CT, G,
     $                                          BB, LDB, EPS, ERR,
     $                                          FTL, NOUT, .FALSE.,
     $                                          KPRINT )
                                 END IF
                              END IF
                              ERRMAX = MAX( ERRMAX, ERR )
                           END IF
                           IF (FTL) THEN
                             FATAL = .TRUE.
                             IF (KPRINT .GE. 3) THEN
                               WRITE (NOUT, FMT = 9996) SNAME
                               WRITE( NOUT, FMT = 9995 )NC, SNAME,
     $                           SIDE, UPLO, TRANSA, DIAG, M,
     $                           N, ALPHA, LDA, LDB
                             ENDIF
                           ENDIF
C
   80                   CONTINUE
C
   90                CONTINUE
C
  100             CONTINUE
C
  110          CONTINUE
C
  120       CONTINUE
C
  130    CONTINUE
C
  140 CONTINUE
C
C     Report result.
C
      IF (.NOT. (FATAL)) THEN
        IF (KPRINT .GE. 3) THEN
          IF( ERRMAX.LT.THRESH )THEN
             WRITE( NOUT, FMT = 9999 )SNAME, NC
          ELSE
             WRITE( NOUT, FMT = 9997 )SNAME, NC, ERRMAX
          END IF
        ENDIF
      ENDIF
C
      RETURN
C
 9999 FORMAT( ' ', A6, ' PASSED THE COMPUTATIONAL TESTS (', I6, ' CALL',
     $      'S)' )
 9998 FORMAT( ' ******* FATAL ERROR - PARAMETER NUMBER ', I2, ' WAS CH',
     $      'ANGED INCORRECTLY *******' )
 9997 FORMAT( ' ', A6, ' COMPLETED THE COMPUTATIONAL TESTS (', I6, ' C',
     $      'ALLS)', /' ******* BUT WITH MAXIMUM TEST RATIO', F8.2,
     $      ' - SUSPECT *******' )
 9996 FORMAT( ' ******* ', A6, ' FAILED ON CALL NUMBER:' )
 9995 FORMAT( 1X, I6, ': ', A6, '(', 4( '''', A1, ''',' ), 2( I3, ',' ),
     $      F4.1, ', A,', I3, ', B,', I3, ')        .' )
 9994 FORMAT( ' ******* FATAL ERROR - ERROR-EXIT TAKEN ON VALID CALL *',
     $      '******' )
C
C     End of SCHK33.
C
      END

*DECK SQFCN2
      SUBROUTINE SQFCN2 (N, X, FVEC, IFLAG)
C***BEGIN PROLOGUE  SQFCN2
C***PURPOSE  Evaluate function used in SNSQE.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SQFCN2-S, DQFCN2-D)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C   Subroutine which evaluates the function for test program
C   used in quick check of SNSQE.
C
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   890618  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   930214  TYPE and declarations sections added.  (WRB)
C***END PROLOGUE  SQFCN2
C     .. Scalar Arguments ..
      INTEGER IFLAG, N
C     .. Array Arguments ..
      REAL FVEC(*), X(*)
C***FIRST EXECUTABLE STATEMENT  SQFCN2
      FVEC(1) = 1.0E0 - X(1)
      FVEC(2) = 10.0E0*(X(2)-X(1)**2)
      RETURN
      END

*DECK ZQCBI
      SUBROUTINE ZQCBI (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  ZQCBI
C***SUBSIDIARY
C***PURPOSE  Quick check for SLATEC subroutine
C            ZBESI
C***LIBRARY   SLATEC
C***CATEGORY  C10B4
C***TYPE      COMPLEX (CQCBI-C, ZQCBI-Z)
C***KEYWORDS  QUICK CHECK, ZBESI
C***AUTHOR  Amos, Don, (SNL)
C           Goudy, Sue, (SNL)
C           Walton, Lee, (SNL)
C***DESCRIPTION
C
C *Usage:
C
C        INTEGER  LUN, KPRINT, IPASS
C
C        CALL ZQCBI (LUN, KPRINT, IPASS)
C
C *Arguments:
C
C     LUN    :IN  is the unit number to which output is to be written.
C
C     KPRINT :IN  controls the amount of output, as specified in the
C                 SLATEC Guidelines.
C
C     IPASS  :OUT indicates whether the test passed or failed.
C                 A value of one is good, indicating no failures.
C
C *Description:
C
C                 *** A DOUBLE PRECISION ROUTINE ***
C
C   ZQCBI is a quick check routine for the complex I Bessel function
C    generated by subroutine ZBESI.
C
C   ZQCBI generates sequences crossing formula boundaries which
C    are started by one formula and terminated in a region where
C    another formula applies. The terminated value is checked by
C    the formula appropriate to that region.
C
C***REFERENCES  Abramowitz, M. and Stegun, I. A., Handbook
C                 of Mathematical Functions, Dover Publications,
C                 New York, 1964.
C               Amos, D. E., A Subroutine Package for Bessel
C                 Functions of a Complex Argument and Nonnegative
C                 Order, SAND85-1018, May, 1985.
C***ROUTINES CALLED  ZBESI, ZBESK, ZWRSK, ZABS, ZDIV, I1MACH, D1MACH
C***REVISION HISTORY  (YYMMDD)
C   830501  DATE WRITTEN
C   890831  Revised to meet new SLATEC standards
C***END PROLOGUE  ZQCBI
C
C*Internal Notes:
C   Machine constants are defined by functions I1MACH and D1MACH.
C
C   The parameter MQC can have values 1 (the default) for a faster,
C   less definitive test or 2 for a slower, more definitive test.
C
C**End
C
C  Set test complexity parameter.
C
      INTEGER  MQC
      PARAMETER (MQC=1)
C
C  Declare arguments.
C
      INTEGER  LUN, KPRINT, IPASS
C
C  Declare external functions.
C
      INTEGER  I1MACH
      DOUBLE PRECISION  D1MACH, ZABS
      EXTERNAL  I1MACH, D1MACH, ZABS
C
C  Declare local variables.
C
      DOUBLE PRECISION  CKR,CKI, CONER,CONEI, CSGNR,CSGNI, CWR,CWI,
     *   CYR,CYI, WR,WI, YR,YI, ZR,ZI, ZNR,ZNI, ZTR,ZTI
      DOUBLE PRECISION  AA, AB, AER, ALIM, ARG, ATOL, AW, CARG, CT, DIG,
     *   ELIM, EPS, ER, ERTOL, FILM, FNU, FNUL, GNU, HPI, PI, R, RL,
     *   RLT, RM, R1, R1M4, R1M5, R2, SARG, SLAK, ST, STI, STR, T, TOL,
     *   TS, ZSCR, ZZR
      INTEGER  I, ICASE, IERR, IL, INU, IPRNT, IR, IT, ITL, K, KDO,
     *   KEPS, KK, KODE, K1, K2, LFLG, MFLG, N, NL, NZI, NZK, NZ1, NZ2,
     *   N1
      DIMENSION  AER(20), CKR(2), CKI(2), KDO(20), KEPS(20), T(20),
     *   WR(20), WI(20), YR(20), YI(20)
C
C***FIRST EXECUTABLE STATEMENT  ZQCBI
      IF (KPRINT.GE.2) THEN
        WRITE (LUN,99999)
99999   FORMAT (' QUICK CHECK ROUTINE FOR THE I BESSEL FUNCTION FROM ',
     *     'ZBESI'/)
      ENDIF
C-----------------------------------------------------------------------
C     Set parameters related to machine constants.
C     TOL is the approximate unit roundoff limited to 1.0D-18.
C     ELIM is the approximate exponential over- and underflow limit.
C     exp(-ELIM).lt.exp(-ALIM)=exp(-ELIM)/TOL    and
C     exp(ELIM).gt.exp(ALIM)=exp(ELIM)*TOL       are intervals near
C     underflow and overflow limits where scaled arithmetic is done.
C     RL is the lower boundary of the asymptotic expansion for large Z.
C     DIG = number of base 10 digits in TOL = 10**(-DIG).
C     FNUL is the lower boundary of the asymptotic series for large FNU.
C-----------------------------------------------------------------------
      R1M4 = D1MACH(4)
      TOL = MAX(R1M4,1.0D-18)
      ATOL = 100.0D0*TOL
      AA = -LOG10(R1M4)
      K1 = I1MACH(12)
      K2 = I1MACH(13)
      R1M5 = D1MACH(5)
      K = MIN(ABS(K1),ABS(K2))
      ELIM = 2.303D0*(K*R1M5-3.0D0)
      AB = AA*2.303D0
      ALIM = ELIM + MAX(-AB,-41.45D0)
      DIG = MIN(AA,18.0D0)
      FNUL = 10.0D0 + 6.0D0*(DIG-3.0D0)
      RL = 1.2D0*DIG + 3.0D0
      SLAK = 3.0D0+4.0D0*(-LOG10(TOL)-7.0D0)/11.0D0
      SLAK = MAX(SLAK,3.0D0)
      ERTOL = TOL*10.0D0**SLAK
      RM = 0.5D0*(ALIM + ELIM)
      RM = MIN(RM,200.0D0)
      RM = MAX(RM,RL+10.0D0)
      R2 = MIN(RM,FNUL)
      R1 = 2.0D0*SQRT(FNUL+1.0D0)
      IF (KPRINT.GE.2) THEN
        WRITE (LUN,99998)
99998   FORMAT (' PARAMETERS'/
     *     5X,'TOL ',8X,'ELIM',8X,'ALIM',8X,'RL  ',8X,'FNUL',8X,'DIG')
        WRITE (LUN,99997) TOL, ELIM, ALIM, RL, FNUL, DIG
99997   FORMAT (1X,6D12.4/)
      ENDIF
C-----------------------------------------------------------------------
C     Set other constants needed in the tests.
C-----------------------------------------------------------------------
      ZZR = 1.0D0/TOL
      CONER = 1.0D0
      CONEI = 0.0D0
      HPI = 2.0D0*ATAN(1.0D0)
      PI = HPI + HPI
C-----------------------------------------------------------------------
C     Generate angles for construction of complex Z to be used in tests.
C-----------------------------------------------------------------------
C     KDO(K), K = 1,IL  determines which of the IL angles in -PI to PI
C     are used to compute values of Z.
C       KDO(K) = 0  means that the index K will be used for one or two
C                   values of Z, depending on the choice of KEPS(K)
C              = 1  means that the index K and the corresponding angle
C                   will be skipped
C     KEPS(K), K = 1,IL determines which of the angles get incremented
C     up and down to put values of Z in regions where different
C     formulae are used.
C       KEPS(K)  = 0  means that the angle will be used without change
C                = 1  means that the angle will be incremented up and
C                   down by EPS
C     The angles to be used are stored in the T(I) array, I = 1,ITL.
C-----------------------------------------------------------------------
      IF (MQC.NE.2) THEN
        NL = 2
        IL = 5
        DO 5 I = 1,IL
          KEPS(I) = 0
          KDO(I) = 0
    5   CONTINUE
      ELSE
        NL = 4
        IL = 13
        DO 6 I = 1,IL
          KDO(I) = 0
          KEPS(I) = 0
    6   CONTINUE
        KDO(2) = 1
        KDO(6) = 1
        KDO(8) = 1
        KDO(12) = 1
        KEPS(3) = 1
        KEPS(4) = 1
        KEPS(5) = 1
        KEPS(9) = 1
        KEPS(10) = 1
        KEPS(11) = 1
      ENDIF
      I = 2
      EPS = 0.01D0
      FILM = IL - 1
      T(1) = -PI + EPS
      DO 30 K = 2,IL
        IF (KDO(K).EQ.0) THEN
          T(I) = PI*(-IL+2*K-1)/FILM
          IF (KEPS(K).NE.0) THEN
            TS = T(I)
            T(I) = TS - EPS
            I = I + 1
            T(I) = TS + EPS
          ELSE
            I = I + 1
          ENDIF
        ENDIF
   30 CONTINUE
      ITL = I - 1
C-----------------------------------------------------------------------
C     Test values of Z in -PI.lt.arg(Z).le.PI near formula boundaries.
C-----------------------------------------------------------------------
      IF (KPRINT.GE.2) THEN
        WRITE (LUN,99996)
99996   FORMAT (' CHECKS ACROSS FORMULA BOUNDARIES')
      ENDIF
      LFLG = 0
      DO 220 ICASE = 1,6
        DO 210 KODE = 1,2
          DO 200 N = 1,NL
            N1 = N + 2
C-----------------------------------------------------------------------
C     Set values for R = magnitude of Z and for FNU to test computation
C     methods for the various regions of the (Z,FNU) plane.
C-----------------------------------------------------------------------
            DO 190 IR = 1,3
C------------ switch (icase)
              GO TO (50, 60, 70, 80, 90, 100), ICASE
   50         CONTINUE
                R = (2.0D0*(3-IR)+RL*(IR-1))/2.0D0
                GNU = R*R/4.0D0 - 0.2D0 - (N-1)
                FNU = MAX(0.0D0,GNU)
                GO TO 110
   60         CONTINUE
                R = (RL*(3-IR)+R2*(IR-1))/2.0D0
                GNU = SQRT(R+R) - 0.2D0 - (N-1)
                FNU = MAX(0.0D0,GNU)
                GO TO 110
   70         CONTINUE
                IF (R2.GE.RM) GO TO 220
                R = (R2*(3-IR)+RM*(IR-1))/2.0D0
                GNU = SQRT(R+R) - 0.2D0 - (N-1)
                FNU = MAX(0.0D0,GNU)
                GO TO 110
   80         CONTINUE
                IF (R1.GE.RL) GO TO 220
                R = (R1*(3-IR)+RL*(IR-1))/2.0D0
                FNU = FNUL - 0.2D0 - (N-1)
                GO TO 110
   90         CONTINUE
                R = (RL*(3-IR)+R2*(IR-1))/2.0D0
                FNU = FNUL - 0.2D0 - (N-1)
                GO TO 110
  100         CONTINUE
                IF (R2.GE.RM) GO TO 220
                R = (R2*(3-IR)+RM*(IR-1))/2.0D0
                FNU = FNUL - 0.2D0 - (N-1)
  110         CONTINUE
C------------ end switch
              DO 180 IT = 1,ITL
                CT = COS(T(IT))
                ST = SIN(T(IT))
                IF (ABS(CT).LT.ATOL) CT = 0.0D0
                IF (ABS(ST).LT.ATOL) ST = 0.0D0
                ZR = R*CT
                ZI = R*ST
                CALL ZBESI(ZR, ZI, FNU, KODE, N1, YR, YI, NZ1, IERR)
                IF (NZ1.NE.0) GO TO 180
C-----------------------------------------------------------------------
C     Compare values from ZBESI with values from ZWRSK, an alternative
C     method for calculating the complex Bessel I function.
C-----------------------------------------------------------------------
                ZNR = ZR
                ZNI = ZI
                IF (ZR.GE.0.0D0) THEN
                  CALL ZWRSK(ZNR, ZNI, FNU, KODE, N, WR, WI, NZ2, CKR,
     *               CKI, TOL, ELIM, ALIM)
                  IF (NZ2.NE.0) GO TO 180
                ELSE
                  ZNR = -ZR
                  ZNI = -ZI
                  INU = INT(FNU)
                  ARG = (FNU-INU)*PI
                  IF (ZI.LT.0.0D0) ARG = -ARG
                  CARG = COS(ARG)
                  SARG = SIN(ARG)
                  CSGNR = CARG
                  CSGNI = SARG
                  IF (MOD(INU,2).EQ.1) THEN
                    CSGNR = -CSGNR
                    CSGNI = -CSGNI
                  ENDIF
                  CALL ZWRSK(ZNR, ZNI, FNU, KODE, N, WR, WI, NZ2, CKR,
     *               CKI, TOL, ELIM, ALIM)
                  IF (NZ2.NE.0) GO TO 180
                  DO 130 I = 1,N
                    STR = WR(I)*CSGNR - WI(I)*CSGNI
                    WI(I) = WR(I)*CSGNI + WI(I)*CSGNR
                    WR(I) = STR
                    CSGNR = -CSGNR
                    CSGNI = -CSGNI
  130             CONTINUE
                ENDIF
                MFLG = 0
                DO 160 I = 1,N
                  AB = FNU + I - 1
                  AA = MAX(2.0D0,AB)
                  ZTR = WR(I)
                  ZTI = WI(I)
                  IF (ABS(ZTR).GT.1.0D0 .OR. ABS(ZTI).GT.1.0D0) THEN
                    ZSCR = TOL
                  ELSE
                    ZSCR = ZZR
C------------------ ZZR = 1.0D0/TOL
                  ENDIF
                  CWR = WR(I)*ZSCR
                  CWI = WI(I)*ZSCR
                  CYR = YR(I)*ZSCR
                  CYI = YI(I)*ZSCR
                  STR = CYR - CWR
                  STI = CYI - CWI
                  ER = ZABS(STR,STI)
                  AW = ZABS(CWR,CWI)
                  IF (AW.NE.0.0D0) THEN
                    IF (ZR.EQ.0.0D0) THEN
                      IF (ABS(ZI).LT.AA) THEN
                        ER = ER/AW
                      ELSE
                        STR = YR(I)-WR(I)
                        STI = YI(I)-WI(I)
                        ER = ZABS(STR,STI)
                      ENDIF
                    ELSE
                      ER = ER/AW
                    ENDIF
                  ELSE
                    ER = ZABS(YR(I),YI(I))
                  ENDIF
                  AER(I) = ER
                  IF (ER.GT.ERTOL) MFLG = 1
  160           CONTINUE
C-----------------------------------------------------------------------
C     Write failure reports for KPRINT.ge.2 and KPRINT.ge.3
C-----------------------------------------------------------------------
                IF (MFLG.NE.0) THEN
                  IF (LFLG.EQ.0) THEN
                    IF (KPRINT.GE.2) THEN
                      WRITE (LUN,99995) ERTOL
99995                 FORMAT (/' CASES WHICH UNDERFLOW OR VIOLATE THE ',
     *                   'RELATIVE ERROR TEST'/' WITH ERTOL = ', D12.4/)
                      WRITE (LUN,99994)
99994                 FORMAT (' INPUT TO ZBESI   Z, FNU, KODE, N')
                    ENDIF
                    IF (KPRINT.GE.3) THEN
                      WRITE (LUN,99993)
99993                 FORMAT (' ERROR TEST ON RESULTS FROM ZBESI AND ',
     *                   'ZWRSK   AER(K)')
                      WRITE (LUN,99992)
99992                 FORMAT (' RESULTS FROM ZBESI   NZ1, Y(KK)'/,
     *                   ' RESULTS FROM ZWRSK   NZ2, W(KK)')
                      WRITE (LUN,99991)
99991                 FORMAT (' TEST CASE INDICES   IT, IR, ICASE'/)
                    ENDIF
                  ENDIF
                  LFLG = LFLG + 1
                  IF (KPRINT.GE.2) THEN
                    WRITE (LUN,99990) ZR, ZI, FNU, KODE, N
99990               FORMAT ('   INPUT:    Z=',2D12.4,4X,'FNU=',D12.4,4X,
     *                 'KODE=',I3,4X,'N=',I3)
                  ENDIF
                  IF (KPRINT.GE.3) THEN
                    WRITE (LUN,99989) (AER(K),K=1,N)
99989               FORMAT ('   ERROR:  AER(K)=',4D12.4)
                    KK = MAX(NZ1,NZ2) + 1
                    KK = MIN(N,KK)
                    WRITE (LUN,99988) NZ1, YR(KK), YI(KK),
     *                 NZ2, WR(KK), WI(KK)
99988               FORMAT (' RESULTS:  NZ1=',I3,4X,'Y(KK)=',2D12.4,
     *                 /11X,'NZ2=',I3,4X,'W(KK)=',2D12.4)
                    WRITE (LUN,99987) IT, IR, ICASE
99987               FORMAT ('    CASE:   IT=',I3,4X,'IR=',I3,4X,
     *                 'ICASE=',I3/)
                  ENDIF
                ENDIF
  180         CONTINUE
  190       CONTINUE
  200     CONTINUE
  210   CONTINUE
  220 CONTINUE
      IF (KPRINT.GE.2) THEN
        IF (LFLG.EQ.0) THEN
          WRITE (LUN,99986)
99986     FORMAT (' QUICK CHECKS OK')
        ELSE
          WRITE (LUN,99985) LFLG
99985     FORMAT(' ***',I5,' FAILURE(S) FOR ZBESI CHECKS NEAR FORMULA ',
     *       'BOUNDARIES')
        ENDIF
      ENDIF
C
C
      IPRNT = 0
      IF (MQC.EQ.1) GO TO 900
C-----------------------------------------------------------------------
C     Checks near underflow limits on series(I=1) and uniform
C     asymptotic expansion(I=2)
C     Compare 1/Z with I(Z,FNU)*K(Z,FNU+1) + I(Z,FNU+1)*K(Z,FNU) and
C     report cases for which the relative error is greater than ERTOL.
C-----------------------------------------------------------------------
      IF (KPRINT.GE.2) THEN
        WRITE (LUN,99984)
99984   FORMAT (/' CHECKS NEAR UNDERFLOW AND OVERFLOW LIMITS'/)
      ENDIF
      ZR = 1.4D0
      ZI = 1.4D0
      KODE = 1
      N = 20
      DO 280 I = 1,2
        FNU = 10.2D0
C-----------------------------------------------------------------------
C       Adjust FNU by repeating until 0.lt.NZI.lt.10
C-----------------------------------------------------------------------
  230   CONTINUE
        CALL ZBESI(ZR, ZI, FNU, KODE, N, YR, YI, NZI, IERR)
        IF (NZI.NE.0) THEN
          IF (NZI.GE.10) THEN
            FNU = FNU - 1.0D0
            GO TO 230
          ENDIF
        ELSE
          FNU = FNU + 5.0D0
          GO TO 230
        ENDIF
C------ End repeat
        CALL ZBESK(ZR, ZI, FNU, KODE, 2, WR, WI, NZK, IERR)
        CALL ZDIV(CONER, CONEI, ZR, ZI, ZTR, ZTI)
        CYR = WR(1)*YR(2) - WI(1)*YI(2)
        CYI = WR(1)*YI(2) + WI(1)*YR(2)
        CWR = WR(2)*YR(1) - WI(2)*YI(1)
        CWI = WR(2)*YI(1) + WI(2)*YR(1)
        CWR = CWR + CYR - ZTR
        CWI = CWI + CYI - ZTI
        ER = ZABS(CWR,CWI)/ZABS(ZTR,ZTI)
C-----------------------------------------------------------------------
C     Write failure reports for KPRINT.ge.2 and KPRINT.ge.3
C-----------------------------------------------------------------------
        IF (ER.GE.ERTOL) THEN
          IF (IPRNT.EQ.0) THEN
            IF (KPRINT.GE.2) THEN
              WRITE (LUN,99983)
99983         FORMAT (' INPUT TO ZBESI   Z, FNU, KODE, N')
            ENDIF
            IF (KPRINT.GE.3) THEN
              WRITE (LUN,99982)
99982         FORMAT (' COMPARE 1/Z WITH WRONSKIAN(ZBESI(Z,FNU),',
     *           'ZBESK(Z,FNU))'/)
            ENDIF
          ENDIF
          IPRNT = 1
          IF (KPRINT.GE.2) THEN
            WRITE (LUN,99981) ZR, ZI, FNU, KODE, N
99981       FORMAT (' INPUT: Z=',2D12.4,3X,'FNU=',D12.4,3X,'KODE=',I3,
     *         3X,'N=',I3)
          ENDIF
          IF (KPRINT.GE.3) THEN
            WRITE (LUN,99980) ZTR, ZTI, CWR+CYR, CWI+CYI
99980       FORMAT (' RESULTS:',15X,'1/Z=',2D12.4/
     *         10X,'WRON(ZBESI,ZBESK)=',2D12.4)
            WRITE (LUN,99979) ER
99979       FORMAT (' RELATIVE ERROR:',9X,'ER=',D12.4/)
          ENDIF
        ENDIF
        RLT = RL + RL
        ZR = RLT
        ZI = 0.0D0
  280 CONTINUE
C-----------------------------------------------------------------------
C     Check near overflow limits
C     Compare 1/Z with I(Z,FNU)*K(Z,FNU+1) + I(Z,FNU+1)*K(Z,FNU) and
C     report cases for which the relative error is greater than ERTOL.
C-----------------------------------------------------------------------
      ZR = ELIM
      ZI = 0.0D0
      FNU = 0.0D0
C-----------------------------------------------------------------------
C     Adjust FNU by repeating until NZK.lt.10
C     N = 20 set before DO 280 loop
C-----------------------------------------------------------------------
  290 CONTINUE
      CALL ZBESK(ZR, ZI, FNU, KODE, N, YR, YI, NZK, IERR)
      IF (NZK.GE.10) THEN
        IF (NZK.EQ.N) THEN
          FNU = FNU + 3.0D0
        ELSE
          FNU = FNU + 2.0D0
        ENDIF
        GO TO 290
      ENDIF
C---- End repeat
      GNU = FNU + (N-2)
      CALL ZBESI(ZR, ZI, GNU, KODE, 2, WR, WI, NZI, IERR)
      CALL ZDIV(CONER, CONEI, ZR, ZI, ZTR, ZTI)
      CYR = YR(N-1)*WR(2) - YI(N-1)*WI(2)
      CYI = YR(N-1)*WI(2) + YI(N-1)*WR(2)
      CWR = YR(N)*WR(1) - YI(N)*WI(1)
      CWI = YR(N)*WI(1) + YI(N)*WR(1)
      CWR = CWR + CYR - ZTR
      CWI = CWI + CYI - ZTI
      ER = ZABS(CWR,CWI)/ZABS(ZTR,ZTI)
      IF (ER.GE.ERTOL) THEN
        IF (IPRNT.EQ.0) THEN
          IF (KPRINT.GE.2) THEN
            WRITE (LUN,99983)
          ENDIF
          IF (KPRINT.GE.3) THEN
            WRITE (LUN,99982)
          ENDIF
        ENDIF
        IPRNT = 1
        IF (KPRINT.GE.2) THEN
          WRITE (LUN,99981) ZR, ZI, FNU, KODE, N
        ENDIF
        IF (KPRINT.GE.3) THEN
          WRITE (LUN,99980) ZTR, ZTI, CWR+CYR, CWI+CYI
          WRITE (LUN,99979) ER
        ENDIF
      ENDIF
      IF (KPRINT.GE.2) THEN
        IF (IPRNT.EQ.0) THEN
          WRITE (LUN,99986)
C 99986   FORMAT (' QUICK CHECKS OK')
        ELSE
          WRITE (LUN,99978)
99978     FORMAT (' ***',5X,'FAILURE(S) FOR ZBESI NEAR UNDERFLOW AND ',
     *       'OVERFLOW LIMITS')
        ENDIF
      ENDIF
  900 CONTINUE
      IPASS = 0
      IF (IPRNT.EQ.0.AND.LFLG.EQ.0) THEN
        IPASS = 1
      ENDIF
      IF (IPASS.EQ.1.AND.KPRINT.GE.2) THEN
        WRITE (LUN,99977)
99977   FORMAT (/' ****** ZBESI  PASSED ALL TESTS  ******'/)
      ENDIF
      IF (IPASS.EQ.0.AND.KPRINT.GE.1) THEN
        WRITE (LUN,99976)
99976   FORMAT (/' ****** ZBESI  FAILED SOME TESTS ******'/)
      ENDIF
      RETURN
      END

*DECK TEST13
      PROGRAM TEST13
C***BEGIN PROLOGUE  TEST13
C***PURPOSE  Driver for testing SLATEC subprograms
C***LIBRARY   SLATEC
C***CATEGORY  C14
C***TYPE      SINGLE PRECISION (TEST13-S, TEST14-D)
C***KEYWORDS  QUICK CHECK DRIVER
C***AUTHOR  SLATEC Common Mathematical Library Committee
C***DESCRIPTION
C
C *Usage:
C     One input data record is required
C         READ (LIN, '(I1)') KPRINT
C
C *Arguments:
C     KPRINT = 0  Quick checks - No printing.
C                 Driver       - Short pass or fail message printed.
C              1  Quick checks - No message printed for passed tests,
C                                short message printed for failed tests.
C                 Driver       - Short pass or fail message printed.
C              2  Quick checks - Print short message for passed tests,
C                                fuller information for failed tests.
C                 Driver       - Pass or fail message printed.
C              3  Quick checks - Print complete quick check results.
C                 Driver       - Pass or fail message printed.
C
C *Description:
C     Driver for testing SLATEC subprograms
C        RC       RD       RF       RJ
C
C***REFERENCES  Kirby W. Fong, Thomas H. Jefferson, Tokihiko Suyehiro
C                 and Lee Walton, Guide to the SLATEC Common Mathema-
C                 tical Library, April 10, 1990.
C***ROUTINES CALLED  I1MACH, QCRC, QCRD, QCRF, QCRJ, XERMAX, XSETF,
C                    XSETUN
C***REVISION HISTORY  (YYMMDD)
C   890618  DATE WRITTEN
C   890618  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900524  Cosmetic changes to code.  (WRB)
C***END PROLOGUE  TEST13
      INTEGER IPASS, KPRINT, LIN, LUN, NFAIL
C***FIRST EXECUTABLE STATEMENT  TEST13
      LUN = I1MACH(2)
      LIN = I1MACH(1)
      NFAIL = 0
C
C     Read KPRINT parameter
C
      READ (LIN, '(I1)') KPRINT
      CALL XERMAX(1000)
      CALL XSETUN(LUN)
      IF (KPRINT .LE. 1) THEN
         CALL XSETF(0)
      ELSE
         CALL XSETF(1)
      ENDIF
C
C     Test single precision Carlson elliptic routines
C
      CALL QCRC(LUN,KPRINT,IPASS)
      IF (IPASS .EQ. 0) NFAIL = NFAIL + 1
      CALL QCRD(LUN,KPRINT,IPASS)
      IF (IPASS .EQ. 0) NFAIL = NFAIL + 1
      CALL QCRF(LUN,KPRINT,IPASS)
      IF (IPASS .EQ. 0) NFAIL = NFAIL + 1
      CALL QCRJ(LUN,KPRINT,IPASS)
      IF (IPASS .EQ. 0) NFAIL = NFAIL + 1
C
C     Write PASS or FAIL message
C
      IF (NFAIL .EQ. 0) THEN
         WRITE (LUN, 9000)
      ELSE
         WRITE (LUN, 9010) NFAIL
      ENDIF
      STOP
 9000 FORMAT (/' --------------TEST13 PASSED ALL TESTS----------------')
 9010 FORMAT (/' ************* WARNING -- ', I5,
     1        ' TEST(S) FAILED IN PROGRAM TEST13  *************')
      END

*DECK EVPCCK
      SUBROUTINE EVPCCK (LOUT, KPRINT, X, Y, F, FX, FY, XE, YE, FE, DE,
     +   FE2, FAIL)
C***BEGIN PROLOGUE  EVPCCK
C***SUBSIDIARY
C***PURPOSE  Test usage of increment argument in PCHFD and PCHFE for
C            PCHQK1.
C***LIBRARY   SLATEC (PCHIP)
C***TYPE      SINGLE PRECISION (EVPCCK-S, DEVPCK-D)
C***KEYWORDS  PCHIP EVALUATOR QUICK CHECK
C***AUTHOR  Fritsch, F. N., (LLNL)
C***DESCRIPTION
C
C ---- CODE TO TEST USAGE OF INCREMENT ARGUMENT IN PCHFD AND PCHFE ----
C
C     EVALUATES A BICUBIC FUNCTION AND ITS FIRST PARTIAL DERIVATIVES
C     ON A 4X6 MESH CONTAINED IN A 10X10 ARRAY.
C
C     INTERPOLATION OF THESE DATA ALONG MESH LINES IN EITHER DIMENSION
C     SHOULD AGREE WITH CORRECT FUNCTION WITHIN ROUNDOFF ERROR.
C
C     ARRAYS ARE ARGUMENTS ONLY TO ALLOW SHARING STORAGE WITH OTHER
C     TEST ROUTINES.
C
C     NOTE:  RUN WITH KPRINT=4 FOR FULL GORY DETAILS (10 PAGES WORTH).
C
C
C     FORTRAN INTRINSICS USED:  ABS.
C     FORTRAN LIBRARY ROUTINES USED:  (WRITE).
C     SLATEC LIBRARY ROUTINES USED:  PCHFD, PCHFE, R1MACH.
C
C***ROUTINES CALLED  PCHFD, PCHFE, R1MACH
C***REVISION HISTORY  (YYMMDD)
C   820601  DATE WRITTEN
C   820714  CONVERTED TO QUICK CHECK FOR SLATEC LIBRARY.
C   820715  1. CORRECTED SOME FORMATS.
C           2. ADDED CALL TO R1MACH TO SET MACHEP.
C   890406  1. Modified to make sure final elements of X and XE
C             agree, to avoid possible failure due to roundoff
C             error.
C           2. Added printout of TOL in case of failure.
C           3. Minor cosmetic changes.
C   890407  Appended E0 to real constants to reduce S.P./D.P.
C           differences.
C   890706  Cosmetic changes to prologue.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   891004  Cosmetic changes to prologue.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  Revised prologue and improved some output formats.  (FNF)
C   900316  Additional minor cosmetic changes.  (FNF)
C   900321  Made miscellaneous cosmetic changes.  (FNF)
C   901130  Made many changes to output:  (FNF)
C           1. Reduced amount of output for KPRINT=3.  (Now need to
C              use KPRINT=4 for full output.)
C           2. Added 1P's to formats and revised some to reduce maximum
C              line length.
C   910708  Minor modifications in use of KPRINT.  (WRB)
C   930317  Improved output formats.  (FNF)
C***END PROLOGUE  EVPCCK
C
C  Declare arguments.
C
      INTEGER  LOUT, KPRINT
      LOGICAL  FAIL
      REAL  X(10), Y(10), F(10,10), FX(10,10), FY(10,10),
     *      XE(51), YE(51), FE(51), DE(51), FE2(51)
C
C  DECLARATIONS.
C
      INTEGER  I, IER2, IERR, INC, J, K, NE, NERR, NMAX, NX, NY
      LOGICAL  FAILD, FAILE, FAILOC, SKIP
      REAL  DERMAX, DERR, DTRUE, DX, FDIFF, FDIFMX, FERMAX, FERR,
     *      FTRUE, MACHEP, TOL, PDERMX, PDIFMX, PFERMX, ZERO
      REAL  R1MACH
C
C  DEFINE TEST FUNCTION AND DERIVATIVES.
C
      REAL  AX, AY, FCN, DFDX, DFDY
      FCN(AX,AY)  =  AX*(AY*AY)*(AX*AX + 1.E0)
      DFDX(AX,AY) = (AY*AY)*(3.E0*AX*AX + 1.E0)
      DFDY(AX,AY) =   2.E0*AX*AY*(AX*AX + 1.E0)
C
      DATA  NMAX /10/,  NX /4/,  NY /6/
      DATA  NE /51/
      DATA  ZERO /0.E0/
C
C  INITIALIZE.
C
C***FIRST EXECUTABLE STATEMENT  EVPCCK
      MACHEP = R1MACH(4)
      TOL = 10.E0*MACHEP
C
      FAIL = .FALSE.
C
C  SET UP 4-BY-6 MESH IN A 10-BY-10 ARRAY:
C     X =  0.25(0.25)1.   ;
C     Y = -0.75(0.5 )1.75 .
C
      DO 1  I = 1, NX-1
         X(I) = 0.25E0*I
    1 CONTINUE
      X(NX) = 1.E0
      DO 5  J = 1, NY
         Y(J) = 0.5E0*J - 1.25E0
         DO 4  I = 1, NX
             F(I,J) = FCN (X(I), Y(J))
            FX(I,J) = DFDX(X(I), Y(J))
            FY(I,J) = DFDY(X(I), Y(J))
    4    CONTINUE
    5 CONTINUE
C
C  SET UP EVALUATION POINTS:
C     XE =  0.(0.02)1. ;
C     YE = -2.(0.08)2. .
C
      DX = 1.E0/(NE-1)
      DO 8  K = 1, NE-1
         XE(K) = DX*(K-1)
         YE(K) = 4.E0*XE(K) - 2.E0
    8 CONTINUE
      XE(NE) = 1.E0
      YE(NE) = 2.E0
C
      IF (KPRINT .GE. 3)  WRITE (LOUT, 1000)
      IF (KPRINT .GE. 2)  WRITE (LOUT, 1001)
C
C  EVALUATE ON HORIZONTAL MESH LINES (Y FIXED, X RUNNING) ..............
C
      NERR = 0
      INC = 1
      SKIP = .FALSE.
      DO 20  J = 1, NY
C        --------------------------------------------------------------
         CALL PCHFD (NX, X, F(1,J), FX(1,J), INC, SKIP, NE, XE, FE, DE,
     *               IERR)
C        --------------------------------------------------------------
         IF (KPRINT .GE. 3)
     *       WRITE (LOUT, 2000)  INC, 'J', J, 'Y', Y(J), IERR
         IF (IERR .LT. 0)  GO TO 15
         IF (KPRINT .GT. 3)  WRITE (LOUT, 2001)  'X'
C
C        PCHFE SHOULD AGREE EXACTLY WITH PCHFD.
C
C        -----------------------------------------------------------
         CALL PCHFE (NX, X, F(1,J), FX(1,J), INC, SKIP, NE, XE, FE2,
     *               IER2)
C        -----------------------------------------------------------
C
         DO 10  K = 1, NE
            FTRUE =  FCN(XE(K), Y(J))
            FERR = FE(K) - FTRUE
            DTRUE = DFDX(XE(K), Y(J))
            DERR = DE(K) - DTRUE
            IF (KPRINT .GT. 3)
     *         WRITE (LOUT, 2002)  XE(K), FTRUE, FE(K), FERR,
     *                                    DTRUE, DE(K), DERR
            IF (K .EQ. 1)  THEN
C              INITIALIZE.
               FERMAX = ABS(FERR)
               PFERMX = XE(1)
               DERMAX = ABS(DERR)
               PDERMX = XE(1)
               FDIFMX = ABS(FE2(1) - FE(1))
               PDIFMX = XE(1)
            ELSE
C              SELECT.
               FERR = ABS(FERR)
               IF (FERR .GT. FERMAX)  THEN
                  FERMAX = FERR
                  PFERMX = XE(K)
               ENDIF
               DERR = ABS(DERR)
               IF (DERR .GT. DERMAX)  THEN
                  DERMAX = DERR
                  PDERMX = XE(K)
               ENDIF
               FDIFF = ABS(FE2(K) - FE(K))
               IF (FDIFF .GT. FDIFMX)  THEN
                  FDIFMX = FDIFF
                  PDIFMX = XE(K)
               ENDIF
            ENDIF
   10    CONTINUE
C
         FAILD = (FERMAX.GT.TOL) .OR. (DERMAX.GT.TOL)
         FAILE = FDIFMX .NE. ZERO
         FAILOC = FAILD .OR. FAILE .OR. (IERR.NE.13) .OR. (IER2.NE.IERR)
C
         IF (FAILOC .AND. (KPRINT.GE.2))
     *      WRITE (LOUT, 2003)  'J', J, 'Y', Y(J)
C
         IF ((KPRINT.GE.3) .OR. (FAILD.AND.(KPRINT.EQ.2)) )
     *      WRITE (LOUT, 2004)  FERMAX, PFERMX, DERMAX, PDERMX
         IF (FAILD .AND. (KPRINT.GE.2))  WRITE (LOUT, 2014)  TOL
C
         IF ((KPRINT.GE.3) .OR. (FAILE.AND.(KPRINT.EQ.2)) )
     *      WRITE (LOUT, 2005)  FDIFMX, PDIFMX
C
         IF ((IERR.NE.13) .AND. (KPRINT.GE.2))
     *      WRITE (LOUT, 2006)  'D', IERR, 13
C
         IF ((IER2.NE.IERR) .AND. (KPRINT.GE.2))
     *      WRITE (LOUT, 2006)  'E', IER2, IERR
         GO TO 19
C
   15    CONTINUE
         FAILOC = .TRUE.
         IF (KPRINT .GE. 2)  WRITE (LOUT, 3000) IERR
C
   19    CONTINUE
         IF (FAILOC)  NERR = NERR + 1
         FAIL = FAIL .OR. FAILOC
   20 CONTINUE
C
      IF (KPRINT .GE. 2)  THEN
         IF (NERR .GT. 0)  THEN
            WRITE (LOUT, 3001)  NERR, 'J'
         ELSE
            WRITE (LOUT, 4000)  'J'
         ENDIF
      ENDIF
C
C  EVALUATE ON VERTICAL MESH LINES (X FIXED, Y RUNNING) ................
C
      NERR = 0
      INC = NMAX
      SKIP = .FALSE.
      DO 40  I = 1, NX
C        --------------------------------------------------------------
         CALL PCHFD (NY, Y, F(I,1), FY(I,1), INC, SKIP, NE, YE, FE, DE,
     *               IERR)
C        --------------------------------------------------------------
         IF (KPRINT .GE. 3)
     *       WRITE (LOUT, 2000)  INC, 'I', I, 'X', X(I), IERR
         IF (IERR .LT. 0)  GO TO 35
         IF (KPRINT .GT. 3)  WRITE (LOUT, 2001)  'Y'
C
C        PCHFE SHOULD AGREE EXACTLY WITH PCHFD.
C
C        -----------------------------------------------------------
         CALL PCHFE (NY, Y, F(I,1), FY(I,1), INC, SKIP, NE, YE, FE2,
     *               IER2)
C        -----------------------------------------------------------
C
         DO 30  K = 1, NE
            FTRUE =  FCN(X(I), YE(K))
            FERR = FE(K) - FTRUE
            DTRUE = DFDY(X(I), YE(K))
            DERR = DE(K) - DTRUE
            IF (KPRINT .GT. 3)
     *         WRITE (LOUT, 2002)  YE(K), FTRUE, FE(K), FERR,
     *                                    DTRUE, DE(K), DERR
            IF (K .EQ. 1)  THEN
C              INITIALIZE.
               FERMAX = ABS(FERR)
               PFERMX = YE(1)
               DERMAX = ABS(DERR)
               PDERMX = YE(1)
               FDIFMX = ABS(FE2(1) - FE(1))
               PDIFMX = YE(1)
            ELSE
C              SELECT.
               FERR = ABS(FERR)
               IF (FERR .GT. FERMAX)  THEN
                  FERMAX = FERR
                  PFERMX = YE(K)
               ENDIF
               DERR = ABS(DERR)
               IF (DERR .GT. DERMAX)  THEN
                  DERMAX = DERR
                  PDERMX = YE(K)
               ENDIF
               FDIFF = ABS(FE2(K) - FE(K))
               IF (FDIFF .GT. FDIFMX)  THEN
                  FDIFMX = FDIFF
                  PDIFMX = YE(K)
               ENDIF
            ENDIF
   30    CONTINUE
C
         FAILD = (FERMAX.GT.TOL) .OR. (DERMAX.GT.TOL)
         FAILE = FDIFMX .NE. ZERO
         FAILOC = FAILD .OR. FAILE .OR. (IERR.NE.20) .OR. (IER2.NE.IERR)
C
         IF (FAILOC .AND. (KPRINT.GE.2))
     *      WRITE (LOUT, 2003)  'I', I, 'X', X(I)
C
         IF ((KPRINT.GE.3) .OR. (FAILD.AND.(KPRINT.EQ.2)) )
     *      WRITE (LOUT, 2004)  FERMAX, PFERMX, DERMAX, PDERMX
         IF (FAILD .AND. (KPRINT.GE.2))  WRITE (LOUT, 2014)  TOL
C
         IF ((KPRINT.GE.3) .OR. (FAILE.AND.(KPRINT.EQ.2)) )
     *      WRITE (LOUT, 2005)  FDIFMX, PDIFMX
C
         IF ((IERR.NE.20) .AND. (KPRINT.GE.2))
     *      WRITE (LOUT, 2006)  'D', IERR, 20
C
         IF ((IER2.NE.IERR) .AND. (KPRINT.GE.2))
     *      WRITE (LOUT, 2006)  'E', IER2, IERR
         GO TO 39
C
   35    CONTINUE
         FAILOC = .TRUE.
         IF (KPRINT .GE. 2)  WRITE (LOUT, 3000) IERR
C
   39    CONTINUE
         IF (FAILOC)  NERR = NERR + 1
         FAIL = FAIL .OR. FAILOC
   40 CONTINUE
C
      IF (KPRINT .GE. 2)  THEN
         IF (NERR .GT. 0)  THEN
            WRITE (LOUT, 3001)  NERR, 'I'
         ELSE
            WRITE (LOUT, 4000)  'I'
         ENDIF
      ENDIF
C
C  TERMINATE.
C
      RETURN
C
C  FORMATS.
C
 1000 FORMAT ('1'//10X,'TEST PCHFE AND PCHFD')
 1001 FORMAT (//10X,'EVPCCK RESULTS'/10X,'--------------')
 2000 FORMAT (//20X,'PCHFD INCREMENT TEST -- INCFD = ',I2
     *        /15X,'ON ',A1,'-LINE ',I2,',  ',A1,' =',F8.4,
     *           '  --  IERR =',I3)
 2001 FORMAT ( /3X,A1,'E',10X,'F',8X,'FE',9X,'DIFF',
     *                    13X,'D',8X,'DE',9X,'DIFF')
 2002 FORMAT (F7.2,2(2X,2F10.5,1P,E15.5,0P))
 2003 FORMAT (/' ***** PCHFD AND/OR PCHFE FAILED ON ',A1,'-LINE ',I1,
     *                             ',  ',A1,' =',F8.4)
 2004 FORMAT (/17X,'  MAXIMUM ERROR IN FUNCTION =',1P,
     *                                   1P,E13.5,0P,' (AT',F6.2,'),'
     *        /31X,    'IN DERIVATIVE =',1P,E13.5,0P,' (AT',F6.2,').' )
 2005 FORMAT ( '  MAXIMUM DIFFERENCE BETWEEN PCHFE AND PCHFD =',
     *                                   1P,E13.5,0P,' (AT',F6.2,').' )
 2006 FORMAT (/'  PCHF',A1,' RETURNED IERR = ',I2,' INSTEAD OF ',I2)
 2014 FORMAT ('  *** BOTH SHOULD BE .LE. TOL =',1P,E12.5,' ***')
 3000 FORMAT (//' ***** ERROR ***** PCHFD RETURNED IERR =',I5//)
 3001 FORMAT (//' ***** ERROR ***** PCHFD AND/OR PCHFE FAILED ON',I2,
     *                                1X,A1,'-LINES.'//)
 4000 FORMAT (/' PCHFD AND PCHFE OK ON ',A1,'-LINES.')
C------------- LAST LINE OF EVPCCK FOLLOWS -----------------------------
      END

*DECK F2N
      REAL FUNCTION F2N (X)
C***BEGIN PROLOGUE  F2N
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F2N
      REAL X
C***FIRST EXECUTABLE STATEMENT  F2N
      F2N=X**(-0.9E+00)
      RETURN
      END

*DECK STEST
      SUBROUTINE STEST (LEN, SCOMP, STRUE, SSIZE, SFAC, KPRINT)
C***BEGIN PROLOGUE  STEST
C***PURPOSE  Compare arrays SCOMP and STRUE.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (STEST-S, DTEST-D)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Lawson, C. L., (JPL)
C***DESCRIPTION
C
C   This subroutine compares arrays SCOMP and STRUE of length LEN to
C   see if the term by term differences, multiplied by SFAC, are
C   negligible.  In the case of a significant difference, appropriate
C   messages are written.
C
C***ROUTINES CALLED  R1MACH
C***COMMON BLOCKS    COMBLA
C***REVISION HISTORY  (YYMMDD)
C   741210  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900820  Modified IF test to use function DIFF and made cosmetic
C           changes to routine.  (WRB)
C   901005  Removed usage of DIFF in favour of R1MACH.  (RWC)
C   910501  Added TYPE record.  (WRB)
C   920211  Code restructured and information added to the DESCRIPTION
C           section.  (WRB)
C***END PROLOGUE  STEST
      REAL SCOMP(*), STRUE(*), SSIZE(*), SFAC, SD, RELEPS, R1MACH
      LOGICAL PASS
      COMMON /COMBLA/ NPRINT, ICASE, N, INCX, INCY, MODE, PASS
      SAVE RELEPS
      DATA RELEPS /0.0E0/
C***FIRST EXECUTABLE STATEMENT  STEST
      IF (RELEPS .EQ. 0.0E0) RELEPS = R1MACH(4)
      DO 100 I = 1,LEN
        SD = ABS(SCOMP(I)-STRUE(I))
        IF (SFAC*SD .GT. ABS(SSIZE(I))*RELEPS) THEN
C
C         Here SCOMP(I) is not close to STRUE(I).
C
          IF (PASS) THEN
C
C           Print FAIL message and header.
C
            PASS = .FALSE.
            IF (KPRINT .GE. 3) THEN
              WRITE (NPRINT,9000)
              WRITE (NPRINT,9010)
            ENDIF
          ENDIF
          IF (KPRINT .GE. 3) WRITE (NPRINT,9020) ICASE, N, INCX, INCY,
     +                       MODE, I, SCOMP(I), STRUE(I), SD, SSIZE(I)
        ENDIF
  100 CONTINUE
      RETURN
 9000 FORMAT ('+', 39X, 'FAIL')
 9010 FORMAT ('0CASE  N INCX INCY MODE  I', 29X, 'COMP(I)', 29X,
     +        'TRUE(I)', 2X, 'DIFFERENCE', 5X, 'SIZE(I)' / 1X)
 9020 FORMAT (1X, I4, I3, 3I5, I3, 2E36.8, 2E12.4)
      END

*DECK FCN2
      SUBROUTINE FCN2 (IFLAG, M, N, X, FVEC, FJAC, LDFJAC)
C***BEGIN PROLOGUE  FCN2
C***PURPOSE  Subsidiary to SNLS1Q.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (FCN2-S, DFCN2-D)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C   Subroutine to evaluate function and full Jacobian for test
C   problem in quick check of SNLS1E.
C
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890911  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   930214  TYPE and declarations sections added and code polished.
C           (WRB)
C***END PROLOGUE  FCN2
C     .. Scalar Arguments ..
      INTEGER IFLAG, LDFJAC, M, N
C     .. Array Arguments ..
      REAL FJAC(LDFJAC,*), FVEC(*), X(*)
C     .. Local Scalars ..
      REAL TEMP, TWO
      INTEGER I
C     .. Intrinsic Functions ..
      INTRINSIC EXP
C     .. Data statements ..
      DATA TWO /2.0E0/
C***FIRST EXECUTABLE STATEMENT  FCN2
      IF (IFLAG .EQ. 0) RETURN
C
C     Should we evaluate functions or Jacobian?
C
      IF (IFLAG .EQ. 1) THEN
C
C       Evaluate functions.
C
        DO 10 I = 1,M
          TEMP = I
          FVEC(I) = TWO + TWO*TEMP - EXP(TEMP*X(1)) - EXP(TEMP*X(2))
   10   CONTINUE
      ELSE
C
C       Evaluate Jacobian.
C
        IF (IFLAG .NE. 2) RETURN
        DO 20 I = 1,M
          TEMP = I
          FJAC(I,1) = -TEMP*EXP(TEMP*X(1))
          FJAC(I,2) = -TEMP*EXP(TEMP*X(2))
   20   CONTINUE
      ENDIF
      RETURN
      END

*DECK UVEC
      SUBROUTINE UVEC (X, Y, YP)
C***BEGIN PROLOGUE  UVEC
C***PURPOSE  Dummy routine for BVSUP quick check.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (UVEC-S, DUVEC-D)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C   This routine is never called;  it is here to prevent loaders from
C   complaining about undefined externals while testing BVSUP.
C
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890618  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920401  Variables declaration and TYPE sections added.  (WRB)
C***END PROLOGUE  UVEC
C     .. Scalar Arguments ..
      REAL X
C     .. Array Arguments ..
      REAL Y(*), YP(*)
C***FIRST EXECUTABLE STATEMENT  UVEC
      STOP
      END

*DECK TEST23
      PROGRAM TEST23
C***BEGIN PROLOGUE  TEST23
C***PURPOSE  Driver for testing SLATEC subprograms
C***LIBRARY   SLATEC
C***CATEGORY  D2
C***TYPE      COMPLEX (TEST23-S)
C***KEYWORDS  QUICK CHECK DRIVER
C***AUTHOR  SLATEC Common Mathematical Library Committee
C***DESCRIPTION
C
C *Usage:
C     One input data record is required
C         READ (LIN, '(I1)') KPRINT
C
C *Arguments:
C     KPRINT = 0  Quick checks - No printing.
C                 Driver       - Short pass or fail message printed.
C              1  Quick checks - No message printed for passed tests,
C                                short message printed for failed tests.
C                 Driver       - Short pass or fail message printed.
C              2  Quick checks - Print short message for passed tests,
C                                fuller information for failed tests.
C                 Driver       - Pass or fail message printed.
C              3  Quick checks - Print complete quick check results.
C                 Driver       - Pass or fail message printed.
C
C *Description:
C     Driver for testing SLATEC subprograms
C        CGECO    CGEDI    CGEFA    CGESL
C        CGBCO    CGBDI    CGBFA    CGBSL
C        CPOCO    CPODI    CPOFA    CPOSL
C        CPPCO    CPPDI    CPPFA    CPPSL
C        CPBCO    CPBDI    CPBFA    CPBSL
C        CSICO    CSIDI    CSIFA    CSISL
C        CSPCO    CSPDI    CSPFA    CSPSL
C        CHICO    CHIDI    CHIFA    CHISL
C        CHPCO    CHPDI    CHPFA    CHPSL
C        CTRCO    CTRDI      -      CTRSL
C        CGTSL
C        CPTSL
C        CCHDC
C        CQRDC    CQRSL
C        CSVDC
C
C***REFERENCES  Kirby W. Fong, Thomas H. Jefferson, Tokihiko Suyehiro
C                 and Lee Walton, Guide to the SLATEC Common Mathema-
C                 tical Library, April 10, 1990.
C***ROUTINES CALLED  CCHQC, CGBQC, CGECK, CGTQC, CHIQC, CHPQC, CPBQC,
C                    CPOQC, CPPQC, CPTQC, CQRQC, CSIQC, CSPQC, CSVQC,
C                    CTRQC, I1MACH, XERMAX, XSETF, XSETUN
C***REVISION HISTORY  (YYMMDD)
C   890618  DATE WRITTEN
C   890618  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900524  Cosmetic changes to code.  (WRB)
C***END PROLOGUE  TEST23
      INTEGER KPRINT, LIN, LUN, NERR, NFAIL
C***FIRST EXECUTABLE STATEMENT  TEST23
      LUN = I1MACH(2)
      LIN = I1MACH(1)
      NFAIL = 0
C
C     Read KPRINT parameter
C
      READ (LIN, '(I1)') KPRINT
      CALL XERMAX(1000)
      CALL XSETUN(LUN)
      IF (KPRINT .LE. 1) THEN
         CALL XSETF(0)
      ELSE
         CALL XSETF(1)
      ENDIF
C
C     Test LINPACK routines
C
      CALL CGECK(LUN,KPRINT,NERR)
      NFAIL = NFAIL + NERR
      CALL CGBQC(LUN,KPRINT,NERR)
      NFAIL = NFAIL + NERR
      CALL CPOQC(LUN,KPRINT,NERR)
      NFAIL = NFAIL + NERR
      CALL CPPQC(LUN,KPRINT,NERR)
      NFAIL = NFAIL + NERR
      CALL CPBQC(LUN,KPRINT,NERR)
      NFAIL = NFAIL + NERR
      CALL CSIQC(LUN,KPRINT,NERR)
      NFAIL = NFAIL + NERR
      CALL CSPQC(LUN,KPRINT,NERR)
      NFAIL = NFAIL + NERR
      CALL CHIQC(LUN,KPRINT,NERR)
      NFAIL = NFAIL + NERR
      CALL CHPQC(LUN,KPRINT,NERR)
      NFAIL = NFAIL + NERR
      CALL CTRQC(LUN,KPRINT,NERR)
      NFAIL = NFAIL + NERR
      CALL CGTQC(LUN,KPRINT,NERR)
      NFAIL = NFAIL + NERR
      CALL CPTQC(LUN,KPRINT,NERR)
      NFAIL = NFAIL + NERR
      CALL CCHQC(LUN,KPRINT,NERR)
      NFAIL = NFAIL + NERR
      CALL CQRQC(LUN,KPRINT,NERR)
      NFAIL = NFAIL + NERR
      CALL CSVQC(LUN,KPRINT,NERR)
      NFAIL = NFAIL + NERR
C
C
C     Write PASS or FAIL message
C
      IF (NFAIL .EQ. 0) THEN
         WRITE (LUN, 9000)
      ELSE
         WRITE (LUN, 9010) NFAIL
      ENDIF
      STOP
 9000 FORMAT (/' --------------TEST23 PASSED ALL TESTS----------------')
 9010 FORMAT (/' ************* WARNING -- ', I5,
     1        ' TEST(S) FAILED IN PROGRAM TEST23 *************')
      END

*DECK LDE
      LOGICAL FUNCTION LDE (RI, RJ, LR)
C***BEGIN PROLOGUE  LDE
C***SUBSIDIARY
C***PURPOSE  Test if two arrays are identical.
C***LIBRARY   SLATEC (BLAS)
C***AUTHOR  Du Croz, J. J., (NAG)
C           Hanson, R. J., (SNLA)
C***DESCRIPTION
C
C  Tests if two arrays are identical.
C
C  Auxiliary routine for test program for Level 2 Blas.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   870810  DATE WRITTEN
C   910620  Modified to meet SLATEC code and prologue standards.  (BKS)
C***END PROLOGUE  LDE
C     .. Scalar Arguments ..
      INTEGER            LR
C     .. Array Arguments ..
      DOUBLE PRECISION   RI( * ), RJ( * )
C     .. Local Scalars ..
      INTEGER            I
C***FIRST EXECUTABLE STATEMENT  LDE
      LDE = .TRUE.
      DO 10 I = 1, LR
         IF( RI( I ).NE.RJ( I ) ) THEN
           LDE = .FALSE.
           GO TO 30
        ENDIF
   10 CONTINUE
   30 RETURN
C
C     End of LDE.
C
      END

*DECK SMMCH
      SUBROUTINE SMMCH (TRANSA, TRANSB, M, N, KK, ALPHA, A, LDA, B, LDB,
     $   BETA, C, LDC, CT, G, CC, LDCC, EPS, ERR, FTL, NOUT, MV, KPRINT)
C***BEGIN PROLOGUE  SMMCH
C***SUBSIDIARY
C***PURPOSE  Check the results of the computational tests.
C***LIBRARY   SLATEC (BLAS)
C***AUTHOR  Dongarra, J. J., (ANL)
C           Duff, I., (AERE)
C           Du Croz, J., (NAG)
C           Hammarling, S., (NAG)
C***DESCRIPTION
C
C  Checks the results of the computational tests.
C
C  Auxiliary routine for test program for Level 3 Blas.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   890208  DATE WRITTEN
C   910620  Modified to meet SLATEC code and prologue standards.  (BKS)
C***END PROLOGUE  SMMCH
C     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0, ONE = 1.0 )
C     .. Scalar Arguments ..
      REAL               ALPHA, BETA, EPS, ERR
      INTEGER            KK, KPRINT, LDA, LDB, LDC, LDCC, M, N, NOUT
      LOGICAL            MV, FTL
      CHARACTER*1        TRANSA, TRANSB
C     .. Array Arguments ..
      REAL               A( LDA, * ), B( LDB, * ), C( LDC, * ),
     $                   CC( LDCC, * ), CT( * ), G( * )
C     .. Local Scalars ..
      REAL               ERRI
      INTEGER            I, J, K
      LOGICAL            TRANA, TRANB
C     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SQRT
C***FIRST EXECUTABLE STATEMENT  SMMCH
      TRANA = TRANSA.EQ.'T'.OR.TRANSA.EQ.'C'
      TRANB = TRANSB.EQ.'T'.OR.TRANSB.EQ.'C'
C
C     Compute expected result, one column at a time, in CT using data
C     in A, B and C.
C     Compute gauges in G.
C
      DO 120 J = 1, N
C
         DO 10 I = 1, M
            CT( I ) = ZERO
            G( I ) = ZERO
   10    CONTINUE
         IF( .NOT.TRANA.AND..NOT.TRANB )THEN
            DO 30 K = 1, KK
               DO 20 I = 1, M
                  CT( I ) = CT( I ) + A( I, K )*B( K, J )
                  G( I ) = G( I ) + ABS( A( I, K ) )*ABS( B( K, J ) )
   20          CONTINUE
   30       CONTINUE
         ELSE IF( TRANA.AND..NOT.TRANB )THEN
            DO 50 K = 1, KK
               DO 40 I = 1, M
                  CT( I ) = CT( I ) + A( K, I )*B( K, J )
                  G( I ) = G( I ) + ABS( A( K, I ) )*ABS( B( K, J ) )
   40          CONTINUE
   50       CONTINUE
         ELSE IF( .NOT.TRANA.AND.TRANB )THEN
            DO 70 K = 1, KK
               DO 60 I = 1, M
                  CT( I ) = CT( I ) + A( I, K )*B( J, K )
                  G( I ) = G( I ) + ABS( A( I, K ) )*ABS( B( J, K ) )
   60          CONTINUE
   70       CONTINUE
         ELSE IF( TRANA.AND.TRANB )THEN
            DO 90 K = 1, KK
               DO 80 I = 1, M
                  CT( I ) = CT( I ) + A( K, I )*B( J, K )
                  G( I ) = G( I ) + ABS( A( K, I ) )*ABS( B( J, K ) )
   80          CONTINUE
   90       CONTINUE
         END IF
         DO 100 I = 1, M
            CT( I ) = ALPHA*CT( I ) + BETA*C( I, J )
            G( I ) = ABS( ALPHA )*G( I ) + ABS( BETA )*ABS( C( I, J ) )
  100    CONTINUE
C
C        Compute the error ratio for this result.
C
         ERR = ZERO
         DO 110 I = 1, M
            ERRI = ABS( CT( I ) - CC( I, J ) )/EPS
            IF( G( I ).NE.ZERO )
     $         ERRI = ERRI/G( I )
            ERR = MAX( ERR, ERRI )
            IF( ERR*SQRT( EPS ).GE.ONE ) THEN
              FTL = .TRUE.
              IF (KPRINT .GE. 2) THEN
               WRITE( NOUT, FMT = 9999 )
               DO 140 K = 1, M
                  IF( MV )THEN
                     WRITE( NOUT, FMT = 9998 )K, CT( K ), CC( K, J )
                  ELSE
                     WRITE( NOUT, FMT = 9998 )K, CC( K, J ), CT( K )
                  END IF
  140          CONTINUE
              ENDIF
            ENDIF
  110    CONTINUE
  120 CONTINUE
      RETURN
C
 9999 FORMAT( ' ******* FATAL ERROR - COMPUTED RESULT IS LESS THAN HAL',
     $      'F ACCURATE *******', /'           EXPECTED RESULT   COMPU',
     $      'TED RESULT' )
 9998 FORMAT( 1X, I7, 2G18.6 )
C
C     End of SMMCH.
C
      END

*DECK DSOSQX
      SUBROUTINE DSOSQX (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  DSOSQX
C***PURPOSE  Quick check for DSOS.
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (SOSNQX-S, DSOSQX-D)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C   This subroutine performs a quick check on the subroutine DSOS.
C
C***ROUTINES CALLED  D1MACH, DNRM2, DSOS, DSOSFN, PASS
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890618  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920310  Code cleaned up and TYPE section added.  (RWC, WRB)
C***END PROLOGUE  DSOSQX
C     .. Scalar Arguments ..
      INTEGER IPASS, KPRINT, LUN
C     .. Local Scalars ..
      DOUBLE PRECISION AER, FNORM, FNORMS, RER, TOLF
      INTEGER ICNT, IFLAG, IFLAGS, LIW, LWA, N
C     .. Local Arrays ..
      DOUBLE PRECISION FVEC(2), WA(17), X(2)
      INTEGER ITEST(2), IW(6)
C     .. External Functions ..
      DOUBLE PRECISION D1MACH, DNRM2, DSOSFN
      EXTERNAL D1MACH, DNRM2, DSOSFN
C     .. External Subroutines ..
      EXTERNAL DSOS, PASS
C     .. Intrinsic Functions ..
      INTRINSIC SQRT
C***FIRST EXECUTABLE STATEMENT  DSOSQX
      IFLAGS = 3
      FNORMS = 0.0D0
      N = 2
      LWA = 17
      LIW = 6
      TOLF = SQRT(D1MACH(4))
      RER = SQRT(D1MACH(4))
      AER = 0.0D0
      IF (KPRINT .GE. 2) WRITE (LUN,9000)
C
C     Test the code with proper input values.
C
      IFLAG = 0
      X(1) = -1.2D0
      X(2) = 1.0D0
      CALL DSOS (DSOSFN,N,X,RER,AER,TOLF,IFLAG,WA,LWA,IW,LIW)
      ICNT = 1
      FVEC(1) = DSOSFN(X,1)
      FVEC(2) = DSOSFN(X,2)
      FNORM = DNRM2(N,FVEC,1)
      ITEST(ICNT) = 0
      IF (IFLAG.LE.IFLAGS .AND. FNORM-FNORMS.LE.RER) ITEST(ICNT) = 1
C
      IF (KPRINT .NE. 0) THEN
         IF (KPRINT.GE.3 .OR. (KPRINT.GE.2.AND.ITEST(ICNT).NE.1))
     +       WRITE (LUN,9010) IFLAGS,FNORMS,IFLAG,FNORM
         IF (KPRINT.GE.2 .OR. (KPRINT.EQ.1.AND.ITEST(ICNT).NE.1))
     +       CALL PASS (LUN,ICNT,ITEST(ICNT))
      ENDIF
C
C     Test improper input parameters.
C
      LWA = 15
      IFLAG = 0
      X(1) = -1.2D0
      X(2) = 1.0D0
      CALL DSOS (DSOSFN,N,X,RER,AER,TOLF,IFLAG,WA,LWA,IW,LIW)
      ICNT = 2
      ITEST(ICNT) = 0
      IF (IFLAG .EQ. 9) ITEST(ICNT) = 1
      IF (KPRINT.GE.2 .OR. (KPRINT.EQ.1.AND.ITEST(ICNT).NE.1))
     +    CALL PASS (LUN,ICNT,ITEST(ICNT))
C
C     Set IPASS.
C
      IPASS = ITEST(1)*ITEST(2)
      IF (KPRINT.GE.1 .AND. IPASS.NE.1) WRITE (LUN,9020)
      IF (KPRINT.GE.2 .AND. IPASS.EQ.1) WRITE (LUN,9030)
      RETURN
 9000 FORMAT ('1' / '  DSOS QUICK CHECK' /)
 9010 FORMAT (' EXPECTED VALUE OF IFLAG AND RESIDUAL NORM', I5, D20.5 /
     +        ' RETURNED VALUE OF IFLAG AND RESIDUAL NORM', I5, D20.5 /)
 9020 FORMAT (/' **********WARNING -- DSOS FAILED SOME TESTS**********')
 9030 FORMAT (/' ----------DSOS PASSED ALL TESTS----------')
      END

*DECK QXCSP
      SUBROUTINE QXCSP (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  QXCSP
C***PURPOSE
C***LIBRARY   SLATEC
C***KEYWORDS  QUICK CHECK
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C     *                                                               *
C     *                        F I S H P A K                          *
C     *                                                               *
C     *                                                               *
C     *     A PACKAGE OF FORTRAN SUBPROGRAMS FOR THE SOLUTION OF      *
C     *                                                               *
C     *      SEPARABLE ELLIPTIC PARTIAL DIFFERENTIAL EQUATIONS        *
C     *                                                               *
C     *                  (VERSION  3 , JUNE 1979)                     *
C     *                                                               *
C     *                             BY                                *
C     *                                                               *
C     *        JOHN ADAMS, PAUL SWARZTRAUBER AND ROLAND SWEET         *
C     *                                                               *
C     *                             OF                                *
C     *                                                               *
C     *         THE NATIONAL CENTER FOR ATMOSPHERIC RESEARCH          *
C     *                                                               *
C     *                BOULDER, COLORADO  (80307)  U.S.A.             *
C     *                                                               *
C     *                   WHICH IS SPONSORED BY                       *
C     *                                                               *
C     *              THE NATIONAL SCIENCE FOUNDATION                  *
C     *                                                               *
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C
C
C     PROGRAM TO ILLUSTRATE THE USE OF HWSCSP
C
C***ROUTINES CALLED  HWSCSP, PIMACH
C***REVISION HISTORY  (YYMMDD)
C   800103  DATE WRITTEN
C   890718  Changed computation of PI to use PIMACH.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890911  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   901010  Added PASS/FAIL message and cleaned up FORMATs.  (RWC)
C***END PROLOGUE  QXCSP
      DIMENSION F(48,33), BDTF(33), W(1200), R(33), THETA(48)
C***FIRST EXECUTABLE STATEMENT  QXCSP
C
C     THE VALUE OF IDIMF IS THE FIRST DIMENSION OF F.  SINCE M=36, N=32,
C     L=N THEREFORE K=5 AND W IS DIMENSIONED 2*(L+1)*(K-1) + 6*(M+N)
C     + MAX(4*N,6*M) + 14 = 902.
C
      ERMAX=1.E-3
      PI = PIMACH(DUM)
      INTL = 0
      TS = 0.
      TF = PI/2.
      M = 36
      MBDCND = 6
      RS = 0.
      RF = 1.
      N = 32
      NBDCND = 5
      ELMBDA = 0.
      IDIMF = 48
C
C     GENERATE AND STORE GRID POINTS FOR THE PURPOSE OF COMPUTING THE
C     BOUNDARY DATA AND THE RIGHT SIDE OF THE EQUATION.
C
      MP1 = M+1
      DTHETA = TF/M
      DO 101 I=1,MP1
         THETA(I) = (I-1)*DTHETA
  101 CONTINUE
      NP1 = N+1
      DR = 1.0E0/N
      DO 102 J=1,NP1
         R(J) = (J-1)*DR
  102 CONTINUE
C
C     GENERATE NORMAL DERIVATIVE DATA AT EQUATOR
C
      DO 103 J=1,NP1
         BDTF(J) = 0.
  103 CONTINUE
C
C     COMPUTE BOUNDARY DATA ON THE SURFACE OF THE SPHERE
C
      DO 104 I=1,MP1
         F(I,N+1) = COS(THETA(I))**4
  104 CONTINUE
C
C     COMPUTE RIGHT SIDE OF EQUATION
C
      DO 106 I=1,MP1
         CI4 = 12.0E0*COS(THETA(I))**2
         DO 105 J=1,N
            F(I,J) = CI4*R(J)**2
  105    CONTINUE
  106 CONTINUE
C
      CALL HWSCSP (INTL,TS,TF,M,MBDCND,BDTS,BDTF,RS,RF,N,NBDCND,BDRS,
     1             BDRF,ELMBDA,F,IDIMF,PERTRB,IERROR,W)
C
C     COMPUTE DISCRETIZATION ERROR
C
      ERR = 0.
      DO 108 I=1,MP1
         CI4 = COS(THETA(I))**4
         DO 107 J=1,N
            Z = ABS(F(I,J)-CI4*R(J)**4)
            IF (Z .GT. ERR) ERR = Z
  107    CONTINUE
  108 CONTINUE
C
      IPASS = 1
      IF (ERR.GT.ERMAX) IPASS = 0
      IF (KPRINT.NE.0) THEN
         IF (KPRINT.GE.2 .OR. IPASS.EQ.0) THEN
            WRITE (LUN,1001) IERROR,ERR,INT(W(1))
            IF (IPASS.EQ.1) THEN
               WRITE (LUN, 1003)
            ELSE
               WRITE (LUN, 1004)
            ENDIF
         ENDIF
      ENDIF
C
C     THE FOLLOWING PROGRAM ILLUSTRATES THE USE OF HWSCSP TO SOLVE
C     A THREE DIMENSIONAL PROBLEM WHICH HAS LONGITUDINAL DEPENDENCE
C
      MBDCND = 2
      NBDCND = 1
      DPHI = PI/72.
      ELMBDA = -2.0E0*(1.0E0-COS(DPHI))/DPHI**2
C
C     COMPUTE BOUNDARY DATA ON THE SURFACE OF THE SPHERE
C
      DO 109 I=1,MP1
         F(I,N+1) = SIN(THETA(I))
  109 CONTINUE
C
C     COMPUTE RIGHT SIDE OF THE EQUATION
C
      DO 111 J=1,N
         DO 110 I=1,MP1
            F(I,J) = 0.
  110    CONTINUE
  111 CONTINUE
C
      CALL HWSCSP (INTL,TS,TF,M,MBDCND,BDTS,BDTF,RS,RF,N,NBDCND,BDRS,
     1             BDRF,ELMBDA,F,IDIMF,PERTRB,IERROR,W)
C
C     COMPUTE DISCRETIZATION ERROR   (FOURIER COEFFICIENTS)
C
      ERR = 0.
      DO 113 I=1,MP1
         SI = SIN(THETA(I))
         DO 112 J=1,NP1
            Z = ABS(F(I,J)-R(J)*SI)
            IF (Z .GT. ERR) ERR = Z
  112    CONTINUE
  113 CONTINUE
C
      IF (ERR.GT.ERMAX) IPASS = 0
      IF (KPRINT.EQ.0) RETURN
      IF (KPRINT.GE.2 .OR. IPASS.EQ.0) THEN
         WRITE (LUN,1002) IERROR,ERR,INT(W(1))
         IF (IPASS.EQ.1) THEN
            WRITE (LUN, 1003)
         ELSE
            WRITE (LUN, 1004)
         ENDIF
      ENDIF
      RETURN
C
 1001 FORMAT ('1',20X,'SUBROUTINE HWSCSP EXAMPLE 1'///
     1        10X,'THE OUTPUT FROM THE NCAR CONTROL DATA 7600 WAS'//
     2        32X,'IERROR = 0'/
     3        18X,'DISCRETIZATION ERROR = 7.99842E-04'/
     4        12X,'REQUIRED LENGTH OF W ARRAY = 775'//
     5        10X,'THE OUTPUT FROM YOUR COMPUTER IS'//
     6        32X,'IERROR =',I2/
     7        18X,'DISCRETIZATION ERROR =',1PE12.5/
     8        12X,'REQUIRED LENGTH OF W ARRAY =',I4)
 1002 FORMAT ('1',20X,'SUBROUTINE HWSCSP EXAMPLE 2'///
     1        10X,'THE OUTPUT FROM THE NCAR CONTROL DATA 7600 WAS'//
     2        32X,'IERROR = 0'/
     3        18X,'DISCRETIZATION ERROR = 5.86824E-05'/
     4        12X,'REQUIRED LENGTH OF W ARRAY = 775'//
     5        10X,'THE OUTPUT FROM YOUR COMPUTER IS'//
     6        32X,'IERROR =',I2/
     7        18X,'DISCRETIZATION ERROR =',1PE12.5/
     8        12X,'REQUIRED LENGTH OF W ARRAY =',I4)
 1003 FORMAT (60X,'PASS'/)
 1004 FORMAT (60X,'FAIL'/)
      END

*DECK SOSNQX
      SUBROUTINE SOSNQX (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  SOSNQX
C***PURPOSE  Quick check for SOS.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SOSNQX-S, DSOSQX-D)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C   This subroutine performs a quick check on the subroutine SOS.
C
C***ROUTINES CALLED  PASS, R1MACH, SNRM2, SOS, SOSFNC
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890618  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920310  Code cleaned up and TYPE section added.  (RWC, WRB)
C***END PROLOGUE  SOSNQX
C     .. Scalar Arguments ..
      INTEGER IPASS, KPRINT, LUN
C     .. Local Scalars ..
      REAL AER, FNORM, FNORMS, RER, TOLF
      INTEGER ICNT, IFLAG, IFLAGS, LIW, LWA, N
C     .. Local Arrays ..
      REAL FVEC(2), WA(17), X(2)
      INTEGER ITEST(2), IW(6)
C     .. External Functions ..
      REAL R1MACH, SNRM2, SOSFNC
      EXTERNAL R1MACH, SNRM2, SOSFNC
C     .. External Subroutines ..
      EXTERNAL PASS, SOS
C     .. Intrinsic Functions ..
      INTRINSIC SQRT
C***FIRST EXECUTABLE STATEMENT  SOSNQX
      IFLAGS = 3
      FNORMS = 0.0E0
      N = 2
      LWA = 17
      LIW = 6
      TOLF = SQRT(R1MACH(4))
      RER = SQRT(R1MACH(4))
      AER = 0.0E0
      IF (KPRINT .GE. 2) WRITE (LUN,9000)
C
C     Test the code with proper input values.
C
      IFLAG = 0
      X(1) = -1.2E0
      X(2) = 1.0E0
      CALL SOS (SOSFNC,N,X,RER,AER,TOLF,IFLAG,WA,LWA,IW,LIW)
      ICNT = 1
      FVEC(1) = SOSFNC(X,1)
      FVEC(2) = SOSFNC(X,2)
      FNORM = SNRM2(N,FVEC,1)
      ITEST(ICNT) = 0
      IF (IFLAG.LE.IFLAGS .AND. FNORM-FNORMS.LE.RER) ITEST(ICNT) = 1
C
      IF (KPRINT .NE. 0) THEN
         IF (KPRINT.GE.3 .OR. (KPRINT.GE.2.AND.ITEST(ICNT).NE.1))
     +       WRITE (LUN,9010) IFLAGS,FNORMS,IFLAG,FNORM
         IF (KPRINT.GE.2 .OR. (KPRINT.EQ.1.AND.ITEST(ICNT).NE.1))
     +       CALL PASS (LUN,ICNT,ITEST(ICNT))
      ENDIF
C
C     Test improper input parameters.
C
      LWA = 15
      IFLAG = 0
      X(1) = -1.2E0
      X(2) = 1.0E0
      CALL SOS (SOSFNC,N,X,RER,AER,TOLF,IFLAG,WA,LWA,IW,LIW)
      ICNT = 2
      ITEST(ICNT) = 0
      IF (IFLAG .EQ. 9) ITEST(ICNT) = 1
      IF (KPRINT.GE.2 .OR. (KPRINT.EQ.1.AND.ITEST(ICNT).NE.1))
     +    CALL PASS (LUN,ICNT,ITEST(ICNT))
C
C     Set IPASS.
C
      IPASS = ITEST(1)*ITEST(2)
      IF (KPRINT.GE.1 .AND. IPASS.NE.1) WRITE (LUN,9020)
      IF (KPRINT.GE.2 .AND. IPASS.EQ.1) WRITE (LUN,9030)
      RETURN
 9000 FORMAT ('1' / '  SOS QUICK CHECK' /)
 9010 FORMAT (' EXPECTED VALUE OF IFLAG AND RESIDUAL NORM', I5, E20.5 /
     +        ' RETURNED VALUE OF IFLAG AND RESIDUAL NORM', I5, E20.5 /)
 9020 FORMAT (/' **********WARNING -- SOS FAILED SOME TESTS**********')
 9030 FORMAT (/' ----------SOS PASSED ALL TESTS----------')
      END

*DECK SDJAC2
      SUBROUTINE SDJAC2 (T, Y, YPRIME, PD, CJ, RPAR, IPAR)
C***BEGIN PROLOGUE  SDJAC2
C***SUBSIDIARY
C***PURPOSE  Second Jacobian evaluator for SDASQC.
C***LIBRARY   SLATEC (DASSL)
C***TYPE      SINGLE PRECISION (SDJAC2-S, DDJAC2-D)
C***AUTHOR  PETZOLD, LINDA R., (LLNL)
C***SEE ALSO  SDASQC
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   891013  DATE WRITTEN
C   901001  Converted prologue to 4.0 format and made all argument
C           declarations explicit.  (FNF)
C   901001  Eliminated 7-character variable names MBANDPn by explicitly
C           including MBAND+n in expressions.  (FNF)
C   901030  Made all local declarations explicit.  (FNF)
C***END PROLOGUE  SDJAC2
      INTEGER  IPAR(*)
      REAL  T, Y(*), YPRIME(*), PD(11,25), CJ, RPAR(*)
      INTEGER  J, MBAND, ML, MU, NEQ, NG
      REAL  ALPH1, ALPH2
      DATA ALPH1/1.0E0/, ALPH2/1.0E0/, NG/5/
      DATA ML/5/, MU/0/, NEQ/25/
C***FIRST EXECUTABLE STATEMENT  SDJAC2
      MBAND = ML + MU + 1
      DO 10 J = 1,NEQ
        PD(MBAND,J) = -2.0E0 - CJ
        PD(MBAND+1,J) = ALPH1
        PD(MBAND+2,J) = 0.0E0
        PD(MBAND+3,J) = 0.0E0
        PD(MBAND+4,J) = 0.0E0
 10     PD(MBAND+5,J) = ALPH2
      DO 20 J = 1,NEQ,NG
 20     PD(MBAND+1,J) = 0.0E0
      RETURN
      END

      INTEGER FUNCTION I1MACH(I)
      INTEGER I
C
C    I1MACH( 1) = THE STANDARD INPUT UNIT.
C    I1MACH( 2) = THE STANDARD OUTPUT UNIT.
C    I1MACH( 3) = THE STANDARD PUNCH UNIT.
C    I1MACH( 4) = THE STANDARD ERROR MESSAGE UNIT.
C    I1MACH( 5) = THE NUMBER OF BITS PER INTEGER STORAGE UNIT.
C    I1MACH( 6) = THE NUMBER OF CHARACTERS PER CHARACTER STORAGE UNIT.
C    INTEGERS HAVE FORM SIGN ( X(S-1)*A**(S-1) + ... + X(1)*A + X(0) )
C    I1MACH( 7) = A, THE BASE.
C    I1MACH( 8) = S, THE NUMBER OF BASE-A DIGITS.
C    I1MACH( 9) = A**S - 1, THE LARGEST MAGNITUDE.
C    FLOATS HAVE FORM  SIGN (B**E)*( (X(1)/B) + ... + (X(T)/B**T) )
C               WHERE  EMIN .LE. E .LE. EMAX.
C    I1MACH(10) = B, THE BASE.
C  SINGLE-PRECISION
C    I1MACH(11) = T, THE NUMBER OF BASE-B DIGITS.
C    I1MACH(12) = EMIN, THE SMALLEST EXPONENT E.
C    I1MACH(13) = EMAX, THE LARGEST EXPONENT E.
C  DOUBLE-PRECISION
C    I1MACH(14) = T, THE NUMBER OF BASE-B DIGITS.
C    I1MACH(15) = EMIN, THE SMALLEST EXPONENT E.
C    I1MACH(16) = EMAX, THE LARGEST EXPONENT E.
C
      INTEGER CRAY1, IMACH(16), OUTPUT, SANITY, SMALL(2)
      COMMON /D8MACH/ CRAY1
      SAVE IMACH, SANITY
      REAL RMACH
      EQUIVALENCE (IMACH(4),OUTPUT), (RMACH,SMALL(1))
C
C     MACHINE CONSTANTS FOR THE HONEYWELL DPS 8/70 SERIES.
C
C      DATA IMACH( 1) /    5 /
C      DATA IMACH( 2) /    6 /
C      DATA IMACH( 3) /   43 /
C      DATA IMACH( 4) /    6 /
C      DATA IMACH( 5) /   36 /
C      DATA IMACH( 6) /    4 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   35 /
C      DATA IMACH( 9) / O377777777777 /
C      DATA IMACH(10) /    2 /
C      DATA IMACH(11) /   27 /
C      DATA IMACH(12) / -127 /
C      DATA IMACH(13) /  127 /
C      DATA IMACH(14) /   63 /
C      DATA IMACH(15) / -127 /
C      DATA IMACH(16) /  127 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRANS SUPPORTING
C     32-BIT INTEGER ARITHMETIC.
C
C      DATA IMACH( 1) /    5 /
C      DATA IMACH( 2) /    6 /
C      DATA IMACH( 3) /    7 /
C      DATA IMACH( 4) /    6 /
C      DATA IMACH( 5) /   32 /
C      DATA IMACH( 6) /    4 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   31 /
C      DATA IMACH( 9) / 2147483647 /
C      DATA IMACH(10) /    2 /
C      DATA IMACH(11) /   24 /
C      DATA IMACH(12) / -127 /
C      DATA IMACH(13) /  127 /
C      DATA IMACH(14) /   56 /
C      DATA IMACH(15) / -127 /
C      DATA IMACH(16) /  127 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR THE SEQUENT BALANCE 8000.
C
C      DATA IMACH( 1) /     0 /
C      DATA IMACH( 2) /     0 /
C      DATA IMACH( 3) /     7 /
C      DATA IMACH( 4) /     0 /
C      DATA IMACH( 5) /    32 /
C      DATA IMACH( 6) /     1 /
C      DATA IMACH( 7) /     2 /
C      DATA IMACH( 8) /    31 /
C      DATA IMACH( 9) /  2147483647 /
C      DATA IMACH(10) /     2 /
C      DATA IMACH(11) /    24 /
C      DATA IMACH(12) /  -125 /
C      DATA IMACH(13) /   128 /
C      DATA IMACH(14) /    53 /
C      DATA IMACH(15) / -1021 /
C      DATA IMACH(16) /  1024 /, SANITY/987/
C
C     MACHINE CONSTANTS FOR THE UNIVAC 1100 SERIES.
C
C     NOTE THAT THE PUNCH UNIT, I1MACH(3), HAS BEEN SET TO 7
C     WHICH IS APPROPRIATE FOR THE UNIVAC-FOR SYSTEM.
C     IF YOU HAVE THE UNIVAC-FTN SYSTEM, SET IT TO 1.
C
C      DATA IMACH( 1) /    5 /
C      DATA IMACH( 2) /    6 /
C      DATA IMACH( 3) /    7 /
C      DATA IMACH( 4) /    6 /
C      DATA IMACH( 5) /   36 /
C      DATA IMACH( 6) /    6 /
C      DATA IMACH( 7) /    2 /
C      DATA IMACH( 8) /   35 /
C      DATA IMACH( 9) / O377777777777 /
C      DATA IMACH(10) /    2 /
C      DATA IMACH(11) /   27 /
C      DATA IMACH(12) / -128 /
C      DATA IMACH(13) /  127 /
C      DATA IMACH(14) /   60 /
C      DATA IMACH(15) /-1024 /
C      DATA IMACH(16) / 1023 /, SANITY/987/
C
      IF (SANITY .NE. 987) THEN
*        *** CHECK FOR AUTODOUBLE ***
         SMALL(2) = 0
         RMACH = 1E13
         IF (SMALL(2) .NE. 0) THEN
*           *** AUTODOUBLED ***
            IF (      (SMALL(1) .EQ. 1117925532
     *           .AND. SMALL(2) .EQ. -448790528)
     *       .OR.     (SMALL(2) .EQ. 1117925532
     *           .AND. SMALL(1) .EQ. -448790528)) THEN
*               *** IEEE ***
               IMACH(10) = 2
               IMACH(14) = 53
               IMACH(15) = -1021
               IMACH(16) = 1024
            ELSE IF ( SMALL(1) .EQ. -2065213935
     *          .AND. SMALL(2) .EQ. 10752) THEN
*               *** VAX WITH D_FLOATING ***
               IMACH(10) = 2
               IMACH(14) = 56
               IMACH(15) = -127
               IMACH(16) = 127
            ELSE IF ( SMALL(1) .EQ. 1267827943
     *          .AND. SMALL(2) .EQ. 704643072) THEN
*               *** IBM MAINFRAME ***
               IMACH(10) = 16
               IMACH(14) = 14
               IMACH(15) = -64
               IMACH(16) = 63
            ELSE
               WRITE(*,9010)
               STOP 777
               END IF
            IMACH(11) = IMACH(14)
            IMACH(12) = IMACH(15)
            IMACH(13) = IMACH(16)
         ELSE
            RMACH = 1234567.
            IF (SMALL(1) .EQ. 1234613304) THEN
*               *** IEEE ***
               IMACH(10) = 2
               IMACH(11) = 24
               IMACH(12) = -125
               IMACH(13) = 128
               IMACH(14) = 53
               IMACH(15) = -1021
               IMACH(16) = 1024
               SANITY = 987
            ELSE IF (SMALL(1) .EQ. -1271379306) THEN
*               *** VAX ***
               IMACH(10) = 2
               IMACH(11) = 24
               IMACH(12) = -127
               IMACH(13) = 127
               IMACH(14) = 56
               IMACH(15) = -127
               IMACH(16) = 127
               SANITY = 987
            ELSE IF (SMALL(1) .EQ. 1175639687) THEN
*               *** IBM MAINFRAME ***
               IMACH(10) = 16
               IMACH(11) = 6
               IMACH(12) = -64
               IMACH(13) = 63
               IMACH(14) = 14
               IMACH(15) = -64
               IMACH(16) = 63
               SANITY = 987
            ELSE IF (SMALL(1) .EQ. 1251390520) THEN
*              *** CONVEX C-1 ***
               IMACH(10) = 2
               IMACH(11) = 24
               IMACH(12) = -128
               IMACH(13) = 127
               IMACH(14) = 53
               IMACH(15) = -1024
               IMACH(16) = 1023
               SANITY = 987
            ELSE
               CRAY1 = 4617762693716115456.D0
               IF (SMALL(1) .NE. CRAY1) THEN
                  WRITE(*,9020)
                  STOP 777
                  END IF
*              *** CRAY 1, XMP, 2, AND 3 ***
               IMACH(1) = 5
               IMACH(2) = 6
               IMACH(3) = 102
               IMACH(4) = 6
               IMACH(5) = 64
               IMACH(6) = 8
               IMACH(7) = 2
               IMACH(8) = 63
               IMACH(9) = 9223372036854775807.D0
               IMACH(10) = 2
               IMACH(11) = 47
               IMACH(12) = -8189
               IMACH(13) = 8190
               IMACH(14) = 94
               IMACH(15) = -8099
               IMACH(16) = 8190
               SANITY = 987
               GO TO 10
               END IF
            END IF
         IMACH( 1) = 5
         IMACH( 2) = 6
         IMACH( 3) = 7
         IMACH( 4) = 6
         IMACH( 5) = 32
         IMACH( 6) = 4
         IMACH( 7) = 2
         IMACH( 8) = 31
         IMACH( 9) = 2147483647
         SANITY = 987
         END IF
 9010 FORMAT(/' Adjust autodoubled I1MACH by uncommenting data'/
     * ' statements appropriate for your machine and setting'/
     * ' IMACH(I) = IMACH(I+3) for I = 11, 12, and 13.')
 9020 FORMAT(/' Adjust I1MACH by uncommenting data statements'/
     * ' appropriate for your machine.')
 10   IF (I .LT. 1  .OR.  I .GT. 16) GO TO 30
      I1MACH = IMACH(I)
C REMOVE THE FOLLOWING LINE IF FORTRAN66 IS PREFERRED TO FORTRAN77.
      IF (I .EQ. 6) I1MACH = 1
      RETURN
 30   WRITE(*,*) 'I1MACH(I): I =',I,' is out of bounds.'
      STOP
* /* C source for I1MACH -- remove the * in column 1 */
* /* Note that some values may need changing. */
*#include <stdio.h>
*#include <float.h>
*#include <limits.h>
*#include <math.h>
*
*long i1mach_(long *i)
*{
*	switch(*i){
*	  case 1:  return 5;	/* standard input */
*	  case 2:  return 6;	/* standard output */
*	  case 3:  return 7;	/* standard punch */
*	  case 4:  return 0;	/* standard error */
*	  case 5:  return 32;	/* bits per integer */
*	  case 6:  return 1;	/* Fortran 77 value */
*	  case 7:  return 2;	/* base for integers */
*	  case 8:  return 31;	/* digits of integer base */
*	  case 9:  return LONG_MAX;
*	  case 10: return FLT_RADIX;
*	  case 11: return FLT_MANT_DIG;
*	  case 12: return FLT_MIN_EXP;
*	  case 13: return FLT_MAX_EXP;
*	  case 14: return DBL_MANT_DIG;
*	  case 15: return DBL_MIN_EXP;
*	  case 16: return DBL_MAX_EXP;
*	  }
*	fprintf(stderr, "invalid argument: i1mach(%ld)\n", *i);
*	exit(1);return 0; /* for compilers that complain of missing return values */
*}
      END

*DECK TEST54
      PROGRAM TEST54
C***BEGIN PROLOGUE  TEST54
C***PURPOSE  Driver for testing SLATEC subprograms
C***LIBRARY   SLATEC
C***CATEGORY  N6A
C***TYPE      ALL (TEST54-A)
C***KEYWORDS  QUICK CHECK DRIVER
C***AUTHOR  SLATEC Common Mathematical Library Committee
C***DESCRIPTION
C
C *Usage:
C     One input data record is required
C         READ (LIN, '(I1)') KPRINT
C
C *Arguments:
C     KPRINT = 0  Quick checks - No printing.
C                 Driver       - Short pass or fail message printed.
C              1  Quick checks - No message printed for passed tests,
C                                short message printed for failed tests.
C                 Driver       - Short pass or fail message printed.
C              2  Quick checks - Print short message for passed tests,
C                                fuller information for failed tests.
C                 Driver       - Pass or fail message printed.
C              3  Quick checks - Print complete quick check results.
C                 Driver       - Pass or fail message printed.
C
C *Description:
C     Driver for testing SLATEC subprograms
C        ISORT   SSORT   DSORT
C        IPSORT  SPSORT  DPSORT  HPSORT
C        IPPERM  SPPERM  DPPERM  HPPERM
C
C***REFERENCES  Kirby W. Fong, Thomas H. Jefferson, Tokihiko Suyehiro
C                 and Lee Walton, Guide to the SLATEC Common Mathema-
C                 tical Library, April 10, 1990.
C***ROUTINES CALLED  DSRTQC, HSRTQC, I1MACH, ISRTQC, SSRTQC, XERMAX,
C                    XSETF, XSETUN
C***REVISION HISTORY  (YYMMDD)
C   890620  DATE WRITTEN
C***END PROLOGUE  TEST54
      INTEGER LUN, I1MACH, LIN, NFAIL, KPRINT, IPASS
C***FIRST EXECUTABLE STATEMENT  TEST54
      LUN = I1MACH(2)
      LIN = I1MACH(1)
      NFAIL = 0
C
C     Read KPRINT parameter
C
      READ (LIN, '(I1)') KPRINT
      CALL XERMAX(1000)
      CALL XSETUN(LUN)
      IF (KPRINT .LE. 1) THEN
         CALL XSETF(0)
      ELSE
         CALL XSETF(1)
      ENDIF
C
C     Test ISORT, IPSORT and IPPERM
C
      CALL ISRTQC(LUN, KPRINT, IPASS)
      IF (IPASS .EQ. 0) NFAIL = NFAIL + 1
C
C     Test SSORT, SPSORT and SPPERM
C
      CALL SSRTQC(LUN, KPRINT, IPASS)
      IF (IPASS .EQ. 0) NFAIL = NFAIL + 1
C
C     Test DSORT, DPSORT and DPPERM
C
      CALL DSRTQC(LUN, KPRINT, IPASS)
      IF (IPASS .EQ. 0) NFAIL = NFAIL + 1
C
C     Test HPSORT and HPPERM
C
      CALL HSRTQC(LUN, KPRINT, IPASS)
      IF (IPASS .EQ. 0) NFAIL = NFAIL + 1
C
C     Write PASS or FAIL message
C
      IF (NFAIL .EQ. 0) THEN
         WRITE (LUN, 9000)
      ELSE
         WRITE (LUN, 9010) NFAIL
      ENDIF
      STOP
 9000 FORMAT (/' --------------TEST54 PASSED ALL TESTS----------------')
 9010 FORMAT (/' ************* WARNING -- ', I5,
     1        ' TEST(S) FAILED IN PROGRAM TEST54 *************')
      END

*DECK SCHKE3
      SUBROUTINE SCHKE3 (ISNUM, SRNAMT, NOUT, KPRINT, FATAL)
C***BEGIN PROLOGUE  SCHKE3
C***SUBSIDIARY
C***PURPOSE  Test the error exits from the Level 3 Blas.
C***LIBRARY   SLATEC (BLAS)
C***AUTHOR  Dongarra, J. J., (ANL)
C           Duff, I., (AERE)
C           Du Croz, J., (NAG)
C           Hammarling, S., (NAG)
C***DESCRIPTION
C
C  Tests the error exits from the Level 3 Blas.
C  ALPHA, BETA, A, X and Y should not need to be defined.
C
C  Auxiliary routine for test program for Level 3 Blas.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  CHKXER, SGEMM, SSYMM, SSYR2K, SSYRK, STRMM, STRSM,
C                    XERCLR, XERDMP, XGETF, XSETF
C***REVISION HISTORY  (YYMMDD)
C   890208  DATE WRITTEN
C   910620  Modified to meet SLATEC code and prologue standards.  (BKS)
C   930701  Name changed from SCHKE5 to SCHKE3.  (BKS)
C***END PROLOGUE  SCHKE3
C     .. Scalar Arguments ..
      LOGICAL            FATAL
      INTEGER            ISNUM, KPRINT, NOUT
      CHARACTER*6        SRNAMT
C     .. Scalars in Common ..
      INTEGER            INFOT
C     .. Local Scalars ..
      REAL               ALPHA, BETA
      INTEGER            KONTRL
C     .. Local Arrays ..
      REAL               A( 1, 1), B( 1, 1), C( 1, 1)
C     .. External Subroutines ..
      EXTERNAL           CHKXER, SGEMM, SSYMM, SSYR2K, SSYRK, STRMM,
     $                   STRSM
C***FIRST EXECUTABLE STATEMENT  SCHKE3
       CALL XGETF (KONTRL)
       IF (KPRINT .LE. 2) THEN
         CALL XSETF(0)
       ELSE
         CALL XSETF(1)
       ENDIF
      GO TO ( 10, 20, 30, 40, 50, 60 )ISNUM
   10 INFOT = 1
      CALL XERCLR
      CALL SGEMM( '/', 'N', 0, 0, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 1
      CALL XERCLR
      CALL SGEMM( '/', 'T', 0, 0, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL SGEMM( 'N', '/', 0, 0, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL SGEMM( 'T', '/', 0, 0, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL SGEMM( 'N', 'N', -1, 0, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL SGEMM( 'N', 'T', -1, 0, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL SGEMM( 'T', 'N', -1, 0, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL SGEMM( 'T', 'T', -1, 0, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL SGEMM( 'N', 'N', 0, -1, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL SGEMM( 'N', 'T', 0, -1, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL SGEMM( 'T', 'N', 0, -1, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL SGEMM( 'T', 'T', 0, -1, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL SGEMM( 'N', 'N', 0, 0, -1, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL SGEMM( 'N', 'T', 0, 0, -1, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL SGEMM( 'T', 'N', 0, 0, -1, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL SGEMM( 'T', 'T', 0, 0, -1, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 8
      CALL XERCLR
      CALL SGEMM( 'N', 'N', 2, 0, 0, ALPHA, A, 1, B, 1, BETA, C, 2 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 8
      CALL XERCLR
      CALL SGEMM( 'N', 'T', 2, 0, 0, ALPHA, A, 1, B, 1, BETA, C, 2 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 8
      CALL XERCLR
      CALL SGEMM( 'T', 'N', 0, 0, 2, ALPHA, A, 1, B, 2, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 8
      CALL XERCLR
      CALL SGEMM( 'T', 'T', 0, 0, 2, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 10
      CALL XERCLR
      CALL SGEMM( 'N', 'N', 0, 0, 2, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 10
      CALL XERCLR
      CALL SGEMM( 'T', 'N', 0, 0, 2, ALPHA, A, 2, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 10
      CALL XERCLR
      CALL SGEMM( 'N', 'T', 0, 2, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 10
      CALL XERCLR
      CALL SGEMM( 'T', 'T', 0, 2, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 13
      CALL XERCLR
      CALL SGEMM( 'N', 'N', 2, 0, 0, ALPHA, A, 2, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 13
      CALL XERCLR
      CALL SGEMM( 'N', 'T', 2, 0, 0, ALPHA, A, 2, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 13
      CALL XERCLR
      CALL SGEMM( 'T', 'N', 2, 0, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 13
      CALL XERCLR
      CALL SGEMM( 'T', 'T', 2, 0, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      GO TO 70
   20 INFOT = 1
      CALL XERCLR
      CALL SSYMM( '/', 'U', 0, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL SSYMM( 'L', '/', 0, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL SSYMM( 'L', 'U', -1, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL SSYMM( 'R', 'U', -1, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL SSYMM( 'L', 'L', -1, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL SSYMM( 'R', 'L', -1, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL SSYMM( 'L', 'U', 0, -1, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL SSYMM( 'R', 'U', 0, -1, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL SSYMM( 'L', 'L', 0, -1, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL SSYMM( 'R', 'L', 0, -1, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL SSYMM( 'L', 'U', 2, 0, ALPHA, A, 1, B, 2, BETA, C, 2 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL SSYMM( 'R', 'U', 0, 2, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL SSYMM( 'L', 'L', 2, 0, ALPHA, A, 1, B, 2, BETA, C, 2 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL SSYMM( 'R', 'L', 0, 2, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL SSYMM( 'L', 'U', 2, 0, ALPHA, A, 2, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL SSYMM( 'R', 'U', 2, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL SSYMM( 'L', 'L', 2, 0, ALPHA, A, 2, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL SSYMM( 'R', 'L', 2, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 12
      CALL XERCLR
      CALL SSYMM( 'L', 'U', 2, 0, ALPHA, A, 2, B, 2, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 12
      CALL XERCLR
      CALL SSYMM( 'R', 'U', 2, 0, ALPHA, A, 1, B, 2, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 12
      CALL XERCLR
      CALL SSYMM( 'L', 'L', 2, 0, ALPHA, A, 2, B, 2, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 12
      CALL XERCLR
      CALL SSYMM( 'R', 'L', 2, 0, ALPHA, A, 1, B, 2, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      GO TO 70
   30 INFOT = 1
      CALL XERCLR
      CALL STRMM( '/', 'U', 'N', 'N', 0, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL STRMM( 'L', '/', 'N', 'N', 0, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL STRMM( 'L', 'U', '/', 'N', 0, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL STRMM( 'L', 'U', 'N', '/', 0, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL STRMM( 'L', 'U', 'N', 'N', -1, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL STRMM( 'L', 'U', 'T', 'N', -1, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL STRMM( 'R', 'U', 'N', 'N', -1, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL STRMM( 'R', 'U', 'T', 'N', -1, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL STRMM( 'L', 'L', 'N', 'N', -1, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL STRMM( 'L', 'L', 'T', 'N', -1, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL STRMM( 'R', 'L', 'N', 'N', -1, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL STRMM( 'R', 'L', 'T', 'N', -1, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL STRMM( 'L', 'U', 'N', 'N', 0, -1, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL STRMM( 'L', 'U', 'T', 'N', 0, -1, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL STRMM( 'R', 'U', 'N', 'N', 0, -1, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL STRMM( 'R', 'U', 'T', 'N', 0, -1, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL STRMM( 'L', 'L', 'N', 'N', 0, -1, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL STRMM( 'L', 'L', 'T', 'N', 0, -1, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL STRMM( 'R', 'L', 'N', 'N', 0, -1, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL STRMM( 'R', 'L', 'T', 'N', 0, -1, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL STRMM( 'L', 'U', 'N', 'N', 2, 0, ALPHA, A, 1, B, 2 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL STRMM( 'L', 'U', 'T', 'N', 2, 0, ALPHA, A, 1, B, 2 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL STRMM( 'R', 'U', 'N', 'N', 0, 2, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL STRMM( 'R', 'U', 'T', 'N', 0, 2, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL STRMM( 'L', 'L', 'N', 'N', 2, 0, ALPHA, A, 1, B, 2 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL STRMM( 'L', 'L', 'T', 'N', 2, 0, ALPHA, A, 1, B, 2 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL STRMM( 'R', 'L', 'N', 'N', 0, 2, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL STRMM( 'R', 'L', 'T', 'N', 0, 2, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 11
      CALL XERCLR
      CALL STRMM( 'L', 'U', 'N', 'N', 2, 0, ALPHA, A, 2, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 11
      CALL XERCLR
      CALL STRMM( 'L', 'U', 'T', 'N', 2, 0, ALPHA, A, 2, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 11
      CALL XERCLR
      CALL STRMM( 'R', 'U', 'N', 'N', 2, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 11
      CALL XERCLR
      CALL STRMM( 'R', 'U', 'T', 'N', 2, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 11
      CALL XERCLR
      CALL STRMM( 'L', 'L', 'N', 'N', 2, 0, ALPHA, A, 2, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 11
      CALL XERCLR
      CALL STRMM( 'L', 'L', 'T', 'N', 2, 0, ALPHA, A, 2, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 11
      CALL XERCLR
      CALL STRMM( 'R', 'L', 'N', 'N', 2, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 11
      CALL XERCLR
      CALL STRMM( 'R', 'L', 'T', 'N', 2, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      GO TO 70
   40 INFOT = 1
      CALL XERCLR
      CALL STRSM( '/', 'U', 'N', 'N', 0, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL STRSM( 'L', '/', 'N', 'N', 0, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL STRSM( 'L', 'U', '/', 'N', 0, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL STRSM( 'L', 'U', 'N', '/', 0, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL STRSM( 'L', 'U', 'N', 'N', -1, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL STRSM( 'L', 'U', 'T', 'N', -1, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL STRSM( 'R', 'U', 'N', 'N', -1, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL STRSM( 'R', 'U', 'T', 'N', -1, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL STRSM( 'L', 'L', 'N', 'N', -1, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL STRSM( 'L', 'L', 'T', 'N', -1, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL STRSM( 'R', 'L', 'N', 'N', -1, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL STRSM( 'R', 'L', 'T', 'N', -1, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL STRSM( 'L', 'U', 'N', 'N', 0, -1, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL STRSM( 'L', 'U', 'T', 'N', 0, -1, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL STRSM( 'R', 'U', 'N', 'N', 0, -1, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL STRSM( 'R', 'U', 'T', 'N', 0, -1, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL STRSM( 'L', 'L', 'N', 'N', 0, -1, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL STRSM( 'L', 'L', 'T', 'N', 0, -1, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL STRSM( 'R', 'L', 'N', 'N', 0, -1, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL STRSM( 'R', 'L', 'T', 'N', 0, -1, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL STRSM( 'L', 'U', 'N', 'N', 2, 0, ALPHA, A, 1, B, 2 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL STRSM( 'L', 'U', 'T', 'N', 2, 0, ALPHA, A, 1, B, 2 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL STRSM( 'R', 'U', 'N', 'N', 0, 2, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL STRSM( 'R', 'U', 'T', 'N', 0, 2, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL STRSM( 'L', 'L', 'N', 'N', 2, 0, ALPHA, A, 1, B, 2 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL STRSM( 'L', 'L', 'T', 'N', 2, 0, ALPHA, A, 1, B, 2 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL STRSM( 'R', 'L', 'N', 'N', 0, 2, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL STRSM( 'R', 'L', 'T', 'N', 0, 2, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 11
      CALL XERCLR
      CALL STRSM( 'L', 'U', 'N', 'N', 2, 0, ALPHA, A, 2, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 11
      CALL XERCLR
      CALL STRSM( 'L', 'U', 'T', 'N', 2, 0, ALPHA, A, 2, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 11
      CALL XERCLR
      CALL STRSM( 'R', 'U', 'N', 'N', 2, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 11
      CALL XERCLR
      CALL STRSM( 'R', 'U', 'T', 'N', 2, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 11
      CALL XERCLR
      CALL STRSM( 'L', 'L', 'N', 'N', 2, 0, ALPHA, A, 2, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 11
      CALL XERCLR
      CALL STRSM( 'L', 'L', 'T', 'N', 2, 0, ALPHA, A, 2, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 11
      CALL XERCLR
      CALL STRSM( 'R', 'L', 'N', 'N', 2, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 11
      CALL XERCLR
      CALL STRSM( 'R', 'L', 'T', 'N', 2, 0, ALPHA, A, 1, B, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      GO TO 70
   50 INFOT = 1
      CALL XERCLR
      CALL SSYRK( '/', 'N', 0, 0, ALPHA, A, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL SSYRK( 'U', '/', 0, 0, ALPHA, A, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL SSYRK( 'U', 'N', -1, 0, ALPHA, A, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL SSYRK( 'U', 'T', -1, 0, ALPHA, A, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL SSYRK( 'L', 'N', -1, 0, ALPHA, A, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL SSYRK( 'L', 'T', -1, 0, ALPHA, A, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL SSYRK( 'U', 'N', 0, -1, ALPHA, A, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL SSYRK( 'U', 'T', 0, -1, ALPHA, A, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL SSYRK( 'L', 'N', 0, -1, ALPHA, A, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL SSYRK( 'L', 'T', 0, -1, ALPHA, A, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL SSYRK( 'U', 'N', 2, 0, ALPHA, A, 1, BETA, C, 2 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL SSYRK( 'U', 'T', 0, 2, ALPHA, A, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL SSYRK( 'L', 'N', 2, 0, ALPHA, A, 1, BETA, C, 2 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL SSYRK( 'L', 'T', 0, 2, ALPHA, A, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 10
      CALL XERCLR
      CALL SSYRK( 'U', 'N', 2, 0, ALPHA, A, 2, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 10
      CALL XERCLR
      CALL SSYRK( 'U', 'T', 2, 0, ALPHA, A, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 10
      CALL XERCLR
      CALL SSYRK( 'L', 'N', 2, 0, ALPHA, A, 2, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 10
      CALL XERCLR
      CALL SSYRK( 'L', 'T', 2, 0, ALPHA, A, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      GO TO 70
   60 INFOT = 1
      CALL XERCLR
      CALL SSYR2K( '/', 'N', 0, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL SSYR2K( 'U', '/', 0, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL SSYR2K( 'U', 'N', -1, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL SSYR2K( 'U', 'T', -1, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL SSYR2K( 'L', 'N', -1, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL SSYR2K( 'L', 'T', -1, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL SSYR2K( 'U', 'N', 0, -1, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL SSYR2K( 'U', 'T', 0, -1, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL SSYR2K( 'L', 'N', 0, -1, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL SSYR2K( 'L', 'T', 0, -1, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL SSYR2K( 'U', 'N', 2, 0, ALPHA, A, 1, B, 1, BETA, C, 2 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL SSYR2K( 'U', 'T', 0, 2, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL SSYR2K( 'L', 'N', 2, 0, ALPHA, A, 1, B, 1, BETA, C, 2 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL SSYR2K( 'L', 'T', 0, 2, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL SSYR2K( 'U', 'N', 2, 0, ALPHA, A, 2, B, 1, BETA, C, 2 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL SSYR2K( 'U', 'T', 0, 2, ALPHA, A, 2, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL SSYR2K( 'L', 'N', 2, 0, ALPHA, A, 2, B, 1, BETA, C, 2 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL SSYR2K( 'L', 'T', 0, 2, ALPHA, A, 2, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 12
      CALL XERCLR
      CALL SSYR2K( 'U', 'N', 2, 0, ALPHA, A, 2, B, 2, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 12
      CALL XERCLR
      CALL SSYR2K( 'U', 'T', 2, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 12
      CALL XERCLR
      CALL SSYR2K( 'L', 'N', 2, 0, ALPHA, A, 2, B, 2, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 12
      CALL XERCLR
      CALL SSYR2K( 'L', 'T', 2, 0, ALPHA, A, 1, B, 1, BETA, C, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
C
   70 IF( KPRINT .GE. 2) THEN
        CALL XERDMP
        IF(.NOT.FATAL) THEN
         WRITE( NOUT, FMT = 9999 )SRNAMT
        ELSE
         WRITE( NOUT, FMT = 9998 )SRNAMT
        ENDIF
      END IF
      CALL XSETF (KONTRL)
      RETURN
C
 9999 FORMAT( ' ', A6, ' PASSED THE TESTS OF ERROR-EXITS' )
 9998 FORMAT( ' ******* ', A6, ' FAILED THE TESTS OF ERROR-EXITS *****',
     $      '**' )
C
C     End of SCHKE3.
C
      END

*DECK EVERCK
      SUBROUTINE EVERCK (LOUT, KPRINT, FAIL)
C***BEGIN PROLOGUE  EVERCK
C***SUBSIDIARY
C***PURPOSE  Test error returns from PCHIP evaluators for PCHQK1.
C***LIBRARY   SLATEC (PCHIP)
C***TYPE      SINGLE PRECISION (EVERCK-S, DEVERK-D)
C***KEYWORDS  PCHIP EVALUATOR QUICK CHECK
C***AUTHOR  Fritsch, F. N., (LLNL)
C***DESCRIPTION
C
C --------- CODE TO TEST ERROR RETURNS FROM PCHIP EVALUATORS. ---------
C
C
C     FORTRAN LIBRARY ROUTINES USED:  (WRITE).
C     SLATEC LIBRARY ROUTINES USED:  CHFDV, CHFEV, PCHFD, PCHFE,
C                                    XERDMP, XGETF, XSETF.
C     OTHER ROUTINES USED:  COMP.
C
C***ROUTINES CALLED  CHFDV, CHFEV, COMP, PCHFD, PCHFE, XERDMP, XGETF,
C                    XSETF
C***REVISION HISTORY  (YYMMDD)
C   820601  DATE WRITTEN
C   820715  CONVERTED TO QUICK CHECK FOR SLATEC LIBRARY.
C   890207  ADDED CALLS TO ERROR HANDLER.
C   890316  Added call to XERDMP if KPRINT.GT.2 (FNF).
C   890629  Appended E0 to real constants to reduce S.P./D.P.
C           differences.
C   890706  Cosmetic changes to prologue.  (WRB)
C   891009  Removed unreferenced statement label.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900309  Added COMP to list of routines called.  (FNF)
C   900315  Revised prologue and improved some output formats.  (FNF)
C   900316  Deleted INCFD tests because some compilers object to them,
C           and made additional minor cosmetic changes.  (FNF)
C   900322  Made miscellaneous cosmetic changes.  (FNF)
C   910708  Minor modifications in use of KPRINT.  (WRB)
C   930504  Removed parens from constants in WRITE statements.  (FNF)
C***END PROLOGUE  EVERCK
C
C  Declare arguments.
C
      INTEGER  LOUT, KPRINT
      LOGICAL  FAIL
C
C  DECLARATIONS.
C
      INTEGER  I, IERR, KONTRL, N, NERR, NEXT(2)
      REAL  D(10), DUM, F(10), TEMP, X(10)
      LOGICAL  COMP, SKIP
C
C  INITIALIZE.
C
      PARAMETER (N = 10)
C***FIRST EXECUTABLE STATEMENT  EVERCK
      NERR = 0
C
      CALL XGETF (KONTRL)
      IF (KPRINT .LE. 2) THEN
         CALL XSETF (0)
      ELSE
         CALL XSETF (1)
      ENDIF
C
      IF (KPRINT .GE. 3)  WRITE (LOUT, 2000)
      IF (KPRINT .GE. 2)  WRITE (LOUT, 5000)
C
C  FIRST, TEST CHFEV AND CHFDV.
C
      IF (KPRINT .GE. 3)  WRITE (LOUT, 5001)  -1
      CALL CHFEV (0.E0, 1.E0, 3.E0, 7.E0, 3.E0, 6.E0, 0, DUM, DUM,
     * NEXT, IERR)
      IF (.NOT. COMP (IERR, -1, LOUT, KPRINT) )  NERR = NERR + 1
C
      IF (KPRINT .GE. 3)  WRITE (LOUT, 5001)  -2
      CALL CHFEV (1.E0, 1.E0, 3.E0, 7.E0, 3.E0, 6.E0, 1, DUM, DUM,
     * NEXT, IERR)
      IF (.NOT. COMP (IERR, -2, LOUT, KPRINT) )  NERR = NERR + 1
C
      IF (KPRINT .GE. 3)  WRITE (LOUT, 5001)  -1
      CALL CHFDV (0.E0, 1.E0, 3.E0, 7.E0, 3.E0, 6.E0, 0, DUM, DUM, DUM,
     * NEXT, IERR)
      IF (.NOT. COMP (IERR, -1, LOUT, KPRINT) )  NERR = NERR + 1
C
      IF (KPRINT .GE. 3)  WRITE (LOUT, 5001)  -2
      CALL CHFDV (1.E0, 1.E0, 3.E0, 7.E0, 3.E0, 6.E0, 1, DUM, DUM, DUM,
     * NEXT, IERR)
      IF (.NOT. COMP (IERR, -2, LOUT, KPRINT) )  NERR = NERR + 1
C
C  SET UP PCH DEFINITION.
C
      DO 10  I = 1, N
         X(I) = I
         F(I) = I + 2
         D(I) = 1.E0
   10 CONTINUE
C
C  SWAP POINTS 4 AND 7, SO X-ARRAY IS OUT OF ORDER.
C
      TEMP = X(4)
      X(4) = X(7)
      X(7) = TEMP
C
C  NOW, TEST PCHFE AND PCHFD.
C
      IF (KPRINT .GE. 3)  WRITE (LOUT, 5001)  -1
      SKIP = .FALSE.
      CALL PCHFE (1, X, F, D, 1, SKIP, 0, DUM, DUM, IERR)
      IF (.NOT. COMP (IERR, -1, LOUT, KPRINT) )  NERR = NERR + 1
C
      IF (KPRINT .GE. 3)  WRITE (LOUT, 5001)  -3
      SKIP = .FALSE.
      CALL PCHFE (N, X, F, D, 1, SKIP, 0, DUM, DUM, IERR)
      IF (.NOT. COMP (IERR, -3, LOUT, KPRINT) )  NERR = NERR + 1
C
      IF (KPRINT .GE. 3)  WRITE (LOUT, 5001)  -4
      SKIP = .TRUE.
      CALL PCHFE (N, X, F, D, 1, SKIP, 0, DUM, DUM, IERR)
      IF (.NOT. COMP (IERR, -4, LOUT, KPRINT) )  NERR = NERR + 1
C
      IF (KPRINT .GE. 3)  WRITE (LOUT, 5001)  -1
      SKIP = .FALSE.
      CALL PCHFD (1, X, F, D, 1, SKIP, 0, DUM, DUM, DUM, IERR)
      IF (.NOT. COMP (IERR, -1, LOUT, KPRINT) )  NERR = NERR + 1
C
      IF (KPRINT .GE. 3)  WRITE (LOUT, 5001)  -3
      SKIP = .FALSE.
      CALL PCHFD (N, X, F, D, 1, SKIP, 0, DUM, DUM, DUM, IERR)
      IF (.NOT. COMP (IERR, -3, LOUT, KPRINT) )  NERR = NERR + 1
C
      IF (KPRINT .GE. 3)  WRITE (LOUT, 5001)  -4
      SKIP = .TRUE.
      CALL PCHFD (N, X, F, D, 1, SKIP, 0, DUM, DUM, DUM, IERR)
      IF (.NOT. COMP (IERR, -4, LOUT, KPRINT) )  NERR = NERR + 1
C
C  SUMMARIZE RESULTS.
C
      IF (KPRINT .GT. 2)  CALL XERDMP
      IF (NERR .EQ. 0)  THEN
         FAIL = .FALSE.
         IF (KPRINT .GE. 2)  WRITE (LOUT, 5002)
      ELSE
         FAIL = .TRUE.
         IF (KPRINT .GE. 2)  WRITE (LOUT, 5003)  NERR
      ENDIF
C
C  TERMINATE.
C
      CALL XSETF (KONTRL)
      RETURN
C
C  FORMATS.
C
 2000 FORMAT ('1'//10X,'TEST ERROR RETURNS')
 5000 FORMAT (//10X,'EVERCK RESULTS'/10X,'--------------')
 5001 FORMAT (/' THIS CALL SHOULD RETURN IERR =',I3)
 5002 FORMAT (/' ALL ERROR RETURNS OK.')
 5003 FORMAT (//' ***** TROUBLE IN EVERCK *****'
     *        //5X,I5,' TESTS FAILED TO GIVE EXPECTED RESULTS.')
C------------- LAST LINE OF EVERCK FOLLOWS -----------------------------
      END

*DECK F1S
      REAL FUNCTION F1S (X)
C***BEGIN PROLOGUE  F1S
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F1S
      REAL X
C***FIRST EXECUTABLE STATEMENT  F1S
      F1S = 0.2E+01/(0.2E+01+SIN(0.314159E+02*X))
      RETURN
      END

*DECK DUIVP
      SUBROUTINE DUIVP (X, Y, YP)
C***BEGIN PROLOGUE  DUIVP
C***PURPOSE  Dummy routine for DBVSUP quick check.
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (UIVP-S, DUIVP-D)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C   This routine is never called;  it is here to prevent loaders from
C   complaining about undefined externals while testing DBVSUP.
C
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890618  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920401  Variables declaration and TYPE sections added.  (WRB)
C***END PROLOGUE  DUIVP
C     .. Scalar Arguments ..
      DOUBLE PRECISION X
C     .. Array Arguments ..
      DOUBLE PRECISION Y(*), YP(*)
C***FIRST EXECUTABLE STATEMENT  DUIVP
      STOP
      END

*DECK DTEST
      SUBROUTINE DTEST (LEN, DCOMP, DTRUE, DSIZE, DFAC, KPRINT)
C***BEGIN PROLOGUE  DTEST
C***PURPOSE  Compare arrays DCOMP and DTRUE.
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (STEST-S, DTEST-D)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Lawson, C. L., (JPL)
C***DESCRIPTION
C
C   This subroutine compares arrays DCOMP and DTRUE of length LEN to
C   see if the term by term differences, multiplied by DFAC, are
C   negligible.  In the case of a significant difference, appropriate
C   messages are written.
C
C***ROUTINES CALLED  D1MACH
C***COMMON BLOCKS    COMBLA
C***REVISION HISTORY  (YYMMDD)
C   741210  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900820  Modified IF test to use function DDIFF and made cosmetic
C           changes to routine.  (WRB)
C   901005  Removed usage of DDIFF in favour of D1MACH.  (RWC)
C   910501  Added TYPE record.  (WRB)
C   920211  Code restructured and information added to the DESCRIPTION
C           section.  (WRB)
C***END PROLOGUE  DTEST
      DOUBLE PRECISION DCOMP(*), DTRUE(*), DSIZE(*), DFAC, DD,
     +       RELEPS, D1MACH
      LOGICAL PASS
      COMMON /COMBLA/ NPRINT, ICASE, N, INCX, INCY, MODE, PASS
      SAVE RELEPS
      DATA RELEPS /0.0D0/
C***FIRST EXECUTABLE STATEMENT  DTEST
      IF (RELEPS .EQ. 0.0D0) RELEPS = D1MACH(4)
      DO 100 I = 1,LEN
        DD = ABS(DCOMP(I)-DTRUE(I))
        IF (DFAC*DD .GT. ABS(DSIZE(I))*RELEPS) THEN
C
C         Here DCOMP(I) is not close to DTRUE(I).
C
          IF (PASS) THEN
C
C           Print FAIL message and header.
C
            PASS = .FALSE.
            IF (KPRINT .GE. 3) THEN
              WRITE (NPRINT,9000)
              WRITE (NPRINT,9010)
            ENDIF
          ENDIF
          IF (KPRINT .GE. 3) WRITE (NPRINT,9020) ICASE, N, INCX, INCY,
     +                       MODE, I, DCOMP(I), DTRUE(I), DD, DSIZE(I)
        ENDIF
  100 CONTINUE
      RETURN
 9000 FORMAT ('+', 39X, 'FAIL')
 9010 FORMAT ('0CASE  N INCX INCY MODE  I', 29X, 'COMP(I)', 29X,
     +        'TRUE(I)', 2X, 'DIFFERENCE', 5X, 'SIZE(I)' / 1X)
 9020 FORMAT (1X, I4, I3, 3I5, I3, 2D36.18, 2D12.4)
      END

*DECK T3
      REAL FUNCTION T3 (X)
C***BEGIN PROLOGUE  T3
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  F3S
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  T3
      REAL A,B,F3S,X,X1,Y
C***FIRST EXECUTABLE STATEMENT  T3
      A = 0.0E+00
      B = 0.5E+01
      X1 = X+0.1E+01
      Y = (B-A)/X1+A
      T3 = (B-A)*F3S(Y)/X1/X1
      RETURN
      END

*DECK TEST12
      PROGRAM TEST12
C***BEGIN PROLOGUE  TEST12
C***PURPOSE  Driver for testing SLATEC subprograms
C***LIBRARY   SLATEC
C***CATEGORY  A3D, C3A2, C7C, C9
C***TYPE      DOUBLE PRECISION (TEST11-S, TEST12-D)
C***KEYWORDS  QUICK CHECK DRIVER
C***AUTHOR  SLATEC Common Mathematical Library Committee
C***DESCRIPTION
C
C *Usage:
C     One input data record is required
C         READ (LIN, '(I1)') KPRINT
C
C *Arguments:
C     KPRINT = 0  Quick checks - No printing.
C                 Driver       - Short pass or fail message printed.
C              1  Quick checks - No message printed for passed tests,
C                                short message printed for failed tests.
C                 Driver       - Short pass or fail message printed.
C              2  Quick checks - Print short message for passed tests,
C                                fuller information for failed tests.
C                 Driver       - Pass or fail message printed.
C              3  Quick checks - Print complete quick check results.
C                 Driver       - Pass or fail message printed.
C
C *Description:
C     Driver for testing SLATEC subprogram
C        DXLEGF   DXNRMP
C
C***REFERENCES  Fong, Kirby W., Jefferson, Thomas H., Suyehiro,
C                 Tokihiko, Walton, Lee, Guidelines to the SLATEC Common
C                 Mathematical Library, March 21, 1989.
C***ROUTINES CALLED  FCNQX2, I1MACH, XERMAX, XSETF, XSETUN
C***REVISION HISTORY  (YYMMDD)
C   901204  DATE WRITTEN
C***END PROLOGUE  TEST12
      INTEGER IPASS, KPRINT, LIN, LUN, NFAIL
C***FIRST EXECUTABLE STATEMENT  TEST12
      LUN = I1MACH(2)
      LIN = I1MACH(1)
      NFAIL = 0
C
C     Read KPRINT parameter
C
      READ (LIN, '(I1)') KPRINT
      CALL XERMAX(1000)
      CALL XSETUN(LUN)
      IF (KPRINT .LE. 1) THEN
         CALL XSETF(0)
      ELSE
         CALL XSETF(1)
      ENDIF
C
C     Test DXLEGF and DXNRMP
C
      CALL FCNQX2 (LUN, KPRINT, IPASS)
      IF (IPASS .EQ. 0) NFAIL = NFAIL + 1
C
C     Write PASS or FAIL message
C
      IF (NFAIL .EQ. 0) THEN
         WRITE (LUN, 9000)
      ELSE
         WRITE (LUN, 9010) NFAIL
      ENDIF
      STOP
 9000 FORMAT (/' --------------TEST12 PASSED ALL TESTS----------------')
 9010 FORMAT (/' ************* WARNING -- ', I5,
     1        ' TEST(S) FAILED IN PROGRAM TEST12  *************')
      END

*DECK QXSSP
      SUBROUTINE QXSSP (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  QXSSP
C***PURPOSE
C***LIBRARY   SLATEC
C***KEYWORDS  QUICK CHECK
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C     *                                                               *
C     *                        F I S H P A K                          *
C     *                                                               *
C     *                                                               *
C     *     A PACKAGE OF FORTRAN SUBPROGRAMS FOR THE SOLUTION OF      *
C     *                                                               *
C     *      SEPARABLE ELLIPTIC PARTIAL DIFFERENTIAL EQUATIONS        *
C     *                                                               *
C     *                  (VERSION  3 , JUNE 1979)                     *
C     *                                                               *
C     *                             BY                                *
C     *                                                               *
C     *        JOHN ADAMS, PAUL SWARZTRAUBER AND ROLAND SWEET         *
C     *                                                               *
C     *                             OF                                *
C     *                                                               *
C     *         THE NATIONAL CENTER FOR ATMOSPHERIC RESEARCH          *
C     *                                                               *
C     *                BOULDER, COLORADO  (80307)  U.S.A.             *
C     *                                                               *
C     *                   WHICH IS SPONSORED BY                       *
C     *                                                               *
C     *              THE NATIONAL SCIENCE FOUNDATION                  *
C     *                                                               *
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C
C
C
C     PROGRAM TO ILLUSTRATE THE USE OF HWSSSP
C
C***ROUTINES CALLED  HWSSSP, PIMACH
C***REVISION HISTORY  (YYMMDD)
C   800103  DATE WRITTEN
C   890718  Changed computation of PI to use PIMACH.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890911  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   901010  Added PASS/FAIL message and cleaned up FORMATs.  (RWC)
C***END PROLOGUE  QXSSP
      DIMENSION F(19,73), BDTF(73), SINT(19), SINP(73), W(1200)
C***FIRST EXECUTABLE STATEMENT  QXSSP
C
C     THE VALUE OF IDIMF IS THE FIRST DIMENSION OF F.  W IS
C     DIMENSIONED 11*(M+1)+6*(N+1)=647 SINCE M=18 AND N=72.
C
      PI = PIMACH(DUM)
      ERMAX=5.E-3
      TS = 0.0
      TF = PI/2.
      M = 18
      MBDCND = 6
      PS = 0.0
      PF = PI+PI
      N = 72
      NBDCND = 0
      ELMBDA = 0.
      IDIMF = 19
C
C     GENERATE SINES FOR USE IN SUBSEQUENT COMPUTATIONS
C
      DTHETA = TF/M
      MP1 = M+1
      DO 101 I=1,MP1
         SINT(I) = SIN((I-1)*DTHETA)
  101 CONTINUE
      DPHI = (PI+PI)/N
      NP1 = N+1
      DO 102 J=1,NP1
         SINP(J) = SIN((J-1)*DPHI)
  102 CONTINUE
C
C     COMPUTE RIGHT SIDE OF EQUATION AND STORE IN F
C
      DO 104 J=1,NP1
         DO 103 I=1,MP1
            F(I,J) = 2.-6.*(SINT(I)*SINP(J))**2
  103    CONTINUE
  104 CONTINUE
C
C     STORE DERIVATIVE DATA AT THE EQUATOR
C
      DO 105 J=1,NP1
         BDTF(J) = 0.
  105 CONTINUE
C
      CALL HWSSSP(TS,TF,M,MBDCND,BDTS,BDTF,PS,PF,N,NBDCND,BDPS,BDPF,
     1             ELMBDA,F,IDIMF,PERTRB,IERROR,W)
C
C     COMPUTE DISCRETIZATION ERROR. SINCE PROBLEM IS SINGULAR, THE
C     SOLUTION MUST BE NORMALIZED.
C
      ERR = 0.0
      DO 107 J=1,NP1
         DO 106 I=1,MP1
            Z = ABS(F(I,J)-(SINT(I)*SINP(J))**2-F(1,1))
            IF (Z .GT. ERR) ERR = Z
  106    CONTINUE
  107 CONTINUE
C
      IPASS = 1
      IF (ERR.GT.ERMAX) IPASS = 0
      IF (KPRINT.EQ.0) RETURN
      IF (KPRINT.GE.2 .OR. IPASS.EQ.0) THEN
         WRITE (LUN,1001) IERROR,ERR,INT(W(1))
         IF (IPASS.EQ.1) THEN
            WRITE (LUN, 1002)
         ELSE
            WRITE (LUN, 1003)
         ENDIF
      ENDIF
      RETURN
C
 1001 FORMAT ('1',20X,'SUBROUTINE HWSSSP EXAMPLE'///
     1        10X,'THE OUTPUT FROM THE NCAR CONTROL DATA 7600 WAS'//
     2        32X,'IERROR = 0'/
     3        18X,'DISCRETIZATION ERROR = 3.38107E-03'/
     4        12X,'REQUIRED LENGTH OF W ARRAY = 600'//
     5        10X,'THE OUTPUT FROM YOUR COMPUTER IS'//
     6        32X,'IERROR =',I2/
     7        18X,'DISCRETIZATION ERROR =',1PE12.5 /
     8        12X,'REQUIRED LENGTH OF W ARRAY =',I4)
 1002 FORMAT (60X,'PASS'/)
 1003 FORMAT (60X,'FAIL'/)
      END

*DECK T2
      REAL FUNCTION T2 (X)
C***BEGIN PROLOGUE  T2
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  F2S
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  T2
      REAL A,B,F2S,X,X1,Y
C***FIRST EXECUTABLE STATEMENT  T2
      A = 0.1E+00
      B = 0.1E+01
      X1 = X+0.1E+01
      Y = (B-A)/X1+A
      T2 = (B-A)*F2S(Y)/X1/X1
      RETURN
      END

*DECK T5
      REAL FUNCTION T5 (X)
C***BEGIN PROLOGUE  T5
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  F5S
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  T5
      REAL A,B,F5S,X,X1,Y
C***FIRST EXECUTABLE STATEMENT  T5
      A = 0.0E+00
      B = 0.1E+01
      X1 = X+0.1E+01
      Y = (B-A)/X1+A
      T5 = (B-A)*F5S(Y)/X1/X1
      RETURN
      END

*DECK ZQCBJ
      SUBROUTINE ZQCBJ (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  ZQCBJ
C***SUBSIDIARY
C***PURPOSE  Quick check for SLATEC subroutine
C            ZBESJ
C***LIBRARY   SLATEC
C***CATEGORY  C10A4
C***TYPE      COMPLEX (CQCBJ-C, ZQCBJ-Z)
C***KEYWORDS  QUICK CHECK, ZBESJ
C***AUTHOR  Amos, Don, (SNL)
C           Goudy, Sue, (SNL)
C           Walton, Lee, (SNL)
C***DESCRIPTION
C
C *Usage:
C
C        INTEGER  LUN, KPRINT, IPASS
C
C        CALL ZQCBJ (LUN, KPRINT, IPASS)
C
C *Arguments:
C
C     LUN    :IN  is the unit number to which output is to be written.
C
C     KPRINT :IN  controls the amount of output, as specified in the
C                 SLATEC Guidelines.
C
C     IPASS  :OUT indicates whether the test passed or failed.
C                 A value of one is good, indicating no failures.
C
C *Description:
C
C                 *** A DOUBLE PRECISION ROUTINE ***
C
C   ZQCBJ is a quick check routine for the complex J Bessel function
C    generated by subroutine ZBESJ.
C
C   ZQCBJ generates sequences of J Bessel functions from ZBESJ
C    and checks them against the evaluation from the formula
C
C            J(FNU,Z) = 0.5*( H(1,FNU,Z) + H(2,FNU,Z) )
C
C    where -PI.lt.arg(Z).le.PI for abs(Z).ge.FNU.
C
C   For abs(Z).lt.FNU, the first N members of a sequence of length
C    N+16 are checked against a corresponding N member sequence where
C    both sequences are generated by ZBESJ beginning at order FNU.
C
C***REFERENCES  Abramowitz, M. and Stegun, I. A., Handbook
C                 of Mathematical Functions, Dover Publications,
C                 New York, 1964.
C               Amos, D. E., A Subroutine Package for Bessel
C                 Functions of a Complex Argument and Nonnegative
C                 Order, SAND85-1018, May, 1985.
C***ROUTINES CALLED  ZBESH, ZBESJ, ZABS, ZEXP, I1MACH, D1MACH
C***REVISION HISTORY  (YYMMDD)
C   830501  DATE WRITTEN
C   890831  Revised to meet new SLATEC standards
C   930122  Added ZEXP to EXTERNAL statement.  (RWC)
C***END PROLOGUE  ZQCBJ
C
C*Internal Notes:
C   Machine constants are defined by functions I1MACH and D1MACH.
C
C   The parameter MQC can have values 1 (the default) for a faster,
C   less definitive test or 2 for a slower, more definitive test.
C
C**End
C
C  Set test complexity parameter.
C
      INTEGER  MQC
      PARAMETER (MQC=1)
C
C  Declare arguments.
C
      INTEGER  LUN, KPRINT, IPASS
C
C  Declare external functions.
C
      INTEGER  I1MACH
      DOUBLE PRECISION  D1MACH, ZABS
      EXTERNAL  I1MACH, D1MACH, ZABS, ZEXP
C
C  Declare local variables.
C
      DOUBLE PRECISION  COE1R,COE1I, COE2R,COE2I, CWR,CWI, HALFR,HALFI,
     *   VR,VI, WR,WI, YR,YI, ZR,ZI
      DOUBLE PRECISION  AA, AB, AER, AI, ALIM, AR, ATOL, AV, CC, CT, DD,
     *   DIG, ELIM, EPS, ER, ERTOL, FILM, FNU, FNUL, GNU, HPI, PI, R,
     *   RL, RM, R1M4, R1M5, R2, SLAK, ST, STR, T, TOL, TS, XNU
      INTEGER  I, ICASE, IERR, IL, IR, IRB, IT, ITL, K, KDO, KEPS, KK,
     *   KODE, K1, K2, LFLG, M, MFLG, N, NL, NU, NUL, NZ, NZ1, NZ2
      DIMENSION  AER(20), KDO(20), KEPS(20), T(20), VR(20), VI(20),
     *   WR(20), WI(20), XNU(20), YR(20), YI(20)
C
C***FIRST EXECUTABLE STATEMENT  ZQCBJ
      IF (KPRINT.GE.2) THEN
        WRITE (LUN,99999)
99999   FORMAT (' QUICK CHECK ROUTINE FOR THE J BESSEL FUNCTION FROM ',
     *     'ZBESJ'/)
      ENDIF
C-----------------------------------------------------------------------
C     Set parameters related to machine constants.
C     TOL is the approximate unit roundoff limited to 1.0D-18.
C     ELIM is the approximate exponential over- and underflow limit.
C     exp(-ELIM).lt.exp(-ALIM)=exp(-ELIM)/TOL    and
C     exp(ELIM).gt.exp(ALIM)=exp(ELIM)*TOL       are intervals near
C     underflow and overflow limits where scaled arithmetic is done.
C     RL is the lower boundary of the asymptotic expansion for large Z.
C     DIG = number of base 10 digits in TOL = 10**(-DIG).
C     FNUL is the lower boundary of the asymptotic series for large FNU.
C-----------------------------------------------------------------------
      R1M4 = D1MACH(4)
      TOL = MAX(R1M4,1.0D-18)
      ATOL = 100.0D0*TOL
      AA = -LOG10(R1M4)
      K1 = I1MACH(12)
      K2 = I1MACH(13)
      R1M5 = D1MACH(5)
      K = MIN(ABS(K1),ABS(K2))
      ELIM = 2.303D0*(K*R1M5-3.0D0)
      AB = AA*2.303D0
      ALIM = ELIM + MAX(-AB,-41.45D0)
      DIG = MIN(AA,18.0D0)
      FNUL = 10.0D0 + 6.0D0*(DIG-3.0D0)
      RL = 1.2D0*DIG + 3.0D0
      SLAK = 3.0D0+4.0D0*(-LOG10(TOL)-7.0D0)/11.0D0
      SLAK = MAX(SLAK,3.0D0)
      ERTOL = TOL*10.0D0**SLAK
      RM = 0.5D0*(ALIM + ELIM)
      RM = MIN(RM,200.0D0)
      RM = MAX(RM,RL+10.0D0)
      R2 = MIN(RM,FNUL)
      IF (KPRINT.GE.2) THEN
        WRITE (LUN,99998)
99998   FORMAT (' PARAMETERS'/
     *     5X,'TOL ',8X,'ELIM',8X,'ALIM',8X,'RL  ',8X,'FNUL',8X,'DIG')
        WRITE (LUN,99997) TOL, ELIM, ALIM, RL, FNUL, DIG
99997   FORMAT (1X,6D12.4/)
      ENDIF
C-----------------------------------------------------------------------
C     Set other constants needed in the tests.
C-----------------------------------------------------------------------
      HALFR = 0.5D0
      HALFI = 0.0D0
      HPI = 2.0D0*ATAN(1.0D0)
      PI = HPI + HPI
C-----------------------------------------------------------------------
C     Generate angles for construction of complex Z to be used in tests.
C-----------------------------------------------------------------------
C     KDO(K), K = 1,IL  determines which of the IL angles in -PI to PI
C     are used to compute values of Z.
C       KDO(K) = 0  means that the index K will be used for one or two
C                   values of Z, depending on the choice of KEPS(K)
C              = 1  means that the index K and the corresponding angle
C                   will be skipped
C     KEPS(K), K = 1,IL determines which of the angles get incremented
C     up and down to put values of Z in regions where different
C     formulae are used.
C       KEPS(K)  = 0  means that the angle will be used without change
C                = 1  means that the angle will be incremented up and
C                   down by EPS
C     The angles to be used are stored in the T(I) array, I = 1,ITL.
C-----------------------------------------------------------------------
      IF (MQC.NE.2) THEN
        NL = 2
        IL = 5
        DO 5 I = 1,IL
          KEPS(I) = 0
          KDO(I) = 0
    5   CONTINUE
        NUL = 5
        XNU(1) = 0.0D0
        XNU(2) = 1.0D0
        XNU(3) = 2.0D0
        XNU(4) = 0.5D0*FNUL
        XNU(5) = FNUL + 1.1D0
      ELSE
        NL = 4
        IL = 13
        DO 6 I = 1,IL
          KDO(I) = 0
          KEPS(I) = 0
    6   CONTINUE
        KDO(2) = 1
        KDO(6) = 1
        KDO(8) = 1
        KDO(12) = 1
        KEPS(3) = 1
        KEPS(4) = 1
        KEPS(5) = 1
        KEPS(9) = 1
        KEPS(10) = 1
        KEPS(11) = 1
        NUL = 6
        XNU(1) = 0.0D0
        XNU(2) = 0.6D0
        XNU(3) = 1.3D0
        XNU(4) = 2.0D0
        XNU(5) = 0.5D0*FNUL
        XNU(6) = FNUL + 1.1D0
      ENDIF
      I = 2
      EPS = 0.01D0
      FILM = IL - 1
      T(1) = -PI + EPS
      DO 30 K = 2,IL
        IF (KDO(K).EQ.0) THEN
          T(I) = PI*(-IL+2*K-1)/FILM
          IF (KEPS(K).EQ.0) THEN
            TS = T(I)
            T(I) = TS - EPS
            I = I + 1
            T(I) = TS + EPS
          ELSE
            I = I + 1
          ENDIF
        ENDIF
   30 CONTINUE
      ITL = I - 1
C-----------------------------------------------------------------------
C     Test values of Z in -PI.lt.arg(Z).le.PI.
C-----------------------------------------------------------------------
      IF (KPRINT.GE.2) THEN
        WRITE (LUN,99996)
99996   FORMAT (' CHECKS IN THE (Z,FNU) SPACE'/)
      ENDIF
      LFLG = 0
      DO 260 KODE = 1,2
        DO 250 N = 1,NL
          DO 240 NU = 1,NUL
            FNU = XNU(NU)
            DO 230 ICASE = 1,3
              IRB = MIN(2,ICASE)
              DO 220 IR = IRB,4
C-------------- switch (icase)
                GO TO (50, 60, 70), ICASE
   50           CONTINUE
                  R = (EPS*(4-IR)+2.0D0*(IR-1))/3.0D0
                  GO TO 80
   60           CONTINUE
                  R = (2.0D0*(4-IR)+R2*(IR-1))/3.0D0
                  GO TO 80
   70           CONTINUE
                  IF (R2.GE.RM) GO TO 230
                  R = (R2*(4-IR)+RM*(IR-1))/3.0D0
   80           CONTINUE
C-------------- end switch
                GNU = FNU + (N-1)
                DO 210 IT = 1,ITL
                  CT = COS(T(IT))
                  ST = SIN(T(IT))
                  IF (ABS(CT).LT.ATOL) CT = 0.0D0
                  IF (ABS(ST).LT.ATOL) ST = 0.0D0
                  ZR = R*CT
                  ZI = R*ST
                  IF (R.GE.GNU) THEN
C------------------ Cases for abs(Z).ge.FNU+N-1
                    CALL ZBESJ(ZR, ZI, FNU, KODE, N, VR, VI, NZ, IERR)
C------------------ Underflow - skip test for this case.
                    IF (NZ.NE.0) GO TO 210
                    CALL ZBESH(ZR, ZI, FNU, KODE, 1, N, WR, WI, NZ1,
     *                 IERR)
                    CALL ZBESH(ZR, ZI, FNU, KODE, 2, N, YR, YI, NZ2,
     *                 IERR)
                    IF (KODE.EQ.2) THEN
C-------------------- Adjust scaling of H functions.
                      CC = -ZI - ABS(ZI)
                      IF (CC.GT.(-ALIM)) THEN
                        CWR = CC
                        CWI = ZR
                        CALL ZEXP(CWR, CWI, COE1R, COE1I)
                      ELSE
                        COE1R = 0.0D0
                        COE1I = 0.0D0
                      ENDIF
                      DD = ZI - ABS(ZI)
                      IF (DD.GT.(-ALIM)) THEN
                        CWR = DD
                        CWI = -ZR
                        CALL ZEXP(CWR, CWI, COE2R, COE2I)
                      ELSE
                        COE2R = 0.0D0
                        COE2I = 0.0D0
                      ENDIF
                      DO 130 KK = 1,N
                        STR = YR(KK)*COE2R - YI(KK)*COE2I
                        YI(KK) = YR(KK)*COE2I + YI(KK)*COE2R
                        YR(KK) = STR
                        STR = WR(KK)*COE1R - WI(KK)*COE1I
                        WI(KK) = WR(KK)*COE1I + WI(KK)*COE1R
                        WR(KK) = STR
  130                 CONTINUE
                    ENDIF
                  ELSE
C------------------ Cases for abs(Z).lt.FNU+N-1
                    M = N + 16
                    CALL ZBESJ(ZR, ZI, FNU, KODE, M, VR, VI, NZ, IERR)
C------------------ Underflow at end of sequence - skip test
                    IF (NZ.GT.10) GO TO 210
                    CALL ZBESJ(ZR, ZI, FNU, KODE, N, WR, WI, NZ, IERR)
                    DO 150 KK = 1,N
                      YR(KK) = WR(KK)
                      YI(KK) = WI(KK)
  150               CONTINUE
                  ENDIF
C-----------------------------------------------------------------------
C     If abs(Z).ge.FNU+N-1 then the error test compares J(Z<FNU) with
C     0.5*(H1(Z,FNU) + H2(Z,FNU)).
C     If abs(Z).lt.FNU+N-1 then the error test ensures that calculations
C     begun in one region of the (Z,FNU) plane and carried into another
C     region do not diverge from calculations carried out entirely in
C     one region.  This is an internal consistency check.
C-----------------------------------------------------------------------
                  MFLG = 0
                  DO 190 I = 1,N
                    AB = FNU + I - 1
                    AA = MAX(2.0D0,AB)
                    CWR = (WR(I)+YR(I))*HALFR - (WI(I)+YI(I))*HALFI
                    CWI = (WR(I)+YR(I))*HALFI + (WI(I)+YI(I))*HALFR
                    AV = ZABS(VR(I),VI(I))
                    AR = CWR - VR(I)
                    AI = CWI - VI(I)
                    ER = ZABS(AR,AI)
                    IF (AV.NE.0.0D0) THEN
                      IF (ZI.EQ.0.0D0) THEN
                        IF (DABS(ZR).LT.AA) ER = ER/AV
                      ELSE
                        ER = ER/AV
                      ENDIF
                    ENDIF
                    AER(I) = ER
                    IF (ER.GT.ERTOL) MFLG = 1
  190             CONTINUE
                  IF (MFLG.NE.0) THEN
                    IF (LFLG.EQ.0) THEN
                      IF (KPRINT.GE.2) THEN
                        WRITE (LUN,99995) ERTOL
99995                   FORMAT (' CASES WHICH VIOLATE THE RELATIVE ',
     *                     'ERROR TEST WITH ERTOL=', D12.4/)
                        WRITE (LUN,99994)
99994                   FORMAT (' INPUT TO ZBESJ   Z, FNU, KODE, N')
                      ENDIF
                      IF (KPRINT.GE.3) THEN
                        IF (R.GE.GNU) THEN
                          WRITE (LUN,99993)
99993                     FORMAT (' COMPARE WITH AVERAGE OF H1 AND H2 ',
     *                       'FUNCTIONS FOR THE SAME INPUT')
                          WRITE (LUN,99992)
99992                     FORMAT (' RESULTS FROM ZBESJ    NZ, V(KK)')
                          WRITE (LUN,99991)
99991                     FORMAT (' RESULTS FROM ZBESH   NZ1, W(KK)')
                          WRITE (LUN,99990)
99990                     FORMAT (' RESULTS FROM ZBESH   NZ2, Y(KK)')
                        ELSE
                          WRITE (LUN,99989)
99989                     FORMAT (' RESULTS FROM ZBESJ    NZ, W(KK)')
                        ENDIF
                        WRITE (LUN,99988)
99988                   FORMAT (' TEST CASE INDICES   IR, IT, ICASE'/)
                      ENDIF
                    ENDIF
                    LFLG = LFLG + 1
                    IF (KPRINT.GE.2) THEN
                      WRITE (LUN,99987) ZR, ZI, FNU, KODE, N
99987                 FORMAT ('   INPUT:   Z=',2D12.4,3X,'FNU=',D12.4,
     *                   3X,'KODE=',I3,3X,'N=',I3)
                    ENDIF
                    IF (KPRINT.GE.3) THEN
                      WRITE (LUN,99986) (AER(K),K=1,N)
99986                 FORMAT ('   ERROR:   AER(K)=',4D12.4)
                      IF (R.GE.GNU) THEN
                        KK = MAX(NZ1,NZ2) + 1
                        KK = MIN(N,KK)
                        WRITE (LUN,99985) NZ, VR(KK), VI(KK)
99985                   FORMAT (' RESULTS:   NZ=',I3,3X,'V(KK)=',2D12.4)
                        WRITE (LUN,99984) NZ1, WR(KK), WI(KK)
99984                   FORMAT (' RESULTS:  NZ1=',I3,3X,'W(KK)=',2D12.4)
                        WRITE (LUN,99983) NZ2, YR(KK), YI(KK)
99983                   FORMAT (' RESULTS:  NZ2=',I3,3X,'Y(KK)=',2D12.4)
                      ELSE
                        KK = N - NZ
                        WRITE (LUN,99982) NZ, WR(KK), WI(KK)
99982                   FORMAT (' RESULTS:   NZ=',I3,3X,'W(KK)=',2D12.4)
                      ENDIF
                      WRITE (LUN,99981) IR, IT, ICASE
99981                 FORMAT ('    CASE:  IR=',I3,3X,'IT=',I3,3X,
     *                   'ICASE=',I3/)
                    ENDIF
                  ENDIF
  210           CONTINUE
  220         CONTINUE
  230       CONTINUE
  240     CONTINUE
  250   CONTINUE
  260 CONTINUE
      IF (KPRINT.GE.2) THEN
        IF (LFLG.EQ.0) THEN
          WRITE (LUN,99980)
99980     FORMAT (' QUICK CHECKS OK')
        ELSE
          WRITE (LUN,99979) LFLG
99979     FORMAT (' ***',I5,' FAILURE(S) FOR ZBESJ IN THE (Z,FNU)',
     *       ' PLANE')
        ENDIF
      ENDIF
      IPASS=0
      IF (LFLG.EQ.0) THEN
        IPASS=1
      ENDIF
      IF (IPASS.EQ.1.AND.KPRINT.GE.2) THEN
        WRITE (LUN,99978)
99978   FORMAT (/' ****** ZBESJ  PASSED ALL TESTS  ******'/)
      ENDIF
      IF (IPASS.EQ.0.AND.KPRINT.GE.1) THEN
        WRITE (LUN,99977)
99977   FORMAT (/' ****** ZBESJ  FAILED SOME TESTS ******'/)
      ENDIF
      RETURN
      END

*DECK PCHQK4
      SUBROUTINE PCHQK4 (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  PCHQK4
C***PURPOSE  Test the PCHIP monotonicity checker PCHCM.
C***LIBRARY   SLATEC (PCHIP)
C***TYPE      SINGLE PRECISION (PCHQK4-S, DPCHQ4-D)
C***KEYWORDS  PCHIP MONOTONICITY CHECKER QUICK CHECK
C***AUTHOR  Fritsch, F. N., (LLNL)
C***DESCRIPTION
C
C              PCHIP QUICK CHECK NUMBER 4
C
C     TESTS THE MONOTONICITY CHECKER:  PCHCM.
C *Usage:
C
C        INTEGER  LUN, KPRINT, IPASS
C
C        CALL PCHQK4 (LUN, KPRINT, IPASS)
C
C *Arguments:
C
C     LUN   :IN  is the unit number to which output is to be written.
C
C     KPRINT:IN  controls the amount of output, as specified in the
C                SLATEC Guidelines.
C
C     IPASS:OUT  will contain a pass/fail flag.  IPASS=1 is good.
C                IPASS=0 indicates one or more tests failed.
C
C *Description:
C
C   This routine tests a constructed data set with three different
C   INCFD settings and compares with the expected results.  It then
C   runs a special test to check for bug in overall monotonicity found
C   in PCHMC.  Finally, it reverses the data and repeats all tests.
C
C***ROUTINES CALLED  PCHCM
C***REVISION HISTORY  (YYMMDD)
C   890208  DATE WRITTEN
C   890306  Changed LOUT to LUN and added it to call list.  (FNF)
C   890316  Removed DATA statements to suit new quick check standards.
C   890410  Changed PCHMC to PCHCM.
C   890410  Added a SLATEC 4.0 format prologue.
C   900314  Changed name from PCHQK3 to PCHQK4 and improved some output
C           formats.
C   900315  Revised prologue and improved some output formats.  (FNF)
C   900321  Removed IFAIL from call sequence for SLATEC standards and
C           made miscellaneous cosmetic changes.  (FNF)
C   900322  Added declarations so all variables are declared.  (FNF)
C   910708  Minor modifications in use of KPRINT.  (WRB)
C   930317  Improved output formats.  (FNF)
C***END PROLOGUE  PCHQK4
C
C*Internal Notes:
C
C     Data set-up is done via assignment statements to avoid modifying
C     DATA-loaded arrays, as required by the 1989 SLATEC Guidelines.
C     Run with KPRINT=3 to display the data.
C**End
C
C  Declare arguments.
C
      INTEGER  LUN, KPRINT, IPASS
C
C  DECLARE VARIABLES.
C
      INTEGER  MAXN, MAXN2, MAXN3, NB
      PARAMETER  (MAXN = 16,  MAXN2 = 8,  MAXN3 = 6,  NB = 7)
      INTEGER  I, IERR, IFAIL, INCFD, ISMEX1(MAXN), ISMEX2(MAXN2),
     *         ISMEX3(MAXN3), ISMEXB(NB), ISMON(MAXN), K, N, NS(3)
      REAL  D(MAXN), DB(NB), F(MAXN), FB(NB), X(MAXN)
      LOGICAL  SKIP
C
C  DEFINE EXPECTED RESULTS.
C
      DATA  ISMEX1 / 1, 1,-1, 1, 1,-1, 1, 1,-1, 1, 1,-1, 1, 1,-1, 2/
      DATA  ISMEX2 / 1, 2, 2, 1, 2, 2, 1, 2/
      DATA  ISMEX3 / 1, 1, 1, 1, 1, 1/
      DATA  ISMEXB / 1, 3, 1, -1, -3, -1, 2/
C
C  DEFINE TEST DATA.
C
      DATA  NS /16, 8, 6/
C
C***FIRST EXECUTABLE STATEMENT  PCHQK4
      IF (KPRINT .GE. 3)  WRITE (LUN, 1000)
      IF (KPRINT .GE. 2)  WRITE (LUN, 1001)
C
C       Define X, F, D.
      DO 1  I = 1, MAXN
         X(I) = I
         D(I) = 0.E0
    1 CONTINUE
      DO 2  I = 2, MAXN, 3
         D(I) = 2.E0
    2 CONTINUE
      DO 3  I = 1, 3
         F(I) = X(I)
         F(I+ 3) = F(I  ) + 1.E0
         F(I+ 6) = F(I+3) + 1.E0
         F(I+ 9) = F(I+6) + 1.E0
         F(I+12) = F(I+9) + 1.E0
    3 CONTINUE
      F(16) = 6.E0
C       Define FB, DB.
      FB(1) = 0.E0
      FB(2) = 2.E0
      FB(3) = 3.E0
      FB(4) = 5.E0
      DB(1) = 1.E0
      DB(2) = 3.E0
      DB(3) = 3.E0
      DB(4) = 0.E0
      DO 4  I = 1, 3
         FB(NB-I+1) =  FB(I)
         DB(NB-I+1) = -DB(I)
    4 CONTINUE
C
C  INITIALIZE.
C
      IFAIL = 0
C
      IF (KPRINT .GE. 3)  THEN
         WRITE (LUN, 1002)
         DO 10  I = 1, NB
            WRITE (LUN, 1010)  I, X(I), F(I), D(I), FB(I), DB(I)
   10    CONTINUE
         DO 20  I = NB+1, MAXN
            WRITE (LUN, 1010)  I, X(I), F(I), D(I)
   20    CONTINUE
      ENDIF
C
C  TRANSFER POINT FOR SECOND SET OF TESTS.
C
   25 CONTINUE
C
C  Loop over a series of values of INCFD.
C
      DO 30  INCFD = 1, 3
         N = NS(INCFD)
         SKIP = .FALSE.
C        -------------------------------------------------
         CALL PCHCM (N, X, F, D, INCFD, SKIP, ISMON, IERR)
C        -------------------------------------------------
         IF (KPRINT.GE.3)
     *      WRITE (LUN, 2000)  INCFD, IERR, (ISMON(I), I=1,N)
         IF ( IERR.NE.0 )  THEN
            IFAIL = IFAIL + 1
            IF (KPRINT.GE.3)  WRITE (LUN,2001)
         ELSE
            DO 29  I = 1, N
               IF (INCFD.EQ.1)  THEN
                  IF ( ISMON(I).NE.ISMEX1(I) )  THEN
                     IFAIL = IFAIL + 1
                     IF (KPRINT.GE.3)
     *                  WRITE (LUN, 2002)  (ISMEX1(K),K=1,N)
                     GO TO 30
                  ENDIF
               ELSE IF (INCFD.EQ.2) THEN
                  IF ( ISMON(I).NE.ISMEX2(I) )  THEN
                     IFAIL = IFAIL + 1
                     IF (KPRINT.GE.3)
     *                  WRITE (LUN, 2002)  (ISMEX2(K),K=1,N)
                     GO TO 30
                  ENDIF
               ELSE
                  IF ( ISMON(I).NE.ISMEX3(I) )  THEN
                     IFAIL = IFAIL + 1
                     IF (KPRINT.GE.3)
     *                  WRITE (LUN, 2002)  (ISMEX3(K),K=1,N)
                     GO TO 30
                  ENDIF
               ENDIF
   29       CONTINUE
         ENDIF
   30 CONTINUE
C
C  Test for -1,3,1 bug.
C
      SKIP = .FALSE.
C     ------------------------------------------------
      CALL PCHCM (NB, X, FB, DB, 1, SKIP, ISMON, IERR)
C     ------------------------------------------------
      IF (KPRINT.GE.3)
     *   WRITE (LUN, 2030)  IERR, (ISMON(I), I=1,NB)
      IF ( IERR.NE.0 )  THEN
         IFAIL = IFAIL + 1
         IF (KPRINT.GE.3)  WRITE (LUN,2001)
      ELSE
         DO 34  I = 1, NB
            IF ( ISMON(I).NE.ISMEXB(I) )  THEN
               IFAIL = IFAIL + 1
               IF (KPRINT.GE.3)
     *            WRITE (LUN, 2002)  (ISMEXB(K),K=1,NB)
               GO TO 35
            ENDIF
   34    CONTINUE
      ENDIF
   35 CONTINUE
C
      IF (F(1).LT.0.)  GO TO 90
C
C  Change sign and do again.
C
      IF (KPRINT.GE.3)  WRITE (LUN, 2050)
      DO 40  I = 1, MAXN
         F(I) = -F(I)
         D(I) = -D(I)
         IF ( ISMEX1(I).NE.2 )  ISMEX1(I) = -ISMEX1(I)
   40 CONTINUE
      DO 42  I = 1, MAXN2
         IF ( ISMEX2(I).NE.2 )  ISMEX2(I) = -ISMEX2(I)
   42 CONTINUE
      DO 43  I = 1, MAXN3
         IF ( ISMEX3(I).NE.2 )  ISMEX3(I) = -ISMEX3(I)
   43 CONTINUE
      DO 50  I = 1, NB
         FB(I) = -FB(I)
         DB(I) = -DB(I)
         IF ( ISMEXB(I).NE.2 )  ISMEXB(I) = -ISMEXB(I)
   50 CONTINUE
      GO TO 25
C
C  PRINT SUMMARY AND TERMINATE.
C
   90 CONTINUE
      IF ((KPRINT.GE.2).AND.(IFAIL.NE.0))  WRITE (LUN, 3001)  IFAIL
C
      IF (IFAIL.EQ.0)  THEN
         IPASS = 1
         IF (KPRINT.GE.2) WRITE(LUN,99998)
      ELSE
         IPASS = 0
         IF (KPRINT.GE.1) WRITE(LUN,99999)
      ENDIF
C
      RETURN
C
C  FORMATS.
C
 1000 FORMAT ('1'//10X,'TEST PCHIP MONOTONICITY CHECKER')
 1001 FORMAT (//10X,'PCHQK4 RESULTS'/10X,'--------------')
 1002 FORMAT (// 5X,'DATA:'
     *        // 9X,'I',4X,'X',5X,'F',5X,'D',5X,'FB',4X,'DB')
 1010 FORMAT (5X,I5,5F6.1)
 2000 FORMAT (/4X,'INCFD =',I2,':  IERR =',I3/15X,'ISMON =',16I3)
 2001 FORMAT (' *** Failed -- bad IERR value.')
 2002 FORMAT (' *** Failed -- expect:',16I3)
 2030 FORMAT (/4X,' Bug test:  IERR =',I3/15X,'ISMON =',7I3)
 2050 FORMAT (/4X,'Changing sign of data.....')
 3001 FORMAT (/' *** TROUBLE ***',I5,' MONOTONICITY TESTS FAILED.')
99998 FORMAT (/' ------------  PCHIP PASSED  ALL MONOTONICITY TESTS',
     *        ' ------------')
99999 FORMAT (/' ************  PCHIP FAILED SOME MONOTONICITY TESTS',
     *        ' ************')
C------------- LAST LINE OF PCHQK4 FOLLOWS -----------------------------
      END

*DECK F4S
      REAL FUNCTION F4S (X)
C***BEGIN PROLOGUE  F4S
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F4S
      REAL X
C***FIRST EXECUTABLE STATEMENT  F4S
      IF(X.EQ..33E+00) GO TO 10
      F4S = ABS(X-0.33E+00)**(-0.999E+00)
      RETURN
   10 F4S=0.0
      RETURN
      END

*DECK QC6A
      SUBROUTINE QC6A (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  QC6A
C***PURPOSE  Test subroutine AAAAAA.
C***LIBRARY   SLATEC
C***TYPE      ALL (QC6A-A)
C***AUTHOR  Boland, W. Robert, (LANL)
C***DESCRIPTION
C
C *Usage:
C
C        INTEGER  LUN, KPRINT, IPASS
C
C        CALL  QC6A (LUN, KPRINT, IPASS)
C
C *Arguments:
C
C     LUN   :IN  is the unit number to which output is to be written.
C
C     KPRINT:IN  controls the amount of output, as specified in the
C                SLATEC Guidelines.
C
C     IPASS:OUT  indicates whether the test passed or failed.
C                A value of one is good, indicating no failures.
C
C *Description:
C
C   This routine tests the SLATEC routine AAAAAA to see if the version
C   number in the SLATEC library source is the same as the quick check
C   version number.
C
C***ROUTINES CALLED  AAAAAA
C***REVISION HISTORY  (YYMMDD)
C   890713  DATE WRITTEN
C   921215  Updated for Version 4.0.  (WRB)
C   930701  Updated for Version 4.1.  (WRB)
C***END PROLOGUE  QC6A
C
C*Internal Notes:
C
C     Data set-up is done via a PARAMETER statement.
C
C**End
C
C  Declare arguments.
C
      INTEGER  LUN, KPRINT, IPASS
C
C  DECLARE VARIABLES.
C
      CHARACTER * 16 VER, VERSN
      PARAMETER  (VERSN = ' 4.1')
C
C***FIRST EXECUTABLE STATEMENT  QC6A
      IF (KPRINT.GE.3) WRITE (LUN, 9000)
      CALL AAAAAA (VER)
      IF (VER .EQ. VERSN) THEN
         IPASS = 1
         IF (KPRINT .GE. 3) THEN
            WRITE (LUN, 9010)
            WRITE (LUN, 9020) VER
         ENDIF
      ELSE
         IPASS = 0
         IF (KPRINT .GE. 3) WRITE (LUN, 9010)
         IF (KPRINT .GE. 2) WRITE (LUN, 9030) VER, VERSN
      ENDIF
C
C     Terminate.
C
      IF (KPRINT.GE.2 .AND. IPASS.EQ.1) WRITE (LUN, 90000)
      IF (KPRINT.GE.1 .AND. IPASS.EQ.0) WRITE (LUN, 90010)
      RETURN
C
C     Formats.
C
 9000 FORMAT ('1' // ' CODE TO TEST SLATEC ROUTINE AAAAAA')
 9010 FORMAT (/ ' QC6A RESULTS')
 9020 FORMAT (' *** Passed -- version number = ', A16)
 9030 FORMAT (' *** Failed -- version number from AAAAAA = ', A16,
     +        ' but expected version number = ', A16)
90000 FORMAT(/' ************QC6A   PASSED  ALL TESTS ****************')
90010 FORMAT(/' ************QC6A   FAILED SOME TESTS ****************')
C------------- LAST LINE OF QC6A FOLLOWS -----------------------------
      END

*DECK DT3
      DOUBLE PRECISION FUNCTION DT3 (X)
C***BEGIN PROLOGUE  DT3
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  DF3S
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  DT3
      DOUBLE PRECISION A,B,DF3S,X,X1,Y
C***FIRST EXECUTABLE STATEMENT  DT3
      A = 0.0D+00
      B = 0.5D+01
      X1 = X+0.1D+01
      Y = (B-A)/X1+A
      DT3 = (B-A)*DF3S(Y)/X1/X1
      RETURN
      END

*DECK DPCHQ2
      SUBROUTINE DPCHQ2 (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  DPCHQ2
C***PURPOSE  Test the PCHIP integrators DPCHIA and DPCHID.
C***LIBRARY   SLATEC (PCHIP)
C***TYPE      DOUBLE PRECISION (PCHQK2-S, DPCHQ2-D)
C***KEYWORDS  PCHIP INTEGRATOR QUICK CHECK
C***AUTHOR  Fritsch, F. N., (LLNL)
C***DESCRIPTION
C
C             DPCHIP QUICK CHECK NUMBER 2
C
C     TESTS THE INTEGRATORS:  DPCHIA, DPCHID.
C *Usage:
C
C        INTEGER  LUN, KPRINT, IPASS
C
C        CALL DPCHQ2 (LUN, KPRINT, IPASS)
C
C *Arguments:
C
C     LUN   :IN  is the unit number to which output is to be written.
C
C     KPRINT:IN  controls the amount of output, as specified in the
C                SLATEC Guidelines.
C
C     IPASS:OUT  will contain a pass/fail flag.  IPASS=1 is good.
C                IPASS=0 indicates one or more tests failed.
C
C *Description:
C
C   This routine constructs data from a cubic, integrates it with DPCHIA
C   and compares the results with the correct answer.
C   Since DPCHIA calls DPCHID, this tests both integrators.
C
C***ROUTINES CALLED  D1MACH, DPCHIA
C***REVISION HISTORY  (YYMMDD)
C   820601  DATE WRITTEN
C   890306  Changed IPASS to the more accurate name IFAIL.  (FNF)
C   890316  1. Removed IMPLICIT statement.                  (FNF)
C           2. Eliminated unnecessary variable N1.          (FNF)
C           3. Miscellaneous cosmetic changes.              (FNF)
C   891004  Cosmetic changes to prologue.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900314  Improved some output formats.  (FNF)
C   900315  Revised prologue and improved some output formats.  (FNF)
C   900316  Additional minor cosmetic changes.  (FNF)
C   900321  Removed IFAIL from call sequence for SLATEC standards and
C           made miscellaneous cosmetic changes.  (FNF)
C   900323  Corrected list of routines called.  (FNF)
C   901130  Added 1P's to formats; changed to allow KPRINT.gt.3.  (FNF)
C   910708  Minor modifications in use of KPRINT.  (WRB)
C   930317  Improved output formats.  (FNF)
C***END PROLOGUE  DPCHQ2
C
C  Declare arguments.
C
      INTEGER  LUN, KPRINT, IPASS
C
C  DECLARE VARIABLES.
C
      INTEGER  I, IEREXP(17), IERR, IFAIL, N, NPAIRS
      DOUBLE PRECISION
     *      A(17), B(17), CALC, D(7), ERRMAX, ERROR, F(7), MACHEP,
     *      ONE, THREE, THRQTR, TOL, TRUE, TWO, X(7)
      LOGICAL  FAIL, SKIP
C
C  DECLARE EXTERNALS.
C
      DOUBLE PRECISION  DPCHIA, D1MACH
C
C  DEFINE TEST FUNCTIONS.
C
      DOUBLE PRECISION AX, FCN, DERIV, ANTDER
      FCN(AX) = THREE*AX*AX*(AX-TWO)
      DERIV(AX) = THREE*AX*(TWO*(AX-TWO) + AX)
      ANTDER(AX) = AX**3 * (THRQTR*AX - TWO)
C
C  INITIALIZE.
C
      DATA  THRQTR /0.75D0/,  ONE /1.D0/,  TWO /2.D0/,  THREE /3.D0/
      DATA  N /7/
      DATA  X /-4.D0, -2.D0, -0.9D0, 0.D0, 0.9D0, 2.D0, 4.D0/
      DATA  NPAIRS /17/
      DATA  A /-3.0D0, 3.0D0,-0.5D0,-0.5D0,-0.5D0,-4.0D0,-4.0D0, 3.0D0,
     *  -5.0D0,-5.0D0,-6.0D0, 6.0D0,-1.5D0,-1.5D0,-3.0D0, 3.0D0, 0.5D0/
      DATA  B / 3.0D0,-3.0D0, 1.0D0, 2.0D0, 5.0D0,-0.5D0, 4.0D0, 5.0D0,
     *  -3.0D0, 5.0D0,-5.0D0, 5.0D0,-0.5D0,-1.0D0,-2.5D0, 3.5D0, 0.5D0/
      DATA  IEREXP /0,0,0,0,2,0,0,2,1,3,3,3,0,0,0,0,0/
C
C  SET PASS/FAIL TOLERANCE.
C
C***FIRST EXECUTABLE STATEMENT  DPCHQ2
      MACHEP = D1MACH(4)
      TOL = 100.D0*MACHEP
C
C  SET UP PCH FUNCTION DEFINITION.
C
      DO 10  I = 1, N
         F(I) =   FCN(X(I))
         D(I) = DERIV(X(I))
   10 CONTINUE
C
      IF (KPRINT .GE. 3)  WRITE (LUN, 1000)
      IF (KPRINT .GE. 2)  WRITE (LUN, 1001)
      IF (KPRINT .GE. 3)  WRITE (LUN, 1002)  (X(I), F(I), D(I), I=1,N)
C
C  LOOP OVER (A,B)-PAIRS.
C
      IF (KPRINT .GE. 3)  WRITE (LUN, 2000)
C
      IFAIL = 0
C
      SKIP = .FALSE.
      DO 20  I = 1, NPAIRS
C               ---------------------------------------------
         CALC = DPCHIA (N, X, F, D, 1, SKIP, A(I), B(I), IERR)
C               ---------------------------------------------
         IF (IERR .GE. 0)  THEN
            FAIL = IERR .NE. IEREXP(I)
            TRUE = ANTDER(B(I)) - ANTDER(A(I))
            ERROR = CALC - TRUE
            IF (KPRINT .GE. 3)  THEN
               IF (FAIL)  THEN
                 WRITE (LUN, 2001) A(I), B(I), IERR, TRUE, CALC, ERROR,
     *                                          IEREXP(I)
               ELSE
                 WRITE (LUN, 2002) A(I), B(I), IERR, TRUE, CALC, ERROR
               ENDIF
            ENDIF
C
            ERROR = ABS(ERROR) / MAX(ONE, ABS(TRUE))
            IF (FAIL .OR. (ERROR.GT.TOL))  IFAIL = IFAIL + 1
            IF (I .EQ. 1)  THEN
               ERRMAX = ERROR
            ELSE
               ERRMAX = MAX(ERRMAX, ERROR)
            ENDIF
         ELSE
            IF (KPRINT .GE. 3)  WRITE (LUN, 2002)  A(I), B(I), IERR
            IFAIL = IFAIL + 1
         ENDIF
   20 CONTINUE
C
C  PRINT SUMMARY.
C
      IF (KPRINT .GE. 2)  THEN
         WRITE (LUN, 2003)  ERRMAX, TOL
         IF (IFAIL .NE. 0)  WRITE (LUN, 3001)  IFAIL
      ENDIF
C
C  TERMINATE.
C
      IF (IFAIL.EQ.0)  THEN
         IPASS = 1
         IF (KPRINT.GE.2) WRITE(LUN,99998)
      ELSE
         IPASS = 0
         IF (KPRINT.GE.1) WRITE(LUN,99999)
      ENDIF
C
      RETURN
C
C  FORMATS.
C
 1000 FORMAT ('1'//10X,'TEST DPCHIP INTEGRATORS')
 1001 FORMAT (//10X,'DPCHQ2 RESULTS'/10X,'--------------')
 1002 FORMAT (// 5X,'DATA:' //11X,'X',9X,'F',9X,'D' /(5X,3F10.3) )
 2000 FORMAT (// 5X,'TEST RESULTS:'
     *        //'    A     B    ERR     TRUE',16X,'CALC',15X,'ERROR')
 2001 FORMAT (2F6.1,I5,1P,2D20.10,D15.5,'  (',I1,') *****' )
 2002 FORMAT (2F6.1,I5,1P,2D20.10,D15.5)
 2003 FORMAT (/'  MAXIMUM RELATIVE ERROR IS:',1P,D15.5,
     *                       ',   TOLERANCE:',1P,D15.5)
 3001 FORMAT (/' *** TROUBLE ***',I5,' INTEGRATION TESTS FAILED.')
99998 FORMAT (/' ------------ DPCHIP PASSED  ALL INTEGRATION TESTS',
     *        ' ------------')
99999 FORMAT (/' ************ DPCHIP FAILED SOME INTEGRATION TESTS',
     *        ' ************')
C------------- LAST LINE OF DPCHQ2 FOLLOWS -----------------------------
      END

*DECK FCN1
      SUBROUTINE FCN1 (IFLAG, M, N, X, FVEC, FJAC, LDFJAC)
C***BEGIN PROLOGUE  FCN1
C***PURPOSE  Subsidiary to SNLS1Q.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (FCN1-S, DFCN1-D)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C   Subroutine which evaluates the function for test program
C   used in quick check of SNLS1E.
C
C   Numerical approximation of Jacobian is used.
C
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   890911  Removed unnecessary intrinsics.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   930214  TYPE and declarations sections added.  (WRB)
C***END PROLOGUE  FCN1
C     .. Scalar Arguments ..
      REAL FJAC
      INTEGER IFLAG, LDFJAC, M, N
C     .. Array Arguments ..
      REAL FVEC(*), X(*)
C     .. Local Scalars ..
      REAL TEMP, TWO
      INTEGER I
C     .. Intrinsic Functions ..
      INTRINSIC EXP
C     .. Data statements ..
      DATA TWO /2.0E0/
C***FIRST EXECUTABLE STATEMENT  FCN1
      IF (IFLAG .NE. 1) RETURN
      DO 10 I = 1,M
        TEMP = I
        FVEC(I) = TWO + TWO*TEMP - EXP(TEMP*X(1)) - EXP(TEMP*X(2))
   10 CONTINUE
      RETURN
      END

*DECK FCN3
      SUBROUTINE FCN3 (IFLAG, M, N, X, FVEC, FJROW, NROW)
C***BEGIN PROLOGUE  FCN3
C***PURPOSE  Subsidiary to SNLS1Q.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (FCN3-S, DFCN3-D)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C   Subroutine to evaluate the Jacobian, one row at a time, for
C   test problem used in quick check of SNLS1E.
C
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890911  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   930214  TYPE and declarations sections added and code polished.
C           (WRB)
C***END PROLOGUE  FCN3
C     .. Scalar Arguments ..
      INTEGER IFLAG, M, N, NROW
C     .. Array Arguments ..
      REAL FJROW(*), FVEC(*), X(*)
C     .. Local Scalars ..
      REAL TEMP, TWO
      INTEGER I
C     .. Intrinsic Functions ..
      INTRINSIC EXP
C     .. Data statements ..
      DATA TWO /2.0E0/
C***FIRST EXECUTABLE STATEMENT  FCN3
      IF (IFLAG .EQ. 0) RETURN
C
C     Should we evaluate functions or Jacobian?
C
      IF (IFLAG .EQ. 1) THEN
C
C       Evaluate functions.
C
        DO 10 I = 1,M
          TEMP = I
          FVEC(I) = TWO + TWO*TEMP - EXP(TEMP*X(1)) - EXP(TEMP*X(2))
   10   CONTINUE
      ELSE
C
C       Evaluate one row of Jacobian.
C
        IF (IFLAG .NE. 3) RETURN
        TEMP = NROW
        FJROW(1) = -TEMP*EXP(TEMP*X(1))
        FJROW(2) = -TEMP*EXP(TEMP*X(2))
      ENDIF
      RETURN
      END

*DECK SCHK32
      SUBROUTINE SCHK32 (SNAME, EPS, THRESH, NOUT, KPRINT, FATAL, NIDIM,
     $   IDIM, NKB, KB, NINC, INC, NMAX, INCMAX, A, AA, AS, X, XX, XS,
     $   XT, G, Z)
C***BEGIN PROLOGUE  SCHK32
C***SUBSIDIARY
C***PURPOSE  Quick check for STRMV, STBMV, STPMV, STRSV, STBSV and
C            STPSV.
C***LIBRARY   SLATEC (BLAS)
C***KEYWORDS  BLAS, QUICK CHECK SERVICE ROUTINE
C***AUTHOR  Du Croz, J. (NAG)
C           Hanson, R. J. (SNLA)
C***DESCRIPTION
C
C  Quick check for STRMV, STBMV, STPMV, STRSV, STBSV and STPSV.
C
C  Auxiliary routine for test program for Level 2 Blas.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  LSE, LSERES, NUMXER, SMAKE2, SMVCH, STBMV, STBSV,
C                    STPMV, STPSV, STRMV, STRSV
C***REVISION HISTORY  (YYMMDD)
C   870810  DATE WRITTEN
C   910619  Modified to meet SLATEC code and prologue standards.  (BKS)
C***END PROLOGUE  SCHK32
C     .. Parameters ..
      REAL               ZERO, HALF, ONE
      PARAMETER          ( ZERO = 0.0, HALF = 0.5, ONE = 1.0 )
C     .. Scalar Arguments ..
      LOGICAL            FATAL
      REAL               EPS, THRESH
      INTEGER            INCMAX, KPRINT, NIDIM, NINC, NKB, NMAX, NOUT
      CHARACTER*6        SNAME
C     .. Array Arguments ..
      REAL               A( NMAX, NMAX ), AA( NMAX*NMAX ),
     $                   AS( NMAX*NMAX ), G( NMAX ), X( NMAX ),
     $                   XS( NMAX*INCMAX ), XT( NMAX ),
     $                   XX( NMAX*INCMAX ), Z( NMAX )
      INTEGER            IDIM( NIDIM ), INC( NINC ), KB( NKB )
C     .. Local Scalars ..
      REAL               ERR, ERRMAX, TRANSL
      INTEGER            I, ICD, ICT, ICU, IK, IN, INCX, INCXS, IX, K,
     $                   KS, LAA, LDA, LDAS, LX, N, NARGS, NC, NK, NS,
     $                   NERR
      LOGICAL            BANDED, FTL, FULL, NULL, PACKED, RESET
      CHARACTER*1        DIAG, DIAGS, TRANS, TRANSS, UPLO, UPLOS
      CHARACTER*2        ICHD, ICHU
      CHARACTER*3        ICHT
C     .. Local Arrays ..
      LOGICAL            ISAME( 13 )
C     .. External Functions ..
      INTEGER            NUMXER
      LOGICAL            LSE, LSERES
      EXTERNAL           LSE, LSERES, NUMXER
C     .. External Subroutines ..
      EXTERNAL           SMAKE2, SMVCH, STBMV, STBSV, STPMV, STPSV,
     $                   STRMV, STRSV
C     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX
C     .. Data statements ..
      DATA               ICHU/'UL'/, ICHT/'NTC'/, ICHD/'UN'/
C***FIRST EXECUTABLE STATEMENT  SCHK32
      FULL = SNAME( 3: 3 ).EQ.'R'
      BANDED = SNAME( 3: 3 ).EQ.'B'
      PACKED = SNAME( 3: 3 ).EQ.'P'
C     Define the number of arguments.
      IF( FULL )THEN
         NARGS = 8
      ELSE IF( BANDED )THEN
         NARGS = 9
      ELSE IF( PACKED )THEN
         NARGS = 7
      END IF
C
      NC = 0
      RESET = .TRUE.
      ERRMAX = ZERO
C     Set up zero vector for SMVCH.
      DO 10 I = 1, NMAX
         Z( I ) = ZERO
   10 CONTINUE
C
      DO 110 IN = 1, NIDIM
         N = IDIM( IN )
C
         IF( BANDED )THEN
            NK = NKB
         ELSE
            NK = 1
         END IF
         DO 100 IK = 1, NK
            IF( BANDED )THEN
               K = KB( IK )
            ELSE
               K = N - 1
            END IF
C           Set LDA to 1 more than minimum value if room.
            IF( BANDED )THEN
               LDA = K + 1
            ELSE
               LDA = N
            END IF
            IF( LDA.LT.NMAX )
     $         LDA = LDA + 1
C           Skip tests if not enough room.
            IF( LDA.GT.NMAX )
     $         GO TO 100
            IF( PACKED )THEN
               LAA = ( N*( N + 1 ) )/2
            ELSE
               LAA = LDA*N
            END IF
            NULL = N.LE.0
C
            DO 90 ICU = 1, 2
               UPLO = ICHU( ICU: ICU )
C
               DO 80 ICT = 1, 3
                  TRANS = ICHT( ICT: ICT )
C
                  DO 70 ICD = 1, 2
                     DIAG = ICHD( ICD: ICD )
C
C                    Generate the matrix A.
C
                     TRANSL = ZERO
                     CALL SMAKE2( SNAME( 2: 3 ), UPLO, DIAG, N, N, A,
     $                           NMAX, AA, LDA, K, K, RESET, TRANSL )
C
                     DO 60 IX = 1, NINC
                        INCX = INC( IX )
                        LX = ABS( INCX )*N
C
C                       Generate the vector X.
C
                        TRANSL = HALF
                        CALL SMAKE2( 'GE', ' ', ' ', 1, N, X, 1, XX,
     $                              ABS( INCX ), 0, N - 1, RESET,
     $                              TRANSL )
                        IF( N.GT.1 )THEN
                           X( N/2 ) = ZERO
                           XX( 1 + ABS( INCX )*( N/2 - 1 ) ) = ZERO
                        END IF
C
                        NC = NC + 1
C
C                       Save every datum before calling the subroutine.
C
                        UPLOS = UPLO
                        TRANSS = TRANS
                        DIAGS = DIAG
                        NS = N
                        KS = K
                        DO 20 I = 1, LAA
                           AS( I ) = AA( I )
   20                   CONTINUE
                        LDAS = LDA
                        DO 30 I = 1, LX
                           XS( I ) = XX( I )
   30                   CONTINUE
                        INCXS = INCX
C
C                       Call the subroutine.
C
                        IF( SNAME( 4: 5 ).EQ.'MV' )THEN
                           IF( FULL )THEN
                              CALL STRMV( UPLO, TRANS, DIAG, N, AA, LDA,
     $                                    XX, INCX )
                           ELSE IF( BANDED )THEN
                              CALL STBMV( UPLO, TRANS, DIAG, N, K, AA,
     $                                    LDA, XX, INCX )
                           ELSE IF( PACKED )THEN
                              CALL STPMV( UPLO, TRANS, DIAG, N, AA, XX,
     $                                    INCX )
                           END IF
                        ELSE IF( SNAME( 4: 5 ).EQ.'SV' )THEN
                           IF( FULL )THEN
                              CALL STRSV( UPLO, TRANS, DIAG, N, AA, LDA,
     $                                    XX, INCX )
                           ELSE IF( BANDED )THEN
                              CALL STBSV( UPLO, TRANS, DIAG, N, K, AA,
     $                                    LDA, XX, INCX )
                           ELSE IF( PACKED )THEN
                              CALL STPSV( UPLO, TRANS, DIAG, N, AA, XX,
     $                                    INCX )
                           END IF
                        END IF
C
C                       Check if error-exit was taken incorrectly.
C
                        IF (NUMXER(NERR) .NE. 0) THEN
                           IF (KPRINT .GE. 2) THEN
                             WRITE( NOUT, FMT = 9992 )
                           ENDIF
                           FATAL = .TRUE.
                        END IF
C
C                       See what data changed inside subroutines.
C
                        ISAME( 1 ) = UPLO.EQ.UPLOS
                        ISAME( 2 ) = TRANS.EQ.TRANSS
                        ISAME( 3 ) = DIAG.EQ.DIAGS
                        ISAME( 4 ) = NS.EQ.N
                        IF( FULL )THEN
                           ISAME( 5 ) = LSE( AS, AA, LAA )
                           ISAME( 6 ) = LDAS.EQ.LDA
                           IF( NULL )THEN
                              ISAME( 7 ) = LSE( XS, XX, LX )
                           ELSE
                              ISAME( 7 ) = LSERES( 'GE', ' ', 1, N, XS,
     $                                     XX, ABS( INCX ) )
                           END IF
                           ISAME( 8 ) = INCXS.EQ.INCX
                        ELSE IF( BANDED )THEN
                           ISAME( 5 ) = KS.EQ.K
                           ISAME( 6 ) = LSE( AS, AA, LAA )
                           ISAME( 7 ) = LDAS.EQ.LDA
                           IF( NULL )THEN
                              ISAME( 8 ) = LSE( XS, XX, LX )
                           ELSE
                              ISAME( 8 ) = LSERES( 'GE', ' ', 1, N, XS,
     $                                     XX, ABS( INCX ) )
                           END IF
                           ISAME( 9 ) = INCXS.EQ.INCX
                        ELSE IF( PACKED )THEN
                           ISAME( 5 ) = LSE( AS, AA, LAA )
                           IF( NULL )THEN
                              ISAME( 6 ) = LSE( XS, XX, LX )
                           ELSE
                              ISAME( 6 ) = LSERES( 'GE', ' ', 1, N, XS,
     $                                     XX, ABS( INCX ) )
                           END IF
                           ISAME( 7 ) = INCXS.EQ.INCX
                        END IF
C
C                       If data was incorrectly changed, report and
C                       return.
C
                        DO 40 I = 1, NARGS
                          IF (.NOT. ISAME( I )) THEN
                            FATAL = .TRUE.
                            IF (KPRINT .GE. 2) THEN
                              WRITE( NOUT, FMT = 9998 )I
                            ENDIF
                          ENDIF
  40                    CONTINUE
C
                        FTL = .FALSE.
                        IF( .NOT.NULL )THEN
                           IF( SNAME( 4: 5 ).EQ.'MV' )THEN
C
C                             Check the result.
C
                              CALL SMVCH( TRANS, N, N, ONE, A, NMAX, X,
     $                                    INCX, ZERO, Z, INCX, XT, G,
     $                                    XX, EPS, ERR, FTL, NOUT,
     $                                    .TRUE., KPRINT )
                           ELSE IF( SNAME( 4: 5 ).EQ.'SV' )THEN
C
C                             Compute approximation to original vector.
C
                              DO 50 I = 1, N
                                 Z( I ) = XX( 1 + ( I - 1 )*
     $                                    ABS( INCX ) )
                                 XX( 1 + ( I - 1 )*ABS( INCX ) )
     $                              = X( I )
   50                         CONTINUE
                              CALL SMVCH( TRANS, N, N, ONE, A, NMAX, Z,
     $                                    INCX, ZERO, X, INCX, XT, G,
     $                                    XX, EPS, ERR, FTL, NOUT,
     $                                    .FALSE., KPRINT )
                           END IF
                           ERRMAX = MAX( ERRMAX, ERR )
                        END IF
                        IF (FTL) THEN
                          FATAL = .TRUE.
                          IF (KPRINT .GE. 3) THEN
                            WRITE( NOUT, FMT = 9996 )SNAME
                            IF( FULL )THEN
                               WRITE( NOUT, FMT = 9993 )NC, SNAME,
     $                          UPLO, TRANS, DIAG, N,
     $                          LDA, INCX
                            ELSE IF( BANDED )THEN
                               WRITE( NOUT, FMT = 9994 )NC, SNAME,
     $                          UPLO, TRANS, DIAG, N,
     $                          K, LDA, INCX
                            ELSE IF( PACKED )THEN
                               WRITE( NOUT, FMT = 9995 )NC, SNAME,
     $                          UPLO, TRANS, DIAG, N,
     $                          INCX
                            END IF
                          ENDIF
                        ENDIF
C
   60                CONTINUE
C
   70             CONTINUE
C
   80          CONTINUE
C
   90       CONTINUE
C
  100    CONTINUE
C
  110 CONTINUE
C
C     Report result.
C
      IF (.NOT. (FATAL)) THEN
        IF (KPRINT .GE. 3) THEN
          IF( ERRMAX.LT.THRESH )THEN
             WRITE( NOUT, FMT = 9999 )SNAME, NC
          ELSE
             WRITE( NOUT, FMT = 9997 )SNAME, NC, ERRMAX
          END IF
        ENDIF
      ENDIF
      RETURN
C
 9999 FORMAT( ' ', A6, ' PASSED THE COMPUTATIONAL TESTS (', I6, ' CALL',
     $      'S)' )
 9998 FORMAT( ' ******* FATAL ERROR - PARAMETER NUMBER ', I2, ' WAS CH',
     $      'ANGED INCORRECTLY *******' )
 9997 FORMAT( ' ', A6, ' COMPLETED THE COMPUTATIONAL TESTS (', I6, ' C',
     $      'ALLS)', /' ******* BUT WITH MAXIMUM TEST RATIO', F8.2,
     $      ' - SUSPECT *******' )
 9996 FORMAT( ' ******* ', A6, ' FAILED ON CALL NUMBER:' )
 9995 FORMAT( 1X, I6, ': ', A6, '(', 3( '''', A1, ''',' ), I3, ', AP, ',
     $      'X,', I2, ')                        .' )
 9994 FORMAT( 1X, I6, ': ', A6, '(', 3( '''', A1, ''',' ), 2( I3, ',' ),
     $      ' A,', I3, ', X,', I2, ')                 .' )
 9993 FORMAT( 1X, I6, ': ', A6, '(', 3( '''', A1, ''',' ), I3, ', A,',
     $      I3, ', X,', I2, ')                     .' )
 9992 FORMAT( ' ******* FATAL ERROR - ERROR-EXIT TAKEN ON VALID CALL *',
     $      '******' )
C
C     End of SCHK32.
C
      END

*DECK QXGBUN
      SUBROUTINE QXGBUN (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  QXGBUN
C***PURPOSE
C***LIBRARY   SLATEC
C***KEYWORDS  QUICK CHECK
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C     *                                                               *
C     *                        F I S H P A K                          *
C     *                                                               *
C     *                                                               *
C     *     A PACKAGE OF FORTRAN SUBPROGRAMS FOR THE SOLUTION OF      *
C     *                                                               *
C     *      SEPARABLE ELLIPTIC PARTIAL DIFFERENTIAL EQUATIONS        *
C     *                                                               *
C     *                  (VERSION  3 , JUNE 1979)                     *
C     *                                                               *
C     *                             BY                                *
C     *                                                               *
C     *        JOHN ADAMS, PAUL SWARZTRAUBER AND ROLAND SWEET         *
C     *                                                               *
C     *                             OF                                *
C     *                                                               *
C     *         THE NATIONAL CENTER FOR ATMOSPHERIC RESEARCH          *
C     *                                                               *
C     *                BOULDER, COLORADO  (80307)  U.S.A.             *
C     *                                                               *
C     *                   WHICH IS SPONSORED BY                       *
C     *                                                               *
C     *              THE NATIONAL SCIENCE FOUNDATION                  *
C     *                                                               *
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C
C     PROGRAM TO ILLUSTRATE THE USE OF SUBROUTINE GENBUN
C
C***ROUTINES CALLED  GENBUN, PIMACH
C***REVISION HISTORY  (YYMMDD)
C   750701  DATE WRITTEN
C   890718  Changed computation of PI to use PIMACH.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   891009  Removed unreferenced variable.  (WRB)
C   891009  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   901010  Added PASS/FAIL message and cleaned up FORMATs.  (RWC)
C***END PROLOGUE  QXGBUN
      DIMENSION F(25,130), A(20), B(20), C(20), W(1200), X(20), Y(120)
C***FIRST EXECUTABLE STATEMENT  QXGBUN
C
C     FROM DIMENSION STATEMENT WE GET VALUE OF IDIMY.  ALSO NOTE THAT
C     W(.) IS DIMENSIONED 6*N + 5*M.
C
      ERMAX=1.E-2
      IDIMY = 25
      MPEROD = 1
      M = 20
      DELTAX = 1.0E0/M
      NPEROD = 0
      N = 120
      PI = PIMACH(DUM)
      DELTAY = 2.0E0*PI/N
C
C     GENERATE AND STORE GRID POINTS FOR THE PURPOSE OF COMPUTING
C     COEFFICIENTS AND RIGHT SIDE OF EQUATION.
C
      DO 100 I=1,M
         X(I) = (I-1)*DELTAX
  100    CONTINUE
      DO 105 J=1,N
         Y(J) = -PI + (J-1)*DELTAY
  105    CONTINUE
C
C     GENERATE COEFFICIENTS.
C
      S = (DELTAY/DELTAX)**2
      T = S*DELTAX
      A(1) = 0.
      B(1) = -2.0E0*S
      C(1) = 2.0E0*S
      DO 110 I=2,M
         A(I) = (1.+X(I))**2*S + (1.+X(I))*T
         C(I) = (1.+X(I))**2*S - (1.+X(I))*T
         B(I) = -2.0E0*(1.0E0+X(I))**2*S
  110    CONTINUE
      C(M) = 0.
C
C     GENERATE RIGHT SIDE OF EQUATION FOR I = 1 SHOWING INTRODUCTION OF
C     BOUNDARY DATA.
C
      DYSQ = DELTAY**2
      DO 115 J=1,N
         F(1,J) = DYSQ*(11. + 8./DELTAX)*SIN(Y(J))
  115    CONTINUE
C
C     GENERATE RIGHT SIDE.
C
      MM1 = M-1
      DO 125 I=2,MM1
         DO 120 J=1,N
            F(I,J) = DYSQ*3.*(1.+X(I))**4*SIN(Y(J))
  120       CONTINUE
  125    CONTINUE
C
C     GENERATE RIGHT SIDE FOR I = M SHOWING INTRODUCTION OF
C     BOUNDARY DATA.
C
      DO 130 J=1,N
         F(M,J) = DYSQ*(3.*(1.+X(M))**4 - 16.*((1.+X(M))/DELTAX)**2
     +                + 16.*(1.+X(M))/DELTAX)*SIN(Y(J))
  130    CONTINUE
      CALL GENBUN(NPEROD,N,MPEROD,M,A,B,C,IDIMY,F,IERROR,W)
C
C     COMPUTE DISCRETIZATION ERROR.  THE EXACT SOLUTION IS
C                   U(X,Y) = (1+X)**4*SIN(Y)
C
      ERR = 0.
      DO 140 I=1,M
         DO 135 J=1,N
            Z = ABS(F(I,J)-(1.+X(I))**4*SIN(Y(J)))
            IF (Z .GT. ERR) ERR = Z
  135       CONTINUE
  140    CONTINUE
C
      IPASS = 1
      IF (ERR.GT.ERMAX) IPASS = 0
      IF (KPRINT.EQ.0) RETURN
      IF (KPRINT.GE.2 .OR. IPASS.EQ.0) THEN
         WRITE (LUN,1001) IERROR, ERR, INT(W(1))
         IF (IPASS.EQ.1) THEN
            WRITE (LUN, 1002)
         ELSE
            WRITE (LUN, 1003)
         ENDIF
      ENDIF
      RETURN
C
 1001 FORMAT ('1',20X,'SUBROUTINE GENBUN EXAMPLE'///
     1        10X,'THE OUTPUT FROM THE NCAR CONTROL DATA 7600 WAS'//
     2        32X,'IERROR = 0'/
     3        18X,'DISCRETIZATION ERROR = 7.94113E-03'/
     4        12X,'REQUIRED LENGTH OF W ARRAY = 740'//
     5        10X,'THE OUTPUT FROM YOUR COMPUTER IS'//
     6        32X,'IERROR =',I2/
     7        18X,'DISCRETIZATION ERROR =',1PE12.5/
     8        12X,'REQUIRED LENGTH OF W ARRAY =',I4)
 1002 FORMAT (60X,'PASS'/)
 1003 FORMAT (60X,'FAIL'/)
      END

*DECK DPCHQ3
      SUBROUTINE DPCHQ3 (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  DPCHQ3
C***PURPOSE  Test the PCHIP interpolators DPCHIC, DPCHIM, DPCHSP.
C***LIBRARY   SLATEC (PCHIP)
C***TYPE      DOUBLE PRECISION (PCHQK3-S, DPCHQ3-D)
C***KEYWORDS  PCHIP INTERPOLATOR QUICK CHECK
C***AUTHOR  Fritsch, F. N., (LLNL)
C***DESCRIPTION
C
C             DPCHIP QUICK CHECK NUMBER 3
C
C     TESTS THE INTERPOLATORS:  DPCHIC, DPCHIM, DPCHSP.
C *Usage:
C
C        INTEGER  LUN, KPRINT, IPASS
C
C        CALL DPCHQ3 (LUN, KPRINT, IPASS)
C
C *Arguments:
C
C     LUN   :IN  is the unit number to which output is to be written.
C
C     KPRINT:IN  controls the amount of output, as specified in the
C                SLATEC Guidelines.
C
C     IPASS:OUT  will contain a pass/fail flag.  IPASS=1 is good.
C                IPASS=0 indicates one or more tests failed.
C
C *Description:
C
C   This routine interpolates a constructed data set with all three
C   DPCHIP interpolators and compares the results with those obtained
C   on a Cray X/MP.  Two different values of the DPCHIC parameter SWITCH
C   are used.
C
C *Remarks:
C     1. The Cray results are given only to nine significant figures,
C        so don't expect them to match to more.
C     2. The results will depend to some extent on the accuracy of
C        the EXP function.
C
C***ROUTINES CALLED  COMP, D1MACH, DPCHIC, DPCHIM, DPCHSP
C***REVISION HISTORY  (YYMMDD)
C   900309  DATE WRITTEN
C   900314  Converted to a subroutine and added a SLATEC 4.0 prologue.
C   900315  Revised prologue and improved some output formats.  (FNF)
C   900316  Made TOLD machine-dependent and added extra output when
C           KPRINT=3.  (FNF)
C   900320  Added E0's to DATA statement for X to reduce single/double
C           differences, and other minor cosmetic changes.
C   900320  Converted to double precision.
C   900321  Removed IFAIL from call sequence for SLATEC standards and
C           made miscellaneous cosmetic changes.  (FNF)
C   900322  Minor changes to reduce single/double differences.  (FNF)
C   900530  Tolerance (TOLD) and argument to DPCHIC changed.  (WRB)
C   900802  Modified TOLD formula and constants in DPCHIC calls to
C           correct DPCHQ3 failures.  (FNF)
C   901130  Several significant changes:  (FNF)
C           1. Changed comparison between DPCHIM and DPCHIC to only
C              require agreement to machine precision.
C           2. Revised to print more output when KPRINT=3.
C           3. Added 1P's to formats.
C   910708  Minor modifications in use of KPRINT.  (WRB)
C   930317  Improved output formats.  (FNF)
C***END PROLOGUE  DPCHQ3
C
C*Internal Notes:
C
C     TOLD is used to compare with stored Cray results.  Its value
C          should be consistent with significance of stored values.
C     TOLZ is used for cases in which exact equality is expected.
C     TOL  is used for cases in which agreement to machine precision
C          is expected.
C**End
C
C  Declare arguments.
C
      INTEGER  LUN, KPRINT, IPASS
      LOGICAL  COMP
      DOUBLE PRECISION  D1MACH
C
C  Declare variables.
C
      INTEGER  I, IC(2), IERR, IFAIL, N, NBAD, NBADZ, NWK
      PARAMETER  (N = 9,  NWK = 2*N)
      DOUBLE PRECISION  D(N), DC(N), DC5, DC6, DM(N), DS(N), ERR, F(N),
     *                MONE, TOL, TOLD, TOLZ, VC(2), X(N), WK(NWK), ZERO
      PARAMETER  (ZERO = 0.0D0,  MONE = -1.0D0)
      CHARACTER*6  RESULT
C
C  Initialize.
C
C       Data.
      DATA  IC /0, 0/
      DATA  X /-2.2D0,-1.2D0,-1.0D0,-0.5D0,-0.01D0, 0.5D0, 1.0D0,
     *          2.0D0, 2.2D0/
C
C       Results generated on Cray X/MP (9 sign. figs.)
      DATA  DM / 0.            , 3.80027352D-01, 7.17253009D-01,
     *           5.82014161D-01, 0.            ,-5.68208031D-01,
     *          -5.13501618D-01,-7.77910977D-02,-2.45611117D-03/
      DATA  DC5,DC6 / 1.76950158D-02,-5.69579814D-01/
      DATA  DS /-5.16830792D-02, 5.71455855D-01, 7.40530225D-01,
     *           7.63864934D-01, 1.92614386D-02,-7.65324380D-01,
     *          -7.28209035D-01,-7.98445427D-02,-2.85983446D-02/
C
C***FIRST EXECUTABLE STATEMENT  DPCHQ3
      IFAIL = 0
C
C        Set tolerances.
      TOL  = 10*D1MACH(4)
      TOLD = MAX( 1.0D-7, 10*TOL )
      TOLZ = ZERO
C
      IF (KPRINT .GE. 3)  WRITE (LUN, 1000)
      IF (KPRINT .GE. 2)  WRITE (LUN, 1001)
C
C  Set up data.
C
      DO 10  I = 1, N
         F(I) = EXP(-X(I)**2)
   10 CONTINUE
C
      IF (KPRINT .GE. 3)  THEN
         WRITE (LUN, 1002)
         DO 12  I = 1, 4
            WRITE (LUN, 1010)  X(I), F(I), DM(I), DS(I)
   12    CONTINUE
            WRITE (LUN, 1011)  X(5), F(5), DM(5), DC5, DS(5)
            WRITE (LUN, 1011)  X(6), F(6), DM(6), DC6, DS(6)
         DO 15  I = 7, N
            WRITE (LUN, 1010)  X(I), F(I), DM(I), DS(I)
   15    CONTINUE
      ENDIF
C
C  Test DPCHIM.
C
      IF (KPRINT.GE.3)  WRITE (LUN, 2000) 'IM'
C     --------------------------------
      CALL DPCHIM (N, X, F, D, 1, IERR)
C     --------------------------------
C        Expect IERR=1 (one monotonicity switch).
      IF ( KPRINT.GE.3 )  WRITE (LUN, 2001) 1
      IF ( .NOT.COMP (IERR, 1, LUN, KPRINT) )  THEN
         IFAIL = IFAIL + 1
      ELSE
         IF ( KPRINT.GE.3 )  WRITE (LUN, 2002)
         NBAD = 0
         NBADZ = 0
         DO 20  I = 1, N
            RESULT = '  OK'
C             D-values should agree with stored values.
C               (Zero values should agree exactly.)
            IF ( DM(I).EQ.ZERO )  THEN
               ERR = ABS( D(I) )
               IF ( ERR.GT.TOLZ )  THEN
                  NBADZ = NBADZ + 1
                  RESULT = '**BADZ'
               ENDIF
            ELSE
               ERR = ABS( (D(I)-DM(I))/DM(I) )
               IF ( ERR.GT.TOLD )  THEN
                  NBAD = NBAD + 1
                  RESULT = '**BAD'
               ENDIF
            ENDIF
            IF (KPRINT.GE.3)
     *         WRITE (LUN, 2003)  I, X(I), D(I), ERR, RESULT
   20    CONTINUE
         IF ( (NBADZ.NE.0).OR.(NBAD.NE.0) )  THEN
            IFAIL = IFAIL + 1
            IF ((NBADZ.NE.0).AND.(KPRINT.GE.2))
     *         WRITE (LUN, 2004)  NBAD
            IF ((NBAD.NE.0).AND.(KPRINT.GE.2))
     *         WRITE (LUN, 2005)  NBAD, 'IM', TOLD
         ELSE
            IF (KPRINT.GE.2)  WRITE (LUN, 2006)  'IM'
         ENDIF
      ENDIF
C
C  Test DPCHIC -- options set to reproduce DPCHIM.
C
      IF (KPRINT.GE.3)  WRITE (LUN, 2000) 'IC'
C     --------------------------------------------------------
      CALL DPCHIC (IC, VC, ZERO, N, X, F, DC, 1, WK, NWK, IERR)
C     --------------------------------------------------------
C        Expect IERR=0 .
      IF ( KPRINT.GE.3 )  WRITE (LUN, 2001) 0
      IF ( .NOT.COMP (IERR, 0, LUN, KPRINT) )  THEN
         IFAIL = IFAIL + 1
      ELSE
         IF ( KPRINT.GE.3 )  WRITE (LUN, 2002)
         NBAD = 0
         DO 30  I = 1, N
            RESULT = '  OK'
C           D-values should agree exactly with those computed by DPCHIM.
C            (To be generous, will only test to machine precision.)
            ERR = ABS( D(I)-DC(I) )
            IF ( ERR.GT.TOL )  THEN
               NBAD = NBAD + 1
               RESULT = '**BAD'
            ENDIF
            IF (KPRINT.GE.3)
     *         WRITE (LUN, 2003)  I, X(I), DC(I), ERR, RESULT
   30    CONTINUE
         IF ( NBAD.NE.0 )  THEN
            IFAIL = IFAIL + 1
            IF (KPRINT.GE.2)  WRITE (LUN, 2005)  NBAD, 'IC', TOL
         ELSE
            IF (KPRINT.GE.2)  WRITE (LUN, 2006)  'IC'
         ENDIF
      ENDIF
C
C  Test DPCHIC -- default nonzero switch derivatives.
C
      IF (KPRINT.GE.3)  WRITE (LUN, 2000) 'IC'
C     -------------------------------------------------------
      CALL DPCHIC (IC, VC, MONE, N, X, F, D, 1, WK, NWK, IERR)
C     -------------------------------------------------------
C        Expect IERR=0 .
      IF ( KPRINT.GE.3 )  WRITE (LUN, 2001) 0
      IF ( .NOT.COMP (IERR, 0, LUN, KPRINT) )  THEN
         IFAIL = IFAIL + 1
      ELSE
         IF ( KPRINT.GE.3 )  WRITE (LUN, 2002)
         NBAD = 0
         NBADZ = 0
         DO 40  I = 1, N
            RESULT = '  OK'
C            D-values should agree exactly with those computed in
C            previous call, except at points 5 and 6.
            IF ( (I.LT.5).OR.(I.GT.6) )  THEN
               ERR = ABS( D(I)-DC(I) )
               IF ( ERR.GT.TOLZ )  THEN
                  NBADZ = NBADZ + 1
                  RESULT = '**BADA'
               ENDIF
            ELSE
               IF ( I.EQ.5 )  THEN
                  ERR = ABS( (D(I)-DC5)/DC5 )
               ELSE
                  ERR = ABS( (D(I)-DC6)/DC6 )
               ENDIF
               IF ( ERR.GT.TOLD )  THEN
                  NBAD = NBAD + 1
                  RESULT = '**BAD'
               ENDIF
            ENDIF
            IF (KPRINT.GE.3)
     *         WRITE (LUN, 2003)  I, X(I), D(I), ERR, RESULT
   40    CONTINUE
         IF ( (NBADZ.NE.0).OR.(NBAD.NE.0) )  THEN
            IFAIL = IFAIL + 1
            IF ((NBADZ.NE.0).AND.(KPRINT.GE.2))
     *         WRITE (LUN, 2007)  NBAD
            IF ((NBAD.NE.0).AND.(KPRINT.GE.2))
     *         WRITE (LUN, 2005)  NBAD, 'IC', TOLD
         ELSE
            IF (KPRINT.GE.2)  WRITE (LUN, 2006)  'IC'
         ENDIF
      ENDIF
C
C  Test DPCHSP.
C
      IF (KPRINT.GE.3)  WRITE (LUN, 2000) 'SP'
C     -------------------------------------------------
      CALL DPCHSP (IC, VC, N, X, F, D, 1, WK, NWK, IERR)
C     -------------------------------------------------
C        Expect IERR=0 .
      IF ( KPRINT.GE.3 )  WRITE (LUN, 2001) 0
      IF ( .NOT.COMP (IERR, 0, LUN, KPRINT) )  THEN
         IFAIL = IFAIL + 1
      ELSE
         IF ( KPRINT.GE.3 )  WRITE (LUN, 2002)
         NBAD = 0
         DO 50  I = 1, N
            RESULT = '  OK'
C             D-values should agree with stored values.
            ERR = ABS( (D(I)-DS(I))/DS(I) )
            IF ( ERR.GT.TOLD )  THEN
               NBAD = NBAD + 1
               RESULT = '**BAD'
            ENDIF
            IF (KPRINT.GE.3)
     *         WRITE (LUN, 2003)  I, X(I), D(I), ERR, RESULT
   50    CONTINUE
         IF ( NBAD.NE.0 )  THEN
            IFAIL = IFAIL + 1
            IF (KPRINT.GE.2)  WRITE (LUN, 2005)  NBAD, 'SP', TOLD
         ELSE
            IF (KPRINT.GE.2)  WRITE (LUN, 2006)  'SP'
         ENDIF
      ENDIF
C
C  PRINT SUMMARY AND TERMINATE.
C
      IF ((KPRINT.GE.2).AND.(IFAIL.NE.0))  WRITE (LUN, 3001)  IFAIL
C
      IF (IFAIL.EQ.0)  THEN
         IPASS = 1
         IF (KPRINT.GE.2) WRITE(LUN,99998)
      ELSE
         IPASS = 0
         IF (KPRINT.GE.1) WRITE(LUN,99999)
      ENDIF
C
      RETURN
C
C  FORMATS.
C
 1000 FORMAT ('1'//10X,'TEST DPCHIP INTERPOLATORS')
 1001 FORMAT (//10X,'DPCHQ3 RESULTS'/10X,'--------------')
 1002 FORMAT (// 5X,'DATA:'
     *         /39X,'---------- EXPECTED D-VALUES ----------'
     *         /12X,'X',9X,'F',18X,'DM',13X,'DC',13X,'DS')
 1010 FORMAT (5X,F10.2,1P,D15.5,4X,D15.5,15X,D15.5)
 1011 FORMAT (5X,F10.2,1P,D15.5,4X,3D15.5)
 2000 FORMAT (/5X,'DPCH',A2,' TEST:')
 2001 FORMAT (15X,'EXPECT  IERR =',I5)
 2002 FORMAT (/9X,'I',7X,'X',9X,'D',13X,'ERR')
 2003 FORMAT (5X,I5,F10.2,1P,2D15.5,2X,A)
 2004 FORMAT (/'    **',I5,' DPCHIM RESULTS FAILED TO BE EXACTLY ZERO.')
 2005 FORMAT (/'    **',I5,' DPCH',A2,' RESULTS FAILED TOLERANCE TEST.',
     *                     '  TOL =',1P,D10.3)
 2006 FORMAT (/5X,'  ALL DPCH',A2,' RESULTS OK.')
 2007 FORMAT (/'    **',I5,' DPCHIC RESULTS FAILED TO AGREE WITH',
     *                      ' PREVIOUS CALL.')
 3001 FORMAT (/' *** TROUBLE ***',I5,' INTERPOLATION TESTS FAILED.')
99998 FORMAT (/' ------------ DPCHIP PASSED  ALL INTERPOLATION TESTS',
     *        ' ------------')
99999 FORMAT (/' ************ DPCHIP FAILED SOME INTERPOLATION TESTS',
     *        ' ************')
C------------- LAST LINE OF DPCHQ3 FOLLOWS -----------------------------
      END

*DECK LSEIQX
      SUBROUTINE LSEIQX (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  LSEIQX
C***PURPOSE  Quick check for LSEI.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (LSEIQX-S, DLSEIT-D)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Hanson, R. J., (SNLA)
C           Haskell, Karen, (SNLA)
C***DESCRIPTION
C
C   The sample problem solved is from a paper by J. Stoer, in
C   SIAM Journal of Numerical Analysis, June 1971.
C
C***ROUTINES CALLED  LSEI, R1MACH, SAXPY, SCOPY, SDOT, SNRM2, SVOUT
C***REVISION HISTORY  (YYMMDD)
C   790216  DATE WRITTEN
C   890618  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   901010  Restructured using IF-THEN-ELSE-ENDIF, modified tolerances
C           to use R1MACH(4) rather than R1MACH(3) and cleaned up
C           FORMATs.  (RWC)
C   920722  Initialized IP(1) and IP(2) for CALL to LSEI.  (BKS, WRB)
C   930214  Declarations sections added, code revised to test error
C           returns for all values of KPRINT and code polished.  (WRB)
C***END PROLOGUE  LSEIQX
C     .. Scalar Arguments ..
      INTEGER IPASS, KPRINT, LUN
C     .. Local Scalars ..
      REAL CNORM, RELERR, RELNRM, RESNRM, RNORME, RNORML, TNORM
      INTEGER I, IDIGIT, JDIGIT, KONTRL, MA, MDD, ME, MEAP1, MEP1, MG,
     *        MODE, N, NERR, NP1
      LOGICAL FATAL
C     .. Local Arrays ..
      REAL A(6,5), D(11,6), ERR(5), F(6), G(5,5), H(5), PRGOPT(4),
     *     SOL(5), WORK(105), X(5)
      INTEGER IP(17)
C     .. External Functions ..
      REAL R1MACH, SDOT, SNRM2
      INTEGER NUMXER
      EXTERNAL NUMXER, R1MACH, SDOT, SNRM2
C     .. External Subroutines ..
      EXTERNAL LSEI, SAXPY, SCOPY, SVOUT, XGETF, XSETF
C     .. Intrinsic Functions ..
      INTRINSIC SQRT
C     .. Data statements ..
C
C     Define the data arrays for the example.  The array A contains
C     the least squares equations.  (There are no equality constraints
C     in this example).
C
      DATA A(1,1),A(1,2),A(1,3),A(1,4),A(1,5)
     *     /-74.,80.,18.,-11.,-4./
      DATA A(2,1),A(2,2),A(2,3),A(2,4),A(2,5)
     *     /14.,-69.,21.,28.,0./
      DATA A(3,1),A(3,2),A(3,3),A(3,4),A(3,5)
     *     /66.,-72.,-5.,7.,1./
      DATA A(4,1),A(4,2),A(4,3),A(4,4),A(4,5)
     *     /-12.,66.,-30.,-23.,3./
      DATA A(5,1),A(5,2),A(5,3),A(5,4),A(5,5)
     *     /3.,8.,-7.,-4.,1./
      DATA A(6,1),A(6,2),A(6,3),A(6,4),A(6,5)
     *     /4.,-12.,4.,4.,0./
C
C     The array G contains the inequality constraint equations,
C     written in the sense
C     (row vector)*(solution vector) .GE. (given value).
C
      DATA G(1,1),G(1,2),G(1,3),G(1,4),G(1,5)
     *     /-1.,-1.,-1.,-1.,-1./
      DATA G(2,1),G(2,2),G(2,3),G(2,4),G(2,5)
     *     /10.,10.,-3.,5.,4./
      DATA G(3,1),G(3,2),G(3,3),G(3,4),G(3,5)
     *     /-8.,1.,-2.,-5.,3./
      DATA G(4,1),G(4,2),G(4,3),G(4,4),G(4,5)
     *     /8.,-1.,2.,5.,-3./
      DATA G(5,1),G(5,2),G(5,3),G(5,4),G(5,5)
     *     /-4.,-2.,3.,-5.,1./
C
C     Define the least squares right-side vector.
C
      DATA F(1),F(2),F(3),F(4),F(5),F(6)
     *     /-5.,-9.,708.,4165.,-13266.,8409./
C
C     Define the inequality constraint right-side vector.
C
      DATA H(1),H(2),H(3),H(4),H(5)
     *     /-5.,20.,-40.,11.,-30./
C
C     Define the vector that is the known solution.
C
      DATA SOL(1),SOL(2),SOL(3),SOL(4),SOL(5)
     *     /1.,2.,-1.,3.,-4./
C***FIRST EXECUTABLE STATEMENT  LSEIQX
      IF (KPRINT .GE. 2) WRITE (LUN, 9000)
C
C     Define the matrix dimensions, number of least squares equations,
C     number of equality constraints, total number of equations, and
C     number of variables.  Set ME=0 to indicate there are no equality
C     constraints.
C
      MDD = 11
      MA = 6
      MG = 5
      N = 5
      ME = 0
C
      IP(1) = 105
      IP(2) = 17
C
      NP1 = N + 1
      MEP1 = ME + 1
      MEAP1 = ME + MA + 1
C
C     Copy the problem matrices.
C
      DO 10 I = 1, N
C
C        Copy the i-th column of the inequality constraint matrix into
C        the work array.
C
         CALL SCOPY(MG, G(1,I), 1, D(MEAP1,I), 1)
C
C        Copy the i-th column of the least squares matrix into the work
C        array.
C
         CALL SCOPY(MA, A(1,I), 1, D(MEP1,I), 1)
   10 CONTINUE
C
C     Copy the right-side vectors into the work array in compatible
C     order.
C
      CALL SCOPY(MG, H, 1, D(MEAP1,NP1), 1)
      CALL SCOPY(MA, F, 1, D(MEP1,NP1),  1)
C
C     Use default program options in LSEI, and set matrix-vector
C     printing accuracy parameters.
C
      PRGOPT(1) = 1
      IDIGIT = -4
      JDIGIT = -11
C
C     Compute residual norm of known least squares solution.
C     (to be used to check computed residual norm = RNORML.)
C
      DO 20 I = 1, MA
         WORK(I) = SDOT(N,D(I,1),MDD,SOL,1) - F(I)
   20 CONTINUE
      RESNRM = SNRM2(MA,WORK,1)
C
C     Call LSEI to get solution in X(*), least squares residual in
C     RNORML.
C
      CALL LSEI(D, MDD, ME, MA, MG, N, PRGOPT, X, RNORME, RNORML, MODE,
     *   WORK, IP)
C
C     Compute relative error in problem variable solution and residual
C     norm computation.
C
      TNORM = SNRM2(N,SOL,1)
      CALL SCOPY(N, SOL, 1, ERR, 1)
      CALL SAXPY(N, -1.0E0, X, 1, ERR, 1)
      CNORM = SNRM2(N, ERR, 1)
      RELERR = CNORM/TNORM
      RELNRM = (RESNRM-RNORML)/RESNRM
C
      IF (RELERR .LE. 70.0E0*SQRT(R1MACH(4)) .AND.
     *    RELNRM .LE.  5.0E0*R1MACH(4)) THEN
         IPASS = 1
         IF (KPRINT .GE. 3) WRITE (LUN, 9010)
      ELSE
         IPASS = 0
         IF (KPRINT .GE. 2) WRITE (LUN, 9020) RELERR, RELNRM
      ENDIF
C
C     Print out known and computed solutions.
C
      IF (KPRINT .GE. 3) THEN
         CALL SVOUT(N, ERR,
     *      '('' RESIDUALS FROM KNOWN LEAST SQUARES SOLUTION'')',
     *      IDIGIT)
         CALL SVOUT(N, X, '(/'' SOLUTION COMPUTED BY LSEI'')', JDIGIT)
      ENDIF
C
      IF (KPRINT .GE. 2) THEN
         IF (.NOT.(KPRINT.EQ.2 .AND. IPASS.NE.0)) THEN
C
C           Print out the known and computed residual norms.
C
            CALL SVOUT(1, RESNRM,
     *         '(/'' RESIDUAL NORM OF KNOWN LEAST SQUARES SOLUTION'')',
     *         JDIGIT)
            CALL SVOUT(1, RNORML,
     *         '(/'' RESIDUAL NORM COMPUTED BY LSEI'')', JDIGIT)
C
C           Print out the computed solution relative error.
C
            CALL SVOUT(1, RELERR,
     *         '(/'' COMPUTED SOLUTION RELATIVE ERROR'')', IDIGIT)
C
C           Print out the computed relative error in residual norm.
C
            CALL SVOUT(1, RELNRM,
     *       '(/'' COMPUTED RELATIVE ERROR IN RESIDUAL NORM'')', IDIGIT)
         ENDIF
      ENDIF
C
C     Check calls to error processor.
C
      CALL XGETF (KONTRL)
      IF (KPRINT .LE. 2) THEN
         CALL XSETF (0)
      ELSE
         CALL XSETF (1)
      ENDIF
      FATAL = .FALSE.
      CALL XERCLR
C
      IF (KPRINT .GE. 3) WRITE (LUN, 9030)
C
      CALL LSEI (D, 0, ME, MA, MG, N, PRGOPT, X, RNORME, RNORML,
     *           MODE, WORK, IP)
      IF (NUMXER(NERR) .NE. 2) THEN
         IPASS = 0
         FATAL = .TRUE.
      ENDIF
      CALL XERCLR
C
      PRGOPT(1) = -1
      CALL LSEI (D, MDD, ME, MA, MG, N, PRGOPT, X, RNORME, RNORML,
     *           MODE, WORK, IP)
      IF (NUMXER(NERR) .NE. 2) THEN
         IPASS = 0
         FATAL = .TRUE.
      ENDIF
      CALL XERCLR
C
C     Restore KONTRL and check to see if the tests of error detection
C     passed.
C
      CALL XSETF (KONTRL)
      IF (FATAL) THEN
         IF (KPRINT .GE. 2) THEN
            WRITE (LUN,  9040)
         ENDIF
      ELSE
         IF (KPRINT .GE. 3) THEN
            WRITE (LUN,  9050)
         ENDIF
      ENDIF
C
C     Print PASS/FAIL message.
C
      IF (IPASS.EQ.1 .AND. KPRINT.GE.2) WRITE (LUN, 9100)
      IF (IPASS.EQ.0 .AND. KPRINT.GE.1) WRITE (LUN, 9110)
      RETURN
C
 9000 FORMAT ('1TEST OF SUBROUTINE LSEI')
 9010 FORMAT (/' LSEI PASSED TEST')
 9020 FORMAT (/' LSEI FAILED TEST'/' RELERR = ',1P,E20.6/' RELNRM = ',
     *        E20.6)
 9030 FORMAT (/ ' 2 ERROR MESSAGES EXPECTED')
 9040 FORMAT (/ ' AT LEAST ONE INCORRECT ARGUMENT TEST FAILED')
 9050 FORMAT (/ ' ALL INCORRECT ARGUMENT TESTS PASSED')
 9100 FORMAT (/' ****************LSEI PASSED ALL TESTS***************')
 9110 FORMAT (/' ****************LSEI FAILED SOME TESTS**************')
      END

*DECK EISQX2
      SUBROUTINE EISQX2 (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  EISQX2
C***PURPOSE  Quick check for SSIEV, CHIEV and SSPEV.
C***LIBRARY   SLATEC
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Kahaner, D. K., (NBS)
C***DESCRIPTION
C
C     THIS QUICK CHECK ROUTINE IS WRITTEN FOR EISPACK DRIVERS
C     SSIEV, CHIEV AND SSPEV.  THE EIGENVALUES OF INPUT MATRIX
C     A(.,.) ARE STORED IN EK(.).  RELERR IS THE RELATIVE
C     ACCURACY REQUIRED FOR THEM TO PASS.
C
C***ROUTINES CALLED  CHIEV, R1MACH, SSIEV, SSPEV
C***REVISION HISTORY  (YYMMDD)
C   800808  DATE WRITTEN
C   890618  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900405  CALL to XERROR replaced by message to LUN.  (WRB)
C***END PROLOGUE  EISQX2
      INTEGER KPRINT,IPASS,LUN
      INTEGER LDA,N,LDV,JOB,I,J,ID
      REAL A1(4,4),A2(10),AP(10),E(4),V(4,4),EK(4),W(16)
      REAL ERR,ERRI,RELERR
      COMPLEX AC(4,4),VC(4,4)
      EQUIVALENCE (V,VC)
      DATA LDA,N,LDV / 3*4 /
      DATA AP / 5., 4., 5., 1., 1., 4., 1., 1., 2., 4. /
      DATA EK / 1., 2., 5., 10. /
C***FIRST EXECUTABLE STATEMENT  EISQX2
      IPASS = 1
      RELERR = SQRT(R1MACH(4))
      ID = 0
      DO 20 J=1,N
         DO 10 I=1,J
            ID = ID + 1
            A1(I,J) = AP(ID)
            A2(ID) = AP(ID)
            AC(I,J) = CMPLX(AP(ID),0.)
   10       CONTINUE
   20    CONTINUE
      JOB = 1
      CALL CHIEV(AC,LDA,N,E,VC,LDV,W,JOB,INFO)
      IF (INFO .NE. 0) THEN
         IF (KPRINT .GE. 2) WRITE (LUN, 688) 'CHIEV', INFO
         IPASS = 0
      ENDIF
      DO 40 J=1,N
         ERR = ABS(E(J) - EK(1))
         ID = 1
         DO 30 I=2,N
            ERRI = ABS(E(J) - EK(I))
            IF (ERRI .LT. ERR) ID = I
            ERR = MIN(ERRI,ERR)
   30       CONTINUE
         IF (ABS(E(J)-EK(ID))/ABS(EK(ID)) .GE. RELERR) IPASS = 0
   40    CONTINUE
      CALL SSIEV(A1,LDA,N,E,W,JOB,INFO)
      IF (INFO .NE. 0) THEN
         IF (KPRINT .GE. 2) WRITE (LUN, 688) 'SSIEV', INFO
         IPASS = 0
      ENDIF
      DO 60 J=1,N
         ERR = ABS(E(J) - EK(1))
         ID = 1
         DO 50 I=2,N
            ERRI = ABS(E(J) - EK(I))
            IF (ERRI .LT. ERR) ID = I
            ERR = MIN(ERRI,ERR)
   50       CONTINUE
         IF (ABS(E(J)-EK(ID))/ABS(EK(ID)) .GE. RELERR) IPASS = 0
   60    CONTINUE
      JOB = 0
      CALL SSPEV(A2,N,E,V,LDV,W,JOB,INFO)
      IF (INFO .NE. 0) THEN
         IF (KPRINT .GE. 2) WRITE (LUN, 688) 'SSPEV', INFO
         IPASS = 0
      ENDIF
      DO 80 J=1,N
         ERR = ABS(E(J) - EK(1))
         ID = 1
         DO 70 I=2,N
            ERRI = ABS(E(J) - EK(I))
            IF (ERRI .LT. ERR) ID = I
            ERR = MIN(ERRI,ERR)
   70       CONTINUE
         IF (ABS(E(J)-EK(ID))/ABS(EK(ID)) .GE. RELERR) IPASS = 0
   80    CONTINUE
      IF (KPRINT.GE.2 .AND. IPASS.NE.0) WRITE (LUN,684)
  684 FORMAT(25H EISQX2 PASSES ALL TESTS.)
      IF (KPRINT.GE.1 .AND. IPASS.EQ.0) WRITE (LUN,686)
  686 FORMAT(25H EISQX2 FAILS SOME TESTS.)
  688 FORMAT (1X, 'Eigenvalue iteration failed to converge in ', A5,
     +        ', INFO = ', I4)
      RETURN
      END

*DECK SCHK62
      SUBROUTINE SCHK62 (SNAME, EPS, THRESH, NOUT, KPRINT, FATAL, NIDIM,
     $   IDIM, NALF, ALF, NINC, INC, NMAX, INCMAX, A, AA, AS, X, XX, XS,
     $   Y, YY, YS, YT, G, Z)
C***BEGIN PROLOGUE  SCHK62
C***SUBSIDIARY
C***PURPOSE  Quick check for SSYR2 and SSPR2.
C***LIBRARY   SLATEC (BLAS)
C***KEYWORDS  BLAS, QUICK CHECK SERVICE ROUTINE
C***AUTHOR  Du Croz, J. (NAG)
C           Hanson, R. J. (SNLA)
C***DESCRIPTION
C
C  Quick check for SSYR2 and SSPR2.
C
C  Auxiliary routine for test program for Level 2 Blas.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  LSE, LSERES, NUMXER, SMAKE2, SMVCH, SSPR2, SSYR2
C***REVISION HISTORY  (YYMMDD)
C   870810  DATE WRITTEN
C   910619  Modified to meet SLATEC code and prologue standards.  (BKS)
C***END PROLOGUE  SCHK62
C     .. Parameters ..
      REAL               ZERO, HALF, ONE
      PARAMETER          ( ZERO = 0.0, HALF = 0.5, ONE = 1.0 )
C     .. Scalar Arguments ..
      LOGICAL            FATAL
      REAL               EPS, THRESH
      INTEGER            INCMAX, KPRINT, NALF, NIDIM, NINC, NMAX, NOUT
      CHARACTER*6        SNAME
C     .. Array Arguments ..
      REAL               A( NMAX, NMAX ), AA( NMAX*NMAX ), ALF( NALF ),
     $                   AS( NMAX*NMAX ), G( NMAX ), X( NMAX ),
     $                   XS( NMAX*INCMAX ), XX( NMAX*INCMAX ),
     $                   Y( NMAX ), YS( NMAX*INCMAX ), YT( NMAX ),
     $                   YY( NMAX*INCMAX ), Z( NMAX, 2 )
      INTEGER            IDIM( NIDIM ), INC( NINC )
C     .. Local Scalars ..
      REAL               ALPHA, ALS, ERR, ERRMAX, TRANSL
      INTEGER            I, IA, IC, IN, INCX, INCXS, INCY, INCYS, IX,
     $                   IY, J, JA, JJ, LAA, LDA, LDAS, LJ, LX, LY, N,
     $                   NARGS, NC, NS, NERR
      LOGICAL            FTL, FULL, NULL, PACKED, RESET, UPPER
      CHARACTER*1        UPLO, UPLOS
      CHARACTER*2        ICH
C     .. Local Arrays ..
      REAL               W( 2 )
      LOGICAL            ISAME( 13 )
C     .. External Functions ..
      INTEGER            NUMXER
      LOGICAL            LSE, LSERES
      EXTERNAL           LSE, LSERES, NUMXER
C     .. External Subroutines ..
      EXTERNAL           SMAKE2, SMVCH, SSPR2, SSYR2
C     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX
C     .. Data statements ..
      DATA               ICH/'UL'/
C***FIRST EXECUTABLE STATEMENT  SCHK62
      FULL = SNAME( 3: 3 ).EQ.'Y'
      PACKED = SNAME( 3: 3 ).EQ.'P'
C     Define the number of arguments.
      IF( FULL )THEN
         NARGS = 9
      ELSE IF( PACKED )THEN
         NARGS = 8
      END IF
C
      NC = 0
      RESET = .TRUE.
      ERRMAX = ZERO
C
      DO 140 IN = 1, NIDIM
         N = IDIM( IN )
C        Set LDA to 1 more than minimum value if room.
         LDA = N
         IF( LDA.LT.NMAX )
     $      LDA = LDA + 1
C        Skip tests if not enough room.
         IF( LDA.GT.NMAX )
     $      GO TO 140
         IF( PACKED )THEN
            LAA = ( N*( N + 1 ) )/2
         ELSE
            LAA = LDA*N
         END IF
C
         DO 130 IC = 1, 2
            UPLO = ICH( IC: IC )
            UPPER = UPLO.EQ.'U'
C
            DO 120 IX = 1, NINC
               INCX = INC( IX )
               LX = ABS( INCX )*N
C
C              Generate the vector X.
C
               TRANSL = HALF
               CALL SMAKE2( 'GE', ' ', ' ', 1, N, X, 1, XX, ABS( INCX ),
     $                     0, N - 1, RESET, TRANSL )
               IF( N.GT.1 )THEN
                  X( N/2 ) = ZERO
                  XX( 1 + ABS( INCX )*( N/2 - 1 ) ) = ZERO
               END IF
C
               DO 110 IY = 1, NINC
                  INCY = INC( IY )
                  LY = ABS( INCY )*N
C
C                 Generate the vector Y.
C
                  TRANSL = ZERO
                  CALL SMAKE2( 'GE', ' ', ' ', 1, N, Y, 1, YY,
     $                        ABS( INCY ), 0, N - 1, RESET, TRANSL )
                  IF( N.GT.1 )THEN
                     Y( N/2 ) = ZERO
                     YY( 1 + ABS( INCY )*( N/2 - 1 ) ) = ZERO
                  END IF
C
                  DO 100 IA = 1, NALF
                     ALPHA = ALF( IA )
                     NULL = N.LE.0.OR.ALPHA.EQ.ZERO
C
C                    Generate the matrix A.
C
                     TRANSL = ZERO
                     CALL SMAKE2( SNAME( 2: 3 ), UPLO, ' ', N, N, A,
     $                           NMAX, AA, LDA, N - 1, N - 1, RESET,
     $                           TRANSL )
C
                     NC = NC + 1
C
C                    Save every datum before calling the subroutine.
C
                     UPLOS = UPLO
                     NS = N
                     ALS = ALPHA
                     DO 10 I = 1, LAA
                        AS( I ) = AA( I )
   10                CONTINUE
                     LDAS = LDA
                     DO 20 I = 1, LX
                        XS( I ) = XX( I )
   20                CONTINUE
                     INCXS = INCX
                     DO 30 I = 1, LY
                        YS( I ) = YY( I )
   30                CONTINUE
                     INCYS = INCY
C
C                    Call the subroutine.
C
                     IF( FULL )THEN
                        CALL SSYR2( UPLO, N, ALPHA, XX, INCX, YY, INCY,
     $                              AA, LDA )
                     ELSE IF( PACKED )THEN
                        CALL SSPR2( UPLO, N, ALPHA, XX, INCX, YY, INCY,
     $                              AA )
                     END IF
C
C                    Check if error-exit was taken incorrectly.
C
                     IF (NUMXER(NERR) .NE. 0) THEN
                        IF (KPRINT .GE. 2) THEN
                          WRITE( NOUT, FMT = 9992 )
                        ENDIF
                        FATAL = .TRUE.
                     END IF
C
C                    See what data changed inside subroutines.
C
                     ISAME( 1 ) = UPLO.EQ.UPLOS
                     ISAME( 2 ) = NS.EQ.N
                     ISAME( 3 ) = ALS.EQ.ALPHA
                     ISAME( 4 ) = LSE( XS, XX, LX )
                     ISAME( 5 ) = INCXS.EQ.INCX
                     ISAME( 6 ) = LSE( YS, YY, LY )
                     ISAME( 7 ) = INCYS.EQ.INCY
                     IF( NULL )THEN
                        ISAME( 8 ) = LSE( AS, AA, LAA )
                     ELSE
                        ISAME( 8 ) = LSERES( SNAME( 2: 3 ), UPLO, N, N,
     $                               AS, AA, LDA )
                     END IF
                     IF( .NOT.PACKED )THEN
                        ISAME( 9 ) = LDAS.EQ.LDA
                     END IF
C
C                    If data was incorrectly changed, report and return.
C
                     DO 40 I = 1, NARGS
                       IF (.NOT. ISAME( I )) THEN
                         FATAL = .TRUE.
                         IF (KPRINT .GE. 2) THEN
                           WRITE( NOUT, FMT = 9998 )I
                         ENDIF
                       ENDIF
  40                 CONTINUE
C
                     FTL = .FALSE.
                     IF( .NOT.NULL )THEN
C
C                       Check the result column by column.
C
                        IF( INCX.GT.0 )THEN
                           DO 50 I = 1, N
                              Z( I, 1 ) = X( I )
   50                      CONTINUE
                        ELSE
                           DO 60 I = 1, N
                              Z( I, 1 ) = X( N - I + 1 )
   60                      CONTINUE
                        END IF
                        IF( INCY.GT.0 )THEN
                           DO 70 I = 1, N
                              Z( I, 2 ) = Y( I )
   70                      CONTINUE
                        ELSE
                           DO 80 I = 1, N
                              Z( I, 2 ) = Y( N - I + 1 )
   80                      CONTINUE
                        END IF
                        JA = 1
                        DO 90 J = 1, N
                           W( 1 ) = Z( J, 2 )
                           W( 2 ) = Z( J, 1 )
                           IF( UPPER )THEN
                              JJ = 1
                              LJ = J
                           ELSE
                              JJ = J
                              LJ = N - J + 1
                           END IF
                           CALL SMVCH( 'N', LJ, 2, ALPHA, Z( JJ, 1 ),
     $                                 NMAX, W, 1, ONE, A( JJ, J ), 1,
     $                                 YT, G, AA( JA ), EPS, ERR, FTL,
     $                                 NOUT, .TRUE., KPRINT )
                           IF( FULL )THEN
                              IF( UPPER )THEN
                                 JA = JA + LDA
                              ELSE
                                 JA = JA + LDA + 1
                              END IF
                           ELSE
                              JA = JA + LJ
                           END IF
                           ERRMAX = MAX( ERRMAX, ERR )
                           IF (FTL) THEN
                             FATAL = .TRUE.
                             IF (KPRINT .GE. 3) THEN
                               WRITE( NOUT, FMT = 9995 )J
                               WRITE( NOUT, FMT = 9996 )SNAME
                               IF( FULL )THEN
                                  WRITE( NOUT, FMT = 9993 )NC, SNAME,
     $                             UPLO, N, ALPHA, INCX,
     $                             INCY, LDA
                               ELSE IF( PACKED )THEN
                                  WRITE( NOUT, FMT = 9994 )NC, SNAME,
     $                             UPLO, N, ALPHA, INCX, INCY
                               END IF
                             ENDIF
                           ENDIF
   90                   CONTINUE
                     END IF
C
  100             CONTINUE
C
  110          CONTINUE
C
  120       CONTINUE
C
  130    CONTINUE
C
  140 CONTINUE
C
C     Report result.
C
      IF (.NOT. (FATAL)) THEN
        IF (KPRINT .GE. 3) THEN
          IF( ERRMAX.LT.THRESH )THEN
             WRITE( NOUT, FMT = 9999 )SNAME, NC
          ELSE
             WRITE( NOUT, FMT = 9997 )SNAME, NC, ERRMAX
          END IF
        ENDIF
      ENDIF
      RETURN
C
 9999 FORMAT( ' ', A6, ' PASSED THE COMPUTATIONAL TESTS (', I6, ' CALL',
     $      'S)' )
 9998 FORMAT( ' ******* FATAL ERROR - PARAMETER NUMBER ', I2, ' WAS CH',
     $      'ANGED INCORRECTLY *******' )
 9997 FORMAT( ' ', A6, ' COMPLETED THE COMPUTATIONAL TESTS (', I6, ' C',
     $      'ALLS)', /' ******* BUT WITH MAXIMUM TEST RATIO', F8.2,
     $      ' - SUSPECT *******' )
 9996 FORMAT( ' ******* ', A6, ' FAILED ON CALL NUMBER:' )
 9995 FORMAT( '      THESE ARE THE RESULTS FOR COLUMN ', I3 )
 9994 FORMAT( 1X, I6, ': ', A6, '(''', A1, ''',', I3, ',', F4.1, ', X,',
     $      I2, ', Y,', I2, ', AP)                     .' )
 9993 FORMAT( 1X, I6, ': ', A6, '(''', A1, ''',', I3, ',', F4.1, ', X,',
     $      I2, ', Y,', I2, ', A,', I3, ')                  .' )
 9992 FORMAT( ' ******* FATAL ERROR - ERROR-EXIT TAKEN ON VALID CALL *',
     $      '******' )
C
C     End of SCHK62.
C
      END

*DECK EDIT2
      SUBROUTINE EDIT2 (Y, T, ERM)
C***BEGIN PROLOGUE  EDIT2
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SDASQC.
C***LIBRARY   SLATEC (DASSL)
C***TYPE      SINGLE PRECISION (EDIT2-S, DEDIT2-D)
C***AUTHOR  PETZOLD, LINDA R., (LLNL)
C***SEE ALSO  SDASQC
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   891013  DATE WRITTEN
C   901001  Converted prologue to 4.0 format and made all argument
C           declarations explicit.  (FNF)
C   901009  Changed AMAX1 to MAX.  (FNF)
C   901030  Removed FLOAT's; made all local declarations explicit. (FNF)
C***END PROLOGUE  EDIT2
      REAL  Y(*), T, ERM
      INTEGER  I, J, K, NG
      REAL  ALPH1, ALPH2, A1, A2, ER, EX, YT
      DATA ALPH1/1.0E0/, ALPH2/1.0E0/, NG/5/
C***FIRST EXECUTABLE STATEMENT  EDIT2
      ERM = 0.0E0
      IF (T .EQ. 0.0E0) RETURN
      EX = 0.0E0
      IF (T .LE. 30.0E0) EX = EXP(-2.0E0*T)
      A2 = 1.0E0
      DO 60 J = 1,NG
        A1 = 1.0E0
        DO 50 I = 1,NG
          K = I + (J - 1)*NG
          YT = T**(I+J-2)*EX*A1*A2
          ER = ABS(Y(K)-YT)
          ERM = MAX(ERM,ER)
          A1 = A1*ALPH1/I
 50       CONTINUE
        A2 = A2*ALPH2/J
 60     CONTINUE
      RETURN
      END

*DECK FDTRUE
      SUBROUTINE FDTRUE (X, F, D)
C***BEGIN PROLOGUE  FDTRUE
C***SUBSIDIARY
C***PURPOSE  Compute exact function values for EVCHCK.
C***LIBRARY   SLATEC (PCHIP)
C***TYPE      SINGLE PRECISION (FDTRUE-S, DFDTRU-D)
C***KEYWORDS  PCHIP EVALUATOR QUICK CHECK
C***AUTHOR  Fritsch, F. N., (LLNL)
C***DESCRIPTION
C
C        COMPUTE EXACT FUNCTION VALUES IN DOUBLE PRECISION.
C
C                   F(X) = X*(X+1)*(X-2)
C
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   820601  DATE WRITTEN
C   890618  REVISION DATE from Version 3.2
C   890706  Cosmetic changes to prologue.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  Revised prologue.  (FNF)
C   900316  Deleted variables ONE and TWO.  (FNF)
C   900321  Changed name of d.p. version from DFTRUE to DFDTRU.
C***END PROLOGUE  FDTRUE
      REAL  X, F, D
      DOUBLE PRECISION  FACT1, FACT2, XX
C
C***FIRST EXECUTABLE STATEMENT  FDTRUE
      XX = X
      FACT1 = XX + 1
      FACT2 = XX - 2
      F = XX * FACT1 * FACT2
      D = FACT1*FACT2 + XX*(FACT1 + FACT2)
C
      RETURN
C------------- LAST LINE OF FDTRUE FOLLOWS -----------------------------
      END

*DECK F2O
      REAL FUNCTION F2O (X)
C***BEGIN PROLOGUE  F2O
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F2O
      REAL X
C***FIRST EXECUTABLE STATEMENT  F2O
      F2O = 0.0E+00
      IF(X.NE.0.0E+00) F2O = 1.0/(X*X*SQRT(X))
      RETURN
      END

*DECK EG8CK
      SUBROUTINE EG8CK (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  EG8CK
C***PURPOSE  Quick check for EXINT and GAUS8.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (EG8CK-S, DEG8CK-D)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Amos, D. E., (SNLA)
C***DESCRIPTION
C
C   EG8CK is a quick check routine for EXINT and GAUS8.  Exponential
C   integrals from EXINT are checked against quadratures from GAUS8.
C
C***ROUTINES CALLED  EXINT, FEIN, GAUS8, R1MACH
C***COMMON BLOCKS    FEINX
C***REVISION HISTORY  (YYMMDD)
C   800501  DATE WRITTEN
C   890718  Added check when testing error conditions.  (WRB)
C   890718  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   910708  Code revised to test error returns for all values of
C           KPRINT.  (WRB)
C   920206  Corrected argument list in CALL to EXINT.  (WRB)
C***END PROLOGUE  EG8CK
      COMMON /FEINX/ X, A, FKM
      INTEGER I, ICASE, IE, IERR, II, IK, IPASS, IX, IY, K, KE, KK,
     * KODE, KX, LUN, M, N, NM, NZ
      REAL A, ANS, ATOL, BB, EN, ER, EX, FKM, SIG, SUM, TOL, T1, T2, X,
     * XX, Y
      REAL R1MACH, FEIN
      DIMENSION EN(4), Y(4), XX(5)
      LOGICAL FATAL
      EXTERNAL FEIN
C***FIRST EXECUTABLE STATEMENT  EG8CK
      IF (KPRINT .GE. 2) WRITE (LUN,90000)
      IPASS=1
      TOL = SQRT(MAX(R1MACH(4),1.0E-18))
      DO 150 KODE=1,2
        IK = KODE - 1
        FKM = IK
        DO 140 N=1,25,8
          DO 130 M=1,4
            NM = N + M - 1
            DO 120 IX=1,25,8
              X = IX- 0.20E0
              CALL EXINT(X, N, KODE, M, TOL, EN, NZ, IERR)
              KX = X+0.5E0
              IF (KX.EQ.0) KX = 1
              ICASE = 1
              A = N
              IF (KX.LE.N) GO TO 10
              ICASE = 2
              A = NM
              IF (KX.GE.NM) GO TO 10
              ICASE = 3
              A = KX
   10         CONTINUE
              SIG = 3.0E0/X
              T2 = 1.0E0
              SUM = 0.0E0
   20         CONTINUE
              T1 = T2
              T2 = T2 + SIG
              ATOL = TOL
              CALL GAUS8(FEIN, T1, T2, ATOL, ANS, IERR)
              SUM = SUM + ANS
              IF (ABS(ANS).LT.ABS(SUM)*TOL) GO TO 30
              GO TO 20
   30         CONTINUE
              EX = 1.0E0
              IF (KODE.EQ.1) EX = EXP(-X)
              BB = A
              IF (ICASE.NE.3) GO TO 40
              IY = KX - N + 1
              Y(IY) = SUM
              KE = M - IY
              IE = IY - 1
              KK = IY
              II = IY
              GO TO 60
   40         CONTINUE
              IF (ICASE.NE.2) GO TO 50
              Y(M) = SUM
              IF (M.EQ.1) GO TO 100
              IE = M - 1
              II = M
              GO TO 80
   50         CONTINUE
              Y(1) = SUM
              IF (M.EQ.1) GO TO 100
              KE = M - 1
              KK = 1
   60         CONTINUE
C
C             Forward recur
C
              DO 70 K=1,KE
                Y(KK+1) = (EX-X*Y(KK))/BB
                BB = BB + 1.0E0
                KK = KK + 1
   70         CONTINUE
              IF (ICASE.NE.3) GO TO 100
   80         BB = A - 1.0E0
C
C             Backward recur
C
              DO 90 I=1,IE
                Y(II-1) = (EX-BB*Y(II))/X
                BB = BB - 1.0E0
                II = II - 1
   90         CONTINUE
  100         CONTINUE
              DO 110 I=1,M
                ER = ABS((Y(I)-EN(I))/Y(I))
                IF (ER .GT. TOL) THEN
                   WRITE (LUN,90010)
                   IPASS = 0
                   GO TO 160
                ENDIF
  110         CONTINUE
  120       CONTINUE
  130     CONTINUE
  140   CONTINUE
  150 CONTINUE
C
C     Trigger 6 error conditions.
C
  160 FATAL = .FALSE.
C
      IF (KPRINT .GE. 3) WRITE (LUN, 90020)
      XX(1) = 1.0E0
      XX(2) = 1.0E0
      XX(3) = 1.0E0
      XX(4) = 1.0E0
      XX(5) = 0.01E0
      DO 170 I=1,5
        XX(I) = -XX(I)
        K = XX(2)
        N = XX(3)
        M = XX(4)
        CALL EXINT (XX(I), N, K, M, XX(5), EN, NZ, IERR)
        IF (IERR .NE. 1) THEN
           IPASS = 0
           FATAL = .TRUE.
           WRITE (LUN, 90030) I
        ENDIF
        XX(I) = -XX(I)
  170 CONTINUE
      X = 0.0E0
      TOL = 1.0E-2
      CALL EXINT (X, 1, 1, 1, TOL, EN, NZ, IERR)
      IF (IERR .NE. 1) THEN
         IPASS = 0
         FATAL = .TRUE.
         WRITE (LUN, 90040)
      ENDIF
      IF (FATAL) THEN
         IF (KPRINT .GE. 2) THEN
            WRITE (LUN, 90070)
         ENDIF
      ELSE
         IF (KPRINT .GE. 3) THEN
            WRITE (LUN, 90080)
         ENDIF
      ENDIF
C
      IF(IPASS.EQ.1 .AND. KPRINT.GE.2) WRITE (LUN, 90100)
      IF(IPASS.EQ.0 .AND. KPRINT.GE.1) WRITE (LUN, 90110)
      RETURN
C
90000 FORMAT ('1' / ' QUICK CHECK FOR EXINT AND GAUS8' /)
90010 FORMAT (// ' ERROR IN EG8CK COMPARISON TEST' /)
90020 FORMAT (/ ' TRIGGER 6 ERROR CONDITIONS')
90030 FORMAT (' Error occurred with DO index I =', I2)
90040 FORMAT (' Error occurred with X = 0.0')
90070 FORMAT (/' AT LEAST ONE INCORRECT ARGUMENT TEST FAILED')
90080 FORMAT (/' ALL INCORRECT ARGUMENT TESTS PASSED')
90100 FORMAT (/ ' **********EXINT AND GAUS8 PASSED ALL TESTS**********')
90110 FORMAT (/ ' **********EXINT OR GAUS8 FAILED SOME TESTS**********')
      END

*DECK F1C
      REAL FUNCTION F1C (X)
C***BEGIN PROLOGUE  F1C
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F1C
      REAL X
C***FIRST EXECUTABLE STATEMENT  F1C
      F1C = 0.0
      IF(X.NE.0.33) F1C = (X-0.5)*ABS(X-0.33)**(-0.9)
      RETURN
      END

*DECK F3S
      REAL FUNCTION F3S (X)
C***BEGIN PROLOGUE  F3S
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F3S
      REAL X
C***FIRST EXECUTABLE STATEMENT  F3S
      F3S = 0.1E+01
      IF(X.GT.3.1415926535897932) F3S = 0.0
      RETURN
      END

*DECK SCHK42
      SUBROUTINE SCHK42 (SNAME, EPS, THRESH, NOUT, KPRINT, FATAL, NIDIM,
     $   IDIM, NALF, ALF, NINC, INC, NMAX, INCMAX, A, AA, AS, X, XX, XS,
     $   Y, YY, YS, YT, G, Z)
C***BEGIN PROLOGUE  SCHK42
C***SUBSIDIARY
C***PURPOSE  Quick check for SGER.
C***LIBRARY   SLATEC (BLAS)
C***KEYWORDS  BLAS, QUICK CHECK SERVICE ROUTINE
C***AUTHOR  Du Croz, J. (NAG)
C           Hanson, R. J. (SNLA)
C***DESCRIPTION
C
C  Quick check for SGER.
C
C  Auxiliary routine for test program for Level 2 Blas.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  LSE, LSERES, NUMXER, SGER, SMAKE2, SMVCH
C***REVISION HISTORY  (YYMMDD)
C   870810  DATE WRITTEN
C   910619  Modified to meet SLATEC code and prologue standards.  (BKS)
C***END PROLOGUE  SCHK42
C     .. Parameters ..
      REAL               ZERO, HALF, ONE
      PARAMETER          ( ZERO = 0.0, HALF = 0.5, ONE = 1.0 )
C     .. Scalar Arguments ..
      LOGICAL            FATAL
      REAL               EPS, THRESH
      INTEGER            INCMAX, KPRINT, NALF, NIDIM, NINC, NMAX, NOUT
      CHARACTER*6        SNAME
C     .. Array Arguments ..
      REAL               A( NMAX, NMAX ), AA( NMAX*NMAX ), ALF( NALF ),
     $                   AS( NMAX*NMAX ), G( NMAX ), X( NMAX ),
     $                   XS( NMAX*INCMAX ), XX( NMAX*INCMAX ),
     $                   Y( NMAX ), YS( NMAX*INCMAX ), YT( NMAX ),
     $                   YY( NMAX*INCMAX ), Z( NMAX )
      INTEGER            IDIM( NIDIM ), INC( NINC )
C     .. Local Scalars ..
      REAL               ALPHA, ALS, ERR, ERRMAX, TRANSL
      INTEGER            I, IA, IM, IN, INCX, INCXS, INCY, INCYS, IX,
     $                   IY, J, LAA, LDA, LDAS, LX, LY, M, MS, N, NARGS,
     $                   NC, ND, NS, NERR
      LOGICAL            FTL, NULL, RESET
C     .. Local Arrays ..
      REAL               W( 1 )
      LOGICAL            ISAME( 13 )
C     .. External Functions ..
      INTEGER            NUMXER
      LOGICAL            LSE, LSERES
      EXTERNAL           LSE, LSERES, NUMXER
C     .. External Subroutines ..
      EXTERNAL           SGER, SMAKE2, SMVCH
C     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN
C***FIRST EXECUTABLE STATEMENT SCHK42
C     Define the number of arguments.
      NARGS = 9
C
      NC = 0
      RESET = .TRUE.
      ERRMAX = ZERO
C
      DO 120 IN = 1, NIDIM
         N = IDIM( IN )
         ND = N/2 + 1
C
         DO 110 IM = 1, 2
            IF( IM.EQ.1 )
     $         M = MAX( N - ND, 0 )
            IF( IM.EQ.2 )
     $         M = MIN( N + ND, NMAX )
C
C           Set LDA to 1 more than minimum value if room.
            LDA = M
            IF( LDA.LT.NMAX )
     $         LDA = LDA + 1
C           Skip tests if not enough room.
            IF( LDA.GT.NMAX )
     $         GO TO 110
            LAA = LDA*N
            NULL = N.LE.0.OR.M.LE.0
C
            DO 100 IX = 1, NINC
               INCX = INC( IX )
               LX = ABS( INCX )*M
C
C              Generate the vector X.
C
               TRANSL = HALF
               CALL SMAKE2( 'GE', ' ', ' ', 1, M, X, 1, XX, ABS( INCX ),
     $                     0, M - 1, RESET, TRANSL )
               IF( M.GT.1 )THEN
                  X( M/2 ) = ZERO
                  XX( 1 + ABS( INCX )*( M/2 - 1 ) ) = ZERO
               END IF
C
               DO 90 IY = 1, NINC
                  INCY = INC( IY )
                  LY = ABS( INCY )*N
C
C                 Generate the vector Y.
C
                  TRANSL = ZERO
                  CALL SMAKE2( 'GE', ' ', ' ', 1, N, Y, 1, YY,
     $                        ABS( INCY ), 0, N - 1, RESET, TRANSL )
                  IF( N.GT.1 )THEN
                     Y( N/2 ) = ZERO
                     YY( 1 + ABS( INCY )*( N/2 - 1 ) ) = ZERO
                  END IF
C
                  DO 80 IA = 1, NALF
                     ALPHA = ALF( IA )
C
C                    Generate the matrix A.
C
                     TRANSL = ZERO
                     CALL SMAKE2(SNAME( 2: 3 ), ' ', ' ', M, N, A, NMAX,
     $                           AA, LDA, M - 1, N - 1, RESET, TRANSL )
C
                     NC = NC + 1
C
C                    Save every datum before calling the subroutine.
C
                     MS = M
                     NS = N
                     ALS = ALPHA
                     DO 10 I = 1, LAA
                        AS( I ) = AA( I )
   10                CONTINUE
                     LDAS = LDA
                     DO 20 I = 1, LX
                        XS( I ) = XX( I )
   20                CONTINUE
                     INCXS = INCX
                     DO 30 I = 1, LY
                        YS( I ) = YY( I )
   30                CONTINUE
                     INCYS = INCY
C
C                    Call the subroutine.
C
                     CALL SGER( M, N, ALPHA, XX, INCX, YY, INCY, AA,
     $                          LDA )
C
C                    Check if error-exit was taken incorrectly.
C
                     IF (NUMXER(NERR) .NE. 0) THEN
                        IF (KPRINT .GE. 2) THEN
                          WRITE( NOUT, FMT = 9993 )
                        ENDIF
                        FATAL = .TRUE.
                     END IF
C
C                    See what data changed inside subroutine.
C
                     ISAME( 1 ) = MS.EQ.M
                     ISAME( 2 ) = NS.EQ.N
                     ISAME( 3 ) = ALS.EQ.ALPHA
                     ISAME( 4 ) = LSE( XS, XX, LX )
                     ISAME( 5 ) = INCXS.EQ.INCX
                     ISAME( 6 ) = LSE( YS, YY, LY )
                     ISAME( 7 ) = INCYS.EQ.INCY
                     IF( NULL )THEN
                        ISAME( 8 ) = LSE( AS, AA, LAA )
                     ELSE
                        ISAME( 8 ) = LSERES( 'GE', ' ', M, N, AS, AA,
     $                               LDA )
                     END IF
                     ISAME( 9 ) = LDAS.EQ.LDA
C
C                    If data was incorrectly changed, report and return.
C
                     DO 40 I = 1, NARGS
                       IF (.NOT. ISAME( I )) THEN
                         FATAL = .TRUE.
                         IF (KPRINT .GE. 2) THEN
                           WRITE( NOUT, FMT = 9998 )I
                         ENDIF
                       ENDIF
  40                 CONTINUE
C
                     FTL = .FALSE.
                     IF( .NOT.NULL )THEN
C
C                       Check the result column by column.
C
                        IF( INCX.GT.0 )THEN
                           DO 50 I = 1, M
                              Z( I ) = X( I )
   50                      CONTINUE
                        ELSE
                           DO 60 I = 1, M
                              Z( I ) = X( M - I + 1 )
   60                      CONTINUE
                        END IF
                        DO 70 J = 1, N
                           IF( INCY.GT.0 )THEN
                              W( 1 ) = Y( J )
                           ELSE
                              W( 1 ) = Y( N - J + 1 )
                           END IF
                           CALL SMVCH( 'N', M, 1, ALPHA, Z, NMAX, W, 1,
     $                                 ONE, A( 1, J ), 1, YT, G,
     $                                 AA( 1 + ( J - 1 )*LDA ), EPS,
     $                                 ERR, FTL, NOUT, .TRUE., KPRINT)
                           ERRMAX = MAX( ERRMAX, ERR )
   70                   CONTINUE
                     END IF
                     IF (FTL) THEN
                       FATAL = .TRUE.
                       IF (KPRINT .GE. 3) THEN
                         WRITE( NOUT, FMT = 9995 )J
                         WRITE( NOUT, FMT = 9996 )SNAME
                         WRITE( NOUT, FMT = 9994 )NC, SNAME, M,
     $                    N, ALPHA, INCX, INCY, LDA
                       ENDIF
                     ENDIF
C
   80             CONTINUE
C
   90          CONTINUE
C
  100       CONTINUE
C
  110    CONTINUE
C
  120 CONTINUE
C
C     Report result.
C
      IF (.NOT. (FATAL)) THEN
        IF (KPRINT .GE. 3) THEN
          IF( ERRMAX.LT.THRESH )THEN
             WRITE( NOUT, FMT = 9999 )SNAME, NC
          ELSE
             WRITE( NOUT, FMT = 9997 )SNAME, NC, ERRMAX
          END IF
        ENDIF
      ENDIF
      RETURN
C
 9999 FORMAT( ' ', A6, ' PASSED THE COMPUTATIONAL TESTS (', I6, ' CALL',
     $      'S)' )
 9998 FORMAT( ' ******* FATAL ERROR - PARAMETER NUMBER ', I2, ' WAS CH',
     $      'ANGED INCORRECTLY *******' )
 9997 FORMAT( ' ', A6, ' COMPLETED THE COMPUTATIONAL TESTS (', I6, ' C',
     $      'ALLS)', /' ******* BUT WITH MAXIMUM TEST RATIO', F8.2,
     $      ' - SUSPECT *******' )
 9996 FORMAT( ' ******* ', A6, ' FAILED ON CALL NUMBER:' )
 9995 FORMAT( '      THESE ARE THE RESULTS FOR COLUMN ', I3 )
 9994 FORMAT( 1X, I6, ': ', A6, '(', 2( I3, ',' ), F4.1, ', X,', I2,
     $      ', Y,', I2, ', A,', I3, ')                  .' )
 9993 FORMAT( ' ******* FATAL ERROR - ERROR-EXIT TAKEN ON VALID CALL *',
     $      '******' )
C
C     End of SCHK42.
C
      END

*DECK F1G
      REAL FUNCTION F1G (X)
C***BEGIN PROLOGUE  F1G
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F1G
      REAL PI,X
      DATA PI/3.1415926535897932/
C***FIRST EXECUTABLE STATEMENT  F1G
      F1G = 2.0/(2.0+SIN(10.0*PI*X))
      RETURN
      END

*DECK FQD2
      REAL FUNCTION FQD2 (X)
C***BEGIN PROLOGUE  FQD2
C***SUBSIDIARY
C***PURPOSE  Function evaluator for QNC79 and GAUS8 quick checks.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (FQD2-S, DFQD2-D)
C***AUTHOR  Boland, W. Robert, (LANL)
C***SEE ALSO  QG8TST, QN79QX
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   920229  DATE WRITTEN
C***END PROLOGUE  FQD2
C     .. Scalar Arguments ..
      REAL X
C     .. Intrinsic Functions ..
      INTRINSIC COS, EXP
C***FIRST EXECUTABLE STATEMENT  FQD2
      FQD2 = EXP(X)*COS(10.0E0*X)
      RETURN
      END

*DECK F4P
      REAL FUNCTION F4P (X)
C***BEGIN PROLOGUE  F4P
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F4P
      REAL X
C***FIRST EXECUTABLE STATEMENT  F4P
      F4P = 0.0
      IF(X.GT.0.0) F4P = 1.0/(X*SQRT(X))
      RETURN
      END

*DECK DPRIN
      SUBROUTINE DPRIN (LUN, NUM1, KPRINT, IP, EXACT, RESULT, ABSERR,
     +   NEVAL, IERV, LIERV)
C***BEGIN PROLOGUE  DPRIN
C***SUBSIDIARY
C***PURPOSE  Subsidiary to CDQAG, CDQAG, CDQAGI, CDQAGP, CDQAGS, CDQAWC,
C            CDQAWF, CDQAWO, CDQAWS, and CDQNG.
C***LIBRARY   SLATEC
C***AUTHOR  Piessens, Robert
C             Applied Mathematics and Programming Division
C             K. U. Leuven
C           de Doncker, Elise
C             Applied Mathematics and Programming Division
C             K. U. Leuven
C***DESCRIPTION
C
C   This program is called by the (double precision) Quadpack quick
C   check routines for printing out their messages.
C
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   811027  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   910627  Code completely rewritten.  (WRB)
C***END PROLOGUE  DPRIN
C     .. Scalar Arguments ..
      DOUBLE PRECISION ABSERR, EXACT, RESULT
      INTEGER IP, KPRINT, LIERV, LUN, NEVAL, NUM1
C     .. Array Arguments ..
      INTEGER IERV(*)
C     .. Local Scalars ..
      DOUBLE PRECISION ERROR
      INTEGER IER, K
C     .. Intrinsic Functions ..
      INTRINSIC ABS
C***FIRST EXECUTABLE STATEMENT  DPRIN
      IER = IERV(1)
      ERROR = ABS(EXACT-RESULT)
C
      IF (KPRINT .GE. 2) THEN
        IF (IP.EQ.1) THEN
          IF (KPRINT .GE. 3) THEN
C
C           Write PASS message.
C
            WRITE (UNIT=LUN, FMT=9000) NUM1
          ENDIF
        ELSE
C
C         Write failure messages.
C
          WRITE (UNIT=LUN, FMT=9010) NUM1
          IF (NUM1 .EQ. 0) WRITE (UNIT=LUN, FMT=9020)
          IF (NUM1 .GT. 0) WRITE (UNIT=LUN, FMT=9030) NUM1
          IF (LIERV .GT. 1) WRITE (UNIT=LUN, FMT=9040) (IERV(K),
     +                      K=2,LIERV)
          IF (NUM1 .EQ. 6) WRITE (UNIT=LUN, FMT=9050)
          WRITE (UNIT=LUN, FMT=9060)
          WRITE (UNIT=LUN, FMT=9070)
          IF (NUM1 .NE. 5) THEN
            WRITE (UNIT=LUN, FMT=9080) EXACT,RESULT,ERROR,ABSERR,IER,
     +                                 NEVAL
          ELSE
            WRITE (LUN,FMT=9090) RESULT,ABSERR,IER,NEVAL
          ENDIF
        ENDIF
      ENDIF
C
      RETURN
C
 9000 FORMAT (' TEST ON IER = ', I2, ' PASSED')
 9010 FORMAT (' TEST ON IER = ', I1, ' FAILED.')
 9020 FORMAT (' WE MUST HAVE IER = 0, ERROR.LE.ABSERR AND ABSERR.LE',
     +        '.MAX(EPSABS,EPSREL*ABS(EXACT))')
 9030 FORMAT (' WE MUST HAVE IER = ', I1)
 9040 FORMAT (' OR IER =     ', 8(I1,2X))
 9050 FORMAT (' RESULT, ABSERR, NEVAL AND EVENTUALLY LAST SHOULD BE',
     +        ' ZERO')
 9060 FORMAT (' WE HAVE   ')
 9070 FORMAT (7X, 'EXACT', 11X, 'RESULT', 6X, 'ERROR', 4X, 'ABSERR',
     +        4X, 'IER     NEVAL', /, ' ', 42X,
     +        '(EST.ERR.)(FLAG)(NO F-EVAL)')
 9080 FORMAT (' ', 2(D15.7,1X), 2(D9.2,1X), I4, 4X, I6)
 9090 FORMAT (5X, 'INFINITY', 4X, D15.7, 11X, D9.2, I5, 4X, I6)
      END

*DECK DPCHQ1
      SUBROUTINE DPCHQ1 (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  DPCHQ1
C***PURPOSE  Test the PCHIP evaluators DCHFDV, DCHFEV, DPCHFD, DPCHFE.
C***LIBRARY   SLATEC (PCHIP)
C***TYPE      DOUBLE PRECISION (PCHQK1-S, DPCHQ1-D)
C***KEYWORDS  PCHIP EVALUATOR QUICK CHECK
C***AUTHOR  Fritsch, F. N., (LLNL)
C***DESCRIPTION
C
C             DPCHIP QUICK CHECK NUMBER 1
C
C     TESTS THE EVALUATORS:  DCHFDV, DCHFEV, DPCHFD, DPCHFE.
C *Usage:
C
C        INTEGER  LUN, KPRINT, IPASS
C
C        CALL DPCHQ1 (LUN, KPRINT, IPASS)
C
C *Arguments:
C
C     LUN   :IN  is the unit number to which output is to be written.
C
C     KPRINT:IN  controls the amount of output, as specified in the
C                SLATEC Guidelines.
C
C     IPASS:OUT  will contain a pass/fail flag.  IPASS=1 is good.
C                IPASS=0 indicates one or more tests failed.
C
C *Description:
C
C   This routine carries out three tests of the PCH evaluators:
C     DEVCHK tests the single-cubic evaluators.
C     DEVPCK tests the full PCH evaluators.
C     DEVERK exercises the error returns in all evaluators.
C
C***ROUTINES CALLED  DEVCHK, DEVERK, DEVPCK
C***REVISION HISTORY  (YYMMDD)
C   820601  DATE WRITTEN
C   890306  Changed IPASS to the more accurate name IFAIL.  (FNF)
C   890307  Removed conditional on call to DEVERK.
C   890706  Cosmetic changes to prologue.  (WRB)
C   891004  Correction in prologue.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900309  Added DEVERK to list of routines called.  (FNF)
C   900314  Improved some output formats.
C   900315  Revised prologue and improved some output formats.  (FNF)
C   900316  Additional minor cosmetic changes.  (FNF)
C   900321  Removed IFAIL from call sequence for SLATEC standards and
C           made miscellaneous cosmetic changes.  (FNF)
C   930317  Improved output formats.  (FNF)
C***END PROLOGUE  DPCHQ1
C
C  Declare arguments.
C
      INTEGER  LUN, KPRINT, IPASS
C
C  DECLARE LOCAL VARIABLES.
C
      INTEGER  I1, I2, I3, I4, I5, I6, I7, I8, I9, IFAIL, NPTS
      DOUBLE PRECISION  WORK (4000)
      LOGICAL  FAIL
C
C***FIRST EXECUTABLE STATEMENT  DPCHQ1
      IF (KPRINT .GE. 2)  WRITE (LUN, 1000) KPRINT
C
C  TEST DCHFDV AND DCHFEV.
C
      IFAIL = 0
      NPTS = 1000
      I1 = 1  + NPTS
      I2 = I1 + NPTS
      I3 = I2 + NPTS
      CALL DEVCHK (LUN, KPRINT, NPTS, WORK(1), WORK(I1), WORK(I2),
     *                                          WORK(I3), FAIL)
      IF (FAIL)  IFAIL = IFAIL + 1
C
C  TEST DPCHFD AND DPCHFE.
C
      I1 = 1  +  10
      I2 = I1 +  10
      I3 = I2 + 100
      I4 = I3 + 100
      I5 = I4 + 100
      I6 = I5 +  51
      I7 = I6 +  51
      I8 = I7 +  51
      I9 = I8 +  51
      CALL DEVPCK (LUN, KPRINT, WORK(1), WORK(I1), WORK(I2), WORK(I3),
     *             WORK(I4), WORK(I5), WORK(I6), WORK(I7), WORK(I8),
     *             WORK(I9), FAIL)
      IF (FAIL)  IFAIL = IFAIL + 2
C
C  TEST ERROR RETURNS.
C
      CALL DEVERK (LUN, KPRINT, FAIL)
      IF (FAIL)  IFAIL = IFAIL + 4
C
C  PRINT SUMMARY AND TERMINATE.
C     At this point, IFAIL has the following value:
C        IFAIL = 0  IF ALL TESTS PASSED.
C        IFAIL BETWEEN 1 AND 7 IS THE SUM OF:
C           IFAIL=1  IF SINGLE CUBIC  TEST FAILED. (SEE DEVCHK OUTPUT.)
C           IFAIL=2  IF DPCHFD/DPCHFE TEST FAILED. (SEE DEVPCK OUTPUT.)
C           IFAIL=4  IF ERROR RETURN  TEST FAILED. (SEE DEVERK OUTPUT.)
C
      IF ((KPRINT.GE.2).AND.(IFAIL.NE.0))  WRITE (LUN, 3001)  IFAIL
C
      IF (IFAIL.EQ.0)  THEN
         IPASS = 1
         IF (KPRINT.GE.2) WRITE(LUN,99998)
      ELSE
         IPASS = 0
         IF (KPRINT.GE.1) WRITE(LUN,99999)
      ENDIF
C
      RETURN
C
C  FORMATS.
C
 1000 FORMAT ('1'/' ------------ DPCHIP QUICK CHECK OUTPUT',
     *        ' ------------' //20X,'( KPRINT =',I2,' )')
 3001 FORMAT (/' *** TROUBLE ***',I5,' EVALUATION TESTS FAILED.')
99998 FORMAT (/' ------------ DPCHIP PASSED  ALL EVALUATION TESTS',
     *        ' ------------')
99999 FORMAT (/' ************ DPCHIP FAILED SOME EVALUATION TESTS',
     *        ' ************')
C------------- LAST LINE OF DPCHQ1 FOLLOWS -----------------------------
      END

*DECK SDRES2
      SUBROUTINE SDRES2 (T, Y, YPRIME, DELTA, IRES, RPAR, IPAR)
C***BEGIN PROLOGUE  SDRES2
C***SUBSIDIARY
C***PURPOSE  Second residual evaluator for SDASQC.
C***LIBRARY   SLATEC (DASSL)
C***TYPE      SINGLE PRECISION (SDRES2-S, DDRES2-D)
C***AUTHOR  PETZOLD, LINDA R., (LLNL)
C***SEE ALSO  SDASQC
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   891013  DATE WRITTEN
C   901001  Converted prologue to 4.0 format and made all argument
C           declarations explicit.  (FNF)
C   901030  Made all local declarations explicit.  (FNF)
C***END PROLOGUE  SDRES2
      INTEGER  IRES, IPAR(*)
      REAL  T, Y(*), YPRIME(*), DELTA(*), RPAR(*)
      INTEGER  I, J, K, NG
      REAL  ALPH1, ALPH2, D
      DATA ALPH1/1.0E0/, ALPH2/1.0E0/, NG/5/
C***FIRST EXECUTABLE STATEMENT  SDRES2
      DO 10 J = 1,NG
      DO 10 I = 1,NG
        K = I + (J - 1)*NG
        D = -2.0E0*Y(K)
        IF (I .NE. 1) D = D + Y(K-1)*ALPH1
        IF (J .NE. 1) D = D + Y(K-NG)*ALPH2
 10     DELTA(K) = D - YPRIME(K)
      RETURN
      END

*DECK F1N
      REAL FUNCTION F1N (X)
C***BEGIN PROLOGUE  F1N
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F1N
      REAL X
C***FIRST EXECUTABLE STATEMENT  F1N
      F1N=1.0E0/(X**4+X**2+1.0E0)
      RETURN
      END

*DECK F0WS
      REAL FUNCTION F0WS (X)
C***BEGIN PROLOGUE  F0WS
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F0WS
      REAL X
C***FIRST EXECUTABLE STATEMENT  F0WS
      F0WS  = SIN(10.0*X)
      RETURN
      END

*DECK SCHK22
      SUBROUTINE SCHK22 (SNAME, EPS, THRESH, NOUT, KPRINT, FATAL, NIDIM,
     $   IDIM, NKB, KB, NALF, ALF, NBET, BET, NINC, INC, NMAX, INCMAX,
     $   A, AA, AS, X, XX, XS, Y, YY, YS, YT, G)
C***BEGIN PROLOGUE  SCHK22
C***SUBSIDIARY
C***PURPOSE  Quick check for SSYMV, SSBMV and SSPMV.
C***LIBRARY   SLATEC (BLAS)
C***KEYWORDS  BLAS, QUICK CHECK SERVICE ROUTINE
C***AUTHOR  Du Croz, J. (NAG)
C           Hanson, R. J. (SNLA)
C***DESCRIPTION
C
C  Quick check for SSYMV, SSBMV and SSPMV.
C
C  Auxiliary routine for test program for Level 2 Blas.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  LSE, LSERES, NUMXER, SMAKE2, SMVCH, SSBMV, SSPMV,
C                    SSYMV
C***REVISION HISTORY  (YYMMDD)
C   870810  DATE WRITTEN
C   910619  Modified to meet SLATEC code and prologue standards.  (BKS)
C***END PROLOGUE  SCHK22
C     .. Parameters ..
      REAL               ZERO, HALF
      PARAMETER          ( ZERO = 0.0, HALF = 0.5 )
C     .. Scalar Arguments ..
      LOGICAL            FATAL
      REAL               EPS, THRESH
      INTEGER            INCMAX, KPRINT, NALF, NBET, NIDIM, NINC, NKB,
     $                   NMAX, NOUT
      CHARACTER*6        SNAME
C     .. Array Arguments ..
      REAL               A( NMAX, NMAX ), AA( NMAX*NMAX ), ALF( NALF ),
     $                   AS( NMAX*NMAX ), BET( NBET ), G( NMAX ),
     $                   X( NMAX ), XS( NMAX*INCMAX ),
     $                   XX( NMAX*INCMAX ), Y( NMAX ),
     $                   YS( NMAX*INCMAX ), YT( NMAX ),
     $                   YY( NMAX*INCMAX )
      INTEGER            IDIM( NIDIM ), INC( NINC ), KB( NKB )
C     .. Local Scalars ..
      REAL               ALPHA, ALS, BETA, BLS, ERR, ERRMAX, TRANSL
      INTEGER            I, IA, IB, IC, IK, IN, INCX, INCXS, INCY,
     $                   INCYS, IX, IY, K, KS, LAA, LDA, LDAS, LX, LY,
     $                   N, NARGS, NC, NK, NS, NERR
      LOGICAL            BANDED, FTL, FULL, NULL, PACKED, RESET
      CHARACTER*1        UPLO, UPLOS
      CHARACTER*2        ICH
C     .. Local Arrays ..
      LOGICAL            ISAME( 13 )
C     .. External Functions ..
      INTEGER            NUMXER
      LOGICAL            LSE, LSERES
      EXTERNAL           LSE, LSERES, NUMXER
C     .. External Subroutines ..
      EXTERNAL           SMAKE2, SMVCH, SSBMV, SSPMV, SSYMV
C     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX
C     .. Data statements ..
      DATA               ICH/'UL'/
C***FIRST EXECUTABLE STATEMENT  SCHK22
      FULL = SNAME( 3: 3 ).EQ.'Y'
      BANDED = SNAME( 3: 3 ).EQ.'B'
      PACKED = SNAME( 3: 3 ).EQ.'P'
C     Define the number of arguments.
      IF( FULL )THEN
         NARGS = 10
      ELSE IF( BANDED )THEN
         NARGS = 11
      ELSE IF( PACKED )THEN
         NARGS = 9
      END IF
C
      NC = 0
      RESET = .TRUE.
      ERRMAX = ZERO
C
      DO 110 IN = 1, NIDIM
         N = IDIM( IN )
C
         IF( BANDED )THEN
            NK = NKB
         ELSE
            NK = 1
         END IF
         DO 100 IK = 1, NK
            IF( BANDED )THEN
               K = KB( IK )
            ELSE
               K = N - 1
            END IF
C           Set LDA to 1 more than minimum value if room.
            IF( BANDED )THEN
               LDA = K + 1
            ELSE
               LDA = N
            END IF
            IF( LDA.LT.NMAX )
     $         LDA = LDA + 1
C           Skip tests if not enough room.
            IF( LDA.GT.NMAX )
     $         GO TO 100
            IF( PACKED )THEN
               LAA = ( N*( N + 1 ) )/2
            ELSE
               LAA = LDA*N
            END IF
            NULL = N.LE.0
C
            DO 90 IC = 1, 2
               UPLO = ICH( IC: IC )
C
C              Generate the matrix A.
C
               TRANSL = ZERO
               CALL SMAKE2( SNAME( 2: 3 ), UPLO, ' ', N, N, A, NMAX, AA,
     $                     LDA, K, K, RESET, TRANSL )
C
               DO 80 IX = 1, NINC
                  INCX = INC( IX )
                  LX = ABS( INCX )*N
C
C                 Generate the vector X.
C
                  TRANSL = HALF
                  CALL SMAKE2( 'GE', ' ', ' ', 1, N, X, 1, XX,
     $                        ABS( INCX ), 0, N - 1, RESET, TRANSL )
                  IF( N.GT.1 )THEN
                     X( N/2 ) = ZERO
                     XX( 1 + ABS( INCX )*( N/2 - 1 ) ) = ZERO
                  END IF
C
                  DO 70 IY = 1, NINC
                     INCY = INC( IY )
                     LY = ABS( INCY )*N
C
                     DO 60 IA = 1, NALF
                        ALPHA = ALF( IA )
C
                        DO 50 IB = 1, NBET
                           BETA = BET( IB )
C
C                          Generate the vector Y.
C
                           TRANSL = ZERO
                           CALL SMAKE2( 'GE', ' ', ' ', 1, N, Y, 1, YY,
     $                                 ABS( INCY ), 0, N - 1, RESET,
     $                                 TRANSL )
C
                           NC = NC + 1
C
C                          Save every datum before calling the
C                          subroutine.
C
                           UPLOS = UPLO
                           NS = N
                           KS = K
                           ALS = ALPHA
                           DO 10 I = 1, LAA
                              AS( I ) = AA( I )
   10                      CONTINUE
                           LDAS = LDA
                           DO 20 I = 1, LX
                              XS( I ) = XX( I )
   20                      CONTINUE
                           INCXS = INCX
                           BLS = BETA
                           DO 30 I = 1, LY
                              YS( I ) = YY( I )
   30                      CONTINUE
                           INCYS = INCY
C
C                          Call the subroutine.
C
                           IF( FULL )THEN
                              CALL SSYMV( UPLO, N, ALPHA, AA, LDA, XX,
     $                                    INCX, BETA, YY, INCY )
                           ELSE IF( BANDED )THEN
                              CALL SSBMV( UPLO, N, K, ALPHA, AA, LDA,
     $                                    XX, INCX, BETA, YY, INCY )
                           ELSE IF( PACKED )THEN
                              CALL SSPMV( UPLO, N, ALPHA, AA, XX, INCX,
     $                                    BETA, YY, INCY )
                           END IF
C
C                          Check if error-exit was taken incorrectly.
C
                           IF (NUMXER(NERR) .NE. 0) THEN
                              IF (KPRINT .GE. 2) THEN
                                WRITE( NOUT, FMT = 9992 )
                              ENDIF
                              FATAL = .TRUE.
                           END IF
C
C                          See what data changed inside subroutines.
C
                           ISAME( 1 ) = UPLO.EQ.UPLOS
                           ISAME( 2 ) = NS.EQ.N
                           IF( FULL )THEN
                              ISAME( 3 ) = ALS.EQ.ALPHA
                              ISAME( 4 ) = LSE( AS, AA, LAA )
                              ISAME( 5 ) = LDAS.EQ.LDA
                              ISAME( 6 ) = LSE( XS, XX, LX )
                              ISAME( 7 ) = INCXS.EQ.INCX
                              ISAME( 8 ) = BLS.EQ.BETA
                              IF( NULL )THEN
                                 ISAME( 9 ) = LSE( YS, YY, LY )
                              ELSE
                                 ISAME( 9 ) = LSERES( 'GE', ' ', 1, N,
     $                                        YS, YY, ABS( INCY ) )
                              END IF
                              ISAME( 10 ) = INCYS.EQ.INCY
                           ELSE IF( BANDED )THEN
                              ISAME( 3 ) = KS.EQ.K
                              ISAME( 4 ) = ALS.EQ.ALPHA
                              ISAME( 5 ) = LSE( AS, AA, LAA )
                              ISAME( 6 ) = LDAS.EQ.LDA
                              ISAME( 7 ) = LSE( XS, XX, LX )
                              ISAME( 8 ) = INCXS.EQ.INCX
                              ISAME( 9 ) = BLS.EQ.BETA
                              IF( NULL )THEN
                                 ISAME( 10 ) = LSE( YS, YY, LY )
                              ELSE
                                 ISAME( 10 ) = LSERES( 'GE', ' ', 1, N,
     $                                         YS, YY, ABS( INCY ) )
                              END IF
                              ISAME( 11 ) = INCYS.EQ.INCY
                           ELSE IF( PACKED )THEN
                              ISAME( 3 ) = ALS.EQ.ALPHA
                              ISAME( 4 ) = LSE( AS, AA, LAA )
                              ISAME( 5 ) = LSE( XS, XX, LX )
                              ISAME( 6 ) = INCXS.EQ.INCX
                              ISAME( 7 ) = BLS.EQ.BETA
                              IF( NULL )THEN
                                 ISAME( 8 ) = LSE( YS, YY, LY )
                              ELSE
                                 ISAME( 8 ) = LSERES( 'GE', ' ', 1, N,
     $                                        YS, YY, ABS( INCY ) )
                              END IF
                              ISAME( 9 ) = INCYS.EQ.INCY
                           END IF
C
C                          If data was incorrectly changed, report and
C                          return.
C
                              DO 40 I = 1, NARGS
                                IF (.NOT. ISAME( I )) THEN
                                  FATAL = .TRUE.
                                  IF (KPRINT .GE. 2) THEN
                                    WRITE( NOUT, FMT = 9998 )I
                                  ENDIF
                                ENDIF
  40                          CONTINUE
C
                           FTL = .FALSE.
                           IF( .NOT.NULL )THEN
C
C                             Check the result.
C
                              CALL SMVCH( 'N', N, N, ALPHA, A, NMAX, X,
     $                                    INCX, BETA, Y, INCY, YT, G,
     $                                    YY, EPS, ERR, FTL, NOUT,
     $                                    .TRUE., KPRINT )
                              ERRMAX = MAX( ERRMAX, ERR )
                           END IF
                           IF (FTL) THEN
                             FATAL = .TRUE.
                             IF (KPRINT .GE. 3) THEN
                               WRITE( NOUT, FMT = 9996 )SNAME
                               IF( FULL )THEN
                                  WRITE( NOUT, FMT = 9993 )NC, SNAME,
     $                             UPLO, N, ALPHA, LDA,
     $                             INCX, BETA, INCY
                               ELSE IF( BANDED )THEN
                                  WRITE( NOUT, FMT = 9994 )NC, SNAME,
     $                             UPLO, N, K, ALPHA,
     $                             LDA, INCX, BETA, INCY
                               ELSE IF( PACKED )THEN
                                  WRITE( NOUT, FMT = 9995 )NC, SNAME,
     $                             UPLO, N, ALPHA, INCX,
     $                             BETA, INCY
                               END IF
                             ENDIF
                           ENDIF
C
   50                   CONTINUE
C
   60                CONTINUE
C
   70             CONTINUE
C
   80          CONTINUE
C
   90       CONTINUE
C
  100    CONTINUE
C
  110 CONTINUE
C
C     Report result.
C
      IF (.NOT. (FATAL)) THEN
        IF (KPRINT .GE. 3) THEN
          IF( ERRMAX.LT.THRESH )THEN
             WRITE( NOUT, FMT = 9999 )SNAME, NC
          ELSE
             WRITE( NOUT, FMT = 9997 )SNAME, NC, ERRMAX
          END IF
        ENDIF
      ENDIF
      RETURN
C
 9999 FORMAT( ' ', A6, ' PASSED THE COMPUTATIONAL TESTS (', I6, ' CALL',
     $      'S)' )
 9998 FORMAT( ' ******* FATAL ERROR - PARAMETER NUMBER ', I2, ' WAS CH',
     $      'ANGED INCORRECTLY *******' )
 9997 FORMAT( ' ', A6, ' COMPLETED THE COMPUTATIONAL TESTS (', I6, ' C',
     $      'ALLS)', /' ******* BUT WITH MAXIMUM TEST RATIO', F8.2,
     $      ' - SUSPECT *******' )
 9996 FORMAT( ' ******* ', A6, ' FAILED ON CALL NUMBER:' )
 9995 FORMAT( 1X, I6, ': ', A6, '(''', A1, ''',', I3, ',', F4.1, ', AP',
     $      ', X,', I2, ',', F4.1, ', Y,', I2, ')                .' )
 9994 FORMAT( 1X, I6, ': ', A6, '(''', A1, ''',', 2( I3, ',' ), F4.1,
     $      ', A,', I3, ', X,', I2, ',', F4.1, ', Y,', I2,
     $      ')         .' )
 9993 FORMAT( 1X, I6, ': ', A6, '(''', A1, ''',', I3, ',', F4.1, ', A,',
     $      I3, ', X,', I2, ',', F4.1, ', Y,', I2, ')             .' )
 9992 FORMAT( ' ******* FATAL ERROR - ERROR-EXIT TAKEN ON VALID CALL *',
     $      '******' )
C
C     End of SCHK22.
C
      END

*DECK QCPSI
      SUBROUTINE QCPSI (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  QCPSI
C***PURPOSE  Quick check for PSIFN.
C***LIBRARY   SLATEC
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Amos, D. E., (SNLA)
C***DESCRIPTION
C
C     ABSTRACT
C     QCPSI IS A QUICK CHECK ROUTINE WHICH EXERCISES THE MAJOR
C     LOOPS IN SUBROUTINE PSIFN(X,N,KODE,M,ANS,NZ,IERR) FOR DERIVATIVES
C     OF THE PSI FUNCTION.  FOR N=0, THE PSI FUNCTIONS ARE CALCULATED
C     EXPLICITLY AND CHECKED AGAINST EVALUATIONS FROM PSIFN. FOR
C     N.GT.0, CONSISTENCY CHECKS ARE MADE BY COMPARING A SEQUENCE
C     AGAINST SINGLE EVALUATIONS OF PSIFN, ONE AT A TIME.
C     IF THE RELATIVE ERROR IS LESS THAN 1000 TIMES UNIT ROUNDOFF,
C     THEN THE TEST IS PASSED--IF NOT,
C     THEN X, THE VALUES TO BE COMPARED, THE RELATIVE ERROR AND
C     PARAMETERS KODE AND N ARE WRITTEN ON LOGICAL UNIT 6 WHERE N IS
C     THE ORDER OF THE DERIVATIVE AND KODE IS A SELECTION PARAMETER
C     DEFINED IN THE PROLOGUE TO PSIFN.
C
C     FUNCTIONS I1MACH AND R1MACH MUST BE INITIALIZED ACCORDING TO THE
C     PROLOGUE IN EACH FUNCTION FOR THE MACHINE ENVIRONMENT BEFORE
C     QCPSI OR PSIFN CAN BE EXECUTED.
C
C***ROUTINES CALLED  PSIFN, R1MACH
C***REVISION HISTORY  (YYMMDD)
C   820601  DATE WRITTEN
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890911  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  QCPSI
      INTEGER I, IERR, IFLG, IX, KODE, LUN, M, N, NM, NN, NZ
      REAL ER, EULER, PSI1, PSI2, R1M4, S, TOL, X
      REAL R1MACH
      DIMENSION PSI1(3), PSI2(20)
      DATA EULER /0.5772156649015328606E0/
C***FIRST EXECUTABLE STATEMENT  QCPSI
      R1M4 = R1MACH(4)
      TOL = 1000.0E0*MAX(R1M4,1.0E-18)
      IF(KPRINT.GE.3)WRITE (LUN,99999)
99999 FORMAT (1H1//34H QUICK CHECK DIAGNOSTICS FOR PSIFN//)
C-----------------------------------------------------------------------
C     CHECK PSI(I) AND PSI(I-0.5), I=1,2,...
C-----------------------------------------------------------------------
      IFLG = 0
      N = 0
      DO 50 KODE=1,2
        DO 40 M=1,2
          S = -EULER + (M-1)*(-2.0E0*LOG(2.0E0))
          X = 1.0E0 - (M-1)*0.5E0
          DO 30 I=1,20
            CALL PSIFN(X, N, KODE, 1, PSI2, NZ, IERR)
            PSI1(1) = -S + (KODE-1)*LOG(X)
            ER = ABS((PSI1(1)-PSI2(1))/PSI1(1))
            IF (ER.LE.TOL) GO TO 20
            IF (IFLG.NE.0) GO TO 10
            IF(KPRINT.GE.2)WRITE (LUN,99998)
99998       FORMAT (8X, 1HX, 13X, 4HPSI1, 11X, 4HPSI2, 9X, 7HREL ERR,
     *       5X, 4HKODE, 3X, 1HN)
   10       CONTINUE
            IFLG = IFLG + 1
            IF(KPRINT.GE.2)
     *      WRITE (LUN,99997) X, PSI1(1), PSI2(I), ER, KODE, N
99997       FORMAT (4E15.6, 2I5)
            IF (IFLG.GT.200) GO TO 150
   20       CONTINUE
            S = S + 1.0E0/X
            X = X + 1.0E0
   30     CONTINUE
   40   CONTINUE
   50 CONTINUE
C-----------------------------------------------------------------------
C     CHECK SMALL X.LT.UNIT ROUNDOFF
C-----------------------------------------------------------------------
      KODE = 1
      X = TOL/10000.0E0
      N = 1
      CALL PSIFN(X, N, KODE, 1, PSI2, NZ, IERR)
      PSI1(1) = X**(-N-1)
      ER = ABS((PSI1(1)-PSI2(1))/PSI1(1))
      IF (ER.LE.TOL) GO TO 70
      IF (IFLG.NE.0) GO TO 60
      IF(KPRINT.GE.2)WRITE (LUN,99998)
   60 CONTINUE
      IFLG = IFLG + 1
      IF(KPRINT.GE.2)
     * WRITE (LUN,99997) X, PSI1(1), PSI2(1), ER, KODE, N
   70 CONTINUE
C-----------------------------------------------------------------------
C     CONSISTENCY TESTS FOR N.GE.0
C-----------------------------------------------------------------------
      DO 130 KODE=1,2
        DO 120 M=1,5
          DO 110 N=1,16,5
            NN = N - 1
            X = 0.1E0
            DO 100 IX=1,25,2
              X = X + 1.0E0
              CALL PSIFN(X, NN, KODE, M, PSI2, NZ, IERR)
              DO 90 I=1,M
                NM = NN + I - 1
                CALL PSIFN(X, NM, KODE, 1, PSI1, NZ, IERR)
                ER = ABS((PSI2(I)-PSI1(1))/PSI1(1))
                IF (ER.LT.TOL) GO TO 90
                IF (IFLG.NE.0) GO TO 80
                IF(KPRINT.GE.2)WRITE (LUN,99998)
   80           CONTINUE
                IFLG = IFLG + 1
                IF(KPRINT.GE.2)
     *          WRITE (LUN,99997) X, PSI1(1), PSI2(I), ER, KODE, NM
   90         CONTINUE
  100       CONTINUE
  110     CONTINUE
  120   CONTINUE
  130 CONTINUE
      IF (IFLG.NE.0.OR.KPRINT.LT.3) GO TO 140
      WRITE (LUN,99996)
99996 FORMAT (//16H QUICK CHECKS OK//)
  140 CONTINUE
      IPASS=0
      IF(IFLG.EQ.0)IPASS=1
      RETURN
  150 CONTINUE
      IF(KPRINT.GE.2)WRITE (LUN,99994)
99994 FORMAT (//52H PROCESSING OF MAIN LOOPS TERMINATED BECAUSE THE NUM,
     * 36HBER OF DIAGNOSTIC PRINTS EXCEEDS 200//)
      IPASS=0
      IF(IFLG.EQ.0)IPASS=1
      RETURN
      END

*DECK SDF
      SUBROUTINE SDF (N, T, Y, YP)
C***BEGIN PROLOGUE  SDF
C***SUBSIDIARY
C***PURPOSE  Quick check for SLATEC routines SDRIV1, SDRIV2 and SDRIV3.
C***LIBRARY   SLATEC (SDRIVE)
C***CATEGORY  I1A2, I1A1B
C***TYPE      SINGLE PRECISION (SDF-S, DDF-D, CDF-C)
C***KEYWORDS  QUICK CHECK, SDRIV1, SDRIV2, SDRIV3
C***AUTHOR  Kahaner, D. K., (NIST)
C             National Institute of Standards and Technology
C             Gaithersburg, MD  20899
C           Sutherland, C. D., (LANL)
C             Mail Stop D466
C             Los Alamos National Laboratory
C             Los Alamos, NM  87545
C***SEE ALSO  SDQCK
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   890405  DATE WRITTEN
C   890405  Revised to meet SLATEC standards.
C***END PROLOGUE  SDF
      REAL ALFA, T, Y(*), YP(*)
      INTEGER N
C***FIRST EXECUTABLE STATEMENT  SDF
      ALFA = Y(N+1)
      YP(1) = 1.E0 + ALFA*(Y(2) - Y(1)) - Y(1)*Y(3)
      YP(2) = ALFA*(Y(1) - Y(2)) - Y(2)*Y(3)
      YP(3) = 1.E0 - Y(3)*(Y(1) + Y(2))
      RETURN
      END

*DECK DQJAC2
      SUBROUTINE DQJAC2 (N, X, FVEC, FJAC, LDFJAC, IFLAG)
C***BEGIN PROLOGUE  DQJAC2
C***PURPOSE
C***LIBRARY   SLATEC
C***KEYWORDS  QUICK CHECK
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     SUBROUTINE TO EVALUATE THE FULL JACOBIAN FOR TEST PROBLEM USED
C     IN QUICK CHECK OF DNSQE.
C
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  DQJAC2
      INTEGER IFLAG, LDFJAC, N
      DOUBLE PRECISION FJAC(LDFJAC,*), FVEC(*), X(*)
C***FIRST EXECUTABLE STATEMENT  DQJAC2
      FJAC(1,1) = -1.0D0
      FJAC(1,2) = 0.0D0
      FJAC(2,1) = -2.0D1*X(1)
      FJAC(2,2) = 1.0D1
      RETURN
      END

*DECK SLAPQC
      SUBROUTINE SLAPQC (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  SLAPQC
C***PURPOSE  Quick check for testing Sparse Linear Algebra Package
C            (SLAP) Version 2.0.2.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      SINGLE PRECISION (SLAPQC-S, DLAPQC-D)
C***KEYWORDS  QUICK CHECK, SLAP
C***AUTHOR  Mark K. Seager (LLNL)
C             seager@llnl.gov
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-300
C             Livermore, CA 94550
C             (510) 423-3141
C***DESCRIPTION
C
C *Arguments:
C     KPRINT = 0  Quick checks - No printing.
C                 Driver       - Short pass or fail message printed.
C              1  Quick checks - No message printed for passed tests,
C                                short message printed for failed tests.
C                 Driver       - Short pass or fail message printed.
C              2  Quick checks - Print short message for passed tests,
C                                fuller information for failed tests.
C                 Driver       - Pass or fail message printed.
C              3  Quick checks - Print complete quick check results.
C                 Driver       - Pass or fail message printed.
C              4  Quick checks - Print complete quick check results.
C                                Prints matrices, etc.  Very verbose!!
C                                                       --------------
C                 Driver       - Pass or fail message printed.
C
C *Description:
C         This is a SLATEC Quick Check program to test the *SLAP*
C         Version 2.0.2 package.  It generates a "random" matrix (See
C         SRMGEN) and then runs all the various methods with all the
C         various preconditioners and all the various stop tests.
C
C         It is assumed that the test is being run interactively and
C         that STDIN (STANDARD INPUT) is Fortran I/O unit I1MACH(1)
C         and STDOUT (STANDARD OUTPUT) is unit I1MACH(2).
C
C         *************************************************************
C         **** WARNING !!! WARNING !!! WARNING !!! WARNING !!! WARNING
C         *************************************************************
C         **** THIS PROGRAM WILL NOT FUNCTION PROPERLY IF THE FORTRAN
C         **** I/O UNITS I1MACH(1) and I1MACH(2) are not connected
C         **** to the program for I/O.
C         *************************************************************
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  OUTERR, R1MACH, SCPPLT, SRMGEN, SS2Y,
C                    SSDBCG, SSDCG, SSDCGN, SSDCGS, SSDGMR, SSDOMN,
C                    SSGS, SSICCG, SSILUR, SSJAC, SSLUBC, SSLUCN,
C                    SSLUCS, SSLUGM, SSLUOM, VFILL, XERMAX, XSETF,
C                    XSETUN
C***COMMON BLOCKS    SSLBLK
C***REVISION HISTORY  (YYMMDD)
C   880601  DATE WRITTEN
C   881213  Revised to meet the new SLATEC prologue standards.
C   890920  Modified to reduce single/double differences and to meet
C           SLATEC standards, as requested at July 1989 CML Meeting.
C   891003  Reduced MAXN to a more reasonable size for quick check.
C   920401  Made routine a SUBROUTINE and made necessary changes to
C           interface with a SLATEC quick check driver.  (WRB)
C   920407  COMMON BLOCK renamed SSLBLK.  (WRB)
C   920511  Added complete declaration section.  (WRB)
C   920602  Eliminated unnecessary variables IOUT and ISTDO and made
C           various cosmetic changes.  (FNF)
C   920602  Reduced problem size for a shorter-running test and
C           corrected lower limit in "DO 80" statement.  (FNF)
C   921021  Added 1P's to output formats.  (FNF)
C***END PROLOGUE  SLAPQC
C
C     The problem size, MAXN, should be large enough that the
C     iterative methods do 10-15 iterations, just to be sure that
C     the truncated methods run to the end of their ropes and enter
C     their error recovery mode.  Thus, for a more thorough test change
C     the following PARAMETER statement to:
C     PARAMETER (MAXN=69, MXNELT=5000, MAXIW=5000, MAXRW=5000)
C
C     .. Parameters ..
      INTEGER MAXN, MXNELT, MAXIW, MAXRW
      PARAMETER (MAXN=25, MXNELT=500, MAXIW=1000, MAXRW=1000)
C     .. Scalar Arguments ..
      INTEGER IPASS, KPRINT, LUN
C     .. Arrays in Common ..
      REAL SOLN(MAXN)
C     .. Local Scalars ..
      REAL DENS, ERR, FACTOR, TOL
      INTEGER IERR, ISYM, ITER, ITMAX, ITOL, ITOLGM, IUNIT, K, KASE,
     +        LENIW, LENW, N, NELT, NELTMX, NFAIL, NMAX, NSAVE
C     .. Local Arrays ..
      REAL A(MXNELT), F(MAXN), RWORK(MAXRW), XITER(MAXN)
      INTEGER IA(MXNELT), IWORK(MAXIW), JA(MXNELT)
C     .. External Functions ..
      REAL R1MACH
      EXTERNAL R1MACH
C     .. External Subroutines ..
      EXTERNAL OUTERR, SCPPLT, SRMGEN, SS2Y, SSDBCG, SSDCG, SSDCGN,
     +         SSDCGS, SSDGMR, SSDOMN, SSGS, SSICCG, SSILUR, SSJAC,
     +         SSLUBC, SSLUCN, SSLUCS, SSLUGM, SSLUOM, VFILL
C     .. Intrinsic Functions ..
      INTRINSIC MAX, REAL
C     .. Common blocks ..
      COMMON /SSLBLK/ SOLN
C
C     The following lines are for the braindamaged Sun FPE handler.
C
C$$$      integer oldmode, fpmode
C***FIRST EXECUTABLE STATEMENT  SLAPQC
C$$$      oldmode = fpmode( 62464 )
C
C     Maximum problem sizes.
C
      NELTMX = MXNELT
      NMAX   = MAXN
      LENIW  = MAXIW
      LENW   = MAXRW
C
C     Set some input data.
C
      N      = NMAX
      ITMAX  = N
      FACTOR = 1.2E0
C
C     Set to print intermediate results if KPRINT.GE.3.
C
      IF( KPRINT.LT.3 ) THEN
         IUNIT = 0
      ELSE
         IUNIT = LUN
      ENDIF
C
C     Set the Error tolerance to depend on the machine epsilon.
C
      TOL = MAX(1.0E3*R1MACH(3),1.0E-6)
      NFAIL = 0
C
C     Test routines using various convergence criteria.
C
      DO 80 KASE = 1, 3
         IF(KASE .EQ. 1 .OR. KASE .EQ. 2) ITOL = KASE
         IF(KASE .EQ. 3) ITOL = 11
C
C         Test routines using nonsymmetric (ISYM=0) and symmetric
C         storage (ISYM=1).  For ISYM=0 a really non-symmetric matrix
C         is generated.  The amount of non-symmetry is controlled by
C         user.
C
         DO 70 ISYM = 0, 1
            IF( KPRINT.GE.2 )  WRITE (LUN, 1050)  N, KASE, ISYM
C
C         Set up a random matrix.
C
            CALL SRMGEN( NELTMX, FACTOR, IERR, N, NELT,
     $           ISYM, IA, JA, A, F, SOLN, RWORK, IWORK, IWORK(N+1) )
            IF( IERR.NE.0 ) THEN
               WRITE(LUN,990) IERR
               NFAIL = NFAIL + 1
               GO TO 70
            ENDIF
            IF( ISYM.EQ.0 ) THEN
               DENS = REAL(NELT)/(N*N)
            ELSE
               DENS = REAL(2*NELT)/(N*N)
            ENDIF
            IF( KPRINT.GE.2 ) THEN
              WRITE(LUN,1020) N, NELT, DENS
              WRITE(LUN,1030) TOL
            ENDIF
C
C         Convert to the SLAP-Column format and
C         write out matrix in SLAP-Column format, if desired.
C
            CALL SS2Y( N, NELT, IA, JA, A, ISYM )
            IF( KPRINT.GE.4 ) THEN
               WRITE(LUN,1040) (K,IA(K),JA(K),A(K),K=1,NELT)
               CALL SCPPLT( N, NELT, IA, JA, A, ISYM, LUN )
            ENDIF
C
C**********************************************************************
C                    BEGINNING OF SLAP QUICK TESTS
C**********************************************************************
C
C         * * * * * *   SSJAC   * * * * * *
C
            IF( KPRINT.GE.3 ) THEN
              WRITE(LUN,1000) 'SSJAC ', ITOL, ISYM
            ENDIF
            CALL VFILL( N, XITER, 0.0E0 )
C
            CALL SSJAC(N, F, XITER, NELT, IA, JA, A, ISYM,
     $           ITOL, TOL, 2*ITMAX, ITER, ERR, IERR, IUNIT,
     $           RWORK, LENW, IWORK, LENIW )
C
            CALL OUTERR( 'SSJAC ',IERR,KPRINT,NFAIL,LUN,ITER,ERR )
C
C         * * * * *  SSGS  * * * * *
C
            IF( KPRINT.GE.3 ) THEN
              WRITE(LUN,1000) 'SSGS  ',ITOL,ISYM
            ENDIF
            CALL VFILL( N, XITER, 0.0E0 )
C
            CALL SSGS(N, F, XITER, NELT, IA, JA, A, ISYM,
     $           ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT,
     $           RWORK, LENW, IWORK, LENIW )
C
            CALL OUTERR( 'SSGS  ',IERR,KPRINT,NFAIL,LUN,ITER,ERR )
C
C         * * * * * *   SSILUR   * * * * * *
C
            IF( KPRINT.GE.3 ) THEN
              WRITE(LUN,1000) 'SSILUR',ITOL,ISYM
            ENDIF
            CALL VFILL( N, XITER, 0.0E0 )
C
            CALL SSILUR(N, F, XITER, NELT, IA, JA, A, ISYM,
     $           ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT,
     $           RWORK, LENW, IWORK, LENIW )
C
            CALL OUTERR( 'SSILUR',IERR,KPRINT,NFAIL,LUN,ITER,ERR )
C
C         * * * * * *   SSDCG    * * * * * *
C
            IF( ISYM.EQ.1 ) THEN
               IF( KPRINT.GE.3 ) THEN
                  WRITE(LUN,1000) 'SSDCG',ITOL,ISYM
               ENDIF
               CALL VFILL( N, XITER, 0.0E0 )
C
               CALL SSDCG(N, F, XITER, NELT, IA, JA, A, ISYM,
     $              ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT,
     $              RWORK, LENW, IWORK, LENIW )
C
               CALL OUTERR( 'SSDCG ',IERR,KPRINT,NFAIL,LUN,ITER,ERR )
            ENDIF
C
C         * * * * * *    SSICCG    * * * * * *
C
            IF( ISYM.EQ.1 ) THEN
               IF( KPRINT.GE.3 ) THEN
                  WRITE(LUN,1000) 'SSICCG',ITOL,ISYM
               ENDIF
               CALL VFILL( N, XITER, 0.0E0 )
C
               CALL SSICCG(N, F, XITER, NELT, IA, JA, A, ISYM,
     $              ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, RWORK,
     $              LENW, IWORK, LENIW )
C
               CALL OUTERR( 'SSICCG',IERR,KPRINT,NFAIL,LUN,ITER,ERR )
            ENDIF
C
C         * * * * * *    SSDCGN   * * * * * *
C
            IF( KPRINT.GE.3 ) THEN
               WRITE(LUN,1000) 'SSDCGN',ITOL,ISYM
            ENDIF
            CALL VFILL( N, XITER, 0.0E0 )
C
            CALL SSDCGN(N, F, XITER, NELT, IA, JA, A, ISYM, ITOL,
     $           TOL, ITMAX, ITER, ERR, IERR, IUNIT, RWORK, LENW,
     $           IWORK, LENIW )
C
            CALL OUTERR( 'SSDCGN',IERR,KPRINT,NFAIL,LUN,ITER,ERR )
C
C         * * * * * *   SSLUCN   * * * * * *
C
            IF( KPRINT.GE.3 ) THEN
               WRITE(LUN,1000) 'SSLUCN',ITOL,ISYM
            ENDIF
            CALL VFILL( N, XITER, 0.0E0 )
C
            CALL SSLUCN(N, F, XITER, NELT, IA, JA, A, ISYM, ITOL,
     $           TOL, ITMAX, ITER, ERR, IERR, IUNIT, RWORK, LENW,
     $           IWORK, LENIW )
C
            CALL OUTERR( 'SSLUCN',IERR,KPRINT,NFAIL,LUN,ITER,ERR )
C
C         * * * * * *    SSDBCG   * * * * * *
C
            IF( KPRINT.GE.3 ) THEN
               WRITE(LUN,1000) 'SSDBCG',ITOL,ISYM
            ENDIF
            CALL VFILL( N, XITER, 0.0E0 )
C
            CALL SSDBCG(N, F, XITER, NELT, IA, JA, A, ISYM, ITOL,
     $           TOL, ITMAX, ITER, ERR, IERR, IUNIT, RWORK, LENW,
     $           IWORK, LENIW )
C
            CALL OUTERR( 'SSDBCG',IERR,KPRINT,NFAIL,LUN,ITER,ERR )
C
C         * * * * * *   SSLUBC   * * * * * *
C
            IF( KPRINT.GE.3 ) THEN
               WRITE(LUN,1000) 'SSLUBC',ITOL,ISYM
            ENDIF
            CALL VFILL( N, XITER, 0.0E0 )
C
            CALL SSLUBC(N, F, XITER, NELT, IA, JA, A, ISYM,
     $           ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT,
     $           RWORK, LENW, IWORK, LENIW )
C
            CALL OUTERR( 'SSLUBC',IERR,KPRINT,NFAIL,LUN,ITER,ERR )
C
C         * * * * * *    SSDCGS   * * * * * *
C
            IF( KPRINT.GE.3 ) THEN
               WRITE(LUN,1000) 'SSDCGS',ITOL,ISYM
            ENDIF
            CALL VFILL( N, XITER, 0.0E0 )
C
            CALL SSDCGS(N, F, XITER, NELT, IA, JA, A, ISYM, ITOL,
     $           TOL, ITMAX, ITER, ERR, IERR, IUNIT, RWORK, LENW,
     $           IWORK, LENIW )
C
            CALL OUTERR( 'SSDCGS',IERR,KPRINT,NFAIL,LUN,ITER,ERR )
C
C         * * * * * *   SSLUCS   * * * * * *
C
            IF( KPRINT.GE.3 ) THEN
               WRITE(LUN,1000) 'SSLUCS',ITOL,ISYM
            ENDIF
            CALL VFILL( N, XITER, 0.0E0 )
C
            CALL SSLUCS(N, F, XITER, NELT, IA, JA, A, ISYM,
     $           ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT,
     $           RWORK, LENW, IWORK, LENIW )
C
            CALL OUTERR( 'SSLUCS',IERR,KPRINT,NFAIL,LUN,ITER,ERR )
C
C         * * * * * *    SSDOMN   * * * * * *
C
CVD$ NOVECTOR
            DO 30 NSAVE = 0, 3
               IF( KPRINT.GE.3 ) THEN
                  WRITE(LUN,1010) 'SSDOMN',ITOL, ISYM, NSAVE
               ENDIF
               CALL VFILL( N, XITER, 0.0E0 )
C
               CALL SSDOMN(N, F, XITER, NELT, IA, JA, A,
     $              ISYM, NSAVE, ITOL, TOL, ITMAX, ITER, ERR, IERR,
     $              IUNIT, RWORK, LENW, IWORK, LENIW )
C
               CALL OUTERR( 'SSDOMN',IERR,KPRINT,NFAIL,LUN,ITER,ERR )
 30         CONTINUE
C
C         * * * * * *   SSLUOM   * * * * * *
C
CVD$ NOVECTOR
            DO 40 NSAVE=0,3
               IF( KPRINT.GE.3 ) THEN
                  WRITE(LUN,1010) 'SSLUOM',ITOL, ISYM, NSAVE
               ENDIF
               CALL VFILL( N, XITER, 0.0E0 )
C
               CALL SSLUOM(N, F, XITER, NELT, IA, JA, A,
     $              ISYM, NSAVE, ITOL, TOL, ITMAX, ITER, ERR, IERR,
     $              IUNIT, RWORK, LENW, IWORK, LENIW )
C
               CALL OUTERR( 'SSLUOM',IERR,KPRINT,NFAIL,LUN,ITER,ERR )
 40         CONTINUE
C
C         * * * * * *   SSDGMR   * * * * * *
C
CVD$ NOVECTOR
            DO 50 NSAVE = 5, 12
               IF( KPRINT.GE.3 ) THEN
                  WRITE(LUN,1010) 'SSDGMR',ITOL, ISYM, NSAVE
               ENDIF
               CALL VFILL( N, XITER, 0.0E0 )
               ITOLGM = 0
C
               CALL SSDGMR(N, F, XITER, NELT, IA, JA, A,
     $              ISYM, NSAVE, ITOLGM, TOL, ITMAX, ITER, ERR, IERR,
     $              IUNIT, RWORK, LENW, IWORK, LENIW )
C
               CALL OUTERR( 'SSDGMR',IERR,KPRINT,NFAIL,LUN,ITER,ERR )
 50         CONTINUE
C
C         * * * * * *   SSLUGM   * * * * * *
C
CVD$ NOVECTOR
            DO 60 NSAVE = 5, 12
               IF( KPRINT.GE.3 ) THEN
                  WRITE(LUN,1010) 'SSLUGM',ITOL, ISYM, NSAVE
               ENDIF
               CALL VFILL( N, XITER, 0.0E0 )
C
               CALL SSLUGM(N, F, XITER, NELT, IA, JA, A,
     $              ISYM, NSAVE, ITOL, TOL, ITMAX, ITER, ERR, IERR,
     $              IUNIT, RWORK, LENW, IWORK, LENIW )
C
               CALL OUTERR( 'SSLUGM',IERR,KPRINT,NFAIL,LUN,ITER,ERR )
 60         CONTINUE
 70      CONTINUE
 80   CONTINUE
C
      IF (NFAIL .EQ. 0) THEN
         IPASS = 1
         IF( KPRINT .GE. 2 )  WRITE (LUN, 5001)
      ELSE
         IPASS = 0
         IF( KPRINT .GE. 2 )  WRITE (LUN, 5002) NFAIL
      ENDIF
C
      RETURN
C
  990 FORMAT(/1X, 'SLAPQC -- Fatal error ', I1, ' generating ',
     $       '*RANDOM* Matrix.')
 1000 FORMAT(/1X,A6,' : ITOL = ',I2,'   ISYM = ',I1)
 1010 FORMAT(/1X,A6,' : ITOL = ',I2,'   ISYM = ',I1,' NSAVE = ',I2)
 1020 FORMAT(/'                * RANDOM Matrix of size',I5,'*'
     $     /'                ',
     $     'Number of non-zeros & Density = ', I5,1P,E16.7)
 1030 FORMAT('                Error tolerance = ',1P,E16.7)
 1040 FORMAT(/'  ***** SLAP Column Matrix *****'/
     $        ' Indx   ia   ja     a'/(1X,I4,1X,I4,1X,I4,1X,1P,E16.7))
 1050 FORMAT('1'/' Running tests with  N =',I3,',  KASE =',I2,
     $                          ',  ISYM =',I2)
 5001 FORMAT('--------- All single precision SLAP tests passed ',
     $       '---------')
 5002 FORMAT('*********',I3,' single precision SLAP tests failed ',
     $       '*********')
      END

*DECK DT4
      DOUBLE PRECISION FUNCTION DT4 (X)
C***BEGIN PROLOGUE  DT4
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  DF4S
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  DT4
      DOUBLE PRECISION A,B,DF4S,X,X1,Y
C***FIRST EXECUTABLE STATEMENT  DT4
      A = 0.0D+00
      B = 0.1D+01
      X1 = X+0.1D+01
      Y = (B-A)/X1+A
      DT4 = (B-A)*DF4S(Y)/X1/X1
      RETURN
      END

*DECK QCDRD
      SUBROUTINE QCDRD (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  QCDRD
C***PURPOSE  Quick check for DRD.
C***LIBRARY   SLATEC
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Pexton, R. L., (LLNL)
C***DESCRIPTION
C
C            QUICK TEST FOR CARLSON INTEGRAL DRD
C
C***ROUTINES CALLED  D1MACH, DRD, NUMXER, XERCLR, XGETF, XSETF
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   890618  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   910708  Minor modifications in use of KPRINT.  (WRB)
C   930214  Added more digits to BLEM.  (WRB)
C***END PROLOGUE  QCDRD
      INTEGER KPRINT, IPASS, CONTRL, KONTRL, LUN, IER
      INTEGER IPASS1, IPASS2, IPASS3, IPASS4, NUMXER
      DOUBLE PRECISION BLEM, TRD, DRD, DIF, D1MACH
      EXTERNAL D1MACH, DRD, NUMXER, XERCLR, XGETF, XSETF
C***FIRST EXECUTABLE STATEMENT  QCDRD
      CALL XERCLR
      CALL XGETF(CONTRL)
      IF ( KPRINT .GE. 3 ) THEN
         KONTRL = +1
      ELSE
         KONTRL = 0
      ENDIF
      CALL XSETF(KONTRL)
C
C  FORCE ERROR 1
C
      IF ( KPRINT .GE. 3 ) WRITE (LUN,101)
  101 FORMAT(' DRD - FORCE ERROR 1 TO OCCUR')
      TRD = DRD(-1.0D0,-1.0D0,-1.0D0,IER)
      IER = NUMXER(IER)
      IF ( IER .EQ. 1 ) THEN
         IPASS1 = 1
      ELSE
         IPASS1 = 0
      ENDIF
      CALL XERCLR
C
C  FORCE ERROR 2
C
      IF ( KPRINT .GE. 3 ) WRITE (LUN,102)
  102 FORMAT(' DRD - FORCE ERROR 2 TO OCCUR')
      TRD = DRD(1.0D0,1.0D0,-1.0D0,IER)
      IER = NUMXER(IER)
      IF ( IER .EQ. 2 ) THEN
         IPASS2 = 1
      ELSE
         IPASS2 = 0
      ENDIF
      CALL XERCLR
C
C  FORCE ERROR 3
C
      IF ( KPRINT .GE. 3 ) WRITE (LUN,103)
  103 FORMAT(' DRD - FORCE ERROR 3 TO OCCUR')
      TRD = DRD(D1MACH(2),D1MACH(2),D1MACH(2),IER)
      IER = NUMXER(IER)
      IF ( IER .EQ. 3 ) THEN
         IPASS3 = 1
      ELSE
         IPASS3 = 0
      ENDIF
      CALL XERCLR
C
C  ARGUMENTS IN RANGE
C  BLEM=3 * LEMNISCATE CONSTANT B
C
      BLEM = 1.797210352103388311159883738420485817341D0
      TRD  = DRD(0.0D0,2.0D0,1.0D0,IER)
      CALL XERCLR
      DIF  = TRD - BLEM
      IF ( (ABS(DIF/BLEM).LT.1000.0D0*D1MACH(4)).AND.(IER.EQ.0) ) THEN
         IPASS4 = 1
      ELSE
         IPASS = 0
      ENDIF
      IPASS = MIN(IPASS1,IPASS2,IPASS3,IPASS4)
      IF ( KPRINT .LE. 0 ) THEN
         GO TO 999
      ELSEIF ( KPRINT .EQ. 1 ) THEN
         IF ( IPASS .EQ. 1 ) THEN
            GO TO 999
         ELSE
            WRITE (LUN,104)
  104       FORMAT(' DRD - FAILED')
            GO TO 999
         ENDIF
      ELSE
         IF ( IPASS .EQ. 1 ) THEN
            WRITE (LUN,105)
  105       FORMAT(' DRD - PASSED')
            GO TO 999
         ELSE
            WRITE (LUN,104)
            IF ( IPASS4 .EQ. 0 ) WRITE (LUN,106) BLEM, TRD, DIF
  106       FORMAT(' CORRECT ANSWER =', 1PD20.14 /
     *             'COMPUTED ANSWER =',   D20.14 /
     *             '     DIFFERENCE =',   D20.14 )
            GO TO 999
         ENDIF
      ENDIF
  999 CONTINUE
      CALL XSETF(CONTRL)
      RETURN
      END

*DECK LDERES
      LOGICAL FUNCTION LDERES (TYPE, UPLO, M, N, AA, AS, LDA)
C***BEGIN PROLOGUE  LDERES
C***SUBSIDIARY
C***PURPOSE  Test if selected elements in two arrays are equal.
C***LIBRARY   SLATEC (BLAS)
C***AUTHOR  Du Croz, J. J., (NAG)
C           Hanson, R. J., (SNLA)
C***DESCRIPTION
C
C  Tests if selected elements in two arrays are equal.
C
C  TYPE is 'GE', 'SY' or 'SP'.
C
C  Auxiliary routine for test program for Level 2 Blas.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   870810  DATE WRITTEN
C   910620  Modified to meet SLATEC code and prologue standards.  (BKS)
C***END PROLOGUE  LDERES
C     .. Scalar Arguments ..
      INTEGER            LDA, M, N
      CHARACTER*1        UPLO
      CHARACTER*2        TYPE
C     .. Array Arguments ..
      DOUBLE PRECISION   AA( LDA, * ), AS( LDA, * )
C     .. Local Scalars ..
      INTEGER            I, IBEG, IEND, J
      LOGICAL            UPPER
C***FIRST EXECUTABLE STATEMENT  LDERES
      UPPER = UPLO.EQ.'U'
      IF( TYPE.EQ.'GE' )THEN
         DO 20 J = 1, N
            DO 10 I = M + 1, LDA
               IF( AA( I, J ).NE.AS( I, J ) )
     $            GO TO 70
   10       CONTINUE
   20    CONTINUE
      ELSE IF( TYPE.EQ.'SY' )THEN
         DO 50 J = 1, N
            IF( UPPER )THEN
               IBEG = 1
               IEND = J
            ELSE
               IBEG = J
               IEND = N
            END IF
            DO 30 I = 1, IBEG - 1
               IF( AA( I, J ).NE.AS( I, J ) )
     $            GO TO 70
   30       CONTINUE
            DO 40 I = IEND + 1, LDA
               IF( AA( I, J ).NE.AS( I, J ) )
     $            GO TO 70
   40       CONTINUE
   50    CONTINUE
      END IF
C
      LDERES = .TRUE.
      GO TO 80
   70 CONTINUE
      LDERES = .FALSE.
   80 RETURN
C
C     End of LDERES.
C
      END

*DECK SBOCQX
      SUBROUTINE SBOCQX (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  SBOCQX
C***PURPOSE  Quick check for SBOCLS.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SBOCQX-S, DBOCQX-D)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     MINIMAL TEST DRIVER FOR SBOCLS, BOUNDED CONSTRAINED LEAST
C     SQUARES SOLVER.  DELIVERS THE VALUE IPASS=1 IF 8 TESTS WERE
C     PASSED.  DELIVER THE VALUE IPASS=0 IF ANY ONE OF THEM FAILED.
C
C     RUN FOUR BOUNDED LEAST SQUARES PROBLEMS THAT COME FROM THE
C     DIPLOME WORK OF P. ZIMMERMANN.
C
C***ROUTINES CALLED  R1MACH, SBOCLS, SBOLS, SCOPY, SNRM2
C***REVISION HISTORY  (YYMMDD)
C   850310  DATE WRITTEN
C   890618  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   901013  Added PASS/FAIL message and cleaned up FORMATs.  (RWC)
C***END PROLOGUE  SBOCQX
      REAL D(6,5),W(11,11),BL(5,2),BU(5,2),X(30),RW(55),XTRUE(9)
      REAL C(5,5)
      REAL BL1(10),BU1(10)
      INTEGER IND(10),IW(20),IOPT(40)
      REAL RHS(6,2)
      CHARACTER*4 MSG
C
      DATA ((C(I,J),I=1,5),J=1,5) /1.,10.,4.,8.,1.,1.,10.,2.,-1.,1.,1.,
     *  -3.,-3.,2.,1.,1.,5.,5.,5.,1.,1.,4.,-1.,-3.,1./
      DATA ((D(I,J),I=1,6),J=1,5) /-74.,14.,66.,-12.,3.,4.,80.,-69.,
     *  -72.,66.,8.,-12.,18.,21.,-5.,-30.,-7.,4.,-11.,28.,7.,-23.,-4.,
     *  4.,-4.,0.,1.,3.,1.,0./
      DATA ((BL(I,J),I=1,5),J=1,2) /1.,0.,-1.,1.,-4.,-1.,0.,-3.,1.,-6./
      DATA ((BU(I,J),I=1,5),J=1,2) /3.,2.,1.,3.,-2.,3.,4.,1.,5.,-2./
      DATA ((RHS(I,J),I=1,6),J=1,2) /51.,-61.,-56.,69.,10.,-12.,-5.,-9.,
     *  708.,4165.,-13266.,8409./
      DATA (XTRUE(J),J=1,9) /1.,2.,-1.,3.,-4.,1.,32.,30.,31./
C***FIRST EXECUTABLE STATEMENT  SBOCQX
      MDW = 11
      MROWS = 6
      NCOLS = 5
      MCON = 4
      IOPT(1) = 99
      IPASS = 1
      ITEST = 0
C
      IF (KPRINT.GE.2) WRITE (LUN, 99998)
C
      DO 50 IB = 1,2
          DO 40 IRHS = 1,2
C
C           TRANSFER DATA TO WORKING ARRAY W(*,*).
C
              DO 10 J = 1,NCOLS
                  CALL SCOPY(MROWS,D(1,J),1,W(1,J),1)
   10         CONTINUE
C
              CALL SCOPY(MROWS,RHS(1,IRHS),1,W(1,NCOLS+1),1)
C
C             SET BOUND INDICATOR FLAGS.
C
              DO 20 J = 1,NCOLS
                  IND(J) = 3
   20         CONTINUE
C
              CALL SBOLS(W,MDW,MROWS,NCOLS,BL(1,IB),BU(1,IB),IND,IOPT,X,
     *                   RNORM,MODE,RW,IW)
              DO 30 J = 1,NCOLS
                  X(J) = X(J) - XTRUE(J)
   30         CONTINUE
C
              SR = SNRM2(NCOLS,X,1)
              MPASS = 1
              IF (SR.GT.10.E3*SQRT(R1MACH(4))) MPASS = 0
              IPASS = IPASS*MPASS
              IF (KPRINT.GE.2) THEN
                 MSG = 'PASS'
                 IF (MPASS.EQ.0) MSG = 'FAIL'
                 ITEST = ITEST + 1
                 WRITE (LUN, 99999) ITEST, IB, IRHS, SR, MSG
              ENDIF
   40     CONTINUE
   50 CONTINUE
C
C     RUN STOER'S PROBLEM FROM 1971 SIAM J. N. ANAL. PAPER.
C
      DO 90 IB = 1,2
         DO 80 IRHS = 1,2
            CALL SCOPY(11*10,0.E0,0,W,1)
            CALL SCOPY(NCOLS,BL(1,IB),1,BL1,1)
            CALL SCOPY(NCOLS,BU(1,IB),1,BU1,1)
            IND(NCOLS+1) = 2
            IND(NCOLS+2) = 1
            IND(NCOLS+3) = 2
            IND(NCOLS+4) = 3
            BU1(NCOLS+1) = 5.
            BL1(NCOLS+2) = 20.
            BU1(NCOLS+3) = 30.
            BL1(NCOLS+4) = 11.
            BU1(NCOLS+4) = 40.
            DO 60 J = 1,NCOLS
               CALL SCOPY(MCON,C(1,J),1,W(1,J),1)
               CALL SCOPY(MROWS,D(1,J),1,W(MCON+1,J),1)
   60       CONTINUE
C
            CALL SCOPY(MROWS,RHS(1,IRHS),1,W(MCON+1,NCOLS+1),1)
C
C           CHECK LENGTHS OF REQD. ARRAYS.
C
            IOPT(01) = 2
            IOPT(02) = 11
            IOPT(03) = 11
            IOPT(04) = 10
            IOPT(05) = 30
            IOPT(06) = 55
            IOPT(07) = 20
            IOPT(08) = 40
            IOPT(09) = 99
            CALL SBOCLS(W,MDW,MCON,MROWS,NCOLS,BL1,BU1,IND,IOPT,X,
     *                  RNORMC,RNORM,MODE,RW,IW)
            DO 70 J = 1,NCOLS + MCON
               X(J) = X(J) - XTRUE(J)
   70       CONTINUE
C
            SR = SNRM2(NCOLS+MCON,X,1)
            MPASS = 1
            IF (SR.GT.10.E3*SQRT(R1MACH(4))) MPASS = 0
            IPASS = IPASS*MPASS
            IF (KPRINT.GE.2) THEN
               MSG = 'PASS'
               IF (MPASS.EQ.0) MSG = 'FAIL'
               ITEST = ITEST + 1
               WRITE (LUN, 99999) ITEST, IB, IRHS, SR, MSG
            ENDIF
   80    CONTINUE
   90 CONTINUE
C
C     HERE THE VALUE OF IPASS=1 SAYS THAT SBOCLS() HAS PASSED ITS TESTS.
C          THE VALUE OF IPASS=0 SAYS THAT SBOCLS() HAS NOT PASSED.
C
      IF(KPRINT.GE.3)
     *WRITE(LUN,'('' IPASS VALUE. (A 1 IS GOOD, 0 IS BAD.)'',I4)')IPASS
      IF(KPRINT.GE.2.AND.IPASS.EQ.0) WRITE(LUN,10789)
      RETURN
C
10789 FORMAT (' ERROR IN SBOCLS OR SBOLS')
99998 FORMAT (' TEST   IB IRHS             SR')
99999 FORMAT (3I5, 1P, E20.6, ' TEST ', A, 'ED.')
      END

*DECK DT5
      DOUBLE PRECISION FUNCTION DT5 (X)
C***BEGIN PROLOGUE  DT5
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  DF5S
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  DT5
      DOUBLE PRECISION A,B,DF5S,X,X1,Y
C***FIRST EXECUTABLE STATEMENT  DT5
      A = 0.0D+00
      B = 0.1D+01
      X1 = X+0.1D+01
      Y = (B-A)/X1+A
      DT5 = (B-A)*DF5S(Y)/X1/X1
      RETURN
      END

*DECK F5S
      REAL FUNCTION F5S (X)
C***BEGIN PROLOGUE  F5S
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F5S
      REAL X
C***FIRST EXECUTABLE STATEMENT  F5S
      F5S = 0.0
      IF(X.NE.0.0) F5S = 1.0/(X*SQRT(X))
      RETURN
      END

*DECK SCHK52
      SUBROUTINE SCHK52 (SNAME, EPS, THRESH, NOUT, KPRINT, FATAL, NIDIM,
     $   IDIM, NALF, ALF, NINC, INC, NMAX, INCMAX, A, AA, AS, X, XX, XS,
     $   Y, YY, YS, YT, G, Z)
C***BEGIN PROLOGUE  SCHK52
C***SUBSIDIARY
C***PURPOSE  Quick check for SSYR and SSPR.
C***LIBRARY   SLATEC (BLAS)
C***KEYWORDS  BLAS, QUICK CHECK SERVICE ROUTINE
C***AUTHOR  Du Croz, J. (NAG)
C           Hanson, R. J. (SNLA)
C***DESCRIPTION
C
C  Quick check for SSYR and SSPR.
C
C  Auxiliary routine for test program for Level 2 Blas.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  LSE, LSERES, NUMXER, SMAKE2, SMVCH, SSPR, SSYR
C***REVISION HISTORY  (YYMMDD)
C   870810  DATE WRITTEN
C   910619  Modified to meet SLATEC code and prologue standards.  (BKS)
C***END PROLOGUE  SCHK52
C     .. Parameters ..
      REAL               ZERO, HALF, ONE
      PARAMETER          ( ZERO = 0.0, HALF = 0.5, ONE = 1.0 )
C     .. Scalar Arguments ..
      LOGICAL            FATAL
      REAL               EPS, THRESH
      INTEGER            INCMAX, KPRINT, NALF, NIDIM, NINC, NMAX, NOUT
      CHARACTER*6        SNAME
C     .. Array Arguments ..
      REAL               A( NMAX, NMAX ), AA( NMAX*NMAX ), ALF( NALF ),
     $                   AS( NMAX*NMAX ), G( NMAX ), X( NMAX ),
     $                   XS( NMAX*INCMAX ), XX( NMAX*INCMAX ),
     $                   Y( NMAX ), YS( NMAX*INCMAX ), YT( NMAX ),
     $                   YY( NMAX*INCMAX ), Z( NMAX )
      INTEGER            IDIM( NIDIM ), INC( NINC )
C     .. Local Scalars ..
      REAL               ALPHA, ALS, ERR, ERRMAX, TRANSL
      INTEGER            I, IA, IC, IN, INCX, INCXS, IX, J, JA, JJ, LAA,
     $                   LDA, LDAS, LJ, LX, N, NARGS, NC, NS, NERR
      LOGICAL            FTL, FULL, NULL, PACKED, RESET, UPPER
      CHARACTER*1        UPLO, UPLOS
      CHARACTER*2        ICH
C     .. Local Arrays ..
      REAL               W( 1 )
      LOGICAL            ISAME( 13 )
C     .. External Functions ..
      INTEGER            NUMXER
      LOGICAL            LSE, LSERES
      EXTERNAL           LSE, LSERES, NUMXER
C     .. External Subroutines ..
      EXTERNAL           SMAKE2, SMVCH, SSPR, SSYR
C     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX
C     .. Data statements ..
      DATA               ICH/'UL'/
C***FIRST EXECUTABLE STATEMENT  SCHK52
      FULL = SNAME( 3: 3 ).EQ.'Y'
      PACKED = SNAME( 3: 3 ).EQ.'P'
C     Define the number of arguments.
      IF( FULL )THEN
         NARGS = 7
      ELSE IF( PACKED )THEN
         NARGS = 6
      END IF
C
      NC = 0
      RESET = .TRUE.
      ERRMAX = ZERO
C
      DO 100 IN = 1, NIDIM
         N = IDIM( IN )
C        Set LDA to 1 more than minimum value if room.
         LDA = N
         IF( LDA.LT.NMAX )
     $      LDA = LDA + 1
C        Skip tests if not enough room.
         IF( LDA.GT.NMAX )
     $      GO TO 100
         IF( PACKED )THEN
            LAA = ( N*( N + 1 ) )/2
         ELSE
            LAA = LDA*N
         END IF
C
         DO 90 IC = 1, 2
            UPLO = ICH( IC: IC )
            UPPER = UPLO.EQ.'U'
C
            DO 80 IX = 1, NINC
               INCX = INC( IX )
               LX = ABS( INCX )*N
C
C              Generate the vector X.
C
               TRANSL = HALF
               CALL SMAKE2( 'GE', ' ', ' ', 1, N, X, 1, XX, ABS( INCX ),
     $                     0, N - 1, RESET, TRANSL )
               IF( N.GT.1 )THEN
                  X( N/2 ) = ZERO
                  XX( 1 + ABS( INCX )*( N/2 - 1 ) ) = ZERO
               END IF
C
               DO 70 IA = 1, NALF
                  ALPHA = ALF( IA )
                  NULL = N.LE.0.OR.ALPHA.EQ.ZERO
C
C                 Generate the matrix A.
C
                  TRANSL = ZERO
                  CALL SMAKE2( SNAME( 2: 3 ), UPLO, ' ', N, N, A, NMAX,
     $                        AA, LDA, N - 1, N - 1, RESET, TRANSL )
C
                  NC = NC + 1
C
C                 Save every datum before calling the subroutine.
C
                  UPLOS = UPLO
                  NS = N
                  ALS = ALPHA
                  DO 10 I = 1, LAA
                     AS( I ) = AA( I )
   10             CONTINUE
                  LDAS = LDA
                  DO 20 I = 1, LX
                     XS( I ) = XX( I )
   20             CONTINUE
                  INCXS = INCX
C
C                 Call the subroutine.
C
                  IF( FULL )THEN
                     CALL SSYR( UPLO, N, ALPHA, XX, INCX, AA, LDA )
                  ELSE IF( PACKED )THEN
                     CALL SSPR( UPLO, N, ALPHA, XX, INCX, AA )
                  END IF
C
C                 Check if error-exit was taken incorrectly.
C
                  IF (NUMXER(NERR) .NE. 0) THEN
                     IF (KPRINT .GE. 2) THEN
                       WRITE( NOUT, FMT = 9992 )
                     ENDIF
                     FATAL = .TRUE.
                  END IF
C
C                 See what data changed inside subroutines.
C
                  ISAME( 1 ) = UPLO.EQ.UPLOS
                  ISAME( 2 ) = NS.EQ.N
                  ISAME( 3 ) = ALS.EQ.ALPHA
                  ISAME( 4 ) = LSE( XS, XX, LX )
                  ISAME( 5 ) = INCXS.EQ.INCX
                  IF( NULL )THEN
                     ISAME( 6 ) = LSE( AS, AA, LAA )
                  ELSE
                     ISAME( 6 ) = LSERES( SNAME( 2: 3 ), UPLO, N, N, AS,
     $                            AA, LDA )
                  END IF
                  IF( .NOT.PACKED )THEN
                     ISAME( 7 ) = LDAS.EQ.LDA
                  END IF
C
C                 If data was incorrectly changed, report and return.
C
                  DO 30 I = 1, NARGS
                    IF (.NOT. ISAME( I )) THEN
                      FATAL = .TRUE.
                      IF (KPRINT .GE. 2) THEN
                        WRITE( NOUT, FMT = 9998 )I
                      ENDIF
                    ENDIF
  30              CONTINUE
C
                  IF( .NOT.NULL )THEN
C
C                    Check the result column by column.
C
                     IF( INCX.GT.0 )THEN
                        DO 40 I = 1, N
                           Z( I ) = X( I )
   40                   CONTINUE
                     ELSE
                        DO 50 I = 1, N
                           Z( I ) = X( N - I + 1 )
   50                   CONTINUE
                     END IF
                     JA = 1
                     DO 60 J = 1, N
                        W( 1 ) = Z( J )
                        IF( UPPER )THEN
                           JJ = 1
                           LJ = J
                        ELSE
                           JJ = J
                           LJ = N - J + 1
                        END IF
                        FTL = .FALSE.
                        CALL SMVCH( 'N', LJ, 1, ALPHA, Z( JJ ), LJ, W,
     $                              1, ONE, A( JJ, J ), 1, YT, G,
     $                              AA( JA ), EPS, ERR, FTL, NOUT,
     $                              .TRUE., KPRINT )
                        IF( FULL )THEN
                           IF( UPPER )THEN
                              JA = JA + LDA
                           ELSE
                              JA = JA + LDA + 1
                           END IF
                        ELSE
                           JA = JA + LJ
                        END IF
                        ERRMAX = MAX( ERRMAX, ERR )
                        IF (FTL) THEN
                          FATAL = .TRUE.
                          IF (KPRINT .GE. 3) THEN
                            WRITE( NOUT, FMT = 9995 )J
                            WRITE( NOUT, FMT = 9996 )SNAME
                            IF( FULL )THEN
                               WRITE( NOUT, FMT = 9993 )NC, SNAME,
     $                          UPLO, N, ALPHA, INCX,
     $                          LDA
                            ELSE IF( PACKED )THEN
                               WRITE( NOUT, FMT = 9994 )NC, SNAME,
     $                          UPLO, N, ALPHA, INCX
                            END IF
                          ENDIF
                        ENDIF
   60                CONTINUE
                  END IF
C
   70          CONTINUE
C
   80       CONTINUE
C
   90    CONTINUE
C
  100 CONTINUE
C
C     Report result.
C
      IF (.NOT. (FATAL)) THEN
        IF (KPRINT .GE. 3) THEN
          IF( ERRMAX.LT.THRESH )THEN
             WRITE( NOUT, FMT = 9999 )SNAME, NC
          ELSE
             WRITE( NOUT, FMT = 9997 )SNAME, NC, ERRMAX
          END IF
        ENDIF
      ENDIF
      RETURN
C
 9999 FORMAT( ' ', A6, ' PASSED THE COMPUTATIONAL TESTS (', I6, ' CALL',
     $      'S)' )
 9998 FORMAT( ' ******* FATAL ERROR - PARAMETER NUMBER ', I2, ' WAS CH',
     $      'ANGED INCORRECTLY *******' )
 9997 FORMAT( ' ', A6, ' COMPLETED THE COMPUTATIONAL TESTS (', I6, ' C',
     $      'ALLS)', /' ******* BUT WITH MAXIMUM TEST RATIO', F8.2,
     $      ' - SUSPECT *******' )
 9996 FORMAT( ' ******* ', A6, ' FAILED ON CALL NUMBER:' )
 9995 FORMAT( '      THESE ARE THE RESULTS FOR COLUMN ', I3 )
 9994 FORMAT( 1X, I6, ': ', A6, '(''', A1, ''',', I3, ',', F4.1, ', X,',
     $      I2, ', AP)                           .' )
 9993 FORMAT( 1X, I6, ': ', A6, '(''', A1, ''',', I3, ',', F4.1, ', X,',
     $      I2, ', A,', I3, ')                        .' )
 9992 FORMAT( ' ******* FATAL ERROR - ERROR-EXIT TAKEN ON VALID CALL *',
     $      '******' )
C
C     End of SCHK52.
C
      END

*DECK QXDABM
      SUBROUTINE QXDABM (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  QXDABM
C***PURPOSE  Test the DEPAC routine DDEABM.
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (QXABM-S, QXDABM-D)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Chow, Jeff, (LANL)
C***DESCRIPTION
C
C *Usage:
C
C        INTEGER  LUN, KPRINT, IPASS
C
C        CALL QXDABM (LUN, KPRINT, IPASS)
C
C *Arguments:
C
C     LUN   :IN  is the unit number to which output is to be written.
C
C     KPRINT:IN  controls the amount of output, as specified in the
C                SLATEC Guidelines.
C
C     IPASS:OUT  will contain a pass/fail flag.  IPASS=1 is good.
C                IPASS=0 indicates one or more tests failed.
C
C *Description:
C
C   DDEABM is tested by solving the equations of motion of a body
C   moving in a plane about a spherical earth, namely
C           (D/DT)(D/DT)X = -G*X/R**3
C           (D/DT)(D/DT)Y = -G*Y/R**3
C   where G = 1, R = SQRT(X**2 + Y**2) and
C           X(0) = 1
C           (D/DT)X(0) = 0
C           Y(0) = 0
C           (D/DT)Y(0) = 1.
C
C***ROUTINES CALLED  D1MACH, DDEABM, DFDEQC
C***REVISION HISTORY  (YYMMDD)
C   810801  DATE WRITTEN
C   890618  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900415  Code extensively revised.  (WRB)
C***END PROLOGUE  QXDABM
C
C     Declare arguments.
C
      INTEGER  LUN, KPRINT, IPASS
C
C     Declare local variables.
C
      INTEGER  IDID, INFO(15), IPAR, IWORK(51), N, LIW, LRW, NSTEP
      DOUBLE PRECISION ABSERR, D1MACH, R, RELERR, RELTOL, RPAR,
     +                 RWORK(214), T, TOUT, U(4)
      EXTERNAL DFDEQC
C***FIRST EXECUTABLE STATEMENT  QXDABM
      IF (KPRINT .GE. 2)  WRITE (LUN, 9000)
C
C     Initialize problem.
C
      N = 4
      LRW = 214
      LIW = 51
      T = 0.0D0
      TOUT = 8.0D0*ATAN(1.0D0)
      U(1) = 1.0D0
      U(2) = 0.0D0
      U(3) = 0.0D0
      U(4) = 1.0D0
      IPASS = 1
      NSTEP = 0
      RELTOL = SQRT(D1MACH(4))
      RELERR = 0.1D0*RELTOL
      ABSERR = RELERR**1.5D0
      INFO(1) = 0
      INFO(2) = 0
      INFO(3) = 1
      INFO(4) = 0
      IF (KPRINT .GT. 2) WRITE (LUN, 9010) RELERR, ABSERR, T, (1.0D0)
C
  100 CALL DDEABM (DFDEQC, N, T, U, TOUT, INFO, RELERR, ABSERR,
     +             IDID, RWORK, LRW, IWORK, LIW, RPAR, IPAR)
      R = SQRT(U(1)*U(1)+U(2)*U(2))
      IF (ABS(R-1.0D0) .GT. RELTOL) IPASS = 0
      IF (KPRINT .GT. 2) WRITE (LUN, 9020) T, R
      INFO(1) = 1
      IF (IDID .EQ. 1) GO TO 100
C
C     For the double precision version, we allow the integrator to take
C     up to 2000 steps before we declare failure.
C
      IF (IDID .EQ. -1) THEN
         NSTEP = NSTEP + 500
         IF (NSTEP .LT. 2000) GOTO 100
      ENDIF
C
C     Finish up.
C
      IF (IDID .LT. 1) IPASS = 0
      IF (KPRINT.GT.1 .AND. IDID.LT.1)  WRITE (LUN, 9030) IDID
      IF (KPRINT.GT.1 .AND. IPASS.EQ.1) WRITE (LUN, 9040)
      IF (KPRINT.GE.1 .AND. IPASS.EQ.0) WRITE (LUN, 9050)
      RETURN
C
C     FORMATs.
C
 9000 FORMAT ('1'/' ------------  DDEABM QUICK CHECK OUTPUT',
     +        ' ------------')
 9010 FORMAT (/ ' RELERR = ', D16.8, '   ABSERR =', D16.8 /
     +        12X, 'T', 19X, 'R' / 2D20.8)
 9020 FORMAT (2D20.8)
 9030 FORMAT (1X, 'ERROR RETURN FROM DDEABM.  IDID = ', I3)
 9040 FORMAT (/ ' ------------  DDEABM PASSED TESTS  ------------')
 9050 FORMAT (/ ' ************  DDEABM FAILED TESTS  ************')
      END

*DECK QCRJ
      SUBROUTINE QCRJ (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  QCRJ
C***PURPOSE  Quick check for RJ.
C***LIBRARY   SLATEC
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Pexton, R. L., (LLNL)
C***DESCRIPTION
C
C            QUICK TEST FOR CARLSON INTEGRAL RJ
C
C***ROUTINES CALLED  NUMXER, R1MACH, RJ, XERCLR, XGETF, XSETF
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   890618  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   910708  Minor modifications in use of KPRINT.  (WRB)
C***END PROLOGUE  QCRJ
      INTEGER KPRINT, IPASS, CONTRL, KONTRL, LUN, IER
      INTEGER IPASS1, IPASS2, IPASS3, IPASS4, NUMXER
      REAL CONSJ, TRJ, RJ, DIF, R1MACH
      EXTERNAL NUMXER, R1MACH, RJ, XERCLR, XGETF, XSETF
C***FIRST EXECUTABLE STATEMENT  QCRJ
      CALL XERCLR
      CALL XGETF(CONTRL)
      IF ( KPRINT .GE. 3 ) THEN
         KONTRL = +1
      ELSE
         KONTRL = 0
      ENDIF
      CALL XSETF(KONTRL)
C
C  FORCE ERROR 1
C
      IF ( KPRINT .GE. 3 ) WRITE (LUN,101)
  101 FORMAT(' RJ - FORCE ERROR 1 TO OCCUR')
      TRJ = RJ(-1.0E0,-1.0E0,-1.0E0,-1.0E0,IER)
      IER = NUMXER(IER)
      IF ( IER .EQ. 1 ) THEN
         IPASS1 = 1
      ELSE
         IPASS1 = 0
      ENDIF
      CALL XERCLR
C
C  FORCE ERROR 2
C
      IF ( KPRINT .GE. 3 ) WRITE (LUN,102)
  102 FORMAT(' RJ - FORCE ERROR 2 TO OCCUR')
      TRJ = RJ(R1MACH(1),R1MACH(1),R1MACH(1),R1MACH(1),IER)
      IER = NUMXER(IER)
      IF ( IER .EQ. 2 ) THEN
         IPASS2 = 1
      ELSE
         IPASS2 = 0
      ENDIF
      CALL XERCLR
C
C  FORCE ERROR 3
C
      IF ( KPRINT .GE. 3 ) WRITE (LUN,103)
  103 FORMAT(' RJ - FORCE ERROR 3 TO OCCUR')
      TRJ = RJ(R1MACH(2),R1MACH(2),R1MACH(2),R1MACH(2),IER)
      IER = NUMXER(IER)
      IF ( IER .EQ. 3 ) THEN
         IPASS3 = 1
      ELSE
         IPASS3 = 0
      ENDIF
      CALL XERCLR
C
C  ARGUMENTS IN RANGE
C
      CONSJ = 0.142975796671567538E0
      TRJ   = RJ(2.0E0,3.0E0,4.0E0,5.0E0,IER)
      CALL XERCLR
      DIF   = TRJ - CONSJ
      IF ( (ABS(DIF/CONSJ).LT.1000.0E0*R1MACH(4)).AND.(IER.EQ.0) ) THEN
         IPASS4 = 1
      ELSE
         IPASS4 = 0
      ENDIF
      IPASS = MIN(IPASS1,IPASS2,IPASS3,IPASS4)
      IF (KPRINT .LE. 0 ) THEN
         GO TO 999
      ELSEIF ( KPRINT .EQ. 1 ) THEN
         IF ( IPASS .EQ. 1 ) THEN
            GO TO 999
         ELSE
            WRITE (LUN,104)
  104       FORMAT(' RJ - FAILED')
            GO TO 999
         ENDIF
      ELSE
         IF ( IPASS .EQ. 1 ) THEN
            WRITE (LUN,105)
  105       FORMAT(' RJ - PASSED')
            GO TO 999
         ELSE
            WRITE (LUN,104)
            IF ( IPASS4 .EQ. 0 ) WRITE (LUN,106) CONSJ, TRJ, DIF
  106       FORMAT(' CORRECT ANSWER =', 1PE14.6 /
     *             'COMPUTED ANSWER =',   E14.6 /
     *             '     DIFFERENCE =',   E14.6 )
            GO TO 999
         ENDIF
      ENDIF
  999 CONTINUE
      CALL XSETF(CONTRL)
      RETURN
      END

*DECK QCRD
      SUBROUTINE QCRD (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  QCRD
C***PURPOSE  Quick check for RD.
C***LIBRARY   SLATEC
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Pexton, R. L., (LLNL)
C***DESCRIPTION
C
C            QUICK TEST FOR CARLSON INTEGRAL RD
C
C***ROUTINES CALLED  NUMXER, R1MACH, RD, XERCLR, XGETF, XSETF
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   890618  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   910708  Minor modifications in use of KPRINT.  (WRB)
C***END PROLOGUE  QCRD
      INTEGER KPRINT, IPASS, CONTRL, KONTRL, LUN, IER
      INTEGER IPASS1, IPASS2, IPASS3, IPASS4, NUMXER
      REAL BLEM, TRD, RD, DIF, R1MACH
      EXTERNAL NUMXER, R1MACH, RD, XERCLR, XGETF, XSETF
C***FIRST EXECUTABLE STATEMENT  QCRD
      CALL XERCLR
      CALL XGETF(CONTRL)
      IF ( KPRINT .GE. 3 ) THEN
         KONTRL = +1
      ELSE
         KONTRL = 0
      ENDIF
      CALL XSETF(KONTRL)
C
C  FORCE ERROR 1
C
      IF ( KPRINT .GE. 3 ) WRITE (LUN,101)
  101 FORMAT(' RD - FORCE ERROR 1 TO OCCUR')
      TRD = RD(-1.0E0,-1.0E0,-1.0E0,IER)
      IER = NUMXER(IER)
      IF ( IER .EQ. 1 ) THEN
         IPASS1 = 1
      ELSE
         IPASS1 = 0
      ENDIF
      CALL XERCLR
C
C  FORCE ERROR 2
C
      IF ( KPRINT .GE. 3 ) WRITE (LUN,102)
  102 FORMAT(' RD - FORCE ERROR 2 TO OCCUR')
      TRD = RD(1.0E0,1.0E0,-1.0E0,IER)
      IER = NUMXER(IER)
      IF ( IER .EQ. 2 ) THEN
         IPASS2 = 1
      ELSE
         IPASS2 = 0
      ENDIF
      CALL XERCLR
C
C  FORCE ERROR 3
C
      IF ( KPRINT .GE. 3 ) WRITE (LUN,103)
  103 FORMAT(' RD - FORCE ERROR 3 TO OCCUR')
      TRD = RD(R1MACH(2),R1MACH(2),R1MACH(2),IER)
      IER = NUMXER(IER)
      IF ( IER .EQ. 3 ) THEN
         IPASS3 = 1
      ELSE
         IPASS3 = 0
      ENDIF
      CALL XERCLR
C
C  ARGUMENTS IN RANGE
C  BLEM=3 * LEMNISCATE CONSTANT B
C
      BLEM = 1.79721035210338831E0
      TRD  = RD(0.0E0,2.0E0,1.0E0,IER)
      CALL XERCLR
      DIF  = TRD - BLEM
      IF ( (ABS(DIF/BLEM).LT.1000.0E0*R1MACH(4)).AND.(IER.EQ.0) ) THEN
         IPASS4 = 1
      ELSE
         IPASS = 0
      ENDIF
      IPASS = MIN(IPASS1,IPASS2,IPASS3,IPASS4)
      IF ( KPRINT .LE. 0 ) THEN
         GO TO 999
      ELSEIF ( KPRINT .EQ. 1 ) THEN
         IF ( IPASS .EQ. 1 ) THEN
            GO TO 999
         ELSE
            WRITE (LUN,104)
  104       FORMAT(' RD - FAILED')
            GO TO 999
         ENDIF
      ELSE
         IF ( IPASS .EQ. 1 ) THEN
            WRITE (LUN,105)
  105       FORMAT(' RD - PASSED')
            GO TO 999
         ELSE
            WRITE (LUN,104)
            IF ( IPASS4 .EQ. 0 ) WRITE (LUN,106) BLEM, TRD, DIF
  106       FORMAT(' CORRECT ANSWER =', 1PE14.6 /
     *             'COMPUTED ANSWER =',   E14.6 /
     *             '     DIFFERENCE =',   E14.6 )
            GO TO 999
         ENDIF
      ENDIF
  999 CONTINUE
      CALL XSETF(CONTRL)
      RETURN
      END

*DECK JAC
      SUBROUTINE JAC (T, U, PD, NROWPD, RPAR, IPAR)
C***BEGIN PROLOGUE  JAC
C***SUBSIDIARY
C***PURPOSE  Evaluate Jacobian for DEBDF quick check.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (JAC-S, DJAC-D)
C***AUTHOR  Chow, Jeff (LANL)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   810801  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900415  Minor clean-up of prologue and code.  (WRB)
C***END PROLOGUE  JAC
      INTEGER IPAR, NROWPD
      REAL PD, R, R5, RPAR, RSQ, T, U, U1SQ, U2SQ, U1U2
      DIMENSION U(*),PD(NROWPD,*),RPAR(*),IPAR(*)
C***FIRST EXECUTABLE STATEMENT  JAC
      U1SQ = U(1)*U(1)
      U2SQ = U(2)*U(2)
      U1U2 = U(1)*U(2)
      RSQ = U1SQ + U2SQ
      R = SQRT(RSQ)
      R5 = RSQ*RSQ*R
      PD(3,1) = (3.E0*U1SQ - RSQ)/R5
      PD(4,1) = 3.E0*U1U2/R5
      PD(3,2) = PD(4,1)
      PD(4,2) = (3.E0*U2SQ - RSQ)/R5
      PD(1,3) = 1.E0
      PD(2,4) = 1.E0
      RETURN
      END

*DECK OUTERR
      SUBROUTINE OUTERR (METHOD, IERR, IOUT, NFAIL, ISTDO, ITER, ERR)
C***BEGIN PROLOGUE  OUTERR
C***SUBSIDIARY
C***PURPOSE  Output error messages for the SLAP Quick Check.
C***LIBRARY   SLATEC (SLAP)
C***TYPE      SINGLE PRECISION (OUTERR-S, DUTERR-D)
C***AUTHOR  Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-300
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   881010  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890920  Converted prologue to SLATEC 4.0 format.  (FNF)
C   920511  Added complete declaration section.  (WRB)
C   921021  Added 1P's to output formats.  (FNF)
C***END PROLOGUE  OUTERR
C     .. Scalar Arguments ..
      REAL ERR
      INTEGER IERR, IOUT, ISTDO, ITER, NFAIL
      CHARACTER METHOD*6
C***FIRST EXECUTABLE STATEMENT  OUTERR
      IF( IERR.NE.0 ) NFAIL = NFAIL + 1
      IF( IOUT.EQ.1 .AND. IERR.NE.0 ) THEN
         WRITE(ISTDO,1000) METHOD
      ENDIF
      IF( IOUT.EQ.2 ) THEN
         IF( IERR.EQ.0 ) THEN
            WRITE(ISTDO,1010) METHOD
         ELSE
            WRITE(ISTDO,1020) METHOD,IERR,ITER,ERR
         ENDIF
      ENDIF
      IF( IOUT.GE.3 ) THEN
         IF( IERR.EQ.0 ) THEN
            WRITE(ISTDO,1030) METHOD,IERR,ITER,ERR
         ELSE
            WRITE(ISTDO,1020) METHOD,IERR,ITER,ERR
         ENDIF
      ENDIF
      RETURN
 1000 FORMAT( 1X,A6,' : **** FAILURE ****')
 1010 FORMAT( 1X,A6,' : **** PASSED  ****')
 1020 FORMAT(' **************** WARNING ***********************'/
     $       ' **** ',A6,' Quick Test FAILED: IERR = ',I5,' ****'/
     $       ' **************** WARNING ***********************'/
     $       ' Iteration Count = ',I3,' Stop Test = ',1P,E12.6)
 1030 FORMAT(' ***************** PASSED ***********************'/
     $       ' **** ',A6,' Quick Test PASSED: IERR = ',I5,' ****'/
     $       ' ***************** PASSED ***********************'/
     $       ' Iteration Count = ',I3,' Stop Test = ',1P,E12.6)
C------------- LAST LINE OF OUTERR FOLLOWS ----------------------------
      END

*DECK HEADER
      SUBROUTINE HEADER (KPRINT)
C***BEGIN PROLOGUE  HEADER
C***PURPOSE  Print header for BLAS quick checks.
C***LIBRARY   SLATEC
C***AUTHOR  Lawson, C. L., (JPL)
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    COMBLA
C***REVISION HISTORY  (YYMMDD)
C   741212  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920210  Minor modifications to prologue and code.  (WRB)
C***END PROLOGUE  HEADER
      COMMON /COMBLA/ NPRINT, ICASE, N, INCX, INCY, MODE, PASS
      LOGICAL PASS
      CHARACTER*6 L(38)
C
      DATA L(1)  /'  SDOT'/
      DATA L(2)  /' DSDOT'/
      DATA L(3)  /'SDSDOT'/
      DATA L(4)  /'  DDOT'/
      DATA L(5)  /'DQDOTI'/
      DATA L(6)  /'DQDOTA'/
      DATA L(7)  /' CDOTC'/
      DATA L(8)  /' CDOTU'/
      DATA L(9)  /' SAXPY'/
      DATA L(10) /' DAXPY'/
      DATA L(11) /' CAXPY'/
      DATA L(12) /' SROTG'/
      DATA L(13) /' DROTG'/
      DATA L(14) /'  SROT'/
      DATA L(15) /'  DROT'/
      DATA L(16) /'SROTMG'/
      DATA L(17) /'DROTMG'/
      DATA L(18) /' SROTM'/
      DATA L(19) /' DROTM'/
      DATA L(20) /' SCOPY'/
      DATA L(21) /' DCOPY'/
      DATA L(22) /' CCOPY'/
      DATA L(23) /' SSWAP'/
      DATA L(24) /' DSWAP'/
      DATA L(25) /' CSWAP'/
      DATA L(26) /' SNRM2'/
      DATA L(27) /' DNRM2'/
      DATA L(28) /'SCNRM2'/
      DATA L(29) /' SASUM'/
      DATA L(30) /' DASUM'/
      DATA L(31) /'SCASUM'/
      DATA L(32) /' SSCAL'/
      DATA L(33) /' DSCAL'/
      DATA L(34) /' CSCAL'/
      DATA L(35) /'CSSCAL'/
      DATA L(36) /'ISAMAX'/
      DATA L(37) /'IDAMAX'/
      DATA L(38) /'ICAMAX'/
C***FIRST EXECUTABLE STATEMENT  HEADER
      IF (KPRINT .GE. 2) WRITE (NPRINT,9000) ICASE,L(ICASE)
      RETURN
C
 9000 FORMAT (' Test of subprogram number', I3, 2X, A)
      END

*DECK F3P
      REAL FUNCTION F3P (X)
C***BEGIN PROLOGUE  F3P
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F3P
      REAL X
C***FIRST EXECUTABLE STATEMENT  F3P
      F3P = 1.0
      IF(X.GT.3.1415926535897932) F3P = 0.0
      RETURN
      END

*DECK PASS
      SUBROUTINE PASS (LUN, ICNT, ITEST)
C***BEGIN PROLOGUE  PASS
C***PURPOSE  Print a PASS/FAIL message for a particular quick check
C            test.
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920210  PURPOSE added and code restructured.  (WRB)
C***END PROLOGUE  PASS
      INTEGER ICNT, ITEST, LUN
C***FIRST EXECUTABLE STATEMENT  PASS
      IF (ITEST .NE. 0) THEN
        WRITE (LUN,9000) ICNT
      ELSE
        WRITE (LUN,9100) ICNT
      ENDIF
      RETURN
 9000 FORMAT(/ ' TEST NUMBER', I5, ' PASSED')
 9100 FORMAT(/ ' *****TEST NUMBER' ,I5, ' FAILED**********')
      END

*DECK T1
      REAL FUNCTION T1 (X)
C***BEGIN PROLOGUE  T1
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  F1S
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  T1
      REAL A,B,F1S,X,X1,Y
C***FIRST EXECUTABLE STATEMENT  T1
      A = 0.0E+00
      B = 0.1E+01
      X1 = X+0.1E+01
      Y = (B-A)/X1+A
      T1 = (B-A)*F1S(Y)/X1/X1
      RETURN
      END

*DECK SMAKE3
      SUBROUTINE SMAKE3 (TYPE, UPLO, DIAG, M, N, A, NMAX, AA, LDA,
     $   RESET, TRANSL)
C***BEGIN PROLOGUE  SMAKE3
C***SUBSIDIARY
C***PURPOSE  Generate values for an M by N matrix A.
C***LIBRARY   SLATEC (BLAS)
C***AUTHOR  Dongarra, J. J., (ANL)
C           Duff, I., (AERE)
C           Du Croz, J., (NAG)
C           Hammarling, S., (NAG)
C***DESCRIPTION
C
C  Generates values for an M by N matrix A within the bandwidth
C  defined by KL and KU.
C  Stores the values in the array AA in the data structure required
C  by the routine, with unwanted elements set to rogue value.
C
C  TYPE is 'GE', 'SY' or  'TR'.
C
C  Auxiliary routine for test program for Level 3 Blas.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  SBEG
C***REVISION HISTORY  (YYMMDD)
C   890208  DATE WRITTEN
C   910620  Modified to meet SLATEC code and prologue standards.  (BKS)
C***END PROLOGUE  SMAKE3
C     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0, ONE = 1.0 )
      REAL               ROGUE
      PARAMETER          ( ROGUE = -1.0E10 )
C     .. Scalar Arguments ..
      REAL               TRANSL
      INTEGER            LDA, M, N, NMAX
      LOGICAL            RESET
      CHARACTER*1        DIAG, UPLO
      CHARACTER*2        TYPE
C     .. Array Arguments ..
      REAL               A( NMAX, * ), AA( * )
C     .. Local Scalars ..
      INTEGER            I, IBEG, IEND, J
      LOGICAL            GEN, LOWER, SYM, TRI, UNIT, UPPER
C     .. External Functions ..
      REAL               SBEG
      EXTERNAL           SBEG
C***FIRST EXECUTABLE STATEMENT  SMAKE3
      GEN = TYPE.EQ.'GE'
      SYM = TYPE.EQ.'SY'
      TRI = TYPE.EQ.'TR'
      UPPER = ( SYM.OR.TRI ).AND.UPLO.EQ.'U'
      LOWER = ( SYM.OR.TRI ).AND.UPLO.EQ.'L'
      UNIT = TRI.AND.DIAG.EQ.'U'
C
C     Generate data in array A.
C
      DO 20 J = 1, N
         DO 10 I = 1, M
            IF( GEN.OR.( UPPER.AND.I.LE.J ).OR.( LOWER.AND.I.GE.J ) )
     $          THEN
               A( I, J ) = SBEG( RESET ) + TRANSL
               IF( I.NE.J )THEN
C                 Set some elements to zero
                  IF( N.GT.3.AND.J.EQ.N/2 )
     $               A( I, J ) = ZERO
                  IF( SYM )THEN
                     A( J, I ) = A( I, J )
                  ELSE IF( TRI )THEN
                     A( J, I ) = ZERO
                  END IF
               END IF
            END IF
   10    CONTINUE
         IF( TRI )
     $      A( J, J ) = A( J, J ) + ONE
         IF( UNIT )
     $      A( J, J ) = ONE
   20 CONTINUE
C
C     Store elements in array AS in data structure required by routine.
C
      IF( TYPE.EQ.'GE' )THEN
         DO 50 J = 1, N
            DO 30 I = 1, M
               AA( I + ( J - 1 )*LDA ) = A( I, J )
   30       CONTINUE
            DO 40 I = M + 1, LDA
               AA( I + ( J - 1 )*LDA ) = ROGUE
   40       CONTINUE
   50    CONTINUE
      ELSE IF( TYPE.EQ.'SY'.OR.TYPE.EQ.'TR' )THEN
         DO 90 J = 1, N
            IF( UPPER )THEN
               IBEG = 1
               IF( UNIT )THEN
                  IEND = J - 1
               ELSE
                  IEND = J
               END IF
            ELSE
               IF( UNIT )THEN
                  IBEG = J + 1
               ELSE
                  IBEG = J
               END IF
               IEND = N
            END IF
            DO 60 I = 1, IBEG - 1
               AA( I + ( J - 1 )*LDA ) = ROGUE
   60       CONTINUE
            DO 70 I = IBEG, IEND
               AA( I + ( J - 1 )*LDA ) = A( I, J )
   70       CONTINUE
            DO 80 I = IEND + 1, LDA
               AA( I + ( J - 1 )*LDA ) = ROGUE
   80       CONTINUE
   90    CONTINUE
      END IF
      RETURN
C
C     End of SMAKE3.
C
      END

*DECK SQCK
      SUBROUTINE SQCK (LUN, KPRINT, NERR)
C***BEGIN PROLOGUE  SQCK
C***PURPOSE  Quick check for SPOFS, SPOIR, SNBFS and SNBIR.
C***LIBRARY   SLATEC
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Voorhees, E. A., (LANL)
C***DESCRIPTION
C
C    QUICK CHECK SUBROUTINE SQCK TESTS THE EXECUTION OF THE
C    SLATEC SUBROUTINES SPOFS, SPOIR, SNBFS AND SNBIR.
C    A TITLE LINE AND A SUMMARY LINE ARE ALWAYS OUTPUTTED.
C
C    THE SUMMARY LINE GIVES A COUNT OF THE NUMBER OF
C    PROBLEMS ENCOUNTERED IN THE TEST IF ANY EXIST.  SQCK
C    CHECKS COMPUTED VS. EXACT SOLUTIONS TO AGREE TO
C    WITHIN 0.8 TIMES THE WORD LENGTH OF THE COMPUTER
C    (1.6 IF DOUBLE PRECISION) FOR CASE 1.  SQCK ALSO
C    TESTS ERROR HANDLING BY THE SUBROUTINE (CALLS TO
C    XERMSG (SQCK SETS IFLAG/KONTRL TO 0))
C    USING A SINGULAR MATRIX FOR CASE 2.  EACH EXECUTION
C    PROBLEM DETECTED BY SQCK RESULTS IN AN ADDITIONAL
C    EXPLANATORY LINE OF OUTPUT.
C
C    SQCK REQUIRES NO INPUT ARGUMENTS.
C    ON RETURN, NERR (INTEGER TYPE) CONTAINS THE TOTAL COUNT
C    OF ALL PROBLEMS DETECTED BY SQCK.
C
C***ROUTINES CALLED  R1MACH, SNBFS, SNBIR, SPOFS, SPOIR
C***REVISION HISTORY  (YYMMDD)
C   800930  DATE WRITTEN
C   890911  Removed unnecessary intrinsics.  (WRB)
C   891009  Removed unreferenced statement label.  (WRB)
C   891009  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   901009  Routine writes illegal character to column 1, fixed.
C           Editorial changes made, code fixed to test all four
C           routines.  (RWC)
C   901009  Restructured using IF-THEN-ELSE-ENDIF, cleaned up FORMATs,
C           including removing an illegal character from column 1, and
C           fixed code to test all four routines.  (RWC)
C***END PROLOGUE  SQCK
      REAL A(4,4),AT(5,4),ABE(5,7),ABET(5,7),B(4),BT(4),C(4),WORK(35),
     1 R,DELX,DELMAX,SIGN,R1MACH
      CHARACTER*4 LIST(4)
      INTEGER LDA,N,ML,MU,IND,IWORK(4),NERR,I,J,J1,J2,JD,MLP,K,KCASE,
     1 KPROG
      DATA A/5.0E0,4.0E0,1.0E0,1.0E0,4.0E0,5.0E0,1.0E0,1.0E0,
     1 1.0E0,1.0E0,4.0E0,2.0E0,1.0E0,1.0E0,2.0E0,4.0E0/
      DATA LIST/'POFS','POIR','NBFS','NBIR'/
C***FIRST EXECUTABLE STATEMENT  SQCK
      IF (KPRINT.GE.3) WRITE (LUN,800)
      LDA = 5
      N = 4
      ML = 2
      MU = 1
      JD = 2*ML+MU+1
      NERR = 0
      R = R1MACH(4)**0.8E0
C
C     COMPUTE C VECTOR.
C
      SIGN = 1.0E0
      DO 10 I=1,N
         C(I) = SIGN/I
         SIGN = -SIGN
   10 CONTINUE
C
C     CASE 1 FOR WELL-CONDITIONED MATRIX, CASE 2 FOR SINGULAR MATRIX.
C
      DO 170 KCASE=1,2
         DO 140 KPROG=1,4
C           SET VECTOR B TO ZERO.
            DO 11 I=1,N
               B(I) = 0.0E0
   11       CONTINUE
C
C           FORM VECTOR B FOR NON-BANDED.
C
            IF (KPROG.LE.2) THEN
               DO 13 I=1,N
                  DO 12 J=1,N
                     B(I) = B(I)+A(I,J)*C(J)
   12             CONTINUE
   13          CONTINUE
            ELSE
C
C              FORM ABE(NB ARRAY) FROM MATRIX A
C              AND FORM VECTOR B FOR BANDED.
C
               DO 30 J=1,JD
                  DO 20 I=1,N
                     ABE(I,J) = 0.0E0
   20             CONTINUE
   30          CONTINUE
C
               MLP = ML+1
               DO 50 I=1,N
                  J1 = MAX(1,I-ML)
                  J2 = MIN(N,I+MU)
                  DO 40 J=J1,J2
                     K = J-I+MLP
                     ABE(I,K) = A(I,J)
                     B(I) = B(I)+(A(I,J)*C(J))
   40             CONTINUE
   50          CONTINUE
            ENDIF
C
C           FORM BT FROM B, AT FROM A, AND ABET FROM ABE.
C
            DO 60 I=1,N
               BT(I) = B(I)
               DO 58 J=1,N
                  AT(I,J) = A(I,J)
   58          CONTINUE
   60       CONTINUE
C
            DO 80 J=1,JD
               DO 70 I=1,N
                  ABET(I,J) = ABE(I,J)
   70          CONTINUE
   80       CONTINUE
C
C           MAKE AT AND ABET SINGULAR FOR CASE  =  2
C
            IF (KCASE.EQ.2) THEN
               DO 88 J=1,N
                  AT(1,J) = 0.0E0
   88          CONTINUE
C
               DO 90 J=1,JD
                  ABET(1,J) = 0.0E0
   90          CONTINUE
            ENDIF
C
C           SOLVE FOR X
C
            IF (KPROG.EQ.1) CALL SPOFS (AT,LDA,N,BT,1,IND,WORK)
            IF (KPROG.EQ.2) CALL SPOIR (AT,LDA,N,BT,1,IND,WORK)
            IF (KPROG.EQ.3) CALL SNBFS (ABET,LDA,N,ML,MU,BT,1,IND,WORK,
     *         IWORK)
            IF (KPROG.EQ.4) CALL SNBIR (ABET,LDA,N,ML,MU,BT,1,IND,WORK,
     *         IWORK)
C
C           COMPARE EXACT AND COMPUTED SOLUTIONS FOR CASE 1
C
            IF (KCASE.EQ.1) THEN
               DELMAX = 0.0E0
               DO 110 I=1,N
                  DELX = ABS(BT(I)-C(I))
                  DELMAX = MAX(DELMAX,DELX)
  110          CONTINUE
C
               IF (R.LE.DELMAX) THEN
                  NERR = NERR+1
                  WRITE (LUN,801) LIST(KPROG),KCASE,DELMAX
               ENDIF
            ELSE
C
C              CHECK CONTROL FOR SINGULAR MATRIX FOR CASE 2
C
               IF (IND.NE.-4) THEN
                  NERR = NERR+1
                  WRITE (LUN,802) LIST(KPROG),KCASE,IND
               ENDIF
            ENDIF
  140    CONTINUE
  170 CONTINUE
C
C     SUMMARY PRINT
C
      IF (NERR.NE.0) WRITE (LUN,803) NERR
      IF (KPRINT.GE.2 .AND. NERR.EQ.0) WRITE (LUN,804)
      RETURN
C
  800 FORMAT (/' *    SQCK - QUICK CHECK FOR SPOFS, SPOIR, SNBFS AND ',
     1   'SNBIR'/)
  801 FORMAT ('   PROBLEM WITH S', A, ', CASE ', I1,
     1 '.  MAX ABS ERROR OF', E11.4/)
  802 FORMAT ('   PROBLEM WITH S', A, ', CASE ', I1, '.  IND = ', I2,
     1  ' INSTEAD OF -4'/)
  803 FORMAT (/' **** SQCK DETECTED A TOTAL OF ', I2,' PROBLEMS. ****'/)
  804 FORMAT ('     SQCK DETECTED NO PROBLEMS.'/)
      END

*DECK F0C
      REAL FUNCTION F0C (X)
C***BEGIN PROLOGUE  F0C
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F0C
      REAL X
C***FIRST EXECUTABLE STATEMENT  F0C
      F0C = 1.E0/(X*X+1.E-4)
      RETURN
      END

*DECK F0F
      REAL FUNCTION F0F (X)
C***BEGIN PROLOGUE  F0F
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F0F
      REAL X
C***FIRST EXECUTABLE STATEMENT  F0F
      F0F = 0.0
      IF(X.NE.0.0) F0F = SIN(0.5E+02*X)/(X*SQRT(X))
      RETURN
      END

*DECK FFTQX
      SUBROUTINE FFTQX (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  FFTQX
C***PURPOSE  Quick check for the NCAR FFT routines.
C***LIBRARY   SLATEC
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Swarztrauber, P. N., (NCAR)
C***DESCRIPTION
C
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C
C                       VERSION 4  APRIL 1985
C
C                         A TEST DRIVER FOR
C          A PACKAGE OF FORTRAN SUBPROGRAMS FOR THE FAST FOURIER
C           TRANSFORM OF PERIODIC AND OTHER SYMMETRIC SEQUENCES
C
C                              BY
C
C                       PAUL N SWARZTRAUBER
C
C    NATIONAL CENTER FOR ATMOSPHERIC RESEARCH  BOULDER, COLORADO 80307
C
C        WHICH IS SPONSORED BY THE NATIONAL SCIENCE FOUNDATION
C
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C
C
C             THIS PROGRAM TESTS THE PACKAGE OF FAST FOURIER
C     TRANSFORMS FOR BOTH COMPLEX AND REAL PERIODIC SEQUENCES AND
C     CERTAIN OTHER SYMMETRIC SEQUENCES THAT ARE LISTED BELOW.
C
C     1.   RFFTI     INITIALIZE  RFFTF AND RFFTB
C     2.   RFFTF     FORWARD TRANSFORM OF A REAL PERIODIC SEQUENCE
C     3.   RFFTB     BACKWARD TRANSFORM OF A REAL COEFFICIENT ARRAY
C
C     4.   EZFFTI    INITIALIZE EZFFTF AND EZFFTB
C     5.   EZFFTF    A SIMPLIFIED REAL PERIODIC FORWARD TRANSFORM
C     6.   EZFFTB    A SIMPLIFIED REAL PERIODIC BACKWARD TRANSFORM
C
C     7.   SINTI     INITIALIZE SINT
C     8.   SINT      SINE TRANSFORM OF A REAL ODD SEQUENCE
C
C     9.   COSTI     INITIALIZE COST
C     10.  COST      COSINE TRANSFORM OF A REAL EVEN SEQUENCE
C
C     11.  SINQI     INITIALIZE SINQF AND SINQB
C     12.  SINQF     FORWARD SINE TRANSFORM WITH ODD WAVE NUMBERS
C     13.  SINQB     UNNORMALIZED INVERSE OF SINQF
C
C     14.  COSQI     INITIALIZE COSQF AND COSQB
C     15.  COSQF     FORWARD COSINE TRANSFORM WITH ODD WAVE NUMBERS
C     16.  COSQB     UNNORMALIZED INVERSE OF COSQF
C
C     17.  CFFTI     INITIALIZE CFFTF AND CFFTB
C     18.  CFFTF     FORWARD TRANSFORM OF A COMPLEX PERIODIC SEQUENCE
C     19.  CFFTB     UNNORMALIZED INVERSE OF CFFTF
C
C***ROUTINES CALLED  CFFTB, CFFTF, CFFTI, COSQB, COSQF, COSQI, COST,
C                    COSTI, EZFFTB, EZFFTF, EZFFTI, PIMACH, R1MACH,
C                    RFFTB, RFFTF, RFFTI, SINQB, SINQF, SINQI, SINT,
C                    SINTI
C***REVISION HISTORY  (YYMMDD)
C   790601  DATE WRITTEN
C   890718  Changed computation of PI to use PIMACH.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890911  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   901205  Changed usage of R1MACH(3) to R1MACH(4).  (RWC)
C   910708  Minor modifications in use of KPRINT.  (WRB)
C   920211  Code cleaned up, an error in printing an error message fixed
C           and comments on PASS/FAIL of individual tests added.  (WRB)
C   920618  Code upgraded to "Version 4".  (BKS, WRB)
C   930315  Modified RFFT* tests to compute "slow-transform" in DOUBLE
C           PRECISION.  (WRB)
C***END PROLOGUE  FFTQX
C     .. Scalar Arguments ..
      INTEGER IPASS, KPRINT, LUN
C     .. Local Scalars ..
      DOUBLE PRECISION ARG, ARG1, ARG2, DT, PI, SUM, SUM1, SUM2
      REAL AZERO, AZEROH, CF, COSQBT, COSQFB, COSQFT, COSTFB, COSTT,
     +     DCFB, DCFFTB, DCFFTF, DEZB1, DEZF1, DEZFB, ERRMAX, RFTB,
     +     RFTF, RFTFB, SIGN, SINQBT, SINQFB, SINQFT, SINTFB, SINTT,
     +     SQRT2, TPI
      INTEGER I, J, K, MODN, N, NM1, NNS, NP1, NS2, NS2M, NZ
C     .. Local Arrays ..
      COMPLEX CX(200), CY(200)
      REAL A(100), AH(100), B(100), BH(100), W(2000), X(200), XH(200),
     +     Y(200)
      INTEGER ND(10)
C     .. External Functions ..
      REAL R1MACH
      EXTERNAL R1MACH
C     .. External Subroutines ..
      EXTERNAL CFFTB, CFFTF, CFFTI, COSQB, COSQF, COSQI, COST, COSTI,
     +         EZFFTB, EZFFTF, EZFFTI, RFFTB, RFFTF, RFFTI, SINQB,
     +         SINQF, SINQI, SINT, SINTI
C     .. Intrinsic Functions ..
      INTRINSIC ABS, CABS, CMPLX, COS, MAX, MOD, SIN, SQRT
C     .. Data statements ..
      DATA ND(1), ND(2), ND(3), ND(4), ND(5), ND(6), ND(7)/120, 54, 49,
     +     32, 4, 3, 2/
C***FIRST EXECUTABLE STATEMENT  FFTQX
      SQRT2 = SQRT(2.0)
      ERRMAX = 2.0*SQRT(R1MACH(4))
      NNS = 7
      PI = 4.0D0*ATAN(1.0D0)
      IF (KPRINT .GE. 2) WRITE (LUN, 9000)
      IPASS = 1
      DO 660 NZ=1,NNS
        N = ND(NZ)
        IF (KPRINT .GE. 2) WRITE (LUN, 9010) N
        MODN = MOD(N, 2)
        NP1 = N + 1
        NM1 = N - 1
        DO 100 J=1,NP1
          X(J) = SIN(J*SQRT2)
          Y(J) = X(J)
          XH(J) = X(J)
  100   CONTINUE
C
C       Test Subroutines RFFTI, RFFTF and RFFTB
C
        CALL RFFTI(N, W)
        DT = (PI+PI)/N
        NS2 = (N+1)/2
        IF (NS2 .LT. 2) GO TO 130
        DO 120 K=2,NS2
          SUM1 = 0.0D0
          SUM2 = 0.0D0
          ARG = (K-1)*DT
          DO 110 I=1,N
            ARG1 = (I-1)*ARG
            SUM1 = SUM1 + X(I)*COS(ARG1)
            SUM2 = SUM2 + X(I)*SIN(ARG1)
  110     CONTINUE
          Y(2*K-2) = SUM1
          Y(2*K-1) = -SUM2
  120   CONTINUE
  130   SUM1 = 0.0D0
        SUM2 = 0.0D0
        DO 140 I=1,NM1,2
          SUM1 = SUM1 + X(I)
          SUM2 = SUM2 + X(I+1)
  140   CONTINUE
        IF (MODN .EQ. 1) SUM1 = SUM1 + X(N)
        Y(1) = SUM1 + SUM2
        IF (MODN .EQ. 0) Y(N) = SUM1 - SUM2
        CALL RFFTF(N, X, W)
        RFTF = 0.0
        DO 150 I=1,N
          RFTF = MAX(RFTF, ABS(X(I)-Y(I)))
          X(I) = XH(I)
  150   CONTINUE
        RFTF = RFTF/N
        IF (RFTF .LE. ERRMAX) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, 9020)
        ELSE
          IPASS = 0
          IF (KPRINT .GE. 2) WRITE (LUN, 9030)
        END IF
        SIGN = 1.0
        DO 180 I=1,N
          SUM = 0.5D0*X(1)
          ARG = (I-1)*DT
          IF (NS2 .LT. 2) GO TO 170
          DO 160 K=2,NS2
            ARG1 = (K-1)*ARG
            SUM = SUM + X(2*K-2)*COS(ARG1) - X(2*K-1)*SIN(ARG1)
  160     CONTINUE
  170     IF (MODN .EQ. 0) SUM = SUM + 0.5D0*SIGN*X(N)
          Y(I) = SUM + SUM
          SIGN = -SIGN
  180   CONTINUE
        CALL RFFTB(N, X, W)
        RFTB = 0.0
        DO 190 I=1,N
          RFTB = MAX(RFTB, ABS(X(I)-Y(I)))
          X(I) = XH(I)
          Y(I) = XH(I)
  190   CONTINUE
        RFTB = RFTB/N
        IF (RFTB .LE. ERRMAX) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, 9040)
        ELSE
          IPASS = 0
          IF (KPRINT .GE. 2) WRITE (LUN, 9050)
        END IF
C
        CALL RFFTB(N, Y, W)
        CALL RFFTF(N, Y, W)
        CF = 1.0/N
        RFTFB = 0.0
        DO 200 I=1,N
          RFTFB = MAX(RFTFB, ABS(CF*Y(I)-X(I)))
  200   CONTINUE
        IF (RFTFB .LE. ERRMAX) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, 9060)
        ELSE
          IPASS = 0
          IF (KPRINT .GE. 2) WRITE (LUN, 9070)
        END IF
C
C       Test Subroutines SINTI and SINT
C
        DT = PI/N
        DO 210 I=1,NM1
          X(I) = XH(I)
  210   CONTINUE
        DO 230 I=1,NM1
          Y(I) = 0.0
          ARG1 = I*DT
          DO 220 K=1,NM1
            Y(I) = Y(I) + X(K)*SIN((K)*ARG1)
  220     CONTINUE
          Y(I) = Y(I) + Y(I)
  230   CONTINUE
        CALL SINTI(NM1, W)
        CALL SINT(NM1, X, W)
        CF = 0.5/N
        SINTT = 0.0
        DO 240 I=1,NM1
          SINTT = MAX(SINTT, ABS(X(I)-Y(I)))
          X(I) = XH(I)
          Y(I) = X(I)
  240   CONTINUE
        SINTT = CF*SINTT
        IF (SINTT .LE. ERRMAX) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, 9080)
        ELSE
          IPASS = 0
          IF (KPRINT .GE. 2) WRITE (LUN, 9090)
        END IF
        CALL SINT(NM1, X, W)
        CALL SINT(NM1, X, W)
        SINTFB = 0.0
        DO 250 I=1,NM1
          SINTFB = MAX(SINTFB, ABS(CF*X(I)-Y(I)))
  250   CONTINUE
        IF (SINTFB .LE. ERRMAX) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, 9100)
        ELSE
          IPASS = 0
          IF (KPRINT .GE. 2) WRITE (LUN, 9110)
        END IF
C
C       Test Subroutines COSTI and COST
C
        DO 260 I=1,NP1
          X(I) = XH(I)
  260   CONTINUE
        SIGN = 1.0
        DO 280 I=1,NP1
          Y(I) = 0.5*(X(1)+SIGN*X(N+1))
          ARG = (I-1)*DT
          DO 270 K=2,N
            Y(I) = Y(I) + X(K)*COS((K-1)*ARG)
  270     CONTINUE
          Y(I) = Y(I) + Y(I)
          SIGN = -SIGN
  280   CONTINUE
        CALL COSTI(NP1, W)
        CALL COST(NP1, X, W)
        COSTT = 0.0
        DO 290 I=1,NP1
          COSTT = MAX(COSTT, ABS(X(I)-Y(I)))
          X(I) = XH(I)
          Y(I) = XH(I)
  290   CONTINUE
        COSTT = CF*COSTT
        IF (COSTT .LE. ERRMAX) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, 9120)
        ELSE
          IPASS = 0
          IF (KPRINT .GE. 2) WRITE (LUN, 9130)
        END IF
C
        CALL COST(NP1, X, W)
        CALL COST(NP1, X, W)
        COSTFB = 0.0
        DO 300 I=1,NP1
          COSTFB = MAX(COSTFB, ABS(CF*X(I)-Y(I)))
  300   CONTINUE
        IF (COSTFB .LE. ERRMAX) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, 9140)
        ELSE
          IPASS = 0
          IF (KPRINT .GE. 2) WRITE (LUN, 9150)
        END IF
C
C       Test Subroutines SINQI, SINQF and SINQB
C
        CF = 0.25/N
        DO 310 I=1,N
          Y(I) = XH(I)
  310   CONTINUE
        DT = PI/(N+N)
        DO 330 I=1,N
          X(I) = 0.0
          ARG = I*DT
          DO 320 K=1,N
            X(I) = X(I) + Y(K)*SIN((K+K-1)*ARG)
  320     CONTINUE
          X(I) = 4.0*X(I)
  330   CONTINUE
        CALL SINQI(N, W)
        CALL SINQB(N, Y, W)
        SINQBT = 0.0
        DO 340 I=1,N
          SINQBT = MAX(SINQBT, ABS(Y(I)-X(I)))
          X(I) = XH(I)
  340   CONTINUE
        SINQBT = CF*SINQBT
        IF (SINQBT .LE. ERRMAX) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, 9160)
        ELSE
          IPASS = 0
          IF (KPRINT .GE. 2) WRITE (LUN, 9170)
        END IF
C
        SIGN = 1.0
        DO 360 I=1,N
          ARG = (I+I-1)*DT
          Y(I) = 0.5*SIGN*X(N)
          DO 350 K=1,NM1
            Y(I) = Y(I) + X(K)*SIN((K)*ARG)
  350     CONTINUE
          Y(I) = Y(I) + Y(I)
          SIGN = -SIGN
  360   CONTINUE
        CALL SINQF(N, X, W)
        SINQFT = 0.0
        DO 370 I=1,N
          SINQFT = MAX(SINQFT, ABS(X(I)-Y(I)))
          Y(I) = XH(I)
          X(I) = XH(I)
  370   CONTINUE
        IF (SINQFT .LE. ERRMAX) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, 9180)
        ELSE
          IPASS = 0
          IF (KPRINT .GE. 2) WRITE (LUN, 9190)
        END IF
C
        CALL SINQF(N, Y, W)
        CALL SINQB(N, Y, W)
        SINQFB = 0.0
        DO 380 I=1,N
          SINQFB = MAX(SINQFB, ABS(CF*Y(I)-X(I)))
  380   CONTINUE
        IF (SINQFB .LE. ERRMAX) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, 9200)
        ELSE
          IPASS = 0
          IF (KPRINT .GE. 2) WRITE (LUN, 9210)
        END IF
C
C       Test Subroutines COSQI, COSQF and COSQB
C
        DO 390 I=1,N
          Y(I) = XH(I)
  390   CONTINUE
        DO 410 I=1,N
          X(I) = 0.0
          ARG = (I-1)*DT
          DO 400 K=1,N
            X(I) = X(I) + Y(K)*COS((K+K-1)*ARG)
  400     CONTINUE
          X(I) = 4.0*X(I)
  410   CONTINUE
        CALL COSQI(N, W)
        CALL COSQB(N, Y, W)
        COSQBT = 0.0
        DO 420 I=1,N
          COSQBT = MAX(COSQBT, ABS(X(I)-Y(I)))
          X(I) = XH(I)
  420   CONTINUE
        COSQBT = CF*COSQBT
        IF (COSQBT .LE. ERRMAX) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, 9220)
        ELSE
          IPASS = 0
          IF (KPRINT .GE. 2) WRITE (LUN, 9230)
        END IF
C
        DO 440 I=1,N
          Y(I) = 0.5*X(1)
          ARG = (I+I-1)*DT
          DO 430 K=2,N
            Y(I) = Y(I) + X(K)*COS((K-1)*ARG)
  430     CONTINUE
          Y(I) = Y(I) + Y(I)
  440   CONTINUE
        CALL COSQF(N, X, W)
        COSQFT = 0.0
        DO 450 I=1,N
          COSQFT = MAX(COSQFT, ABS(Y(I)-X(I)))
          X(I) = XH(I)
          Y(I) = XH(I)
  450   CONTINUE
        COSQFT = CF*COSQFT
        IF (COSQFT .LE. ERRMAX) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, 9240)
        ELSE
          IPASS = 0
          IF (KPRINT .GE. 2) WRITE (LUN, 9250)
        END IF
C
        CALL COSQB(N, X, W)
        CALL COSQF(N, X, W)
        COSQFB = 0.0
        DO 460 I=1,N
          COSQFB = MAX(COSQFB, ABS(CF*X(I)-Y(I)))
  460   CONTINUE
        IF (COSQFB .LE. ERRMAX) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, 9260)
        ELSE
          IPASS = 0
          IF (KPRINT .GE. 2) WRITE (LUN, 9270)
        END IF
C
C       Test Subroutines EZFFTI, EZFFTF and EZFFTB
C
        CALL EZFFTI(N, W)
        DO 470 I=1,N
          X(I) = XH(I)
  470   CONTINUE
        TPI = 2.0*PI
        DT = TPI/N
        NS2 = (N+1)/2
        CF = 2.0/N
        NS2M = NS2 - 1
        IF (NS2M .LE. 0) GO TO 500
        DO 490 K=1,NS2M
          SUM1 = 0.0D0
          SUM2 = 0.0D0
          ARG = K*DT
          DO 480 I=1,N
            ARG1 = (I-1)*ARG
            SUM1 = SUM1 + X(I)*COS(ARG1)
            SUM2 = SUM2 + X(I)*SIN(ARG1)
  480     CONTINUE
          A(K) = CF*SUM1
          B(K) = CF*SUM2
  490   CONTINUE
  500   NM1 = N - 1
        SUM1 = 0.0D0
        SUM2 = 0.0D0
        DO 510 I=1,NM1,2
          SUM1 = SUM1 + X(I)
          SUM2 = SUM2 + X(I+1)
  510   CONTINUE
        IF (MODN .EQ. 1) SUM1 = SUM1 + X(N)
        AZERO = 0.5*CF*(SUM1+SUM2)
        IF (MODN .EQ. 0) A(NS2) = 0.5*CF*(SUM1-SUM2)
        CALL EZFFTF(N, X, AZEROH, AH, BH, W)
        DEZF1 = ABS(AZEROH-AZERO)
        IF (MODN .EQ. 0) DEZF1 = MAX(DEZF1, ABS(A(NS2)-AH(NS2)))
        IF (NS2M .LE. 0) GO TO 530
        DO 520 I=1,NS2M
          DEZF1 = MAX(DEZF1, ABS(AH(I)-A(I)), ABS(BH(I)-B(I)))
  520   CONTINUE
        IF (DEZF1 .LE. ERRMAX) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, 9280)
        ELSE
          IPASS = 0
          IF (KPRINT .GE. 2) WRITE (LUN, 9290)
        END IF
C
  530   NS2 = N/2
        IF (MODN .EQ. 0) B(NS2) = 0.0
        DO 550 I=1,N
          SUM = AZERO
          ARG1 = (I-1)*DT
          DO 540 K=1,NS2
            ARG2 = K*ARG1
            SUM = SUM + A(K)*COS(ARG2) + B(K)*SIN(ARG2)
  540     CONTINUE
          X(I) = SUM
  550   CONTINUE
        CALL EZFFTB(N, Y, AZERO, A, B, W)
        DEZB1 = 0.0
        DO 560 I=1,N
          DEZB1 = MAX(DEZB1, ABS(X(I)-Y(I)))
          X(I) = XH(I)
  560   CONTINUE
        IF (DEZB1 .LE. ERRMAX) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, 9300)
        ELSE
          IPASS = 0
          IF (KPRINT .GE. 2) WRITE (LUN, 9310)
        END IF
C
        CALL EZFFTF(N, X, AZERO, A, B, W)
        CALL EZFFTB(N, Y, AZERO, A, B, W)
        DEZFB = 0.0
        DO 570 I=1,N
          DEZFB = MAX(DEZFB, ABS(X(I)-Y(I)))
  570   CONTINUE
        IF (DEZFB .LE. ERRMAX) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, 9320)
        ELSE
          IPASS = 0
          IF (KPRINT .GE. 2) WRITE (LUN, 9330)
        END IF
C
C       Test Subroutines CFFTI, CFFTF and CFFTB
C
        DO 580 I=1,N
          CX(I) = CMPLX(COS(SQRT2*I), SIN(SQRT2*(I*I)))
  580   CONTINUE
        DT = (PI+PI)/N
        DO 600 I=1,N
          ARG1 = -(I-1)*DT
          CY(I) = (0.0,0.0)
          DO 590 K=1,N
            ARG2 = (K-1)*ARG1
            CY(I) = CY(I) + CMPLX(COS(ARG2),SIN(ARG2))*CX(K)
  590     CONTINUE
  600   CONTINUE
        CALL CFFTI(N, W)
        CALL CFFTF(N, CX, W)
        DCFFTF = 0.0
        DO 610 I=1,N
          DCFFTF = MAX(DCFFTF, CABS(CX(I)-CY(I)))
          CX(I) = CX(I)/N
  610   CONTINUE
        DCFFTF = DCFFTF/N
        IF (DCFFTF .LE. ERRMAX) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, 9340)
        ELSE
          IPASS = 0
          IF (KPRINT .GE. 2) WRITE (LUN, 9350)
        END IF
C
        DO 630 I=1,N
          ARG1 = (I-1)*DT
          CY(I) = (0.0,0.0)
          DO 620 K=1,N
            ARG2 = (K-1)*ARG1
            CY(I) = CY(I) + CMPLX(COS(ARG2),SIN(ARG2))*CX(K)
  620     CONTINUE
  630   CONTINUE
        CALL CFFTB(N, CX, W)
        DCFFTB = 0.0
        DO 640 I=1,N
          DCFFTB = MAX(DCFFTB, CABS(CX(I)-CY(I)))
          CX(I) = CY(I)
  640   CONTINUE
        IF (DCFFTB .LE. ERRMAX) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, 9360)
        ELSE
          IPASS = 0
          IF (KPRINT .GE. 2) WRITE (LUN, 9370)
        END IF
C
        CF = 1.0/N
        CALL CFFTF(N, CX, W)
        CALL CFFTB(N, CX, W)
        DCFB = 0.0
        DO 650 I=1,N
          DCFB = MAX(DCFB, CABS(CF*CX(I)-CY(I)))
  650   CONTINUE
        IF (DCFB .LE. ERRMAX) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, 9380)
        ELSE
          IPASS = 0
          IF (KPRINT .GE. 2) WRITE (LUN, 9390)
        END IF
        IF (KPRINT .GE. 3) THEN
          WRITE (LUN, 9400) N, RFTF, RFTB, RFTFB, SINTT, SINTFB,
     +      COSTT, COSTFB, SINQFT, SINQBT, SINQFB, COSQFT, COSQBT,
     +      COSQFB, DEZF1, DEZB1, DEZFB, DCFFTF, DCFFTB, DCFB
        END IF
  660 CONTINUE
      IF (KPRINT.GE.2 .AND. IPASS.EQ.1) WRITE (LUN, 9410)
      IF (KPRINT.GE.1 .AND. IPASS.EQ.0) WRITE (LUN, 9420)
      RETURN
C
 9000 FORMAT ('1' / ' FFT QUICK CHECK')
 9010 FORMAT (/ ' Test FFT routines with a sequence of length ', I3)
 9020 FORMAT (' Test of RFFTF PASSED')
 9030 FORMAT (' Test of RFFTF FAILED')
 9040 FORMAT (' Test of RFFTB PASSED')
 9050 FORMAT (' Test of RFFTB FAILED')
 9060 FORMAT (' Test of RFFTF and RFFTB PASSED')
 9070 FORMAT (' Test of RFFTF and RFFTB FAILED')
 9080 FORMAT (' First test of SINT PASSED')
 9090 FORMAT (' First test of SINT FAILED')
 9100 FORMAT (' Second test of SINT PASSED')
 9110 FORMAT (' Second test of SINT FAILED')
 9120 FORMAT (' First test of COST PASSED')
 9130 FORMAT (' First test of COST FAILED')
 9140 FORMAT (' Second test of COST PASSED')
 9150 FORMAT (' Second test of COST FAILED')
 9160 FORMAT (' Test of SINQB PASSED')
 9170 FORMAT (' Test of SINQB FAILED')
 9180 FORMAT (' Test of SINQF PASSED')
 9190 FORMAT (' Test of SINQF FAILED')
 9200 FORMAT (' Test of SINQF and SINQB PASSED')
 9210 FORMAT (' Test of SINQF and SINQB FAILED')
 9220 FORMAT (' Test of COSQB PASSED')
 9230 FORMAT (' Test of COSQB FAILED')
 9240 FORMAT (' Test of COSQF PASSED')
 9250 FORMAT (' Test of COSQF FAILED')
 9260 FORMAT (' Test of COSQF and COSQB PASSED')
 9270 FORMAT (' Test of COSQF and COSQB FAILED')
 9280 FORMAT (' Test of EZFFTF PASSED')
 9290 FORMAT (' Test of EZFFTF FAILED')
 9300 FORMAT (' Test of EZFFTB PASSED')
 9310 FORMAT (' Test of EZFFTB FAILED')
 9320 FORMAT (' Test of EZFFTF and EZFFTB PASSED')
 9330 FORMAT (' Test of EZFFTF and EZFFTB FAILED')
 9340 FORMAT (' Test of CFFTF PASSED')
 9350 FORMAT (' Test of CFFTF FAILED')
 9360 FORMAT (' Test of CFFTB PASSED')
 9370 FORMAT (' Test of CFFTB FAILED')
 9380 FORMAT (' Test of CFFTF and CFFTB PASSED')
 9390 FORMAT (' Test of CFFTF and CFFTB FAILED')
 9400 FORMAT ('0N', I5, '  RFFTF  ', E9.3, '  RFFTB  ', E9.3,
     +        '  RFFTFB ',E9.3 /
     +        7X, '  SINT   ', E9.3, '  SINTFB ', E9.3 /
     +        7X, '  COST   ', E9.3 , '  COSTFB '  , E9.3 /
     +        7X, '  SINQF  ', E9.3, '  SINQB  ', E9.3, '  SINQFB ',
     +        E9.3 /
     +        7X, '  COSQF  ', E9.3, '  COSQB  ', E9.3, '  COSQFB ',
     +        E9.3 /
     +        7X, '  DEZF1  ', E9.3, '  DEZB1  ', E9.3, '  DEZFB  ',
     +        E9.3 /
     +        7X, '  CFFTF  ', E9.3, '  CFFTB  ', E9.3, '  CFFTFB ',
     +        E9.3)
 9410 FORMAT (/ ' ***********FFT ROUTINES PASSED ALL TESTS************')
 9420 FORMAT (/ ' ***********FFT ROUTINES FAILED SOME TESTS***********')
      END

*DECK DSOSFN
      DOUBLE PRECISION FUNCTION DSOSFN (X, K)
C***BEGIN PROLOGUE  DSOSFN
C***PURPOSE  Function evaluator for DSOS quick check.
C***LIBRARY   SLATEC
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C     FUNCTION WHICH EVALUATES THE FUNCTIONS, ONE AT A TIME,
C     FOR TEST PROGRAM USED IN QUICK CHECK OF DSOS.
C
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   890618  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  DSOSFN
      INTEGER K
      DOUBLE PRECISION X(2)
C***FIRST EXECUTABLE STATEMENT  DSOSFN
      IF (K .EQ. 1) DSOSFN = 1.0D0 - X(1)
      IF (K .EQ. 2) DSOSFN = 1.0D1*(X(2) - X(1)**2)
      RETURN
      END

*DECK RQRTST
      SUBROUTINE RQRTST (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  RQRTST
C***PURPOSE  Quick check for RPQR79.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (RQRTST-S, CQRTST-C)
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  NUMXER, PASS, R1MACH, RPQR79, XERCLR, XGETF, XSETF
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   901010  Restructured using IF-THEN-ELSE-ENDIF, cleaned up FORMATs
C           and changed TOL from sqrt R1MACH(3) to sqrt R1MACH(4) for
C           the IBM 370 mainframes.  (RWC)
C   911010  Code reworked and simplified.  (RWC and WRB)
C***END PROLOGUE  RQRTST
      INTEGER ITMP(7)
      COMPLEX ROOT(7), CHK(7)
      DIMENSION WORK(63)
      REAL COEF(8)
      LOGICAL FATAL
C
      DATA CHK / ( 1.4142135623731,  1.4142135623731),
     *           ( 1.4142135623731, -1.4142135623731),
     *           (0.0, 2.0), (0.0, -2.0), (-2.0, 0.0),
     *           (-1.4142135623731,  1.4142135623731),
     *           (-1.4142135623731, -1.4142135623731) /
C***FIRST EXECUTABLE STATEMENT  RQRTST
      IF (KPRINT .GE. 2) WRITE (LUN, 90000)
      TOL = SQRT(R1MACH(4))
      IPASS = 1
C
C     Initialize variables for testing.
C
      BETA = 0.0078125
      DO 20 J=1,8
         COEF(J) = BETA
         BETA = 2.0*BETA
   20 CONTINUE
C
      CALL RPQR79 (7, COEF, ROOT, IERR, WORK)
C
C     Check to see if test passed.
C
      DO 10 I=1,7
         ITMP(I) = 0
   10 CONTINUE
C
C     Check for roots in any order.
C
      DO 40 I=1,7
         DO 30 J=1,7
            IF (ABS(ROOT(I)-CHK(J)) .LE. TOL) THEN
               ITMP(J) = 1
               GO TO 40
            ENDIF
   30    CONTINUE
   40 CONTINUE
C
C     Check that we found all 7 roots.
C
      IPASS = 1
      DO 50 I=1,7
         IPASS = IPASS*ITMP(I)
   50 CONTINUE
C
C     Print test results.
C
      IF (KPRINT.GE.3 .OR. (KPRINT.GE.2.AND.IPASS.EQ.0)) THEN
         WRITE (LUN, 90010)
         WRITE (LUN, 90020) (J,COEF(J), J=1,8)
         WRITE (LUN, 90030)
         WRITE (LUN, 90040) (J,ROOT(J), J=1,7)
      ENDIF
      IF (KPRINT .GE. 2) THEN
         CALL PASS (LUN, 1, IPASS)
      ENDIF
C
C     Trigger 2 error conditions
C
      CALL XGETF (KONTRL)
      IF (KPRINT .LE. 2) THEN
         CALL XSETF (0)
      ELSE
         CALL XSETF (1)
      ENDIF
      FATAL = .FALSE.
      CALL XERCLR
      IF (KPRINT .GE. 3) WRITE (LUN, 90060)
C
C     CALL RPQR79 with 0 degree polynomial.
C
      CALL RPQR79 (0, COEF, ROOT, IERR, WORK)
      IF (NUMXER(NERR) .NE. 3) THEN
         FATAL = .TRUE.
      ENDIF
      CALL XERCLR
C
C     CALL RPQR79 with zero leading coefficient.
C
      COEF(1) = 0.0
      CALL RPQR79 (2, COEF, ROOT, IERR, WORK)
      IF (NUMXER(NERR) .NE. 2) THEN
         FATAL = .TRUE.
      ENDIF
      CALL XERCLR
C
      CALL XSETF (KONTRL)
      IF (FATAL) THEN
         IPASS = 0
         IF (KPRINT .GE. 2) THEN
            WRITE (LUN, 90070)
         ENDIF
      ELSE
         IF (KPRINT .GE. 3) THEN
            WRITE (LUN, 90080)
         ENDIF
      ENDIF
C
      IF (IPASS.EQ.1 .AND. KPRINT.GT.1) WRITE (LUN,90100)
      IF (IPASS.EQ.0 .AND. KPRINT.NE.0) WRITE (LUN,90110)
      RETURN
C
90000 FORMAT ('1', /,' RPQR79 QUICK CHECK')
90010 FORMAT (/, ' CHECK REAL AND IMAGINARY PARTS OF ROOT' /
     *          ' COEFFICIENTS')
90020 FORMAT (/ (I6, 3X, 1P, E22.14))
90030 FORMAT (// 25X, 'TABLE of ROOTS' //
     *        '   ROOT         REAL  PART', 12X, 'IMAG  PART' /
     *        '  NUMBER', 8X, 2(' of  ZERO ', 12X))
90040 FORMAT (I6, 3X, 1P, 2E22.14)
90060 FORMAT (// ' TRIGGER 2 ERROR CONDITIONS' //)
90070 FORMAT (/ ' AT LEAST ONE INCORRECT ARGUMENT TEST FAILED')
90080 FORMAT (/ ' ALL INCORRECT ARGUMENT TESTS PASSED')
90100 FORMAT (/' **************RPQR79 PASSED ALL TESTS**************')
90110 FORMAT (/' **************RPQR79 FAILED SOME TESTS*************')
      END

*DECK ITEST
      SUBROUTINE ITEST (LEN, ICOMP, ITRUE, KPRINT)
C***BEGIN PROLOGUE  ITEST
C***PURPOSE  Compare arrays ICOMP and ITRUE.
C***LIBRARY   SLATEC
C***TYPE      INTEGER (ITEST-I)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Lawson, C. L., (JPL)
C***DESCRIPTION
C
C   This subroutine compares the arrays ICOMP and ITRUE of length LEN
C   for equality.  In the case of an unequal compare, appropriate
C   messages are written.
C
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    COMBLA
C***REVISION HISTORY  (YYMMDD)
C   741210  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920211  Code restructured and information added to the DESCRIPTION
C           section.  (WRB)
C***END PROLOGUE  ITEST
      INTEGER ICOMP(*), ITRUE(*)
      LOGICAL PASS
      COMMON /COMBLA/ NPRINT, ICASE, N, INCX, INCY, MODE, PASS
C***FIRST EXECUTABLE STATEMENT  ITEST
      DO 100 I = 1,LEN
        IF (ICOMP(I) .NE. ITRUE(I)) THEN
C
C         Here ICOMP(I) is not equal to ITRUE(I).
C
          IF (PASS) THEN
C
C           Print FAIL message and header.
C
            PASS = .FALSE.
            IF (KPRINT .GE. 3) THEN
              WRITE (NPRINT,9000)
              WRITE (NPRINT,9010)
            ENDIF
          ENDIF
          IF (KPRINT .GE. 3) THEN
            ID = ICOMP(I) - ITRUE(I)
            WRITE (NPRINT,9020) ICASE, N, INCX, INCY, MODE, I, ICOMP(I),
     +                          ITRUE(I), ID
          ENDIF
        ENDIF
  100 CONTINUE
      RETURN
 9000 FORMAT ('+', 39X, 'FAIL')
 9010 FORMAT ('0CASE  N INCX INCY MODE  I', 29X, 'COMP(I)', 29X,
     +        'TRUE(I)', 2X, 'DIFFERENCE' / 1X)
 9020 FORMAT (1X, I4, I3, 3I5, I3, 2I36, I12)
      END

*DECK F2S
      REAL FUNCTION F2S (X)
C***BEGIN PROLOGUE  F2S
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F2S
      REAL X
C***FIRST EXECUTABLE STATEMENT  F2S
      F2S = 100.0
      IF(X.NE.0.0) F2S = SIN(0.314159E+03*X)/(0.314159E+01*X)
      RETURN
      END

*DECK F2G
      REAL FUNCTION F2G (X)
C***BEGIN PROLOGUE  F2G
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F2G
      REAL X
C***FIRST EXECUTABLE STATEMENT  F2G
      F2G = X*SIN(0.3E+02*X)*COS(0.5E+02*X)
      RETURN
      END

*DECK QXCRT
      SUBROUTINE QXCRT (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  QXCRT
C***PURPOSE
C***LIBRARY   SLATEC
C***KEYWORDS  QUICK CHECK
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C     *                                                               *
C     *                        F I S H P A K                          *
C     *                                                               *
C     *                                                               *
C     *     A PACKAGE OF FORTRAN SUBPROGRAMS FOR THE SOLUTION OF      *
C     *                                                               *
C     *      SEPARABLE ELLIPTIC PARTIAL DIFFERENTIAL EQUATIONS        *
C     *                                                               *
C     *                  (VERSION  3 , JUNE 1979)                     *
C     *                                                               *
C     *                             BY                                *
C     *                                                               *
C     *        JOHN ADAMS, PAUL SWARZTRAUBER AND ROLAND SWEET         *
C     *                                                               *
C     *                             OF                                *
C     *                                                               *
C     *         THE NATIONAL CENTER FOR ATMOSPHERIC RESEARCH          *
C     *                                                               *
C     *                BOULDER, COLORADO  (80307)  U.S.A.             *
C     *                                                               *
C     *                   WHICH IS SPONSORED BY                       *
C     *                                                               *
C     *              THE NATIONAL SCIENCE FOUNDATION                  *
C     *                                                               *
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C
C
C          PROGRAM TO ILLUSTRATE THE USE OF SUBROUTINE HWSCRT TO SOLVE
C     THE EQUATION
C
C     (D/DX)(DU/DX) + (D/DY)(DU/DY) - 4*U
C
C     = (2 - (4 + PI**2/4)*X**2)*COS((Y+1)*PI/2)
C
C     WITH THE BOUNDARY CONDITIONS
C     ON THE RECTANGLE 0 .LT. X .LT. 2, -1 .LT. Y .LT. 3 WITH THE
C
C     U(0,Y) = 0
C                                          -1 .LE. Y .LE. 3
C     (DU/DX)(2,Y) = 4*COS((Y+1)*PI/2)
C
C     AND WITH U PERIODIC IN Y.
C          THE X-INTERVAL WILL BE DIVIDED INTO 40 PANELS AND THE
C     Y-INTERVAL WILL BE DIVIDED INTO 80 PANELS.
C
C***ROUTINES CALLED  HWSCRT, PIMACH
C***REVISION HISTORY  (YYMMDD)
C   800103  DATE WRITTEN
C   890718  Changed computation of PI to use PIMACH.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890911  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   901010  Added PASS/FAIL message and cleaned up FORMATs.  (RWC)
C***END PROLOGUE  QXCRT
      DIMENSION F(45,82), BDB(81), W(1200), X(41), Y(81)
C***FIRST EXECUTABLE STATEMENT  QXCRT
C
C     FROM DIMENSION STATEMENT WE GET VALUE OF IDIMF.  ALSO NOTE THAT W
C     IS DIMENSIONED 6*(N+1) + 8*(M+1).
C
      IDIMF = 45
      ERMAX=1.E-3
      A = 0.
      B = 2.
      M = 40
      MBDCND = 2
      C = -1.
      D = 3.
      N = 80
      NBDCND = 0
      ELMBDA = -4.
C
C     AUXILIARY QUANTITIES.
C
      PI = PIMACH(DUM)
      PIBY2 = PI/2.
      PISQ = PI**2
      MP1 = M+1
      NP1 = N+1
C
C     GENERATE AND STORE GRID POINTS FOR THE PURPOSE OF COMPUTING
C     BOUNDARY DATA AND THE RIGHT SIDE OF THE HELMHOLTZ EQUATION.
C
      DO 101 I=1,MP1
         X(I) = (I-1)/20.0E0
  101 CONTINUE
      DO 102 J=1,NP1
         Y(J) = -1.0E0+(J-1)/20.0E0
  102 CONTINUE
C
C     GENERATE BOUNDARY DATA.
C
      DO 103 J=1,NP1
         BDB(J) = 4.*COS((Y(J)+1.)*PIBY2)
  103 CONTINUE
C
C     BDA, BDC, AND BDD ARE DUMMY VARIABLES.
C
      DO 104 J=1,NP1
         F(1,J) = 0.
  104 CONTINUE
C
C     GENERATE RIGHT SIDE OF EQUATION.
C
      DO 106 I=2,MP1
         DO 105 J=1,NP1
            F(I,J) = (2.-(4.+PISQ/4.)*X(I)**2)*COS((Y(J)+1.)*PIBY2)
  105    CONTINUE
  106 CONTINUE
      CALL HWSCRT(A,B,M,MBDCND,BDA,BDB,C,D,N,NBDCND,BDC,BDD,ELMBDA,F,
     1             IDIMF,PERTRB,IERROR,W)
C
C     COMPUTE DISCRETIZATION ERROR.  THE EXACT SOLUTION IS
C                U(X,Y) = X**2*COS((Y+1)*PIBY2)
C
      ERR = 0.
      DO 108 I=1,MP1
         DO 107 J=1,NP1
            Z = ABS(F(I,J)-X(I)**2*COS((Y(J)+1.)*PIBY2))
            IF (Z .GT. ERR) ERR = Z
  107    CONTINUE
  108 CONTINUE
C
      IPASS = 1
      IF (ERR.GT.ERMAX) IPASS = 0
      IF (KPRINT.EQ.0) RETURN
      IF (KPRINT.GE.2 .OR. IPASS.EQ.0) THEN
         WRITE (LUN,1001) IERROR,ERR,INT(W(1))
         IF (IPASS.EQ.1) THEN
            WRITE (LUN, 1002)
         ELSE
            WRITE (LUN, 1003)
         ENDIF
      ENDIF
      RETURN
C
 1001 FORMAT ('1',20X,'SUBROUTINE HWSCRT EXAMPLE'///
     1        10X,'THE OUTPUT FROM THE NCAR CONTROL DATA 7600 WAS'//
     2        32X,'IERROR = 0'/
     3        18X,'DISCRETIZATION ERROR = 5.36508E-04'/
     4        12X,'REQUIRED LENGTH OF W ARRAY = 880'//
     5        10X,'THE OUTPUT FROM YOUR COMPUTER IS'//
     6        32X,'IERROR =',I2/
     7        18X,'DISCRETIZATION ERROR =',1PE12.5/
     8        12X,'REQUIRED LENGTH OF W ARRAY =',I4)
 1002 FORMAT (60X,'PASS'/)
 1003 FORMAT (60X,'FAIL'/)
      END

*DECK ISMPL
      SUBROUTINE ISMPL (N, M, INDX)
C***BEGIN PROLOGUE  ISMPL
C***SUBSIDIARY
C***PURPOSE  Generate integer sample.
C            This routine picks M "random" integers in the range 1 to
C            N without any repetitions.
C***LIBRARY   SLATEC (SLAP)
C***TYPE      INTEGER (ISMPL-I)
C***AUTHOR  Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-300
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***ROUTINES CALLED  RAND
C***REVISION HISTORY  (YYMMDD)
C   871119  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890919  Changed to integer name ISMPL.  (MKS)
C   890920  Converted prologue to SLATEC 4.0 format.  (FNF)
C   920511  Added complete declaration section.  (WRB)
C***END PROLOGUE  ISMPL
C     .. Scalar Arguments ..
      INTEGER M, N
C     .. Array Arguments ..
      INTEGER INDX(M)
C     .. Local Scalars ..
      REAL DUMMY
      INTEGER I, ID, J
C     .. External Functions ..
      REAL RAND
      EXTERNAL RAND
C     .. Intrinsic Functions ..
      INTRINSIC INT
C***FIRST EXECUTABLE STATEMENT  ISMPL
C
C     Check the input
C
      DUMMY = 0.0
      IF( N*M.LT.0 .OR. M.GT.N ) RETURN
C
C     Set the indices.
      INDX(1) = INT( RAND(DUMMY)*N ) + 1
CVD$ NOCONCUR
      DO 30 I = 2, M
 10      ID = INT( RAND(DUMMY)*N ) + 1
C
C        Check to see if ID has already been chosen.
CVD$ NOVECTOR
CVD$ NOCONCUR
         DO 20 J = 1, I-1
            IF( ID.EQ.INDX(J) ) GOTO 10
 20      CONTINUE
         INDX(I) = ID
 30   CONTINUE
      RETURN
C------------- LAST LINE OF ISMPL FOLLOWS ------------------------------
      END

*DECK T0
      REAL FUNCTION T0 (X)
C***BEGIN PROLOGUE  T0
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  F0S
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  T0
      REAL A,B,F0S,X,X1,Y
C***FIRST EXECUTABLE STATEMENT  T0
      A = 0.0E+00
      B = 0.1E+01
      X1 = X+0.1E+01
      Y = (B-A)/X1+A
      T0 = (B-A)*F0S(Y)/X1/X1
      RETURN
      END

*DECK PCHQK3
      SUBROUTINE PCHQK3 (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  PCHQK3
C***PURPOSE  Test the PCHIP interpolators PCHIC, PCHIM, PCHSP.
C***LIBRARY   SLATEC (PCHIP)
C***TYPE      SINGLE PRECISION (PCHQK3-S, DPCHQ3-D)
C***KEYWORDS  PCHIP INTERPOLATOR QUICK CHECK
C***AUTHOR  Fritsch, F. N., (LLNL)
C***DESCRIPTION
C
C              PCHIP QUICK CHECK NUMBER 3
C
C     TESTS THE INTERPOLATORS:  PCHIC, PCHIM, PCHSP.
C *Usage:
C
C        INTEGER  LUN, KPRINT, IPASS
C
C        CALL PCHQK3 (LUN, KPRINT, IPASS)
C
C *Arguments:
C
C     LUN   :IN  is the unit number to which output is to be written.
C
C     KPRINT:IN  controls the amount of output, as specified in the
C                SLATEC Guidelines.
C
C     IPASS:OUT  will contain a pass/fail flag.  IPASS=1 is good.
C                IPASS=0 indicates one or more tests failed.
C
C *Description:
C
C   This routine interpolates a constructed data set with all three
C    PCHIP interpolators and compares the results with those obtained
C   on a Cray X/MP.  Two different values of the  PCHIC parameter SWITCH
C   are used.
C
C *Remarks:
C     1. The Cray results are given only to nine significant figures,
C        so don't expect them to match to more.
C     2. The results will depend to some extent on the accuracy of
C        the EXP function.
C
C***ROUTINES CALLED  COMP, PCHIC, PCHIM, PCHSP, R1MACH
C***REVISION HISTORY  (YYMMDD)
C   900309  DATE WRITTEN
C   900314  Converted to a subroutine and added a SLATEC 4.0 prologue.
C   900315  Revised prologue and improved some output formats.  (FNF)
C   900316  Made TOLD machine-dependent and added extra output when
C           KPRINT=3.  (FNF)
C   900320  Added E0's to DATA statement for X to reduce single/double
C           differences, and other minor cosmetic changes.
C   900321  Removed IFAIL from call sequence for SLATEC standards and
C           made miscellaneous cosmetic changes.  (FNF)
C   900322  Minor changes to reduce single/double differences.  (FNF)
C   900530  Tolerance (TOLD) changed.  (WRB)
C   900802  Modified TOLD formula and constants in PCHIC calls to be
C           compatible with DPCHQ3.  (FNF)
C   901130  Several significant changes:  (FNF)
C           1. Changed comparison between PCHIM and PCHIC to only
C              require agreement to machine precision.
C           2. Revised to print more output when KPRINT=3.
C           3. Added 1P's to formats.
C   910708  Minor modifications in use of KPRINT.  (WRB)
C   930317  Improved output formats.  (FNF)
C***END PROLOGUE  PCHQK3
C
C*Internal Notes:
C
C     TOLD is used to compare with stored Cray results.  Its value
C          should be consistent with significance of stored values.
C     TOLZ is used for cases in which exact equality is expected.
C     TOL  is used for cases in which agreement to machine precision
C          is expected.
C**End
C
C  Declare arguments.
C
      INTEGER  LUN, KPRINT, IPASS
      LOGICAL  COMP
      REAL  R1MACH
C
C  Declare variables.
C
      INTEGER  I, IC(2), IERR, IFAIL, N, NBAD, NBADZ, NWK
      PARAMETER  (N = 9,  NWK = 2*N)
      REAL  D(N), DC(N), DC5, DC6, DM(N), DS(N), ERR, F(N), MONE, TOL,
     *      TOLD, TOLZ, VC(2), X(N), WK(NWK), ZERO
      PARAMETER  (ZERO = 0.0E0,  MONE = -1.0E0)
      CHARACTER*6  RESULT
C
C  Initialize.
C
C       Data.
      DATA  IC /0, 0/
      DATA  X /-2.2E0,-1.2E0,-1.0E0,-0.5E0,-0.01E0, 0.5E0, 1.0E0,
     *          2.0E0, 2.2E0/
C
C       Results generated on Cray X/MP (9 sign. figs.)
      DATA  DM / 0.            , 3.80027352E-01, 7.17253009E-01,
     *           5.82014161E-01, 0.            ,-5.68208031E-01,
     *          -5.13501618E-01,-7.77910977E-02,-2.45611117E-03/
      DATA  DC5,DC6 / 1.76950158E-02,-5.69579814E-01/
      DATA  DS /-5.16830792E-02, 5.71455855E-01, 7.40530225E-01,
     *           7.63864934E-01, 1.92614386E-02,-7.65324380E-01,
     *          -7.28209035E-01,-7.98445427E-02,-2.85983446E-02/
C
C***FIRST EXECUTABLE STATEMENT  PCHQK3
      IFAIL = 0
C
C        Set tolerances.
      TOL  = 10*R1MACH(4)
      TOLD = MAX( 1.0E-7, 10*TOL )
      TOLZ = ZERO
C
      IF (KPRINT .GE. 3)  WRITE (LUN, 1000)
      IF (KPRINT .GE. 2)  WRITE (LUN, 1001)
C
C  Set up data.
C
      DO 10  I = 1, N
         F(I) = EXP(-X(I)**2)
   10 CONTINUE
C
      IF (KPRINT .GE. 3)  THEN
         WRITE (LUN, 1002)
         DO 12  I = 1, 4
            WRITE (LUN, 1010)  X(I), F(I), DM(I), DS(I)
   12    CONTINUE
            WRITE (LUN, 1011)  X(5), F(5), DM(5), DC5, DS(5)
            WRITE (LUN, 1011)  X(6), F(6), DM(6), DC6, DS(6)
         DO 15  I = 7, N
            WRITE (LUN, 1010)  X(I), F(I), DM(I), DS(I)
   15    CONTINUE
      ENDIF
C
C  Test PCHIM.
C
      IF (KPRINT.GE.3)  WRITE (LUN, 2000) 'IM'
C     --------------------------------
      CALL PCHIM (N, X, F, D, 1, IERR)
C     --------------------------------
C        Expect IERR=1 (one monotonicity switch).
      IF ( KPRINT.GE.3 )  WRITE (LUN, 2001) 1
      IF ( .NOT.COMP (IERR, 1, LUN, KPRINT) )  THEN
         IFAIL = IFAIL + 1
      ELSE
         IF ( KPRINT.GE.3 )  WRITE (LUN, 2002)
         NBAD = 0
         NBADZ = 0
         DO 20  I = 1, N
            RESULT = '  OK'
C             D-values should agree with stored values.
C               (Zero values should agree exactly.)
            IF ( DM(I).EQ.ZERO )  THEN
               ERR = ABS( D(I) )
               IF ( ERR.GT.TOLZ )  THEN
                  NBADZ = NBADZ + 1
                  RESULT = '**BADZ'
               ENDIF
            ELSE
               ERR = ABS( (D(I)-DM(I))/DM(I) )
               IF ( ERR.GT.TOLD )  THEN
                  NBAD = NBAD + 1
                  RESULT = '**BAD'
               ENDIF
            ENDIF
            IF (KPRINT.GE.3)
     *         WRITE (LUN, 2003)  I, X(I), D(I), ERR, RESULT
   20    CONTINUE
         IF ( (NBADZ.NE.0).OR.(NBAD.NE.0) )  THEN
            IFAIL = IFAIL + 1
            IF ((NBADZ.NE.0).AND.(KPRINT.GE.2))
     *         WRITE (LUN, 2004)  NBAD
            IF ((NBAD.NE.0).AND.(KPRINT.GE.2))
     *         WRITE (LUN, 2005)  NBAD, 'IM', TOLD
         ELSE
            IF (KPRINT.GE.2)  WRITE (LUN, 2006)  'IM'
         ENDIF
      ENDIF
C
C  Test PCHIC -- options set to reproduce PCHIM.
C
      IF (KPRINT.GE.3)  WRITE (LUN, 2000) 'IC'
C     --------------------------------------------------------
      CALL PCHIC (IC, VC, ZERO, N, X, F, DC, 1, WK, NWK, IERR)
C     --------------------------------------------------------
C        Expect IERR=0 .
      IF ( KPRINT.GE.3 )  WRITE (LUN, 2001) 0
      IF ( .NOT.COMP (IERR, 0, LUN, KPRINT) )  THEN
         IFAIL = IFAIL + 1
      ELSE
         IF ( KPRINT.GE.3 )  WRITE (LUN, 2002)
         NBAD = 0
         DO 30  I = 1, N
            RESULT = '  OK'
C           D-values should agree exactly with those computed by PCHIM.
C            (To be generous, will only test to machine precision.)
            ERR = ABS( D(I)-DC(I) )
            IF ( ERR.GT.TOL )  THEN
               NBAD = NBAD + 1
               RESULT = '**BAD'
            ENDIF
            IF (KPRINT.GE.3)
     *         WRITE (LUN, 2003)  I, X(I), DC(I), ERR, RESULT
   30    CONTINUE
         IF ( NBAD.NE.0 )  THEN
            IFAIL = IFAIL + 1
            IF (KPRINT.GE.2)  WRITE (LUN, 2005)  NBAD, 'IC', TOL
         ELSE
            IF (KPRINT.GE.2)  WRITE (LUN, 2006)  'IC'
         ENDIF
      ENDIF
C
C  Test PCHIC -- default nonzero switch derivatives.
C
      IF (KPRINT.GE.3)  WRITE (LUN, 2000) 'IC'
C     -------------------------------------------------------
      CALL PCHIC (IC, VC, MONE, N, X, F, D, 1, WK, NWK, IERR)
C     -------------------------------------------------------
C        Expect IERR=0 .
      IF ( KPRINT.GE.3 )  WRITE (LUN, 2001) 0
      IF ( .NOT.COMP (IERR, 0, LUN, KPRINT) )  THEN
         IFAIL = IFAIL + 1
      ELSE
         IF ( KPRINT.GE.3 )  WRITE (LUN, 2002)
         NBAD = 0
         NBADZ = 0
         DO 40  I = 1, N
            RESULT = '  OK'
C            D-values should agree exactly with those computed in
C            previous call, except at points 5 and 6.
            IF ( (I.LT.5).OR.(I.GT.6) )  THEN
               ERR = ABS( D(I)-DC(I) )
               IF ( ERR.GT.TOLZ )  THEN
                  NBADZ = NBADZ + 1
                  RESULT = '**BADA'
               ENDIF
            ELSE
               IF ( I.EQ.5 )  THEN
                  ERR = ABS( (D(I)-DC5)/DC5 )
               ELSE
                  ERR = ABS( (D(I)-DC6)/DC6 )
               ENDIF
               IF ( ERR.GT.TOLD )  THEN
                  NBAD = NBAD + 1
                  RESULT = '**BAD'
               ENDIF
            ENDIF
            IF (KPRINT.GE.3)
     *         WRITE (LUN, 2003)  I, X(I), D(I), ERR, RESULT
   40    CONTINUE
         IF ( (NBADZ.NE.0).OR.(NBAD.NE.0) )  THEN
            IFAIL = IFAIL + 1
            IF ((NBADZ.NE.0).AND.(KPRINT.GE.2))
     *         WRITE (LUN, 2007)  NBAD
            IF ((NBAD.NE.0).AND.(KPRINT.GE.2))
     *         WRITE (LUN, 2005)  NBAD, 'IC', TOLD
         ELSE
            IF (KPRINT.GE.2)  WRITE (LUN, 2006)  'IC'
         ENDIF
      ENDIF
C
C  Test PCHSP.
C
      IF (KPRINT.GE.3)  WRITE (LUN, 2000) 'SP'
C     -------------------------------------------------
      CALL PCHSP (IC, VC, N, X, F, D, 1, WK, NWK, IERR)
C     -------------------------------------------------
C        Expect IERR=0 .
      IF ( KPRINT.GE.3 )  WRITE (LUN, 2001) 0
      IF ( .NOT.COMP (IERR, 0, LUN, KPRINT) )  THEN
         IFAIL = IFAIL + 1
      ELSE
         IF ( KPRINT.GE.3 )  WRITE (LUN, 2002)
         NBAD = 0
         DO 50  I = 1, N
            RESULT = '  OK'
C             D-values should agree with stored values.
            ERR = ABS( (D(I)-DS(I))/DS(I) )
            IF ( ERR.GT.TOLD )  THEN
               NBAD = NBAD + 1
               RESULT = '**BAD'
            ENDIF
            IF (KPRINT.GE.3)
     *         WRITE (LUN, 2003)  I, X(I), D(I), ERR, RESULT
   50    CONTINUE
         IF ( NBAD.NE.0 )  THEN
            IFAIL = IFAIL + 1
            IF (KPRINT.GE.2)  WRITE (LUN, 2005)  NBAD, 'SP', TOLD
         ELSE
            IF (KPRINT.GE.2)  WRITE (LUN, 2006)  'SP'
         ENDIF
      ENDIF
C
C  PRINT SUMMARY AND TERMINATE.
C
      IF ((KPRINT.GE.2).AND.(IFAIL.NE.0))  WRITE (LUN, 3001)  IFAIL
C
      IF (IFAIL.EQ.0)  THEN
         IPASS = 1
         IF (KPRINT.GE.2) WRITE(LUN,99998)
      ELSE
         IPASS = 0
         IF (KPRINT.GE.1) WRITE(LUN,99999)
      ENDIF
C
      RETURN
C
C  FORMATS.
C
 1000 FORMAT ('1'//10X,'TEST PCHIP INTERPOLATORS')
 1001 FORMAT (//10X,'PCHQK3 RESULTS'/10X,'--------------')
 1002 FORMAT (// 5X,'DATA:'
     *         /39X,'---------- EXPECTED D-VALUES ----------'
     *         /12X,'X',9X,'F',18X,'DM',13X,'DC',13X,'DS')
 1010 FORMAT (5X,F10.2,1P,E15.5,4X,E15.5,15X,E15.5)
 1011 FORMAT (5X,F10.2,1P,E15.5,4X,3E15.5)
 2000 FORMAT (/5X,'PCH',A2,' TEST:')
 2001 FORMAT (15X,'EXPECT  IERR =',I5)
 2002 FORMAT (/9X,'I',7X,'X',9X,'D',13X,'ERR')
 2003 FORMAT (5X,I5,F10.2,1P,2E15.5,2X,A)
 2004 FORMAT (/'    **',I5,'  PCHIM RESULTS FAILED TO BE EXACTLY ZERO.')
 2005 FORMAT (/'    **',I5,'  PCH',A2,' RESULTS FAILED TOLERANCE TEST.',
     *                     '  TOL =',1P,E10.3)
 2006 FORMAT (/5X,'  ALL  PCH',A2,' RESULTS OK.')
 2007 FORMAT (/'    **',I5,'  PCHIC RESULTS FAILED TO AGREE WITH',
     *                      ' PREVIOUS CALL.')
 3001 FORMAT (/' *** TROUBLE ***',I5,' INTERPOLATION TESTS FAILED.')
99998 FORMAT (/' ------------  PCHIP PASSED  ALL INTERPOLATION TESTS',
     *        ' ------------')
99999 FORMAT (/' ************  PCHIP FAILED SOME INTERPOLATION TESTS',
     *        ' ************')
C------------- LAST LINE OF PCHQK3 FOLLOWS -----------------------------
      END

*DECK DT1
      DOUBLE PRECISION FUNCTION DT1 (X)
C***BEGIN PROLOGUE  DT1
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  DF1S
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  DT1
      DOUBLE PRECISION A,B,DF1S,X,X1,Y
C***FIRST EXECUTABLE STATEMENT  DT1
      A = 0.0D+00
      B = 0.1D+01
      X1 = X+0.1D+01
      Y = (B-A)/X1+A
      DT1 = (B-A)*DF1S(Y)/X1/X1
      RETURN
      END

*DECK F0S
      REAL FUNCTION F0S (X)
C***BEGIN PROLOGUE  F0S
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F0S
      REAL X
C***FIRST EXECUTABLE STATEMENT  F0S
      F0S = 0.0
      IF(X.NE.0.0) F0S = 1.0/SQRT(X)
      RETURN
      END

*DECK QXDBVS
      SUBROUTINE QXDBVS (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  QXDBVS
C***PURPOSE  Quick check for DBVSUP.
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (QXBVSP-S, QXDBVS-D)
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  DBVSUP, PASS
C***COMMON BLOCKS    DSAVEX
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   901014  Made editorial changes and added correct result to
C           output. (RWC)
C   910708  Minor modifications in use of KPRINT.  (WRB)
C***END PROLOGUE  QXDBVS
      INTEGER ITMP(9), IWORK(100)
      DOUBLE PRECISION WORK(1000),AE,RE,XSAVE,SVE,TERM,TOL
      DOUBLE PRECISION Y(4,15),XPTS(15),A(2,4),ALPHA(2),B(2,4),BETA(2),
     * YANS(2,15),RELER,ABSER
      CHARACTER*4 MSG
      COMMON /DSAVEX/ XSAVE, TERM
      DATA YANS(1,1),YANS(2,1),YANS(1,2),YANS(2,2),
     1     YANS(1,3),YANS(2,3),YANS(1,4),YANS(2,4),
     2     YANS(1,5),YANS(2,5),YANS(1,6),YANS(2,6),
     3     YANS(1,7),YANS(2,7),YANS(1,8),YANS(2,8),
     4     YANS(1,9),YANS(2,9),YANS(1,10),YANS(2,10),
     5     YANS(1,11),YANS(2,11),YANS(1,12),YANS(2,12),
     6     YANS(1,13),YANS(2,13),YANS(1,14),YANS(2,14),
     7     YANS(1,15),YANS(2,15)/
     8      5.000000000D+00,-6.888880126D-01, 8.609248635D+00,
     9     -1.083092311D+00, 1.674923836D+01,-2.072210073D+00,
     1      3.351098494D+01,-4.479263780D+00, 6.601103894D+01,
     2     -8.909222513D+00, 8.579580988D+01,-1.098742758D+01,
     3      1.106536877D+02,-1.402469444D+01, 1.421228220D+02,
     4     -1.742236546D+01, 1.803383474D+02,-2.086465851D+01,
     5      2.017054332D+02,-1.990879843D+01, 2.051622475D+02,
     6     -1.324886978D+01, 2.059197452D+02, 1.051529813D+01,
     7      1.972191446D+02, 9.320592785D+01, 1.556894846D+02,
     8      3.801682434D+02, 1.818989404D-12, 1.379853993D+03/
      DATA XPTS(1),XPTS(2),XPTS(3),XPTS(4),XPTS(5),
     1     XPTS(6),XPTS(7),XPTS(8),XPTS(9),XPTS(10),
     2     XPTS(11),XPTS(12),XPTS(13),XPTS(14),XPTS(15)/
     3     60.0D+00,55.0D+00,50.0D+00,45.0D+00,40.0D+00,38.0D+00,
     4     36.0D+00,34.0D+00,32.0D+00,31.0D+00,30.8D+00,30.6D+00,
     5     30.4D+00,30.2D+00,30.0D+00/
C***FIRST EXECUTABLE STATEMENT  QXDBVS
      IF (KPRINT.GE.2) THEN
         WRITE (LUN,800)
         WRITE (LUN,810)
      ENDIF
C
C-----INITIALIZE VARIABLES FOR TEST PROBLEM.
C
      DO 10 I = 1, 9
         ITMP(I) = 0
   10 CONTINUE
C
      TOL = 1.0D-03
      XSAVE = 0.0D+00
      NROWY = 4
      NCOMP = 2
      NXPTS = 15
      A(1,1) = 1.0D+00
      A(1,2) = 0.0D+00
      NROWA = 2
      ALPHA(1) = 5.0D+00
      NIC = 1
      B(1,1) = 1.0D+00
      B(1,2) = 0.0D+00
      NROWB = 2
      BETA(1) = 0.0D+00
      NFC = 1
      IGOFX = 1
      RE = 1.0D-05
      AE = 1.0D-05
      NDW = 1000
      NDIW = 100
      NEQIVP = 0
      IPASS = 1
C
      DO 20 I = 1, 15
         IWORK(I) = 0
   20 CONTINUE
C
      CALL DBVSUP(Y,NROWY,NCOMP,XPTS,NXPTS,A,NROWA,ALPHA,NIC,B,NROWB,
     1     BETA,NFC,IGOFX,RE,AE,IFLAG,WORK,NDW,IWORK,NDIW,NEQIVP)
C
C-----IF IFLAG = 0, WE HAVE A SUCCESSFUL SOLUTION; OTHERWISE, SKIP
C     THE ARGUMENT CHECKING AND GO TO THE END.
C
      IF (IFLAG.NE.0) THEN
         IPASS = 0
         IF (KPRINT .GT. 1) WRITE (LUN,820) IFLAG
         GO TO 170
      ENDIF
C
C-----CHECK THE ACCURACY OF THE SOLUTION.
C
      NUMORT = IWORK(1)
      DO 50 J = 1, NXPTS
         DO 40 L = 1, 2
            ABSER = ABS(YANS(L,J)-Y(L,J))
            RELER = ABSER/ABS(YANS(L,J))
            IF (RELER.GT.TOL .AND. ABSER.GT.TOL) IPASS = 0
   40    CONTINUE
   50 CONTINUE
C
C-----CHECK FOR SUPPRESSION OF PRINTING.
C
      IF (KPRINT.EQ.0 .OR. (KPRINT.EQ.1 .AND. IPASS.EQ.1)) GO TO 190
C
      IF (KPRINT.NE.1 .OR. IPASS.NE.0) THEN
         IF (KPRINT.GE.3 .OR. IPASS.EQ.0) THEN
            WRITE (LUN,830)
            WRITE (LUN,840) NUMORT
            WRITE (LUN,850) (WORK(J),J = 1, NUMORT)
            WRITE (LUN,860)
            DO 60 J = 1, NXPTS
               MSG = 'PASS'
               ABSER = ABS(YANS(1,J)-Y(1,J))
               RELER = ABSER/ABS(YANS(1,J))
               IF (RELER.GT.TOL .AND. ABSER.GT.TOL) MSG = 'FAIL'
               ABSER = ABS(YANS(2,J)-Y(2,J))
               RELER = ABSER/ABS(YANS(2,J))
               IF (RELER.GT.TOL .AND. ABSER.GT.TOL) MSG = 'FAIL'
               WRITE (LUN,870) XPTS(J),Y(1,J),Y(2,J),YANS(1,J),
     *            YANS(2,J),MSG
   60       CONTINUE
         ENDIF
      ENDIF
C
C-----SEND MESSAGE INDICATING PASSAGE OR FAILURE OF TESTS.
C
      CALL PASS (LUN, 1, IPASS)
C
C-----ERROR MESSAGE TESTS.
C
      IF (KPRINT.EQ.1) GO TO 190
      KONT = 1
      WRITE (LUN,880)
C
C-----NROWY LESS THAN NCOMP
C
      KOUNT = 1
      NROWY = 1
  150 DO 160 I = 1, 15
         IWORK(I) = 0
  160 CONTINUE
      CALL DBVSUP(Y,NROWY,NCOMP,XPTS,NXPTS,A,NROWA,ALPHA,NIC,B,NROWB,
     1     BETA,NFC,IGOFX,RE,AE,IFLAG,WORK,NDW,IWORK,NDIW,NEQIVP)
      GO TO (80,90,100,110,120,130,140), KOUNT
C
   80 WRITE (LUN,900) IFLAG
      IF (IFLAG .EQ. -2) ITMP(KONT) = 1
      KONT = KONT + 1
C
C-----IGOFX NOT EQUAL TO 0 OR 1
C
      KOUNT = 2
      NROWY = 2
      IGOFX = 3
      GO TO 150
C
   90 WRITE (LUN,900) IFLAG
      IF (IFLAG .EQ. -2) ITMP(KONT) = 1
      KONT = KONT + 1
C
C-----RE OR AE NEGATIVE
C
      KOUNT = 3
      IGOFX = 1
      RE = -1.0D+00
      AE = -2.0D+00
      GO TO 150
C
  100 WRITE (LUN,900) IFLAG
      IF (IFLAG .EQ. -2) ITMP(KONT) = 1
      KONT = KONT + 1
C
C-----NROWA LESS THAN NIC
C
      KOUNT = 4
      RE = 1.0D-05
      AE = 1.0D-05
      NROWA = 0
C
  110 WRITE (LUN,900) IFLAG
      IF (IFLAG .EQ. -2) ITMP(KONT) = 1
      KONT = KONT + 1
C-----NROWB LESS THAN NFC
      KOUNT = 5
      NROWA = 2
      NROWB = 0
C
  120 WRITE (LUN,900) IFLAG
      IF (IFLAG .EQ. -2) ITMP(KONT) = 1
      KONT = KONT + 1
C-----STORAGE ALLOCATION IS INSUFFICIENT
      KOUNT = 6
      NROWB = 2
      NDIW = 17
      GO TO 150
C
  130 WRITE (LUN,910) IFLAG
      IF (IFLAG .EQ. -1) ITMP(KONT) = 1
      KONT = KONT + 1
C-----INCORRECT ORDERING OF XPTS
      KOUNT = 7
      NDIW = 100
      SVE = XPTS(1)
      XPTS(1) = XPTS(4)
      XPTS(4) = SVE
      GO TO 150
C
  140 WRITE (LUN,900) IFLAG
      IF (IFLAG .EQ. -2) ITMP(KONT) = 1
C
C-----SEE IF IFLAG TESTS PASSED
C
  170 IPSS = 1
      DO 180 I = 1, KONT
         IPSS = IPSS*ITMP(I)
  180 CONTINUE
C
      CALL PASS (LUN, 2, IPSS)
C
C-----SEE IF ALL TESTS PASSED.
C
      IPASS = IPASS*IPSS
C
  190 IF (IPASS .EQ. 1 .AND. KPRINT .GT. 1) WRITE (LUN,980)
      IF (IPASS .EQ. 0 .AND. KPRINT .NE. 0) WRITE (LUN,990)
      RETURN
C
  800 FORMAT ('1')
  810 FORMAT (/' DBVSUP QUICK CHECK')
  820 FORMAT (10X,'IFLAG =',I2)
  830 FORMAT (/' ACCURACY TEST')
  840 FORMAT (/' NUMBER OF ORTHONORMALIZATIONS =',I3)
  850 FORMAT (/' ORTHONORMALIZATION POINTS ARE'/(1X,4F10.2))
  860 FORMAT (//20X,'CALCULATION',30X,'TRUE SOLUTION'/
     *   2X,'X',14X,'Y',17X,'Y-PRIME',15X,'Y',17X,'Y-PRIME'/)
  870 FORMAT (F5.1,4E20.7,5X,A)
  880 FORMAT (/' (7) TESTS OF IFLAG VALUES')
  900 FORMAT (/' IFLAG SHOULD BE -2, IFLAG =',I3)
  910 FORMAT (/' IFLAG SHOULD BE -1, IFLAG =',I3)
  980 FORMAT (/' ***************DBVSUP PASSED ALL TESTS***************')
  990 FORMAT (/' ***************DBVSUP FAILED SOME TESTS**************')
      END

*DECK QXCYL
      SUBROUTINE QXCYL (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  QXCYL
C***PURPOSE
C***LIBRARY   SLATEC
C***KEYWORDS  QUICK CHECK
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C     *                                                               *
C     *                        F I S H P A K                          *
C     *                                                               *
C     *                                                               *
C     *     A PACKAGE OF FORTRAN SUBPROGRAMS FOR THE SOLUTION OF      *
C     *                                                               *
C     *      SEPARABLE ELLIPTIC PARTIAL DIFFERENTIAL EQUATIONS        *
C     *                                                               *
C     *                  (VERSION  3 , JUNE 1979)                     *
C     *                                                               *
C     *                             BY                                *
C     *                                                               *
C     *        JOHN ADAMS, PAUL SWARZTRAUBER AND ROLAND SWEET         *
C     *                                                               *
C     *                             OF                                *
C     *                                                               *
C     *         THE NATIONAL CENTER FOR ATMOSPHERIC RESEARCH          *
C     *                                                               *
C     *                BOULDER, COLORADO  (80307)  U.S.A.             *
C     *                                                               *
C     *                   WHICH IS SPONSORED BY                       *
C     *                                                               *
C     *              THE NATIONAL SCIENCE FOUNDATION                  *
C     *                                                               *
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C
C
C          PROGRAM TO ILLUSTRATE THE USE OF SUBROUTINE HWSCYL TO SOLVE
C     THE EQUATION
C
C     (1/R)(D/DR)(R*(DU/DR)) + (D/DZ)(DU/DZ)
C
C     = (2*R*Z)**2*(4*Z**2 + 3*R**2)
C
C     ON THE RECTANGLE 0 .LT. R .LT. 1, 0 .LT. Z .LT. 1 WITH THE
C     BOUNDARY CONDITIONS
C
C     U(0,Z) UNSPECIFIED
C                                            0 .LE. Z .LE. 1
C     (DU/DR)(1,Z) = 4*Z**4
C
C     AND
C
C     (DU/DZ)(R,0) = 0
C                                            0 .LE. R .LE. 1
C     (DU/DZ)(R,1) = 4*R**4 .
C
C          THE R-INTERVAL WILL BE DIVIDED INTO 50 PANELS AND THE
C     Z-INTERVAL WILL BE DIVIDED INTO 100 PANELS.
C
C***ROUTINES CALLED  HWSCYL
C***REVISION HISTORY  (YYMMDD)
C   800103  DATE WRITTEN
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890911  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   901010  Added PASS/FAIL message and cleaned up FORMATs.  (RWC)
C   930415  Test modified to use a 64 by 128 grid.  (WRB)
C***END PROLOGUE  QXCYL
      DIMENSION F(65,129), BDA(129), BDB(129), BDC(65), BDD(65),
     1   W(1400), R(65), Z(129)
C***FIRST EXECUTABLE STATEMENT  QXCYL
      IF (KPRINT .GE. 2) WRITE (LUN, 1000)
C
C     FROM DIMENSION STATEMENT WE GET VALUE OF IDIMF.
C
      IDIMF = 65
      ERMAX = 1.0E-3
      A = 0.0
      B = 1.0
      M = 64
      MBDCND = 6
      C = 0.0
      D = 1.0
      N = 128
      NBDCND = 3
      ELMBDA = 0.0
C
C     AUXILIARY QUANTITIES.
C
      MP1 = M+1
      NP1 = N+1
C
C     GENERATE AND STORE GRID POINTS FOR THE PURPOSE OF COMPUTING
C     BOUNDARY DATA AND THE RIGHT SIDE OF THE POISSON EQUATION.
C
      DO 101 I=1,MP1
         R(I) = (I-1)/64.0E0
  101 CONTINUE
      DO 102 J=1,NP1
         Z(J) = (J-1)/128.0E0
  102 CONTINUE
C
C     GENERATE BOUNDARY DATA.
C
      DO 103 J=1,NP1
         BDB(J) = 4.0*Z(J)**4
  103 CONTINUE
      DO 104 I=1,MP1
         BDC(I) = 0.0
         BDD(I) = 4.0*R(I)**4
  104 CONTINUE
C
C     BDA IS A DUMMY VARIABLE.
C
C     GENERATE RIGHT SIDE OF EQUATION.
C
      DO 106 I=1,MP1
         DO 105 J=1,NP1
            F(I,J) = 4.0*R(I)**2*Z(J)**2*(4.0*Z(J)**2+3.0*R(I)**2)
  105    CONTINUE
  106 CONTINUE
      CALL HWSCYL (A,B,M,MBDCND,BDA,BDB,C,D,N,NBDCND,BDC,BDD,ELMBDA,F,
     1             IDIMF,PERTRB,IERROR,W)
C
C     COMPUTE DISCRETIZATION ERROR BY MINIMIZING OVER ALL A THE FUNCTION
C     NORM(F(I,J) - A - U(R(I),Z(J))).  THE EXACT SOLUTION IS
C     U(R,Z) = (R*Z)**4 + ARBITRARY CONSTANT.
C
      X = 0.0
      DO 108 I=1,MP1
         DO 107 J=1,NP1
            X = X+F(I,J)-(R(I)*Z(J))**4
  107    CONTINUE
  108 CONTINUE
      X = X/(NP1*MP1)
      DO 110 I=1,MP1
         DO 109 J=1,NP1
            F(I,J) = F(I,J)-X
  109    CONTINUE
  110 CONTINUE
      ERR = 0.0
      DO 112 I=1,MP1
         DO 111 J=1,NP1
            X = ABS(F(I,J)-(R(I)*Z(J))**4)
            IF (X .GT. ERR) ERR = X
  111    CONTINUE
  112 CONTINUE
C
      IPASS = 1
      IF (ERR .GT. ERMAX) IPASS = 0
      IF (KPRINT.GE.3 .OR. (KPRINT.GE.2.AND.IPASS.EQ.0))
     +   WRITE (LUN,1001) IERROR,PERTRB,ERR,INT(W(1))
C
C     Print PASS/FAIL message.
C
      IF (IPASS.EQ.1 .AND. KPRINT.GE.2) WRITE (LUN, 1002)
      IF (IPASS.EQ.0 .AND. KPRINT.GE.1) WRITE (LUN, 1003)
      RETURN
C
 1000 FORMAT ('1', 20X, 'SUBROUTINE HWSCYL EXAMPLE' //)
 1001 FORMAT (10X, 'THE OUTPUT FROM YOUR COMPUTER IS' //
     +        32X, 'IERROR =', I2 /
     +        32X, 'PERTRB =', E12.5 /
     +        18X, 'DISCRETIZATION ERROR =', 1PE12.5 /
     +        12X, 'REQUIRED LENGTH OF W ARRAY = ', I4)
 1002 FORMAT (25X, 'HWSCYL TEST PASSED' /)
 1003 FORMAT (25X, 'HWSCYL TEST FAILED' /)
      END

*DECK ZQCBY
      SUBROUTINE ZQCBY (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  ZQCBY
C***SUBSIDIARY
C***PURPOSE  Quick check for SLATEC subroutine
C            ZBESY
C***LIBRARY   SLATEC
C***CATEGORY  C10A4
C***TYPE      COMPLEX (CQCBY-C, ZQCBY-Z)
C***KEYWORDS  QUICK CHECK, ZBESY
C***AUTHOR  Amos, Don, (SNL)
C           Goudy, Sue, (SNL)
C           Walton, Lee, (SNL)
C***DESCRIPTION
C
C *Usage:
C
C        INTEGER  LUN, KPRINT, IPASS
C
C        CALL ZQCBY (LUN, KPRINT, IPASS)
C
C *Arguments:
C
C     LUN    :IN  is the unit number to which output is to be written.
C
C     KPRINT :IN  controls the amount of output, as specified in the
C                 SLATEC Guidelines.
C
C     IPASS  :OUT indicates whether the test passed or failed.
C                 A value of one is good, indicating no failures.
C
C *Description:
C
C                 *** A DOUBLE PRECISION ROUTINE ***
C
C   ZQCBY is a quick check routine for the complex Y Bessel function
C    generated by subroutine ZBESY.
C
C   ZQCBY generates sequences of Y Bessel functions from ZBESY
C    and checks them against the evaluation from the formula
C
C    Y(FNU,Z*ROT) = C(FNU+1)*I(FNU,Z)-(2/PI)*CONJG(C(FNU))*K(FNU,Z)
C
C    where ROT = EXP(PI*I/2) , C(FNU)=EXP(PI*FNU*I/2) , I**2=-1
C
C    and -PI.LT.ARG(Z).LE.PI/2, in the (Z,FNU) space.
C
C***REFERENCES  Abramowitz, M. and Stegun, I. A., Handbook
C                 of Mathematical Functions, Dover Publications,
C                 New York, 1964.
C               Amos, D. E., A Subroutine Package for Bessel
C                 Functions of a Complex Argument and Nonnegative
C                 Order, SAND85-1018, May, 1985.
C***ROUTINES CALLED  ZBESI, ZBESK, ZBESY, ZABS, ZEXP, I1MACH, D1MACH
C***REVISION HISTORY  (YYMMDD)
C   830501  DATE WRITTEN
C   890831  Revised to meet new SLATEC standards
C   930122  Added ZEXP to EXTERNAL Statement.  (RWC)
C***END PROLOGUE  ZQCBY
C
C*Internal Notes:
C   Machine constants are defined by functions I1MACH and D1MACH.
C
C   The parameter MQC can have values 1 (the default) for a faster,
C   less definitive test or 2 for a slower, more definitive test.
C
C**End
C
C  Set test complexity parameter.
C
      INTEGER  MQC
      PARAMETER (MQC=1)
C
C  Declare arguments.
C
      INTEGER  LUN, KPRINT, IPASS
C
C  Declare external functions.
C
      INTEGER  I1MACH
      DOUBLE PRECISION  D1MACH, ZABS
      EXTERNAL  I1MACH, D1MACH, ZABS, ZEXP
C
C  Declare local variables.
C
      DOUBLE PRECISION  CIPR,CIPI, COE1R,COE1I, COE2R,COE2I,
     *   CSGNR,CSGNI, CSPNR,CSPNI, CWR,CWI, CWRKR,CWRKI, VR,VI, WR,WI,
     *   YR,YI, ZR,ZI, ZNR,ZNI
      DOUBLE PRECISION  AA, AB, AER, AI, ALIM, AR, ARG, ATOL, AV, CC,
     *   CT, DIG, ELIM, EPS, ER, ERTOL, FFNU, FILM, FNU, FNUL, HPI, PI,
     *   PTR, R, RHPI, RL, RM, R1M4, R1M5, R2, SLAK, ST, STI, STR, T,
     *   TOL, TS, XNU
      INTEGER  I, ICASE, IERR, IFNU, IL, IR, IRB, IT, ITL, I4, K, KDO,
     *   KEPS, KK, KODE, K1, K2, LFLG, MFLG, N, NL, NU, NUL, NZ, NZ1,
     *   NZ2
      DIMENSION  AER(20), CIPR(4), CIPI(4), CWRKR(20), CWRKI(20),
     *   KDO(20), KEPS(20), T(20), VR(20), VI(20), WR(20), WI(20),
     *   XNU(20), YR(20), YI(20)
      DATA CIPR(1), CIPI(1), CIPR(2), CIPI(2), CIPR(3), CIPI(3),
     *   CIPR(4), CIPI(4) / 1.0D0,0.0D0, 0.0D0,1.0D0, -1.0D0,0.0D0,
     *   0.0D0,-1.0D0 /
C
C***FIRST EXECUTABLE STATEMENT  ZQCBY
      IF (KPRINT.GE.2) THEN
        WRITE (LUN,99999)
99999   FORMAT (' QUICK CHECK ROUTINE FOR THE Y BESSEL FUNCTION FROM ',
     *    'ZBESY'/)
      ENDIF
C-----------------------------------------------------------------------
C     Set parameters related to machine constants.
C     TOL is the approximate unit roundoff limited to 1.0D-18.
C     ELIM is the approximate exponential over- and underflow limit.
C     exp(-ELIM).lt.exp(-ALIM)=exp(-ELIM)/TOL    and
C     exp(ELIM).gt.exp(ALIM)=exp(ELIM)*TOL       are intervals near
C     underflow and overflow limits where scaled arithmetic is done.
C     RL is the lower boundary of the asymptotic expansion for large Z.
C     DIG = number of base 10 digits in TOL = 10**(-DIG).
C     FNUL is the lower boundary of the asymptotic series for large FNU.
C-----------------------------------------------------------------------
      R1M4 = D1MACH(4)
      TOL = MAX(R1M4,1.0D-18)
      ATOL = 100.0D0*TOL
      AA = -LOG10(R1M4)
      K1 = I1MACH(12)
      K2 = I1MACH(13)
      R1M5 = D1MACH(5)
      K = MIN(ABS(K1),ABS(K2))
      ELIM = 2.303D0*(K*R1M5-3.0D0)
      AB = AA*2.303D0
      ALIM = ELIM + MAX(-AB,-41.45D0)
      DIG = MIN(AA,18.0D0)
      FNUL = 10.0D0 + 6.0D0*(DIG-3.0D0)
      RL = 1.2D0*DIG + 3.0D0
      SLAK = 3.0D0+4.0D0*(-LOG10(TOL)-7.0D0)/11.0D0
      SLAK = MAX(SLAK,3.0D0)
      ERTOL = TOL*10.0D0**SLAK
      RM = 0.5D0*(ALIM + ELIM)
      RM = MIN(RM,200.0D0)
      RM = MAX(RM,RL+10.0D0)
      R2 = MIN(RM,FNUL)
      IF (KPRINT.GE.2) THEN
        WRITE (LUN,99998)
99998   FORMAT (' PARAMETERS'/
     *     5X,'TOL ',8X,'ELIM',8X,'ALIM',8X,'RL  ',8X,'FNUL',8X,'DIG')
        WRITE (LUN,99997) TOL, ELIM, ALIM, RL, FNUL, DIG
99997   FORMAT (1X,6D12.4/)
      ENDIF
C-----------------------------------------------------------------------
C     Set other constants needed in the tests.
C-----------------------------------------------------------------------
      HPI = 2.0D0*ATAN(1.0D0)
      RHPI = 1.0D0/HPI
      PI = HPI + HPI
C-----------------------------------------------------------------------
C     Generate angles for construction of complex Z to be used in tests.
C-----------------------------------------------------------------------
C     KDO(K), K = 1,IL  determines which of the IL angles in -PI to PI
C     are used to compute values of Z.
C       KDO(K) = 0  means that the index K will be used for one or two
C                   values of Z, depending on the choice of KEPS(K)
C              = 1  means that the index K and the corresponding angle
C                   will be skipped
C     KEPS(K), K = 1,IL determines which of the angles get incremented
C     up and down to put values of Z in regions where different
C     formulae are used.
C       KEPS(K)  = 0  means that the angle will be used without change
C                = 1  means that the angle will be incremented up and
C                   down by EPS
C     The angles to be used are stored in the T(I) array, I = 1,ITL.
C-----------------------------------------------------------------------
      IF (MQC.NE.2) THEN
        NL = 2
        IL = 5
        DO 5 I = 1,IL
          KEPS(I) = 0
          KDO(I) = 0
    5   CONTINUE
        KDO(5) = 1
        NUL = 5
        XNU(1) = 0.0D0
        XNU(2) = 1.0D0
        XNU(3) = 2.0D0
        XNU(4) = 0.5D0*FNUL
        XNU(5) = FNUL + 1.2D0
      ELSE
        NL = 4
        IL = 13
        DO 6 I = 1,IL
          KDO(I) = 0
          KEPS(I) = 0
    6   CONTINUE
        KDO(2) = 1
        KDO(6) = 1
        KDO(8) = 1
        KDO(11) = 1
        KDO(12) = 1
        KDO(13) = 1
        KEPS(3) = 1
        KEPS(4) = 1
        KEPS(5) = 1
        KEPS(9) = 1
        NUL = 6
        XNU(1) = 0.0D0
        XNU(2) = 0.6D0
        XNU(3) = 1.3D0
        XNU(4) = 2.0D0
        XNU(5) = 0.5D0*FNUL
        XNU(6) = FNUL + 1.2D0
      ENDIF
      I = 2
      EPS = 0.01D0
      FILM = IL - 1
      T(1) = -PI + EPS
      DO 30 K = 2,IL
        IF (KDO(K).EQ.0) THEN
          T(I) = PI*(-IL+2*K-1)/FILM
          IF (KEPS(K).NE.0) THEN
            TS = T(I)
            T(I) = TS - EPS
            I = I + 1
            T(I) = TS + EPS
          ELSE
            I = I + 1
          ENDIF
        ENDIF
   30 CONTINUE
      ITL = I - 1
C-----------------------------------------------------------------------
C     Test values of Z in -PI/2.lt.arg(Z).le.PI
C-----------------------------------------------------------------------
      IF (KPRINT.GE.2) THEN
        WRITE (LUN,99996)
99996   FORMAT (' CHECKS IN THE (Z,FNU) SPACE')
      ENDIF
      LFLG = 0
      DO 190 KODE = 1,2
        DO 180 N = 1,NL
          DO 170 NU = 1,NUL
C-----------------------------------------------------------------------
C     Construct values which will be used to set
C           COE1 = exp(i*(FNU+1)*PI/2) and
C           COE2 = (2/pi)*exp(-i*FNU*PI/2).
C-----------------------------------------------------------------------
            FNU = XNU(NU)
            IFNU = INT(FNU)
            FFNU = FNU - IFNU
            ARG = HPI*FFNU
            CSGNR = COS(ARG)
            CSGNI = SIN(ARG)
            I4 = MOD(IFNU,4) + 1
            STR = CSGNR*CIPR(I4) - CSGNI*CIPI(I4)
            CSGNI = CSGNR*CIPI(I4) + CSGNI*CIPR(I4)
            CSGNR = STR
            CSPNR = CSGNR*RHPI
            CSPNI = -CSGNI*RHPI
C---------- CSGN=CSGN*CI in CQCBY
            STR = -CSGNI
            CSGNI = CSGNR
            CSGNR = STR
            DO 160 ICASE = 1,3
              IRB = MIN(2,ICASE)
              DO 150 IR = IRB,4
C-------------- switch (icase)
                GO TO (50, 60, 70), ICASE
   50           CONTINUE
                  R = (EPS*(4-IR)+2.0D0*(IR-1))/3.0D0
                  GO TO 80
   60           CONTINUE
                  R = (2.0D0*(4-IR)+R2*(IR-1))/3.0D0
                  GO TO 80
   70           CONTINUE
                  IF (R2.GE.RM) GO TO 160
                  R = (R2*(4-IR)+RM*(IR-1))/3.0D0
   80           CONTINUE
C-------------- end switch
                DO 140 IT = 1,ITL
                  CT = COS(T(IT))
                  ST = SIN(T(IT))
                  IF (ABS(CT).LT.ATOL) CT = 0.0D0
                  IF (ABS(ST).LT.ATOL) ST = 0.0D0
                  ZR = R*CT
                  ZI = R*ST
                  CALL ZBESI(ZR, ZI, FNU, KODE, N, WR, WI, NZ2, IERR)
C---------------- Underflow in ZBESI - skip test for this case.
                  IF (NZ2.NE.0) GO TO 140
                  CALL ZBESK(ZR, ZI, FNU, KODE, N, YR, YI, NZ1, IERR)
C---------------- Underflow in ZBESK - skip test for this case.
                  IF (NZ1.NE.0) GO TO 140
                  ZNR = -ZI
                  ZNI = ZR
                  CALL ZBESY(ZNR, ZNI, FNU, KODE, N, VR, VI, NZ, CWRKR,
     *               CWRKI, IERR)
C---------------- Underflow in ZBESY - skip test for this case.
                  IF (NZ.NE.0) GO TO 140
                  COE1R = CSGNR
                  COE1I = CSGNI
                  COE2R = CSPNR
                  COE2I = CSPNI
                  IF (KODE.EQ.2) THEN
C------------------ Adjust scale for I and K functions.
                    CC = -ZR - ABS(ZR)
                    IF (CC.GT.(-ALIM)) THEN
                      ZNR = CC
                      ZNI = -ZI
                      CALL ZEXP(ZNR, ZNI, STR, STI)
                      PTR = STR*COE2R - STI*COE2I
                      COE2I = STR*COE2I + STI*COE2R
                      COE2R = PTR
                    ELSE
C-------------------- Scaling problem - skip test for this case
                      COE2R = 0.0D0
                      COE2I = 0.0D0
                      GO TO 140
                    ENDIF
                  ENDIF
                  DO 110 KK = 1,N
                    STR = YR(KK)*COE2R - YI(KK)*COE2I
                    YI(KK) = YR(KK)*COE2I + YI(KK)*COE2R
                    YR(KK) = STR
                    STR = WR(KK)*COE1R - WI(KK)*COE1I
                    WI(KK) = WR(KK)*COE1I + WI(KK)*COE1R
                    WR(KK) = STR
                    STR = -COE1I
                    COE1I = COE1R
                    COE1R = STR
                    STR = COE2I
                    COE2I = -COE2R
                    COE2R = STR
  110             CONTINUE
C-----------------------------------------------------------------------
C     Compare Y(ZN,FNU) with COE1*I(Z,FNU)-COE2*K(Z,FNU).
C-----------------------------------------------------------------------
                  MFLG = 0
                  DO 120 I = 1,N
                    AB = FNU + I - 1
                    AA = MAX(0.5D0,AB)
                    CWR = WR(I) - YR(I)
                    CWI = WI(I) - YI(I)
                    AV = ZABS(VR(I),VI(I))
                    AR = CWR - VR(I)
                    AI = CWI - VI(I)
                    ER = ZABS(AR,AI)
                    IF (AV.NE.0.0D0) THEN
                      IF (ZNI.EQ.0.0D0) THEN
                        IF (ZNR.GT.0.0D0) THEN
                          IF (DABS(ZNR).LT.AA) ER = ER/AV
                        ELSE
                          IF (DABS(FFNU-0.5D0).LT.0.125D0) THEN
                            IF (DABS(ZNR).LT.AA) ER = ER/AV
                          ELSE
                            ER = ER/AV
                          ENDIF
                        ENDIF
                      ELSE
                        ER = ER/AV
                      ENDIF
                    ENDIF
                    AER(I) = ER
                    IF (ER.GT.ERTOL) MFLG = 1
  120             CONTINUE
                  IF (MFLG.NE.0) THEN
                    IF (LFLG.EQ.0) THEN
                      IF (KPRINT.GE.2) THEN
                        WRITE (LUN,99995) ERTOL
99995                   FORMAT (/' CASES WHICH VIOLATE THE RELATIVE ',
     *                      'ERROR TEST WITH ERTOL = ',D12.4/)
                        WRITE (LUN,99994)
99994                   FORMAT (' INPUT TO ZBESY   ZN, FNU, KODE, N')
                      ENDIF
                      IF (KPRINT.GE.3) THEN
                        WRITE (LUN,99993)
99993                   FORMAT (' COMPARE Y(ZN,FNU) WITH COE1*I(Z,FNU)',
     *                     '-COE2*K(Z,FNU)')
                        WRITE (LUN,99992)
99992                   FORMAT (' Z = ZN*EXP(-i*PI/2)'/
     *                     ' COE1 = EXP(i*(FNU+1)*PI/2)  ',
     *                     ' COE2 = (2/PI)*EXP(-i*FNU*PI/2)')
                        WRITE (LUN,99991)
99991                   FORMAT (' RESULTS FROM ZBESY   V(KK)'/
     *                     9X,'FROM ZBESI   W(KK)'/
     *                     9X,'FROM ZBESK   Y(KK)')
                        WRITE (LUN,99990)
99990                   FORMAT (' TEST CASE INDICES   IR, IT, ICASE'/)
                      ENDIF
                    ENDIF
                    LFLG = LFLG + 1
                    IF (KPRINT.GE.2) THEN
                      WRITE (LUN,99989) ZNR, ZNI, FNU, KODE, N
99989                 FORMAT ('   INPUT:   ZN=',2D12.4,3X,'FNU=',D12.4,
     *                   3X,'KODE=',I3,3X,'N=',I3)
                    ENDIF
                    IF (KPRINT.GE.3) THEN
                      WRITE (LUN,99988) (AER(K),K=1,N)
99988                 FORMAT ('   ERROR:   AER(K)=',4D12.4)
                      WRITE (LUN,99987) ZR, ZI, COE1R, COE1I, COE2R,
     *                   COE2R
99987                 FORMAT (12X,'Z=',2D12.4/12X,'COE1=',2D12.4,3X,
     *                   'COE2=',2D12.4)
                      KK = MAX(NZ1,NZ2) + 1
                      KK = MIN(N,KK)
                      WRITE (LUN,99986) VR(KK), VI(KK), WR(KK), WI(KK),
     *                   YR(KK), YI(KK)
99986                 FORMAT (' RESULTS:   V(KK)=',2D12.4/
     *                   12X,'W(KK)=',2D12.4/12X,'Y(KK)=',2D12.4)
                      WRITE (LUN,99985) IR, IT, ICASE
99985                 FORMAT ('    CASE:   IR=',I3,3X,'IT=',I3,3X,
     *                   'ICASE=',I3/)
                    ENDIF
                  ENDIF
  140           CONTINUE
  150         CONTINUE
  160       CONTINUE
  170     CONTINUE
  180   CONTINUE
  190 CONTINUE
      IF (KPRINT.GE.2) THEN
        IF (LFLG.EQ.0) THEN
          WRITE (LUN,99984)
99984     FORMAT (' QUICK CHECKS OK')
        ELSE
          WRITE (LUN,99983) LFLG
99983     FORMAT (' ***',I5,' FAILURE(S) FOR ZBESY IN THE (Z,FNU) ',
     *       'PLANE')
        ENDIF
      ENDIF
      IPASS = 0
      IF (LFLG.EQ.0) THEN
        IPASS = 1
      ENDIF
      IF (IPASS.EQ.1.AND.KPRINT.GE.2) THEN
        WRITE (LUN,99982)
99982   FORMAT (/' ****** ZBESY  PASSED ALL TESTS  ******'/)
      ENDIF
      IF (IPASS.EQ.0.AND.KPRINT.GE.1) THEN
        WRITE (LUN,99981)
99981   FORMAT (/' ****** ZBESY  FAILED SOME TESTS ******'/)
      ENDIF
      RETURN
      END

*DECK QXPLR
      SUBROUTINE QXPLR (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  QXPLR
C***PURPOSE
C***LIBRARY   SLATEC
C***KEYWORDS  QUICK CHECK
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C     *                                                               *
C     *                        F I S H P A K                          *
C     *                                                               *
C     *                                                               *
C     *     A PACKAGE OF FORTRAN SUBPROGRAMS FOR THE SOLUTION OF      *
C     *                                                               *
C     *      SEPARABLE ELLIPTIC PARTIAL DIFFERENTIAL EQUATIONS        *
C     *                                                               *
C     *                  (VERSION  3 , JUNE 1979)                     *
C     *                                                               *
C     *                             BY                                *
C     *                                                               *
C     *        JOHN ADAMS, PAUL SWARZTRAUBER AND ROLAND SWEET         *
C     *                                                               *
C     *                             OF                                *
C     *                                                               *
C     *         THE NATIONAL CENTER FOR ATMOSPHERIC RESEARCH          *
C     *                                                               *
C     *                BOULDER, COLORADO  (80307)  U.S.A.             *
C     *                                                               *
C     *                   WHICH IS SPONSORED BY                       *
C     *                                                               *
C     *              THE NATIONAL SCIENCE FOUNDATION                  *
C     *                                                               *
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C
C
C          PROGRAM TO ILLUSTRATE THE USE OF SUBROUTINE HWSPLR TO SOLVE
C     THE EQUATION
C
C     (1/R)(D/DR)(R*(DU/DR)) + (1/R**2)(D/DTHETA)(DU/DTHETA) = 16*R**2
C
C     ON THE QUARTER-DISK 0 .LT. R .LT. 1, 0 .LT. THETA .LT. PI/2 WITH
C     WITH THE BOUNDARY CONDITIONS
C
C     U(1,THETA) = 1 - COS(4*THETA), 0 .LE. THETA .LE. 1
C
C     AND
C
C     (DU/DTHETA)(R,0) = (DU/DTHETA)(R,PI/2) = 0,  0 .LE. R .LE. 1.
C
C     (NOTE THAT THE SOLUTION U IS UNSPECIFIED AT R = 0.)
C          THE R-INTERVAL WILL BE DIVIDED INTO 50 PANELS AND THE
C     THETA-INTERVAL WILL BE DIVIDED INTO 48 PANELS.
C
C***ROUTINES CALLED  HWSPLR, PIMACH
C***REVISION HISTORY  (YYMMDD)
C   800103  DATE WRITTEN
C   890718  Changed computation of PI to use PIMACH.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890911  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   901010  Added PASS/FAIL message and cleaned up FORMATs.  (RWC)
C***END PROLOGUE  QXPLR
      DIMENSION F(100,50), BDC(51), BDD(51), W(1200), R(51), THETA(49)
C***FIRST EXECUTABLE STATEMENT  QXPLR
C
C     FROM DIMENSION STATEMENT WE GET VALUE OF IDIMF.  ALSO NOTE THAT W
C     IS DIMENSIONED 6*(N+1) + 8*(M+1).
C
      IDIMF = 100
      ERMAX=1.E-3
      A = 0.
      B = 1.
      M = 50
      MBDCND = 5
      C = 0.
      PI = PIMACH(DUM)
      D = PI/2.
      N = 48
      NBDCND = 3
      ELMBDA = 0.
C
C     AUXILIARY QUANTITIES.
C
      MP1 = M+1
      NP1 = N+1
C
C     GENERATE AND STORE GRID POINTS FOR THE PURPOSE OF COMPUTING
C     BOUNDARY DATA AND THE RIGHT SIDE OF THE POISSON EQUATION.
C
      DO 101 I=1,MP1
         R(I) = (I-1)/50.0E0
  101 CONTINUE
      DO 102 J=1,NP1
         THETA(J) = (J-1)*PI/96.0E0
  102 CONTINUE
C
C     GENERATE BOUNDARY DATA.
C
      DO 103 I=1,MP1
         BDC(I) = 0.
         BDD(I) = 0.
  103 CONTINUE
C
C     BDA AND BDB ARE DUMMY VARIABLES.
C
      DO 104 J=1,NP1
         F(MP1,J) = 1.-COS(4.*THETA(J))
  104 CONTINUE
C
C     GENERATE RIGHT SIDE OF EQUATION.
C
      DO 106 I=1,M
         DO 105 J=1,NP1
            F(I,J) = 16.*R(I)**2
  105    CONTINUE
  106 CONTINUE
      CALL HWSPLR(A,B,M,MBDCND,BDA,BDB,C,D,N,NBDCND,BDC,BDD,ELMBDA,F,
     1             IDIMF,PERTRB,IERROR,W)
C
C     COMPUTE DISCRETIZATION ERROR.  THE EXACT SOLUTION IS
C                U(R,THETA) = R**4*(1 - COS(4*THETA))
C
      ERR = 0.
      DO 108 I=1,MP1
         DO 107 J=1,NP1
            Z = ABS(F(I,J)-R(I)**4*(1.-COS(4.*THETA(J))))
            IF (Z .GT. ERR) ERR = Z
  107    CONTINUE
  108 CONTINUE
C
      IPASS = 1
      IF (ERR.GT.ERMAX) IPASS = 0
      IF (KPRINT.EQ.0) RETURN
      IF (KPRINT.GE.2 .OR. IPASS.EQ.0) THEN
         WRITE (LUN,1001) IERROR,ERR,INT(W(1))
         IF (IPASS.EQ.1) THEN
            WRITE (LUN, 1002)
         ELSE
            WRITE (LUN, 1003)
         ENDIF
      ENDIF
      RETURN
C
 1001 FORMAT ('1',20X,'SUBROUTINE HWSPLR EXAMPLE'///
     1        10X,'THE OUTPUT FROM THE NCAR CONTROL DATA 7600 WAS'//
     2        32X,'IERROR = 0'/
     3        18X,'DISCRETIZATION ERROR = 6.19134E-04'/
     4        12X,'REQUIRED LENGTH OF W ARRAY = 882'//
     5        10X,'THE OUTPUT FROM YOUR COMPUTER IS'//
     6        32X,'IERROR =',I2/
     7        18X,'DISCRETIZATION ERROR =',1PE12.5/
     8        12X,'REQUIRED LENGTH OF W ARRAY =',I4)
 1002 FORMAT (60X,'PASS'/)
 1003 FORMAT (60X,'FAIL'/)
      END

*DECK FEIN
      REAL FUNCTION FEIN (T)
C***BEGIN PROLOGUE  FEIN
C***PURPOSE  Subsidiary to EG8CK.
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    FEINX
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  FEIN
      COMMON /FEINX/ X, A, FKM
      REAL X, A, FKM, T, ALN
C***FIRST EXECUTABLE STATEMENT  FEIN
      ALN = (FKM-T)*X - A*LOG(T)
      FEIN = EXP(ALN)
      RETURN
      END

*DECK TEST32
      PROGRAM TEST32
C***BEGIN PROLOGUE  TEST32
C***PURPOSE  Driver for testing SLATEC subprograms
C***LIBRARY   SLATEC
C***CATEGORY  E1A
C***TYPE      SINGLE PRECISION (TEST32-S, TEST33-D)
C***KEYWORDS  QUICK CHECK DRIVER
C***AUTHOR  SLATEC Common Mathematical Library Committee
C***DESCRIPTION
C
C *Usage:
C     One input data record is required
C         READ (LIN, '(I1)') KPRINT
C
C *Arguments:
C     KPRINT = 0  Quick checks - No printing.
C                 Driver       - Short pass or fail message printed.
C              1  Quick checks - No message printed for passed tests,
C                                short message printed for failed tests.
C                 Driver       - Short pass or fail message printed.
C              2  Quick checks - Print short message for passed tests,
C                                fuller information for failed tests.
C                 Driver       - Pass or fail message printed.
C              3  Quick checks - Print complete quick check results.
C                 Driver       - Pass or fail message printed.
C
C *Description:
C     Driver for testing SLATEC subprograms
C        PCHIP
C
C***REFERENCES  Kirby W. Fong, Thomas H. Jefferson, Tokihiko Suyehiro
C                 and Lee Walton, Guide to the SLATEC Common Mathema-
C                 tical Library, April 10, 1990.
C***ROUTINES CALLED  I1MACH, PCHQK1, PCHQK2, PCHQK3, PCHQK4, PCHQK5,
C                    XERMAX, XSETF, XSETUN
C***REVISION HISTORY  (YYMMDD)
C   890618  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900314  Added new quick checks PCHQK3, PCHQK4.  (FNF)
C   900315  Corrected category record.  (FNF)
C   900321  Moved IPASS to call sequences for SLATEC standards.  (FNF)
C   900524  Cosmetic changes to code.  (WRB)
C   930318  Added new quick check PCHQK5.  (WRB,FNF)
C***END PROLOGUE  TEST32
      INTEGER IPASS, KPRINT, LIN, LUN, NFAIL
C***FIRST EXECUTABLE STATEMENT  TEST32
      LUN   = I1MACH(2)
      LIN   = I1MACH(1)
      NFAIL = 0
C
C     Read KPRINT parameter
C
      READ (LIN, '(I1)') KPRINT
      CALL XERMAX(1000)
      CALL XSETUN(LUN)
      IF (KPRINT .LE. 1) THEN
         CALL XSETF(0)
      ELSE
         CALL XSETF(1)
      ENDIF
C
C     Test PCHIP evaluators
C
      CALL PCHQK1(LUN,KPRINT,IPASS)
      IF (IPASS .EQ. 0) NFAIL = NFAIL + 1
C
C     Test PCHIP integrators
C
      CALL PCHQK2(LUN,KPRINT,IPASS)
      IF (IPASS .EQ. 0) NFAIL = NFAIL + 1
C
C     Test PCHIP interpolators
C
      CALL PCHQK3(LUN,KPRINT,IPASS)
      IF (IPASS .EQ. 0) NFAIL = NFAIL + 1
C
C     Test PCHIP monotonicity checker
C
      CALL PCHQK4(LUN,KPRINT,IPASS)
      IF (IPASS .EQ. 0) NFAIL = NFAIL + 1
C
C     Test PCH to B-spline conversion.
C
      CALL PCHQK5(LUN,KPRINT,IPASS)
      IF (IPASS .EQ. 0) NFAIL = NFAIL + 1
C
C     Write PASS or FAIL message
C
      IF (NFAIL .EQ. 0) THEN
         WRITE (LUN, 9000)
      ELSE
         WRITE (LUN, 9010) NFAIL
      ENDIF
      STOP
 9000 FORMAT (/' --------------TEST32 PASSED ALL TESTS----------------')
 9010 FORMAT (/' ************* WARNING -- ', I5,
     1        ' TEST(S) FAILED IN PROGRAM TEST32 *************')
      END

*DECK PNTCHK
      SUBROUTINE PNTCHK (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  PNTCHK
C***PURPOSE  Quick check for POLINT, POLCOF and POLYVL
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (PNTCHK-S, DPNTCK-D)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  NUMXER, POLCOF, POLINT, POLYVL, R1MACH, XERCLR,
C                    XGETF, XSETF
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   901205  Changed usage of R1MACH(3) to R1MACH(4).  (RWC)
C   910708  Minor modifications in use of KPRINT.  (WRB)
C   920212  Code completely restructured to test errors for all values
C           of KPRINT.  (WRB)
C***END PROLOGUE  PNTCHK
C     .. Scalar Arguments ..
      INTEGER IPASS, KPRINT, LUN
C     .. Local Scalars ..
      REAL TOL, YF
      INTEGER I, IERR, KONTRL, N, NERR
      LOGICAL FATAL
C     .. Local Arrays ..
      REAL C(6), D(6), DCHK(6), W(12), X(6), XCHK(6), Y(6)
C     .. External Functions ..
      REAL R1MACH
      INTEGER NUMXER
      EXTERNAL R1MACH, NUMXER
C     .. External Subroutines ..
      EXTERNAL POLCOF, POLINT, POLYVL, XERCLR, XGETF, XSETF
C     .. Intrinsic Functions ..
      INTRINSIC ABS, SQRT
C     .. Data statements ..
      DATA X / 1.0E0, 2.0E0, 3.0E0, -1.0E0, -2.0E0, -3.0E0 /
      DATA Y / 0.0E0, 9.0E0, 64.0E0, 0.0E0, 9.0E0, 64.0E0 /
      DATA XCHK / 1.0E0, 0.0E0, -2.0E0, 0.0E0, 1.0E0, 0.0E0 /
      DATA DCHK / 1.0E0, 0.0E0, -4.0E0, 0.0E0, 24.0E0, 0.0E0 /
C***FIRST EXECUTABLE STATEMENT  PNTCHK
      IF (KPRINT .GE. 2) WRITE (LUN,9000)
C
C     Initialize variables for tests.
C
      TOL = SQRT(R1MACH(4))
      IPASS = 1
      N = 6
C
C     Set up polynomial test.
C
      CALL POLINT (N, X, Y, C)
      CALL POLCOF (0.0E0, N, X, C, D, W)
C
C     Check to see if POLCOF test passed.
C
      FATAL = .FALSE.
      DO 110 I = 1,N
        IF (ABS(D(I)-XCHK(I)) .GT. TOL) THEN
          IPASS = 0
          FATAL = .TRUE.
        ENDIF
  110 CONTINUE
      IF (FATAL) THEN
        IF (KPRINT .GE. 2) WRITE (LUN, 9010) 'FAILED', (D(I), I = 1,N)
      ELSE
        IF (KPRINT .GE. 3) WRITE (LUN, 9010) 'PASSED', (D(I), I = 1,N)
      ENDIF
C
C     Test POLYVL.
C
      CALL POLYVL (5, 0.0E0, YF, D, N, X, C, W, IERR)
      IF (ABS(DCHK(1)-YF) .LE. TOL) THEN
        IF (KPRINT .GE. 3) WRITE (LUN, 9020) 'PASSED', YF,(D(I),I=1,5)
      ELSE
        IPASS = 0
        IF (KPRINT .GE. 2) WRITE (LUN, 9020) 'FAILED', YF,(D(I),I=1,5)
      ENDIF
C
      FATAL = .FALSE.
      DO 120 I = 1,5
        IF (ABS(DCHK(I+1)-D(I)) .GT. TOL) THEN
          IPASS = 0
          FATAL = .TRUE.
        ENDIF
  120 CONTINUE
C
C     Trigger 2 error conditions
C
      CALL XGETF (KONTRL)
      IF (KPRINT .LE. 2) THEN
         CALL XSETF (0)
      ELSE
         CALL XSETF (1)
      ENDIF
      FATAL = .FALSE.
      CALL XERCLR
C
      IF (KPRINT .GE. 3) WRITE (LUN,9030)
      CALL POLINT (0, X, Y, C)
      IF (NUMXER(NERR) .NE. 2) THEN
        IPASS = 0
        FATAL = .TRUE.
      ENDIF
      CALL XERCLR
C
      X(1) = -1.0E0
      CALL POLINT (N, X, Y, C)
      IF (NUMXER(NERR) .NE. 2) THEN
        IPASS = 0
        FATAL = .TRUE.
      ENDIF
      CALL XERCLR
C
      CALL XSETF (KONTRL)
      IF (FATAL) THEN
        IF (KPRINT .GE. 2) THEN
          WRITE (LUN, 9040)
        ENDIF
      ELSE
        IF (KPRINT .GE. 3) THEN
          WRITE (LUN, 9050)
        ENDIF
      ENDIF
C
      IF (IPASS.EQ.1 .AND. KPRINT.GE.2) WRITE (LUN,9080)
      IF (IPASS.EQ.0 .AND. KPRINT.GE.1) WRITE (LUN,9090)
      RETURN
C
 9000 FORMAT ('1' / ' Test POLINT, POLCOF and POLYVL')
 9010 FORMAT (/ 'POLCOF ', A, ' test' /
     +        ' Taylor coefficients for the quintic should be' /
     +        6X, '1.000', 5X, '0.000', 4X, '-2.000', 5X, '0.000', 5X,
     +        '1.000', 5X, '0.000' /
     +        ' Taylor coefficients from POLCOF are' / 1X, 6F10.3 /)
 9020 FORMAT (' Derivative test ', A /
     +        ' The derivatives of the polynomial at zero as ',
     +        'computed by POLYVL are' / 1X, 6F10.3 /)
 9030 FORMAT (/' 2 Error messages expected')
 9040 FORMAT (/ ' AT LEAST ONE INCORRECT ARGUMENT TEST FAILED')
 9050 FORMAT (/ ' ALL INCORRECT ARGUMENT TESTS PASSED')
 9080 FORMAT (/' ****************POLINT PASSED ALL TESTS**************')
 9090 FORMAT (/' ***************POLINT FAILED SOME TESTS**************')
      END

*DECK F1F
      REAL FUNCTION F1F (X)
C***BEGIN PROLOGUE  F1F
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F1F
      REAL X,X1,Y
C***FIRST EXECUTABLE STATEMENT  F1F
      X1 = X+1.0
      F1F = 5.0/X1/X1
      Y = 5.0/X1
      IF(Y.GT.3.1415926535897932) F1F = 0.0
      RETURN
      END

*DECK ZQCAI
      SUBROUTINE ZQCAI (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  ZQCAI
C***SUBSIDIARY
C***PURPOSE  Quick check for SLATEC subroutines
C            ZAIRY, ZBIRY
C***LIBRARY   SLATEC
C***CATEGORY  C10D
C***TYPE      COMPLEX (CQCAI-C, ZQCAI-Z)
C***KEYWORDS  QUICK CHECK, ZAIRY, ZBIRY
C***AUTHOR  Amos, Don, (SNL)
C           Goudy, Sue, (SNL)
C           Walton, Lee, (SNL)
C***DESCRIPTION
C
C *Usage:
C
C        INTEGER  LUN, KPRINT, IPASS
C
C        CALL ZQCAI (LUN, KPRINT, IPASS)
C
C *Arguments:
C
C     LUN    :IN  is the unit number to which output is to be written.
C
C     KPRINT :IN  controls the amount of output, as specified in the
C                 SLATEC Guidelines.
C
C     IPASS  :OUT indicates whether the test passed or failed.
C                 A value of one is good, indicating no failures.
C
C *Description:
C
C               *** A DOUBLE PRECISION ROUTINE ***
C
C   ZQCAI is a quick check routine for the complex Airy functions
C    generated by subroutines ZAIRY and ZBIRY.
C
C   ZQCAI generates Airy functions and their derivatives from ZAIRY
C    and ZBIRY and checks them against the Wronskian evaluation
C    in the Z plane.
C
C***REFERENCES  Abramowitz, M. and Stegun, I. A., Handbook
C                 of Mathematical Functions, Dover Publications,
C                 New York, 1964.
C               Amos, D. E., A Subroutine Package for Bessel
C                 Functions of a Complex Argument and Nonnegative
C                 Order, SAND85-1018, May, 1985.
C***ROUTINES CALLED  ZAIRY, ZBIRY, ZABS, ZSQRT, ZEXP, I1MACH, D1MACH
C***REVISION HISTORY  (YYMMDD)
C   830501  DATE WRITTEN
C   890831  Revised to meet new SLATEC standards
C   930122  Added ZEXP and ZSQRT to EXTERNAL statement.  (RWC)
C***END PROLOGUE  ZQCAI
C
C*Internal Notes:
C   Machine constants are defined by functions I1MACH and D1MACH.
C
C   The parameter MQC can have values 1 (the default) for a faster,
C   less definitive test or 2 for a slower, more definitive test.
C
C**End
C
C  Set test complexity parameter.
C
      INTEGER  MQC
      PARAMETER (MQC=1)
C
C  Declare arguments.
C
      INTEGER  LUN, KPRINT, IPASS
C
C  Declare external functions.
C
      INTEGER  I1MACH
      DOUBLE PRECISION  D1MACH, ZABS
      EXTERNAL  I1MACH, D1MACH, ZABS, ZEXP, ZSQRT
C
C  Declare local variables.
C
      DOUBLE PRECISION  CON1R,CON1I, CON2R,CON2I, CON3R,CON3I, CVR,CVI,
     *   CWR,CWI, CYR,CYI, WR,WI, YR,YI, ZR,ZI, ZRR,ZRI
      DOUBLE PRECISION  AA, AB, ACW, ACY, ALIM, ARG, ATOL, AV, AZRR, A1,
     *   A2, CT, C23, DIG, ELIM, EPS, ER, ERTOL, FILM, FNUL, FPI, HPI,
     *   PI, PI3, PTR, R, RL, RM, RPI, RTPI, R1M4, R1M5, SLAK, SPI, ST,
     *   STI, STR, T, TOL, TPI, TPI3, TS
      INTEGER  I, ICASE, ICL, IERR, IL, IR, IRB, IRSET, IT, ITL, K, KDO,
     *   KEPS, KODE, K1, K2, LFLG, NZ1, NZ2, NZ3, NZ4
      DIMENSION  KDO(20), KEPS(20), T(20), WR(20), WI(20), YR(20),
     *   YI(20)
C
C***FIRST EXECUTABLE STATEMENT  ZQCAI
      IF (KPRINT.GE.2) THEN
        WRITE (LUN,99999)
99999   FORMAT (' QUICK CHECK ROUTINE FOR THE AIRY FUNCTIONS FROM ',
     *     'ZAIRY AND ZBIRY'/)
      ENDIF
C-----------------------------------------------------------------------
C     Set parameters related to machine constants.
C     TOL is the approximate unit roundoff limited to 1.0D-18.
C     ELIM is the approximate exponential over- and underflow limit.
C     exp(-ELIM).lt.exp(-ALIM)=exp(-ELIM)/TOL    and
C     exp(ELIM).gt.exp(ALIM)=exp(ELIM)*TOL       are intervals near
C     underflow and overflow limits where scaled arithmetic is done.
C     RL is the lower boundary of the asymptotic expansion for large Z.
C     DIG = number of base 10 digits in TOL = 10**(-DIG).
C     FNUL is the lower boundary of the asymptotic series for large FNU.
C-----------------------------------------------------------------------
      R1M4 = D1MACH(4)
      TOL = MAX(R1M4,1.0D-18)
      ATOL = 100.0D0*TOL
      AA = -LOG10(R1M4)
      K1 = I1MACH(12)
      K2 = I1MACH(13)
      R1M5 = D1MACH(5)
      K = MIN(ABS(K1),ABS(K2))
      ELIM = 2.303D0*(K*R1M5-3.0D0)
      AB = AA*2.303D0
      ALIM = ELIM + MAX(-AB,-41.45D0)
      DIG = MIN(AA,18.0D0)
      SLAK = 3.0D0+4.0D0*(-LOG10(TOL)-7.0D0)/11.0D0
      SLAK = MAX(SLAK,3.0D0)
      ERTOL = TOL*10.0D0**SLAK
      RL = 1.2D0*DIG + 3.0D0
      RM = 0.5D0*(ALIM + ELIM)
      RM = MIN(RM,200.0D0)
      RM = MAX(RM,RL+10.0D0)
      FNUL = 10.0D0 + 6.0D0*(DIG-3.0D0)
      IF (KPRINT.GE.2) THEN
        WRITE (LUN,99998)
99998   FORMAT (' PARAMETERS'/
     *     5X,'TOL ',8X,'ELIM',8X,'ALIM',8X,'RL  ',8X,'FNUL',8X,'DIG')
        WRITE (LUN,99997) TOL, ELIM, ALIM, RL, FNUL, DIG
99997   FORMAT (6D12.4/)
      ENDIF
C-----------------------------------------------------------------------
C     Generate angles for construction of complex Z to be used in tests.
C-----------------------------------------------------------------------
      FPI = ATAN(1.0D0)
      HPI = FPI + FPI
      PI = HPI + HPI
      TPI = PI + PI
      RPI = 1.0D0/PI
      TPI3 = TPI/3.0D0
      SPI = PI/6.0D0
      PI3 = SPI+SPI
      RTPI = 1.0D0/TPI
      A1 = RTPI*COS(SPI)
      A2 = RTPI*SIN(SPI)
      CON1R = COS(TPI3)
      CON1I = SIN(TPI3)
      CON2R = A1
      CON2I = -A2
      CON3R = RPI
      CON3I = 0.0D0
      C23 = 2.0D0/3.0D0
C-----------------------------------------------------------------------
C     KDO(K), K = 1,IL  determines which of the IL angles in -PI to PI
C     are used to compute values of Z.
C       KDO(K) = 0  means that the index K will be used for one or two
C                   values of Z, depending on the choice of KEPS(K)
C              = 1  means that the index K and the corresponding angle
C                   will be skipped
C     KEPS(K), K = 1,IL determines which of the angles get incremented
C     up and down to put values of Z in regions where different
C     formulae are used.
C       KEPS(K)  = 0  means that the angle will be used without change
C                = 1  means that the angle will be incremented up and
C                   down by EPS
C     The angles to be used are stored in the T(I) array, I = 1,ITL.
C-----------------------------------------------------------------------
      IF (MQC.NE.2) THEN
        ICL = 1
        IL = 5
        DO 5 I = 1,IL
          KDO(I) = 0
          KEPS(I) = 0
    5   CONTINUE
      ELSE
        ICL = 2
        IL = 7
        DO 6 I = 1,IL
          KDO(I) = 0
          KEPS(I) = 0
    6   CONTINUE
        KEPS(2) = 1
        KEPS(3) = 1
        KEPS(5) = 1
        KEPS(6) = 1
      ENDIF
      I = 2
      EPS = 0.01D0
      FILM = IL - 1
      T(1) = -PI + EPS
      DO 30 K = 2,IL
        IF(KDO(K).EQ.0) THEN
          T(I) = PI*(-IL+2*K-1)/FILM
          IF (KEPS(K).NE.0) THEN
            TS = T(I)
            T(I) = TS - EPS
            I = I + 1
            T(I) = TS + EPS
          ENDIF
          I = I + 1
        ENDIF
   30 CONTINUE
      ITL = I - 1
C-----------------------------------------------------------------------
C     Test values of Z in -PI.lt.arg(Z).le.PI near formula boundaries.
C-----------------------------------------------------------------------
      IF (KPRINT.GE.2) THEN
        WRITE (LUN,99996)
99996   FORMAT (' CHECKS IN THE Z PLANE'/)
      ENDIF
      LFLG = 0
      DO 180 ICASE = 1,ICL
C-----------------------------------------------------------------------
C     ICASE = 1 computes wron(AI(Z),BI(Z))     =CON3
C     ICASE = 2 computes wron(AI(Z),AI(Z*CON1))=CON2
C-----------------------------------------------------------------------
        DO 170 KODE = 1,2
          DO 160 IRSET = 1,3
            IRB = MIN(IRSET,2)
            DO 150 IR = IRB,4
C------------ switch (irset)
              GO TO (40, 50, 60), IRSET
   40         CONTINUE
                R = 2.0D0*(IR-1)/3.0D0
                GO TO 70
   50         CONTINUE
                R = (2.0D0*(4-IR)+RL*(IR-1))/3.0D0
                GO TO 70
   60         CONTINUE
                R = (RL*(4-IR)+RM*(IR-1))/3.0D0
   70         CONTINUE
C------------ end switch
              DO 140 IT = 1,ITL
C----------------------------------------------------------------------
C     The following values are set before the DO 30 loop:
C            C23 = 2/3
C           CON1 = cmplx(cos(2PI/3),sin(2PI/3))
C           CON2 = cmplx(cos(PI/6),-sin(PI/6)/2PI
C           CON3 = cmplx(1/PI,0)
C----------------------------------------------------------------------
                CT = COS(T(IT))
                ST = SIN(T(IT))
                IF (ABS(CT).LT.ATOL) CT = 0.0D0
                IF (ABS(ST).LT.ATOL) ST = 0.0D0
                ZR = R*CT
                ZI = R*ST
                CALL ZSQRT(ZR, ZI, STR, STI)
                PTR = (ZR*STR-ZI*STI)*C23
                ZRI = (ZR*STI+ZI*STR)*C23
                ZRR = PTR
                AZRR = ABS(ZRR)
C-------------- Check for possible underflow or overflow
                IF (AZRR.NE.0.0D0) THEN
                  ARG = -AZRR - 0.5D0*LOG(AZRR) + 0.226D0
                  ARG = ARG + ARG
C---------------- Skip test for this case?
                  IF (ARG.LT.(-ELIM)) GO TO 140
                ENDIF
                CALL ZAIRY(ZR, ZI, 0, KODE, YR(1), YI(1), NZ1, IERR)
                CALL ZAIRY(ZR, ZI, 1, KODE, YR(2), YI(2), NZ2, IERR)
                IF (ICASE.EQ.1) THEN
C---------------- Compare 1/PI with Wronskian of ZAIRY(Z) and ZBIRY(Z).
                  CALL ZBIRY(ZR, ZI, 0, KODE, WR(1), WI(1), IERR)
                  CALL ZBIRY(ZR, ZI, 1, KODE, WR(2), WI(2), IERR)
                  IF (KODE.EQ.2) THEN
C-----------------------------------------------------------------------
C     When KODE = 2, the scaling factor exp(-zeta1-zeta2) is 1.0 for
C     -PI.lt.arg(Z).le.PI/3 and exp(-2.0*zeta1) for PI/3.lt.arg(Z)
C     .le.PI where zeta1 = zeta2 in this range. This is due to the fact
C     that arg(Z*CON1) is taken to be in (-PI,PI) by the principal
C     square root.
C-----------------------------------------------------------------------
C------------------ Adjust scaling factor.
                    CVR = AZRR - ZRR
                    CVI = -ZRI
                    CALL ZEXP(CVR, CVI, CVR, CVI)
                    STR = WR(1)*CVR - WI(1)*CVI
                    WI(1) = WR(1)*CVI + WI(1)*CVR
                    WR(1) = STR
                    STR = WR(2)*CVR - WI(2)*CVI
                    WI(2) = WR(2)*CVI + WI(2)*CVR
                    WR(2) = STR
                  ENDIF
                  CVR = CON3R
                  CVI = CON3I
                ELSE
C---------------- Compare exp(-i*PI/6)/2PI with Wronskian of ZAIRY(Z)
C                 and ZAIRY(Z*exp(2i*PI/3)).
                  CVR = ZR*CON1R - ZI*CON1I
                  CVI = ZR*CON1I + ZI*CON1R
                  CALL ZAIRY(CVR, CVI, 0, KODE, WR(1), WI(1), NZ3, IERR)
                  CALL ZAIRY(CVR, CVI, 1, KODE, WR(2), WI(2), NZ4, IERR)
                  IF (KODE.EQ.2) THEN
                    IF (T(IT).GE.PI3) THEN
C-------------------- Adjust scaling factor.
                      CVR = ZRR + ZRR
                      CVI = ZRI + ZRI
                      CALL ZEXP(-CVR, -CVI, CVR, CVI)
                      STR = WR(1)*CVR - WI(1)*CVI
                      WI(1) = WR(1)*CVI + WI(1)*CVR
                      WR(1) = STR
                      STR = WR(2)*CVR - WI(2)*CVI
                      WI(2) = WR(2)*CVI + WI(2)*CVR
                      WR(2) = STR
                    ENDIF
                  ENDIF
                  STR = WR(2)*CON1R - WI(2)*CON1I
                  WI(2) = WR(2)*CON1I + WI(2)*CON1R
                  WR(2) = STR
                  CVR = CON2R
                  CVI = CON2I
                ENDIF
C-----------------------------------------------------------------------
C     Error relative to maximum term
C-----------------------------------------------------------------------
                AV = ZABS(CVR,CVI)
                CWR = YR(1)*WR(2) - YI(1)*WI(2)
                CWI = YR(1)*WI(2) + YI(1)*WR(2)
                CYR = YR(2)*WR(1) - YI(2)*WI(1)
                CYI = YR(2)*WI(1) + YI(2)*WR(1)
                CYR = CWR - CYR - CVR
                CYI = CWI - CYI - CVI
                ACY = ZABS(YR(1),YI(1))*ZABS(WR(2),WI(2))
                ACW = ZABS(WR(1),WI(1))*ZABS(YR(2),YI(2))
                AV = MAX(ACW,ACY,AV)
                ER = ZABS(CYR,CYI)/AV
                IF (ER.GE.ERTOL) THEN
                  IF (LFLG.EQ.0) THEN
                    IF (KPRINT.GE.2) THEN
                      WRITE (LUN,99995) ERTOL
99995                 FORMAT (' CASES WHICH VIOLATE THE RELATIVE ERROR',
     *                   ' TEST WITH ERTOL = ', D12.4/)
                      WRITE (LUN,99994)
99994                 FORMAT (' INPUT TO ZAIRY AND ERROR')
                    ENDIF
                    IF (KPRINT.GE.3) THEN
                      WRITE (LUN,99993)
99993                 FORMAT (' COMPARISON VALUE AND WRONSKIAN')
                      WRITE (LUN,99992)
99992                 FORMAT (' RESULTS FROM ZAIRY AND/OR ZBIRY')
                      WRITE (LUN,99991)
99991                 FORMAT (' TEST CASE INDICES'/)
                    ENDIF
                  ENDIF
                  LFLG = 1
                  IF (KPRINT.GE.2) THEN
                    WRITE (LUN,99990) ZR, ZI, ER
99990               FORMAT (12X,'INPUT:    Z=',2D12.4,5X,'ERROR:   ER=',
     *                 D12.4)
                  ENDIF
                  IF (KPRINT.GE.3) THEN
                    WRITE (LUN,99989) CVR, CVI, CYR, CYI
99989               FORMAT (' COMPARISON VALUE:   CV=',2D12.4/
     *                 8X,'WRONSKIAN:   CY=',2D12.4)
                    WRITE (LUN,99988) NZ1, YR(1), YI(1),
     *                 NZ2, YR(2), YI(2)
99988               FORMAT (10X,'RESULTS:  NZ1=',I3,4X,'Y(1)=',2D12.4/
     *                 20X,'NZ2=',I3,4X,'Y(2)=',2D12.4)
                    IF (ICASE.EQ.1) THEN
                      WRITE (LUN,99987) WR(1), WI(1), WR(2), WI(2)
99987                 FORMAT (31X,'W(1)=',2D12.4/31X,'W(2)=',2D12.4)
                    ELSE
                      WRITE (LUN,99986) NZ3, WR(1), WI(1),
     *                   NZ4, WR(2), WI(2)
99986                 FORMAT (20X,'NZ3=',I3,4X,'W(1)=',2D12.4/
     *                   20X,'NZ4=',I3,4X,'W(2)=',2D12.4)
                    ENDIF
                    WRITE (LUN,99985) IT, IR, IRSET, ICASE
99985               FORMAT (13X,'CASE:   IT=',I3,4X,'IR=',I3,4X,
     *                 'IRSET=',I3,4X,'ICASE=',I3,4X/)
                  ENDIF
                ENDIF
  140         CONTINUE
  150       CONTINUE
  160     CONTINUE
  170   CONTINUE
  180 CONTINUE
      IF (KPRINT.GE.2) THEN
        IF (LFLG.EQ.0) THEN
          WRITE (LUN,99984)
99984     FORMAT (' QUICK CHECKS OK')
        ELSE
          WRITE (LUN,99983)
99983     FORMAT (' ***',5X,'FAILURE(S) FOR ZAIRY IN THE Z PLANE')
        ENDIF
      ENDIF
      IPASS = 0
      IF (LFLG.EQ.0) THEN
        IPASS = 1
      ENDIF
      IF (IPASS.EQ.1.AND.KPRINT.GE.2) THEN
        WRITE (LUN,99982)
99982   FORMAT (/' ****** ZAIRY  PASSED ALL TESTS  ******'/)
      ENDIF
      IF (IPASS.EQ.0.AND.KPRINT.GE.1) THEN
        WRITE (LUN,99981)
99981   FORMAT (/' ****** ZAIRY  FAILED SOME TESTS ******'/)
      ENDIF
      RETURN
      END

*DECK ISRTQC
      SUBROUTINE ISRTQC (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  ISRTQC
C***SUBSIDIARY
C***PURPOSE  Quick check for SLATEC routines ISORT, IPSORT, IPPERM
C***LIBRARY   SLATEC
C***CATEGORY  N6A
C***TYPE      INTEGER (SSRTQC-S, DSRTQC-D, ISRTQC-I, HSRTQC-H)
C***KEYWORDS  IPPERM, IPSORT, ISORT, QUICK CHECK
C***AUTHOR  Boisvert, Ronald, (NIST)
C***REFERENCES  (NONE)
C***ROUTINES CALLED  IPPERM, IPSORT, ISORT
C***REVISION HISTORY  (YYMMDD)
C   890620  DATE WRITTEN
C   901005  Included test of IPPERM.  (MAM)
C   920511  Added error message tests.  (MAM)
C***END PROLOGUE  ISRTQC
C
      INTEGER N, NTEST
      PARAMETER (N=9,NTEST=4)
C
      LOGICAL FAIL
      INTEGER X(N,NTEST), XS(N,NTEST), Y(N), YC(N)
      INTEGER IX(N,NTEST), IY(N), KFLAG(NTEST), KPRINT, LUN, IPASS, J,
     +        I, KABS, IER, NERR, NUMXER, NN, KKFLAG
C
C     ---------
C     TEST DATA
C     ---------
C
C         X   = TEST VECTOR
C         XS  = TEST VECTOR IN SORTED ORDER
C         IX  = PERMUTATION VECTOR, I.E.  X(IX(J)) = XS(J)
C
      DATA KFLAG(1)       /  2 /
      DATA (X(I,1),I=1,N) / 36, 54, -1, 29,  1, 80, 98, 99, 55/
      DATA (IX(I,1),I=1,N)/  3,  5,  4,  1,  2,  9,  6,  7,  8/
      DATA (XS(I,1),I=1,N)/ -1,  1, 29, 36, 54, 55, 80, 98, 99/
C
      DATA KFLAG(2)       / -1 /
      DATA (X(I,2),I=1,N) /  1,  2,  3,  4,  5,  6,  7,  8,  9/
      DATA (IX(I,2),I=1,N)/  9,  8,  7,  6,  5,  4,  3,  2,  1/
      DATA (XS(I,2),I=1,N)/  9,  8,  7,  6,  5,  4,  3,  2,  1/
C
      DATA KFLAG(3)       / -2 /
      DATA (X(I,3),I=1,N) / -9, -8, -7, -6, -5, -4, -3, -2, -1/
      DATA (IX(I,3),I=1,N)/  9,  8,  7,  6,  5,  4,  3,  2,  1/
      DATA (XS(I,3),I=1,N)/ -1, -2, -3, -4, -5, -6, -7, -8, -9/
C
      DATA KFLAG(4)       /  1 /
      DATA (X(I,4),I=1,N) / 36, 54, -1, 29,  1, 80, 98, 99, 55/
      DATA (IX(I,4),I=1,N)/  3,  5,  4,  1,  2,  9,  6,  7,  8/
      DATA (XS(I,4),I=1,N)/ -1,  1, 29, 36, 54, 55, 80, 98, 99/
C
C***FIRST EXECUTABLE STATEMENT  ISRTQC
      IF ( KPRINT .GE. 2 ) THEN
         WRITE (LUN,2001) '================='
         WRITE (LUN,2002) 'OUTPUT FROM ISRTQC'
         WRITE (LUN,2002) '================='
      ENDIF
      IPASS = 1
C
C     -------------------------------------------------------------
C                          CHECK ISORT
C     -------------------------------------------------------------
C
      DO 200 J=1,NTEST
C
C        ... SETUP PROBLEM
C
         DO 110 I=1,N
            Y(I) = X(I,J)
            YC(I) = X(I,J)
  110    CONTINUE
C
C        ... CALL ROUTINE TO BE TESTED
C
         CALL ISORT(Y,YC,N,KFLAG(J))
C
C        ... EVALUATE RESULTS
C
         KABS = ABS(KFLAG(J))
         FAIL = .FALSE.
         DO 120 I=1,N
            FAIL = FAIL .OR. (Y(I).NE.XS(I,J))
     +                  .OR. ((KABS.EQ.1).AND.(YC(I).NE.X(I,J)))
     +                  .OR. ((KABS.EQ.2).AND.(YC(I).NE.XS(I,J)))
  120    CONTINUE
C
C        ... PRODUCE REQUIRED OUTPUT
C
         IF (FAIL) THEN
             IPASS = 0
             IF (KPRINT .GT. 0) WRITE(LUN,2001) 'ISORT FAILED TEST ',J
         ELSE
             IF (KPRINT .GE. 2) WRITE(LUN,2001) 'ISORT PASSED TEST ',J
         ENDIF
         IF ((FAIL .AND. (KPRINT .GE. 2)) .OR. (KPRINT .GE. 3)) THEN
            WRITE(LUN,2001) '------------------------'
            WRITE(LUN,2002) 'DETAILS OF ISORT TEST ',J
            WRITE(LUN,2002) '------------------------'
            WRITE(LUN,2002) '1ST ARGUMENT (VECTOR TO BE SORTED)'
            WRITE(LUN,2003) '             INPUT = ',(X(I,J),I=1,N)
            WRITE(LUN,2003) '   COMPUTED OUTPUT = ',(Y(I),I=1,N)
            WRITE(LUN,2003) '    CORRECT OUTPUT = ',(XS(I,J),I=1,N)
            WRITE(LUN,2002) '2ND ARGUMENT (VECTOR CARRIED ALONG)'
            WRITE(LUN,2003) '             INPUT = ',(X(I,J),I=1,N)
            WRITE(LUN,2003) '   COMPUTED OUTPUT = ',(YC(I),I=1,N)
            IF (KABS .EQ. 1) THEN
               WRITE(LUN,2003) '    CORRECT OUTPUT = ',(X(I,J),I=1,N)
            ELSE
               WRITE(LUN,2003) '    CORRECT OUTPUT = ',(XS(I,J),I=1,N)
            ENDIF
            WRITE(LUN,2002) '3RD ARGUMENT (VECTOR LENGTH)'
            WRITE(LUN,2004) '             INPUT = ',N
            WRITE(LUN,2002) '4TH ARGUMENT (TYPE OF SORT)'
            WRITE(LUN,2004) '             INPUT = ',KFLAG(J)
         ENDIF
  200 CONTINUE
C
C     -------------------------------------------------------------
C                            CHECK IPSORT
C     -------------------------------------------------------------
C
      DO 300 J=1,NTEST
C
C        ... SETUP PROBLEM
C
         DO 210 I=1,N
            Y(I) = X(I,J)
  210    CONTINUE
C
C        ... CALL ROUTINE TO BE TESTED
C
         CALL IPSORT(Y,N,IY,KFLAG(J),IER)
C
C        ... EVALUATE RESULTS
C
         KABS = ABS(KFLAG(J))
         FAIL = .FALSE. .OR. (IER.GT.0)
         DO 220 I=1,N
            FAIL = FAIL .OR. (IY(I).NE.IX(I,J))
     +                  .OR. ((KABS.EQ.1).AND.(Y(I).NE.X(I,J)))
     +                  .OR. ((KABS.EQ.2).AND.(Y(I).NE.XS(I,J)))
  220    CONTINUE
C
C        ... PRODUCE REQUIRED OUTPUT
C
         IF (FAIL) THEN
            IPASS = 0
            IF (KPRINT .GT. 0) WRITE(LUN,2001) 'IPSORT FAILED TEST ',J
         ELSE
            IF (KPRINT .GE. 2) WRITE(LUN,2001) 'IPSORT PASSED TEST ',J
         ENDIF
         IF ((FAIL .AND. (KPRINT .GE. 2)) .OR. (KPRINT .GE. 3)) THEN
            WRITE(LUN,2001) '-------------------------'
            WRITE(LUN,2002) 'DETAILS OF IPSORT TEST ',J
            WRITE(LUN,2002) '-------------------------'
            WRITE(LUN,2002) '1ST ARGUMENT (VECTOR TO BE SORTED)'
            WRITE(LUN,2003) '             INPUT = ',(X(I,J),I=1,N)
            WRITE(LUN,2003) '   COMPUTED OUTPUT = ',(Y(I),I=1,N)
            IF (KABS .EQ. 1) THEN
               WRITE(LUN,2003) '    CORRECT OUTPUT = ',(X(I,J),I=1,N)
            ELSE
               WRITE(LUN,2003) '    CORRECT OUTPUT = ',(XS(I,J),I=1,N)
            ENDIF
            WRITE(LUN,2002) '2ND ARGUMENT (VECTOR LENGTH)'
            WRITE(LUN,2004) '             INPUT = ',N
            WRITE(LUN,2002) '3RD ARGUMENT (PERMUTATION VECTOR)'
            WRITE(LUN,2004) '   COMPUTED OUTPUT = ',(IY(I),I=1,N)
            WRITE(LUN,2004) '    CORRECT OUTPUT = ',(IX(I,J),I=1,N)
            WRITE(LUN,2002) '4TH ARGUMENT (TYPE OF SORT)'
            WRITE(LUN,2004) '             INPUT = ',KFLAG(J)
         ENDIF
C
  300 CONTINUE
C
C     ... TEST ERROR MESSAGES
C
      IF(KPRINT.LE.2)THEN
         CALL XSETF(0)
      ELSE
         CALL XSETF(-1)
      ENDIF
C
      NN=-1
      KKFLAG=1
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL IPSORT(Y,NN,IY,KKFLAG,IER)
      IF(NUMXER(NERR).NE.IER)IPASS=0
C
      NN=1
      KKFLAG=0
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL IPSORT(Y,NN,IY,KKFLAG,IER)
      IF(NUMXER(NERR).NE.IER)IPASS=0
C
      IF((KPRINT.GE.2).AND.(IPASS.EQ.1))THEN
         WRITE(LUN,*)
         WRITE(LUN,*)' IPSORT PASSED ERROR MESSAGE TESTS'
      ELSE IF((KPRINT.GE.1).AND.(IPASS.EQ.0))THEN
         WRITE(LUN,*)
         WRITE(LUN,*)' IPSORT FAILED ERROR MESSAGE TESTS'
      ENDIF
C
C     -------------------------------------------------------------
C                            CHECK IPPERM
C     -------------------------------------------------------------
C
      DO 400 J=1,NTEST
C
C        ... SETUP PROBLEM
C
         KABS = ABS(KFLAG(J))
         DO 310 I=1,N
            Y(I) = X(I,J)
            IF(KABS.EQ.1)THEN
               IY(I) = I
            ELSE
               IY(I) = IX(I,J)
            ENDIF
  310    CONTINUE
C
C        ... CALL ROUTINE TO BE TESTED
C
         CALL IPPERM(Y,N,IY,IER)
C
C        ... EVALUATE RESULTS
C
         FAIL = .FALSE. .OR. (IER.GT.0)
         DO 320 I=1,N
            FAIL = FAIL .OR. ((KABS.EQ.1).AND.(IY(I).NE.I))
     +                  .OR. ((KABS.EQ.2).AND.(IY(I).NE.IX(I,J)))
     +                  .OR. ((KABS.EQ.1).AND.(Y(I).NE.X(I,J)))
     +                  .OR. ((KABS.EQ.2).AND.(Y(I).NE.XS(I,J)))
  320    CONTINUE
C
C        ... PRODUCE REQUIRED OUTPUT
C
         IF (FAIL) THEN
            IPASS = 0
            IF (KPRINT.GT.0) WRITE(LUN,2001)'IPPERM FAILED TEST ',J
         ELSE
            IF (KPRINT.GE.2) WRITE(LUN,2001)'IPPERM PASSED TEST ',J
         ENDIF
         IF ((FAIL .AND. (KPRINT.GE.2)) .OR. (KPRINT.GE.3)) THEN
            WRITE(LUN,2001)'------------------------'
            WRITE(LUN,2002)'DETAILS OF IPPERM TEST',J
            WRITE(LUN,2002)'------------------------'
            WRITE(LUN,2002)'1ST ARGUMENT (VECTOR TO BE PERMUTED)'
            WRITE(LUN,2003)'             INPUT =',(X(I,J),I=1,N)
            WRITE(LUN,2003)'   COMPUTED OUTPUT =',(Y(I),I=1,N)
            IF(KABS.EQ.1)THEN
               WRITE(LUN,2003)'    CORRECT OUTPUT =',(X(I,J),I=1,N)
            ELSE
               WRITE(LUN,2003)'    CORRECT OUTPUT =',(XS(I,J),I=1,N)
            ENDIF
            WRITE(LUN,2002)'2ND ARGUMENT (VECTOR LENGTH)'
            WRITE(LUN,2004)'             INPUT =',N
            WRITE(LUN,2002)'3RD ARGUMENT (PERMUTATION VECTOR)'
            WRITE(LUN,2004)'             INPUT =',(IY(I),I=1,N)
            WRITE(LUN,2002)'4TH ARGUMENT (ERROR FLAG)'
            WRITE(LUN,2004)'             OUTPUT =',IER
         ENDIF
C
  400 CONTINUE
C
C     ... TEST ERROR MESSAGES
C
      IF(KPRINT.LE.2)THEN
         CALL XSETF(0)
      ELSE
         CALL XSETF(-1)
      ENDIF
C
      NN=-1
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL IPPERM(Y,NN,IY,IER)
      IF(NUMXER(NERR).NE.IER)IPASS=0
C
      NN=1
      IY(1)=5
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL IPPERM(Y,NN,IY,IER)
      IF(NUMXER(NERR).NE.IER)IPASS=0
C
      IF((KPRINT.GE.2).AND.(IPASS.EQ.1))THEN
         WRITE(LUN,*)
         WRITE(LUN,*)' IPPERM PASSED ERROR MESSAGE TESTS'
      ELSE IF((KPRINT.GE.1).AND.(IPASS.EQ.0))THEN
         WRITE(LUN,*)
         WRITE(LUN,*)' IPPERM FAILED ERROR MESSAGE TESTS'
      ENDIF
C
      RETURN
C
 2001 FORMAT(/ 1X,A,I2)
 2002 FORMAT(1X,A,I2)
 2003 FORMAT(1X,A,9I4)
 2004 FORMAT(1X,A,9I4)
      END

*DECK F1O
      REAL FUNCTION F1O (X)
C***BEGIN PROLOGUE  F1O
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F1O
      REAL X
C***FIRST EXECUTABLE STATEMENT  F1O
      F1O = 1.0
      IF(X.GT.3.1415926535897932) F1O = 0.0
      RETURN
      END

*DECK FZTEST
      SUBROUTINE FZTEST (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  FZTEST
C***PURPOSE  Quick check for FZERO.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (FZTEST-S, DFZTST-D)
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  FZERO, R1MACH, XERCLR, XGETF, XSETF
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   901205  Changed usage of R1MACH(3) to R1MACH(4).  (RWC)
C   910501  Added PURPOSE and TYPE records.  (WRB)
C   910708  Minor modifications in use of KPRINT.  (WRB)
C   920212  Code completely restructured to test IFLAG for all values
C           of KPRINT.  (WRB)
C***END PROLOGUE  FZTEST
C     .. Scalar Arguments ..
      INTEGER IPASS, KPRINT, LUN
C     .. Local Scalars ..
      INTEGER IFLAG, KONTRL
      REAL AE, B, C, PI, R, RE, TOL
      LOGICAL FATAL
C     .. External Functions ..
      REAL R1MACH
      EXTERNAL R1MACH
C     .. External Subroutines ..
      EXTERNAL FZERO, XERCLR, XGETF, XSETF
C     .. Intrinsic Functions ..
      INTRINSIC ABS, ATAN, MAX, SIN, SQRT, TAN
C***FIRST EXECUTABLE STATEMENT  FZTEST
      IF (KPRINT .GE. 2) WRITE (LUN,9000)
      IPASS = 1
      PI = 4.0E0 *ATAN(1.0E0)
      RE = 1.0E-6
      AE = 1.0E-6
      TOL = MAX(1.0E-5,SQRT(R1MACH(4)))
C
C     Set up and solve example problem
C
      B = 0.1E0
      C = 4.0E0
      R = C - B
      CALL FZERO (SIN, B, C, R, RE, AE, IFLAG)
C
C     See if test was passed.
C
      IF (ABS(B-PI).LE.TOL .AND. ABS(C-PI).LE.TOL) THEN
        IF (KPRINT .GE. 3) WRITE (LUN, 9010) 'PASSED', B, C, IFLAG
      ELSE
        IPASS = 0
        IF (KPRINT .GE. 2) WRITE (LUN, 9010) 'FAILED', B, C, IFLAG
      ENDIF
C
C     Trigger 2 error conditions
C
      CALL XGETF (KONTRL)
      IF (KPRINT .LE. 2) THEN
         CALL XSETF (0)
      ELSE
         CALL XSETF (1)
      ENDIF
      FATAL = .FALSE.
      CALL XERCLR
C
      IF (KPRINT .GE. 3) WRITE (LUN,9020)
      B = 1.0E0
C
C     IFLAG=3 (Singular point)
C
      C = 2.0E0
      R = 0.5E0*(B+C)
      CALL FZERO (TAN, B, C, B, RE, AE, IFLAG)
      IF (IFLAG .NE. 3) THEN
        IPASS = 0
        FATAL = .TRUE.
        IF (KPRINT .GE. 2) WRITE (LUN,9030) IFLAG, 2
      ENDIF
C
C     IFLAG=4 (No sign change)
C
      B = -3.0E0
      C = -0.1E0
      R = 0.5E0*(B+C)
      CALL FZERO (SIN, B, C, R, RE, AE, IFLAG)
      IF (IFLAG .NE. 4) THEN
        IPASS = 0
        FATAL = .TRUE.
        IF (KPRINT .GE. 2) WRITE (LUN,9030) IFLAG, 4
      ENDIF
C
      CALL XERCLR
C
      CALL XSETF (KONTRL)
      IF (FATAL) THEN
        IF (KPRINT .GE. 2) THEN
          WRITE (LUN, 9040)
        ENDIF
      ELSE
        IF (KPRINT .GE. 3) THEN
          WRITE (LUN, 9050)
        ENDIF
      ENDIF
C
      IF (IPASS.EQ.1 .AND. KPRINT.GE.2) WRITE (LUN,9060)
      IF (IPASS.EQ.0 .AND. KPRINT.GE.1) WRITE (LUN,9070)
      RETURN
 9000 FORMAT ('1' / ' FZERO QUICK CHECK')
 9010 FORMAT (' Accuracy test ', A /
     +        ' Example problem results:  (answer = PI),  B =', F20.14,
     +        ' C =', F20.14 / ' IFLAG =', I2)
 9020 FORMAT (/ ' IFLAG 3 and 4 tests')
 9030 FORMAT (/' IFLAG test FAILED.  IFLAG =', I2, ', but should ',
     +        'have been', I2)
 9040 FORMAT (/ ' At least IFLAG test failed')
 9050 FORMAT (/ ' All IFLAG tests passed')
 9060 FORMAT (/' ***************FZERO PASSED ALL TESTS**************')
 9070 FORMAT (/' ***************FZERO FAILED SOME TESTS*************')
      END

      double precision function zmach(job)
      integer job
c
c     double complex floating point arithmetic constants.
c     for the linpack test drivers only.
c     not used by actual linpack subroutines.
c
c     smach computes machine parameters of floating point
c     arithmetic for use in testing only.  not required by
c     linpack proper.
c
c     if trouble with automatic computation of these quantities,
c     they can be set by direct assignment statements.
c     assume the computer has
c
c        b = base of arithmetic
c        t = number of base  b  digits
c        l = smallest possible exponent
c        u = largest possible exponent
c
c     then
c
c        eps = b**(1-t)
c        tiny = 100.0*b**(-l+t)
c        huge = 0.01*b**(u-t)
c
c     dmach same as smach except t, l, u apply to
c     double precision.
c
c     cmach same as smach except if complex division
c     is done by
c
c        1/(x+i*y) = (x-i*y)/(x**2+y**2)
c
c     then
c
c        tiny = sqrt(tiny)
c        huge = sqrt(huge)
c
c
c     job is 1, 2 or 3 for epsilon, tiny and huge, respectively.
c
      double precision eps,tiny,huge,s
c
      eps = 1.0d0
   10 eps = eps/2.0d0
      s = 1.0d0 + eps
      if (s .gt. 1.0d0) go to 10
      eps = 2.0d0*eps
c
      s = 1.0d0
   20 tiny = s
      s = s/16.0d0
      if (s*1.0d0 .ne. 0.0d0) go to 20
      tiny = tiny/eps
      s = (1.0d0,0.0d0)/dcmplx(tiny,0.0d0)
      if (s .ne. 1.0d0/tiny) tiny = dsqrt(tiny)
      huge = 1.0d0/tiny
c
      if (job .eq. 1) zmach = eps
      if (job .eq. 2) zmach = tiny
      if (job .eq. 3) zmach = huge
      return
      end

*DECK F1WS
      REAL FUNCTION F1WS (X)
C***BEGIN PROLOGUE  F1WS
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F1WS
      REAL X
C***FIRST EXECUTABLE STATEMENT  F1WS
      F1WS = ABS(X-0.33E+00)**(-0.999E+00)
      RETURN
      END

*DECK PCHQK5
      SUBROUTINE PCHQK5 (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  PCHQK5
C***PURPOSE  Test the PCH to B-spline conversion routine PCHBS.
C***LIBRARY   SLATEC (PCHIP)
C***TYPE      SINGLE PRECISION (PCHQK5-S, DPCHQ5-D)
C***KEYWORDS  PCHIP CONVERSION ROUTINE QUICK CHECK
C***AUTHOR  Fritsch, F. N., (LLNL)
C***DESCRIPTION
C
C              PCHIP QUICK CHECK NUMBER 5
C
C     TESTS THE CONVERSION ROUTINE:  PCHBS.
C *Usage:
C
C        INTEGER  LUN, KPRINT, IPASS
C
C        CALL PCHQK5 (LUN, KPRINT, IPASS)
C
C *Arguments:
C
C     LUN   :IN  is the unit number to which output is to be written.
C
C     KPRINT:IN  controls the amount of output, as specified in the
C                SLATEC Guidelines.
C
C     IPASS:OUT  will contain a pass/fail flag.  IPASS=1 is good.
C                IPASS=0 indicates one or more tests failed.
C
C *Description:
C
C   This routine tests a constructed data set with four different
C   KNOTYP settings.  It computes the function and derivatives of the
C   resulting B-representation via BVALU and compares with PCH data.
C
C *Caution:
C   This routine assumes BVALU has already been successfully tested.
C
C***ROUTINES CALLED  BVALU, PCHBS, R1MACH
C***REVISION HISTORY  (YYMMDD)
C   900411  DATE WRITTEN
C   900412  Corrected minor errors in initial implementation.
C   900430  Corrected errors in prologue.
C   900501  Corrected declarations.
C   930317  Improved output formats.  (FNF)
C***END PROLOGUE  PCHQK5
C
C*Internal Notes:
C  TOL  is the tolerance to use for quantities that should only
C       theoretically be equal.
C  TOLZ is the tolerance to use for quantities that should be exactly
C       equal.
C
C**End
C
C  Declare arguments.
C
      INTEGER  LUN, KPRINT, IPASS
C
C  Declare externals.
C
      REAL  BVALU, R1MACH
      EXTERNAL  BVALU, PCHBS, R1MACH
C
C  Declare variables.
C
      INTEGER  I, IERR, IFAIL, INBV, J, KNOTYP, K, N, NDIM, NKNOTS
      PARAMETER  (N = 9)
      REAL  BCOEF(2*N), D(N), DCALC, DERR, DERMAX, F(N), FCALC, FERR,
     *      FERMAX, T(2*N+4), TERR, TERMAX, TOL, TOLZ, TSAVE(2*N+4),
     *      WORK(16*N), X(N), ZERO
      PARAMETER  (ZERO = 0.0E0)
      LOGICAL  FAIL
C
C  Define relative error function.
C
      REAL  ANS, ERR, RELERR
      RELERR (ERR, ANS) = ABS(ERR) / MAX(1.0E-5,ABS(ANS))
C
C  Define test data.
C
      DATA  X /-2.2E0,   -1.2E0,   -1.0E0,   -0.5E0,   -0.01E0,
     *          0.5E0,    1.0E0,    2.0E0,    2.2E0/
      DATA  F / 0.0079E0, 0.2369E0, 0.3679E0, 0.7788E0, 0.9999E0,
     *          0.7788E0, 0.3679E0, 0.1083E0, 0.0079E0/
      DATA  D / 0.0000E0, 0.3800E0, 0.7173E0, 0.5820E0, 0.0177E0,
     *         -0.5696E0,-0.5135E0,-0.0778E0,-0.0025E0/
C
C  Initialize.
C
C***FIRST EXECUTABLE STATEMENT  PCHQK5
      IFAIL = 0
      TOL = 100*R1MACH(4)
      TOLZ = ZERO
C
      IF (KPRINT.GE.3)  WRITE (LUN, 1000)
      IF (KPRINT.GE.2)  WRITE (LUN, 1001)
C
C  Loop over a series of values of KNOTYP.
C
      IF (KPRINT.GE.3)  WRITE (LUN, 1010)
      DO 300  KNOTYP = 2, -1, -1
C        ------------
         CALL PCHBS (N, X, F, D, 1, KNOTYP, NKNOTS, T, BCOEF, NDIM, K,
     *               IERR)
C        ------------
         IF (KPRINT.GE.3)
     *       WRITE (LUN, 2000) KNOTYP, NKNOTS, NDIM, K, IERR
         IF ( IERR.NE.0 )  THEN
            IFAIL = IFAIL + 1
            IF (KPRINT.GE.3)  WRITE (LUN, 2001)
         ELSE
C             Compare evaluated results with inputs to PCHBS.
            INBV = 1
            FERMAX = ZERO
            DERMAX = ZERO
            IF (KPRINT.GE.3)  THEN
               WRITE (LUN, 2002)
               WRITE (LUN, 2003)  T(1), T(2)
               J = 1
            ENDIF
            DO 100  I = 1, N
               FCALC = BVALU (T, BCOEF, NDIM, K, 0, X(I), INBV, WORK)
               FERR = F(I) - FCALC
               FERMAX = MAX(FERMAX, RELERR(FERR,F(I)) )
               DCALC = BVALU (T, BCOEF, NDIM, K, 1, X(I), INBV, WORK)
               DERR = D(I) - DCALC
               DERMAX = MAX(DERMAX, RELERR(DERR,D(I)) )
               IF (KPRINT.GE.3)  THEN
                  J = J + 2
                  WRITE (LUN, 2004)  X(I), T(J), T(J+1), F(I), FERR,
     *                                                   D(I), DERR
               ENDIF
  100       CONTINUE
            IF (KPRINT.GE.3)  THEN
               J = J + 2
               WRITE (LUN, 2003)  T(J), T(J+1)
            ENDIF
            FAIL = (FERMAX.GT.TOL).OR.(DERMAX.GT.TOL)
            IF (FAIL)  IFAIL = IFAIL + 1
            IF ((KPRINT.GE.3).OR.(KPRINT.GE.2).AND.FAIL)
     *         WRITE (LUN, 2005)  FERMAX, DERMAX, TOL
         ENDIF
C
C          Special check for KNOTYP=-1.
         IF (KNOTYP.EQ.0)  THEN
C             Save knot vector for next test.
            DO 200  I = 1, NKNOTS
               TSAVE(I) = T(I)
  200       CONTINUE
         ELSE IF (KNOTYP.EQ.-1)  THEN
C             Check that knot vector is unchanged.
            TERMAX = ZERO
            DO 250  I = 1, NKNOTS
               TERR = ABS(T(I) - TSAVE(I))
               TERMAX = MAX(TERMAX, TERR)
  250       CONTINUE
            IF (TERMAX.GT.TOLZ)  THEN
               IFAIL = IFAIL + 1
               IF (KPRINT.GE.2)  WRITE (LUN, 2007)  TERMAX, TOLZ
            ENDIF
         ENDIF
  300 CONTINUE
C
C  PRINT SUMMARY AND TERMINATE.
C
      IF ((KPRINT.GE.2).AND.(IFAIL.NE.0))  WRITE (LUN, 3001)  IFAIL
C
      IF (IFAIL.EQ.0)  THEN
         IPASS = 1
         IF (KPRINT.GE.2) WRITE(LUN,99998)
      ELSE
         IPASS = 0
         IF (KPRINT.GE.1) WRITE(LUN,99999)
      ENDIF
C
      RETURN
C
C  FORMATS.
C
 1000 FORMAT ('1'//10X,'TEST PCH TO B-SPLINE CONVERTER')
 1001 FORMAT (//10X,'PCHQK5 RESULTS'/10X,'--------------')
 1010 FORMAT (/4X,'(Results should be the same for all KNOTYP values.)')
 2000 FORMAT (/4X,'KNOTYP =',I2,':  NKNOTS =',I3,',  NDIM =',I3,
     *                        ',  K =',I2,',  IERR =',I3)
 2001 FORMAT (' *** Failed -- bad IERR value.')
 2002 FORMAT (/15X,'X',9X,'KNOTS',10X,'F',7X,'FERR',8X,'D',7X,'DERR')
 2003 FORMAT (18X,2F8.2)
 2004 FORMAT (10X,3F8.2,F10.4,1P,E10.2,0P,F10.4,1P,E10.2)
 2005 FORMAT (/5X,'Maximum relative errors:'
     *       /15X,'F-error =',1P,E13.5,5X,'D-error =',E13.5
     *        /5X,'Both should be less than  TOL =',E13.5)
 2007 FORMAT (/' *** T-ARRAY MAXIMUM CHANGE =',1P,E13.5,
     *           ';  SHOULD NOT EXCEED TOLZ =',E13.5)
 3001 FORMAT (/' *** TROUBLE ***',I5,' CONVERSION TESTS FAILED.')
99998 FORMAT (/' ------------  PCHIP PASSED  ALL CONVERSION TESTS',
     *        ' ------------')
99999 FORMAT (/' ************  PCHIP FAILED SOME CONVERSION TESTS',
     *        ' ************')
C------------- LAST LINE OF PCHQK5 FOLLOWS -----------------------------
      END

      REAL FUNCTION R1MACH(I)
      INTEGER I
C
C  SINGLE-PRECISION MACHINE CONSTANTS
C  R1MACH(1) = B**(EMIN-1), THE SMALLEST POSITIVE MAGNITUDE.
C  R1MACH(2) = B**EMAX*(1 - B**(-T)), THE LARGEST MAGNITUDE.
C  R1MACH(3) = B**(-T), THE SMALLEST RELATIVE SPACING.
C  R1MACH(4) = B**(1-T), THE LARGEST RELATIVE SPACING.
C  R1MACH(5) = LOG10(B)
C
C  THIS VERSION ADAPTS AUTOMATICALLY TO MOST CURRENT MACHINES,
C  INCLUDING AUTO-DOUBLE COMPILERS.
C  TO ALTER FOR A PARTICULAR ENVIRONMENT, THE DESIRED SET OF DATA
C  STATEMENTS MAY BE ACTIVATED BY REMOVING THE C FROM COLUMN 1.
C  CONSTANTS FOR OLDER MACHINES CAN BE OBTAINED BY
C          mail netlib@research.bell-labs.com
C          send old1mach from blas
C  PLEASE SEND CORRECTIONS TO dmg OR ehg@bell-labs.com.
C
      INTEGER SMALL(2)
      INTEGER LARGE(2)
      INTEGER RIGHT(2)
      INTEGER DIVER(2)
      INTEGER LOG10(2)
      INTEGER CRAY1, SC
      COMMON /D8MACH/ CRAY1
      SAVE SMALL, LARGE, RIGHT, DIVER, LOG10, SC
      REAL RMACH(5)
      EQUIVALENCE (RMACH(1),SMALL(1))
      EQUIVALENCE (RMACH(2),LARGE(1))
      EQUIVALENCE (RMACH(3),RIGHT(1))
      EQUIVALENCE (RMACH(4),DIVER(1))
      EQUIVALENCE (RMACH(5),LOG10(1))
C     MACHINE CONSTANTS FOR THE HONEYWELL DPS 8/70 SERIES.
C
C      DATA RMACH(1) / O402400000000 /
C      DATA RMACH(2) / O376777777777 /
C      DATA RMACH(3) / O714400000000 /
C      DATA RMACH(4) / O716400000000 /
C      DATA RMACH(5) / O776464202324 /, SC/987/
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRANS SUPPORTING
C     32-BIT INTEGERS (EXPRESSED IN INTEGER AND OCTAL).
C
C      DATA SMALL(1) /    8388608 /
C      DATA LARGE(1) / 2147483647 /
C      DATA RIGHT(1) /  880803840 /
C      DATA DIVER(1) /  889192448 /
C      DATA LOG10(1) / 1067065499 /, SC/987/
C
C      DATA RMACH(1) / O00040000000 /
C      DATA RMACH(2) / O17777777777 /
C      DATA RMACH(3) / O06440000000 /
C      DATA RMACH(4) / O06500000000 /
C      DATA RMACH(5) / O07746420233 /, SC/987/
C
C     MACHINE CONSTANTS FOR THE SEQUENT BALANCE 8000.
C
C      DATA SMALL(1) / $00800000 /
C      DATA LARGE(1) / $7F7FFFFF /
C      DATA RIGHT(1) / $33800000 /
C      DATA DIVER(1) / $34000000 /
C      DATA LOG10(1) / $3E9A209B /, SC/987/
C
C     MACHINE CONSTANTS FOR THE UNIVAC 1100 SERIES.
C
C      DATA RMACH(1) / O000400000000 /
C      DATA RMACH(2) / O377777777777 /
C      DATA RMACH(3) / O146400000000 /
C      DATA RMACH(4) / O147400000000 /
C      DATA RMACH(5) / O177464202324 /, SC/987/
C
      IF (SC .NE. 987) THEN
*        *** CHECK FOR AUTODOUBLE ***
         SMALL(2) = 0
         RMACH(1) = 1E13
         IF (SMALL(2) .NE. 0) THEN
*           *** AUTODOUBLED ***
            IF (      SMALL(1) .EQ. 1117925532
     *          .AND. SMALL(2) .EQ. -448790528) THEN
*              *** IEEE BIG ENDIAN ***
               SMALL(1) = 1048576
               SMALL(2) = 0
               LARGE(1) = 2146435071
               LARGE(2) = -1
               RIGHT(1) = 1017118720
               RIGHT(2) = 0
               DIVER(1) = 1018167296
               DIVER(2) = 0
               LOG10(1) = 1070810131
               LOG10(2) = 1352628735
            ELSE IF ( SMALL(2) .EQ. 1117925532
     *          .AND. SMALL(1) .EQ. -448790528) THEN
*              *** IEEE LITTLE ENDIAN ***
               SMALL(2) = 1048576
               SMALL(1) = 0
               LARGE(2) = 2146435071
               LARGE(1) = -1
               RIGHT(2) = 1017118720
               RIGHT(1) = 0
               DIVER(2) = 1018167296
               DIVER(1) = 0
               LOG10(2) = 1070810131
               LOG10(1) = 1352628735
            ELSE IF ( SMALL(1) .EQ. -2065213935
     *          .AND. SMALL(2) .EQ. 10752) THEN
*              *** VAX WITH D_FLOATING ***
               SMALL(1) = 128
               SMALL(2) = 0
               LARGE(1) = -32769
               LARGE(2) = -1
               RIGHT(1) = 9344
               RIGHT(2) = 0
               DIVER(1) = 9472
               DIVER(2) = 0
               LOG10(1) = 546979738
               LOG10(2) = -805796613
            ELSE IF ( SMALL(1) .EQ. 1267827943
     *          .AND. SMALL(2) .EQ. 704643072) THEN
*              *** IBM MAINFRAME ***
               SMALL(1) = 1048576
               SMALL(2) = 0
               LARGE(1) = 2147483647
               LARGE(2) = -1
               RIGHT(1) = 856686592
               RIGHT(2) = 0
               DIVER(1) = 873463808
               DIVER(2) = 0
               LOG10(1) = 1091781651
               LOG10(2) = 1352628735
            ELSE
               WRITE(*,9010)
               STOP 777
               END IF
         ELSE
            RMACH(1) = 1234567.
            IF (SMALL(1) .EQ. 1234613304) THEN
*              *** IEEE ***
               SMALL(1) = 8388608
               LARGE(1) = 2139095039
               RIGHT(1) = 864026624
               DIVER(1) = 872415232
               LOG10(1) = 1050288283
            ELSE IF (SMALL(1) .EQ. -1271379306) THEN
*              *** VAX ***
               SMALL(1) = 128
               LARGE(1) = -32769
               RIGHT(1) = 13440
               DIVER(1) = 13568
               LOG10(1) = 547045274
            ELSE IF (SMALL(1) .EQ. 1175639687) THEN
*              *** IBM MAINFRAME ***
               SMALL(1) = 1048576
               LARGE(1) = 2147483647
               RIGHT(1) = 990904320
               DIVER(1) = 1007681536
               LOG10(1) = 1091781651
            ELSE IF (SMALL(1) .EQ. 1251390520) THEN
*              *** CONVEX C-1 ***
               SMALL(1) = 8388608
               LARGE(1) = 2147483647
               RIGHT(1) = 880803840
               DIVER(1) = 889192448
               LOG10(1) = 1067065499
            ELSE
               CRAY1 = 4617762693716115456.D0
               IF (SMALL(1) .NE. CRAY1) THEN
                  WRITE(*,9020)
                  STOP 777
                  END IF
*              *** CRAY 1, XMP, 2, AND 3 ***
               SMALL(1) = 2306828171632181248.D0
               LARGE(1) = 6917247552664371198.D0
               RIGHT(1) = 4598878906987053056.D0
               DIVER(1) = 4599160381963763712.D0
               LOG10(1) = 4611574008272714704.D0
               END IF
            END IF
         SC = 987
         END IF
*     SANITY CHECK
      IF (RMACH(4) .GE. 1.0) STOP 776
      IF (I .LT. 1 .OR. I .GT. 5) THEN
         WRITE(*,*) 'R1MACH(I): I =',I,' is out of bounds.'
         STOP
         END IF
      R1MACH = RMACH(I)
      RETURN
 9010 FORMAT(/' Adjust autodoubled R1MACH by getting data'/
     *' appropriate for your machine from D1MACH.')
 9020 FORMAT(/' Adjust R1MACH by uncommenting data statements'/
     *' appropriate for your machine.')
* /* C source for R1MACH -- remove the * in column 1 */
*#include <stdio.h>
*#include <float.h>
*#include <math.h>
*float r1mach_(long *i)
*{
*	switch(*i){
*	  case 1: return FLT_MIN;
*	  case 2: return FLT_MAX;
*	  case 3: return FLT_EPSILON/FLT_RADIX;
*	  case 4: return FLT_EPSILON;
*	  case 5: return log10(FLT_RADIX);
*	  }
*	fprintf(stderr, "invalid argument: r1mach(%ld)\n", *i);
*	exit(1); return 0; /* for compilers that complain of missing return values */
*}
      END

*DECK QXBDF
      SUBROUTINE QXBDF (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  QXBDF
C***PURPOSE  Test the DEPAC routine DEBDF.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (QXBDF-S, QXDBDF-D)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Chow, Jeff, (LANL)
C***DESCRIPTION
C
C *Usage:
C
C        INTEGER  LUN, KPRINT, IPASS
C
C        CALL QXBDF (LUN, KPRINT, IPASS)
C
C *Arguments:
C
C     LUN   :IN  is the unit number to which output is to be written.
C
C     KPRINT:IN  controls the amount of output, as specified in the
C                SLATEC Guidelines.
C
C     IPASS:OUT  will contain a pass/fail flag.  IPASS=1 is good.
C                IPASS=0 indicates one or more tests failed.
C
C *Description:
C
C   DEBDF is tested by solving the equations of motion of a body
C   moving in a plane about a spherical earth, namely
C           (D/DT)(D/DT)X = -G*X/R**3
C           (D/DT)(D/DT)Y = -G*Y/R**3
C   where G = 1, R = SQRT(X**2 + Y**2) and
C           X(0) = 1
C           (D/DT)X(0) = 0
C           Y(0) = 0
C           (D/DT)Y(0) = 1.
C
C***ROUTINES CALLED  DEBDF, FDEQC, JAC, R1MACH
C***REVISION HISTORY  (YYMMDD)
C   810801  DATE WRITTEN
C   890618  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900415  Code extensively revised.  (WRB)
C***END PROLOGUE  QXBDF
C
C     Declare arguments.
C
      INTEGER  LUN, KPRINT, IPASS
C
C     Declare local variables.
C
      INTEGER  IDID, INFO(15), IPAR, IWORK(60), N, LIW, LRW
      REAL ABSERR, R, R1MACH, RELERR, RELTOL, RPAR, RWORK(306), T, TOUT,
     +     U(4)
      EXTERNAL FDEQC, JAC
C***FIRST EXECUTABLE STATEMENT  QXBDF
      IF (KPRINT .GE. 2)  WRITE (LUN, 9000)
C
C     Initialize problem.
C
      N = 4
      LRW = 306
      LIW = 60
      T = 0.0E0
      TOUT = 8.0E0*ATAN(1.0E0)
      U(1) = 1.0E0
      U(2) = 0.0E0
      U(3) = 0.0E0
      U(4) = 1.0E0
      IPASS = 1
      RELTOL = SQRT(R1MACH(4))
      RELERR = 0.001E0*RELTOL
      ABSERR = RELERR**1.5E0
      INFO(1) = 0
      INFO(2) = 0
      INFO(3) = 1
      INFO(4) = 0
      INFO(5) = 1
      INFO(6) = 0
      IF (KPRINT .GT. 2) WRITE (LUN, 9010) RELERR, ABSERR, T, (1.0E0)
C
  100 CALL DEBDF (FDEQC, N, T, U, TOUT, INFO, RELERR, ABSERR,
     +            IDID, RWORK, LRW, IWORK, LIW, RPAR, IPAR, JAC)
      R = SQRT(U(1)*U(1)+U(2)*U(2))
      IF (ABS(R-1.0E0) .GT. RELTOL) IPASS = 0
      IF (KPRINT .GT. 2) WRITE (LUN, 9020) T, R
      INFO(1) = 1
      IF (IDID .EQ. 1) GO TO 100
C
C     Finish up.
C
      IF (IDID .LT. 1) IPASS = 0
      IF (KPRINT.GT.1 .AND. IDID.LT.1)  WRITE (LUN, 9030) IDID
      IF (KPRINT.GT.1 .AND. IPASS.EQ.1) WRITE (LUN, 9040)
      IF (KPRINT.GE.1 .AND. IPASS.EQ.0) WRITE (LUN, 9050)
      RETURN
C
C     FORMATs.
C
 9000 FORMAT ('1'/' ------------  DEBDF QUICK CHECK OUTPUT',
     +        ' ------------')
 9010 FORMAT (/ ' RELERR = ', E16.8, '   ABSERR =', E16.8 /
     +        12X, 'T', 19X, 'R' / 2E20.8)
 9020 FORMAT (2E20.8)
 9030 FORMAT (1X, 'ERROR RETURN FROM DEBDF.  IDID = ', I3)
 9040 FORMAT (/ ' ------------  DEBDF PASSED TESTS  ------------')
 9050 FORMAT (/ ' ************  DEBDF FAILED TESTS  ************')
      END

*DECK SBEG
      REAL FUNCTION SBEG (RESET)
C***BEGIN PROLOGUE  SBEG
C***SUBSIDIARY
C***PURPOSE  Generate random numbers.
C***LIBRARY   SLATEC (BLAS)
C***AUTHOR  Du Croz, J. (NAG)
C           Hanson, R. J. (SNLA)
C***DESCRIPTION
C
C  Generates random numbers uniformly distributed between -0.5 and 0.5.
C
C  Auxiliary routine for test program for Level 2 Blas.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   870810  DATE WRITTEN
C   910619  Modified to meet SLATEC code and prologue standards.  (BKS)
C***END PROLOGUE  SBEG
C     .. Scalar Arguments ..
      LOGICAL            RESET
C     .. Local Scalars ..
      INTEGER            I, IC, MI
C     .. Save statement ..
      SAVE               I, IC, MI
C     .. Intrinsic Functions ..
      INTRINSIC          REAL
C ***FIRST EXECUTABLE STATEMENT  SBEG
      IF( RESET )THEN
C        Initialize local variables.
         MI = 891
         I = 7
         IC = 0
         RESET = .FALSE.
      END IF
C
C     The sequence of values of I is bounded between 1 and 999.
C     If initial I = 1,2,3,6,7 or 9, the period will be 50.
C     If initial I = 4 or 8, the period will be 25.
C     If initial I = 5, the period will be 10.
C     IC is used to break up the period by skipping 1 value of I in 6.
C
      IC = IC + 1
   10 I = I*MI
      I = I - 1000*( I/1000 )
      IF( IC.GE.5 )THEN
         IC = 0
         GO TO 10
      END IF
      SBEG = REAL( I - 500 )/1001.0
      RETURN
C
C     End of SBEG.
C
      END

*DECK DT0
      DOUBLE PRECISION FUNCTION DT0 (X)
C***BEGIN PROLOGUE  DT0
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  DF0S
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  DT0
      DOUBLE PRECISION A,B,DF0S,X,X1,Y
C***FIRST EXECUTABLE STATEMENT  DT0
      A = 0.0D+00
      B = 0.1D+01
      X1 = X+0.1D+01
      Y = (B-A)/X1+A
      DT0 = (B-A)*DF0S(Y)/X1/X1
      RETURN
      END

*DECK T4
      REAL FUNCTION T4 (X)
C***BEGIN PROLOGUE  T4
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  F4S
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  T4
      REAL A,B,F4S,X,X1,Y
C***FIRST EXECUTABLE STATEMENT  T4
      A = 0.0E+00
      B = 0.1E+01
      X1 = X+0.1E+01
      Y = (B-A)/X1+A
      T4 = (B-A)*F4S(Y)/X1/X1
      RETURN
      END

*DECK DQFCN2
      SUBROUTINE DQFCN2 (N, X, FVEC, IFLAG)
C***BEGIN PROLOGUE  DQFCN2
C***PURPOSE  Evaluate function used in DNSQE.
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (SQFCN2-S, DQFCN2-D)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C   Subroutine which evaluates the function for test program
C   used in quick check of DNSQE.
C
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   930214  TYPE and declarations sections added.  (WRB)
C***END PROLOGUE  DQFCN2
C     .. Scalar Arguments ..
      INTEGER IFLAG, N
C     .. Array Arguments ..
      DOUBLE PRECISION FVEC(*), X(*)
C***FIRST EXECUTABLE STATEMENT  DQFCN2
      FVEC(1) = 1.0D0 - X(1)
      FVEC(2) = 10.0D0*(X(2)-X(1)**2)
      RETURN
      END

*DECK FCQX
      SUBROUTINE FCQX (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  FCQX
C***PURPOSE  Quick check for FC.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (FCQX-S, DFCQX-D)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Hanson, R. J., (SNLA)
C***DESCRIPTION
C
C   Quick check subprogram for the subroutine FC.
C
C   Fit discrete data by an S-shaped curve.  Evaluate the fitted curve,
C   its first two derivatives, and probable error curve.
C
C   Use subprogram FC to obtain the constrained cubic B-spline
C   representation of the curve.
C
C   The values of the coefficients of the B-spline as computed by FC
C   and the values of the fitted curve as computed by BVALU in the
C   de Boor package are tested for accuracy with the expected values.
C   See the example program in the report sand78-1291, pp. 22-27.
C
C   The dimensions in the following arrays are as small as possible for
C   the problem being solved.
C
C***ROUTINES CALLED  BVALU, CV, FC, IVOUT, R1MACH, SCOPY, SMOUT, SVOUT
C***REVISION HISTORY  (YYMMDD)
C   780801  DATE WRITTEN
C   890718  Changed references from BVALUE to BVALU.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   891004  Changed computation of XVAL.  (WRB)
C   891004  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   901010  Restructured using IF-THEN-ELSE-ENDIF, modified tolerances
C           to use R1MACH(4) rather than R1MACH(3) and cleaned up
C           FORMATs.  (RWC)
C   930214  Declarations sections added, code revised to test error
C           returns for all values of KPRINT and code polished.  (WRB)
C***END PROLOGUE  FCQX
C     .. Scalar Arguments ..
      INTEGER IPASS, KPRINT, LUN
C     .. Local Scalars ..
      REAL DIFF, ONE, T, TOL, XVAL, ZERO
      INTEGER KONTRL, I, IDIGIT, II, J, L, LAST, MODE, N, NBKPT,
     +        NCONST, NDATA, NDEG, NERR, NORD, NVAL
      LOGICAL FATAL
C     .. Local Arrays ..
      REAL BKPT(13), CHECK(51), COEFCK(9), COEFF(9), SDDATA(9), V(51,5),
     +     W(529), WORK(12), XCONST(11), XDATA(9), YCONST(11), YDATA(9)
      INTEGER IW(30), NDERIV(11)
C     .. External Functions ..
      REAL BVALU, CV, R1MACH
      INTEGER NUMXER
      EXTERNAL BVALU, CV, NUMXER, R1MACH
C     .. External Subroutines ..
      EXTERNAL FC, IVOUT, SCOPY, SMOUT, SVOUT, XGETF, XSETF
C     .. Intrinsic Functions ..
      INTRINSIC ABS, REAL, SQRT
C     .. Data statements ..
C
      DATA XDATA(1),XDATA(2),XDATA(3),XDATA(4),XDATA(5),XDATA(6),
     +     XDATA(7),XDATA(8),XDATA(9)
     +     /0.15E0,0.27E0,0.33E0,0.40E0,0.43E0,0.47E0,
     +      0.53E0,0.58E0,0.63E0/
      DATA YDATA(1),YDATA(2),YDATA(3),YDATA(4),YDATA(5),YDATA(6),
     +     YDATA(7),YDATA(8),YDATA(9)
     +     /0.025E0,0.05E0,0.13E0,0.27E0,0.37E0,0.47E0,
     +      0.64E0,0.77E0,0.87E0/
      DATA SDDATA(1)/0.015E0/, NDATA/9/, NORD/4/, NBKPT/13/, LAST/10/
      DATA BKPT(1),BKPT(2),BKPT(3),BKPT(4),BKPT(5),BKPT(6),BKPT(7),
     +     BKPT(8),BKPT(9),BKPT(10),BKPT(11),BKPT(12),BKPT(13)
     +     /-0.6E0,-0.4E0,-0.2E0,0.0E0,0.2E0,0.4E0,0.6E0,
     +      0.8E0,0.9E0,1.0E0,1.1E0,1.2E0,1.3E0/
C
C     Store the data to be used to check the accuracy of the computed
C     results.  See SAND78-1291, p.26.
C
      DATA COEFCK(1),COEFCK(2),COEFCK(3),COEFCK(4),COEFCK(5),COEFCK(6),
     +     COEFCK(7),COEFCK(8),COEFCK(9)
     +     /1.186380846E-13,-2.826166426E-14,-4.333929094E-15,
     +      1.722113311E-01, 9.421965984E-01, 9.684708719E-01,
     +      9.894902905E-01, 1.005254855E+00, 9.894902905E-01/
      DATA CHECK(1),CHECK(2),CHECK(3),CHECK(4),CHECK(5),CHECK(6),
     +     CHECK(7),CHECK(8),CHECK(9)
     +     /2.095830752E-16, 2.870188850E-05, 2.296151081E-04,
     +      7.749509897E-04, 1.836920865E-03, 3.587736064E-03,
     +      6.199607918E-03, 9.844747759E-03, 1.469536692E-02/
      DATA CHECK(10),CHECK(11),CHECK(12),CHECK(13),CHECK(14),CHECK(15),
     +     CHECK(16),CHECK(17),CHECK(18)
     +     /2.092367672E-02, 2.870188851E-02, 3.824443882E-02,
     +      4.993466504E-02, 6.419812979E-02, 8.146039566E-02,
     +      1.021470253E-01, 1.266835812E-01, 1.554956261E-01/
      DATA CHECK(19),CHECK(20),CHECK(21),CHECK(22),CHECK(23),CHECK(24),
     +     CHECK(25),CHECK(26),CHECK(27)
     +     /1.890087225E-01, 2.276484331E-01, 2.718403204E-01,
     +      3.217163150E-01, 3.762338189E-01, 4.340566020E-01,
     +      4.938484342E-01, 5.542730855E-01,6.139943258E-01/
      DATA CHECK(28),CHECK(29),CHECK(30),CHECK(31),CHECK(32),CHECK(33),
     +     CHECK(34),CHECK(35),CHECK(36)
     +     /6.716759250E-01, 7.259816530E-01, 7.755752797E-01,
     +      8.191205752E-01, 8.556270903E-01, 8.854875002E-01,
     +      9.094402609E-01, 9.282238286E-01, 9.425766596E-01/
      DATA CHECK(37),CHECK(38),CHECK(39),CHECK(40),CHECK(41),CHECK(42),
     +     CHECK(43),CHECK(44),CHECK(45)
     +     /9.532372098E-01, 9.609439355E-01, 9.664352927E-01,
     +      9.704497377E-01, 9.737257265E-01, 9.768786393E-01,
     +      9.800315521E-01, 9.831844649E-01, 9.863373777E-01/
      DATA CHECK(46),CHECK(47),CHECK(48),CHECK(49),CHECK(50),
     +     CHECK(51)
     +     /9.894902905E-01, 9.926011645E-01, 9.954598055E-01,
     +      9.978139804E-01, 9.994114563E-01, 1.000000000E+00/
C***FIRST EXECUTABLE STATEMENT  FCQX
      IF (KPRINT .GE. 2) WRITE (LUN,9000)
      IPASS = 1
C
C     Broadcast SDDATA(1) value to all of SDDATA(*).
C
      CALL SCOPY(NDATA,SDDATA,0,SDDATA,1)
      ZERO = 0
      ONE = 1
      NDEG = NORD - 1
C
C     Write the various constraints for the fitted curve.
C
      NCONST = 0
      T = BKPT(NORD)
C
C     Constrain function to be zero at left-most breakpoint.
C
      NCONST = NCONST + 1
      XCONST(NCONST) = T
      YCONST(NCONST) = ZERO
      NDERIV(NCONST) = 2 + 4*0
C
C     Constrain first derivative to be nonnegative at left-most
C     breakpoint.
C
      NCONST = NCONST + 1
      XCONST(NCONST) = T
      YCONST(NCONST) = ZERO
      NDERIV(NCONST) = 1 + 4*1
C
C     Constrain second derivatives to be nonnegative at left set of
C     breakpoints.
C
      DO 10 I = 1,3
        L = NDEG + I
        T = BKPT(L)
        NCONST = NCONST + 1
        XCONST(NCONST) = T
        YCONST(NCONST) = ZERO
        NDERIV(NCONST) = 1 + 4*2
   10 CONTINUE
C
C     Constrain function value at right-most breakpoint to be one.
C
      NCONST = NCONST + 1
      T = BKPT(LAST)
      XCONST(NCONST) = T
      YCONST(NCONST) = ONE
      NDERIV(NCONST) = 2 + 4*0
C
C     Constrain slope to agree at left- and right-most breakpoints.
C
      NCONST = NCONST + 1
      XCONST(NCONST) = BKPT(NORD)
      YCONST(NCONST) = BKPT(LAST)
      NDERIV(NCONST) = 3 + 4*1
C
C     Constrain second derivatives to be nonpositive at right set of
C     breakpoints.
C
      DO 20 I = 1,4
        NCONST = NCONST + 1
        L = LAST - 4 + I
        XCONST(NCONST) = BKPT(L)
        YCONST(NCONST) = ZERO
        NDERIV(NCONST) = 0 + 4*2
   20 CONTINUE
C
      IDIGIT = -4
C
      IF (KPRINT .GE. 3) THEN
        CALL SVOUT (NBKPT,BKPT,'('' ARRAY OF KNOTS.'')',IDIGIT)
        CALL SVOUT (NDATA,XDATA,
     +              '('' INDEPENDENT VARIABLE VALUES'')',IDIGIT)
        CALL SVOUT (NDATA,YDATA,'('' DEPENDENT VARIABLE VALUES'')',
     +              IDIGIT)
        CALL SVOUT (NDATA,SDDATA,
     +              '('' DEPENDENT VARIABLE UNCERTAINTY'')',IDIGIT)
        CALL SVOUT (NCONST,XCONST,
     +              '('' INDEPENDENT VARIABLE CONSTRAINT VALUES'')',
     +              IDIGIT)
        CALL SVOUT (NCONST,YCONST,'('' CONSTRAINT VALUES'')',IDIGIT)
        CALL IVOUT (NCONST,NDERIV,'('' CONSTRAINT INDICATOR'')',IDIGIT)
      ENDIF
C
C     Declare amount of working storage allocated to FC.
C
      IW(1) = 529
      IW(2) = 30
C
C     Set mode to indicate a new problem and request the variance
C     function.
C
      MODE = 2
C
C     Obtain the coefficients of the B-spline.
C
      CALL FC(NDATA,XDATA,YDATA,SDDATA,NORD,NBKPT,BKPT,NCONST,XCONST,
     +        YCONST,NDERIV,MODE,COEFF,W,IW)
C
C     Check coefficients.
C
      TOL = 7.0E0*SQRT(R1MACH(4))
      DIFF = 0.0E0
      DO 30 I = 1,NDATA
        DIFF = MAX(DIFF,ABS(COEFF(I)-COEFCK(I)))
   30 CONTINUE
      IF (DIFF .LE. TOL) THEN
        FATAL = .FALSE.
        IF (KPRINT .GE. 3) WRITE (LUN,9010)
      ELSE
        IPASS = 0
        FATAL = .TRUE.
        IF (KPRINT .GE. 2) WRITE (LUN,9020)
      ENDIF
C
      IF ((FATAL.AND.KPRINT.GE.2) .OR. KPRINT.GE.3) THEN
        CALL SVOUT (NDATA,COEFCK,
     +              '(/'' PREDICTED COEFFICIENTS OF THE B-SPLINE '//
     +              'FROM SAMPLE'')',IDIGIT)
        CALL SVOUT (NDATA,COEFF,
     +              '(/'' COEFFICIENTS OF THE B-SPLINE COMPUTED '//
     +              'BY FC'')',IDIGIT)
      ENDIF
C
C     Compute value, first two derivatives and probable uncertainty.
C
      N = NBKPT - NORD
      NVAL = 51
      DO 70 I = 1,NVAL
C
C       The function BVALU is in the de Boor B-spline package.
C
        XVAL = REAL(I-1)/(NVAL-1)
        II = 1
        DO 60 J = 1,3
          V(I,J+1) = BVALU(BKPT,COEFF,N,NORD,J-1,XVAL,II,WORK)
   60   CONTINUE
        V(I,1) = XVAL
C
C       The variance function CV is a companion subprogram to FC.
C
        V(I,5) = SQRT(CV(XVAL,NDATA,NCONST,NORD,NBKPT,BKPT,W))
   70 CONTINUE
C
      DIFF = 0.0E0
      DO 80 I = 1,NVAL
        DIFF = MAX(DIFF,ABS(V(I,2)-CHECK(I)))
   80 CONTINUE
      IF (DIFF .LE. TOL) THEN
        FATAL = .FALSE.
        IF (KPRINT .GE. 3) WRITE (LUN,9030)
      ELSE
        IPASS = 0
        FATAL = .TRUE.
        IF (KPRINT .GE. 2) WRITE (LUN,9040)
      ENDIF
C
      IF ((FATAL.AND.KPRINT.GE.2) .OR. KPRINT.GE.3) THEN
C
C       Print these values.
C
        CALL SMOUT(NVAL,5,NVAL,V,'(16X, ''X'', 10X, ''FNCN'', 8X,' //
     +             '''1ST D'', 7X, ''2ND D'', 7X, ''ERROR'')',IDIGIT)
        WRITE (LUN,9050)
      ENDIF
C
C     Trigger error conditions.
C
      CALL XGETF (KONTRL)
      IF (KPRINT .LE. 2) THEN
         CALL XSETF (0)
      ELSE
         CALL XSETF (1)
      ENDIF
      FATAL = .FALSE.
      CALL XERCLR
C
      IF (KPRINT .GE. 3) WRITE (LUN, 9060)
C
      CALL FC(NDATA,XDATA,YDATA,SDDATA,0,NBKPT,BKPT,NCONST,XCONST,
     +        YCONST,NDERIV,MODE,COEFF,W,IW)
      IF (NUMXER(NERR) .NE. 2) FATAL = .TRUE.
      CALL XERCLR
C
      CALL FC(NDATA,XDATA,YDATA,SDDATA,NORD,0,BKPT,NCONST,XCONST,
     +        YCONST,NDERIV,MODE,COEFF,W,IW)
      IF (NUMXER(NERR) .NE. 2) FATAL = .TRUE.
      CALL XERCLR
C
      CALL FC(-1,XDATA,YDATA,SDDATA,NORD,NBKPT,BKPT,NCONST,XCONST,
     +        YCONST,NDERIV,MODE,COEFF,W,IW)
      IF (NUMXER(NERR) .NE. 2) FATAL = .TRUE.
      CALL XERCLR
C
      MODE = 0
      CALL FC(NDATA,XDATA,YDATA,SDDATA,NORD,NBKPT,BKPT,NCONST,XCONST,
     +        YCONST,NDERIV,MODE,COEFF,W,IW)
      IF (NUMXER(NERR) .NE. 2) FATAL = .TRUE.
      CALL XERCLR
C
      IW(1) = 10
      CALL FC(NDATA,XDATA,YDATA,SDDATA,NORD,NBKPT,BKPT,NCONST,XCONST,
     +        YCONST,NDERIV,MODE,COEFF,W,IW)
      IF (NUMXER(NERR) .NE. 2) FATAL = .TRUE.
      CALL XERCLR
C
      IW(1) = 529
      IW(2) = 2
      CALL FC(NDATA,XDATA,YDATA,SDDATA,NORD,NBKPT,BKPT,NCONST,XCONST,
     +        YCONST,NDERIV,MODE,COEFF,W,IW)
      IF (NUMXER(NERR) .NE. 2) FATAL = .TRUE.
      CALL XERCLR
C
C     Restore KONTRL and check to see if the tests of error detection
C     passed.
C
      CALL XSETF (KONTRL)
      IF (FATAL) THEN
         IPASS = 0
         IF (KPRINT .GE. 2) THEN
            WRITE (LUN, 9070)
         ENDIF
      ELSE
         IF (KPRINT .GE. 3) THEN
            WRITE (LUN, 9080)
         ENDIF
      ENDIF
C
C     Print PASS/FAIL message.
C
      IF (IPASS.EQ.1 .AND. KPRINT.GE.2) WRITE (LUN,9100)
      IF (IPASS.EQ.0 .AND. KPRINT.GE.1) WRITE (LUN,9110)
      RETURN
C
 9000 FORMAT ('1' / ' Test FC')
 9010 FORMAT (/ ' FC PASSED TEST 1')
 9020 FORMAT (/ ' FC FAILED TEST 1')
 9030 FORMAT (/ ' FC (AND BVALU) PASSED TEST 2')
 9040 FORMAT (/ ' FC (AND BVALU) FAILED TEST 2')
 9050 FORMAT (/ ' VALUES SHOULD CORRESPOND TO THOSE IN ','SAND78-1291,',
     +        ' P. 26')
 9060 FORMAT (/ ' TRIGGER 6 ERROR MESSAGES',/)
 9070 FORMAT (' AT LEAST ONE INCORRECT ARGUMENT TEST FAILED')
 9080 FORMAT (' ALL INCORRECT ARGUMENT TESTS PASSED')
 9100 FORMAT (/' *****************FC PASSED ALL TESTS*****************')
 9110 FORMAT (/' ****************FC FAILED SOME TESTS*****************')
      END

*DECK QCRF
      SUBROUTINE QCRF (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  QCRF
C***PURPOSE  Quick check for RF.
C***LIBRARY   SLATEC
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Pexton, R. L., (LLNL)
C***DESCRIPTION
C
C            QUICK TEST FOR CARLSON INTEGRAL RF
C
C***ROUTINES CALLED  NUMXER, R1MACH, RF, XERCLR, XGETF, XSETF
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   890618  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   910708  Minor modifications in use of KPRINT.  (WRB)
C***END PROLOGUE  QCRF
      INTEGER KPRINT, IPASS, CONTRL, KONTRL, LUN, IER
      INTEGER IPASS1, IPASS2, IPASS3, IPASS4, NUMXER
      REAL ALEM, TRF, RF, DIF, R1MACH
      EXTERNAL NUMXER, R1MACH, RF, XERCLR, XGETF, XSETF
C***FIRST EXECUTABLE STATEMENT  QCRF
      CALL XERCLR
      CALL XGETF(CONTRL)
      IF ( KPRINT .GE. 3 ) THEN
         KONTRL = +1
      ELSE
         KONTRL = 0
      ENDIF
      CALL XSETF(KONTRL)
C
C  FORCE ERROR 1
C
      IF ( KPRINT .GE. 3 ) WRITE (LUN,101)
  101 FORMAT(' RF - FORCE ERROR 1 TO OCCUR')
      TRF = RF(-1.0E0,-1.0E0,-1.0E0,IER)
      IER = NUMXER(IER)
      IF ( IER .EQ. 1 ) THEN
         IPASS1 = 1
      ELSE
         IPASS1 = 0
      ENDIF
      CALL XERCLR
C
C  FORCE ERROR 2
C
      IF ( KPRINT .GE. 3 ) WRITE (LUN,102)
  102 FORMAT(' RF - FORCE ERROR 2 TO OCCUR')
      TRF = RF(R1MACH(1),R1MACH(1),R1MACH(1),IER)
      IER = NUMXER(IER)
      IF ( IER .EQ. 2 ) THEN
         IPASS2 = 1
      ELSE
         IPASS2 = 0
      ENDIF
      CALL XERCLR
C
C  FORCE ERROR 3
C
      IF ( KPRINT .GE. 3 ) WRITE (LUN,103)
  103 FORMAT(' RF - FORCE ERROR 3 TO OCCUR')
      TRF = RF(R1MACH(2),R1MACH(2),R1MACH(2),IER)
      IER = NUMXER(IER)
      IF ( IER .EQ. 3 ) THEN
         IPASS3 = 1
      ELSE
         IPASS3 = 0
      ENDIF
      CALL XERCLR
C
C  ARGUMENTS IN RANGE
C  ALEM=LEMNISCATE CONSTANT A
C
      ALEM = 1.311028777146059905E0
      TRF  = RF(0.0E0,1.0E0,2.0E0,IER)
      CALL XERCLR
      DIF  = TRF - ALEM
      IF ( (ABS(DIF/ALEM).LT.1000.0E0*R1MACH(4)).AND.(IER.EQ.0) ) THEN
         IPASS4 = 1
      ELSE
         IPASS4 = 0
      ENDIF
      IPASS = MIN(IPASS1,IPASS2,IPASS3,IPASS4)
      IF ( KPRINT .EQ. 0 ) THEN
         GO TO 999
      ELSEIF ( KPRINT .EQ. 1 ) THEN
         IF ( IPASS .EQ. 1 ) THEN
            GO TO 999
         ELSE
            WRITE (LUN,104)
  104       FORMAT(' RF - FAILED')
            GO TO 999
         ENDIF
      ELSE
         IF ( IPASS .EQ. 1 ) THEN
            WRITE (LUN,105)
  105       FORMAT(' RF - PASSED')
            GO TO 999
         ELSE
            WRITE (LUN,104)
            IF ( IPASS4 .EQ. 0 ) WRITE (LUN,106) ALEM, TRF, DIF
  106       FORMAT(' CORRECT ANSWER =', 1PE14.6 /
     *             'COMPUTED ANSWER =',   E14.6 /
     *             '     DIFFERENCE =',   E14.6 )
            GO TO 999
         ENDIF
      ENDIF
  999 CONTINUE
      CALL XSETF(CONTRL)
      RETURN
      END

*DECK SGEQC
      SUBROUTINE SGEQC (LUN, KPRINT, NERR)
C***BEGIN PROLOGUE  SGEQC
C***PURPOSE  Quick check for SGEFS and SGEIR.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SGEQC-S, DGEQC-D, CGEQC-C)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Jacobsen, Nancy, (LANL)
C***DESCRIPTION
C
C   Let A*X=B be a SINGLE PRECISION linear system where the
C   matrix is of the proper type for the Linpack subroutines
C   being called.  The values of A and B and the pre-computed
C   values of BXEX (the solution vector) are given in DATA
C   statements.  The computed test results for X are compared to
C   the stored pre-computed values.  Failure of the test occurs
C   when there is less than 80% agreement between the absolute
C   values.  There are 2 tests - one for the normal case and one
C   for the singular case.  A message is printed indicating
C   whether each subroutine has passed or failed for each case.
C
C   On return, NERR (INTEGER type) contains the total count of
C   all failures detected.
C
C***ROUTINES CALLED  R1MACH, SGEFS, SGEIR
C***REVISION HISTORY  (YYMMDD)
C   801022  DATE WRITTEN
C   891009  Removed unreferenced statement label.  (WRB)
C   891009  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920601  Code reworked and TYPE section added.  (RWC, WRB)
C***END PROLOGUE  SGEQC
C     .. Scalar Arguments ..
      INTEGER KPRINT, LUN, NERR
C     .. Local Scalars ..
      REAL ERRCMP, ERRMAX
      INTEGER I, IND, ITASK, J, KPROG, LDA, N
C     .. Local Arrays ..
      REAL A(5,4), ATEMP(5,4), B(4), BTEMP(4), BXEX(4), WORK(20)
      INTEGER IWORK(4)
      CHARACTER LIST(2)*4
C     .. External Functions ..
      REAL R1MACH
      EXTERNAL R1MACH
C     .. External Subroutines ..
      EXTERNAL SGEFS, SGEIR
C     .. Intrinsic Functions ..
      INTRINSIC ABS, MAX
C     .. Data statements ..
      DATA A /5.0E0,  1.0E0,  0.3E0, 2.1E0, 0.0E0,
     +       -1.0E0, -0.5E0,  1.0E0, 1.0E0, 0.0E0,
     +        4.5E0, -1.0E0, -1.7E0, 2.0E0, 0.0E0,
     +        0.5E0,  2.0E0,  0.6E0, 1.3E0, 0.0E0/
      DATA B /0.0E0, 3.5E0, 3.6E0, 2.4E0/
      DATA BXEX /0.10E+01, 0.10E+01, -0.10E+01, 0.10E+01/
      DATA LIST /'GEFS', 'GEIR'/
C***FIRST EXECUTABLE STATEMENT  SGEQC
      N = 4
      LDA = 5
      NERR = 0
      ERRCMP = R1MACH(4)**0.8E0
      IF (KPRINT .GE. 2) WRITE (LUN,9000)
C
      DO 180 KPROG=1,2
C
C     First test case - normal
C
        ITASK = 1
        DO 100 I=1,N
          BTEMP(I) = B(I)
  100   CONTINUE
        DO 120 J=1,N
          DO 110 I=1,N
            ATEMP(I,J) = A(I,J)
  110     CONTINUE
  120   CONTINUE
        IF (KPROG .EQ. 1) THEN
          CALL SGEFS (ATEMP, LDA, N, BTEMP, ITASK, IND, WORK, IWORK)
        ELSE
          CALL SGEIR (ATEMP, LDA, N, BTEMP, ITASK, IND, WORK, IWORK)
        ENDIF
        IF (IND .LT. 0) THEN
          IF (KPRINT .GE. 2) WRITE (LUN, FMT=9010) LIST(KPROG), IND
          NERR = NERR + 1
        ENDIF
C
C       Calculate error for first test
C
        ERRMAX = 0.0E0
C
        DO 130 I=1,N
          ERRMAX = MAX(ERRMAX,ABS(BTEMP(I)-BXEX(I)))
  130   CONTINUE
        IF (ERRCMP .GT. ERRMAX) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, FMT=9010) LIST(KPROG)
        ELSE
          IF (KPRINT .GE. 2) WRITE (LUN, FMT=9020) LIST(KPROG), ERRMAX
          NERR = NERR + 1
        ENDIF
C
C       Second test case - singular matrix
C
        ITASK = 1
        DO 140 I=1,N
          BTEMP(I) = B(I)
  140   CONTINUE
        DO 160 J=1,N
          DO 150 I=1,N
            ATEMP(I,J) = A(I,J)
  150     CONTINUE
  160   CONTINUE
        DO 170 J=1,N
          ATEMP(1,J) = 0.0E0
  170   CONTINUE
        IF (KPROG .EQ. 1) THEN
          CALL SGEFS (ATEMP, LDA, N, BTEMP, ITASK, IND, WORK, IWORK)
        ELSE
          CALL SGEIR (ATEMP, LDA, N, BTEMP, ITASK, IND, WORK, IWORK)
        ENDIF
        IF (IND .EQ. -4) THEN
          IF (KPRINT .GE. 3) WRITE (LUN, FMT=9030) LIST(KPROG)
        ELSE
          IF (KPRINT .GE. 2) WRITE (LUN, FMT=9040) LIST(KPROG), IND
          NERR = NERR + 1
        ENDIF
C
  180 CONTINUE
C
      IF (KPRINT.GE.3 .AND. NERR.EQ.0) WRITE (LUN,9050)
      IF (KPRINT.GE.2 .AND. NERR.NE.0) WRITE (LUN,9060)
      RETURN
C
 9000 FORMAT (//, 2X, 'SGEFS and SGEIR Quick Check' /)
 9010 FORMAT (/, 5X, 'S', A, ' Normal test PASSED')
 9020 FORMAT (/, 5X, 'S', A, ' Test FAILED, MAX ABS(ERROR) is', E13.5)
 9030 FORMAT (/, 5X, 'S', A, ' Singular test PASSED')
 9040 FORMAT (/, 5X, 'S', A, ' Singular test FAILED, IND=', I3)
 9050 FORMAT (/, 2X, 'SGEFS and SGEIR Quick Check PASSED' /)
 9060 FORMAT (/, 2X, 'SGEFS and SGEIR Quick Check FAILED' /)
      END

*DECK SCHKE2
      SUBROUTINE SCHKE2 (ISNUM, SRNAMT, NOUT, KPRINT, FATAL)
C***BEGIN PROLOGUE  SCHKE2
C***SUBSIDIARY
C***PURPOSE  Test the error exits from the Level 2 Blas.
C***LIBRARY   SLATEC (BLAS)
C***AUTHOR  Du Croz, J. J., (NAG)
C           Hanson, R. J., (SNLA)
C***DESCRIPTION
C
C  Tests the error exits from the Level 2 Blas.
C  ALPHA, BETA, A, X and Y should not need to be defined.
C
C  Auxiliary routine for test program for Level 2 Blas.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  CHKXER, SGBMV, SGEMV, SGER, SSBMV, SSPMV, SSPR,
C                    SSPR2, SSYMV, SSYR, SSYR2, STBMV, STBSV, STPMV,
C                    STPSV, STRMV, STRSV, XERCLR, XERDMP, XGETF, XSETF
C***REVISION HISTORY  (YYMMDD)
C   870810  DATE WRITTEN
C   910620  Modified to meet SLATEC code and prologue standards.  (BKS)
C***END PROLOGUE  SCHKE2
C     .. Scalar Arguments ..
      LOGICAL            FATAL
      INTEGER            ISNUM, KPRINT, NOUT
      CHARACTER*6        SRNAMT
C     .. Scalars in Common ..
      INTEGER            INFOT
C     .. Local Scalars ..
      REAL               ALPHA, BETA
      INTEGER            KONTRL
C     .. Local Arrays ..
      REAL               A( 1, 1), X( 1), Y( 1)
C     .. External Subroutines ..
      EXTERNAL           CHKXER, SGBMV, SGEMV, SGER, SSBMV, SSPMV, SSPR,
     $                   SSPR2, SSYMV, SSYR, SSYR2, STBMV, STBSV, STPMV,
     $                   STPSV, STRMV, STRSV
C***FIRST EXECUTABLE STATEMENT  SCHKE2
       CALL XGETF (KONTRL)
       IF (KPRINT .LE. 2) THEN
         CALL XSETF(0)
       ELSE
         CALL XSETF(1)
       ENDIF
      GO TO ( 10, 20, 30, 40, 50, 60, 70, 80,
     $        90, 100, 110, 120, 130, 140, 150,
     $        160 )ISNUM
  10  INFOT = 1
      CALL XERCLR
      CALL SGEMV( '/', 0, 0, ALPHA, A, 1, X, 1, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL SGEMV( 'N', -1, 0, ALPHA, A, 1, X, 1, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL SGEMV( 'N', 0, -1, ALPHA, A, 1, X, 1, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL SGEMV( 'N', 2, 0, ALPHA, A, 1, X, 1, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 8
      CALL XERCLR
      CALL SGEMV( 'N', 0, 0, ALPHA, A, 1, X, 0, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 11
      CALL XERCLR
      CALL SGEMV( 'N', 0, 0, ALPHA, A, 1, X, 1, BETA, Y, 0 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      GO TO 170
   20 INFOT = 1
      CALL XERCLR
      CALL SGBMV( '/', 0, 0, 0, 0, ALPHA, A, 1, X, 1, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL SGBMV( 'N', -1, 0, 0, 0, ALPHA, A, 1, X, 1, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL SGBMV( 'N', 0, -1, 0, 0, ALPHA, A, 1, X, 1, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL SGBMV( 'N', 0, 0, -1, 0, ALPHA, A, 1, X, 1, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL SGBMV( 'N', 2, 0, 0, -1, ALPHA, A, 1, X, 1, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 8
      CALL XERCLR
      CALL SGBMV( 'N', 0, 0, 1, 0, ALPHA, A, 1, X, 1, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 10
      CALL XERCLR
      CALL SGBMV( 'N', 0, 0, 0, 0, ALPHA, A, 1, X, 0, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 13
      CALL XERCLR
      CALL SGBMV( 'N', 0, 0, 0, 0, ALPHA, A, 1, X, 1, BETA, Y, 0 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      GO TO 170
   30 INFOT = 1
      CALL XERCLR
      CALL SSYMV( '/', 0, ALPHA, A, 1, X, 1, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL SSYMV( 'U', -1, ALPHA, A, 1, X, 1, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL SSYMV( 'U', 2, ALPHA, A, 1, X, 1, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL SSYMV( 'U', 0, ALPHA, A, 1, X, 0, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 10
      CALL XERCLR
      CALL SSYMV( 'U', 0, ALPHA, A, 1, X, 1, BETA, Y, 0 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      GO TO 170
   40 INFOT = 1
      CALL XERCLR
      CALL SSBMV( '/', 0, 0, ALPHA, A, 1, X, 1, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL SSBMV( 'U', -1, 0, ALPHA, A, 1, X, 1, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL SSBMV( 'U', 0, -1, ALPHA, A, 1, X, 1, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL SSBMV( 'U', 0, 1, ALPHA, A, 1, X, 1, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 8
      CALL XERCLR
      CALL SSBMV( 'U', 0, 0, ALPHA, A, 1, X, 0, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 11
      CALL XERCLR
      CALL SSBMV( 'U', 0, 0, ALPHA, A, 1, X, 1, BETA, Y, 0 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      GO TO 170
   50 INFOT = 1
      CALL XERCLR
      CALL SSPMV( '/', 0, ALPHA, A, X, 1, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL SSPMV( 'U', -1, ALPHA, A, X, 1, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL SSPMV( 'U', 0, ALPHA, A, X, 0, BETA, Y, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL SSPMV( 'U', 0, ALPHA, A, X, 1, BETA, Y, 0 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      GO TO 170
   60 INFOT = 1
      CALL XERCLR
      CALL STRMV( '/', 'N', 'N', 0, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL STRMV( 'U', '/', 'N', 0, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL STRMV( 'U', 'N', '/', 0, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL STRMV( 'U', 'N', 'N', -1, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL STRMV( 'U', 'N', 'N', 2, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 8
      CALL XERCLR
      CALL STRMV( 'U', 'N', 'N', 0, A, 1, X, 0 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      GO TO 170
   70 INFOT = 1
      CALL XERCLR
      CALL STBMV( '/', 'N', 'N', 0, 0, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL STBMV( 'U', '/', 'N', 0, 0, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL STBMV( 'U', 'N', '/', 0, 0, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL STBMV( 'U', 'N', 'N', -1, 0, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL STBMV( 'U', 'N', 'N', 0, -1, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL STBMV( 'U', 'N', 'N', 0, 1, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL STBMV( 'U', 'N', 'N', 0, 0, A, 1, X, 0 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      GO TO 170
   80 INFOT = 1
      CALL XERCLR
      CALL STPMV( '/', 'N', 'N', 0, A, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL STPMV( 'U', '/', 'N', 0, A, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL STPMV( 'U', 'N', '/', 0, A, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL STPMV( 'U', 'N', 'N', -1, A, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL STPMV( 'U', 'N', 'N', 0, A, X, 0 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      GO TO 170
   90 INFOT = 1
      CALL XERCLR
      CALL STRSV( '/', 'N', 'N', 0, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL STRSV( 'U', '/', 'N', 0, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL STRSV( 'U', 'N', '/', 0, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL STRSV( 'U', 'N', 'N', -1, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 6
      CALL XERCLR
      CALL STRSV( 'U', 'N', 'N', 2, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 8
      CALL XERCLR
      CALL STRSV( 'U', 'N', 'N', 0, A, 1, X, 0 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      GO TO 170
  100 INFOT = 1
      CALL XERCLR
      CALL STBSV( '/', 'N', 'N', 0, 0, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL STBSV( 'U', '/', 'N', 0, 0, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL STBSV( 'U', 'N', '/', 0, 0, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL STBSV( 'U', 'N', 'N', -1, 0, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL STBSV( 'U', 'N', 'N', 0, -1, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL STBSV( 'U', 'N', 'N', 0, 1, A, 1, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL STBSV( 'U', 'N', 'N', 0, 0, A, 1, X, 0 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      GO TO 170
  110 INFOT = 1
      CALL XERCLR
      CALL STPSV( '/', 'N', 'N', 0, A, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL STPSV( 'U', '/', 'N', 0, A, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 3
      CALL XERCLR
      CALL STPSV( 'U', 'N', '/', 0, A, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 4
      CALL XERCLR
      CALL STPSV( 'U', 'N', 'N', -1, A, X, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL STPSV( 'U', 'N', 'N', 0, A, X, 0 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      GO TO 170
  120 INFOT = 1
      CALL XERCLR
      CALL SGER( -1, 0, ALPHA, X, 1, Y, 1, A, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL SGER( 0, -1, ALPHA, X, 1, Y, 1, A, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL SGER( 0, 0, ALPHA, X, 0, Y, 1, A, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL SGER( 0, 0, ALPHA, X, 1, Y, 0, A, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL SGER( 2, 0, ALPHA, X, 1, Y, 1, A, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      GO TO 170
  130 INFOT = 1
      CALL XERCLR
      CALL SSYR( '/', 0, ALPHA, X, 1, A, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL SSYR( 'U', -1, ALPHA, X, 1, A, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL SSYR( 'U', 0, ALPHA, X, 0, A, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL SSYR( 'U', 2, ALPHA, X, 1, A, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      GO TO 170
  140 INFOT = 1
      CALL XERCLR
      CALL SSPR( '/', 0, ALPHA, X, 1, A )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL SSPR( 'U', -1, ALPHA, X, 1, A )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL SSPR( 'U', 0, ALPHA, X, 0, A )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      GO TO 170
  150 INFOT = 1
      CALL XERCLR
      CALL SSYR2( '/', 0, ALPHA, X, 1, Y, 1, A, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL SSYR2( 'U', -1, ALPHA, X, 1, Y, 1, A, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL SSYR2( 'U', 0, ALPHA, X, 0, Y, 1, A, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL SSYR2( 'U', 0, ALPHA, X, 1, Y, 0, A, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 9
      CALL XERCLR
      CALL SSYR2( 'U', 2, ALPHA, X, 1, Y, 1, A, 1 )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      GO TO 170
  160 INFOT = 1
      CALL XERCLR
      CALL SSPR2( '/', 0, ALPHA, X, 1, Y, 1, A )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 2
      CALL XERCLR
      CALL SSPR2( 'U', -1, ALPHA, X, 1, Y, 1, A )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 5
      CALL XERCLR
      CALL SSPR2( 'U', 0, ALPHA, X, 0, Y, 1, A )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
      INFOT = 7
      CALL XERCLR
      CALL SSPR2( 'U', 0, ALPHA, X, 1, Y, 0, A )
      CALL CHKXER( SRNAMT, INFOT, NOUT, FATAL, KPRINT )
C
 170  IF (KPRINT .GE. 2) THEN
        CALL XERDMP
        IF(.NOT.FATAL) THEN
           WRITE( NOUT, FMT = 9999 )SRNAMT
        ELSE
           WRITE( NOUT, FMT = 9998 )SRNAMT
        END IF
      ENDIF
      CALL XSETF (KONTRL)
      RETURN
C
 9999 FORMAT( ' ', A6, ' PASSED THE TESTS OF ERROR-EXITS' )
 9998 FORMAT( ' ******* ', A6, ' FAILED THE TESTS OF ERROR-EXITS *****',
     $      '**' )
C
C     End of SCHKE2.
C
      END

*DECK F1P
      REAL FUNCTION F1P (X)
C***BEGIN PROLOGUE  F1P
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F1P
      REAL ALFA1,ALFA2,P1,P2,X,D1,D2
C  P1 = 1/7, P2 = 2/3
      DATA P1/0.1428571428571428E+00/
      DATA P2/0.6666666666666667E+00/
C***FIRST EXECUTABLE STATEMENT  F1P
      ALFA1 = -0.25E0
      ALFA2 = -0.5E0
      D1=ABS(X-P1)
      D2=ABS(X-P2)
      F1P = 0.0E+00
      IF(D1.NE.0.0E+00.AND.D2.NE.0.0E+00) F1P = D1**ALFA1+D2**ALFA2
      RETURN
      END

*DECK SQJAC2
      SUBROUTINE SQJAC2 (N, X, FVEC, FJAC, LDFJAC, IFLAG)
C***BEGIN PROLOGUE  SQJAC2
C***PURPOSE  Evaluate full Jacobian for SNSQE test.
C***LIBRARY   SLATEC
C***KEYWORDS  QUICK CHECK
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     SUBROUTINE TO EVALUATE THE FULL JACOBIAN FOR TEST PROBLEM USED
C     IN QUICK CHECK OF SNSQE.
C
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  SQJAC2
      DIMENSION X(*),FVEC(*),FJAC(LDFJAC,*)
C***FIRST EXECUTABLE STATEMENT  SQJAC2
      FJAC(1,1)=-1.E0
      FJAC(1,2)=0.E0
      FJAC(2,1)=-2.E1*X(1)
      FJAC(2,2)=1.E1
      RETURN
      END

*DECK DT2
      DOUBLE PRECISION FUNCTION DT2 (X)
C***BEGIN PROLOGUE  DT2
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  DF2S
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  DT2
      DOUBLE PRECISION A,B,DF2S,X,X1,Y
C***FIRST EXECUTABLE STATEMENT  DT2
      A = 0.1D+00
      B = 0.1D+01
      X1 = X+0.1D+01
      Y = (B-A)/X1+A
      DT2 = (B-A)*DF2S(Y)/X1/X1
      RETURN
      END

*DECK SNLS1Q
      SUBROUTINE SNLS1Q (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  SNLS1Q
C***PURPOSE  Quick check for SNLS1E, SNLS1 and SCOV.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SNLS1Q-S, DNLS1Q-D)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C   This subroutine performs a quick check on the subroutines SNLS1E
C   (and SNLS1) and SCOV.
C
C***ROUTINES CALLED  ENORM, FCN1, FCN2, FCN3, FDJAC3, PASS, R1MACH,
C                    SCOV, SNLS1E
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890911  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   930214  Declarations sections added, code revised to test error
C           returns for all values of KPRINT and code polished.  (WRB)
C***END PROLOGUE  SNLS1Q
C     .. Scalar Arguments ..
      INTEGER IPASS, KPRINT, LUN
C     .. Local Scalars ..
      REAL FNORM, FNORMS, ONE, SIGMA, TEMP1, TEMP2, TEMP3, TOL, TOL2,
     +     ZERO
      INTEGER I, IFLAG, INFO, INFOS, IOPT, KONTRL, LDFJAC, LWA, M, N,
     +        NERR, NPRINT
      LOGICAL FATAL
C     .. Local Arrays ..
      REAL FJAC(10,2), FJROW(2), FJTJ(3), FVEC(10), WA(40), X(2)
      INTEGER IW(2)
C     .. External Functions ..
      REAL ENORM, R1MACH
      INTEGER NUMXER
      EXTERNAL ENORM, NUMXER, R1MACH
C     .. External Subroutines ..
      EXTERNAL FCN1, FCN2, FCN3, FDJAC3, PASS, SCOV, SNLS1E, XGETF,
     +         XSETF
C     .. Intrinsic Functions ..
      INTRINSIC ABS, SQRT
C***FIRST EXECUTABLE STATEMENT  SNLS1Q
      IF (KPRINT .GE. 2) WRITE (LUN,9000)
C
      IPASS = 1
      INFOS = 1
      FNORMS = 1.1151779E+01
      M = 10
      N = 2
      LWA = 40
      LDFJAC = 10
      NPRINT = -1
      IFLAG = 1
      ZERO = 0.0E0
      ONE = 1.0E0
      TOL = SQRT(40.0E0*R1MACH(4))
      TOL2 = SQRT(TOL)
C
C     OPTION=2, the full Jacobian is stored and the user provides the
C     Jacobian.
C
      IOPT = 2
      X(1) = 3.0E-1
      X(2) = 4.0E-1
      CALL SNLS1E(FCN2,IOPT,M,N,X,FVEC,TOL,NPRINT,INFO,IW,WA,LWA)
      FNORM = ENORM(M,FVEC)
      IF (INFO.EQ.INFOS .AND. ABS(FNORM-FNORMS)/FNORMS.LE.TOL) THEN
        FATAL = .FALSE.
        IF (KPRINT .GE. 3) CALL PASS(LUN,1,1)
      ELSE
        IPASS = 0
        FATAL = .TRUE.
        IF (KPRINT .GE. 2) CALL PASS(LUN,1,0)
      ENDIF
      IF ((FATAL.AND.KPRINT.GE.2) .OR. KPRINT.GE.3)
     +   WRITE (LUN,9010) INFOS,FNORMS,INFO,FNORM
C
C     Form JAC-transpose*JAC.
C
      SIGMA = FNORM*FNORM/(M-N)
      IFLAG = 2
      CALL FCN2(IFLAG,M,N,X,FVEC,FJAC,LDFJAC)
      DO 20 I = 1,3
        FJTJ(I) = ZERO
   20 CONTINUE
      DO 30 I = 1,M
        FJTJ(1) = FJTJ(1) + FJAC(I,1)**2
        FJTJ(2) = FJTJ(2) + FJAC(I,1)*FJAC(I,2)
        FJTJ(3) = FJTJ(3) + FJAC(I,2)**2
   30 CONTINUE
C
C     Calculate the covariance matrix.
C
      CALL SCOV(FCN2,IOPT,M,N,X,FVEC,FJAC,LDFJAC,INFO,WA(1),WA(N+1),
     +          WA(2*N+1),WA(3*N+1))
C
C     Form JAC-transpose*JAC * covariance matrix (should = SIGMA*I).
C
      TEMP1 = (FJTJ(1)*FJAC(1,1)+FJTJ(2)*FJAC(1,2))/SIGMA
      TEMP2 = (FJTJ(1)*FJAC(1,2)+FJTJ(2)*FJAC(2,2))/SIGMA
      TEMP3 = (FJTJ(2)*FJAC(1,2)+FJTJ(3)*FJAC(2,2))/SIGMA
      IF (INFO.EQ.INFOS .AND. ABS(TEMP1-ONE).LT.TOL2 .AND.
     +    ABS(TEMP2).LT.TOL2 .AND. ABS(TEMP3-ONE).LT.TOL2) THEN
        FATAL = .FALSE.
        IF (KPRINT .GE. 3) CALL PASS(LUN,2,1)
      ELSE
        IPASS = 0
        FATAL = .TRUE.
        IF (KPRINT .GE. 2) CALL PASS(LUN,2,0)
      ENDIF
      IF ((FATAL.AND.KPRINT.GE.2) .OR. KPRINT.GE.3)
     +  WRITE (LUN,9020) INFOS,INFO,TEMP1,TEMP2,TEMP3
C
C     OPTION=1, the full Jacobian is stored and the code approximates
C     the Jacobian.
C
      IOPT = 1
      X(1) = 3.0E-1
      X(2) = 4.0E-1
      CALL SNLS1E(FCN1,IOPT,M,N,X,FVEC,TOL,NPRINT,INFO,IW,WA,LWA)
      FNORM = ENORM(M,FVEC)
      IF (INFO.EQ.INFOS .AND. ABS(FNORM-FNORMS)/FNORMS.LE.TOL) THEN
        FATAL = .FALSE.
        IF (KPRINT .GE. 3) CALL PASS(LUN,3,1)
      ELSE
        IPASS = 0
        FATAL = .TRUE.
        IF (KPRINT .GE. 2) CALL PASS(LUN,3,0)
      ENDIF
      IF ((FATAL.AND.KPRINT.GE.2) .OR. KPRINT.GE.3)
     +  WRITE (LUN,9010) INFOS,FNORMS,INFO,FNORM
C
C     Form JAC-transpose*JAC.
C
      SIGMA = FNORM*FNORM/(M-N)
      IFLAG = 1
      CALL FDJAC3(FCN1,M,N,X,FVEC,FJAC,LDFJAC,IFLAG,ZERO,WA)
      DO 60 I = 1,3
        FJTJ(I) = ZERO
   60 CONTINUE
      DO 70 I = 1,M
        FJTJ(1) = FJTJ(1) + FJAC(I,1)**2
        FJTJ(2) = FJTJ(2) + FJAC(I,1)*FJAC(I,2)
        FJTJ(3) = FJTJ(3) + FJAC(I,2)**2
   70 CONTINUE
C
C     Calculate the covariance matrix.
C
      CALL SCOV(FCN1,IOPT,M,N,X,FVEC,FJAC,LDFJAC,INFO,WA(1),WA(N+1),
     +          WA(2*N+1),WA(3*N+1))
C
C     Form JAC-transpose*JAC * covariance matrix (should = SIGMA*I).
C
      TEMP1 = (FJTJ(1)*FJAC(1,1)+FJTJ(2)*FJAC(1,2))/SIGMA
      TEMP2 = (FJTJ(1)*FJAC(1,2)+FJTJ(2)*FJAC(2,2))/SIGMA
      TEMP3 = (FJTJ(2)*FJAC(1,2)+FJTJ(3)*FJAC(2,2))/SIGMA
      IF (INFO.EQ.INFOS .AND. ABS(TEMP1-ONE).LT.TOL2 .AND.
     +    ABS(TEMP2).LT.TOL2 .AND. ABS(TEMP3-ONE).LT.TOL2) THEN
        FATAL = .FALSE.
        IF (KPRINT .GE. 3) CALL PASS(LUN,4,1)
      ELSE
        IPASS = 0
        FATAL = .TRUE.
        IF (KPRINT .GE. 2) CALL PASS(LUN,4,0)
      ENDIF
      IF ((FATAL .AND.KPRINT.GE.2) .OR. KPRINT.GE.3)
     +  WRITE (LUN,9020) INFOS,INFO,TEMP1,TEMP2,TEMP3
C
C     OPTION=3, the full Jacobian is not stored.  Only the product of
C     the Jacobian transpose and Jacobian is stored.  The user provides
C     the Jacobian one row at a time.
C
      IOPT = 3
      X(1) = 3.0E-1
      X(2) = 4.0E-1
      CALL SNLS1E(FCN3,IOPT,M,N,X,FVEC,TOL,NPRINT,INFO,IW,WA,LWA)
      FNORM = ENORM(M,FVEC)
      IF (INFO.EQ.INFOS .AND. ABS(FNORM-FNORMS)/FNORMS.LE.TOL) THEN
        FATAL = .FALSE.
        IF (KPRINT .GE. 3) CALL PASS(LUN,5,1)
      ELSE
        IPASS = 0
        FATAL = .TRUE.
        IF (KPRINT .GE. 2) CALL PASS(LUN,5,0)
      ENDIF
      IF ((FATAL.AND.KPRINT.GE.2) .OR. KPRINT.GE.3)
     +  WRITE (LUN,9010) INFOS,FNORMS,INFO,FNORM
C
C     Form JAC-transpose*JAC.
C
      SIGMA = FNORM*FNORM/(M-N)
      DO 100 I = 1,3
        FJTJ(I) = ZERO
  100 CONTINUE
      IFLAG = 3
      DO 110 I = 1,M
        CALL FCN3(IFLAG,M,N,X,FVEC,FJROW,I)
        FJTJ(1) = FJTJ(1) + FJROW(1)**2
        FJTJ(2) = FJTJ(2) + FJROW(1)*FJROW(2)
        FJTJ(3) = FJTJ(3) + FJROW(2)**2
  110 CONTINUE
C
C     Calculate the covariance matrix.
C
      CALL SCOV(FCN3,IOPT,M,N,X,FVEC,FJAC,LDFJAC,INFO,WA(1),WA(N+1),
     +          WA(2*N+1),WA(3*N+1))
C
C     Form JAC-transpose*JAC * covariance matrix (should = SIGMA*I).
C
      TEMP1 = (FJTJ(1)*FJAC(1,1)+FJTJ(2)*FJAC(1,2))/SIGMA
      TEMP2 = (FJTJ(1)*FJAC(1,2)+FJTJ(2)*FJAC(2,2))/SIGMA
      TEMP3 = (FJTJ(2)*FJAC(1,2)+FJTJ(3)*FJAC(2,2))/SIGMA
      IF (INFO.EQ.INFOS .AND. ABS(TEMP1-ONE).LT.TOL2 .AND.
     +    ABS(TEMP2).LT.TOL2 .AND. ABS(TEMP3-ONE).LT.TOL2) THEN
        FATAL = .FALSE.
        IF (KPRINT .GE. 3) CALL PASS(LUN,6,1)
      ELSE
        IPASS = 0
        FATAL = .TRUE.
        IF (KPRINT .GE. 2) CALL PASS(LUN,6,0)
      ENDIF
      IF ((FATAL.AND.KPRINT.GE.2) .OR. KPRINT.GE.3)
     +  WRITE (LUN,9020) INFOS,INFO,TEMP1,TEMP2,TEMP3
C
C     Test improper input parameters.
C
      CALL XGETF (KONTRL)
      IF (KPRINT .LE. 2) THEN
         CALL XSETF (0)
      ELSE
         CALL XSETF (1)
      ENDIF
      FATAL = .FALSE.
      CALL XERCLR
C
      IF (KPRINT .GE. 3) WRITE (LUN, 9060)
C
      LWA = 35
      IOPT = 2
      X(1) = 3.0E-1
      X(2) = 4.0E-1
      CALL SNLS1E(FCN2,IOPT,M,N,X,FVEC,TOL,NPRINT,INFO,IW,WA,LWA)
      IF (INFO.NE.0 .OR. NUMXER(NERR).NE.2) FATAL = .TRUE.
C
      M = 0
      CALL SCOV(FCN2,IOPT,M,N,X,FVEC,FJAC,LDFJAC,INFO,WA(1),WA(N+1),
     +          WA(2*N+1),WA(3*N+1))
      IF (INFO.NE.0 .OR. NUMXER(NERR).NE.2) FATAL = .TRUE.
C
C     Restore KONTRL and check to see if the tests of error detection
C     passed.
C
      CALL XSETF (KONTRL)
      IF (FATAL) THEN
         IPASS = 0
         IF (KPRINT .GE. 2) THEN
            WRITE (LUN, 9070)
         ENDIF
      ELSE
         IF (KPRINT .GE. 3) THEN
            WRITE (LUN, 9080)
         ENDIF
      ENDIF
C
C     Print PASS/FAIL message.
C
      IF (IPASS.EQ.1 .AND. KPRINT.GE.2) WRITE (LUN,9100)
      IF (IPASS.EQ.0 .AND. KPRINT.GE.1) WRITE (LUN,9110)
C
  130 RETURN
C
 9000 FORMAT ('1' / ' Test SNLS1E, SNLS1 and SCOV')
 9010 FORMAT (' EXPECTED VALUE OF INFO AND RESIDUAL NORM', I5, E20.9 /
     +        ' RETURNED VALUE OF INFO AND RESIDUAL NORM', I5, E20.9 /)
 9020 FORMAT (' EXPECTED AND RETURNED VALUE OF INFO', I5, 10X, I5 /
     +        ' RETURNED PRODUCT OF (J-TRANS*J)*COVARIANCE MATRIX/SIGMA'
     +        / ' (SHOULD = THE IDENTITY -- 1.0, 0.0, 1.0)' / 3E20.9 /)
 9060 FORMAT (/ ' TRIGGER 2 ERROR MESSAGES',/)
 9070 FORMAT (' AT LEAST ONE INCORRECT ARGUMENT TEST FAILED')
 9080 FORMAT (' ALL INCORRECT ARGUMENT TESTS PASSED')
 9100 FORMAT (/' *************SNLS1E PASSED ALL TESTS*****************')
 9110 FORMAT (/' ************SNLS1E FAILED SOME TESTS*****************')
      END

*DECK SRMGEN
      SUBROUTINE SRMGEN (NELTMX, FACTOR, IERR, N, NELT, ISYM, IA, JA, A,
     $   F, SOLN, DSUM, ITMP, IDIAG)
C***BEGIN PROLOGUE  SRMGEN
C***SUBSIDIARY
C***PURPOSE  This routine generates a "Random" symmetric or
C            non-symmetric matrix of size N for use in the SLAP
C            Quick Checks.
C***LIBRARY   SLATEC (SLAP)
C***TYPE      SINGLE PRECISION (SRMGEN-S, DRMGEN-D)
C***AUTHOR  Seager, Mark K., (LLNL)
C             seager@llnl.gov
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-300
C             Livermore, CA 94550
C             (510) 423-3141
C***DESCRIPTION
C
C *Usage:
C       INTEGER NELTMX, IERR, N, NELT, ISYM,
C       INTEGER IA(NELTMX), JA(NELTMX), ITMP(N), IDIAG(N)
C       REAL    FACTOR, A(NELTMX), F(N), SOLN(N), DSUM(N)
C
C       CALL SRMGEN( NELTMX, FACTOR, IERR, N, NELT, ISYM,
C      $     IA, JA, A, F, SOLN, DSUM, ITMP, IDIAG )
C
C *Arguments:
C
C NELTMX :IN       Integer.
C         Maximum number of non-zeros that can be created by this
C         routine for storage in the IA, JA, A arrays,  see below.
C FACTOR :IN       Real.
C         Non-zeros in the upper triangle are set to FACTOR times
C         the corresponding entry in the lower triangle when a non-
C         symmetric matrix is requested (See ISYM, below).
C IERR   :OUT      Integer.
C         Return error flag.
C             IERR = 0 => everything went OK.
C                  = 1 => Ran out of space trying to create matrix.
C                         Set NELTMX to something larger and retry.
C N      :IN       Integer.
C         Size of the linear system to generate (number of unknowns).
C NELT   :OUT      Integer.
C         Number of non-zeros stored in the IA, JA, A arrays, see below.
C ISYM   :IN       Integer.
C         Flag to indicate the type of matrix to generate:
C             ISYM = 0 => Non-Symmetric Matrix (See FACTOR, above).
C                  = 1 => Symmetric Matrix.
C IA     :OUT      Integer IA(NELTMX).
C         Stores the row indices for the non-zeros.
C JA     :OUT      Integer JA(NELTMX).
C         Stores the column indices for the non-zeros.
C A      :OUT      Real A(NELTMX).
C         Stores the values of the non-zeros.
C F      :OUT      Real F(N).
C         The right hand side of the linear system.  Obtained by
C         multiplying the matrix times SOLN, see below.
C SOLN   :OUT      Real SOLN(N).
C         The true solution to the linear system.  Each component is
C         chosen at random (0.0<SOLN(I)<1.0, I=1,N)
C DSUM   :WORK     Real DSUM(N).
C ITMP   :WORK     Integer ITMP(N).
C IDIAG  :WORK     Integer IDIAG(N).
C
C *Description
C         The matrix is generated by choosing a random number of
C         entries for each column and then chosing negative random
C         numbers for each off diagonal.   The diagonal elements
C         are chosen to be positive and large enough so the matrix
C         is slightly diagonally dominant.  The lower triangle of
C         the matrix is generated and if isym.eq.0 (all matrix elements
C         stored) the upper triangle elements are chosen so that they
C         are FACTOR times the corresponding lower triangular element.
C
C***ROUTINES CALLED  ISMPL, RAND
C***REVISION HISTORY  (YYMMDD)
C   881120  DATE WRITTEN
C   890919  Replaced SMPL with ISMPL.  (MKS)
C   890920  Minor changes to reduce single/double differences.  (FNF)
C   920511  Added complete declaration section.  (WRB)
C***END PROLOGUE  SRMGEN
C     .. Scalar Arguments ..
      REAL FACTOR
      INTEGER IERR, ISYM, N, NELT, NELTMX
C     .. Array Arguments ..
      REAL A(NELTMX), DSUM(N), F(N), SOLN(N)
      INTEGER IA(NELTMX), IDIAG(N), ITMP(N), JA(NELTMX)
C     .. Local Scalars ..
      REAL DUMMY
      INTEGER I, ICOL, INUM, IROW, ISEED, K, NL
C     .. External Functions ..
      REAL RAND
      EXTERNAL RAND
C     .. External Subroutines ..
      EXTERNAL ISMPL
C     .. Intrinsic Functions ..
      INTRINSIC INT
C***FIRST EXECUTABLE STATEMENT  SRMGEN
C
C     Start by setting the random number generator seed.  This is done
C     for reproducibility in debugging.
C
C     Remove the seed setting call for production testing.
C
C     Note:  Double precision version did not work properly with
C            certain compilers with literal arguments to RAND.
C
      DUMMY = 16381.0
      ISEED = RAND( DUMMY )
      IERR = 0
      DO 10 I = 1, N
         IDIAG(I) = 0
         DSUM(I) = -1.0E0
 10   CONTINUE
      DUMMY = 0.0
      NELT = 0
C
C     Set the matrix elements.
C     Loop over the columns.
C
CVD$ NOCONCUR
      DO 30 ICOL = 1, N
         NL = N+1-ICOL
C
C         To keep things sparse divide by two, three or four or ...
C
         INUM = (INT( RAND(DUMMY)*NL ) + 1)/3
         CALL ISMPL( NL, INUM, ITMP )
C
C         Set up this column (and row, if non-symmetric structure).
CVD$ NOVECTOR
CVD$ NOCONCUR
         DO 20 IROW = 1, INUM
            NELT = NELT + 1
            IF( NELT.GT.NELTMX ) THEN
               IERR = 1
               RETURN
            ENDIF
            IA(NELT) = N+1-ITMP(IROW)
            JA(NELT) = ICOL
            IF( IA(NELT).EQ.ICOL ) THEN
               IDIAG(ICOL) = NELT
            ELSE
               A(NELT) = -RAND(DUMMY)
               DSUM(ICOL) = DSUM(ICOL) + A(NELT)
               IF( ISYM.EQ.0 ) THEN
C
C         Copy this element into upper triangle.
C
                  NELT = NELT + 1
                  IF( NELT.GT.NELTMX ) THEN
                     IERR = 1
                     RETURN
                  ENDIF
                  IA(NELT) = ICOL
                  JA(NELT) = IA(NELT-1)
                  A(NELT)  = A(NELT-1)*FACTOR
                  DSUM(JA(NELT)) = DSUM(JA(NELT)) + A(NELT)
               ELSE
                  DSUM(IA(NELT)) = DSUM(IA(NELT)) + A(NELT)
               ENDIF
            ENDIF
 20      CONTINUE
         IF( IDIAG(ICOL).EQ.0 ) THEN
C
C           Add a diagonal to the column.
C
            NELT = NELT + 1
            IF( NELT.GT.NELTMX ) THEN
               IERR = 1
               RETURN
            ENDIF
            IDIAG(ICOL) = NELT
            A(NELT) = 0.0E0
            IA(NELT) = ICOL
            JA(NELT) = ICOL
         ENDIF
 30   CONTINUE
C
C         Clean up the diagonals.
C
CVD$ NODEPCHK
CLLL. OPTION ASSERT (NOHAZARD)
CDIR$ IVDEP
      DO 40 I = 1, N
         A(IDIAG(I)) = -1.0001E0*DSUM(I)
 40   CONTINUE
C
C         Set a random solution and determine the right-hand side.
C
CVD$ NOVECTOR
CVD$ NOCONCUR
      DO 50 I = 1, N
         SOLN(I) = RAND(DUMMY)
         F(I) = 0.0E0
 50   CONTINUE
C
CVD$ NOVECTOR
CVD$ NOCONCUR
      DO 60 K = 1, NELT
         F(IA(K)) = F(IA(K)) + A(K)*SOLN(JA(K))
         IF( ISYM.NE.0 .AND. IA(K).NE.JA(K) ) THEN
            F(JA(K)) = F(JA(K)) + A(K)*SOLN(IA(K))
         ENDIF
 60   CONTINUE
      RETURN
C------------- LAST LINE OF SRMGEN FOLLOWS ----------------------------
      END

*DECK FCNQX1
      SUBROUTINE FCNQX1 (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  FCNQX1
C***SUBSIDIARY
C***PURPOSE  THIS IS A QUICK CHECK PROGRAM FOR THE SUBROUTINES XLEGF
C            AND XNRMP WHICH CALCULATE LEGENDRE FUNCTIONS
C***LIBRARY   SLATEC
C***CATEGORY  C3A2, C9
C***TYPE      SINGLE PRECISION (FCNQX1-S, FCNQX2-D)
C***KEYWORDS  LEGENDRE FUNCTIONS, QUICK CHECK
C***AUTHOR  LOZIER, DANIEL W., (NIST)
C           SMITH, JOHN M., (NIST AND GEORGE MASON UNIVERSITY)
C***REFERENCES  OLVER AND SMITH,J.COMPUT.PHYSICS,51(1983),NO.3,502-518.
C               SMITH, OLVER AND LOZIER,ACM TRANS MATH SOFTW,7(1981),
C                 NO.1,93-105.
C***ROUTINES CALLED  XCON, XCSRT, XERCLR, XLEGF, XNRMP, XSET, XSETF
C***REVISION HISTORY  (YYMMDD)
C   881020  DATE WRITTEN
C   900306  Added SLATEC prologue to this routine. (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C   910104  Changed to print variable number of decimals. (DWL and JMS)
C***END PROLOGUE  FCNQX1
C
      CHARACTER*34 FMT, FMTF, FMTI
      INTEGER LUN,KPRINT,IPASS
      DIMENSION P(10),Q(10),R(10),C1(10),C2(10),IP(10),IQ(10),IR(10)
      DIMENSION IC1(10),IC2(10),PN(10),IPN(10)
      REAL P,Q,R,C1,C2,PN
      REAL DEG,THETA,DNU1,DZERO
      REAL X11,X12,X13,X21,X22,X23
      REAL NU
C
C***FIRST EXECUTABLE STATEMENT  FCNQX1
C
      IF(KPRINT.GE.2) WRITE(LUN,1)
    1 FORMAT(' ** TEST SINGLE PRECISION LEGENDRE FUNCTION ROUTINES',
     2' IN FCNPAK ** ',/)
      IPASS=1
      IRAD=0
      NRADPL=0
      DZERO=0.0
      NBITS=0
      CALL XSET(IRAD,NRADPL,DZERO,NBITS,IERROR)
      IF(IERROR.NE.0) IPASS=0
      IERR=0
      DNU1=2000.4
      IF(I1MACH(13)*LOG10(REAL(I1MACH(10))).LT.150.) DNU1=100.4
      IF (KPRINT.LE.2) GO TO 150
      IF (I1MACH(13).LT.500) WRITE(LUN,24)
   24 FORMAT(' ON COMPUTERS WITH MAXIMUM EXPONENT LESS THAN 500, SMALL'/
     1' TEST VALUES FOR NU, MU ARE USED. IF LARGER THAN OR EQUAL 500,'/
     2' LARGER VALUES ARE USED. THIS COMPUTER USES THE SMALLER VALUES.')
      IF (I1MACH(13).GE.500) WRITE(LUN,26)
   26 FORMAT(' ON COMPUTERS WITH MAXIMUM EXPONENT LESS THAN 500, SMALL'/
     1' TEST VALUES FOR NU, MU ARE USED. IF LARGER THAN OR EQUAL 500,'/
     2' LARGER VALUES ARE USED. THIS COMPUTER USES THE LARGER VALUES.')
  150 CONTINUE
      NUDIFF=5
      MU1=DNU1
      MU2=MU1
      DEG=0.1
      THETA=DEG*4.*ATAN(1.0)/180.0
C
C In TEST 1 the Legendre functions P (of both positive and negative
C order) and Q are calculated.  Large values of mu and nu are used
C so that it is necessary to use extended range arithmetic.  The
C values of the Casoratians should be approximately equal to 1.0.
C The check which is applied is to verify that the difference between
C the Casoratians and 1.0 is less that 10.**(6-NDEC), where NDEC =
C INT((D-1)*LOG10(R)), D = I1MACH(11) = significand length, R =
C I1MACH(10) = radix. The value of IERROR should always be returned
C as zero. This test uses the programs
C XLEGF, XPQNU, XPSI, XQNU, XPMUP, XSET, XADD,
C XADJ, XCSRT, XRED, XC210, and XCON.
C
      ISUM=0
      NDEC = (I1MACH(11)-1) * LOG10(REAL(I1MACH(10)))
C Formats that depend on NDEC ...
      FMT(1:20)='(1X, 6X, 4H   (,E30.'
      WRITE(FMT(21:22),'(I2)') NDEC
      FMT(23:34)=',1H,,I8,1H))'
      FMTF(1:20)='(1X,F6.1,4H   (,E30.'
      WRITE(FMTF(21:22),'(I2)') NDEC
      FMTF(23:34)=',1H,,I8,1H))'
      FMTI(1:20)='(1X, I6, 4H   (,E30.'
      WRITE(FMTI(21:22),'(I2)') NDEC
      FMTI(23:34)=',1H,,I8,1H))'
      IF (KPRINT.GT.2) WRITE(LUN,2) MU1, DEG
    2 FORMAT(/
     1' TEST 1, FIXED MU = ',I4,' AND THETA = ',F3.1,
     1' DEGREES, RECURRENCE IN NU,'/
     2'         CASORATIS SHOULD = 1.0')
      CALL XLEGF(DNU1,NUDIFF,MU1,MU2,THETA,1,P,IP,IERROR)
      ISUM=ISUM+IERROR
      CALL XLEGF(DNU1,NUDIFF,MU1,MU2,THETA,2,Q,IQ,IERROR)
      ISUM=ISUM+IERROR
      CALL XLEGF(DNU1,NUDIFF,MU1,MU2,THETA,3,R,IR,IERROR)
      ISUM=ISUM+IERROR
      CALL XCSRT(DNU1,NUDIFF,MU1,MU2,THETA,P,Q,R,IP,IQ,IR,
     1 C1,IC1,C2,IC2,IERROR)
      ISUM=ISUM+IERROR
      DO 20 I=1,6
      CALL XCON(P(I),IP(I),IERROR)
      ISUM=ISUM+IERROR
      CALL XCON(Q(I),IQ(I),IERROR)
      ISUM=ISUM+IERROR
      CALL XCON(R(I),IR(I),IERROR)
      ISUM=ISUM+IERROR
   20 CONTINUE
      X11=P(1)
      IX11=IP(1)
      X12=R(1)
      IX12=IR(1)
      X13=Q(1)
      IX13=IQ(1)
      IF(KPRINT.GT.2) THEN
        WRITE(LUN,'(A)') '     NU   CASORATI 1'
        NU=DNU1
        DO 25 I=1,5
        WRITE(LUN,FMTF) NU,C1(I),IC1(I)
        NU=NU+1.
   25   CONTINUE
        WRITE(LUN,'(A)') '     NU   CASORATI 2'
        NU=DNU1
        DO 30 I=1,5
        WRITE(LUN,FMTF) NU,C2(I),IC2(I)
        NU=NU+1.
   30   CONTINUE
      ENDIF
      DO 35 I=1,5
      IF(ABS(1.0-C1(I)).GE.10.0E0**(6-NDEC)) GO TO 40
      IF(ABS(1.0-C2(I)).GE.10.0E0**(6-NDEC)) GO TO 40
   35 CONTINUE
      IF(ISUM.NE.0) GO TO 40
      IF (KPRINT.GE.2) WRITE(LUN,8)
    8 FORMAT(' ***** TEST 1 (SINGLE PRECISION) PASSED *****')
      GO TO 50
   40 IF(KPRINT.GE.1) WRITE(LUN,7)
    7 FORMAT(' ***** TEST 1 (SINGLE PRECISION) FAILED *****')
      IERR=IERR+1
      IPASS=0
   50 NUDIFF=0
      MU1=MU2-5
C
C In TEST 2 P (of positive and negative order) and Q are again
C calculated but in this test the recurrence is in the mu-wise direction
C rather than in the nu-wise direction as was the case before.  The same
C programs are used except that XQNU is not used and XQMU and XPMU
C are used. Again the criterion for passing the test is that the
C Casoratians differ from 1.0 by less than 10.0**(6-NDEC). The value
C of IERROR should always be returned as zero.
C
      ISUM=0
      IF (KPRINT.GT.2) WRITE(LUN,9) DNU1, DEG
    9 FORMAT(/
     1' TEST 2, FIXED NU = ',F6.1,' AND THETA = ',F3.1,
     1' DEGREES, RECURRENCE IN MU,'/
     2'         CASORATIS SHOULD = 1.0')
      CALL XLEGF(DNU1,NUDIFF,MU1,MU2,THETA,1,P,IP,IERROR)
      ISUM=ISUM+IERROR
      CALL XLEGF(DNU1,NUDIFF,MU1,MU2,THETA,2,Q,IQ,IERROR)
      ISUM=ISUM+IERROR
      CALL XLEGF(DNU1,NUDIFF,MU1,MU2,THETA,3,R,IR,IERROR)
      ISUM=ISUM+IERROR
      CALL XCSRT(DNU1,NUDIFF,MU1,MU2,THETA,P,Q,R,IP,IQ,IR,
     1 C1,IC1,C2,IC2,IERROR)
      ISUM=ISUM+IERROR
      DO 60 I=1,6
      CALL XCON(P(I),IP(I),IERROR)
      ISUM=ISUM+IERROR
      CALL XCON(Q(I),IQ(I),IERROR)
      ISUM=ISUM+IERROR
      CALL XCON(R(I),IR(I),IERROR)
      ISUM=ISUM+IERROR
   60 CONTINUE
      X21=P(6)
      IX21=IP(6)
      X22=R(6)
      IX22=IR(6)
      X23=Q(6)
      IX23=IQ(6)
      IF(KPRINT.GT.2) THEN
        WRITE(LUN,'(A)') '     MU   CASORATI 3'
        MU=MU1
        DO 65 I=1,5
        WRITE(LUN,FMTI) MU,C1(I),IC1(I)
        MU=MU+1
   65   CONTINUE
        WRITE(LUN,'(A)') '     MU   CASORATI 4'
        MU=MU1
        DO 70 I=1,5
        WRITE(LUN,FMTI) MU,C2(I),IC2(I)
        MU=MU+1
   70   CONTINUE
      ENDIF
      DO 75 I=1,5
      IF(ABS(1.0-C1(I)).GE.10.0E0**(6-NDEC)) GO TO 80
      IF(ABS(1.0-C2(I)).GE.10.0E0**(6-NDEC)) GO TO 80
      IF(ISUM.NE.0) GO TO 80
   75 CONTINUE
      IF(KPRINT.GE.2) WRITE(LUN,12)
   12 FORMAT(' ***** TEST 2 (SINGLE PRECISION) PASSED *****')
      GO TO 85
   80 IF(KPRINT.GE.1) WRITE(LUN,11)
   11 FORMAT(' ***** TEST 2 (SINGLE PRECISION) FAILED *****')
      IERR=IERR+1
      IPASS=0
C
C In TEST 3 values of P and Q which were calculated in two different
C manners, one by nu-wise recurrence in TEST 1 and one by mu-wise
C recurrence in TEST 2, are compared.  Again, the criterion for success
C is a relative error of less than 10.0**(6-NDEC).
C
   85 IF(KPRINT.GT.2) THEN
      WRITE(LUN,13) DEG, MU2, DNU1
   13 FORMAT(/
     1' TEST 3, COMPARISON OF VALUES FROM TEST 1 AND TEST 2',
     1' WITH THETA = ',F3.1,' DEGREES,'/
     2'         MU = ',I4,' AND NU = ',F6.1)
        WRITE(LUN,'(A)') '          P(-MU,NU)'
        WRITE(LUN,FMT)   X11,IX11
        WRITE(LUN,FMT)   X21,IX21
        WRITE(LUN,'(A)') '          P(MU,NU)'
        WRITE(LUN,FMT)   X12,IX12
        WRITE(LUN,FMT)   X22,IX22
        WRITE(LUN,'(A)') '          Q(MU,NU)'
        WRITE(LUN,FMT)   X13,IX13
        WRITE(LUN,FMT)   X23,IX23
      ENDIF
      IF(ABS((X11-X21)/X11).GE.10.0E0**(6-NDEC)) GO TO 90
      IF(ABS((X12-X22)/X12).GE.10.0E0**(6-NDEC)) GO TO 90
      IF(ABS((X13-X13)/X13).GE.10.0E0**(6-NDEC)) GO TO 90
      IF(IX11.NE.IX21) GO TO 90
      IF(IX12.NE.IX22) GO TO 90
      IF(IX13.NE.IX23) GO TO 90
      IF(KPRINT.GE.2) WRITE(LUN,15)
   15 FORMAT(' ***** TEST 3 (SINGLE PRECISION) PASSED *****')
      GO TO 100
   90 IF(KPRINT.GE.1) WRITE(LUN,16)
   16 FORMAT(' ***** TEST 3 (SINGLE PRECISION) FAILED *****')
      IERR=IERR+1
      IPASS=0
  100 CONTINUE
C
C In TEST 4, the value of the normalized Legendre function as
C calculated by XLEGF and XPNRM is compared to the same value
C as calculated by the program XNRMP.  Again the criterion is a
C relative error of less than 10.0**(6-NDEC). The value of IERROR
C should always be returned as zero.
C
      ISUM=0
      DNU1=100.0
      NUDIFF=0
      MU1=10
      MU2=10
      IF(KPRINT.GT.2) WRITE(LUN,17) DEG, MU1, DNU1
   17 FORMAT(/
     1' TEST 4, COMPARISON OF VALUES FROM XLEGF AND XNRMP',
     1' WITH THETA = ',F3.1,' DEGREES,'/
     2'         MU = ',I4,' AND NU = ',F6.1)
      CALL XLEGF(DNU1,NUDIFF,MU1,MU2,THETA,4,PN,IPN,IERROR)
      ISUM=ISUM+IERROR
      X11=PN(1)
      IX11=IPN(1)
      NU1=100
      CALL XNRMP(NU1,MU1,MU2,THETA,2,PN,IPN,ISIG,IERROR)
      ISUM=ISUM+IERROR
      X21=PN(1)
      IX21=IPN(1)
      IF(KPRINT.GT.2) THEN
        WRITE(LUN,'(A)') '          NORMALIZED P'
        WRITE(LUN,FMT) X11,IX11
        WRITE(LUN,FMT) X21,IX21
      ENDIF
      IF(ABS((X11-X21)/X11).GE.10.0E0**(6-NDEC)) GO TO 110
      IF(IX11.NE.IX21) GO TO 110
      IF(ISUM.NE.0) GO TO 110
      IF(KPRINT.GE.2) WRITE(LUN,18)
   18 FORMAT(' ***** TEST 4 (SINGLE PRECISION) PASSED *****')
      GO TO 120
  110 IF(KPRINT.GE.1) WRITE(LUN,19)
   19 FORMAT(' ***** TEST 4 (SINGLE PRECISION) FAILED *****')
      IERR=IERR+1
      IPASS=0
  120 CONTINUE
C
C In TEST 5 errors are purposely made in input so as to test error
C handling capability. First, an incorrect value of ID is given. Then
C both NUDIFF and MU2-MU1 are non-zero. Finally, an incorrect value
C of THETA is given. In each case the value of the error indicator
C IERROR should equal the error number as returned by the error
C handling package XERROR (which includes XSETF, XERCLR, and NUMXER).
C
      CALL XSETF(-1)
      IF (KPRINT.LE.2) CALL XSETF(0)
      IF (KPRINT.GT.2) WRITE(LUN,23)
   23 FORMAT(/' TEST 5, TEST OF ERROR HANDLING. 3 ERROR MESSAGES',
     1' SHOULD BE PRINTED.')
      NUDIFF=0
      MU2=MU1
      ID=5
      CALL XERCLR
      CALL XLEGF(DNU1,NUDIFF,MU1,MU2,THETA,ID,P,IP,IERROR)
      N=NUMXER(NERR)
      IF (N.NE.IERROR) GO TO 125
      MU2=MU1+5
      NUDIFF=5
      CALL XERCLR
      CALL XLEGF(DNU1,NUDIFF,MU1,MU2,THETA,1,P,IP,IERROR)
      N=NUMXER(NERR)
      IF(N.NE.IERROR) GO TO 125
      NUDIFF=0
      THETA=2.0
      CALL XERCLR
      CALL XLEGF(DNU1,NUDIFF,MU1,MU2,THETA,1,P,IP,IERROR)
      N=NUMXER(NERR)
      IF(N.NE.IERROR) GO TO 125
      IF(KPRINT.GE.2) WRITE(LUN,28)
   28 FORMAT(' ***** TEST 5 (SINGLE PRECISION) PASSED *****')
      GO TO 135
  125 IF(KPRINT.GE.1) WRITE(LUN,29)
   29 FORMAT(' ***** TEST 5 (SINGLE PRECISION) FAILED *****')
      IERR=IERR+1
      IPASS=0
  135 CONTINUE
      IF(IERR.EQ.0) GO TO 140
      IF(KPRINT.GE.2) WRITE(LUN,21) IERR
   21 FORMAT(/'  TESTS COMPLETED, NUMBER OF TESTS FAILED = ',I2)
  140 CONTINUE
      RETURN
      END

*DECK DQCGLS
      SUBROUTINE DQCGLS (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  DQCGLS
C***PURPOSE  Quick check for DGLSS.
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (QCGLSS-S, DQCGLS-D)
C***AUTHOR  Voorhees, E. A., (LANL)
C***DESCRIPTION
C
C      QUICK CHECK SUBROUTINE  DQCGLS  TESTS THE EXECUTION
C      OF THE GENERAL LINEAR SYSTEM SOLVER, DGLSS .  THE
C      DGLSS  SUBROUTINE PACKAGE WAS WRITTEN BY T. MANTEUFFEL
C      (LANL).
C
C      A TITLE LINE AND A SUMMARY LINE ARE ALWAYS OUTPUTTED
C      BY DQCGLS.  THE SUMMARY LINE GIVES A COUNT OF THE
C      NUMBER OF PROBLEMS DETECTED DURING THE TEST.
C
C      THE REAL QUANTITIES FOR THE COMPUTED SOLUTION VECTOR
C      X  AND THE CORRESPONDING  RNORM  ARE COMPARED AGAINST
C      STORED VALUES.  DISAGREEMENT OCCURS IF A DIFFERENCE
C      IS SQRT(D1MACH(4) OR MORE.  THE RETURNED VALUE (INTEGER)
C      OF  INFO  IS ALSO CHECKED.  FOUR CASES ARE RUN, TWO
C      INVOLVING  LLSIA  AND TWO INVOLVING  ULSIA .
C
C      DQCGLS REQUIRES NO INPUT ARGUMENTS.  ON RETURN, NERR
C      (INTEGER TYPE) CONTAINS THE COUNT OF THE NUMBER OF
C      PROBLEMS DETECTED BY  QCGLSS .
C
C***ROUTINES CALLED  D1MACH, DGLSS
C***REVISION HISTORY  (YYMMDD)
C   811026  DATE WRITTEN
C   850601  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   901010  Restructured using IF-THEN-ELSE-ENDIF, cleaned up FORMATs,
C           including removing an illegal character from column 1, and
C           editorial changes.  (RWC)
C***END PROLOGUE  DQCGLS
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION AA(4,4,2),A(4,4),BB(4,2),B(4),XX(4,4)
      DIMENSION WORK(50)
      CHARACTER*1 LIST(2)
      INTEGER INF(4),NERR,KPROG,KCASE
      INTEGER IWORK(20),INFO,LUN
      DATA AA/1.D0,.5D0,1.D0,.25D0,0.D0,2.D0,0.D0,1.D0,2.D0,-1.D0,
     11.D0,0.D0,0.D0,0.D0,0.D0,0.D0,1.D0,2.D0,-1.D0,0.D0,0.D0,1.D0,
     22.D0,0.D0,-1.D0,0.D0,1.D0,0.D0,1.D0,0.D0,1.D0,0.D0/
      DATA BB/3.D0,1.5D0,2.D0,1.25D0,1.D0,3.D0,3.D0,0.D0/
      DATA XX/.9999999999999787D0,1.000000000000007D0,
     1 1.000000000000007D0,0.D0,.8095238095238102D0,
     2 1.047619047619044D0,1.095238095238081D0,0.D0,
     3 .7777777777777857D0,1.444444444444429D0,.3333333333333393D0,
     4 .5555555555555500D0,
     5 .3333333333333321D0,0.0D0,-.3333333333333286D0,
     6 .3333333333333286D0/
      DATA INF/0,1,0,2/
      DATA LIST/'L', 'U'/
C***FIRST EXECUTABLE STATEMENT  DQCGLS
      INFO = 0
      NERR = 0
      R = MAX(SQRT(D1MACH(4)),1.D-12)
      IF (KPRINT.GE.2) WRITE(LUN,800)
      DO 60 KPROG=1,2
         DO 50 KCASE=1,2
C
C           FORM BASIC MATRIX  A  AND VECTOR  B .  (CASE 1)
C
            DO 10  I=1,4
               DO 5  J=1,4
                  A(I,J) = AA(I,J,KPROG)
    5          CONTINUE
               B(I) = BB(I,KPROG)
   10       CONTINUE
C
C           MAKE 3 ROWS IDENTICAL FOR CASE 2.
C
            IF (KCASE .NE. 1) THEN
               DO 20  I=2,3
                  DO 15  J=1,4
                     A(I,J) = A(1,J)
   15             CONTINUE
                  B(I) = B(1)
   20          CONTINUE
            ENDIF
C
C           SOLVE FOR VECTOR  X .
C
            INFO = 0
            IF (KPROG .EQ. 1) CALL DGLSS(A,4,4,3,B,4,1,RNORM,WORK,50,
     1         IWORK,20,INFO)
            IF (KPROG .EQ. 2) CALL DGLSS(A,4,3,4,B,4,1,RNORM,WORK,50,
     1         IWORK,20,INFO)
C
C           TEST COMPUTED  X , RNORM , AND  INFO .
C
            KK = 2*(KPROG - 1) + KCASE
            DELMAX = 0.0D0
            DO 30  I=1,4
               DELX = ABS(B(I)-XX(I,KK))
               DELMAX = MAX(DELMAX,DELX)
   30       CONTINUE
C
            IF (KPRINT.GE.3) WRITE (LUN,701) LIST(KPROG),KCASE,DELMAX
            IF (DELMAX .GE. R) THEN
               NERR = NERR + 1
               IF(KPRINT.GE.2) WRITE(LUN,801) LIST(KPROG),KCASE,DELMAX
            ENDIF
C
            IF (KPRINT.GE.3) WRITE (LUN,702) LIST(KPROG),KCASE,RNORM
            IF (RNORM .GE. R) THEN
               NERR = NERR + 1
               IF (KPRINT.GE.2) WRITE (LUN,802) LIST(KPROG),KCASE,RNORM
            ENDIF
            IF (KPRINT.GE.3) WRITE (LUN,703) LIST(KPROG),KCASE,INFO,
     *         INF(KK)
            IF (INFO .NE. INF(KK)) THEN
               NERR = NERR + 1
               IF (KPRINT.GE.2) WRITE (LUN,803) LIST(KPROG),KCASE,INFO,
     *            INF(KK)
            ENDIF
   50    CONTINUE
   60 CONTINUE
C
C     SUMMARY PRINT
C
      IPASS=0
      IF (NERR.EQ.0) IPASS=1
      IF (NERR.NE.0 .AND. KPRINT.NE.0) WRITE (LUN,804) NERR
      IF (NERR.EQ.0 .AND. KPRINT.GT.1) WRITE (LUN,805)
      RETURN
C
  703 FORMAT (3X, A, 'LSIA, CASE ', I1, '.  INFO=', I1, ' (SHOULD = ',
     1   I1, ')'/)
  804 FORMAT (/' **** DQCGLS DETECTED A TOTAL OF ', I2,
     1   ' PROBLEMS WITH DGLSS. ****'/)
  805 FORMAT ('     DQCGLS DETECTED NO PROBLEMS WITH DGLSS.'/)
  801 FORMAT ('   PROBLEM WITH ', A, 'LSIA, CASE ', I1,
     1   '.  MAX ABS ERROR OF', D11.4/)
  800 FORMAT(/' *  DQCGLS - QUICK CHECK FOR DGLSS (DLLSIA AND DULSIA)'/)
  701 FORMAT (3X, A, 'LSIA, CASE ', I1, '.  MAX ABS ERROR OF', D11.4/)
  702 FORMAT (3X, A, 'LSIA, CASE ', I1, '.  RNORM IS ', D11.4/)
  802 FORMAT ('   PROBLEM WITH ', A, 'LSIA, CASE ', I1,
     1   '.  RNORM (TOO LARGE) IS', D11.4/)
  803 FORMAT ('   PROBLEM WITH ', A, 'LSIA, CASE ', I1, '.  INFO=', I1,
     1   ' (SHOULD = ', I1, ')'/)
      END

*DECK QXBLKT
      SUBROUTINE QXBLKT (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  QXBLKT
C***PURPOSE
C***LIBRARY   SLATEC
C***KEYWORDS  QUICK CHECK
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C     *                                                               *
C     *                        F I S H P A K                          *
C     *                                                               *
C     *                                                               *
C     *     A PACKAGE OF FORTRAN SUBPROGRAMS FOR THE SOLUTION OF      *
C     *                                                               *
C     *      SEPARABLE ELLIPTIC PARTIAL DIFFERENTIAL EQUATIONS        *
C     *                                                               *
C     *                  (VERSION  3 , JUNE 1979)                     *
C     *                                                               *
C     *                             BY                                *
C     *                                                               *
C     *        JOHN ADAMS, PAUL SWARZTRAUBER AND ROLAND SWEET         *
C     *                                                               *
C     *                             OF                                *
C     *                                                               *
C     *         THE NATIONAL CENTER FOR ATMOSPHERIC RESEARCH          *
C     *                                                               *
C     *                BOULDER, COLORADO  (80307)  U.S.A.             *
C     *                                                               *
C     *                   WHICH IS SPONSORED BY                       *
C     *                                                               *
C     *              THE NATIONAL SCIENCE FOUNDATION                  *
C     *                                                               *
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C
C
C     PROGRAM TO ILLUSTRATE THE USE OF BLKTRI
C
C***ROUTINES CALLED  BLKTRI
C***REVISION HISTORY  (YYMMDD)
C   800103  DATE WRITTEN
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890911  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   901010  Added PASS/FAIL message and cleaned up FORMATs.  (RWC)
C***END PROLOGUE  QXBLKT
      DIMENSION Y(75,105), AM(75), BM(75), CM(75), AN(105), BN(105),
     1          CN(105), W(1952), S(75), T(105)
C***FIRST EXECUTABLE STATEMENT  QXBLKT
      ERMAX=1.E-3
      IFLG = 0
      NP = 1
      N = 63
      MP = 1
      M = 50
      IDIMY = 75
C
C     GENERATE AND STORE GRID POINTS FOR THE PURPOSE OF COMPUTING THE
C     COEFFICIENTS AND THE ARRAY Y.
C
      DELTAS = 1.0E0/(M+1)
      DO 101 I=1,M
         S(I) = I * DELTAS
  101 CONTINUE
      DELTAT = 1.0E0/(N+1)
      DO 102 J=1,N
         T(J) = J*DELTAT
  102 CONTINUE
C
C     COMPUTE THE COEFFICIENTS AM, BM AND CM CORRESPONDING TO THE S
C     DIRECTION.
C
      HDS = DELTAS/2.
      TDS = DELTAS+DELTAS
      DO 103 I=1,M
         TEMP1 = 1./(S(I)*TDS)
         TEMP2 = 1./((S(I)-HDS)*TDS)
         TEMP3 = 1./((S(I)+HDS)*TDS)
         AM(I) = TEMP1*TEMP2
         CM(I) = TEMP1*TEMP3
         BM(I) = -(AM(I)+CM(I))
  103 CONTINUE
C
C     COMPUTE THE COEFFICIENTS AN, BN AND CN CORRESPONDING TO THE T
C     DIRECTION.
C
      HDT = DELTAT/2.
      TDT = DELTAT+DELTAT
      DO 104 J=1,N
         TEMP1 = 1./(T(J)*TDT)
         TEMP2 = 1./((T(J)-HDT)*TDT)
         TEMP3 = 1./((T(J)+HDT)*TDT)
         AN(J) = TEMP1*TEMP2
         CN(J) = TEMP1*TEMP3
         BN(J) = -(AN(J)+CN(J))
  104 CONTINUE
C
C     COMPUTE RIGHT SIDE OF EQUATION
C
      DO 106 J=1,N
         DO 105 I=1,M
            Y(I,J) = 3.75*S(I)*T(J)*(S(I)**4.+T(J)**4.)
  105    CONTINUE
  106 CONTINUE
C
C     INCLUDE NONHOMOGENEOUS BOUNDARY INTO RIGHT SIDE. NOTE THAT THE
C     CORNER AT J=N,I=M INCLUDES CONTRIBUTIONS FROM BOTH BOUNDARIES.
C
      DO 107 J=1,N
         Y(M,J) = Y(M,J)-CM(M)*T(J)**5.
  107 CONTINUE
      DO 108 I=1,M
         Y(I,N) = Y(I,N)-CN(N)*S(I)**5.
  108 CONTINUE
C
  109 CALL BLKTRI (IFLG,NP,N,AN,BN,CN,MP,M,AM,BM,CM,IDIMY,Y,IERROR,W)
      IFLG = IFLG+1
      IF (IFLG-1) 109,109,110
C
C     COMPUTE DISCRETIZATION ERROR
C
  110 ERR = 0.
      DO 112 J=1,N
         DO 111 I=1,M
            Z = ABS(Y(I,J)-(S(I)*T(J))**5.)
            IF (Z .GT. ERR) ERR = Z
  111    CONTINUE
  112 CONTINUE
C
      IPASS = 1
      IF (ERR.GT.ERMAX) IPASS = 0
      IF (KPRINT.EQ.0) RETURN
      IF (KPRINT.GE.2 .OR. IPASS.EQ.0) THEN
         WRITE (LUN,1001) IERROR,ERR,INT(W(1))
         IF (IPASS.EQ.1) THEN
            WRITE (LUN, 1002)
         ELSE
            WRITE (LUN, 1003)
         ENDIF
      ENDIF
      RETURN
C
 1001 FORMAT ('1',20X,'SUBROUTINE BLKTRI EXAMPLE'///
     1        10X,'THE OUTPUT FROM THE NCAR CONTROL DATA 7600 WAS'//
     2        32X,'IERROR = 0'/
     3        18X,'DISCRETIZATION ERROR = 1.6478E-05'/
     4        12X,'REQUIRED LENGTH OF W ARRAY = 823'//
     5        10X,'THE OUTPUT FROM YOUR COMPUTER IS'//
     6        32X,'IERROR =',I2/
     7        18X,'DISCRETIZATION ERROR =',1PE12.5/
     8        12X,'REQUIRED LENGTH OF W ARRAY =', I4)
 1002 FORMAT (60X,'PASS'/)
 1003 FORMAT (60X,'FAIL'/)
      END

*DECK QC36J
      SUBROUTINE QC36J (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  QC36J
C***SUBSIDIARY
C***PURPOSE  THIS IS A QUICK CHECK PROGRAM FOR THE SUBROUTINES RC3JJ,
C            RC3JM, AND RC6J, WHICH CALCULATE THE WIGNER COEFFICIENTS,
C            3J AND 6J.
C***LIBRARY   SLATEC
C***CATEGORY  C19
C***TYPE      SINGLE PRECISION (QC36J-S, DQC36J-D)
C***KEYWORDS  3J COEFFICIENTS, 3J SYMBOLS, 6J COEFFICIENTS, 6J SYMBOLS,
C             CLEBSCH-GORDAN COEFFICIENTS, QUICK CHECK,
C             RACAH COEFFICIENTS, VECTOR ADDITION COEFFICIENTS,
C             WIGNER COEFFICIENTS
C***AUTHOR  LOZIER, DANIEL W., (NIST)
C           MCCLAIN, MARJORIE A., (NIST)
C           SMITH, JOHN M., (NIST AND GEORGE MASON UNIVERSITY)
C***REFERENCES  MESSIAH, ALBERT., QUANTUM MECHANICS, VOLUME II,
C               NORTH-HOLLAND PUBLISHING COMPANY, 1963.
C***ROUTINES CALLED  NUMXER, R1MACH, RC3JJ, RC3JM, RC6J, XERCLR, XSETF
C***REVISION HISTORY  (YYMMDD)
C   891129  DATE WRITTEN
C   910415  Mixed type expressions eliminated; precision of output
C           formats made uniform for all tests; detail added to output
C           when KPRINT=2 and a test fails; name of quick check added
C           to output when KPRINT=3 or KPRINT=2 and a test fails; some
C           output formats modified for clarity or adherence to SLATEC
C           guidelines. These changes were done by D. W. Lozier.
C   930115  Replaced direct calculation of 3j-6j symbols in tests 1, 2,
C           and 4 with values stored in data statements.  This involved
C           removing all calls to subroutine RACAH.  These changes were
C           made by M. McClain.
C***END PROLOGUE  QC36J
C
      INTEGER LUN, KPRINT, IPASS
C
      CHARACTER STRING*36, FMT*30, FMT2*13
      INTEGER IPASS1, IPASS2, IPASS3, IPASS4, IPASS5, NDIM, IER, INDEX,
     +        I, FIRST, LAST, NSIG, NUMXER, NERR, IERJJ, IERJM
      PARAMETER(NDIM=15)
      REAL TOL, L1, L2, L3, M1, M2, M3, L1MIN, L1MAX, M2MIN, M2MAX,
     +     DIFF(NDIM), R1MACH, X, JJVAL, JMVAL, THRCOF(NDIM),
     +     SIXCOF(NDIM), R3JJ(8), R3JM(14), R6J(15)
C
      DATA R3JJ / 2.78886675511358515993E-1,
     +           -9.53462589245592315447E-2,
     +           -6.74199862463242086246E-2,
     +            1.53311035167966641297E-1,
     +           -1.56446554693685969725E-1,
     +            1.09945041215655051079E-1,
     +           -5.53623569313171943334E-2,
     +            1.79983545113778583298E-2/
C
      DATA R3JM / 2.09158973288615242614E-2,
     +            8.53756555321524722127E-2,
     +            9.08295370868692516943E-2,
     +           -3.89054377846499391700E-2,
     +           -6.63734970165680635691E-2,
     +            6.49524040528389395031E-2,
     +            2.15894310595403759392E-2,
     +           -7.78912711785239219992E-2,
     +            3.59764371059543401880E-2,
     +            5.47301500021263423079E-2,
     +           -7.59678665956761514629E-2,
     +           -2.19224445539892113776E-2,
     +            1.01167744280772202424E-1,
     +            7.34825726244719704696E-2/
C
      DATA R6J / 3.49090513837329977746E-2,
     +          -3.74302503965979160859E-2,
     +           1.89086639095956018415E-2,
     +           7.34244825492864345709E-3,
     +          -2.35893518508179445858E-2,
     +           1.91347695521543652000E-2,
     +           1.28801739772417220844E-3,
     +          -1.93001836629052653977E-2,
     +           1.67730594938288876974E-2,
     +           5.50114727485094871674E-3,
     +          -2.13543979089683097421E-2,
     +           3.46036445143538730828E-3,
     +           2.52095005479558458604E-2,
     +           1.48399056122171330285E-2,
     +           2.70857768063318559724E-3/
C
C***FIRST EXECUTABLE STATEMENT  QC36J
C
C --- INITIALIZATION OF TESTS
      TOL=100.0*R1MACH(3)
      IF(KPRINT.GE.2)THEN
         WRITE(LUN,*)' THIS IS QC36J, A TEST PROGRAM FOR THE ' //
     +   'SINGLE PRECISION 3J6J PACKAGE.'
         WRITE(LUN,*)' AN EXPLANATION OF THE VARIOUS ' //
     +   'TESTS CAN BE FOUND IN THE PROGRAM COMMENTS.'
         WRITE(LUN,*)
      ENDIF
C
C --- FIND NUMBER OF SIGNIFICANT FIGURES FOR FORMATTING
      X=1.0/3.0
      WRITE(STRING,100)X
  100 FORMAT(F35.25)
      DO 200 I=1,35
         IF(STRING(I:I).EQ.'3')THEN
            FIRST=I
            GOTO 300
         ENDIF
  200 CONTINUE
  300 CONTINUE
      DO 400 I=FIRST,35
         IF(STRING(I:I).NE.'3')THEN
            LAST=I-1
            GOTO 500
         ENDIF
  400 CONTINUE
      LAST=36
  500 CONTINUE
      NSIG=LAST-FIRST+1
      FMT(1:16)='(1X,F5.1,T8,G35.'
      WRITE(FMT(17:18),'(I2)')NSIG
      FMT(19:27)=',T45,G35.'
      WRITE(FMT(28:29),'(I2)')NSIG
      FMT(30:30)=')'
      FMT2(1:10)='(1X,A,G35.'
      WRITE(FMT2(11:12),'(I2)')NSIG
      FMT2(13:13)=')'
C
C --- TEST 1: COMPARE RC3JJ VALUES WITH FORMULA
      IPASS1=1
      L2=4.5
      L3=3.5
      M2=-3.5
      M3=2.5
      CALL RC3JJ(L2,L3,M2,M3,L1MIN,L1MAX,THRCOF,NDIM,IER)
      IF(IER.NE.0)THEN
         IPASS1=0
      ELSE
         DO 550 L1=L1MIN,L1MAX
            INDEX=INT(L1-L1MIN)+1
            M1=1.0
            DIFF(INDEX)=ABS(THRCOF(INDEX)-R3JJ(INDEX))
            IF(DIFF(INDEX).GT.ABS(R3JJ(INDEX))*TOL)IPASS1=0
  550    CONTINUE
      ENDIF
      IF(KPRINT.GE.3 .OR. (KPRINT.EQ.2.AND.IPASS1.EQ.0))THEN
         WRITE(LUN,*)' TEST 1, RECURRENCE IN L1, COMPARE VALUES OF 3J ',
     +               'CALCULATED BY RC3JJ TO'
         WRITE(LUN,*)' VALUES CALCULATED BY EXPLICIT FORMULA FROM ',
     +               'MESSIAH''S QUANTUM MECHANICS'
         WRITE(LUN,600)L2,L3
  600    FORMAT('              L2 = ',F5.1,'   L3 = ',F5.1)
         WRITE(LUN,700)M1,M2,M3
  700    FORMAT(' M1 = ',F5.1,'   M2 = ',F5.1,'   M3 = ',F5.1)
         IF(IER.NE.0)THEN
            WRITE(LUN,*)' ERROR RETURNED FROM SUBROUTINE ',
     +      'RC3JJ: IER =',IER
         ELSE
            WRITE(LUN,800)
  800       FORMAT('    L1',T31,' RC3JJ VALUE',T67,'FORMULA VALUE')
            DO 900 L1=L1MIN,L1MAX
               INDEX=INT(L1-L1MIN)+1
               WRITE(LUN,FMT)L1,THRCOF(INDEX),R3JJ(INDEX)
               IF(DIFF(INDEX).GT.ABS(R3JJ(INDEX))*TOL)THEN
                  WRITE(LUN,'(1X,A,F5.1)')'DIFFERENCE EXCEEDS ERROR '//
     +            'TOLERANCE FOR L1 =',L1
               ENDIF
  900       CONTINUE
         ENDIF
      ENDIF
      IF(IPASS1.EQ.0)THEN
         IF(KPRINT.GE.1)THEN
            WRITE(LUN,*)' ***** ***** TEST 1 FAILED ***** *****'
            WRITE(LUN,*)
         ENDIF
      ELSE
         IF(KPRINT.GE.2)THEN
            WRITE(LUN,*)' ***** ***** TEST 1 PASSED ***** *****'
            WRITE(LUN,*)
         ENDIF
      ENDIF
C
C --- TEST 2: COMPARE RC3JM VALUES WITH FORMULA
      IPASS2=1
      L1=8.0
      L2=7.5
      L3=6.5
      M1=1.0
      CALL RC3JM(L1,L2,L3,M1,M2MIN,M2MAX,THRCOF,NDIM,IER)
      IF(IER.NE.0)THEN
         IPASS2=0
      ELSE
         DO 950 M2=M2MIN,M2MAX
            INDEX=INT(M2-M2MIN)+1
            M3=-M1-M2
            DIFF(INDEX)=ABS(THRCOF(INDEX)-R3JM(INDEX))
            IF(DIFF(INDEX).GT.ABS(R3JM(INDEX))*TOL)IPASS2=0
  950    CONTINUE
      ENDIF
      IF(KPRINT.GE.3 .OR. (KPRINT.EQ.2.AND.IPASS2.EQ.0))THEN
         WRITE(LUN,*)' TEST 2, RECURRENCE IN M2, COMPARE VALUES OF 3J ',
     +               'CALCULATED BY RC3JM TO'
         WRITE(LUN,*)' VALUES CALCULATED BY EXPLICIT FORMULA FROM ',
     +               'MESSIAH''S QUANTUM MECHANICS'
         WRITE(LUN,1000)L1,L2,L3
 1000    FORMAT(' L1 = ',F5.1,'   L2 = ',F5.1,'   L3 = ',F5.1)
         WRITE(LUN,1100)M1
 1100    FORMAT(' M1 = ',F5.1,'                M3 = -(M1+M2)')
         IF(IER.NE.0)THEN
            WRITE(LUN,*)' ERROR RETURNED FROM SUBROUTINE ',
     +      'RC3JM: IER =',IER
         ELSE
            WRITE(LUN,1200)
 1200       FORMAT('    M2',T31,' RC3JM VALUE',T67,'FORMULA VALUE')
            DO 1300 M2=M2MIN,M2MAX
               INDEX=INT(M2-M2MIN)+1
               WRITE(LUN,FMT)M2,THRCOF(INDEX),R3JM(INDEX)
               IF(DIFF(INDEX).GT.ABS(R3JM(INDEX))*TOL)THEN
                  WRITE(LUN,'(1X,A,F5.1)')'DIFFERENCE EXCEEDS ERROR '//
     +            'TOLERANCE FOR M2 =',M2
               ENDIF
 1300       CONTINUE
         ENDIF
      ENDIF
      IF(IPASS2.EQ.0)THEN
         IF(KPRINT.GE.1)THEN
            WRITE(LUN,*)' ***** ***** TEST 2 FAILED ***** *****'
            WRITE(LUN,*)
         ENDIF
      ELSE
         IF(KPRINT.GE.2)THEN
            WRITE(LUN,*)' ***** ***** TEST 2 PASSED ***** *****'
            WRITE(LUN,*)
         ENDIF
      ENDIF
C
C --- TEST3: COMPARE COMMON VALUE OF RC3JJ AND RC3JM
      IPASS3=1
      L1=100.0
      L2=2.0
      L3=100.0
      M1=-10.0
      M2=0.0
      M3=10.0
      CALL RC3JJ(L2,L3,M2,M3,L1MIN,L1MAX,THRCOF,NDIM,IERJJ)
      JJVAL=THRCOF(3)
      CALL RC3JM(L1,L2,L3,M1,M2MIN,M2MAX,THRCOF,NDIM,IERJM)
      JMVAL=THRCOF(3)
      IF(IERJJ.NE.0 .OR. IERJM.NE.0)THEN
        IPASS3=0
      ELSE
         DIFF(1)=ABS(JJVAL-JMVAL)
         IF(DIFF(1).GT.0.5*ABS(JJVAL+JMVAL)*TOL)IPASS3=0
      ENDIF
      IF(KPRINT.GE.3 .OR. (KPRINT.EQ.2.AND.IPASS3.EQ.0))THEN
         WRITE(LUN,*)' TEST 3, COMPARE A COMMON VALUE CALCULATED BY ',
     +               'BOTH RC3JJ AND RC3JM'
         WRITE(LUN,*)' L1 = 100.0   L2 =   2.0   L3 = 100.0'
         WRITE(LUN,*)' M1 = -10.0   M2 =   0.0   M3 =  10.0'
         IF(IERJJ.NE.0)THEN
            WRITE(LUN,*)' ERROR RETURNED FROM SUBROUTINE ',
     +      'RC3JJ: IER =',IERJJ
         ELSEIF(IERJM.NE.0)THEN
            WRITE(LUN,*)' ERROR RETURNED FROM SUBROUTINE ',
     +      'RC3JM: IER =',IERJM
         ELSE
            WRITE(LUN,FMT2)'RC3JJ VALUE =',JJVAL
            WRITE(LUN,FMT2)'RC3JM VALUE =',JMVAL
            IF(DIFF(1).GT.0.5*ABS(JJVAL+JMVAL)*TOL)THEN
               WRITE(LUN,'(1X,A)')'DIFFERENCE EXCEEDS ERROR TOLERANCE'
            ENDIF
         ENDIF
      ENDIF
      IF(IPASS3.EQ.0)THEN
         IF(KPRINT.GE.1)THEN
            WRITE(LUN,*)' ***** ***** TEST 3 FAILED ***** *****'
            WRITE(LUN,*)
         ENDIF
      ELSE
         IF(KPRINT.GE.2)THEN
            WRITE(LUN,*)' ***** ***** TEST 3 PASSED ***** *****'
            WRITE(LUN,*)
         ENDIF
      ENDIF
C
C --- TEST 4: COMPARE RC6J VALUES WITH FORMULA
      IPASS4=1
      L2=8.0
      L3=7.0
      M1=6.5
      M2=7.5
      M3=7.5
      CALL RC6J(L2,L3,M1,M2,M3,L1MIN,L1MAX,SIXCOF,NDIM,IER)
      IF(IER.NE.0)THEN
         IPASS4=0
      ELSE
         DO 1310 L1=L1MIN,L1MAX
            INDEX=INT(L1-L1MIN)+1
            DIFF(INDEX)=ABS(SIXCOF(INDEX)-R6J(INDEX))
            IF(DIFF(INDEX).GT.ABS(R6J(INDEX))*TOL)IPASS4=0
 1310    CONTINUE
      ENDIF
      IF(KPRINT.GE.3 .OR. (KPRINT.EQ.2.AND.IPASS4.EQ.0))THEN
         WRITE(LUN,*)' TEST 4, RECURRENCE IN L1, COMPARE VALUES OF 6J ',
     +               'CALCULATED BY RC6J TO'
         WRITE(LUN,*)' VALUES CALCULATED BY EXPLICIT FORMULA FROM ',
     +               'MESSIAH''S QUANTUM MECHANICS'
         WRITE(LUN,600)L2,L3
         WRITE(LUN,700)M1,M2,M3
         IF(IER.NE.0)THEN
            WRITE(LUN,*)' ERROR RETURNED FROM SUBROUTINE ',
     +      'RC6J: IER =',IER
         ELSE
            WRITE(LUN,1320)
 1320       FORMAT('    L1',T32,' RC6J VALUE',T67,'FORMULA VALUE')
            DO 1350 L1=L1MIN,L1MAX
               INDEX=INT(L1-L1MIN)+1
               WRITE(LUN,FMT)L1,SIXCOF(INDEX),R6J(INDEX)
               IF(DIFF(INDEX).GT.ABS(R6J(INDEX))*TOL)THEN
                  WRITE(LUN,'(1X,A,F5.1)')'DIFFERENCE EXCEEDS ERROR '//
     +            'TOLERANCE FOR L1 =',L1
               ENDIF
 1350       CONTINUE
         ENDIF
      ENDIF
      IF(IPASS4.EQ.0)THEN
         IF(KPRINT.GE.1)THEN
            WRITE(LUN,*)' ***** ***** TEST 4 FAILED ***** *****'
            WRITE(LUN,*)
         ENDIF
      ELSE
         IF(KPRINT.GE.2)THEN
            WRITE(LUN,*)' ***** ***** TEST 4 PASSED ***** *****'
            WRITE(LUN,*)
         ENDIF
      ENDIF
C
C --- TEST 5: CHECK INVALID INPUT
      IPASS5=1
      IF(KPRINT.LE.2)THEN
         CALL XSETF(0)
      ELSE
         CALL XSETF(-1)
      ENDIF
      IF(KPRINT.GE.3)WRITE(LUN,*)' TEST 5, CHECK FOR PROPER HANDLING ',
     +   'OF INVALID INPUT'
C --- RC3JJ: L2-ABS(M2) OR L3-ABS(M3) LESS THAN ZERO (IER=1)
      L2=2.0
      L3=100.0
      M1=-6.0
      M2=-4.0
      M3=10.0
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL RC3JJ(L2,L3,M2,M3,L1MIN,L1MAX,THRCOF,NDIM,IER)
      IF(NUMXER(NERR).NE.IER)IPASS5=0
C --- RC3JJ: L2+ABS(M2) OR L3+ABS(M3) NOT INTEGER (IER=2)
      L2=2.0
      L3=99.5
      M1=-10.0
      M2=0.0
      M3=10.0
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL RC3JJ(L2,L3,M2,M3,L1MIN,L1MAX,THRCOF,NDIM,IER)
      IF(NUMXER(NERR).NE.IER)IPASS5=0
C --- RC3JJ: L1MAX-L1MIN NOT INTEGER (IER=3)
      L2=3.2
      L3=4.5
      M1=-1.3
      M2=0.8
      M3=0.5
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL RC3JJ(L2,L3,M2,M3,L1MIN,L1MAX,THRCOF,NDIM,IER)
      IF(NUMXER(NERR).NE.IER)IPASS5=0
C --- RC3JJ: L1MIN GREATER THAN L1MAX (IER=4)
C            (NO TEST -- THIS ERROR SHOULD NEVER OCCUR)
C --- RC3JJ: DIMENSION OF THRCOF TOO SMALL (IER=5)
      L2=10.0
      L3=150.0
      M1=-10.0
      M2=0.0
      M3=10.0
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL RC3JJ(L2,L3,M2,M3,L1MIN,L1MAX,THRCOF,NDIM,IER)
      IF(NUMXER(NERR).NE.IER)IPASS5=0
C --- RC3JM: L1-ABS(M1) LESS THAN ZERO OR L1+ABS(M1) NOT INTEGER (IER=1)
      L1=100.0
      L2=2.0
      L3=100.0
      M1=150.0
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL RC3JM(L1,L2,L3,M1,M2MIN,M2MAX,THRCOF,NDIM,IER)
      IF(NUMXER(NERR).NE.IER)IPASS5=0
C --- RC3JM: L1, L2, L3 DO NOT SATISFY TRIANGULAR CONDITION (IER=2)
      L1=20.0
      L2=5.0
      L3=10.0
      M1=-10.0
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL RC3JM(L1,L2,L3,M1,M2MIN,M2MAX,THRCOF,NDIM,IER)
      IF(NUMXER(NERR).NE.IER)IPASS5=0
C --- RC3JM: L1+L2+L3 NOT INTEGER (IER=3)
      L1=1.0
      L2=1.3
      L3=1.5
      M1=0.0
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL RC3JM(L1,L2,L3,M1,M2MIN,M2MAX,THRCOF,NDIM,IER)
      IF(NUMXER(NERR).NE.IER)IPASS5=0
C --- RC3JM: M2MAX-M2MIN NOT INTEGER (IER=4)
      L1=1.0
      L2=1.3
      L3=1.7
      M1=0.0
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL RC3JM(L1,L2,L3,M1,M2MIN,M2MAX,THRCOF,NDIM,IER)
      IF(NUMXER(NERR).NE.IER)IPASS5=0
C --- RC3JM: M2MIN GREATER THAN M2MAX (IER=5)
C            (NO TEST -- THIS ERROR SHOULD NEVER OCCUR)
C --- RC3JM: DIMENSION OF THRCOF TOO SMALL (IER=6)
      L1=100.0
      L2=10.0
      L3=110.0
      M1=-10.0
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL RC3JM(L1,L2,L3,M1,M2MIN,M2MAX,THRCOF,NDIM,IER)
      IF(NUMXER(NERR).NE.IER)IPASS5=0
C --- RC6J: L2+L3+L5+L6 OR L4+L2+L6 NOT INTEGER (IER=1)
      L2=0.5
      L3=1.0
      M1=0.5
      M2=2.0
      M3=3.0
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL RC6J(L2,L3,M1,M2,M3,L1MIN,L1MAX,SIXCOF,NDIM,IER)
      IF(NUMXER(NERR).NE.IER)IPASS5=0
C --- RC6J: L4, L2, L6 TRIANGULAR CONDITION NOT SATISFIED (IER=2)
      L2=1.0
      L3=3.0
      M1=5.0
      M2=6.0
      M3=2.0
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL RC6J(L2,L3,M1,M2,M3,L1MIN,L1MAX,SIXCOF,NDIM,IER)
      IF(NUMXER(NERR).NE.IER)IPASS5=0
C --- RC6J: L4, L5, L3 TRIANGULAR CONDITION NOT SATISFIED (IER=3)
      L2=4.0
      L3=1.0
      M1=5.0
      M2=3.0
      M3=2.0
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL RC6J(L2,L3,M1,M2,M3,L1MIN,L1MAX,SIXCOF,NDIM,IER)
      IF(NUMXER(NERR).NE.IER)IPASS5=0
C --- RC6J: L1MAX-L1MIN NOT INTEGER (IER=4)
      L2=0.9
      L3=0.5
      M1=0.9
      M2=0.4
      M3=0.2
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL RC6J(L2,L3,M1,M2,M3,L1MIN,L1MAX,SIXCOF,NDIM,IER)
      IF(NUMXER(NERR).NE.IER)IPASS5=0
C --- RC6J: L1MIN GREATER THAN L1MAX (IER=5)
C           (NO TEST -- THIS ERROR SHOULD NEVER OCCUR)
C --- RC6J: DIMENSION OF SIXCOF TOO SMALL (IER=6)
      L2=50.0
      L3=25.0
      M1=15.0
      M2=30.0
      M3=40.0
      IF(KPRINT.GE.3)WRITE(LUN,*)
      CALL XERCLR
      CALL RC6J(L2,L3,M1,M2,M3,L1MIN,L1MAX,SIXCOF,NDIM,IER)
      IF(NUMXER(NERR).NE.IER)IPASS5=0
      IF(IPASS5.EQ.0)THEN
         IF(KPRINT.GE.1)THEN
            WRITE(LUN,*)' ***** ***** TEST 5 FAILED ***** *****'
            WRITE(LUN,*)
         ENDIF
      ELSE
         IF(KPRINT.GE.2)THEN
            WRITE(LUN,*)' ***** ***** TEST 5 PASSED ***** *****'
            WRITE(LUN,*)
         ENDIF
      ENDIF
C
C --- END OF TESTS
      IF((IPASS1.EQ.0).OR.(IPASS2.EQ.0).OR.(IPASS3.EQ.0).OR.
     +   (IPASS4.EQ.0).OR.(IPASS5.EQ.0))THEN
         IPASS=0
         IF(KPRINT.GE.1)WRITE(LUN,1500)
      ELSE
         IPASS=1
         IF(KPRINT.GE.2)WRITE(LUN,1600)
      ENDIF
 1500 FORMAT(' *****  QC36J  FAILED SOME TESTS *****')
 1600 FORMAT(' *****  QC36J  PASSED ALL TESTS  *****')
C
      RETURN
      END

*DECK FQD1
      REAL FUNCTION FQD1 (X)
C***BEGIN PROLOGUE  FQD1
C***SUBSIDIARY
C***PURPOSE  Function evaluator for QNC79 and GAUS8 quick checks.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (FQD1-S, DFQD1-D)
C***AUTHOR  Boland, W. Robert, (LANL)
C***SEE ALSO  QG8TST, QN79QX
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   920229  DATE WRITTEN
C***END PROLOGUE  FQD1
C     .. Scalar Arguments ..
      REAL X
C     .. Intrinsic Functions ..
      INTRINSIC SQRT
C***FIRST EXECUTABLE STATEMENT  FQD1
      FQD1 = 0.0E0
      IF (X .GT. 0.0E0) THEN
        FQD1 = 1.0E0/SQRT(X)
      ENDIF
      RETURN
      END

*DECK DXCSRT
      SUBROUTINE DXCSRT (DNU1, NUDIFF, MU1, MU2, THETA, P, Q, R, IP, IQ,
     1   IR, C1, IC1, C2, IC2, IERROR)
C***BEGIN PROLOGUE  DXCSRT
C***PURPOSE  TO COMPUTE CHECK VALUES FOR LEGENDRE FUNCTIONS
C***LIBRARY   SLATEC
C***CATEGORY  C3A2, C9
C***TYPE      SINGLE PRECISION (XCRST-S, DXCRST-D)
C***KEYWORDS  LEGENDRE FUNCTIONS
C***AUTHOR  SMITH, JOHN M., (NBS AND GEORGE MASON UNIVERSITY)
C***DESCRIPTION
C
C        SUBROUTINE DXCSRT CALCULATES CASORATI (CROSS PRODUCT)
C        CHECK VALUES AND STORES THEM IN ARRAYS C1 AND C2 WITH
C        EXPONENTS IN ARRAYS IC1 AND IC2.  CALCULATIONS ARE BASED
C        ON PREVIOUSLY CALCULATED LEGENDRE FUNCTIONS OF THE
C        FIRST KIND (NEGATIVE ORDER) IN ARRAY P, THE SECOND KIND
C        IN ARRAY Q, THE FIRST KIND (POSITIVE ORDER) IN ARRAY R.
C        RESULTS SHOULD BE 1.0 TO WITHIN ROUNDOFF ERROR.
C
C***SEE ALSO  FCNQX2
C***REFERENCES  OLVER AND SMITH,J.COMPUT.PHYSICS,51(1983),NO.3,502-518.
C***ROUTINES CALLED  DXADD, DXADJ, DXRED
C***REVISION HISTORY  (YYMMDD)
C   820728  DATE WRITTEN
C   890126  Revised to meet SLATEC CML recommendations.  (DWL and JMS)
C   901019  Revisions to prologue.  (DWL and WRB)
C   901106  Changed all specific intrinsics to generic.  (WRB)
C***END PROLOGUE  DXCSRT
      DOUBLE PRECISION C1,C2,DMU,DMU1,NU,DNU1,P,Q,R,THETA,SX,X1,X2
      DIMENSION P(*),IP(*),Q(*),IQ(*),R(*),IR(*)
      DIMENSION C1(*),IC1(*),C2(*),IC2(*)
C
C         PLACE ALL INPUT IN ADJUSTED FORM.
C
C***FIRST EXECUTABLE STATEMENT  DXCSRT
      IERROR=0
      L=NUDIFF+(MU2-MU1)+1
      LM1=L-1
      DO 500 I=1,L
      CALL DXADJ(P(I),IP(I),IERROR)
      IF (IERROR.NE.0) RETURN
      CALL DXADJ(Q(I),IQ(I),IERROR)
      IF (IERROR.NE.0) RETURN
      CALL DXADJ(R(I),IR(I),IERROR)
      IF (IERROR.NE.0) RETURN
  500 CONTINUE
C
C         CHECKS FOR FIXED MU, VARIABLE NU
C
      IF(MU2.GT.MU1) GO TO 700
      DMU1=MU1
      DO 650 I=1,LM1
      C1(I)=0.D0
      C2(I)=0.D0
      NU=DNU1+I-1.D0
C
C         CASORATI 2
C
C         (MU+NU+1)*P(-MU,NU+1,X)*Q(MU,NU,X)
C               +(MU-NU-1)*P(-MU,NU,X)*Q(MU,NU+1,X)=COS(MU*PI)
C
      X1=P(I+1)*Q(I)
      IX1=IP(I+1)+IQ(I)
      CALL DXADJ(X1,IX1,IERROR)
      IF (IERROR.NE.0) RETURN
      X2=P(I)*Q(I+1)
      IX2=IP(I)+IQ(I+1)
      CALL DXADJ(X2,IX2,IERROR)
      IF (IERROR.NE.0) RETURN
      X1=(DMU1+NU+1.D0)*X1
      X2=(DMU1-NU-1.D0)*X2
      CALL DXADD(X1,IX1,X2,IX2,C1(I),IC1(I),IERROR)
      IF (IERROR.NE.0) RETURN
      CALL DXADJ(C1(I),IC1(I),IERROR)
      IF (IERROR.NE.0) RETURN
C
C         MULTIPLY BY (-1)**MU SO THAT CHECK VALUE IS 1.
C
      C1(I)=C1(I)*(-1)**MU1
C
C         CASORATI 1
C
C         P(MU,NU+1,X)*Q(MU,NU,X)-P(MU,NU,X)*Q(MU,NU+1,X)=
C               GAMMA(NU+MU+1)/GAMMA(NU-MU+2)
C
      IF(DMU1.GE.NU+1.D0.AND.MOD(NU,1.D0).EQ.0.D0) GO TO 630
      X1=R(I+1)*Q(I)
      IX1=IR(I+1)+IQ(I)
      CALL DXADJ(X1,IX1,IERROR)
      IF (IERROR.NE.0) RETURN
      X2=R(I)*Q(I+1)
      IX2=IR(I)+IQ(I+1)
      CALL DXADJ(X2,IX2,IERROR)
      IF (IERROR.NE.0) RETURN
      CALL DXADD(X1,IX1,-X2,IX2,C2(I),IC2(I),IERROR)
      IF (IERROR.NE.0) RETURN
C
C         DIVIDE BY (NU+MU),(NU+MU-1),(NU+MU-2),....(NU-MU+2),
C         SO THAT CHECK VALUE IS 1.
C
      K=2*MU1-1
      DO 620 J=1,K
      IF(K.LE.0) GO TO 620
      C2(I)=C2(I)/(NU+DMU1+1.D0-J)
  620 CALL DXADJ(C2(I),IC2(I),IERROR)
      IF (IERROR.NE.0) RETURN
      IF(K.LE.0) C2(I)=(NU+1.D0)*C2(I)
      GO TO 650
  630 C2(I)=0.D0
      IC2(I)=0
  650 CONTINUE
      GO TO 800
C
C         CHECKS FOR FIXED NU, VARIABLE MU
C
  700 CONTINUE
      SX=SIN(THETA)
      DO 750 I=1,LM1
      C1(I)=0.D0
      C2(I)=0.D0
C
C         CASORATI 4
C
C         (MU+NU+1)*(MU-NU)*P(-(MU+1),NU,X)*Q(MU,NU,X)
C              -P(-MU,NU,X)*Q(MU+1,NU,X)=COS(MU*PI)/SQRT(1-X**2)
C
      MU=MU1+I-1
      DMU=MU
      X1=P(I+1)*Q(I)
      IX1=IP(I+1)+IQ(I)
      CALL DXADJ(X1,IX1,IERROR)
      IF (IERROR.NE.0) RETURN
      X2=P(I)*Q(I+1)
      IX2=IP(I)+IQ(I+1)
      CALL DXADJ(X2,IX2,IERROR)
      IF (IERROR.NE.0) RETURN
      X1=(DMU+DNU1+1.D0)*(DMU-DNU1)*X1
C
C         MULTIPLY BY SQRT(1-X**2)*(-1)**MU SO THAT CHECK VALUE IS 1.
C
      CALL DXADD(X1,IX1,-X2,IX2,C1(I),IC1(I),IERROR)
      IF (IERROR.NE.0) RETURN
      C1(I)=SX*C1(I)*(-1)**MU
      CALL DXADJ(C1(I),IC1(I),IERROR)
      IF (IERROR.NE.0) RETURN
C
C         CASORATI 3
C
C         P(MU+1,NU,X)*Q(MU,NU,X)-P(MU,NU,X)*Q(MU+1,NU,X)=
C               GAMMA(NU+MU+1)/(GAMMA(NU-MU+1)*SQRT(1-X**2))
C
      IF(DMU.GE.DNU1+1.D0.AND.MOD(DNU1,1.D0).EQ.0.D0) GO TO 750
      X1=R(I+1)*Q(I)
      IX1=IR(I+1)+IQ(I)
      CALL DXADJ(X1,IX1,IERROR)
      IF (IERROR.NE.0) RETURN
      X2=R(I)*Q(I+1)
      IX2=IR(I)+IQ(I+1)
      CALL DXADJ(X2,IX2,IERROR)
      IF (IERROR.NE.0) RETURN
      CALL DXADD(X1,IX1,-X2,IX2,C2(I),IC2(I),IERROR)
      IF (IERROR.NE.0) RETURN
C
C         MULTIPLY BY SQRT(1-X**2) AND THEN DIVIDE BY
C         (NU+MU),(NU+MU-1),(NU+MU-2),...,(NU-MU+1) SO THAT
C         CHECK VALUE IS 1.
C
      C2(I)=C2(I)*SX
      K=2*MU
      IF(K.LE.0) GO TO 750
      DO 740 J=1,K
      C2(I)=C2(I)/(DNU1+DMU+1.D0-J)
  740 CALL DXADJ(C2(I),IC2(I),IERROR)
      IF (IERROR.NE.0) RETURN
  750 CONTINUE
C
C         PLACE RESULTS IN REDUCED FORM.
C
  800 DO 810 I=1,LM1
      CALL DXRED(C1(I),IC1(I),IERROR)
      IF (IERROR.NE.0) RETURN
      CALL DXRED(C2(I),IC2(I),IERROR)
      IF (IERROR.NE.0) RETURN
  810 CONTINUE
      RETURN
      END

*DECK ZQCBH
      SUBROUTINE ZQCBH (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  ZQCBH
C***SUBSIDIARY
C***PURPOSE  Quick check for SLATEC subroutine
C            ZBESH
C***LIBRARY   SLATEC
C***CATEGORY  C10A4
C***TYPE      COMPLEX (CQCBH-C, ZQCBH-Z)
C***KEYWORDS  QUICK CHECK, ZBESH
C***AUTHOR  Amos, Don, (SNL)
C           Goudy, Sue, (SNL)
C           Walton, Lee, (SNL)
C***DESCRIPTION
C
C *Usage:
C
C        INTEGER  LUN, KPRINT, IPASS
C
C        CALL ZQCBH (LUN, KPRINT, IPASS)
C
C *Arguments:
C
C     LUN    :IN  is the unit number to which output is to be written.
C
C     KPRINT :IN  controls the amount of output, as specified in the
C                 SLATEC Guidelines.
C
C     IPASS  :OUT indicates whether the test passed or failed.
C                 A value of one is good, indicating no failures.
C
C *Description:
C
C                 *** A DOUBLE PRECISION ROUTINE ***
C
C   ZQCBH is a quick check routine for the complex H Bessel functions
C    generated by subroutine ZBESH.
C
C   ZQCBH generates sequences of H Bessel functions for kinds 1 and 2
C    from CBESH and checks them against the Wronskian evaluation
C    in the (Z,FNU) space.
C
C***REFERENCES  Abramowitz, M. and Stegun, I. A., Handbook
C                 of Mathematical Functions, Dover Publications,
C                 New York, 1964.
C               Amos, D. E., A Subroutine Package for Bessel
C                 Functions of a Complex Argument and Nonnegative
C                 Order, SAND85-1018, May, 1985.
C***ROUTINES CALLED  ZBESH, ZUOIK, ZABS, ZDIV, I1MACH, D1MACH
C***REVISION HISTORY  (YYMMDD)
C   830501  DATE WRITTEN
C   890831  Revised to meet new SLATEC standards
C***END PROLOGUE  ZQCBH
C
C*Internal Notes:
C   Machine constants are defined by functions I1MACH and D1MACH.
C
C   The parameter MQC can have values 1 (the default) for a faster,
C   less definitive test or 2 for a slower, more definitive test.
C
C**End
C
C  Set test complexity parameter.
C
      INTEGER  MQC
      PARAMETER (MQC=1)
C
C  Declare arguments.
C
      INTEGER  LUN, KPRINT, IPASS
C
C  Declare external functions.
C
      INTEGER  I1MACH
      DOUBLE PRECISION  D1MACH, ZABS
      EXTERNAL  I1MACH, D1MACH, ZABS
C
C  Declare local variables.
C
      DOUBLE PRECISION  CVR,CVI, CWR,CWI, CYR,CYI, WR,WI, YR,YI, ZR,ZI,
     *   ZNR,ZNI
      DOUBLE PRECISION  AA, AB, ACW, ACY, AER, ALIM, ATOL, AV, AW, AY,
     *   AZ, CT, DIG, ELIM, EPS, ER, ERTOL, FILM, FNU, FNUL, FPI, HPI,
     *   PI, R, RFPI, RL, RM, R1M4, R1M5, R2, SLAK, ST, T, TOL, TS, XNU
      INTEGER  I, ICASE, IERR, IL, IR, IRB, IT, ITL, K, KDO, KEPS, KK,
     *   KODE, K1, K2, LFLG, MFLG, N, NL, NU, NUL, NZ1, NZ2, N1
      DIMENSION  AER(20), KDO(20), KEPS(20), T(20), WR(20), WI(20),
     *   XNU(20), YR(20), YI(20)
C
C***FIRST EXECUTABLE STATEMENT  ZQCBH
      IF (KPRINT.GE.2) THEN
        WRITE (LUN,99999)
99999   FORMAT (' QUICK CHECK ROUTINE FOR THE H BESSEL FUNCTIONS FROM ',
     *     'ZBESH'/)
      ENDIF
C-----------------------------------------------------------------------
C     Set parameters related to machine constants.
C     TOL is the approximate unit roundoff limited to 1.0D-18.
C     ELIM is the approximate exponential over- and underflow limit.
C     exp(-ELIM).lt.exp(-ALIM)=exp(-ELIM)/TOL    and
C     exp(ELIM).gt.exp(ALIM)=exp(ELIM)*TOL       are intervals near
C     underflow and overflow limits where scaled arithmetic is done.
C     RL is the lower boundary of the asymptotic expansion for large Z.
C     DIG = number of base 10 digits in TOL = 10**(-DIG).
C     FNUL is the lower boundary of the asymptotic series for large FNU.
C-----------------------------------------------------------------------
      R1M4 = D1MACH(4)
      TOL = MAX(R1M4,1.0D-18)
      ATOL = 100.0D0*TOL
      AA = -LOG10(R1M4)
      K1 = I1MACH(12)
      K2 = I1MACH(13)
      R1M5 = D1MACH(5)
      K = MIN(ABS(K1),ABS(K2))
      ELIM = 2.303D0*(K*R1M5-3.0D0)
      AB = AA*2.303D0
      ALIM = ELIM + MAX(-AB,-41.45D0)
      DIG = MIN(AA,18.0D0)
      FNUL = 10.0D0 + 6.0D0*(DIG-3.0D0)
      RL = 1.2D0*DIG + 3.0D0
      SLAK = 3.0D0+4.0D0*(-LOG10(TOL)-7.0D0)/11.0D0
      SLAK = MAX(SLAK,3.0D0)
      ERTOL = TOL*10.0D0**SLAK
      RM = 0.5D0*(ALIM + ELIM)
      RM = MIN(RM,200.0D0)
      RM = MAX(RM,RL+10.0D0)
      R2 = MIN(FNUL,RM)
      IF (KPRINT.GE.2) THEN
        WRITE (LUN,99998)
99998   FORMAT (' PARAMETERS'/
     *     5X,'TOL ',8X,'ELIM',8X,'ALIM',8X,'RL  ',8X,'FNUL',8X,'DIG')
        WRITE (LUN,99997) TOL, ELIM, ALIM, RL, FNUL, DIG
99997   FORMAT (6D12.4/)
      ENDIF
C-----------------------------------------------------------------------
C     Set other constants needed in the tests.
C-----------------------------------------------------------------------
      FPI = ATAN(1.0D0)
      HPI = FPI + FPI
      PI = HPI + HPI
      RFPI = 1.0D0/FPI
      ZNR = 0.0D0
      ZNI = -RFPI
C-----------------------------------------------------------------------
C     Generate angles for construction of complex Z to be used in tests.
C-----------------------------------------------------------------------
C     KDO(K), K = 1,IL  determines which of the IL angles in -PI to PI
C     are used to compute values of Z.
C       KDO(K) = 0  means that the index K will be used for one or two
C                   values of Z, depending on the choice of KEPS(K)
C              = 1  means that the index K and the corresponding angle
C                   will be skipped
C     KEPS(K), K = 1,IL determines which of the angles get incremented
C     up and down to put values of Z in regions where different
C     formulae are used.
C       KEPS(K)  = 0  means that the angle will be used without change
C                = 1  means that the angle will be incremented up and
C                   down by EPS
C     The angles to be used are stored in the T(I) array, I = 1,ITL.
C-----------------------------------------------------------------------
      IF (MQC.NE.2) THEN
        NL = 2
        IL = 5
        DO 5 I = 1,IL
          KEPS(I) = 0
          KDO(I) = 0
    5   CONTINUE
        NUL = 5
        XNU(1) = 0.0D0
        XNU(2) = 1.0D0
        XNU(3) = 2.0D0
        XNU(4) = 0.5D0*FNUL
        XNU(5) = FNUL + 1.1D0
      ELSE
        NL = 4
        IL = 13
        DO 6 I = 1,IL
          KDO(I) = 0
          KEPS(I) = 0
    6   CONTINUE
        KDO(2) = 1
        KDO(6) = 1
        KDO(8) = 1
        KDO(12) = 1
        KEPS(3) = 1
        KEPS(4) = 1
        KEPS(5) = 1
        KEPS(9) = 1
        KEPS(10) = 1
        KEPS(11) = 1
        NUL = 6
        XNU(1) = 0.0D0
        XNU(2) = 0.6D0
        XNU(3) = 1.3D0
        XNU(4) = 2.0D0
        XNU(5) = 0.5D0*FNUL
        XNU(6) = FNUL + 1.1D0
      ENDIF
      I = 2
      EPS = 0.01D0
      FILM = IL - 1
      T(1) = -PI + EPS
      DO 30 K = 2,IL
        IF (KDO(K).EQ.0) THEN
          T(I) = PI*(-IL+2*K-1)/FILM
          IF (KEPS(K).NE.0) THEN
            TS = T(I)
            T(I) = TS - EPS
            I = I + 1
            T(I) = TS + EPS
          ELSE
            I = I + 1
          ENDIF
        ENDIF
   30 CONTINUE
      ITL = I - 1
C-----------------------------------------------------------------------
C     Test values of Z in -PI.lt.arg(Z).le.PI.
C-----------------------------------------------------------------------
      IF (KPRINT.GE.2) THEN
        WRITE (LUN,99996)
99996   FORMAT (' CHECKS IN THE (Z,FNU) SPACE'/)
      ENDIF
      LFLG = 0
      DO 170 KODE = 1,2
        DO 160 N = 1,NL
          N1 = N + 1
          DO 150 NU = 1,NUL
            FNU = XNU(NU)
            DO 140 ICASE = 1,3
              IRB = MIN(ICASE,2)
              DO 130 IR = IRB,3
C-------------- switch (icase)
                GO TO (50, 60, 70), ICASE
   50           CONTINUE
                  R = (EPS*(3-IR)+2.0D0*(IR-1))/2.0D0
                  GO TO 80
   60           CONTINUE
                  R = (2.0D0*(3-IR)+R2*(IR-1))/2.0D0
                  GO TO 80
   70           CONTINUE
                  IF (R2.GE.RM) GO TO 140
                  R = (R2*(3-IR)+RM*(IR-1))/2.0D0
   80           CONTINUE
C-------------- end switch
                DO 120 IT = 1,ITL
                  CT = COS(T(IT))
                  ST = SIN(T(IT))
                  IF (ABS(CT).LT.ATOL) CT = 0.0D0
                  IF (ABS(ST).LT.ATOL) ST = 0.0D0
                  ZR = R*CT
                  ZI = R*ST
                  IF (FNU.GE.2.0D0) THEN
C------------------ Check for possible overflow condition
                    CVR = -ZI
                    CVI = ZR
                    CALL ZUOIK(CVR, CVI, FNU, KODE, 2, N1, WR, WI, NZ2,
     *                 TOL, ELIM, ALIM)
C------------------ Overflow detected? - skip test for this case
                    IF (NZ2.EQ.(-1)) GO TO 120
                    CVR = -CVR
                    CVI = -CVI
                    CALL ZUOIK(CVR, CVI, FNU, KODE, 2, N1, WR, WI,
     *                 NZ2, TOL, ELIM, ALIM)
C------------------ Overflow detected? - skip test for this case
                    IF (NZ2.EQ.(-1)) GO TO 120
                  ENDIF
C---------------- No overflow - calculate H1(Z,FNU) and H2(Z,FNU)
                  CALL ZBESH(ZR, ZI, FNU, KODE, 1, N1, YR, YI, NZ1,
     *               IERR)
C---------------- Underflow? - skip test for this case
                  IF (NZ1.NE.0) GO TO 120
                  CALL ZBESH(ZR, ZI, FNU, KODE, 2, N1, WR, WI, NZ2,
     *               IERR)
C---------------- Underflow? - skip test for this case
                  IF (NZ2.NE.0) GO TO 120
C-----------------------------------------------------------------------
C     Compare ZN/Z with the Wronskian of H1(Z,FNU) and H2(Z,FNU).
C     ZN = -4i/PI
C-----------------------------------------------------------------------
                  CALL ZDIV(ZNR, ZNI, ZR, ZI, CVR, CVI)
                  MFLG = 0
                  DO 100 I = 1,N
C-----------------------------------------------------------------------
C     Error relative to maximum term
C-----------------------------------------------------------------------
                    AW = ZABS(WR(I+1),WI(I+1))
                    AY = ZABS(YR(I),YI(I))
                    AZ = LOG(AW) + LOG(AY)
                    AZ = ABS(AZ)
                    IF (AZ.LE.ALIM) THEN
C-------------------- No scaling problem - do error analysis
                      AV = ZABS(CVR,CVI)
                      CWR = WR(I)*YR(I+1) - WI(I)*YI(I+1)
                      CWI = WR(I)*YI(I+1) + WI(I)*YR(I+1)
                      CYR = WR(I+1)*YR(I) - WI(I+1)*YI(I)
                      CYI = WR(I+1)*YI(I) + WI(I+1)*YR(I)
                      CYR = CWR - CYR - CVR
                      CYI = CWI - CYI - CVI
                      ACY = AW*AY
                      ACW = ZABS(WR(I),WI(I))*ZABS(YR(I+1),YI(I+1))
                      AV = MAX(ACW,ACY,AV)
                      ER = ZABS(CYR,CYI)/AV
                      AER(I) = ER
                      IF (ER.GT.ERTOL) THEN
                        MFLG = 1
                      ENDIF
                    ENDIF
  100             CONTINUE
                  IF (MFLG.NE.0) THEN
                    IF (LFLG.EQ.0) THEN
                      IF (KPRINT.GE.2) THEN
                        WRITE (LUN,99995) ERTOL
99995                   FORMAT (' CASES WHICH VIOLATE THE RELATIVE ',
     *                     'ERROR TEST WITH ERTOL = ',D12.4/)
                        WRITE (LUN,99994)
99994                   FORMAT (' INPUT TO ZBESH   Z, FNU, KODE, N')
                      ENDIF
                      IF (KPRINT.GE.3) THEN
                        WRITE (LUN,99993)
99993                   FORMAT (' COMPARE -4i/(PI*Z) WITH WRONSKIAN OF',
     *                     ' H1(Z,FNU) AND H2(Z,FNU)')
                        WRITE (LUN,99992)
99992                   FORMAT (' RESULTS FROM ZBESH FOR FUNCTION H1'/
     *                     '         AND FUNCTION H2')
                        WRITE (LUN,99991)
99991                   FORMAT (' TEST CASE INDICES'/)
                      ENDIF
                    ENDIF
                    LFLG = LFLG + 1
                    IF (KPRINT.GE.2) THEN
                      WRITE (LUN,99990) ZR, ZI, FNU, KODE, N
99990                 FORMAT ('   INPUT:    Z=',2D12.4,4X,'FNU=',D12.4,
     *                   4X,'KODE=',I3,4X,'N=',I3)
                    ENDIF
                    IF (KPRINT.GE.3) THEN
                      WRITE (LUN,99989) (AER(K),K=1,N)
99989                 FORMAT ('   ERROR:   AER(K)=',4D12.4)
                      KK = MAX(NZ1,NZ2) + 1
                      KK = MIN(N,KK)
                      WRITE (LUN,99988) NZ1, YR(KK), YI(KK),
     *                   NZ2, WR(KK), WI(KK)
99988                 FORMAT (' RESULTS:  NZ1=',I3,4X,'Y(KK)=',2D12.4/
     *                   11X,'NZ2=',I3,4X,'W(KK)=',2D12.4)
                      WRITE (LUN,99987) IT, IR, ICASE
99987                 FORMAT ('    CASE:   IT=',I3,4X,'IR=',I3,4X,
     *                   'ICASE=',I3/)
                    ENDIF
                  ENDIF
  120           CONTINUE
  130         CONTINUE
  140       CONTINUE
  150     CONTINUE
  160   CONTINUE
  170 CONTINUE
      IF (KPRINT.GE.2) THEN
        IF (LFLG.EQ.0) THEN
          WRITE (LUN,99986)
99986     FORMAT (' QUICK CHECKS OK')
        ELSE
          WRITE (LUN,99985) LFLG
99985     FORMAT (' ***',I5,' FAILURE(S) FOR ZBESH IN THE (Z,FNU)',
     *      ' PLANE')
        ENDIF
      ENDIF
      IPASS = 0
      IF (LFLG.EQ.0) THEN
        IPASS = 1
      ENDIF
      IF (IPASS.EQ.1.AND.KPRINT.GE.2) THEN
        WRITE (LUN,99984)
99984   FORMAT (/' ****** ZBESH  PASSED ALL TESTS  ******'/)
      ENDIF
      IF (IPASS.EQ.0.AND.KPRINT.GE.1) THEN
        WRITE (LUN,99983)
99983   FORMAT (/' ****** ZBESH  FAILED SOME TESTS ******'/)
      ENDIF
      RETURN
      END

*DECK DPFITT
      SUBROUTINE DPFITT (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  DPFITT
C***PURPOSE  Quick check for DPOLFT, DPCOEF and DP1VLU.
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (PFITQX-S, DPFITT-D)
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  D1MACH, DCMPAR, DP1VLU, DPCOEF, DPOLFT, PASS,
C                    XERCLR, XGETF, XSETF
C***COMMON BLOCKS    DCHECK
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890921  Realigned order of variables in the COMMON block.
C           (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900911  Test problem changed and cosmetic changes to code.  (WRB)
C   901205  Changed usage of D1MACH(3) to D1MACH(4) and modified the
C           FORMATs.  (RWC)
C   910708  Minor modifications in use of KPRINT.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900911  Test problem changed and cosmetic changes to code.  (WRB)
C   920214  Code restructured to test for all values of KPRINT and to
C           provide more PASS/FAIL information.  (WRB)
C***END PROLOGUE  DPFITT
C     .. Scalar Arguments ..
      INTEGER IPASS, KPRINT, LUN
C     .. Scalars in Common ..
      DOUBLE PRECISION EPS, RP, SVEPS, TOL
      INTEGER IERP, IERR, NORD, NORDP
C     .. Arrays in Common ..
      DOUBLE PRECISION R(11)
C     .. Local Scalars ..
      DOUBLE PRECISION YFIT
      INTEGER I, ICNT, M, MAXORD
C     .. Local Arrays ..
      DOUBLE PRECISION A(97), TC(5), W(11), X(11), Y(11), YP(5)
      INTEGER ITEST(9)
C     .. External Functions ..
      DOUBLE PRECISION D1MACH
      EXTERNAL D1MACH
C     .. External Subroutines ..
      EXTERNAL DCMPAR, PASS, DPCOEF, DPOLFT, DP1VLU
C     .. Intrinsic Functions ..
      INTRINSIC ABS, SQRT
C     .. Common blocks ..
      COMMON /DCHECK/ EPS, R, RP, SVEPS, TOL, NORDP, NORD, IERP, IERR
C***FIRST EXECUTABLE STATEMENT  DPFITT
      IF (KPRINT .GE. 2) WRITE (LUN,FMT=9000)
C
C     Initialize variables for testing passage or failure of tests
C
      DO 100 I = 1,9
        ITEST(I) = 0
  100 CONTINUE
      ICNT = 0
      TOL = SQRT(D1MACH(4))
      M = 11
      DO 110 I = 1,M
        X(I) = I - 6
        Y(I) = X(I)**4
  110 CONTINUE
C
C     Test DPOLFT
C     Input EPS is negative - specified level
C
      W(1) = -1.0D0
      EPS = -0.01D0
      SVEPS = EPS
      MAXORD = 8
      NORDP = 4
      RP = 625.0D0
      IERP = 1
      CALL DPOLFT (M, X, Y, W, MAXORD, NORD, EPS, R, IERR, A)
C
C     See if test passed
C
      CALL DCMPAR (ICNT, ITEST)
C
C     Check for suppression of printing.
C
      IF (KPRINT .EQ. 0) GO TO 130
      IF (KPRINT.EQ.1 .AND. ITEST(ICNT).EQ.1) GO TO 130
      WRITE (LUN,FMT=9010)
      WRITE (LUN,FMT=9020)
      IF (KPRINT.LE.2 .AND. ITEST(ICNT).EQ.1) GO TO 120
      WRITE (LUN,FMT=9030) SVEPS,NORDP,RP,IERP
      WRITE (LUN,FMT=9040) EPS,NORD,R(11),IERR
C
C     Send message indicating passage or failure of test
C
  120 CALL PASS (LUN, ICNT, ITEST(ICNT))
C
C     Input EPS is negative - computed level
C
  130 EPS = -1.0D0
      SVEPS = EPS
      CALL DPOLFT (M, X, Y, W, MAXORD, NORD, EPS, R, IERR, A)
C
C     See if test passed
C
      CALL DCMPAR (ICNT, ITEST)
C
C     Check for suppression of printing.
C
      IF (KPRINT .EQ. 0) GO TO 150
      IF (KPRINT.EQ.1 .AND. ITEST(ICNT).EQ.1) GO TO 150
      WRITE (LUN,FMT=9050)
      IF (KPRINT.LE.2 .AND. ITEST(ICNT).EQ.1) GO TO 140
      WRITE (LUN,FMT=9060) MAXORD
      WRITE (LUN,FMT=9030) SVEPS,NORDP,RP,IERP
      WRITE (LUN,FMT=9040) EPS,NORD,R(11),IERR
C
C     Send message indicating passage or failure of test
C
  140 CALL PASS (LUN, ICNT, ITEST(ICNT))
C
C     Input EPS is zero
C
  150 W(1) = -1.0D0
      EPS = 0.0D0
      SVEPS = EPS
      NORDP = 5
      MAXORD = 5
      CALL DPOLFT (M, X, Y, W, MAXORD, NORD, EPS, R, IERR, A)
C
C     See if test passed
C
      CALL DCMPAR (ICNT, ITEST)
C
C     Check for suppression of printing.
C
      IF (KPRINT .EQ. 0) GO TO 170
      IF (KPRINT.EQ.1 .AND. ITEST(ICNT).EQ.1) GO TO 170
      WRITE (LUN,FMT=9070)
      IF (KPRINT.LE.2 .AND. ITEST(ICNT).EQ.1) GO TO 160
      WRITE (LUN,FMT=9060) MAXORD
      WRITE (LUN,FMT=9030) SVEPS,NORDP,RP,IERP
      WRITE (LUN,FMT=9040) EPS,NORD,R(11),IERR
C
C     Send message indicating passage or failure of test
C
  160 CALL PASS (LUN, ICNT, ITEST(ICNT))
C
C     Input EPS is positive
C
  170 IERP = 1
      NORDP = 4
      EPS = 75.0D0*D1MACH(4)
      SVEPS = EPS
      CALL DPOLFT (M, X, Y, W, MAXORD, NORD, EPS, R, IERR, A)
C
C     See if test passed
C
      CALL DCMPAR (ICNT, ITEST)
C
C     Check for suppression of printing.
C
      IF (KPRINT .EQ. 0) GO TO 190
      IF (KPRINT.EQ.1 .AND. ITEST(ICNT).EQ.1) GO TO 190
      WRITE (LUN,FMT=9080)
      IF (KPRINT.LE.2 .AND. ITEST(ICNT).EQ.1) GO TO 180
      WRITE (LUN,FMT=9060) MAXORD
      WRITE (LUN,FMT=9030) SVEPS,NORDP,RP,IERP
      WRITE (LUN,FMT=9040) EPS,NORD,R(11),IERR
C
C     Send message indicating passage or failure of test
C
  180 CALL PASS (LUN, ICNT, ITEST(ICNT))
C
C     Improper input
C
  190 IERP = 2
      M = -2
C
C     Check for suppression of printing.
C
      CALL XGETF (KONTRL)
      IF (KPRINT .LE. 2) THEN
         CALL XSETF (0)
      ELSE
         CALL XSETF (1)
      ENDIF
      CALL XERCLR
C
      IF (KPRINT .GE. 3) WRITE (LUN,9090)
      CALL DPOLFT (M, X, Y, W, MAXORD, NORD, EPS, R, IERR, A)
C
C     See if test passed
C
      ICNT = ICNT + 1
      IF (IERR .EQ. 2) THEN
        ITEST(ICNT) = 1
        IF (KPRINT .GE. 3) THEN
          WRITE (LUN, 9100) 'PASSED', IERR
        ENDIF
      ELSE
        IF (KPRINT .GE. 2) THEN
          WRITE (LUN, 9100) 'FAILED', IERR
        ENDIF
      ENDIF
C
C     Check for suppression of printing.
C
      IF (KPRINT .EQ. 0) GO TO 210
      IF (KPRINT.EQ.1 .AND. ITEST(ICNT).EQ.1) GO TO 210
      IF (KPRINT.LE.2 .AND. ITEST(ICNT).EQ.1) GO TO 200
C
C     Send message indicating passage or failure of test
C
  200 CALL PASS (LUN, ICNT, ITEST(ICNT))
C
      CALL XERCLR
      CALL XSETF (KONTRL)
C
C     MAXORD too small to meet RMS error
C
  210 M = 11
      W(1) = -1.0D0
      EPS = 5.0D0*D1MACH(4)
      SVEPS = EPS
      RP = 553.0D0
      MAXORD = 2
      IERP = 3
      NORDP = 2
      CALL DPOLFT (M, X, Y, W, MAXORD, NORD, EPS, R, IERR, A)
C
C     See if test passed
C
      CALL DCMPAR (ICNT, ITEST)
C
C     Check for suppression of printing.
C
      IF (KPRINT .EQ. 0) GO TO 230
      IF (KPRINT.EQ.1 .AND. ITEST(ICNT).EQ.1) GO TO 230
      WRITE (LUN,FMT=9110)
      IF (KPRINT.LE.2 .AND. ITEST(ICNT).EQ.1) GO TO 220
      WRITE (LUN,FMT=9060) MAXORD
      WRITE (LUN,FMT=9030) SVEPS,NORDP,RP,IERP
      WRITE (LUN,FMT=9040) EPS,NORD,R(11),IERR
C
C     Send message indicating passage or failure of test
C
  220 CALL PASS (LUN, ICNT, ITEST(ICNT))
C
C     MAXORD too small to meet statistical test
C
  230 NORDP = 4
      IERP = 4
      RP = 625.0D0
      EPS = -0.01D0
      SVEPS = EPS
      MAXORD = 5
      CALL DPOLFT (M, X, Y, W, MAXORD, NORD, EPS, R, IERR, A)
C
C     See if test passed
C
      CALL DCMPAR (ICNT, ITEST)
C
C     Check for suppression of printing.
C
      IF (KPRINT .EQ. 0) GO TO 250
      IF (KPRINT.EQ.1 .AND. ITEST(ICNT).EQ.1) GO TO 250
      WRITE (LUN,FMT=9120)
      IF (KPRINT.LE.2 .AND. ITEST(ICNT).EQ.1) GO TO 240
      WRITE (LUN,FMT=9060) MAXORD
      WRITE (LUN,FMT=9030) SVEPS,NORDP,RP,IERP
      WRITE (LUN,FMT=9040) EPS,NORD,R(11),IERR
C
C     Send message indicating passage or failure of test
C
  240 CALL PASS (LUN, ICNT, ITEST(ICNT))
C
C     Test DPCOEF
C
  250 MAXORD = 6
      EPS = 0.0D0
      SVEPS = EPS
      Y(6) = 1.0D0
      DO 260 I = 1,M
        W(I) = 1.0D0/(Y(I)**2)
  260 CONTINUE
      Y(6) = 0.0D0
      CALL DPOLFT (M, X, Y, W, MAXORD, NORD, EPS, R, IERR, A)
      CALL DPCOEF (4, 5.0D0, TC, A)
C
C     See if test passed
C
      ICNT = ICNT + 1
      IF (ABS(R(11)-TC(1)) .LE. TOL) ITEST(ICNT) = 1
C
C     Check for suppression of printing
C
      IF (KPRINT .EQ. 0) GO TO 280
      IF (KPRINT.EQ.1 .AND. ITEST(ICNT).EQ.1) GO TO 280
      WRITE (LUN,FMT=9130)
      IF (KPRINT.LE.2 .AND. ITEST(ICNT).EQ.1) GO TO 270
      WRITE (LUN,FMT=9140) R(11),TC(1)
C
C     Send message indicating passage or failure of test
C
  270 CALL PASS (LUN, ICNT, ITEST(ICNT))
C
C     Test DP1VLU
C     Normal call
C
  280 CALL DP1VLU (6, 0, X(8), YFIT, YP, A)
C
C     See if test passed
C
      ICNT = ICNT + 1
      IF (ABS(R(8)-YFIT) .LE. TOL) ITEST(ICNT) = 1
C
C     Check for suppression of printing
C
      IF (KPRINT .EQ. 0) GO TO 300
      IF (KPRINT.EQ.1 .AND. ITEST(ICNT).EQ.1) GO TO 300
      WRITE (LUN,FMT=9150)
      WRITE (LUN,FMT=9160)
      IF (KPRINT.LE.2 .AND. ITEST(ICNT).EQ.1) GO TO 290
      WRITE (LUN,FMT=9170) X(8),R(8),YFIT
C
C     Send message indicating passage or failure of test
C
  290 CALL PASS (LUN, ICNT, ITEST(ICNT))
C
C     Check to see if all tests passed
C
  300 IPASS = 1
      DO 310 I = 1,9
        IPASS = IPASS*ITEST(I)
  310 CONTINUE
C
      IF (IPASS.EQ.1 .AND. KPRINT.GE.3) WRITE (LUN,FMT=9180)
      IF (IPASS.EQ.0 .AND. KPRINT.GE.2) WRITE (LUN,FMT=9190)
      RETURN
C
 9000 FORMAT ('1' / ' Test DPOLFT, DPCOEF and DP1VLU')
 9010 FORMAT (' Exercise DPOLFT')
 9020 FORMAT (' Input EPS is negative - specified significance level')
 9030 FORMAT (' Input EPS =  ', E15.8, '   correct order =  ', I3,
     +        '   R(1) = ', E15.8, '   IERR = ', I1)
 9040 FORMAT (' Output EPS = ', E15.8, '   computed order = ', I3,
     +        '   R(1) = ', E15.8, '   IERR = ', I1)
 9050 FORMAT (/ ' Input EPS is negative - computed significance level')
 9060 FORMAT (' Maximum order = ', I2)
 9070 FORMAT (/ ' Input EPS is zero')
 9080 FORMAT (/ ' Input EPS is positive')
 9090 FORMAT (/ ' Invalid input')
 9100 FORMAT (' DPOLFT incorrect argument test ', A /
     +        ' IERR should be 2.  It is ', I4)
 9110 FORMAT (/ ' Cannot meet RMS error requirement')
 9120 FORMAT (/ ' Cannot satisfy statistical test')
 9130 FORMAT (/ ' Exercise DPCOEF')
 9140 FORMAT (/ ' For C=1.0, correct coefficient = ', E15.8,
     +        '   computed = ', E15.8)
 9150 FORMAT (/ ' Exercise DP1VLU')
 9160 FORMAT (' Normal execution')
 9170 FORMAT (' For X = ', F5.2, '   correct P(X) = ', E15.8,
     +        '    P(X) from DP1VLU = ', E15.8)
 9180 FORMAT (/' ***************DPOLFT PASSED ALL TESTS***************')
 9190 FORMAT (/' ***************DPOLFT FAILED SOME TESTS**************')
      END

*DECK DNSQQK
      SUBROUTINE DNSQQK (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  DNSQQK
C***PURPOSE  Quick check for DNSQE and DNSQ.
C***LIBRARY   SLATEC
C***TYPE      DOUBLE PRECISION (SNSQQK-S, DNSQQK-D)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C   This subroutine performs a quick check on the subroutine DNSQE
C   (and DNSQ).
C
C***ROUTINES CALLED  D1MACH, DENORM, DNSQE, DQFCN2, DQJAC2, PASS
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   890618  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920310  Code cleaned up and TYPE section added.  (RWC, WRB)
C***END PROLOGUE  DNSQQK
C     .. Scalar Arguments ..
      INTEGER IPASS, KPRINT, LUN
C     .. Local Scalars ..
      DOUBLE PRECISION FNORM, FNORMS, TOL
      INTEGER ICNT, INFO, INFOS, IOPT, LWA, N, NPRINT
C     .. Local Arrays ..
      DOUBLE PRECISION FVEC(2), WA(19), X(2)
      INTEGER ITEST(3)
C     .. External Functions ..
      DOUBLE PRECISION D1MACH, DENORM
      EXTERNAL D1MACH, DENORM
C     .. External Subroutines ..
      EXTERNAL DNSQE, DQFCN2, DQJAC2, PASS
C     .. Intrinsic Functions ..
      INTRINSIC SQRT
C***FIRST EXECUTABLE STATEMENT  DNSQQK
      INFOS = 1
      FNORMS = 0.0D0
      N = 2
      LWA = 19
      NPRINT = -1
      TOL = SQRT(D1MACH(4))
      IF (KPRINT .GE. 2) WRITE (LUN,9000)
C
C     Option 1, the user provides the Jacobian.
C
      IOPT = 1
      X(1) = -1.2D0
      X(2) = 1.0D0
      CALL DNSQE (DQFCN2,DQJAC2,IOPT,N,X,FVEC,TOL,NPRINT,INFO,WA,LWA)
      ICNT = 1
      FNORM = DENORM(N,FVEC)
      ITEST(ICNT) = 0
      IF ((INFO.EQ.INFOS) .AND. (FNORM-FNORMS.LE.TOL)) ITEST(ICNT) = 1
C
      IF (KPRINT .NE. 0) THEN
         IF ((KPRINT.GE.2 .AND. ITEST(ICNT).NE.1) .OR. KPRINT.GE.3)
     +       WRITE (LUN,9010) INFOS,FNORMS,INFO,FNORM
         IF ((KPRINT.GE.2) .OR. (KPRINT.EQ.1 .AND. ITEST(ICNT).NE.1))
     +       CALL PASS (LUN, ICNT, ITEST(ICNT))
      ENDIF
C
C     Option 2, the code approximates the Jacobian.
C
      IOPT = 2
      X(1) = -1.2D0
      X(2) = 1.0D0
      CALL DNSQE (DQFCN2,DQJAC2,IOPT,N,X,FVEC,TOL,NPRINT,INFO,WA,LWA)
      ICNT = 2
      FNORM = DENORM(N,FVEC)
      ITEST(ICNT) = 0
      IF ((INFO.EQ.INFOS) .AND. (FNORM-FNORMS.LE.TOL)) ITEST(ICNT) = 1
C
      IF (KPRINT .NE. 0) THEN
         IF (KPRINT.GE.3 .OR. (KPRINT.GE.2.AND.ITEST(ICNT).NE.1))
     +       WRITE (LUN,9010) INFOS, FNORMS, INFO, FNORM
         IF (KPRINT.GE.2 .OR. (KPRINT.EQ.1.AND.ITEST(ICNT).NE.1))
     +       CALL PASS (LUN, ICNT, ITEST(ICNT))
      ENDIF
C
C     Test improper input parameters.
C
      LWA = 15
      IOPT = 1
      X(1) = -1.2D0
      X(2) = 1.0D0
      CALL DNSQE (DQFCN2,DQJAC2,IOPT,N,X,FVEC,TOL,NPRINT,INFO,WA,LWA)
      ICNT = 3
      ITEST(ICNT) = 0
      IF (INFO .EQ. 0) ITEST(ICNT) = 1
      IF (KPRINT.GE.2 .OR. (KPRINT.EQ.1.AND.ITEST(ICNT).NE.1))
     +    CALL PASS (LUN, ICNT, ITEST(ICNT))
C
C     Set IPASS.
C
      IPASS = ITEST(1)*ITEST(2)*ITEST(3)
      IF (KPRINT.GE.1 .AND. IPASS.NE.1) WRITE (LUN,9020)
      IF (KPRINT.GE.2 .AND. IPASS.EQ.1) WRITE (LUN,9030)
      RETURN
 9000 FORMAT ('1' / '  DNSQE QUICK CHECK'/)
 9010 FORMAT (' EXPECTED VALUE OF INFO AND RESIDUAL NORM', I5, D20.5 /
     +        ' RETURNED VALUE OF INFO AND RESIDUAL NORM', I5, D20.5 /)
 9020 FORMAT (/' **********WARNING -- DNSQE/DNSQ FAILED SOME TESTS****',
     +        '******')
 9030 FORMAT (/' ----------DNSQE/DNSQ PASSED ALL TESTS----------')
      END

*DECK SCHK53
      SUBROUTINE SCHK53 (SNAME, EPS, THRESH, NOUT, KPRINT, FATAL, NIDIM,
     $   IDIM, NALF, ALF, NBET, BET, NMAX, AB, AA, AS, BB, BS, C, CC,
     $   CS, CT, G, W)
C***BEGIN PROLOGUE  SCHK53
C***SUBSIDIARY
C***PURPOSE  Quick check for SSYR2K.
C***LIBRARY   SLATEC (BLAS)
C***KEYWORDS  BLAS, QUICK CHECK SERVICE ROUTINE
C***AUTHOR  Dongarra, J. J., (ANL)
C           Duff, I., (AERE)
C           Du Croz, J., (NAG)
C           Hammarling, S., (NAG)
C***DESCRIPTION
C
C  Quick check for SSYR2K.
C
C  Auxiliary routine for test program for Level 3 Blas.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  LSE, LSERES, NUMXER, SMAKE3, SMMCH, SSYR2K
C***REVISION HISTORY  (YYMMDD)
C   890208  DATE WRITTEN
C   910619  Modified to meet SLATEC code and prologue standards.  (BKS)
C***END PROLOGUE  SCHK53
C     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0)
C     .. Scalar Arguments ..
      LOGICAL            FATAL
      REAL               EPS, THRESH
      INTEGER            KPRINT, NALF, NBET, NIDIM, NMAX, NOUT
      CHARACTER*6        SNAME
C     .. Array Arguments ..
      REAL               AA( NMAX*NMAX), ALF( NALF),
     $                   AS( NMAX*NMAX ), BET( NBET ), G( NMAX ),
     $                   BB( NMAX*NMAX ),
     $                   BS( NMAX*NMAX ), C( NMAX, NMAX ),
     $                   CC( NMAX*NMAX ), CS( NMAX*NMAX ),
     $                   CT( NMAX ), W( 2*NMAX ), AB(2*NMAX*NMAX)
      INTEGER            IDIM( NIDIM )
C     .. Local Scalars ..
      REAL               ALPHA, ALS, BETA, BETS, ERR, ERRMAX
      INTEGER            I, IA, IB, ICT, ICU, IK, IN, J, JC, JJ, K, LAA,
     $                   LBB, LCC, LDA, LDAS, LDB, LDBS, LDC, LDCS,
     $                   N, NA, NARGS, NC, NERR, NS, KS, LJ, MA, JJAB
      LOGICAL            FTL, NULL, RESET, TRAN, UPPER
      CHARACTER*1        UPLO, UPLOS, TRANS, TRANSS
      CHARACTER*2        ICHU
      CHARACTER*3        ICHT
C     .. Local Arrays ..
      LOGICAL            ISAME( 13 )
C     .. External Functions ..
      INTEGER            NUMXER
      LOGICAL            LSE, LSERES
      EXTERNAL           LSE, LSERES, NUMXER
C     .. External Subroutines ..
      EXTERNAL           SSYR2K, SMAKE3, SMMCH
C     .. Intrinsic Functions ..
      INTRINSIC          MAX
C     .. Data statements ..
      DATA               ICHT/'NTC'/, ICHU/'UL'/
C***FIRST EXECUTABLE STATEMENT  SCHK53
      NARGS = 12
C
      NC = 0
      RESET = .TRUE.
      ERRMAX = ZERO
C
C
      DO 130 IN = 1, NIDIM
         N = IDIM( IN )
C        Set LDC to 1 more than minimum value if room.
         LDC = N
         IF( LDC.LT.NMAX )
     $      LDC = LDC + 1
C        Skip tests if not enough room.
         IF( LDC.GT.NMAX )
     $      GO TO 130
         LCC = LDC*N
         NULL = N.LE.0
C
         DO 120 IK = 1, NIDIM
            K = IDIM( IK )
C
            DO 110 ICT = 1, 3
               TRANS = ICHT( ICT: ICT )
               TRAN = TRANS.EQ.'T'.OR.TRANS.EQ.'C'
               IF( TRAN )THEN
                  MA = K
                  NA = N
               ELSE
                  MA = N
                  NA = K
               END IF
C              Set LDA to 1 more than minimum value if room.
               LDA = MA
               IF( LDA.LT.NMAX )
     $            LDA = LDA + 1
C              Skip tests if not enough room.
               IF( LDA.GT.NMAX )
     $            GO TO 110
               LAA = LDA*NA
C
C              Generate the matrix A.
C
               IF( TRAN )THEN
                  CALL SMAKE3( 'GE', ' ', ' ', MA, NA, AB, 2*NMAX, AA,
     $                        LDA, RESET, ZERO )
               ELSE
                  CALL SMAKE3('GE', ' ', ' ', MA, NA, AB, NMAX, AA, LDA,
     $                        RESET, ZERO )
               END IF
C
C              Generate the matrix B.
C
               LDB = LDA
               LBB = LAA
               IF( TRAN )THEN
                  CALL SMAKE3( 'GE', ' ', ' ', MA, NA, AB( K + 1 ),
     $                        2*NMAX, BB, LDB, RESET, ZERO )
               ELSE
                  CALL SMAKE3( 'GE', ' ', ' ', MA, NA, AB( K*NMAX + 1 ),
     $                        NMAX, BB, LDB, RESET, ZERO )
               END IF
C
               DO 100 ICU = 1, 2
                  UPLO = ICHU( ICU: ICU )
                  UPPER = UPLO.EQ.'U'
C
                  DO 90 IA = 1, NALF
                     ALPHA = ALF( IA )
C
                     DO 80 IB = 1, NBET
                        BETA = BET( IB )
C
C                       Generate the matrix C.
C
                        CALL SMAKE3( 'SY', UPLO, ' ', N, N, C, NMAX, CC,
     $                              LDC, RESET, ZERO )
C
                        NC = NC + 1
C
C                       Save every datum before calling the subroutine.
C
                        UPLOS = UPLO
                        TRANSS = TRANS
                        NS = N
                        KS = K
                        ALS = ALPHA
                        DO 10 I = 1, LAA
                           AS( I ) = AA( I )
   10                   CONTINUE
                        LDAS = LDA
                        DO 20 I = 1, LBB
                           BS( I ) = BB( I )
   20                   CONTINUE
                        LDBS = LDB
                        BETS = BETA
                        DO 30 I = 1, LCC
                           CS( I ) = CC( I )
   30                   CONTINUE
                        LDCS = LDC
C
C                       Call the subroutine.
C
                        CALL SSYR2K( UPLO, TRANS, N, K, ALPHA, AA, LDA,
     $                               BB, LDB, BETA, CC, LDC )
C
C                       Check if error-exit was taken incorrectly.
C
                        IF( NUMXER(NERR) .NE. 0) THEN
                          IF (KPRINT .GE. 2) THEN
                           WRITE( NOUT, FMT = 9993 )
                          ENDIF
                          FATAL = .TRUE.
                        END IF
C
C                       See what data changed inside subroutines.
C
                        ISAME( 1 ) = UPLOS.EQ.UPLO
                        ISAME( 2 ) = TRANSS.EQ.TRANS
                        ISAME( 3 ) = NS.EQ.N
                        ISAME( 4 ) = KS.EQ.K
                        ISAME( 5 ) = ALS.EQ.ALPHA
                        ISAME( 6 ) = LSE( AS, AA, LAA )
                        ISAME( 7 ) = LDAS.EQ.LDA
                        ISAME( 8 ) = LSE( BS, BB, LBB )
                        ISAME( 9 ) = LDBS.EQ.LDB
                        ISAME( 10 ) = BETS.EQ.BETA
                        IF( NULL )THEN
                           ISAME( 11 ) = LSE( CS, CC, LCC )
                        ELSE
                           ISAME( 11 ) = LSERES( 'SY', UPLO, N, N, CS,
     $                                   CC, LDC )
                        END IF
                        ISAME( 12 ) = LDCS.EQ.LDC
C
C                       If data was incorrectly changed, report and
C                       return.
C
                        DO 40 I = 1, NARGS
                          IF (.NOT. ISAME( I )) THEN
                            FATAL = .TRUE.
                            IF (KPRINT .GE. 2) THEN
                              WRITE( NOUT, FMT = 9998 )I
                            ENDIF
                          ENDIF
  40                    CONTINUE
C
                        IF( .NOT.NULL )THEN
C
C                          Check the result column by column.
C
                           JJAB = 1
                           JC = 1
                           DO 70 J = 1, N
                              IF( UPPER )THEN
                                 JJ = 1
                                 LJ = J
                              ELSE
                                 JJ = J
                                 LJ = N - J + 1
                              END IF
                              IF( TRAN )THEN
                                 DO 50 I = 1, K
                                    W( I ) = AB( ( J - 1 )*2*NMAX + K +
     $                                       I )
                                    W( K + I ) = AB( ( J - 1 )*2*NMAX +
     $                                           I )
   50                            CONTINUE
                                 FTL = .FALSE.
                                 CALL SMMCH( 'T', 'N', LJ, 1, 2*K,
     $                                       ALPHA, AB( JJAB ), 2*NMAX,
     $                                       W, 2*NMAX, BETA,
     $                                       C( JJ, J ), NMAX, CT, G,
     $                                       CC( JC ), LDC, EPS, ERR,
     $                                       FTL, NOUT, .TRUE.,KPRINT)
                              ELSE
                                 DO 60 I = 1, K
                                    W( I ) = AB( ( K + I - 1 )*NMAX +
     $                                       J )
                                    W( K + I ) = AB( ( I - 1 )*NMAX +
     $                                           J )
   60                            CONTINUE
                                 FTL = .FALSE.
                                 CALL SMMCH( 'N', 'N', LJ, 1, 2*K,
     $                                       ALPHA, AB( JJ ), NMAX, W,
     $                                       2*NMAX, BETA, C( JJ, J ),
     $                                       NMAX, CT, G, CC( JC ), LDC,
     $                                       EPS, ERR, FTL, NOUT,
     $                                       .TRUE., KPRINT )
                              END IF
                              IF( UPPER )THEN
                                 JC = JC + LDC
                              ELSE
                                 JC = JC + LDC + 1
                                 IF( TRAN )
     $                              JJAB = JJAB + 2*NMAX
                              END IF
                              ERRMAX = MAX( ERRMAX, ERR )
                              IF (FTL) THEN
                                FATAL = .TRUE.
                                IF (KPRINT .GE. 3) THEN
                                  WRITE (NOUT, FMT = 9996) SNAME
                                  WRITE( NOUT, FMT = 9994 )NC, SNAME,
     $                              UPLO, TRANS, N, K,
     $                              ALPHA, LDA, LDB, BETA, LDC
                                ENDIF
                              ENDIF
   70                      CONTINUE
                        END IF
C
   80                CONTINUE
C
   90             CONTINUE
C
  100          CONTINUE
C
  110       CONTINUE
C
  120    CONTINUE
C
  130 CONTINUE
C
C     Report result.
C
      IF (.NOT. (FATAL))THEN
        IF (KPRINT .GE. 3) THEN
          IF( ERRMAX.LT.THRESH )THEN
             WRITE( NOUT, FMT = 9999 )SNAME, NC
          ELSE
             WRITE( NOUT, FMT = 9997 )SNAME, NC, ERRMAX
          END IF
        ENDIF
      ENDIF
      RETURN
C
 9999 FORMAT( ' ', A6, ' PASSED THE COMPUTATIONAL TESTS (', I6, ' CALL',
     $      'S)' )
 9998 FORMAT( ' ******* FATAL ERROR - PARAMETER NUMBER ', I2, ' WAS CH',
     $      'ANGED INCORRECTLY *******' )
 9997 FORMAT( ' ', A6, ' COMPLETED THE COMPUTATIONAL TESTS (', I6, ' C',
     $      'ALLS)', /' ******* BUT WITH MAXIMUM TEST RATIO', F8.2,
     $      ' - SUSPECT *******' )
 9996 FORMAT( ' ******* ', A6, ' FAILED ON CALL NUMBER:' )
 9994 FORMAT( 1X, I6, ': ', A6, '(', 2( '''', A1, ''',' ), 2( I3, ',' ),
     $      F4.1, ', A,', I3, ', B,', I3, ',', F4.1, ', C,', I3, ')   ',
     $      ' .' )
 9993 FORMAT( ' ******* FATAL ERROR - ERROR-EXIT TAKEN ON VALID CALL *',
     $      '******' )
C
C     End of SCHK53.
C
      END

*DECK QG8TST
      SUBROUTINE QG8TST (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  QG8TST
C***PURPOSE  Quick check for GAUS8.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (QG8TST-S, DQG8TS-D)
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  FQD1, FQD2, GAUS8, R1MACH, XGETF, XSETF
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   901205  Changed usage of R1MACH(3) to R1MACH(4).  (RWC)
C   910501  Added PURPOSE and TYPE records.  (WRB)
C   910708  Minor modifications in use of KPRINT.  (WRB)
C   920213  Code restructured to test GAUS8 for all values of KPRINT,
C           second accuracy test added and testing of error returns
C           revised.  (WRB)
C***END PROLOGUE  QG8TST
C     .. Scalar Arguments ..
      INTEGER IPASS, KPRINT, LUN
C     .. Local Scalars ..
      INTEGER IERR, KONTRL
      REAL A, ANS, B, COR, ERR, REQ, TOL
      LOGICAL FATAL
C     .. External Functions ..
      REAL FQD1, FQD2, R1MACH
      EXTERNAL FQD1, FQD2, R1MACH
C     .. External Subroutines ..
      EXTERNAL GAUS8, XGETF, XSETF
C     .. Intrinsic Functions ..
      INTRINSIC ABS, ATAN, EXP, SQRT
C***FIRST EXECUTABLE STATEMENT  QG8TST
      IF (KPRINT .GE. 2) WRITE (LUN,FMT=9000)
C
C     Initialize variables for testing.
C
      TOL = SQRT(R1MACH(4))
      IPASS = 1
C
C     First accuracy test.
C
      A = 1.0E0
      B = 4.0E0
      ERR = TOL/100.0E0
      CALL GAUS8 (FQD1, A, B, ERR, ANS, IERR)
      COR = 2.0E0
      IF (ABS(ANS-COR).LE.TOL .AND. IERR.EQ.1) THEN
        IF (KPRINT .GE. 3)
     +    WRITE (LUN, 9010) 'PASSED', A, B, ANS, COR, ERR, IERR
      ELSE
        IPASS = 0
        IF (KPRINT .GE. 2)
     +    WRITE (LUN, 9010) 'FAILED', A, B, ANS, COR, ERR, IERR
      ENDIF
C
C     Second accuracy test.
C
      A = 0.0E0
      B = 4.0E0*ATAN(1.0E0)
      ERR = TOL/100.0E0
      CALL GAUS8 (FQD2, A, B, ERR, ANS, IERR)
      COR = (EXP(B)-1.0E0)/101.0E0
      IF (ABS(ANS-COR).LE.TOL .AND. IERR.EQ.1) THEN
        IF (KPRINT .GE. 3)
     +    WRITE (LUN, 9010) 'PASSED', A, B, ANS, COR, ERR, IERR
      ELSE
        IPASS = 0
        IF (KPRINT .GE. 2)
     +    WRITE (LUN, 9010) 'FAILED', A, B, ANS, COR, ERR, IERR
      ENDIF
C
C     Test error returns.
C
      CALL XGETF (KONTRL)
      IF (KPRINT .LE. 2) THEN
         CALL XSETF (0)
      ELSE
         CALL XSETF (1)
      ENDIF
      FATAL = .FALSE.
C
      IF (KPRINT .GE. 3) WRITE (LUN,FMT=9030)
C
C     Test with a discontinuous integrand and a tight error tolerance.
C
      A = 0.0E0
      B = 1.0E0
      COR = 2.0E0
      ERR = 100.0E0*R1MACH(4)
      REQ = ERR
      CALL GAUS8 (FQD1, A, B, ERR, ANS, IERR)
C
C     See if test passed.
C
      IF (IERR .EQ. 2) THEN
        IF (KPRINT .GE. 3)
     +    WRITE (LUN,FMT=9040) 'PASSED', REQ, ANS, IERR, ERR, COR
      ELSE
        IF (KPRINT .GE. 2)
     +    WRITE (LUN,FMT=9040) 'PASSED', REQ, ANS, IERR, ERR, COR
        IPASS = 0
        FATAL = .TRUE.
      ENDIF
C
C     Test GAUS8 with A and B nearly equal.
C
      A = 2.0E0
      B = A*(1.0E0+R1MACH(4))
      COR = 0.0E0
      ERR = TOL
C
      CALL GAUS8 (FQD1, A, B, ERR, ANS, IERR)
C
C     Check to see if test passed.
C
      IF (IERR.EQ.-1 .AND. ANS.EQ.0.0E0) THEN
        IF (KPRINT .GE. 3) WRITE (LUN,9050) 'PASSED'
      ELSE
        IPASS = 0
        FATAL = .TRUE.
        IF (KPRINT .GE. 2) WRITE (LUN,9050) 'FAILED'
      ENDIF
C
      CALL XSETF (KONTRL)
      IF (FATAL) THEN
         IF (KPRINT .GE. 2) THEN
            WRITE (LUN, 9060)
         ENDIF
      ELSE
         IF (KPRINT .GE. 3) THEN
            WRITE (LUN, 9070)
         ENDIF
      ENDIF
C
      IF (IPASS.EQ.1 .AND. KPRINT.GE.3) WRITE (LUN,FMT=9080)
      IF (IPASS.EQ.0 .AND. KPRINT.GE.2) WRITE (LUN,FMT=9090)
      RETURN
C
 9000 FORMAT ('1' / ' GAUS8 Quick Check')
 9010 FORMAT (/ ' Accuracy test of GAUS8 ', A /
     +        ' A = ', F10.5, '   B = ', F10.5 /
     +        ' Computed result = ', E14.7, '   Exact result = ',
     +        E14.7 /
     +        ' Tolerance = ', E14.7, '   IERR = ', I2 /)
 9030 FORMAT (/ ' Test error returns' /
     +        ' 2 error messages expected' /)
 9040 FORMAT (' Test of GAUS8 ', A /
     +        ' REQ =', E10.2, 5X, 'ANS =', E20.13, 5X, 'IERR =', I2,
     +        5X, 'should be 2' /
     +        ' ERR =', E10.2, ' CORRECT =' ,E20.13 /)
 9050 FORMAT (' Test of A and B nearly equal ', A)
 9060 FORMAT (/ ' At least one incorrect argument test FAILED')
 9070 FORMAT (/ ' All incorrect argument tests PASSED')
 9080 FORMAT (/,' ***************GAUS8 PASSED ALL TESTS***************')
 9090 FORMAT (/,' ***************GAUS8 FAILED SOME TESTS**************')
      END

*DECK FMAT
      SUBROUTINE FMAT (X, Y, YP)
C***BEGIN PROLOGUE  FMAT
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    SAVEX
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  FMAT
      DIMENSION Y(*),YP(*)
      COMMON /SAVEX/ XSAVE, TERM
C***FIRST EXECUTABLE STATEMENT  FMAT
      YP(1) = Y(2)
      IF (X .EQ. XSAVE) GO TO 10
      XSAVE=X
      TANX=TAN(X/57.2957795130823)
      TERM=3.0/TANX+2.0*TANX
   10 YP(2) = -TERM*Y(2)-0.7*Y(1)
      RETURN
      END

*DECK QCGLSS
      SUBROUTINE QCGLSS (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  QCGLSS
C***PURPOSE  Quick check for SGLSS.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (QCGLSS-S, DQCGLS-D)
C***AUTHOR  Voorhees, E. A., (LANL)
C***DESCRIPTION
C
C      QUICK CHECK SUBROUTINE  QCGLSS  TESTS THE EXECUTION
C      OF THE GENERAL LINEAR SYSTEM SOLVER, SGLSS .  THE
C      SGLSS  SUBROUTINE PACKAGE WAS WRITTEN BY T. MANTEUFFEL
C      (LANL).
C
C      A TITLE LINE AND A SUMMARY LINE ARE ALWAYS OUTPUTTED
C      BY QCGLSS.  THE SUMMARY LINE GIVES A COUNT OF THE
C      NUMBER OF PROBLEMS DETECTED DURING THE TEST.
C
C      THE REAL QUANTITIES FOR THE COMPUTED SOLUTION VECTOR
C      X  AND THE CORRESPONDING  RNORM  ARE COMPARED AGAINST
C      STORED VALUES.  DISAGREEMENT OCCURS IF A DIFFERENCE
C      IS SQRT(R1MACH(4) OR MORE.  THE RETURNED VALUE (INTEGER)
C      OF  INFO  IS ALSO CHECKED.  FOUR CASES ARE RUN, TWO
C      INVOLVING  LLSIA  AND TWO INVOLVING  ULSIA .
C
C      QCGLSS REQUIRES NO INPUT ARGUMENTS.  ON RETURN, NERR
C      (INTEGER TYPE) CONTAINS THE COUNT OF THE NUMBER OF
C      PROBLEMS DETECTED BY  QCGLSS .
C
C***ROUTINES CALLED  R1MACH, SGLSS
C***REVISION HISTORY  (YYMMDD)
C   811026  DATE WRITTEN
C   820801  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   901010  Restructured using IF-THEN-ELSE-ENDIF, cleaned up FORMATs,
C           including removing an illegal character from column 1, and
C           editorial changes.  (RWC)
C***END PROLOGUE  QCGLSS
      REAL AA(4,4,2),A(4,4),BB(4,2),B(4),XX(4,4),DELMAX,DELX,R
      REAL WORK(20)
      CHARACTER*1 LIST(2)
      INTEGER INF(4),NERR,KPROG,KCASE
      INTEGER IWORK(7),INFO,LUN
      DATA AA/1.,.5,1.,.25,0.,2.,0.,1.,2.,-1.,1.,0.,0.,0.,0.,0.,
     1 1.,2.,-1.,0.,0.,1.,2.,0.,-1.,0.,1.,0.,1.,0.,1.,0./
      DATA BB/3.,1.5,2.,1.25,1.,3.,3.,0./
      DATA XX/.9999999999999787,1.000000000000007,1.000000000000007,
     1 0.,.8095238095238102,1.047619047619044,1.095238095238081,0.,
     1 .7777777777777857,1.444444444444429,.3333333333333393,
     1 .5555555555555500,
     1 .3333333333333321,0.0,-.3333333333333286,.3333333333333286/
      DATA INF/0,1,0,2/
      DATA LIST/'L','U'/
C***FIRST EXECUTABLE STATEMENT  QCGLSS
      INFO = 0
      NERR = 0
      R = SQRT(R1MACH(4))
      IF (KPRINT.GE.2) WRITE (LUN,800)
      DO 60 KPROG=1,2
         DO 50 KCASE=1,2
C
C           FORM BASIC MATRIX  A  AND VECTOR  B .  (CASE 1)
C
            DO 10  I=1,4
               DO 5  J=1,4
                  A(I,J) = AA(I,J,KPROG)
    5          CONTINUE
               B(I) = BB(I,KPROG)
   10       CONTINUE
C
C           MAKE 3 ROWS IDENTICAL FOR CASE 2.
C
            IF (KCASE .NE. 1) THEN
               DO 20  I=2,3
                  DO 15  J=1,4
                     A(I,J) = A(1,J)
   15             CONTINUE
                  B(I) = B(1)
   20          CONTINUE
            ENDIF
C
C           SOLVE FOR VECTOR  X .
C
            INFO = 0
            IF (KPROG .EQ. 1) CALL SGLSS(A,4,4,3,B,4,1,RNORM,WORK,20,
     1         IWORK,7,INFO)
            IF (KPROG .EQ. 2) CALL SGLSS(A,4,3,4,B,4,1,RNORM,WORK,20,
     1         IWORK,7,INFO)
C
C           TEST COMPUTED  X , RNORM , AND  INFO .
C
            KK = 2*(KPROG - 1) + KCASE
            DELMAX = 0.0E0
            DO 30  I=1,4
               DELX = ABS(B(I)-XX(I,KK))
               DELMAX = MAX(DELMAX,DELX)
   30       CONTINUE
C
            IF (KPRINT.GE.3) WRITE (LUN,701) LIST(KPROG),KCASE,DELMAX
            IF (DELMAX .GE. R) THEN
               NERR = NERR + 1
               IF (KPRINT.GE.2) WRITE (LUN,801) LIST(KPROG),KCASE,DELMAX
            ENDIF
            IF (KPRINT.GE.3) WRITE (LUN,702) LIST(KPROG),KCASE,RNORM
            IF (RNORM .GT. R) THEN
               NERR = NERR + 1
               IF (KPRINT.GE.2) WRITE (LUN,802) LIST(KPROG),KCASE,RNORM
            ENDIF
C
            IF (KPRINT.GE.3) WRITE (LUN,703) LIST(KPROG),KCASE,INFO,
     *         INF(KK)
            IF (INFO .NE. INF(KK)) THEN
               NERR = NERR + 1
               IF (KPRINT.GE.2) WRITE (LUN,803) LIST(KPROG),KCASE,INFO,
     *            INF(KK)
            ENDIF
   50    CONTINUE
   60 CONTINUE
C
C     SUMMARY PRINT
C
      IPASS=0
      IF (NERR.EQ.0) IPASS=1
      IF (NERR.NE.0 .AND. KPRINT.NE.0) WRITE (LUN,804) NERR
      IF (NERR.EQ.0 .AND. KPRINT.GT.1) WRITE (LUN,805)
      RETURN
C
  701 FORMAT (3X, A, 'LSIA, CASE ', I1, '.  MAX ABS ERROR OF', E11.4/)
  702 FORMAT (3X, A, 'LSIA, CASE ', I1, '.  RNORM IS ', E11.4/)
  703 FORMAT (3X, A, 'LSIA, CASE ', I1, '.  INFO=', I1,
     1   ' (SHOULD = ', I1, ')'/)
  800 FORMAT(/' *    QCGLSS - QUICK CHECK FOR SGLSS (LLSIA AND ULSIA)'/)
  801 FORMAT ('   PROBLEM WITH ', A, 'LSIA, CASE ', I1,
     1   '.  MAX ABS ERROR OF', E11.4/)
  802 FORMAT ('   PROBLEM WITH ', A, 'LSIA, CASE ', I1,
     1   '.  RNORM (TOO LARGE) IS', E11.4/)
  803 FORMAT ('   PROBLEM WITH ', A, 'LSIA, CASE ', I1,
     1   '.  INFO=', I1, ' (SHOULD = ', I1, ')'/)
  804 FORMAT (/' **** QCGLSS DETECTED A TOTAL OF ', I2,
     1   ' PROBLEMS WITH SGLSS. ****'/)
  805 FORMAT ('     QCGLSS DETECTED NO PROBLEMS WITH SGLSS.'/)
      END

*DECK SMVCH
      SUBROUTINE SMVCH (TRANS, M, N, ALPHA, A, NMAX, X, INCX, BETA, Y,
     $   INCY, YT, G, YY, EPS, ERR, FTL, NOUT, MV, KPRINT)
C***BEGIN PROLOGUE  SMVCH
C***SUBSIDIARY
C***PURPOSE  Check the results of the computational tests.
C***LIBRARY   SLATEC (BLAS)
C***AUTHOR  Du Croz, J. J., (NAG)
C           Hanson, R. J., (SNLA)
C***DESCRIPTION
C
C  Checks the results of the computational tests.
C
C  Auxiliary routine for test program for Level 2 Blas.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   870810  DATE WRITTEN
C   910620  Modified to meet SLATEC code and prologue standards.  (BKS)
C***END PROLOGUE  SMVCH
C     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0, ONE = 1.0 )
C     .. Scalar Arguments ..
      REAL               ALPHA, BETA, EPS, ERR
      INTEGER            INCX, INCY, KPRINT, M, N, NMAX, NOUT
      LOGICAL            MV, FTL
      CHARACTER*1        TRANS
C     .. Array Arguments ..
      REAL               A( NMAX, * ), G( * ), X( * ), Y( * ), YT( * ),
     $                   YY( * )
C     .. Local Scalars ..
      REAL               ERRI
      INTEGER            I, INCXL, INCYL, IY, J, JX, K, KX, KY, ML, NL
      LOGICAL            TRAN
C     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SQRT
C***FIRST EXECUTABLE STATEMENT  SMVCH
      TRAN = TRANS.EQ.'T'.OR.TRANS.EQ.'C'
      IF( TRAN )THEN
         ML = N
         NL = M
      ELSE
         ML = M
         NL = N
      END IF
      IF( INCX.LT.0 )THEN
         KX = NL
         INCXL = -1
      ELSE
         KX = 1
         INCXL = 1
      END IF
      IF( INCY.LT.0 )THEN
         KY = ML
         INCYL = -1
      ELSE
         KY = 1
         INCYL = 1
      END IF
C
C     Compute expected result in YT using data in A, X and Y.
C     Compute gauges in G.
C
      IY = KY
      DO 30 I = 1, ML
         YT( IY ) = ZERO
         G( IY ) = ZERO
         JX = KX
         IF( TRAN )THEN
            DO 10 J = 1, NL
               YT( IY ) = YT( IY ) + A( J, I )*X( JX )
               G( IY ) = G( IY ) + ABS( A( J, I )*X( JX ) )
               JX = JX + INCXL
   10       CONTINUE
         ELSE
            DO 20 J = 1, NL
               YT( IY ) = YT( IY ) + A( I, J )*X( JX )
               G( IY ) = G( IY ) + ABS( A( I, J )*X( JX ) )
               JX = JX + INCXL
   20       CONTINUE
         END IF
         YT( IY ) = ALPHA*YT( IY ) + BETA*Y( IY )
         G( IY ) = ABS( ALPHA )*G( IY ) + ABS( BETA*Y( IY ) )
         IY = IY + INCYL
   30 CONTINUE
C
C     Compute the error ratio for this result.
C
      ERR = ZERO
      DO 40 I = 1, ML
         ERRI = ABS( YT( I ) - YY( 1 + ( I - 1 )*ABS( INCY ) ) )/EPS
         IF( G( I ).NE.ZERO )
     $      ERRI = ERRI/G( I )
         ERR = MAX( ERR, ERRI )
         IF( ERR*SQRT( EPS ).GE.ONE ) THEN
           FTL = .TRUE.
           IF (KPRINT .GE. 2) THEN
             WRITE( NOUT, FMT = 9999 )
             DO 60 K = 1, ML
                IF( MV )THEN
                   WRITE( NOUT, FMT = 9998 )K, YT( K ),
     $                YY( 1 + ( K - 1 )*ABS( INCY ) )
                ELSE
                   WRITE( NOUT, FMT = 9998 )K,
     $                YY( 1 + ( K - 1 )*ABS( INCY ) ), YT(K)
                END IF
   60        CONTINUE
           ENDIF
         ENDIF
   40 CONTINUE
      RETURN
C
 9999 FORMAT( ' ******* FATAL ERROR - COMPUTED RESULT IS LESS THAN HAL',
     $      'F ACCURATE *******', /'           EXPECTED RESULT   COMPU',
     $      'TED RESULT' )
 9998 FORMAT( 1X, I7, 2G18.6 )
C
C     End of SMVCH.
C
      END

*DECK SCHK12
      SUBROUTINE SCHK12 (SNAME, EPS, THRESH, NOUT, KPRINT, FATAL, NIDIM,
     $   IDIM, NKB, KB, NALF, ALF, NBET, BET, NINC, INC, NMAX, INCMAX,
     $   A, AA, AS, X, XX, XS, Y, YY, YS, YT, G)
C***BEGIN PROLOGUE  SCHK12
C***SUBSIDIARY
C***PURPOSE  Quick check for SGEMV and SGBMV.
C***LIBRARY   SLATEC (BLAS)
C***KEYWORDS  BLAS, QUICK CHECK SERVICE ROUTINE
C***AUTHOR  Du Croz, J. (NAG)
C           Hanson, R. J. (SNLA)
C***DESCRIPTION
C
C  Quick check for SGEMV and SGBMV.
C
C  Auxiliary routine for test program for Level 2 Blas.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  LSE, LSERES, NUMXER, SGBMV, SGEMV, SMAKE2, SMVCH
C***REVISION HISTORY  (YYMMDD)
C   870810  DATE WRITTEN
C   910619  Modified to meet SLATEC code and prologue standards.  (BKS)
C***END PROLOGUE  SCHK12
C     .. Parameters ..
      REAL               ZERO, HALF
      PARAMETER          ( ZERO = 0.0, HALF = 0.5 )
C     .. Scalar Arguments ..
      LOGICAL            FATAL
      REAL               EPS, THRESH
      INTEGER            INCMAX, KPRINT, NALF, NBET, NIDIM, NINC, NKB,
     $                   NMAX, NOUT
      CHARACTER*6        SNAME
C     .. Array Arguments ..
      REAL               A( NMAX, NMAX ), AA( NMAX*NMAX ), ALF( NALF ),
     $                   AS( NMAX*NMAX ), BET( NBET ), G( NMAX ),
     $                   X( NMAX ), XS( NMAX*INCMAX ),
     $                   XX( NMAX*INCMAX ), Y( NMAX ),
     $                   YS( NMAX*INCMAX ), YT( NMAX ),
     $                   YY( NMAX*INCMAX )
      INTEGER            IDIM( NIDIM ), INC( NINC ), KB( NKB )
C     .. Local Scalars ..
      REAL               ALPHA, ALS, BETA, BLS, ERR, ERRMAX, TRANSL
      INTEGER            I, IA, IB, IC, IKU, IM, IN, INCX, INCXS, INCY,
     $                   INCYS, IX, IY, KL, KLS, KU, KUS, LAA, LDA,
     $                   LDAS, LX, LY, M, ML, MS, N, NARGS, NC, ND, NK,
     $                   NL, NS, NERR
      LOGICAL            BANDED, FTL, FULL, NULL, RESET, TRAN
      CHARACTER*1        TRANS, TRANSS
      CHARACTER*3        ICH
C     .. Local Arrays ..
      LOGICAL            ISAME( 13 )
C     .. External Functions ..
      INTEGER            NUMXER
      LOGICAL            LSE, LSERES
      EXTERNAL           LSE, LSERES, NUMXER
C     .. External Subroutines ..
      EXTERNAL           SGBMV, SGEMV, SMAKE2, SMVCH
C     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN
C     .. Data statements ..
      DATA               ICH/'NTC'/
C***FIRST EXECUTABLE STATEMENT  SCHK12
      FULL = SNAME( 3: 3 ).EQ.'E'
      BANDED = SNAME( 3: 3 ).EQ.'B'
C     Define the number of arguments.
      IF( FULL )THEN
         NARGS = 11
      ELSE IF( BANDED )THEN
         NARGS = 13
      END IF
C
      NC = 0
      RESET = .TRUE.
      ERRMAX = ZERO
C
      DO 120 IN = 1, NIDIM
         N = IDIM( IN )
         ND = N/2 + 1
C
         DO 110 IM = 1, 2
            IF( IM.EQ.1 )
     $         M = MAX( N - ND, 0 )
            IF( IM.EQ.2 )
     $         M = MIN( N + ND, NMAX )
C
            IF( BANDED )THEN
               NK = NKB
            ELSE
               NK = 1
            END IF
            DO 100 IKU = 1, NK
               IF( BANDED )THEN
                  KU = KB( IKU )
                  KL = MAX( KU - 1, 0 )
               ELSE
                  KU = N - 1
                  KL = M - 1
               END IF
C              Set LDA to 1 more than minimum value if room.
               IF( BANDED )THEN
                  LDA = KL + KU + 1
               ELSE
                  LDA = M
               END IF
               IF( LDA.LT.NMAX )
     $            LDA = LDA + 1
C              Skip tests if not enough room.
               IF( LDA.GT.NMAX )
     $            GO TO 100
               LAA = LDA*N
               NULL = N.LE.0.OR.M.LE.0
C
C              Generate the matrix A.
C
               TRANSL = ZERO
               CALL SMAKE2( SNAME( 2: 3 ), ' ', ' ', M, N, A, NMAX, AA,
     $                     LDA, KL, KU, RESET, TRANSL )
C
               DO 90 IC = 1, 3
                  TRANS = ICH( IC: IC )
                  TRAN = TRANS.EQ.'T'.OR.TRANS.EQ.'C'
C
                  IF( TRAN )THEN
                     ML = N
                     NL = M
                  ELSE
                     ML = M
                     NL = N
                  END IF
C
                  DO 80 IX = 1, NINC
                     INCX = INC( IX )
                     LX = ABS( INCX )*NL
C
C                    Generate the vector X.
C
                     TRANSL = HALF
                     CALL SMAKE2( 'GE', ' ', ' ', 1, NL, X, 1, XX,
     $                           ABS( INCX ), 0, NL - 1, RESET, TRANSL )
                     IF( NL.GT.1 )THEN
                        X( NL/2 ) = ZERO
                        XX( 1 + ABS( INCX )*( NL/2 - 1 ) ) = ZERO
                     END IF
C
                     DO 70 IY = 1, NINC
                        INCY = INC( IY )
                        LY = ABS( INCY )*ML
C
                        DO 60 IA = 1, NALF
                           ALPHA = ALF( IA )
C
                           DO 50 IB = 1, NBET
                              BETA = BET( IB )
C
C                             Generate the vector Y.
C
                              TRANSL = ZERO
                              CALL SMAKE2( 'GE', ' ', ' ', 1, ML, Y, 1,
     $                                    YY, ABS( INCY ), 0, ML - 1,
     $                                    RESET, TRANSL )
C
                              NC = NC + 1
C
C                             Save every datum before calling the
C                             subroutine.
C
                              TRANSS = TRANS
                              MS = M
                              NS = N
                              KLS = KL
                              KUS = KU
                              ALS = ALPHA
                              DO 10 I = 1, LAA
                                 AS( I ) = AA( I )
   10                         CONTINUE
                              LDAS = LDA
                              DO 20 I = 1, LX
                                 XS( I ) = XX( I )
   20                         CONTINUE
                              INCXS = INCX
                              BLS = BETA
                              DO 30 I = 1, LY
                                 YS( I ) = YY( I )
   30                         CONTINUE
                              INCYS = INCY
C
C                             Call the subroutine.
C
                              IF( FULL )THEN
                                 CALL SGEMV( TRANS, M, N, ALPHA, AA,
     $                                       LDA, XX, INCX, BETA, YY,
     $                                       INCY )
                              ELSE IF( BANDED )THEN
                                 CALL SGBMV( TRANS, M, N, KL, KU, ALPHA,
     $                                       AA, LDA, XX, INCX, BETA,
     $                                       YY, INCY )
                              END IF
C
C                             Check if error-exit was taken incorrectly.
C
                              IF (NUMXER(NERR) .NE. 0) THEN
                                 IF (KPRINT .GE. 2) THEN
                                   WRITE( NOUT, FMT = 9993 )
                                 ENDIF
                                 FATAL = .TRUE.
                              END IF
C
C                             See what data changed inside subroutines.
C
                              ISAME( 1 ) = TRANS.EQ.TRANSS
                              ISAME( 2 ) = MS.EQ.M
                              ISAME( 3 ) = NS.EQ.N
                              IF( FULL )THEN
                                 ISAME( 4 ) = ALS.EQ.ALPHA
                                 ISAME( 5 ) = LSE( AS, AA, LAA )
                                 ISAME( 6 ) = LDAS.EQ.LDA
                                 ISAME( 7 ) = LSE( XS, XX, LX )
                                 ISAME( 8 ) = INCXS.EQ.INCX
                                 ISAME( 9 ) = BLS.EQ.BETA
                                 IF( NULL )THEN
                                    ISAME( 10 ) = LSE( YS, YY, LY )
                                 ELSE
                                    ISAME( 10 ) = LSERES( 'GE', ' ', 1,
     $                                            ML, YS, YY,
     $                                            ABS( INCY ) )
                                 END IF
                                 ISAME( 11 ) = INCYS.EQ.INCY
                              ELSE IF( BANDED )THEN
                                 ISAME( 4 ) = KLS.EQ.KL
                                 ISAME( 5 ) = KUS.EQ.KU
                                 ISAME( 6 ) = ALS.EQ.ALPHA
                                 ISAME( 7 ) = LSE( AS, AA, LAA )
                                 ISAME( 8 ) = LDAS.EQ.LDA
                                 ISAME( 9 ) = LSE( XS, XX, LX )
                                 ISAME( 10 ) = INCXS.EQ.INCX
                                 ISAME( 11 ) = BLS.EQ.BETA
                                 IF( NULL )THEN
                                    ISAME( 12 ) = LSE( YS, YY, LY )
                                 ELSE
                                    ISAME( 12 ) = LSERES( 'GE', ' ', 1,
     $                                            ML, YS, YY,
     $                                            ABS( INCY ) )
                                 END IF
                                 ISAME( 13 ) = INCYS.EQ.INCY
                              END IF
C
C                             If data was incorrectly changed, report
C                             and return.
C
                              DO 40 I = 1, NARGS
                                IF (.NOT. ISAME( I )) THEN
                                  FATAL = .TRUE.
                                  IF (KPRINT .GE. 2) THEN
                                    WRITE( NOUT, FMT = 9998 )I
                                  ENDIF
                                ENDIF
  40                          CONTINUE
C
                              FTL = .FALSE.
                              IF( .NOT.NULL )THEN
C
C                                Check the result.
C
                                 CALL SMVCH( TRANS, M, N, ALPHA, A,
     $                                       NMAX, X, INCX, BETA, Y,
     $                                       INCY, YT, G, YY, EPS, ERR,
     $                                       FTL, NOUT, .TRUE.,
     $                                       KPRINT )
                                 ERRMAX = MAX( ERRMAX, ERR )
                              END IF
                              IF (FTL) THEN
                                FATAL = .TRUE.
                                IF (KPRINT .GE. 3) THEN
                                  WRITE( NOUT, FMT = 9996 )SNAME
                                  IF( FULL )THEN
                                     WRITE( NOUT, FMT = 9994 )NC, SNAME,
     $                                TRANS, M, N, ALPHA,
     $                                LDA, INCX, BETA, INCY
                                  ELSE IF( BANDED )THEN
                                     WRITE( NOUT, FMT = 9995 )NC, SNAME,
     $                                TRANS, M, N, KL, KU,
     $                                ALPHA, LDA, INCX, BETA, INCY
                                  END IF
                                ENDIF
                              ENDIF
C
   50                      CONTINUE
C
   60                   CONTINUE
C
   70                CONTINUE
C
   80             CONTINUE
C
   90          CONTINUE
C
  100       CONTINUE
C
  110    CONTINUE
C
  120 CONTINUE
C
C     Report result.
C
      IF (.NOT. (FATAL)) THEN
        IF (KPRINT .GE. 3) THEN
          IF( ERRMAX.LT.THRESH )THEN
             WRITE( NOUT, FMT = 9999 )SNAME, NC
          ELSE
             WRITE( NOUT, FMT = 9997 )SNAME, NC, ERRMAX
          END IF
        ENDIF
      ENDIF
      RETURN
C
 9999 FORMAT( ' ', A6, ' PASSED THE COMPUTATIONAL TESTS (', I6, ' CALL',
     $      'S)' )
 9998 FORMAT( ' ******* FATAL ERROR - PARAMETER NUMBER ', I2, ' WAS CH',
     $      'ANGED INCORRECTLY *******' )
 9997 FORMAT( ' ', A6, ' COMPLETED THE COMPUTATIONAL TESTS (', I6, ' C',
     $      'ALLS)', /' ******* BUT WITH MAXIMUM TEST RATIO', F8.2,
     $      ' - SUSPECT *******' )
 9996 FORMAT( ' ******* ', A6, ' FAILED ON CALL NUMBER:' )
 9995 FORMAT( 1X, I6, ': ', A6, '(''', A1, ''',', 4( I3, ',' ), F4.1,
     $      ', A,', I3, ', X,', I2, ',', F4.1, ', Y,', I2, ') .' )
 9994 FORMAT( 1X, I6, ': ', A6, '(''', A1, ''',', 2( I3, ',' ), F4.1,
     $      ', A,', I3, ', X,', I2, ',', F4.1, ', Y,', I2,
     $      ')         .' )
 9993 FORMAT( ' ******* FATAL ERROR - ERROR-EXIT TAKEN ON VALID CALL *',
     $      '******' )
C
C     End of SCHK12.
C
      END

*DECK SCHK23
      SUBROUTINE SCHK23 (SNAME, EPS, THRESH, NOUT, KPRINT, FATAL, NIDIM,
     $   IDIM, NALF, ALF, NBET, BET, NMAX, A, AA, AS, B, BB, BS, C, CC,
     $   CS, CT, G)
C***BEGIN PROLOGUE  SCHK23
C***SUBSIDIARY
C***PURPOSE  Quick check for SSYMM.
C***LIBRARY   SLATEC (BLAS)
C***KEYWORDS  BLAS, QUICK CHECK SERVICE ROUTINE
C***AUTHOR  Dongarra, J. J., (ANL)
C           Duff, I., (AERE)
C           Du Croz, J., (NAG)
C           Hammarling, S., (NAG)
C***DESCRIPTION
C
C  Quick check for SSYMM.
C
C  Auxiliary routine for test program for Level 3 Blas.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  LSE, LSERES, NUMXER, SMAKE3, SMMCH, SSYMM
C***REVISION HISTORY  (YYMMDD)
C   890208  DATE WRITTEN
C   910619  Modified to meet SLATEC code and prologue standards.  (BKS)
C***END PROLOGUE  SCHK23
C     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0 )
C     .. Scalar Arguments ..
      LOGICAL            FATAL
      REAL               EPS, THRESH
      INTEGER            KPRINT, NALF, NBET, NIDIM, NMAX, NOUT
      CHARACTER*6        SNAME
C     .. Array Arguments ..
      REAL               A( NMAX, NMAX ), AA( NMAX*NMAX ), ALF( NALF ),
     $                   AS( NMAX*NMAX ), BET( NBET ), G( NMAX ),
     $                   B( NMAX, NMAX ), BB( NMAX*NMAX ),
     $                   BS( NMAX*NMAX ), C( NMAX, NMAX ),
     $                   CC( NMAX*NMAX ), CS( NMAX*NMAX ),
     $                   CT( NMAX )
      INTEGER            IDIM( NIDIM )
C     .. Local Scalars ..
      REAL               ALPHA, ALS, BETA, BLS, ERR, ERRMAX
      INTEGER            I, IA, IB, ICS, ICU, IM, IN, LAA,
     $                   LBB, LCC, LDA, LDAS, LDB, LDBS, LDC, LDCS, M,
     $                   MS, N, NA, NARGS, NC, NERR, NS
      LOGICAL            FTL, NULL, RESET, LEFT
      CHARACTER*1        SIDE, SIDES, UPLO, UPLOS
      CHARACTER*2        ICHS, ICHU
C     .. Local Arrays ..
      LOGICAL            ISAME( 13 )
C     .. External Functions ..
      INTEGER            NUMXER
      LOGICAL            LSE, LSERES
      EXTERNAL           LSE, LSERES, NUMXER
C     .. External Subroutines ..
      EXTERNAL           SSYMM, SMAKE3, SMMCH
C     .. Intrinsic Functions ..
      INTRINSIC          MAX
C     .. Data statements ..
      DATA               ICHS/'LR'/, ICHU/'UL'/
C***FIRST EXECUTABLE STATEMENT  SCHK23
      NARGS = 12
C
      NC = 0
      RESET = .TRUE.
      ERRMAX = ZERO
C
      DO 100 IM = 1, NIDIM
         M = IDIM( IM )
C
         DO 90 IN = 1, NIDIM
            N = IDIM( IN )
C           Set LDC to 1 more than minimum value if room.
            LDC = M
            IF( LDC.LT.NMAX )
     $         LDC = LDC + 1
C           Skip tests if not enough room.
            IF( LDC.GT.NMAX )
     $         GO TO 90
            LCC = LDC*N
            NULL = N.LE.0.OR.M.LE.0
C
C           Set LDB to 1 more than minimum value if room.
            LDB = M
            IF( LDB.LT.NMAX )
     $         LDB = LDB + 1
C           Skip tests if not enough room.
            IF( LDB.GT.NMAX )
     $         GO TO 90
            LBB = LDB*N
C
C           Generate the matrix B.
C
            CALL SMAKE3( 'GE', ' ', ' ', M, N, B, NMAX, BB, LDB, RESET,
     $                  ZERO )
C
            DO 80 ICS = 1, 2
               SIDE = ICHS( ICS: ICS )
               LEFT = SIDE.EQ.'L'
C
               IF( LEFT )THEN
                  NA = M
               ELSE
                  NA = N
               END IF
C              Set LDA to 1 more than minimum value if room.
               LDA = NA
               IF( LDA.LT.NMAX )
     $            LDA = LDA + 1
C              Skip tests if not enough room.
               IF( LDA.GT.NMAX )
     $            GO TO 80
               LAA = LDA*NA
C
               DO 70 ICU = 1, 2
                  UPLO = ICHU( ICU: ICU )
C
C                 Generate the symmetric matrix A.
C
                  CALL SMAKE3('SY', UPLO, ' ', NA, NA, A, NMAX, AA, LDA,
     $                        RESET, ZERO )
C
                  DO 60 IA = 1, NALF
                     ALPHA = ALF( IA )
C
                     DO 50 IB = 1, NBET
                        BETA = BET( IB )
C
C                       Generate the matrix C.
C
                        CALL SMAKE3( 'GE', ' ', ' ', M, N, C, NMAX, CC,
     $                              LDC, RESET, ZERO )
C
                        NC = NC + 1
C
C                       Save every datum before calling the
C                       subroutine.
C
                        SIDES = SIDE
                        UPLOS = UPLO
                        MS = M
                        NS = N
                        ALS = ALPHA
                        DO 10 I = 1, LAA
                           AS( I ) = AA( I )
   10                   CONTINUE
                        LDAS = LDA
                        DO 20 I = 1, LBB
                           BS( I ) = BB( I )
   20                   CONTINUE
                        LDBS = LDB
                        BLS = BETA
                        DO 30 I = 1, LCC
                           CS( I ) = CC( I )
   30                   CONTINUE
                        LDCS = LDC
C
C                       Call the subroutine.
C
                        CALL SSYMM( SIDE, UPLO, M, N, ALPHA, AA, LDA,
     $                              BB, LDB, BETA, CC, LDC )
C
C                       Check if error-exit was taken incorrectly.
C
                        IF(NUMXER(NERR) .NE. 0) THEN
                          IF (KPRINT .GE. 2) THEN
                           WRITE( NOUT, FMT = 9994 )
                          ENDIF
                          FATAL = .TRUE.
                        END IF
C
C                       See what data changed inside subroutines.
C
                        ISAME( 1 ) = SIDES.EQ.SIDE
                        ISAME( 2 ) = UPLOS.EQ.UPLO
                        ISAME( 3 ) = MS.EQ.M
                        ISAME( 4 ) = NS.EQ.N
                        ISAME( 5 ) = ALS.EQ.ALPHA
                        ISAME( 6 ) = LSE( AS, AA, LAA )
                        ISAME( 7 ) = LDAS.EQ.LDA
                        ISAME( 8 ) = LSE( BS, BB, LBB )
                        ISAME( 9 ) = LDBS.EQ.LDB
                        ISAME( 10 ) = BLS.EQ.BETA
                        IF( NULL )THEN
                           ISAME( 11 ) = LSE( CS, CC, LCC )
                        ELSE
                           ISAME( 11 ) = LSERES( 'GE', ' ', M, N, CS,
     $                                   CC, LDC )
                        END IF
                        ISAME( 12 ) = LDCS.EQ.LDC
C
C                       If data was incorrectly changed, report and
C                       return.
C
                        DO 40 I = 1, NARGS
                          IF (.NOT. ISAME( I )) THEN
                            FATAL = .TRUE.
                            IF (KPRINT .GE. 2) THEN
                              WRITE( NOUT, FMT = 9998 )I
                            ENDIF
                          ENDIF
  40                    CONTINUE
C
                        FTL = .FALSE.
                        IF( .NOT.NULL )THEN
C
C                          Check the result.
C
                           IF( LEFT )THEN
                              CALL SMMCH( 'N', 'N', M, N, M, ALPHA, A,
     $                                    NMAX, B, NMAX, BETA, C, NMAX,
     $                                    CT, G, CC, LDC, EPS, ERR,
     $                                    FTL, NOUT, .TRUE., KPRINT )
                           ELSE
                              CALL SMMCH( 'N', 'N', M, N, N, ALPHA, B,
     $                                    NMAX, A, NMAX, BETA, C, NMAX,
     $                                    CT, G, CC, LDC, EPS, ERR,
     $                                    FTL, NOUT, .TRUE., KPRINT )
                           END IF
                           ERRMAX = MAX( ERRMAX, ERR )
                        END IF
                        IF (FTL) THEN
                          FATAL = .TRUE.
                          IF (KPRINT .GE. 3) THEN
                            WRITE (NOUT, FMT = 9996) SNAME
                            WRITE( NOUT, FMT = 9995 )NC, SNAME,
     $                        SIDE, UPLO, M, N,
     $                        ALPHA, LDA, LDB, BETA, LDC
                          ENDIF
                        ENDIF
C
   50                CONTINUE
C
   60             CONTINUE
C
   70          CONTINUE
C
   80       CONTINUE
C
   90    CONTINUE
C
  100 CONTINUE
C
C     Report result.
C
      IF (.NOT. (FATAL)) THEN
        IF (KPRINT .GE. 3) THEN
          IF( ERRMAX.LT.THRESH )THEN
             WRITE( NOUT, FMT = 9999 )SNAME, NC
          ELSE
             WRITE( NOUT, FMT = 9997 )SNAME, NC, ERRMAX
          END IF
         ENDIF
      ENDIF
      RETURN
C
 9999 FORMAT( ' ', A6, ' PASSED THE COMPUTATIONAL TESTS (', I6, ' CALL',
     $      'S)' )
 9998 FORMAT( ' ******* FATAL ERROR - PARAMETER NUMBER ', I2, ' WAS CH',
     $      'ANGED INCORRECTLY *******' )
 9997 FORMAT( ' ', A6, ' COMPLETED THE COMPUTATIONAL TESTS (', I6, ' C',
     $      'ALLS)', /' ******* BUT WITH MAXIMUM TEST RATIO', F8.2,
     $      ' - SUSPECT *******' )
 9996 FORMAT( ' ******* ', A6, ' FAILED ON CALL NUMBER:' )
 9995 FORMAT( 1X, I6, ': ', A6, '(', 2( '''', A1, ''',' ), 2( I3, ',' ),
     $      F4.1, ', A,', I3, ', B,', I3, ',', F4.1, ', C,', I3, ')   ',
     $      ' .' )
 9994 FORMAT( ' ******* FATAL ERROR - ERROR-EXIT TAKEN ON VALID CALL *',
     $      '******' )
C
C     End of SCHK23.
C
      END

*DECK F0O
      REAL FUNCTION F0O (X)
C***BEGIN PROLOGUE  F0O
C***PURPOSE  Subsidiary to
C***LIBRARY   SLATEC
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  F0O
      REAL X
C***FIRST EXECUTABLE STATEMENT  F0O
      F0O = (2.0E0*SIN(X))**14
      RETURN
      END

*DECK FB
      REAL FUNCTION FB (X)
C***BEGIN PROLOGUE  FB
C***PURPOSE  Subsidiary to BSPCK.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (FB-S, DFB-D)
C***AUTHOR  (UNKNOWN)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   ??????  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   930214  Added TYPE statement.  (WRB)
C***END PROLOGUE  FB
      REAL X
C***FIRST EXECUTABLE STATEMENT  FB
      FB = 1.0E0
      RETURN
      END

*DECK SDASQC
      SUBROUTINE SDASQC (LUN, KPRINT, IPASS)
C***BEGIN PROLOGUE  SDASQC
C***PURPOSE  Quick check for SLATEC routine SDASSL.
C***LIBRARY   SLATEC (DASSL)
C***CATEGORY  I1A2
C***TYPE      SINGLE PRECISION (SDASQC-S, DDASQC-D)
C***KEYWORDS  QUICK CHECK, SDASSL
C***AUTHOR  PETZOLD, LINDA R., (LLNL)
C             COMPUTING AND MATHEMATICS RESEARCH DIVISION
C             LAWRENCE LIVERMORE NATIONAL LABORATORY
C             L - 316, P.O. BOX 808,
C             LIVERMORE, CA.    94550
C***DESCRIPTION
C       Demonstration program for SDASSL.
C
C       SDASSL is used to solve two simple problems,
C       one with a full Jacobian, the other with a banded Jacobian,
C       with the 2 appropriate values of info(5) in each case.
C       If the errors are too large, or other difficulty occurs,
C       a warning message is printed.  All output is on unit LUN.
C
C       To run the demonstration problems with full print, call
C       SDASQC with KPRINT = 3.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  EDIT2, SDASSL, SDJAC1, SDJAC2, SDRES1, SDRES2
C***REVISION HISTORY  (YYMMDD)
C   851113  DATE WRITTEN
C   880608  Revised to meet new LDOC standards.
C   880615  Revised to meet new prologue standards.
C   891016  Converted to 4.0 format (FNF).
C   901001  Minor improvements to prologue.  (FNF)
C   901003  Added some error prints and improved output formats.  (FNF)
C   901009  Corrected GAMS classification code.  (FNF)
C   901009  Changed AMAX1 to MAX.  (FNF)
C   901030  Made all declarations explicit; added 1P's to formats. (FNF)
C***END PROLOGUE  SDASQC
C
      INTEGER  LUN, KPRINT, IPASS
C
      EXTERNAL  EDIT2, SDASSL, SDJAC1, SDJAC2, SDRES1, SDRES2
C
      INTEGER  I, IDID, INFO(15), IOUT, IPAR(1), IRES, IWORK(45),
     *   J190, J290, LIW, LRW, ML, MU, NEQ, NERR, NFE, NJE, NOUT,
     *   NQU, NST
      REAL  ATOL, DELTA(25), DTOUT, ER, ER1, ER2, ERM, ERO, HU, RPAR(1),
     *   RTOL, RWORK(550), T, TOUT, TOUT1, Y(25), YPRIME(25), YT1, YT2
C
      DATA TOUT1/1.0E0/, DTOUT/1.0E0/
C
C***FIRST EXECUTABLE STATEMENT  SDASQC
      IPASS = 1
      NERR = 0
      RTOL = 0.0E0
      ATOL = 1.0E-3
      LRW = 550
      LIW = 45
C
C FIRST PROBLEM
C
      NEQ = 2
      NOUT = 10
      IF (KPRINT .GE. 2)  WRITE (LUN,110) NEQ,RTOL,ATOL
 110  FORMAT('1'/1X,' DEMONSTRATION PROGRAM FOR SDASSL',///
     1  1X,' PROBLEM 1..   LINEAR DIFFERENTIAL/ALGEBRAIC SYSTEM..',/
     2  1X,' X1DOT + 10.0*X1 = 0,  X1 + X2 = 1',/
     3  1X,' X1(0) = 1.0, X2(0) = 0.0',/
     4  1X,' NEQ =',I2/
     5  1X,' RTOL =',1P,E10.1,'   ATOL =',E10.1)
C
      DO 190 J190 = 1,2
      DO 115 I = 1,15
 115    INFO(I) = 0
      IF(J190 .EQ. 2) INFO(5) = 1
C
      IF (KPRINT .GT. 2)  WRITE (LUN,120) INFO(5)
 120  FORMAT(////1X,' INFO(5) =',I3//
     1  6X,'T',15X,'X1',14X,'X2',12X,'NQ',6X,'H',12X/)
C
      T = 0.0E0
      Y(1) = 1.0E0
      Y(2) = 0.0E0
      YPRIME(1) = -10.0E0
      YPRIME(2) =  10.0E0
      TOUT = TOUT1
      ERO = 0.0E0
      DO 170 IOUT = 1,NOUT
        CALL SDASSL(SDRES1,NEQ,T,Y,YPRIME,TOUT,INFO,RTOL,ATOL,IDID,
     1     RWORK,LRW,IWORK,LIW,RPAR,IPAR,SDJAC1)
        HU = RWORK(7)
        NQU = IWORK(8)
        IF (KPRINT .GT. 2) THEN
          WRITE (LUN,140) T,Y(1),Y(2),NQU,HU
        ENDIF
 140    FORMAT(1X,1P,E15.5,E16.5,E16.5,I6,E14.3)
C
        IF (IDID .LT. 0) GO TO 175
        YT1 = EXP(-10.0E0*T)
        YT2 = 1.0E0 - YT1
        ER1 = ABS(YT1 - Y(1))
        ER2 = ABS(YT2 - Y(2))
        ER = MAX(ER1,ER2)/ATOL
        ERO = MAX(ERO,ER)
        IF (ER .GT. 1000.0E0)  THEN
          IF (KPRINT .GE. 2)  WRITE (LUN,150) T
 150      FORMAT(//' WARNING.. ERROR EXCEEDS 1000 * TOLERANCE',
     +             '  WHEN  T =',1P,E13.5//)
C
          NERR = NERR + 1
        ENDIF
 170    TOUT = TOUT + DTOUT
 175  CONTINUE
      IF (IDID .LT. 0)  THEN
        IF (KPRINT .GE. 2)  WRITE (LUN, 176)  IDID, T
 176    FORMAT (//'TROUBLE..  SDASSL RETURNED  IDID =',I4,
     +            '  WHEN  T =',1P,E13.5)
C
        NERR = NERR + 1
      ENDIF
      NST = IWORK(11)
      NFE = IWORK(12)
      NJE = IWORK(13)
      IF (KPRINT .GT. 2)  WRITE (LUN,180) NST,NFE,NJE,ERO
 180  FORMAT(//1X,' FINAL STATISTICS FOR THIS RUN..',/
     1  1X,' NUMBER OF STEPS =',I5/
     2  1X,' NUMBER OF F-S   =',I5/
     4  1X,' NUMBER OF J-S   =',I5/
     5  1X,' ERROR OVERRUN =',1P,E10.2)
C
 190  CONTINUE
C
C SECOND PROBLEM
C
      NEQ = 25
      ML = 5
      MU = 0
      IWORK(1) = ML
      IWORK(2) = MU
      NOUT = 5
      IF (KPRINT .GE. 2)  WRITE (LUN,210) NEQ,ML,MU,RTOL,ATOL
 210  FORMAT('1'/1X,' DEMONSTRATION PROGRAM FOR SDASSL',///
     1  1X,' PROBLEM 2.. YDOT = A * Y , WHERE ',
     2  ' A IS A BANDED LOWER TRIANGULAR MATRIX',/
     2  1X,'  DERIVED FROM 2-D ADVECTION PDE',/
     3  1X,' NEQ =',I3,'   ML =',I2,'   MU =',I2/
     4  1X,' RTOL =',1P,E10.1,'   ATOL =',E10.1)
C
      DO 290 J290 = 1,2
      DO 215 I = 1,15
 215    INFO(I) = 0
      INFO(6) = 1
      IF(J290 .EQ. 2) INFO(5) = 1
C
      IF (KPRINT .GT. 2)  WRITE (LUN,220) INFO(5)
 220  FORMAT(////1X,' INFO(5) =',I3//
     1  6X,'T',14X,'MAX.ERR.',5X,'NQ',6X,'H'/)
C
      T = 0.0E0
      DO 230 I = 2,NEQ
 230    Y(I) = 0.0E0
      Y(1) = 1.0E0
      DO 235 I = 1,NEQ
 235    DELTA(I) = 0.0E0
C        Following is to initialize YPRIME.
      CALL SDRES2(T,Y,DELTA,YPRIME,IRES,RPAR,IPAR)
      TOUT = 0.01E0
      ERO = 0.0E0
      DO 270 IOUT = 1,NOUT
        CALL SDASSL(SDRES2,NEQ,T,Y,YPRIME,TOUT,INFO,RTOL,ATOL,IDID,
     1     RWORK,LRW,IWORK,LIW,RPAR,IPAR,SDJAC2)
        CALL EDIT2(Y,T,ERM)
        HU = RWORK(7)
        NQU = IWORK(8)
        IF (KPRINT .GT. 2)  WRITE (LUN,240) T,ERM,NQU,HU
 240    FORMAT(1X,1P,E15.5,E14.3,I6,E14.3)
C
        IF (IDID .LT. 0) GO TO 275
        ER = ERM/ATOL
        ERO = MAX(ERO,ER)
        IF (ER .GT. 1000.0E0) THEN
          IF (KPRINT .GE. 2)  WRITE (LUN,150) T
          NERR = NERR + 1
        ENDIF
 270    TOUT = TOUT*10.0E0
 275  CONTINUE
      IF (IDID .LT. 0)  THEN
        IF (KPRINT .GE. 2)  WRITE (LUN, 176)  IDID, T
        NERR = NERR + 1
      ENDIF
      NST = IWORK(11)
      NFE = IWORK(12)
      NJE = IWORK(13)
      IF (KPRINT .GT. 2)  WRITE (LUN,180) NST,NFE,NJE,ERO
C
 290  CONTINUE
      IF (KPRINT .GE. 2)  WRITE (LUN,300) NERR
C
 300  FORMAT(////1X,' NUMBER OF ERRORS ENCOUNTERED =',I3)
C
      IF (NERR .GT. 0) THEN
        IPASS = 0
      ENDIF
      IF ((IPASS .EQ. 1) .AND. (KPRINT .GT. 1)) WRITE (LUN,700)
      IF ((IPASS .EQ. 0) .AND. (KPRINT .NE. 0)) WRITE (LUN,800)
 700  FORMAT (/,' ----------SDASSL PASSED ALL TESTS----------')
 800  FORMAT (/,' **********SDASSL FAILED SOME TESTS*********')
      RETURN
      END

*DECK FDEQC
      SUBROUTINE FDEQC (T, U, UPRIME, RPAR, IPAR)
C***BEGIN PROLOGUE  FDEQC
C***SUBSIDIARY
C***PURPOSE  Derivative evaluator for DEPAC quick checks.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (FDEQC-S, DFDEQC-D)
C***AUTHOR  Chow, Jeff, (LANL)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   810801  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900415  Name changed from F to FDEQC.  (WRB)
C***END PROLOGUE  FDEQC
C
C     Declare arguments.
C
      INTEGER IPAR(*)
      REAL RPAR(*), T, U(*), UPRIME(*)
C
C     Declare local variables.
C
      REAL R, RSQ, R3
C***FIRST EXECUTABLE STATEMENT  FDEQC
      RSQ = U(1)*U(1) + U(2)*U(2)
      R = SQRT(RSQ)
      R3 = RSQ*R
      UPRIME(1) = U(3)
      UPRIME(2) = U(4)
      UPRIME(3) = -(U(1)/R3)
      UPRIME(4) = -(U(2)/R3)
      RETURN
      END

*DECK EVCHCK
      SUBROUTINE EVCHCK (LOUT, KPRINT, NPTS, XEV, FEV, DEV, FEV2, FAIL)
C***BEGIN PROLOGUE  EVCHCK
C***SUBSIDIARY
C***PURPOSE  Test evaluation accuracy of CHFDV and CHFEV for PCHQK1.
C***LIBRARY   SLATEC (PCHIP)
C***TYPE      SINGLE PRECISION (EVCHCK-S, DEVCHK-D)
C***KEYWORDS  PCHIP EVALUATOR QUICK CHECK
C***AUTHOR  Fritsch, F. N., (LLNL)
C***DESCRIPTION
C
C -------- CODE TO TEST EVALUATION ACCURACY OF CHFDV AND CHFEV --------
C
C     USING FUNCTION AND DERIVATIVE VALUES FROM A CUBIC (COMPUTED IN
C     DOUBLE PRECISION) AT NINT DIFFERENT (X1,X2) PAIRS:
C     1. CHECKS THAT CHFDV AND CHFEV BOTH REPRODUCE ENDPOINT VALUES.
C     2. EVALUATES AT NPTS POINTS, 10 OF WHICH ARE OUTSIDE THE INTERVAL
C        AND:
C        A. CHECKS ACCURACY OF CHFDV FUNCTION AND DERIVATIVE VALUES
C           AGAINST EXACT VALUES.
C        B. CHECKS THAT RETURNED VALUES OF NEXT SUM TO 10.
C        C. CHECKS THAT FUNCTION VALUES FROM CHFEV AGREE WITH THOSE
C           FROM CHFDV.
C
C
C     FORTRAN INTRINSICS USED:  ABS, MAX, MIN.
C     FORTRAN LIBRARY ROUTINES USED:  SQRT, (READ), (WRITE).
C     SLATEC LIBRARY ROUTINES USED:  CHFDV, CHFEV, R1MACH, RAND.
C     OTHER ROUTINES USED:  FDTRUE.
C
C***ROUTINES CALLED  CHFDV, CHFEV, FDTRUE, R1MACH, RAND
C***REVISION HISTORY  (YYMMDD)
C   820601  DATE WRITTEN
C   820624  CONVERTED TO QUICK CHECK FOR SLATEC LIBRARY.
C   820630  1. MODIFIED DEFINITIONS OF RELATIVE ERROR AND TEST
C             TOLERANCES.
C           2. VARIOUS IMPROVEMENTS TO OUTPUT FORMATS.
C   820716  1. SET MACHEP VIA A CALL TO R1MACH.
C           2. CHANGED FROM FORTLIB'S RANF TO SLATEC'S RAND.
C   890629  1. Appended E0 to real constants to reduce S.P./D.P.
C             differences.
C           2. Other minor cosmetic changes.
C   890831  Modified array declarations.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   891004  Cosmetic changes to prologue.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  Revised prologue and improved some output formats.  (FNF)
C           Also moved formats to end to be consistent with other PCHIP
C           quick checks.
C   900316  Additional minor cosmetic changes.  (FNF)
C   900321  Made miscellaneous cosmetic changes.  (FNF)
C   901130  Added 1P's to formats and revised some to reduce maximum
C           line length.  (FNF)
C   910708  Minor modifications in use of KPRINT.  (WRB)
C   910801  Added EXTERNAL statement for RAND due to problem on IBM
C           RS 6000.  (WRB)
C***END PROLOGUE  EVCHCK
C
C  Declare arguments.
C
      INTEGER  LOUT, KPRINT, NPTS
      REAL  XEV(*), FEV(*), DEV(*), FEV2(*)
      LOGICAL  FAIL
C
C  DECLARATIONS.
C
      INTEGER  I, IERR, IINT, NEXT(2), NEXT2(2), NINT
      REAL  AED, AED2, AEDMAX, AEDMIN, AEF, AEF2, AEFMAX, AEFMIN,
     *      CHECK(2), CHECKF(2), CHECKD(2), D1, D2, DERMAX, DTRUE, DX,
     *      EPS1, EPS2, F1, F2, FACT, FERMAX, FLOORD, FLOORF, FOUR,
     *      FTRUE, LEFT(3), MACHEP,
     *      ONE, RED, RED2, REDMAX, REDMIN, REF, REF2, REFMAX,
     *      REFMIN, RIGHT(3), SMALL, TEN, TOL1, TOL2,
     *      X1, X2, XADMAX, XADMIN, XAFMAX, XAFMIN, XRDMAX,
     *      XRDMIN, XRFMAX, XRFMIN, ZERO
      LOGICAL  FAILOC, FAILNX
C
      REAL  R1MACH
C       The following should stay REAL (no D.P. equivalent).
      REAL  RAND
      EXTERNAL  RAND
C
C  DEFINE RELATIVE ERROR WITH FLOOR.
C
      REAL  RERR, ERR, VALUE, FLOOR
      RERR(ERR,VALUE,FLOOR) = ERR / MAX(ABS(VALUE), FLOOR)
C
C  INITIALIZE.
C
      DATA  ZERO /0.E0/, ONE /1.E0/, FOUR /4.E0/, TEN /10.E0/
      DATA  SMALL  /1.0E-10/
      DATA  NINT /3/
      DATA   LEFT /-1.5E0, 2.0E-10, 1.0E0 /
      DATA  RIGHT / 2.5E0, 3.0E-10, 1.0E+8/
C
C***FIRST EXECUTABLE STATEMENT  EVCHCK
      MACHEP = R1MACH(4)
      EPS1 = FOUR*MACHEP
      EPS2 = TEN*MACHEP
C
      FAIL = .FALSE.
C
      IF (KPRINT .GE. 2)  WRITE (LOUT, 3000)
C
C  CYCLE OVER INTERVALS.
C
      DO 90  IINT = 1, NINT
      X1 =  LEFT(IINT)
      X2 = RIGHT(IINT)
C
      FACT = MAX(SQRT(X2-X1), ONE)
      TOL1 = EPS1 * FACT
      TOL2 = EPS2 * FACT
C
C  COMPUTE AND PRINT ENDPOINT VALUES.
C
      CALL FDTRUE (X1, F1, D1)
      CALL FDTRUE (X2, F2, D2)
C
      IF (KPRINT .GE. 3)  THEN
         IF (IINT .EQ. 1)  WRITE (LOUT, 2000)
         WRITE (LOUT, '(/)')
         WRITE (LOUT, 2001)  'X1', X1, 'X2', X2
         WRITE (LOUT, 2001)  'F1', F1, 'F2', F2
         WRITE (LOUT, 2001)  'D1', D1, 'D2', D2
      ENDIF
C
      IF (KPRINT .GE. 2)  WRITE (LOUT, 3001)  X1, X2
C
C  COMPUTE FLOORS FOR RELATIVE ERRORS.
C
      FLOORF = MAX( MIN(ABS(F1),ABS(F2)), SMALL)
      FLOORD = MAX( MIN(ABS(D1),ABS(D2)), SMALL)
C
C  CHECK REPRODUCTION OF ENDPOINT VALUES.
C
      XEV(1) = X1
      XEV(2) = X2
C     -----------------------------------------------------------
      CALL CHFDV (X1, X2, F1, F2, D1, D2, 2, XEV, CHECKF, CHECKD,
     *            NEXT, IERR)
C     -----------------------------------------------------------
      AEF  = CHECKF(1)-F1
      REF  = RERR(AEF , F1, FLOORF)
      AEF2 = CHECKF(2)-F2
      REF2 = RERR(AEF2, F2, FLOORF)
      AED  = CHECKD(1)-D1
      RED  = RERR(AED , D1, FLOORD)
      AED2 = CHECKD(2)-D2
      RED2 = RERR(AED2, D2, FLOORD)
C
      FAILOC = MAX(ABS(REF),ABS(REF2),ABS(RED),ABS(RED2)) .GT. TOL1
      FAIL = FAIL .OR. FAILOC
C
      IF (KPRINT .GE. 3)  THEN
         WRITE (LOUT, 2002)  NEXT, AEF, AEF2, AED, AED2
         WRITE (LOUT, 2003)  REF, REF2, RED, RED2
      ENDIF
C
      IF (FAILOC .AND. (KPRINT.GE.2))  WRITE (LOUT, 3002)
C
C  CHFEV SHOULD AGREE EXACTLY WITH CHFDV.
C                     -------
C     --------------------------------------------------------------
      CALL CHFEV (X1, X2, F1, F2, D1, D2, 2, XEV, CHECK, NEXT, IERR)
C     --------------------------------------------------------------
      FAILOC = (CHECK(1).NE.CHECKF(1)) .OR. (CHECK(2).NE.CHECKF(2))
      FAIL = FAIL .OR. FAILOC
C
      IF (FAILOC .AND. (KPRINT.GE.2))  WRITE (LOUT, 3003)
C
C  EVALUATE AT NPTS 'UNIFORMLY RANDOM' POINTS IN (X1,X2).
C     THIS VERSION EXTENDS EVALUATION DOMAIN BY ADDING 4 SUBINTERVALS
C     TO LEFT AND 6 TO RIGHT OF [X1,X2].
C
      DX = (X2-X1)/(NPTS-10)
      DO 20  I = 1, NPTS
         XEV(I) = (X1 + (I-5)*DX) + DX*RAND(ZERO)
   20 CONTINUE
C     --------------------------------------------------------
      CALL CHFDV (X1, X2, F1, F2, D1, D2, NPTS, XEV, FEV, DEV,
     *            NEXT, IERR)
C     --------------------------------------------------------
      IF (IERR .NE. 0)  THEN
         FAILOC = .TRUE.
         IF (KPRINT .GE. 2)  WRITE (LOUT, 4003)  IERR
      ELSE
C
C     CUMULATE LARGEST AND SMALLEST ERRORS FOR SUMMARY.
C
      DO 30  I = 1, NPTS
         CALL FDTRUE (XEV(I), FTRUE, DTRUE)
         AEF = FEV(I) - FTRUE
         REF = RERR(AEF, FTRUE, FLOORF)
         AED = DEV(I) - DTRUE
         RED = RERR(AED, DTRUE, FLOORD)
C
         IF (I .EQ. 1)  THEN
C            INITIALIZE.
            AEFMIN = AEF
            AEFMAX = AEF
            AEDMIN = AED
            AEDMAX = AED
            REFMIN = REF
            REFMAX = REF
            REDMIN = RED
            REDMAX = RED
            XAFMIN = XEV(1)
            XAFMAX = XEV(1)
            XADMIN = XEV(1)
            XADMAX = XEV(1)
            XRFMIN = XEV(1)
            XRFMAX = XEV(1)
            XRDMIN = XEV(1)
            XRDMAX = XEV(1)
         ELSE
C            SELECT.
            IF (AEF .LT. AEFMIN)  THEN
               AEFMIN = AEF
               XAFMIN = XEV(I)
            ELSE IF (AEF .GT. AEFMAX)  THEN
               AEFMAX = AEF
               XAFMAX = XEV(I)
            ENDIF
            IF (AED .LT. AEDMIN)  THEN
               AEDMIN = AED
               XADMIN = XEV(I)
            ELSE IF (AED .GT. AEDMAX)  THEN
               AEDMAX = AED
               XADMAX = XEV(I)
            ENDIF
            IF (REF .LT. REFMIN)  THEN
               REFMIN = REF
               XRFMIN = XEV(I)
            ELSE IF (REF .GT. REFMAX)  THEN
               REFMAX = REF
               XRFMAX = XEV(I)
            ENDIF
            IF (RED .LT. REDMIN)  THEN
               REDMIN = RED
               XRDMIN = XEV(I)
            ELSE IF (RED .GT. REDMAX)  THEN
               REDMAX = RED
               XRDMAX = XEV(I)
            ENDIF
         ENDIF
   30    CONTINUE
C
         FERMAX = MAX (ABS(REFMAX), ABS(REFMIN))
         DERMAX = MAX (ABS(REDMAX), ABS(REDMIN))
C
         FAILNX = (NEXT(1) + NEXT(2)) .NE. 10
         FAILOC = FAILNX .OR. (MAX(FERMAX, DERMAX) .GT. TOL2)
      ENDIF
      FAIL = FAIL .OR. FAILOC
C
C  PRINT SUMMARY.
C
      IF (KPRINT .GE. 3)  THEN
         WRITE (LOUT, 2004)  NPTS-10, NEXT
C
         WRITE (LOUT, 2005)  'MIN', AEFMIN, REFMIN, AEDMIN, REDMIN
         WRITE (LOUT, 2006) XAFMIN, XRFMIN, XADMIN, XRDMIN
         WRITE (LOUT, 2005)  'MAX', AEFMAX, REFMAX, AEDMAX, REDMAX
         WRITE (LOUT, 2006) XAFMAX, XRFMAX, XADMAX, XRDMAX
      ENDIF
C
      IF (KPRINT .GE. 2)  THEN
         IF (FAILOC) THEN
            IF (FERMAX .GT. TOL2)  WRITE (LOUT, 3006) 'F', FERMAX, TOL2
            IF (DERMAX .GT. TOL2)  WRITE (LOUT, 3006) 'D', DERMAX, TOL2
            IF (FAILNX)  WRITE (LOUT, 4006)  NEXT
         ELSE
            WRITE (LOUT, 5006)
         ENDIF
      ENDIF
C
C  CHECK THAT CHFEV AGREES WITH CHFDV.
C
C     -----------------------------------------------------------------
      CALL CHFEV (X1, X2, F1, F2, D1, D2, NPTS, XEV, FEV2, NEXT2, IERR)
C     -----------------------------------------------------------------
      IF (IERR .NE. 0)  THEN
         FAILOC = .TRUE.
         IF (KPRINT .GE. 2)  WRITE (LOUT, 3007)  IERR
      ELSE
         AEFMAX = ABS(FEV2(1) - FEV(1))
         XAFMAX = XEV(1)
         DO 40  I = 2, NPTS
            AEF = ABS(FEV2(I) - FEV(I))
            IF (AEF .GT. AEFMAX)  THEN
               AEFMAX = AEF
               XAFMAX = XEV(I)
            ENDIF
   40    CONTINUE
         FAILNX = (NEXT2(1).NE.NEXT(1)) .OR. (NEXT2(2).NE.NEXT(2))
         FAILOC = FAILNX .OR. (AEFMAX.NE.ZERO)
         IF (KPRINT .GE. 2)  THEN
            IF (FAILOC)  THEN
               WRITE (LOUT, 3008)
               IF (AEFMAX.NE.ZERO)  WRITE (LOUT, 3009)  AEFMAX, XAFMAX
               IF (FAILNX)  WRITE (LOUT, 4009)  NEXT2, NEXT
            ELSE
               WRITE (LOUT, 5009)
            ENDIF
         ENDIF
      ENDIF
C
      FAIL = FAIL .OR. FAILOC
C
C  GO BACK FOR ANOTHER INTERVAL.
C
   90 CONTINUE
C
      RETURN
C
C  FORMATS.
C
 2000 FORMAT (/10X,'CHFDV ACCURACY TEST')
 2001 FORMAT (10X,A2,' =',1P,E18.10,5X,A2,' =',E18.10)
 2002 FORMAT (/' ERRORS AT ENDPOINTS:',40X,'(NEXT =',2I3,')'
     *        // 1P,4X,'F1:',E13.5,4X,'F2:',E13.5,
     *              4X,'D1:',E13.5,4X,'D2:',E13.5)
 2003 FORMAT (1P,4(7X,E13.5))
 2004 FORMAT (/' ERRORS AT ',I5,' INTERIOR POINTS + 10 OUTSIDE:',
     *                15X,'(NEXT =',2I3,')'
     *        //30X,'FUNCTION',17X,'DERIVATIVE'
     *         /15X,2(11X,'ABS',9X,'REL') )
 2005 FORMAT (/5X,A3,'IMUM ERROR:  ',1P,2E12.4,2X,2E12.4)
 2006 FORMAT ( 5X,'LOCATED AT X =  ',1P,2E12.4,2X,2E12.4)
 3000 FORMAT (//10X,'EVCHCK RESULTS'/10X,'--------------')
 3001 FORMAT (/10X,'INTERVAL = (',1P,E12.5,',',E12.5,' ):' )
 3002 FORMAT (/' ***** CHFDV FAILED TO REPRODUCE ENDPOINT VALUES.')
 3003 FORMAT (/' ***** CHFEV DOES NOT AGREE WITH CHFDV AT ENDPOINTS.')
 3006 FORMAT (/' ***** MAXIMUM RELATIVE ERROR IN ',A1,' =',1P,E12.5,','
     *        /        17X,'EXCEEDS TOLERANCE =',E12.5)
 3007 FORMAT (/' ***** ERROR ***** CHFEV RETURNED IERR =',I5)
 3008 FORMAT (/' ***** CHFEV DID NOT AGREE WITH CHFDV:')
 3009 FORMAT (7X,'MAXIMUM DIFFERENCE ',1P,E12.5,
     *                '; OCCURRED AT X =',E12.5)
 4003 FORMAT (/' ***** ERROR ***** CHFDV RETURNED IERR =',I5)
 4006 FORMAT (/' ***** REPORTED NEXT =',2I5,'   RATHER THAN    4    6')
 4009 FORMAT (7X,'REPORTED NEXT =',2I3,'   RATHER THAN ',2I3)
 5006 FORMAT (/' CHFDV RESULTS OK.')
 5009 FORMAT (/' CHFEV AGREES WITH CHFDV.')
C------------- LAST LINE OF EVCHCK FOLLOWS -----------------------------
      END
